REM
REM   $Id: BUILD622.BAT 1.54 2003/08/20 17:57:28Z thomd Exp $
REM
REM   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
REM
REM   Copyright (c) 1993 - 2002 Datalight, Inc.
REM   All Rights Reserved
REM
REM   Datalight, Inc. is a Washington corporation with an address at
REM   21520 30TH DR SE MS110 Bothell, WA, 98021
REM   Tel: 800.221.6630  Fax: 425.951.8091
REM   Http://www.datalight.com
REM
REM   This software, including without limitation all source code and
REM   documentation, is the confidential, trade secret property of
REM   Datalight, Inc., and is protected under the copyright laws of
REM   the United States and other jurisdictions. Portions of the
REM   software may also be subject to one or more the following US
REM   patents: US#5860082, US#6260156.
REM
REM   In addition to civil penalties for infringement of copyright
REM   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
REM   penalties for violation of (a) the restrictions on circumvention
REM   of copyright protection systems found in 17 U.S.C. 1201 and
REM   (b) the protections for the integrity of copyright management
REM   information found in 17 U.S.C. 1202.
REM
REM   U.S. Government Restricted Rights. Use, duplication,
REM   reproduction, or transfer of this commercial product and
REM   accompanying documentation is restricted in accordance with
REM   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
REM
REM   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
REM   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
REM   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
REM   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
REM   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
REM   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
REM   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
REM   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
REM   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
REM   THIS SOFTWARE IN ERROR.
REM
@echo off
REM
REM  BUILD622.BAT
REM
REM  Copyright (c) 2000-2002 Datalight, Inc.
REM  All Rights Reserved.
REM  Datalight Confidential and Proprietary
REM
REM  HISTORY
REM   04-12/2001 jmb modified NED and PROTO copy paths if DL_ROOT is set
REM

set bldlog=
if NOT "%buildlog%"=="" goto start
set buildlog=..\build.log
set bldlog=1


:start


REM Create the release tree directory
REM
if exist testing\622\nul deltree /y testing\622
if exist release\622\nul deltree /y release\622
if not exist release\nul md release
if not exist testing\nul md testing
md release\622
md release\622\devsrc
md release\622\memdisk
md release\622\minicmd
md release\622\utils
md testing\622


REM Build TOOLS first
REM
call setdeb release 32
set enablef32=
echo Building Required Tools...
cd bin\source
make -B >>%buildlog%
cd ..\..
%DEBUGCMD%


REM
REM Build TOOLS used to make a ROMDOS release
REM

echo Building BIN...
cd bin
make -B >>%buildlog%
cd ..
%DEBUGCMD%


REM
REM  Build ROMDOS Libraries
REM

echo Building Library Code...
cd lib
if exist *.lib del *.lib
recurse command /c if exist makefile make -B >>%buildlog%
if exist makefile make -B >>%buildlog%
cd ..
%DEBUGCMD%


REM
REM  Build romdos binaries
REM


call setdeb release
set enablef32=


echo Building ROMDOS kernel
cd kernel
if exist makefile make -B >>%buildlog%
cd ..


echo Building BUILD.EXE
cd build
if exist makefile make -B >>%buildlog%
call makelibs
cd ..


echo Building default 6.22 release kernel
cd build
echo.>build.key
echo.>>build.key
echo.>>build.key
echo.>>build.key
echo.>>build.key
echo.>>build.key
echo.>>build.key
@if exist build.bat del build.bat
build <build.key
cd ..


call setdeb release 32
set enablef32=


echo Building LFN command
cd command
if exist makefile make -B command.com >>%buildlog%
cd ..


echo Building LFN utilities...
cd utils
recurse command /c if exist makefile make -B >>%buildlog%
if exist makefile make -B >>%buildlog%
cd ..


echo Building non-LFN utilities...
cd nonlfn
recurse command /c if exist makefile make -B >>%buildlog%
if exist makefile make -B >>%buildlog%
cd ..


REM this does not actually exist...
REM
REM call setdeb release
REM set enablef32=
REM
REM echo Building non-FAT32 chkdsk
REM cd nonlfn\chkdsk
REM if exist makefile make -B release16>>%buildlog%
REM cd ..\..


call setdeb release 32
set enablef32=


echo Building drivers
cd drivers
recurse command /c if exist makefile make -B >>%buildlog%
if exist makefile make -B >>%buildlog%
cd ..


echo Building memdisk
cd memdisk
if exist makefile make -B >>%buildlog%
cd ..


echo Building minibios
cd minibios
if exist makefile make -B >>%buildlog%
cd ..


echo Building minicmd
cd minicmd
if exist makefile make -B >>%buildlog%
cd ..


REM
REM  Copy the files to the release tree
REM


REM root directory
REM
copy build\rom-dos.sys release\622
copy bin\compress.exe release\622
copy bin\loc.exe release\622
copy build\build.exe release\622
if exist build\user.lib del build\user.lib
copy build\*.lib release\622
if exist build\devfdhd*.obj del build\devfdhd*.obj
if exist build\sysgen.obj del build\sysgen.obj
copy build\*.obj release\622
if exist release\622\longnam7.lib del release\622\longnam7.lib
if exist release\622\dosinit7.lib del release\622\dosinit7.lib
if exist release\622\doscfg7.lib  del release\622\doscfg7.lib
if exist release\622\fdhd7*.lib   del release\622\fdhd7*.lib
if exist release\622\romdos7.lib  del release\622\romdos7.lib
if exist release\622\dos7cfg*.obj del release\622\dos7cfg*.obj
if exist release\622\dos7asm.obj  del release\622\dos7asm.obj
copy utils\sys\sys.com release\622


REM devsrc directory
REM
copy kernel\devfdhd.inc release\622\devsrc
copy kernel\dev*.asm release\622\devsrc
copy include\dostruct.inc release\622\devsrc
copy include\profile.inc release\622\devsrc
copy include\profile.h release\622\devsrc
copy build\devsrc.mak release\622\devsrc\makefile
copy kernel\dosignon.c release\622\devsrc
copy kernel\sysgen.asm release\622\devsrc
copy include\macros.inc release\622\devsrc
copy include\devhdr.inc release\622\devsrc
copy include\dosver.inc release\622\devsrc
copy include\dosver.h release\622\devsrc
copy include\bldver.h release\622\devsrc
copy include\bldver.inc release\622\devsrc
copy include\use186.inc release\622\devsrc


REM memdisk directory
REM
copy memdisk\membc.mak release\622\memdisk\makefile
copy memdisk\memdisk.asm release\622\memdisk
copy memdisk\ldrbext.asm release\622\memdisk
copy memdisk\vdisk.c release\622\memdisk
copy memdisk\raminit.c release\622\memdisk
copy memdisk\pagedldr.c release\622\memdisk
copy memdisk\pagedldr.loc release\622\memdisk
copy memdisk\memfixed.c release\622\memdisk
copy memdisk\int15pag.c release\622\memdisk
copy memdisk\dyndrvr.c release\622\memdisk
copy memdisk\memrom.c release\622\memdisk
copy memdisk\memext.c release\622\memdisk
copy memdisk\sc400pag.c release\622\memdisk
copy memdisk\mempaged.c release\622\memdisk
copy memdisk\memdisk.inc release\622\memdisk
copy memdisk\compiler.h release\622\memdisk
copy memdisk\memdisk.h release\622\memdisk
copy memdisk\vdisk.h release\622\memdisk
copy memdisk\dyndrvr.h release\622\memdisk
copy memdisk\memutil.lib release\622\memdisk


REM  minicmd
REM
copy minicmd\*.* release\622\minicmd


REM  utils
REM
copy drivers\ansi\ansi.sys release\622\utils\ansi.sys
copy drivers\ata\ata.sys release\622\utils\ata.sys
copy utils\attrib\attrib.exe release\622\utils
copy nonlfn\backup\backup.exe release\622\utils
copy drivers\cdex\mscdex.exe release\622\utils
copy utils\chkdsk\chkdsk.exe release\622\utils
copy utils\choice\choice.com release\622\utils
copy command\command.com release\622
copy command\command.hlp release\622
copy drivers\country\country.sys release\622\utils
copy utils\comm\comm.exe release\622\utils
rem copy utils\defrag\defrag.exe release\622\utils
copy utils\deltree\deltree.exe release\622\utils
copy utils\disk2img\disk2img.exe release\622\utils
copy utils\diskcomp\diskcomp.com release\622\utils
copy utils\diskcopy\diskcopy.com release\622\utils
copy drivers\display\display.sys release\622\utils
copy utils\dump\dump.exe release\622\utils
copy drivers\display\ega.cpi release\622\utils
copy drivers\display\ega3.cpi release\622\utils
copy drivers\emm386\emm386.exe release\622\utils
copy utils\exe2bin\exe2bin.com release\622\utils
copy utils\fdisk\fdisk.exe release\622\utils
copy utils\find\find.exe release\622\utils
copy utils\format\format.com release\622\utils
copy drivers\himem\himem.sys release\622\utils
copy drivers\keyb\keyb.com release\622\utils
copy drivers\keyb\keyboard.sys release\622\utils
copy drivers\keyb\keybrd2.sys release\622\utils
copy utils\label\label.exe release\622\utils
copy kernel\longname.txt release\622\utils
copy utils\mem\mem.exe release\622\utils
copy utils\mode\mode.com release\622\utils
copy utils\more\more.com release\622\utils
copy utils\move\move.exe release\622\utils
copy utils\power\power.exe release\622\utils
copy nonlfn\print\print.exe release\622\utils
copy utils\remdisk\remdisk.exe release\622\utils
copy utils\remdisk\remserv.exe release\622\utils
copy utils\remdisk\remquit.com release\622\utils
copy nonlfn\backup\restore.exe release\622\utils
copy nonlfn\romdisk\romdisk.exe release\622\utils
copy nonlfn\rsz\rsz.exe release\622\utils\rsz.exe
copy nonlfn\rsz\rz.bat release\622\utils\rz.bat
copy utils\client\serlink.exe release\622\utils
copy utils\server\serserv.exe release\622\utils
copy nonlfn\share\share.exe release\622\utils
copy utils\cache\smartdrv.exe release\622\utils
copy utils\sort\sort.exe release\622\utils
copy drivers\stackdev\stackdev.sys release\622\utils\stackdev.sys
copy utils\subst\subst.exe release\622\utils
copy utils\sys\sys.com release\622\utils
copy nonlfn\rsz\sz.bat release\622\utils\sz.bat
copy utils\transfer\transfer.exe release\622\utils
copy utils\tree\tree.com release\622\utils
copy kernel\umblink.exe release\622\utils
copy memdisk\vdisk.sys release\622\utils
copy drivers\version\version.sys release\622\utils
copy drivers\wx2swap\wx2swap.sys release\622\utils
copy utils\xcopy\xcopy.exe release\622\utils


REM  Copy in the items from devtools which are in the ROMDOS release
REM
cd release\622\utils
set ned_dir=c:\dl\devtools\bin
if not "%dl_root%" == "" ned_dir=%dl_root%\devtools\bin
copy %ned_dir%\ned*.*
copy %ned_dir%\proto.exe
if exist ned.cfg del ned.cfg
set ned_dir=
rem copy t:\products\devtools\testing\isfiles\common\bin\ned.exe
rem copy t:\products\devtools\testing\isfiles\common\bin\nedman.txt
rem copy t:\products\devtools\testing\isfiles\common\bin\nedremot.cfg
rem copy t:\products\devtools\testing\isfiles\common\bin\nedremot.com
rem copy t:\products\devtools\testing\isfiles\common\bin\proto.exe
cd ..\..\..


rem  Copy the user manuals and read.me into the release tree
rem
copy "rxe\RXE Theory of Operation.PDF" release\622
copy docs\rdosdev.pdf release\622\rdosdev.pdf
copy docs\rdosuser.pdf release\622\rdosuser.pdf
bin\verhdr >hdr.txt
copy hdr.txt+docs\read.me readme.tmp
copy readme.tmp release\622\read.me
del readme.tmp


REM
REM build the files needed for the romdos test suite
REM

call setdeb release 32
set enablef32=

echo Building DDTDISK
cd memdisk
if exist makefile make -B ddtdisk.exe >>%buildlog%
cd ..

echo Building IMAVIRUS
cd drivers\emm386
if exist makefile make -B -fmaketest.mak >>%buildlog%
cd ..\..

echo Building RDBLDNUM
cd utils\rdbldnum
if exist makefile make -B >>%buildlog%
cd ..\..

copy memdisk\ddtdisk.exe testing\622
copy drivers\emm386\imavirus.exe testing\622
copy utils\rdbldnum\rdbldnum.exe testing\622


REM Update the file time to reflect the version
bin\sdkver 6.22 release\622
bin\sdkver 6.22 release\622\devsrc
bin\sdkver 6.22 release\622\memdisk
bin\sdkver 6.22 release\622\minicmd
bin\sdkver 6.22 release\622\utils
bin\sdkver 6.22 testing\622


:done
if "%bldlog%"=="1" set buildlog=
