//
//   $Id: cfgtest.c 1.4 2002/10/16 21:35:22Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*******************************************************************

Error: Undefined symbol _cfg_menuptr in module doscfg.c

   08-16-2002 jmb initialized "Terminators" to term_table
********************************************************************/

//  Datalight libraries
//
#include "dostruct.h"
#include "dosdef.h"
#include "datalght.h"
#include "dlbiosio.h"
#include "dldosio.h"
#include "dllfn.h"

// Local Includes
//
#include "dosproto.h"

// "Global" variables
//
   unsigned cfg_seg = 0;
   unsigned cfg_position;           // current position, 0xFFFF = eof


   uchar minute, hour;      /* the current system time */
   uchar hund, seconds;

/* required by doscfg.c && doscfg6a.asm */
   uchar cfg_nobypass;
   int  cfg_ask = 0;
	char starting_msg[]= "\nStarting ROM-DOS...\n";
	int  cfg_seconds = 1;
	char nagware_key = 0;

#define MAX_INCLUDE_DEPTH 3      // see DOSASM.ASM as well

   char shell[128];         // the 1st program run by ROM-DOS, ie COMMAND
   unsigned cfg_inc_pos[MAX_INCLUDE_DEPTH];
   int cfg_inc_line[MAX_INCLUDE_DEPTH];
   int cfg_inc_level;
   int cfg_ask_line;
   int cfg_linenum;                         // current line #
   int stacksNum;
   int stacksSize;
   char warn_bad[]    = "Bad or Missing %s (%ls)\n";
   char warn_cmd[]    = "Bad cmd (%ls) in %s, line %d\n";
   char config_str[128];                     /* a buffer to read lines */
   int error_no;
   int lfnMaxSearches;
   uchar BREAK_FLAG;
   struct LOL lol;
   int init_buffers;
   char country_buff[66];
   char warn_device[] = "Device";
   uchar mem_fit;
   unsigned dos5_flags;
   char trydoshi = FALSE;
   unsigned hma_used;
   unsigned codeparas;
   unsigned bufparas;
   uchar sda_numfcbs;
   uchar sda_numsfts;
   int init_files;
   char warn_newfile[]= "NewFile";

   char char_stack[0x26C];
   char *pDiskStack;
   char *pCharStack;
   char *pDiskStackTop;
   char *pCharStackTop;
   union EXEPARM boot_parms;
   unsigned boot_env;
   unsigned cfg_default;                    // MENUDEFAULT, points to menu name
   int cfg_num_menus;                               // # of menus (up to 9)

   void * cfg_menuptr;       // ptr to up to 9 menuitems

   unsigned cfg_menupos;                    // set by caller
   char sda_fname1[128];                    // used as a buffer to read lines
   extern unsigned char term_table[];
   unsigned char * terminators = term_table+11;
   uchar switch_char = '/';
   unsigned cfg_size;

#define TSR_SUCCESSFUL  TRUE
#define DEVICE_SUCCESSFUL  TRUE

#ifndef VDOS
#define VDOS 6
#endif


int main( int argc, char *argv[] )
{
   int retcode = 0;
	unsigned openMode = O_RDWR;
	unsigned attributes = A_NORMAL;
	unsigned uAction = ACT_NEXIST_CREATE | ACT_EXIST_REPLACE;
	int iHandle;
	static char * szName;
	bool fSuccessful;
	static char szFileBuffer[80];
	unsigned uByteCount;

#define separator "\n--[PASS %u]------------------\n"

   if( argc<2 )
   {
      printf( "No CONFIG.SYS file specified.\n" );
      retcode = 1;
   }
   else
   {
      strcpy(shell,"COMMAND.COM");
      strcpy(country_buff,"-");

      // load the config file
      //
      load_and_process_config( (char far *)argv[1], 0 );
//TD      load_config((char far *)argv[1]);

      // initialize relevant "global" variables
      //
      touch_time(TM_WRITE);

      // now process the configuration files
      //
      printf(separator,1);
      configsys(PASS1);

		// create a log file to be parsed later
		//
		strcpy( szName, "PASS1.LOG\0" );
		fSuccessful = dlOpenOrCreateFile( openMode, attributes, &uAction,
								szName, &iHandle );
		if( !fSuccessful )
		{
			printf("failed to create/open log file\n");
			return 255;
		}


		// print out any important variable states
      //
      printf("\nDOS = ");

      if( trydoshi )
		{
         printf("HIGH\n");
			strcpy( szFileBuffer, "\nDOS = HIGH\n\0" );
			uByteCount = strlen( szFileBuffer );
			fSuccessful = dlWriteFile( iHandle, &uByteCount,
									(char far *)szFileBuffer );
			if( !fSuccessful )
			{
				printf("error writing to log file\n");
				dlCloseFile( iHandle );
				return 255;
			}
		}
      else
		{
         printf("LOW\n");
			strcpy( szFileBuffer, "\nDOS = LOW\n\0" );
			uByteCount = strlen( szFileBuffer );
			fSuccessful = dlWriteFile( iHandle, &uByteCount,
									(char far *)szFileBuffer );
			if( !fSuccessful )
			{
				printf("error writing to log file\n");
				dlCloseFile( iHandle );
				return 255;
			}
		}

		dlCloseFile( iHandle );


      // continue processing
      //
      printf(separator,2);
      configsys(PASS2);

		// create a log file to be parsed later
		//
		strcpy( szName, "PASS2.LOG\0");
		uAction = ACT_NEXIST_CREATE | ACT_EXIST_REPLACE;
		fSuccessful = dlOpenOrCreateFile( openMode, attributes, &uAction,
								szName, &iHandle );
		if( !fSuccessful )
		{
			printf("failed to create/open log file\n");
			return 255;
		}


		// print out any important variable states
      //
      printf("\nDOS = ");
      if( trydoshi )
		{
         printf("HIGH\n");
		}
      else
		{
         printf("LOW\n");
		}

      printf("stacks %d,%d\n",stacksNum,stacksSize);
		sprintf( szFileBuffer, "stacks %d,%d\n\0", stacksNum, stacksSize );
		uByteCount = strlen( szFileBuffer );
		fSuccessful = dlWriteFile( iHandle, &uByteCount,
								(char far *)szFileBuffer );
		if( !fSuccessful )
		{
			printf("error writing to log file\n");
			dlCloseFile( iHandle );
			return 255;
		}

      printf("BREAK = ");
      if(BREAK_FLAG)
		{
         printf("ON\n");
			strcpy( szFileBuffer, "BREAK = ON\n\0" );
			uByteCount = strlen( szFileBuffer );
			fSuccessful = dlWriteFile( iHandle, &uByteCount,
									(char far *)szFileBuffer );
			if( !fSuccessful )
			{
				printf("error writing to log file\n");
				dlCloseFile( iHandle );
				return 255;
			}
		}
      else
		{
         printf("OFF\n");
 			strcpy( szFileBuffer, "BREAK = OFF\n\0" );
			uByteCount = strlen( szFileBuffer );
			fSuccessful = dlWriteFile( iHandle, &uByteCount,
									(char far *)szFileBuffer );
			if( !fSuccessful )
			{
				printf("error writing to log file\n");
				dlCloseFile( iHandle );
				return 255;
			}
		}

      printf("buffers %d\n",init_buffers);
		sprintf( szFileBuffer, "buffers %d\n\0", init_buffers );
		uByteCount = strlen( szFileBuffer );
		fSuccessful = dlWriteFile( iHandle, &uByteCount,
								(char far *)szFileBuffer );
		if( !fSuccessful )
		{
			printf("error writing to log file\n");
			dlCloseFile( iHandle );
			return 255;
		}

		printf("files %d\n",init_files);
		sprintf( szFileBuffer, "files %d\n\0", init_files );
		uByteCount = strlen( szFileBuffer );
		fSuccessful = dlWriteFile( iHandle, &uByteCount,
								(char far *)szFileBuffer );
		if( !fSuccessful )
		{
			printf("error writing to log file\n");
			dlCloseFile( iHandle );
			return 255;
		}

      printf("FCBs %d  SFTs %d\n",sda_numfcbs,sda_numsfts);
		sprintf( szFileBuffer, "FCBs %d  SFTs %d\n\0", sda_numfcbs, sda_numsfts );
		uByteCount = strlen( szFileBuffer );
		fSuccessful = dlWriteFile( iHandle, &uByteCount,
								(char far *)szFileBuffer );
		if( !fSuccessful )
		{
			printf("error writing to log file\n");
			dlCloseFile( iHandle );
			return 255;
		}

      printf("Shell = %s\n",shell);
		sprintf( szFileBuffer, "Shell = %s\n\0", shell );
		uByteCount = strlen( szFileBuffer );
		fSuccessful = dlWriteFile( iHandle, &uByteCount,
								(char far *)szFileBuffer );
		if( !fSuccessful )
		{
			printf("error writing to log file\n");
			dlCloseFile( iHandle );
			return 255;
		}

      printf("country %s\n",country_buff);
		sprintf( szFileBuffer, "country %s\n\0", country_buff );
		uByteCount = strlen( szFileBuffer );
		fSuccessful = dlWriteFile( iHandle, &uByteCount,
								(char far *)szFileBuffer );
		if( !fSuccessful )
		{
			printf("error writing to log file\n");
			dlCloseFile( iHandle );
			return 255;
		}

		dlCloseFile( iHandle );


      // final pass
      //
      printf(separator,3);
      configsys(PASS3);

		// print out any important variable states
      //
      printf("\nDOS = ");
      if( trydoshi )
		{
         printf("HIGH\n");
		}
      else
		{
         printf("LOW\n");
		}

      printf("stacks %d,%d\n",stacksNum,stacksSize);

      printf("BREAK = ");
      if(BREAK_FLAG)
		{
         printf("ON\n");
		}
      else
		{
         printf("OFF\n");
		}

      printf("buffers %d\n",init_buffers);
      printf("files %d\n",init_files);

      printf("FCBs %d  SFTs %d\n",sda_numfcbs,sda_numsfts);

      printf("Shell = %s\n",shell);

      printf("country %s\n",country_buff);

   }
   return retcode;
}

unsigned PASCAL load_device(char far *name)
{
   char menuline[80];
   int iNameLen;


   iNameLen = fstrlen( name )+1;
   fmemcpy( (char far *)menuline, name, iNameLen );

   // returns the segment "loaded" into
   //
   printf( "load_device(%s)\n", menuline );


#if DEVICE_SUCCESSFUL
   return 0;
#else
   return 0xFFFF;
#endif
}

void PASCAL dev_init(LPDEV_HDR lpDevHeader, char far *pArgStr)
{
   char menuline[80];
   int iArgLen;

   iArgLen = fstrlen( pArgStr )+1;
   fmemcpy( (char far *)menuline, pArgStr, iArgLen );

   printf( "dev_init - %s\n", menuline );
}

int load_config(char far *name)
{
   void * new_seg;
   char far * fpBuffer;
   unsigned uFileLength;
   long lDistance;
   int iFileHandle,iActionTaken;
   char config_str[128];

   IntlFStrCpy( (char far *)config_str, name );

   printf( "load_config(%s)\n", config_str );

   // alloc new seg 16k
   // zero new seg
   //
   new_seg = mem_alloc_ptr( 16*1024, 'T' );
   fpBuffer = MK_FP(new_seg,0);

   // read file into new seg
   //
   iFileHandle = -1;
   SmartCreateOpenFile(O_RDONLY, 0, ACT_EXIST_OPEN, config_str,
      &iFileHandle, &iActionTaken);
   if( new_seg && (iFileHandle != -1) )
   {
      // determine file length
      //
      lDistance = -1L;
      dlSeekFile( SEEK_END, iFileHandle, &lDistance );
      uFileLength = (unsigned) lDistance+1;

      // read in up to 16k
      //
      lDistance = 0;
      dlSeekFile( SEEK_SET, iFileHandle, &lDistance );
      dlReadFile( iFileHandle, &uFileLength, fpBuffer );

      // close the file
      //
      dlCloseFile( iFileHandle );

      // tack on a ^Z
      //
      fpBuffer += uFileLength;
      *fpBuffer = 0x1A;

      cfg_seg = (unsigned) new_seg;
   }
   else
   {
      cfg_seg = 0;
   }

   return 0;
}

int spawn_tsr(char far *name, union EXEPARM *parms)
{
   char menuline[80];
   int iNameLen;

   iNameLen = fstrlen( name )+1;
   fmemcpy( (char far *)menuline, name, iNameLen );

   printf( "spawn_tsr - %s,parms\n", menuline );

#if TSR_SUCCESSFUL
   return 1;
#else
   return 0;
#endif
}

void set_umb_link(bool on)
{
   printf( "set_umb_link(" );
   if( on )
   {
      printf( "ON)\n" );
   }
   else
   {
      printf( "OFF)\n" );
   }
}

void disable_extended(void)
{
   printf( "extended keyboard disabled by SWITCHES\n" );
}

unsigned getDS(void)
{
   // This sets up the segment for the spawn_tsr() function
   //
   return 0x1234;
}

int con_getkey(void)
{
   asm mov ah,07h
   asm int 21h
   asm cbw

   return _AX;
}

int con_chkkey(void)
{
   asm mov ah, 0Bh
   asm int 21h
   asm cbw

   return( ~_AX );
}

void PASCAL touch_time(bool wr)
{
   unsigned far *fpTicks = MK_FP(0x40, 0x6c);
   static unsigned uBaseTicks = 0;

   if( (!uBaseTicks) || (wr != TM_READ) )
   {
      seconds = (*fpTicks - uBaseTicks) / 18;
   }
   else
   {
      uBaseTicks = *fpTicks;
   }
}

void * mem_alloc_ptr(unsigned bytes, char id)
{
   unsigned paras;
   void far * ptr;

   printf( "mem_alloc_ptr( 0x%04x, '%c' )\n", bytes, id );

   /* convert bytes to paragraphs */
   paras = bytes/16 + ((bytes & 0xF)?1:0);

   /* allocate the memory */
   ptr = dosmalloc(paras);

   /* zero the memory */
   fmemset(ptr,0,paras*16);

   return( (void *)FP_SEG(ptr) );
}

/*
	Allocate a number of paragraphs and return the
	segment of this memory.  This routine can allocate
	in one of 9 ways: first fit, best fit, last fit.

	bit 80H means UMBs first
	bit 40H means UMBs only
s
	Returns the segment of the allocated memory, or sets
	error_no and returns the largest free block on failure.
*/
unsigned PASCAL mem_alloc(unsigned para_req)
{
   void far * ptr;

   ptr = dosmalloc(para_req);

   return( FP_SEG(ptr) );
}

int alloc_hma(unsigned bytes)
{
   printf( "Allocating %u bytes of HMA\n", bytes );

   return 0;
}

// We won't actually "free" the memory for this test
// but we will report that we tried to
//
unsigned PASCAL mem_free(unsigned seg)
{
   printf( "Called mem_free( %04x )\n",seg);

   return 0;
}
