REM
REM   $Id: APCLEAN.BAT 1.27 2003/05/01 15:26:06Z thomd Exp $
REM
REM   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
REM
REM   Copyright (c) 1993 - 2002 Datalight, Inc.
REM   All Rights Reserved
REM
REM   Datalight, Inc. is a Washington corporation with an address at
REM   21520 30TH DR SE MS110 Bothell, WA, 98021
REM   Tel: 800.221.6630  Fax: 425.951.8091
REM   Http://www.datalight.com
REM
REM   This software, including without limitation all source code and
REM   documentation, is the confidential, trade secret property of
REM   Datalight, Inc., and is protected under the copyright laws of
REM   the United States and other jurisdictions. Portions of the
REM   software may also be subject to one or more the following US
REM   patents: US#5860082, US#6260156.
REM
REM   In addition to civil penalties for infringement of copyright
REM   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
REM   penalties for violation of (a) the restrictions on circumvention
REM   of copyright protection systems found in 17 U.S.C. 1201 and
REM   (b) the protections for the integrity of copyright management
REM   information found in 17 U.S.C. 1202.
REM
REM   U.S. Government Restricted Rights. Use, duplication,
REM   reproduction, or transfer of this commercial product and
REM   accompanying documentation is restricted in accordance with
REM   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
REM
REM   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
REM   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
REM   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
REM   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
REM   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
REM   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
REM   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
REM   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
REM   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
REM   THIS SOFTWARE IN ERROR.
REM
@echo %echo%
REM  APCLEAN.BAT
REM
REM  Copyright (c) 2000-2002 Datalight, Inc.
REM  All Rights Reserved.
REM  Datalight Confidential and Proprietary
REM

REM ----------------------------------------------------------------------
REM $DOCFILE:APCLEAN.BAT
REM
REM This is an optional batch file called as a part of Stage 10 of the
REM AUTOPROJ process.  It allows each project to perform project specific
REM cleanup as needed.  This batch file is called after the project has
REM been checkpointed, so it's generally too late to do anything that
REM will update the project.
REM
REM All the standard environment variables are set on entry.  On exit,
REM ERROR must be set to null if no error, or the error message text to
REM use if an error occurred.
REM ----------------------------------------------------------------------


rem  Post the romdos release for the test machines
rem
cd t:\products\romdos\romdos
if exist t:rdts\rd%sibldnum%\nul deltree /y t:rdts\rd%sibldnum%
if not exist t:rdts\nul md t:rdts
if not exist t:rdts\rd%sibldnum%\nul md t:rdts\rd%sibldnum%
if not exist t:rdts\rd%sibldnum%\support\nul md t:rdts\rd%sibldnum%\support
%localdrive%
cd %localdir%
cd release
xcopy *.* t:rdts\rd%sibldnum%\*.* /s
cd ..
cd testing
xcopy *.* t:rdts\rd%sibldnum%\support\*.* /s
cd ..


rem  Post the build for Install Shield to use
rem
%localdrive%
cd %localdir%
cd release
cd t:\products\isbuild\testing\romdos
if exist t:romdos\nul deltree /y t:romdos
if exist t:options\nul deltree /y t:options
if exist t:sockets\nul deltree /y t:sockets
xcopy 71\options\*.* t:options\*.* /s
xcopy 71\*.* t:romdos\*.* /s
xcopy sockets\*.* t:sockets\*.* /s
if exist t:romdos\options\nul deltree /y t:romdos\options


rem  Save the LASTGOODBLD and LASTGOODDATE variables
rem
set NLGB=%LASTGOODBLD%
set NLGD=%LASTGOODDATE%


rem  Get the previous ROM-DOS build number
rem
call t:\products\romdos\romdos7\autoproj\lastgood.bat
set PREVRDBLD=%LASTGOODBLD%


rem  Restore the LASTGOODBLD and LASTGOODDATE variables
rem
set LASTGOODBLD=%NLGB%
set LASTGOODDATE=%NLGD%
set NLGB=
set NLGD=


rem  Create a batch file containing the new build number
rem
%localdrive%
cd %localdir%
echo set LASTGOODBLD=%sibldnum%>romdos.bat
echo set LASTGOODDATE=%siblddate%>>romdos.bat
echo set PREVGOODBLD=%prevrdbld%>>romdos.bat


rem  Copy the batch file that contains the build number into
rem  the posting
rem
copy romdos.bat t:\products\romdos\romdos\rdts\rd%sibldnum%\support\622\lastgood.bat
copy romdos.bat t:\products\romdos\romdos\rdts\rd%sibldnum%\support\71\lastgood.bat


rem  Create a batch file to aid navigation to the new build
rem
echo CD T:\PRODUCTS\ROMDOS\ROMDOS\RDTS\RD%sibldnum%\71 > T:\PRODUCTS\ROMDOS\ROMDOS\RDTS\ROMDOS.BAT


rem  Set the token for install shield to run
rem
copy romdos.bat t:\products\isbuild\release\romdos.bat
del romdos.bat


rem  Save the LASTGOODBLD and LASTGOODDATE variables
rem
set NLGB=%LASTGOODBLD%
set NLGD=%LASTGOODDATE%


rem  Get the current ROM-DOS test suite build number
rem
call t:\products\romdos\rdtest7\autoproj\lastgood.bat
set tsbld=%LASTGOODBLD%


rem  Restore the LASTGOODBLD and LASTGOODDATE variables
rem
set LASTGOODBLD=%NLGB%
set LASTGOODDATE=%NLGD%
set NLGB=
set NLGD=


rem  Save the LASTGOODBLD and LASTGOODDATE variables
rem
set NLGB=%LASTGOODBLD%
set NLGD=%LASTGOODDATE%


rem  Get the current Sockets test suite build number
rem
call t:\products\romdos\socktest\autoproj\lastgood.bat
set skbld=%LASTGOODBLD%


rem  Restore the LASTGOODBLD and LASTGOODDATE variables
rem
set LASTGOODBLD=%NLGB%
set LASTGOODDATE=%NLGD%
set NLGB=
set NLGD=


rem  Set the tokens for the romdos test machines to run
rem
cd t:\products\romdos\rdtest7\autoproj
set rdbld=%sibldnum%

echo set rdbld=%rdbld%>t:%rdbld%%tsbld%.4
echo set tsbld=%tsbld%>>t:%rdbld%%tsbld%.4
c:\rdtest\bin\waitfor NULL /s180

echo set rdbld=%rdbld%>t:%rdbld%%tsbld%.3
echo set tsbld=%tsbld%>>t:%rdbld%%tsbld%.3
c:\rdtest\bin\waitfor NULL /s180

REM Microsoft test machines only need run when the test suite changes
REM  NOT when ROM-DOS changes.  Don't set these tokens...
REM
goto NoMicrosoft

echo set rdbld=%rdbld%>t:%rdbld%%tsbld%.2
echo set tsbld=%tsbld%>>t:%rdbld%%tsbld%.2
c:\rdtest\bin\waitfor NULL /s180

echo set rdbld=%rdbld%>t:%rdbld%%tsbld%.1
echo set tsbld=%tsbld%>>t:%rdbld%%tsbld%.1
REM no need to wait, machine 0 can launch immediately

echo set rdbld=%rdbld%>t:%rdbld%%tsbld%.0
echo set tsbld=%tsbld%>>t:%rdbld%%tsbld%.0

:NoMicrosoft
rem  Set the token for sockets test machines to run
rem
cd t:\products\romdos\socktest\autoproj
echo set rdbld=%rdbld%>t:%rdbld%%tsbld%.0
echo set tsbld=%tsbld%>>t:%rdbld%%tsbld%.0
echo set skbld=%skbld%>>t:%rdbld%%tsbld%.0

:fini
