REM
REM   $Id: b71suv.bat 1.4 2003/08/08 16:17:24Z thomd Exp $
REM
REM   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
REM
REM   Copyright (c) 1993 - 2002 Datalight, Inc.
REM   All Rights Reserved
REM
REM   Datalight, Inc. is a Washington corporation with an address at
REM   21520 30TH DR SE MS110 Bothell, WA, 98021
REM   Tel: 800.221.6630  Fax: 425.951.8091
REM   Http://www.datalight.com
REM
REM   This software, including without limitation all source code and
REM   documentation, is the confidential, trade secret property of
REM   Datalight, Inc., and is protected under the copyright laws of
REM   the United States and other jurisdictions. Portions of the
REM   software may also be subject to one or more the following US
REM   patents: US#5860082, US#6260156.
REM
REM   In addition to civil penalties for infringement of copyright
REM   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
REM   penalties for violation of (a) the restrictions on circumvention
REM   of copyright protection systems found in 17 U.S.C. 1201 and
REM   (b) the protections for the integrity of copyright management
REM   information found in 17 U.S.C. 1202.
REM
REM   U.S. Government Restricted Rights. Use, duplication,
REM   reproduction, or transfer of this commercial product and
REM   accompanying documentation is restricted in accordance with
REM   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
REM
REM   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
REM   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
REM   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
REM   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
REM   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
REM   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
REM   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
REM   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
REM   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
REM   THIS SOFTWARE IN ERROR.
REM
@echo off
REM
REM  BUILD71.BAT
REM
REM  Copyright (c) 2000-2002 Datalight, Inc.
REM  All Rights Reserved.
REM  Datalight Confidential and Proprietary
REM
REM  HISTORY
REM   05/03/2001 jmb fixed a problem with the NED_DIR if DL_ROOT is set.
REM   04-12/2001 jmb modified NED and PROTO copy paths if DL_ROOT is set
REM

set bldlog=
if NOT "%buildlog%"=="" goto start
set buildlog=..\build.log
set bldlog=1


:start


REM Create the release tree directory
REM
if exist release\suv\71\nul deltree /y release\suv\71
if exist release\suv\docs\nul deltree /y release\suv\docs
if not exist release\nul md release
if not exist release\suv\nul md release\suv
if not exist release\suv\71\nul md release\suv\71
if not exist release\suv\DOCS\nul md release\suv\DOCS



REM Build TOOLS first
REM
call setdeb release 32 suv
echo Building Required Tools...
cd bin\source
make -B >>%buildlog%
cd ..\..
%DEBUGCMD%


REM
REM Build TOOLS used to make a ROMDOS release
REM

echo Building BIN...
cd bin
make -B >>%buildlog%
cd ..
%DEBUGCMD%


REM
REM  Build ROMDOS Libraries
REM

rem goto nolibbld
echo Building Library Code...
cd lib
if exist *.lib del *.lib
recurse command /c if exist makefile make -B >>%buildlog%
if exist makefile make -B >>%buildlog%
cd ..
%DEBUGCMD%
:nolibbld


REM
REM  Build romdos binaries
REM


call setdeb release 32 suv


echo Building ROMDOS kernel
cd kernel
if exist makefile make -B >>%buildlog%
cd ..


call setdeb release 32 suv


echo Building BUILD.EXE
cd build
set SUV_BUILD=SUV
if exist makefile make -B >>%buildlog%
call makelibs
set SUV_BUILD=
cd ..


echo Building default 7.1  release kernel
cd build
@if exist build.bat del build.bat
build <..\71lfn.key
cd ..


call setdeb release 32 suv


echo Building LFN command
cd command
if exist makefile make -B command.com >>%buildlog%
cd ..


echo Building LFN utilities...
cd utils
recurse command /c if exist makefile make -B >>%buildlog%
if exist makefile make -B >>%buildlog%
cd ..


echo Building non-LFN utilities...
cd nonlfn
recurse command /c if exist makefile make -B >>%buildlog%
if exist makefile make -B >>%buildlog%
cd ..


call setdeb release 32 suv


echo Building drivers
cd drivers
recurse command /c if exist makefile make -B >>%buildlog%
if exist makefile make -B >>%buildlog%
cd ..


REM
REM  Copy the files to the release tree
REM


REM root directory
REM
copy build\rom-dos.sys release\suv\71


REM  utils
REM
copy drivers\ansi\ansi.sys              release\suv\71\ansi.sys
copy drivers\ata\ata.sys                release\suv\71\ata.sys
copy utils\attrib\attrib.exe            release\suv\71
copy nonlfn\backup\backup.exe           release\suv\71
copy drivers\cdex\mscdex.exe            release\suv\71
copy utils\chkdsk\chkdsk.exe            release\suv\71
copy utils\choice\choice.com            release\suv\71
copy command\command.com                release\suv\71
copy command\command.hlp                release\suv\71
copy drivers\country\country.sys        release\suv\71
copy utils\comm\comm.exe                release\suv\71
rem copy utils\defrag\defrag.exe        release\suv\71
copy utils\deltree\deltree.exe          release\suv\71
copy utils\disk2img\disk2img.exe        release\suv\71
copy utils\diskcomp\diskcomp.com        release\suv\71
copy utils\diskcopy\diskcopy.com        release\suv\71
copy drivers\display\display.sys        release\suv\71
copy utils\dump\dump.exe                release\suv\71
copy drivers\display\ega.cpi            release\suv\71
copy drivers\display\ega3.cpi           release\suv\71
copy drivers\emm386\emm386.exe          release\suv\71
copy utils\exe2bin\exe2bin.com          release\suv\71
copy utils\fdisk\fdisk.exe              release\suv\71
copy utils\find\find.exe                release\suv\71
copy utils\format\format.com            release\suv\71
copy drivers\himem\himem.sys            release\suv\71
copy drivers\keyb\keyb.com              release\suv\71
copy drivers\keyb\keyboard.sys          release\suv\71
copy drivers\keyb\keybrd2.sys           release\suv\71
copy utils\label\label.exe              release\suv\71
rem copy kernel\longname.txt            release\suv\71
copy utils\mem\mem.exe                  release\suv\71
copy utils\mode\mode.com                release\suv\71
copy utils\more\more.com                release\suv\71
copy utils\move\move.exe                release\suv\71
copy utils\power\power.exe              release\suv\71
copy nonlfn\print\print.exe             release\suv\71
copy nonlfn\backup\restore.exe          release\suv\71
copy nonlfn\rsz\rsz.exe                 release\suv\71\rsz.exe
copy utils\client\serlink.exe           release\suv\71
copy utils\server\serserv.exe           release\suv\71
copy nonlfn\share\share.exe             release\suv\71
copy utils\cache\smartdrv.exe           release\suv\71
copy utils\sort\sort.exe                release\suv\71
copy drivers\stackdev\stackdev.sys      release\suv\71\stackdev.sys
copy utils\subst\subst.exe              release\suv\71
copy utils\sys\sys.com                  release\suv\71
copy utils\transfer\transfer.exe        release\suv\71
copy utils\tree\tree.com                release\suv\71
copy kernel\umblink.exe                 release\suv\71
copy memdisk\vdisk.sys                  release\suv\71
copy drivers\version\version.sys        release\suv\71
copy utils\xcopy\xcopy.exe              release\suv\71


REM  Copy in the items from devtools which are in the ROMDOS release
REM
cd release\suv\71
set ned_dir=c:\dl\devtools\bin
if not "%dl_root%" == "" set ned_dir=%dl_root%\devtools\bin
copy %ned_dir%\ned.exe
set ned_dir=
cd ..\..\..


rem  Copy the user manuals and readme.txt into the release tree
rem
copy docs\single~1.pdf release\suv\docs
bin\verhdr >hdr.txt
copy hdr.txt+docs\SUVread.me readme.tmp
copy readme.tmp release\suv\readme.txt
del readme.tmp

REM Update the file time to reflect the version
bin\sdkver 7.10 release\suv\71


:done
if "%bldlog%"=="1" set buildlog=
