//
//   $Id: SAVE.H 1.4 2002/10/15 19:58:14Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
	SAVE.H

	Copyright (c) 1994-2002 Datalight, Inc.
	Datalight Proprietary and Confidential
	All Rights Reserved

	Revision History
		06/20/97 - ms  - original (moved from save.c)

	Description
		macro definitions for SAVE.C program
*/
#define USAGE	"SAVE\r\n"\
					"Copyright (c) 1994 Datalight, Inc.\r\n\r\n"\
					"Syntax : SAVE [Item] [EnvSymName]\r\n\r\n"\
					"SAVE places values in the Permanent Command Environment such\n"\
					"as time, date or the current working directory.  Saveable\n"\
					"items are DOS, VER, DATE, TIME, DRIVE, and CWD (current \n"\
					"working directory)\n"\
					"Example:\n"\
					"save date today\n"\
					"\tThis example will set an environment variable to \n"\
					"\tTODAY=3-16-1994\n"\
					"\tLater a batch file command \"date %TODAY%\" could reset\n"\
					"\tthe date\n"\
					"Save DOS DOS\n"\
					"\tThis example will set an environment variable named\n"\
					"\tDOS to ROM-DOS or MS-DOS etc.\n"\
					"Save \"This is a test\" JUNK\n"\
					"\tSets Environment variable JUNK as \"This is a test\"\n"

#define GET_DEFAULT_DRIVE 0x1900
#define GET_SYSTEM_DATE 0x2a00
#define GET_SYSTEM_TIME 0x2c00
#define GET_DOS_VERSION 0x3000
#define GET_REVISION    0x30DB
#define GET_CWD         0x4700

#define CHECKVAL	      0xB2D2

#define COMMAND_LIST {"DATE", "TIME", "CWD", "DOS", "VER", "DRIVE", "REV"}
#define NUMBER_OF_COMMANDS 7

#define EQUALS '='
