//
//   $Id: VERHDR.C 1.3 2002/10/15 19:58:14Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//  VERHDR.C
//
//  Copyright (c) 2001-2002 Datalight, Inc.
//  All Rights Reserved.
//  Datalight Confidential and Proprietary
//
//  HISTORY:
//
//  06-22-01  bt  Created
//


//  Borland libraries
//
#include <stdio.h>
#include <string.h>
#include <mem.h>


//  Datalight libraries
//
#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "dldosio.h"
#include "dosver.h"
#include "bldver.h"


//  Prototypes
//
#include "verhdr.pt"


//  Start of the program
//
uchar main( int argc, char *argv[] )
{
	uchar ucExitCode = 0;
	static char szTemp[40];
	static char szTemp2[80];
	static char szTemp3[80];
	char szLine1a[] = "Datalight";
	char szRomdos[] = "ROM-DOS";
	char szSockets[] = "Sockets";
	char * szLine1b;
#ifdef ENABLEF32
	char szLine1c[] = SHORTVERSION;
#else
	char szLine1c[] = SHORTVERSION622;
#endif
	char szLine1d[] = BUILDVERSION;
	char szLine2[] = "Software Developer's Kit";
	char szLine3[] = COPYRIGHT;
	DOSDate DOSDate;
	char * szMonth[] = {
		"",
		"January",
		"February",
		"March",
		"April",
		"May",
		"June",
		"July",
		"August",
		"September",
		"October",
		"November",
		"December",
	};


	//  Get the date
	//
	dlGetDOSDate( &DOSDate );
	sprintf( szTemp, "%s %u, %u", szMonth[DOSDate.month], DOSDate.day,
			DOSDate.year );


	if( (argc == 2) && (stricmp(argv[1],"/s") == 0) )
	{
		szLine1b = szSockets;
		sprintf(szTemp2, "%s %s %s", szLine1a, szLine1b, szLine1d );
		CenterLine( 78, szTemp2, szTemp3 );
		printf("%s\n", szTemp3 );

		CenterLine( 78, szLine2, szTemp3 );
		printf("%s\n", szTemp3 );

		CenterLine( 78, szLine3, szTemp3 );
		printf("%s\n", szTemp3 );

		CenterLine( 78, szTemp, szTemp3 );
		printf("%s\n\n", szTemp3 );
	}
	else
	{
		//  Build the header and echo it out
		//
		szLine1b = szRomdos;
		printf("\n%s %s %s %s\n", szLine1a, szLine1b, szLine1c, szLine1d );
		printf("%s\n", szLine2 );
		printf("%s%39s\n", szLine3, szTemp );
	}


	return ucExitCode;
}


//  Center a line
//
void CenterLine( uchar ucLineWidth, char * szSourceString,
		char * szDestString )
{
	unsigned uLength;


	uLength = strlen( szSourceString );
	if( uLength > ucLineWidth )
	{
		szDestString[0] = 0;
	}


	uLength  = (unsigned)ucLineWidth - uLength;
	uLength /= 2;


	memset( szDestString, ' ', uLength );
	strcpy( &szDestString[uLength], szSourceString );
}
