#  $Id: devsrc.mak 1.5 2003/03/20 17:21:34Z thomd Exp $
#
#  *** DO NOT REMOVE THE FOLLOWING NOTICE ***
#
#  Copyright (c) 1989-2003 Datalight, Inc.
#  All Rights Reserved
#
#  Datalight, Inc. is a Washington corporation located at:
#
#  21520 30th Dr SE, Suite 110,          Tel: +1.425.951.8086
#  Bothell, WA  98021                    Fax: +1.425.951.8094
#  USA                                   Http://www.datalight.com
#
#  This software, including without limitation all source code and
#  documentation, is the confidential, trade secret property of
#  Datalight, Inc., and is protected under the copyright laws of
#  the United States and other jurisdictions.  Portions of the
#  software may also be subject to one or more the following US
#  patents: US#5860082, US#6260156.
#
#  In addition to civil penalties for infringement of copyright
#  under applicable U.S. law, 17 U.S.C. 1204 provides criminal
#  penalties for violation of (a) the restrictions on circumvention
#  of copyright protection systems found in 17 U.S.C. 1201 and
#  (b) the protections for the integrity of copyright management
#  information found in 17 U.S.C. 1202.
#
#  U.S. Government Restricted Rights.  Use, duplication,
#  reproduction, or transfer of this commercial product and
#  accompanying documentation is restricted in accordance with
#  FAR 12.212 and DFARS 227.7202 and by a License Agreement.
#
#  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
#  PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
#  AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
#  INC. AND THE LICENSEE ("BINDING AGREEMENT").  YOUR RIGHT, IF ANY,
#  TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
#  TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
#  USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
#  TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT.  CONTACT
#  DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
#  THIS SOFTWARE IN ERROR.
#
# --------------------------------------------------------
#  Makefile for the Datalight Built-In Device Drivers
#
#  Modules:
#  DEVCLK   ASM       Clock Driver (Int 1Ah)
#  DEVCOM   ASM       COMn Driver (Int 14h)
#  DEVCON   ASM       Console Driver (Int 10h, Int 16h)
#  DEVFDHD  ASM       Floppy/Hard Disk Driver (Int 13h)
#  DEVFDHDI ASM       Floppy/Hard Disk Init Code
#  DEVNUL   ASM       NUL Driver
#  DEVPRN   ASM       LPTn Driver (Int 17h)
#  DEVROM   ASM       ROM-DISK Driver
#  DEVFDHD  INC       Defines for Floppy/Hard Disk Driver
#
#  This makefile contains targets for each of the built-in drivers.
#  Each driver has a library target, that results in a USER.LIB in the
#  ROM-DOS Kernel directory. For example, assume you want to make
#  a specialized built-in ROM-DISK. Simply type:
#
#     MAKE devrom.lib
#
#  Note: RD_SW_A is an environment variable that can be set to
#  include debugging information without changing makefile.
#

# BORLAND C compiler/linker options
# ---------------------------------
ASM      = TASM
AFLAGS   = /z /mx /zd $(RD_SW_A) /I..
LIBR     = TLIB
LIBEND   =

#  DEVCLK   ASM       Clock Driver (Int 1Ah)
devclk.lib : devclk.obj
	$(LIBR) ..\user.lib -+devclk$(LIBEND)

#  DEVCOM   ASM       COMn Driver (Int 14h)
devcom.lib : devcom.obj
	$(LIBR) ..\user.lib -+devcom$(LIBEND)

#  DEVCON   ASM       Console Driver (Int 10h, Int 16h)
devcon.lib : devcon.obj
	$(LIBR) ..\user.lib -+devcon$(LIBEND)

#  DEVFDHD  ASM       Floppy/Hard Disk Driver (Int 13h)
#  DEVFDHDI ASM       Floppy/Hard Disk Init Code
#  DEVFDHD  INC       Defines for Floppy/Hard Disk Driver
devfdhd.lib : devfdhd.obj devfdhdi.obj
	$(LIBR) ..\user.lib -+devfdhd -+devfdhdi$(LIBEND)

#  DEVNUL   ASM       NUL Driver
devnul.lib : devnul.obj
	$(LIBR) ..\user.lib -+devnul$(LIBEND)

#  DEVPRN   ASM       LPTn Driver (Int 17h)
devprn.lib : devprn.obj
	$(LIBR) ..\user.lib -+devprn$(LIBEND)

#  DEVROM   ASM       ROM-DISK Driver
devrom.lib : devrom.obj
	$(LIBR) ..\user.lib -+devrom$(LIBEND)

# make all the drivers
all : devclk.lib devcom.lib devcon.lib devfdhd.lib devnul.lib devprn.lib devrom.lib


clean :
	if exist *.lib del *.lib
	if exist *.obj del *.obj
	if exist *.lst del *.lst

# GENERIC RULES
# -----------------
.asm.obj:
   $(ASM) $(AFLAGS) $*.asm;
