REM
REM   $Id: buildrxe.bat 1.7 2002/10/15 18:12:18Z peterb Exp $
REM
REM   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
REM
REM   Copyright (c) 1993 - 2002 Datalight, Inc.
REM   All Rights Reserved
REM
REM   Datalight, Inc. is a Washington corporation with an address at
REM   21520 30TH DR SE MS110 Bothell, WA, 98021
REM   Tel: 800.221.6630  Fax: 425.951.8091
REM   Http://www.datalight.com
REM
REM   This software, including without limitation all source code and
REM   documentation, is the confidential, trade secret property of
REM   Datalight, Inc., and is protected under the copyright laws of
REM   the United States and other jurisdictions. Portions of the
REM   software may also be subject to one or more the following US
REM   patents: US#5860082, US#6260156.
REM
REM   In addition to civil penalties for infringement of copyright
REM   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
REM   penalties for violation of (a) the restrictions on circumvention
REM   of copyright protection systems found in 17 U.S.C. 1201 and
REM   (b) the protections for the integrity of copyright management
REM   information found in 17 U.S.C. 1202.
REM
REM   U.S. Government Restricted Rights. Use, duplication,
REM   reproduction, or transfer of this commercial product and
REM   accompanying documentation is restricted in accordance with
REM   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
REM
REM   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
REM   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
REM   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
REM   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
REM   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
REM   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
REM   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
REM   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
REM   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
REM   THIS SOFTWARE IN ERROR.
REM
@echo off
REM
REM  BUILDRXE.BAT
REM
REM  Copyright (c) 2000-2002 Datalight, Inc.
REM  All Rights Reserved.
REM  Datalight Confidential and Proprietary
REM

set bldlog=
if NOT "%buildlog%"=="" goto start
set buildlog=..\build.log
set bldlog=1


:start


REM Create the release tree directory
REM
if exist release\%1\rxe\nul deltree /y release\%1\rxe
if not exist release\nul md release
md release\%1\rxe
md release\%1\rxe\b-start
md release\%1\rxe\examples
md release\%1\rxe\libsrc
md release\%1\rxe\ms-start


call setdeb release 32


REM Build ABSDISK.SYS
REM
echo Building ABSDISK...
cd rxe\absdisk
make -B >>%buildlog%
cd ..\..
%DEBUGCMD%


REM Build RXEVERFY.EXE
REM
echo Building RXEVERFY...
cd rxe\rxeverfy
make -B >>%buildlog%
cd ..\..
%DEBUGCMD%


REM Build RXEOPTIM.EXE
REM
echo Building RXEOPTIM...
cd rxe\rxeoptim
make -B >>%buildlog%
cd ..\..
%DEBUGCMD%


REM Build RXE_CVT.EXE and RXE_INIT.EXE
REM
echo Building RXE_CVT and RXE_INIT...
cd rxe
make -B >>%buildlog%
cd ..
%DEBUGCMD%


REM Build ROMDISK.EXE
REM
echo Building ROMDISK...
cd nonlfn\romdisk
make -B >>%buildlog%
cd ..\..
%DEBUGCMD%


REM
REM  Copy the files to the release tree
REM


REM root directory
REM
copy rxe\absdisk\absdisk.asm release\%1\rxe
copy rxe\absdisk\absdisk.sys release\%1\rxe
copy rxe\absdisk\reset.exe   release\%1\rxe
copy rxe\readme.txt release\%1\rxe
copy nonlfn\romdisk\romdisk.exe release\%1\rxe
copy rxe\rxe_cvt.exe release\%1\rxe
copy rxe\rxe_init.asm release\%1\rxe
copy rxe\rxe_init.exe release\%1\rxe
copy rxe\rxeverfy\rxeverfy.exe release\%1\rxe
copy rxe\rxeoptim\rxeoptim.exe release\%1\rxe
copy rxe\rxe-flot.txt release\%1\rxe
copy "rxe\rxe theory of operation.pdf" release\%1\rxe


REM  B-START directory
REM
xcopy rxe\b-start\bc2\*.obj  release\%1\rxe\b-start\bc2\*.obj
xcopy rxe\b-start\bc3\*.obj  release\%1\rxe\b-start\bc3\*.obj
xcopy rxe\b-start\bc4\*.obj  release\%1\rxe\b-start\bc4\*.obj
xcopy rxe\b-start\bc45\*.obj release\%1\rxe\b-start\bc45\*.obj
xcopy rxe\b-start\bc5\*.obj  release\%1\rxe\b-start\bc5\*.obj


REM  EXAMPLES directory
REM
xcopy rxe\examples release\%1\rxe\examples /s
copy release\%1\rxe\examples\makefile.mak release\%1\rxe\examples\makefile
del  release\%1\rxe\examples\makefile.mak


REM  LIBSRC directory
REM
xcopy rxe\libsrc release\%1\rxe\libsrc /s
copy release\%1\rxe\libsrc\makefile.mak release\%1\rxe\libsrc\makefile
del  release\%1\rxe\libsrc\makefile.mak


REM  MS-START directory
REM
md release\%1\rxe\MS-START\MS-C600
md release\%1\rxe\MS-START\MSVC
md release\%1\rxe\MS-START\MS-C600\C
md release\%1\rxe\MS-START\MS-C600\L
md release\%1\rxe\MS-START\MS-C600\M
md release\%1\rxe\MS-START\MS-C600\S
md release\%1\rxe\MS-START\MS-C600\C\DOS
copy rxe\ms_start\MS-C600\C\DOS\CRT0.OBJ release\%1\rxe\MS-START\MS-C600\C\DOS
md release\%1\rxe\MS-START\MS-C600\L\DOS
copy rxe\ms_start\MS-C600\L\DOS\CRT0.OBJ release\%1\rxe\MS-START\MS-C600\L\DOS
md release\%1\rxe\MS-START\MS-C600\M\DOS
copy rxe\ms_start\MS-C600\M\DOS\CRT0.OBJ release\%1\rxe\MS-START\MS-C600\M\DOS
md release\%1\rxe\MS-START\MS-C600\S\DOS
copy rxe\ms_start\MS-C600\S\DOS\CRT0.OBJ release\%1\rxe\MS-START\MS-C600\S\DOS
md release\%1\rxe\MS-START\MSVC\C
md release\%1\rxe\MS-START\MSVC\L
md release\%1\rxe\MS-START\MSVC\M
md release\%1\rxe\MS-START\MSVC\S
md release\%1\rxe\MS-START\MSVC\C\DOS
copy rxe\ms_start\MSVC\C\DOS\CRT0.OBJ release\%1\rxe\MS-START\MSVC\C\DOS
md release\%1\rxe\MS-START\MSVC\L\DOS
copy rxe\ms_start\MSVC\L\DOS\CRT0.OBJ release\%1\rxe\MS-START\MSVC\L\DOS
md release\%1\rxe\MS-START\MSVC\M\DOS
copy rxe\ms_start\MSVC\M\DOS\CRT0.OBJ release\%1\rxe\MS-START\MSVC\M\DOS
md release\%1\rxe\MS-START\MSVC\S\DOS
copy rxe\ms_start\MSVC\S\DOS\CRT0.OBJ release\%1\rxe\MS-START\MSVC\S\DOS

IF "%1"=="622" goto ver622
IF "%1"=="71" goto ver71

:ver622
REM Update the file time to reflect the version
bin\sdkver 6.22 release\%1\rxe
bin\sdkver 6.22 release\%1\rxe\examples
goto done

:ver71
REM Update the file time to reflect the version
bin\sdkver 7.10 release\%1\rxe
bin\sdkver 7.10 release\%1\rxe\examples
goto done

:done
if "%bldlog%"=="1" set buildlog=
