REM
REM   $Id: buildsck.bat 1.21 2003/07/24 22:42:26Z thomd Exp $
REM
REM   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
REM
REM   Copyright (c) 1993 - 2002 Datalight, Inc.
REM   All Rights Reserved
REM
REM   Datalight, Inc. is a Washington corporation with an address at
REM   21520 30TH DR SE MS110 Bothell, WA, 98021
REM   Tel: 800.221.6630  Fax: 425.951.8091
REM   Http://www.datalight.com
REM
REM   This software, including without limitation all source code and
REM   documentation, is the confidential, trade secret property of
REM   Datalight, Inc., and is protected under the copyright laws of
REM   the United States and other jurisdictions. Portions of the
REM   software may also be subject to one or more the following US
REM   patents: US#5860082, US#6260156.
REM
REM   In addition to civil penalties for infringement of copyright
REM   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
REM   penalties for violation of (a) the restrictions on circumvention
REM   of copyright protection systems found in 17 U.S.C. 1201 and
REM   (b) the protections for the integrity of copyright management
REM   information found in 17 U.S.C. 1202.
REM
REM   U.S. Government Restricted Rights. Use, duplication,
REM   reproduction, or transfer of this commercial product and
REM   accompanying documentation is restricted in accordance with
REM   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
REM
REM   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
REM   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
REM   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
REM   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
REM   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
REM   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
REM   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
REM   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
REM   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
REM   THIS SOFTWARE IN ERROR.
REM
@echo off
REM
REM  BUILDSCK.BAT
REM
REM  Copyright (c) 2000-2002 Datalight, Inc.
REM  All Rights Reserved.
REM  Datalight Confidential and Proprietary
REM
REM  History
REM  03/20/2003 tzd removed PDF docs and docs subdirectory
REM  02/20/2003 jmb added SOCKETS API and a bunch of other stuff
REM                 to enable linking with LIBS for CAPI and the new
REM                 API.  Added SOCKET API Diagnostic, SOCKDIAG and
REM                 example application, STELNET.
REM  10/08/2002 pb  added build and copy for ARPDIAG.EXE which will
REM                 be included in the testing\71 directory as a test suite
REM                 support utility.
REM  07/18/2001 jmb added copy for CGI.BAT in server directory
REM  06/21/2001 jmb added copy for *.CSS in SERVER directory
REM  05/21/2001 jmb added copy for UTILS.MS in UTILS directory
REM  05/10/2001 jmb added copy for GETCH.H in INCLUDE directory
REM  05/03/2001 jmb added copy for read.me in DOCS dir to release\sockets
REM  04/17/2001 jmb added check for DL_ROOT.  If DL_ROOT is not set,
REM                 then SOCKETS will not build.  Removed copy for
REM                 FTPSIG.H.
REM  04/19/2001 pb  added script to copy the docs to the release tree.
REM


set bldlog=
if NOT "%buildlog%"=="" goto start
set buildlog=..\build.log
set bldlog=1

if exist %BCROOT%\LIB\NOEHC.LIB goto start
echo.
echo -------------- A L E R T ----------------------------------------
echo Sockets requires DEVTOOLS to build.
echo -----------------------------------------------------------------
echo.
echo.                                                                  >>%buildlog%
echo -------------- A L E R T ---------------------------------------- >>%buildlog%
echo Sockets requires DEVTOOLS to build.                               >>%buildlog%
echo ----------------------------------------------------------------- >>%buildlog%
echo.                                                                  >>%buildlog%
goto done

:start


REM Create the release tree directory
REM
if exist release\sockets\nul deltree /y release\sockets
if not exist release\nul md release
md release\sockets
md release\sockets\bsdsock
md release\sockets\capi
md release\sockets\clients
md release\sockets\configs
md release\sockets\examples
md release\sockets\server
md release\sockets\utils
md release\sockets\include
md release\sockets\lib


call setdeb release 32

REM Build Libraries
REM 
echo Building Libraries >>%buildlog%
echo Building Libraries
cd sockets\capi
make -B >>%buildlog%
cd ..\..
cd sockets\bsdsock
make -B >>%buildlog%
cd ..\..

REM Build KERNEL
REM
echo Building Kernel... >>%buildlog%
echo Building Kernel...
cd sockets\kernel
make -B >>%buildlog%
cd ..\..
%DEBUGCMD%


REM Build SERVER
REM
echo Building Servers >>%buildlog%
echo Building Servers
cd sockets\server
make -B >>%buildlog%
cd ..\..
%DEBUGCMD%


REM Build CLIENTS
REM
echo Building Clients... >>%buildlog%
echo Building Clients...
REM ####
REM #### DEBUGGING CODE!!!!!
REM ####
cd sockets\clients >>%buildlog%
cd >>%buildlog%
make -B all >>%buildlog%
cd ..\.. >>%buildlog%
cd >>%buildlog%
%DEBUGCMD%


REM Build EXAMPLES
REM
echo Building Examples... >>%buildlog%
echo Building Examples...
cd sockets\examples
make -fexample -B >>%buildlog%
cd ..\..
%DEBUGCMD%


REM Build UTILS
REM
echo Building Utilities... >>%buildlog%
echo Building Utilities...
cd sockets\utils
make -B>>%buildlog%
cd ..\..
%DEBUGCMD%


REM Build ARPDIAG for the test suite
REM
echo Building ARPDIAG... >>%buildlog%
echo Building ARPDIAG...
cd sockets\utils\arpdiag
make -B -farpdiag.mak>>%buildlog%
cd ..\..\..
%DEBUGCMD%


REM
REM  Copy the files to the release tree
REM


REM root directory
REM
xcopy sockets\kernel\socketm\socketm.exe release\sockets
xcopy sockets\kernel\socketp\socketp.exe release\sockets
xcopy sockets\kernel\hosts release\sockets
xcopy sockets\services\*.* release\sockets
xcopy sockets\utils\sconfig\sconfig.exe release\sockets


REM  SERVER directory
REM
xcopy sockets\server\*.exe release\sockets\server
xcopy sockets\server\*.c   release\sockets\server
xcopy sockets\server\*.jpg release\sockets\server
xcopy sockets\server\*.htm release\sockets\server
xcopy sockets\server\*.jar release\sockets\server
xcopy sockets\server\*.gif release\sockets\server
xcopy sockets\server\*.css release\sockets\server
xcopy sockets\server\cgi.bat release\sockets\server
xcopy sockets\server\cgi.mak release\sockets\server
xcopy sockets\server\htaccess. release\sockets\server
xcopy sockets\server\socket.upw release\sockets\server


REM UTILS directory
REM
xcopy sockets\utils\*.exe release\sockets\utils
xcopy sockets\utils\*.c   release\sockets\utils
xcopy sockets\utils\utils.mak release\sockets\utils
xcopy sockets\utils\utils.ms release\sockets\utils
xcopy sockets\utils\capidiag.pt release\sockets\utils
xcopy sockets\utils\sockdiag.pt release\sockets\utils
xcopy sockets\utils\*.dj release\sockets\utils
xcopy sockets\utils\*.lnk release\sockets\utils


REM  EXAMPLES directory
REM
xcopy sockets\examples release\sockets\examples


REM  CLIENTS directory
REM
xcopy sockets\clients\*.exe release\sockets\clients
xcopy sockets\clients\*.com release\sockets\clients
xcopy sockets\clients\*.scr release\sockets\clients


REM  API directories
REM
xcopy sockets\capi\capi.c release\sockets\capi
xcopy sockets\capi\_capi.c release\sockets\capi
xcopy sockets\bsdsock\socket.c release\sockets\bsdsock


REM  CONFIGS directory
REM
xcopy sockets\configs\*.* release\sockets\configs


REM  from the DOCS directory
REM
bin\verhdr /s >hdr.txt
copy hdr.txt+sockets\docs\read.me readme.tmp
copy readme.tmp release\sockets\read.me
del readme.tmp


REM  INCLUDE directory
REM
copy sockets\include\capi.h     release\sockets\include
copy sockets\include\compiler.h release\sockets\include
copy sockets\include\ftpapi.h   release\sockets\include
copy sockets\include\api.h      release\sockets\include
copy sockets\include\cgiadap.h  release\sockets\include
copy sockets\include\ssi.h      release\sockets\include
copy sockets\include\htapic.h   release\sockets\include
copy sockets\include\getch.h    release\sockets\include
copy sockets\include\arpapi.h   release\sockets\include
copy sockets\include\socket.h   release\sockets\include
rem copy sockets\include\ftpsig.h release\sockets\include

REM LIB directory
REM
copy sockets\lib\*.* release\sockets\lib


REM  ARPDIAG for testing
REM
copy sockets\utils\arpdiag\arpdiag.exe  testing\71


REM Update the file time to reflect the version
bin\sdkver 7.10 release\sockets
bin\sdkver 7.10 release\sockets\capi
bin\sdkver 7.10 release\sockets\server
bin\sdkver 7.10 release\sockets\utils
bin\sdkver 7.10 release\sockets\clients
bin\sdkver 7.10 release\sockets\include
bin\sdkver 7.10 release\sockets\configs
bin\sdkver 7.10 release\sockets\examples


:done
if "%bldlog%"=="1" set buildlog=
