;
;   $Id: COMASM.ASM 1.11 2002/10/15 20:08:46Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;---------------------------------------------------------------------------
; $DOCMODULE:COMASM.ASM
;
; Copyright (c) 1989-2002 Datalight, Inc.
; Datalight Confidential and Proprietary.
; All Rights Reserved.
;
; Entry points to the TRANSIENT portion of COMMAND and communications
; between the RESIDENT and TRANSIENT portions.
;
; $DOCHISTORY
;
; 03/25/1999 dg  Added LFNFOR
; 08/20/1997 de  SPR 1361: revised to fix batch file processing bug
; 11/10/1988 dg  Created by Drew Gislason
;
;---------------------------------------------------------------------------
include macros.inc

__FILENUM__	equ	10


;	[]------------------------------[]
;	 |				|
;	 |	CRITICAL DATA		|
;	 |				|
;	[]------------------------------[]
DGROUP	GROUP	_CRIT_DATA

_CRIT_DATA	segment word public 'DATA'
	extrn	_errno:word
	extrn	_beg_res_vars:word

	public _c_curBCBSeg
	public _c_cmdname
	public _c_no_exit
	public _c_one_only
	public _c_errorlevel
	public _c_iExecError
	public _c_fFailInt24
	public _c_fDisplayErrorlevel
	public _c_pipe_ptr
	public _c_pipe_num
	public _c_pipe_del
	public _c_redirect
	public _c_country
	public _c_dbcs_ptr
	public _c_resseg
	public _c_ctty
	public _c_crit_drive
	public _c_crit_error
	public _c_ignore
	public __psp
	public _c_main
	public _c_exe_fcb1
	public _c_exe_fcb2
	public _c_exe_name
	public _c_exe_cmdline
	public _c_lastline
	public _c_in_batch
	public _c_in_batch_for
	public _c_no_batch_echo
	public _c_trans_memseg
	public _c_trans_memparas
	public _c_umb_link
	public _c_ask_autoexec
	public _c_cmdline
	public _c_new_COMSPEC
	public _c_bat_redirect
	public _c_lfnfor
	public _c_uPrevPSP

;  This structure exactly corresponds to an identical one
;  in COMRES.  If you change one, you must change them both.
;  This must be here so that TRANSIENT can refer to near
;  pointers.  They are saved in RESIDENT in case a large EXE
;  trashes the TRANSIENT versions.
;
	public	_crit_vars, _end_crit_vars
_crit_vars	label	word
   _c_curBCBSeg		dw ?		; seg of current BCB (0 if none)
   _c_cmdname		db 66 dup (?)	; full path of command.com
   _c_no_exit		DW ?		; can we exit this COMMAND?
   _c_one_only		DW ?		; when spawning for a single command
   _c_errorlevel	DW ?		; error code returned from process
   _c_pipe_ptr		DW ?
   _c_pipe_num		DW ?
   _c_pipe_del		DW ?
   _c_redirect		DW ?, ?
   _c_country		DB 34 dup (?)	; structure is 34 bytes in length
   _c_dbcs_ptr		DD ?		; ptr to lead byte table
   _c_resseg		DW ?		; segment of the resident CODE
   _c_ctty		DB 16 DUP (?)
   _c_crit_drive	DB ?		; what drive had critcal error?
   _c_crit_error	DW ?		; what critical error happened?
   _c_ignore		DW ?
   __psp		DW ?
   _c_main		DW ?
   _c_exe_fcb1		DB 16 DUP (?)
   _c_exe_fcb2		DB 16 DUP (?)
   _c_exe_name		DB 260 DUP (?)

   _c_exe_cmdline	DB 130 DUP (?)
   _c_lastline		DB 130 DUP (?)	; a record of last line (for F3)

   _c_in_batch_banner	db 3 dup(?)	; ala MSDOS, locates in_batch flag
  					; the same as the C struct "batch"
    _c_in_batch		DW ?		; are we in a batch?
    _c_no_batch_echo	DB ?		; echo for current batch file

   _c_trans_memseg	DW ?            ; segment of "free" space
   _c_trans_memparas	DW ?            ; size (in paras) of "free" space
   _c_umb_link		DW ?		; Upper Memory Block link
   _c_ask_autoexec	DW ?            ; ask? each line of AUTOEXEC
   _c_cmdline		DB 130 DUP (?)  ; ask? each line of AUTOEXEC
   _c_new_COMSPEC	db ?		; 1=c_exe_name has new COMSPEC value
   _c_bat_redirect      db 2 dup (?)	; redirected handles for .BAT
   _c_lfnfor		dw ?            ; is FOR longname or shortname?
     _c_in_batch_for	dw ?		; are we in a batch?
     _c_uPrevPSP	dw ?
     _c_fpINT22Vector	dd ?		; INT 22h vector before INT 21h fn 4bh call
     _c_fpINT23Vector	dd ?		; INT 23h vector before INT 21h fn 4bh call
     _c_fpINT24Vector	dd ?		; INT 24h vector before INT 21h fn 4bh call
     _c_iExecError	dw ?
      _c_fFailInt24	dw ?		; /f switch fail all int 24h calls
      _c_fDisplayErrorlevel dw ? 	  ; /z switch to display errorlevel

	public _end_crit_vars
_end_crit_vars	label	word

_CRIT_DATA	ends


cBegUdata
	public	_max_free
	_max_free	DW	?
	farcall_ptr	DD	?
cEndUdata


cBegCode

; simple error handler, store the error code.
; saves code space by not including library's error handler.
	public	__IOERROR
__IOERROR:
	push	BP
	mov	BP, SP
	mov	AX, P[BP]
	mov	[_errno], AX
	mov	AX, -1
	pop	BP
	ret	2		; PASCAL function, pop error off stack

COMMENT ~
/*
  Make a far call to the resident segment.
*/
void farcall(void (*func)())
~
c_func	farcall
	push	BP
	mov	BP, SP

	mov	AX, P[BP]
	mov	WORD PTR farcall_ptr,AX
	mov	AX, _c_resseg
	mov	WORD PTR farcall_ptr+2,AX

	call	DWORD PTR farcall_ptr

	pop	BP
	ret
c_endp	farcall


COMMENT ~ ;
/*
   Get current code segment.
*/
unsigned getCS(void)
{}
~
c_func	getCS
	mov	AX, CS
	ret
c_endp	getCS


COMMENT ~ ;
/*
   Get current data segment.
*/
unsigned getDS(void)
{}
~
c_func	getDS
	mov	AX, DS
	ret
c_endp	getDS

comment ~ ; prototype ;
void PASCAL farmemcpy(void far *dst, void far *src, unsigned count)
~
	public	FARMEMCPY
FARMEMCPY proc near
	push	BP
	mov	BP, SP
	push	SI
	push	DI
	push	DS

	mov	CX, P[BP]
	lds	SI, P+2[BP]
	les	DI, P+6[BP]

	cld
	rep	movsb

	pop	DS
	pop	DI
	pop	SI
	pop	BP
	ret	10
FARMEMCPY endp

comment ~ ; prototype ;
void PASCAL farmemset(void far *dst, unsigned char c, unsigned count)
~
	public	FARMEMSET
FARMEMSET proc near
	push	BP
	mov	BP, SP
	push	DI

	mov	CX, P[BP]
	mov	AX, P+2[BP]
	les	DI, P+4[BP]

	cld
	rep	stosb

	pop	DI
	pop	BP
	ret	8
FARMEMSET endp

comment ~ ; prototype ;
/* Returns UMB link/status with link in AH, status in AL */
int get_umb_link(void)
~
c_func	get_umb_link

	; get strategy 1st
	mov	AX, 5800H
	int	21H
	push	AX		; status in AL

	; get link status
	mov	AX, 5802H
	int	21H
	xchg	BH, AL
	pop	AX
	xchg	BH, AH		; link in AH

	ret
c_endp	get_umb_link

comment ~ ; prototype ;
/*
   Sets both memory strategy and UMB link
   Returns 0 on success, DOS error code otherwise
*/
int set_umb_link(int link)
~
c_func	set_umb_link
	push	BP
	mov	BP, SP

	; set strategy before setting link
	mov	AX, 5801H
	mov	BH, 0
	mov	BL, P[BP]
	int	21H
	jc	umb_failed

	; set link status
	mov	AX, 5803H
	mov	BH, 0
	mov	BL, P[BP+1]
	int	21H
	jc	umb_failed

	; everthing worked, return 0
	xor	AX, AX
umb_failed:
	pop	BP
	ret
c_endp	set_umb_link


COMMENT ~ ; prototype
/*
   Allocate some memory from the DOS pool
*/
unsigned dos_malloc(unsigned paras)
{}
~
c_func	dos_malloc
	push	BP
	mov	BP, SP

	mov	BX, P[BP]	; PARAS TO ALLOC...
	mov	AH, 48H		; ALLOCATE MEMORY DOS CALL
alloc:	int	21H

	jnc	M1		; MEMORY SEGMENT IN AX
	mov	_max_free, BX	; LET OTHER ROUTINES KNOW HOW MUCH MEMORY
	xor	AX, AX		; ERR, INSUFFICENT MEMORY

M1:	pop	BP
	ret
c_endp	dos_malloc

COMMENT ~ ;
/*
   Allocate some memory from the DOS pool.  Note: changes
   "max_free" and "errno".
   Returns the segment if worked, -1 if failed.
*/
unsigned dos_realloc(unsigned segment, unsigned numparas)
{}
~
c_func	dos_realloc
	push	BP
	mov	BP, SP

	mov	BX, P+2[BP]	; NEW SIZE
	mov	ES, P[BP]	; SEGMENT
	mov	AH, 4AH		; REALLOC MEM DOS CALL
	jmp	short alloc
c_endp	dos_realloc


COMMENT ~ ;
/*
   Free memory that was previously allocated.
*/
void dos_free(unsigned segment)
{}
~
c_func	dos_free
	push	BP
	mov	BP,SP
	push	ES

	mov	AH,49H		; FREE MEM DOS CALL
	mov	ES,P[BP]
	int	21H

	pop	ES
	pop	BP
	ret
c_endp	dos_free


COMMENT ~ ;
/*
   Get/Set the attribute of this file/device.
*/
unsigned dos_ioctl(int fd,int set,unsigned dx)
{}
~
c_func	dos_ioctl
	push	BP
	mov	BP,SP

	mov	AH,44H		; ioctl
	mov	BX,P[BP]	; handle
	mov	AL,P+2[BP]	; set
	mov	DX,P+4[BP]	; data
	int	21H

	mov	AX,DX		; device word
	pop	BP
	ret
c_endp	dos_ioctl


COMMENT ~ ;
/*
   Read from a file/device.

   Returns the # of characters read.  "errno" is set if
   there is an error, cleared otherwise.
*/
int dos_read(int fd,char far *buff,unsigned len)
{}
~
c_func	dos_read
	push	BP
	mov	BP,SP
	push	DS

	mov	AH,3FH
rdwr:	mov	BX,P[BP]
	mov	DX,P+2[BP]
	mov	DS,P+4[BP]	; DS:DX = POINTER TO BUFFER
	mov	CX,P+6[BP]
	int	21H

	jnc	rdout
	pop	DS
	mov	_errno, AX	; preserve error code on error
	mov	AX,-1
	pop	BP
	ret

rdout:	pop	DS
	mov	_errno, 0
	pop	BP
	ret
c_endp	dos_read


COMMENT ~ ;
/*
   Write to a file/device.  Returns the # of characters
   written.
*/
int dos_write(int fd,char far *buff,unsigned len)
{}
~
c_func	dos_write
	push	BP
	mov	BP,SP
	push	DS

	mov	AH,40H
	jmp	rdwr
c_endp	dos_write


COMMENT ~ ;
/*
   Create a file with a normal attribute.
*/
int dos_creat(char *name)
{}
~
c_func	dos_creat
	push	BP
	mov	BP,SP

	mov	AH,3CH		; CREATE
	mov	CX,0		; file attr
	mov	DX,P[BP]	; pathname
doint21:
	int	21H

	jnc	CR1
	mov	_errno, AX	; PRESERVE ERROR CODE
	mov	AX,-1
	jmp	short xxx

CR1:	mov	_errno, 0
xxx:	pop	BP
	ret
c_endp	dos_creat


COMMENT ~ ;
/*
   Seek within a file
*/
long dos_seek(int fd, long pos, int whence)
{}
~
c_func	dos_seek
	push	BP
	mov	BP,SP

	mov	AH, 42H		; seek
	mov	BX, P[BP]
	mov	DX, P+2[BP]
	mov	CX, P+4[BP]	; CX:DX = pos
	mov	AL, P+6[BP]	; seek mode
	jmp	doint21
c_endp	dos_seek


COMMENT ~ ;
/*
   Open a file/device.  Returns -1 or the handle.
*/
int dos_open(char *name,int mode)
{}
~
c_func	dos_open
	push	BP
	mov	BP,SP

	mov	AH,3DH		; OPEN
	mov	AL,P+2[BP]	; rd/wr mode
	mov	DX,P[BP]	; pathname
	jmp	doint21
c_endp	dos_open


COMMENT ~ ;
/*
   Open a file/device with a far name.  Returns -1 or the handle.
*/
int dos_faropen(char far *name,int mode)
{}
~
c_func	dos_faropen
	push	BP
	mov	BP,SP
	push	ds

	mov	_errno, 0	; assume success

	mov	AH,3DH		; OPEN
	mov	AL,P+4[BP]	; rd/wr mode
	lds	DX,P[BP]	; pathname
	int	21H

	pop	ds
	jnc	DFO_done

	mov	_errno, AX	; PRESERVE ERROR CODE
	mov	AX, -1

    DFO_done:
	pop	bp
	ret
c_endp	dos_faropen


COMMENT ~ ;
/*
   Close a file/device.
*/
void dos_close(int fd)
{}
~
c_func	dos_close
	push	BP
	mov	BP,SP

	mov	AH,3EH		; CLOSE
	mov	BX,P[BP]	; handle
	jmp	doint21
c_endp	dos_close


if 0		; This code not used any more

COMMENT ~ ;
/*
   Set the DTA address so this segment/offset
*/
void dos_setdta(unsigned seg,unsigned offset)
{}
~
c_func	dos_setdta
	push	BP
	mov	BP, SP
	push	DS

	; DS:DX points to DTA
	mov	AH, 1AH
	mov	DS, P[BP]
	mov	DX, P+2[BP]
	int	21H

	pop	DS
	pop	BP
	ret
c_endp	dos_setdta

endif ; not used


COMMENT ~ ;
/*

  Returns the max row number (lines) on the current text display.

*/
void clear_screen(void)
{}
~
; ->	void
; <-	dh	max row number (0..24|42|49|???)
; regs: ax, dh
;
c_func	get_rows
	push	es

	xor	ax, ax
	mov	es, ax
	mov	dh, es:[484h]	; get EGA/VGA rows "value" from BIOS
	or	dh, dh
	jg	get_rows_done	; if >=0 use it
	mov	dh, 24		; else default to 25 lines

    get_rows_done:
	pop	es
	ret
c_endp	get_rows

c_func	clear_screen

	; get graphics mode, etc...
	;
	; NOTE: MS only uses mode number from fn 0Fh. It sucks BOTH
	; the max column and max row numbers out of the BIOS data area.
	;
	mov	AH, 0FH
	int	10H
	cmp	AL, 7
	je	textmode
	cmp	AL, 4
	jae	graphicsmode

textmode:
	push	BX		; save page # (BH)

	; get the current cursor color
	;
;	push	AX		; save # of columns
;	mov	AH, 08H		; page already in BH
;	int	10H
; 	xchg	BH, AH		; attrib now in BH
;	pop	AX		; restore # of columns

	; Set the default color attribute to light grey on black
	;
	mov	bh, 07h

	; clear the screen
	mov	DL, AH
	dec	DL
	call	get_rows	; get max row number into DH
	mov	AX, 0600H
	xor	CX, CX
	int	10H

	pop	BX		; restore page # (BH)

	; set cursor position to upper left
	mov	AH, 2
	xor	DX, DX
	int	10H
	ret

	; set graphics mode clears the screen AND sets cursor to upper left
graphicsmode:
	xor	AH, AH
	int	10H
	ret
c_endp	clear_screen

	public	_intdos, _intdosx

	; intdos(&r,&r);
_intdos:
	push	BP
	mov	BP, SP
	sub	SP, 8		; make room for SEG regs

	; fill in SEG regs
	lea	BX, [BP-08]
	mov	[BX], DS	; set ES to DS
	mov	[BX+2], CS
	mov	[BX+4], SS
	mov	[BX+6], DS

	; let intdosx do the work
	push	BX			; SEG regs
	push	word ptr P[BP+2]	; OUT regs
	push	word ptr P[BP]		; IN regs
	call	_intdosx

	; we're done
	mov	SP, BP
	pop	BP
	ret

	; intdosx(&r,&r, &sr);
_intdosx:
	push	BP
	mov	BP, SP
	push	SI
	push	DI
	push	DS
	mov	SI,8[BP]	; get ptr to seg regs
	push	[SI]		; save ES
	push	6[SI]		; save DS
	mov	SI,4[BP]	; get ptr to word regs IN
	mov	AX,[SI]
	mov	BX,2[SI]
	mov	CX,4[SI]
	mov	DX,6[SI]
	mov	DI,0Ah[SI]
	mov	SI,8[SI]
	pop	DS
	pop	ES
	push	BP
	int	21H		; do the DOS call
	pop	BP
	pushf			; save a couple copies of the flags
	pushf
	push	SI
	push	DS
	push	ES
	mov	DS,0FFFAh[BP]	; restore DS from stack
	mov	SI,8[BP]	; get ptr to seg regs
	pop	[SI]		; fill in ES field
	pop	6[SI]		; fill in DS field
	mov	SI,6[BP]	; get ptr to word regs OUT
	pop	8[SI]		; fill in SI field (regs OUT)
	pop	0Eh[SI]		; fill in FLAGS field
	pop	0Ch[SI]		; fill in CFLAG field
	and	word ptr 0Ch[SI], 1
	mov	0Ah[SI],DI	; fill in DI field
	mov	6[SI],DX
	mov	4[SI],CX
	mov	2[SI],BX
	mov	[SI],AX
	pop	DS
	pop	DI
	pop	SI
	pop	BP
	ret

c_func	BiosGetCols
	; get video mode/cols
	mov	ah, 0Fh
	int	10h		; # cols returned in ah
	mov	al, ah
	xor	ah, ah
	ret
c_endp	BiosGetCols

cEndCode

	END
