;
;   $Id: COMRES.ASM 1.21 2003/05/15 16:33:10Z thomd Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;---------------------------------------------------------------------------
; $DOCMODULE:COMRES.ASM
;
; Copyright (c) 1989-2002 Datalight, Inc.
; Datalight Confidential and Proprietary.
; All Rights Reserved.
;
; This file contains the resident portion of COMMAND. All the rest of
; COMMAND is freed up in memory to allow maximum room for running .EXEs.
; This resident part is about 4K bytes.
;
; C Callable Routines
; res_exit()		exit COMMAND
; res_spawn()		run program from COMMAND
; res_openhole()	open/close the "hole" between
; res_closehole()	TRANSIENT and RESIDENT
;
; $DOCHISTORY
; 08/22/2002 jmb added code to appropriately ignore ARF on internal DOS
;                commands as well as external commands
; 03/25/1999 dg  Added LFNFOR variable
; 08/20/1997 de  SPR 1361: revised to fix batch file processing bug
; 05/04/1989 dg  Created by Drew Gislason
;
;---------------------------------------------------------------------------
include macros.inc

__FILENUM__	equ	11	; used by assert

;
;  Datalight's COMMAND.COM can be debugged by Turbo Debug
;  as an EXE, without relocating itself.  (That's ALOT
;  easier than trying to figure out transient vs resident
;  issues).  Simply set this equate to TRUE (1) and make
;  COMMAND.EXE.
;
;  "DEBUG_EXE" set in the makefile.
;
; DEBUG_EXE =	0		; 1 for EXE or 0 for COM


INTERNAL_VERSION =	0236H	; change for each new beta/release
STACKSIZE	=	3*1024	; 3K bytes of stack
RESSTACKSIZE	=	200H	; resident stack can be smaller
ERROR_TABLES	=	1	; support error tables or simple msg


; generic defines
TRUE		= 1
FALSE		= 0

PSP_PARENT	equ 16H
PSP_ENV		equ 2CH



;	[]--------------------------------------[]
;	 |					|
;	 |	SEGMENT ORDERING DEFINITIONS	|
;	 |					|
;	[]--------------------------------------[]


	public	begres, begcode, begdata, begudata, beglast

_RES	segment	byte public 'RES'
	assume	CS:_RES,DS:_RES
begres	label byte
_RES	ends

_RESEND	segment para public 'RES'
_RESEND	ends

cBegCode
	assume DS:_TEXT
begcode	label	byte
cEndCode

cBegData
begdata	label	byte
cEndData

_CRIT_DATA segment word public 'DATA'
begcritdata label byte
_CRIT_DATA ends

DGROUP GROUP _CRIT_DATA

cBegUdata
begudata label	byte
cEndUdata

_LAST	segment para public 'LAST'
beglast	label	byte
_LAST	ends




;	[]------------------------------[]
;	 |				|
;	 |	TRANSIENT CODE/DATA	|
;	 |				|
;	[]------------------------------[]

cBegData
	extrn	_crit_vars:word
	extrn	__psp:word
	extrn	_c_cmdline:word
	extrn	_errno:word
	extrn	_c_main:word
	extrn	_resseg:word
	extrn _c_res_slashf_flag_ptr:dword

		public	_ver_tran
	_ver_tran	dw	INTERNAL_VERSION ; version to check TRANSIENT
cEndData

cBegUdata

	; define stack for TRANSIENT part of COMMAND
	public	_stack, _stacktop, _stack_bottom
	_stack_bottom	dw	?
	_stack		db	STACKSIZE dup (?)
	_stacktop	label word

	; these items are here to appease TLINK when linking
	; with the standard Borland startup code
	public	__argc, __argv, __setargv__
	__setargv__	equ	0
	__argc		dw	?
	__argv		dw	?
cEndUdata


cBegCode
	extrn _main:near
	extrn _CommandLoop:near
	extrn _BreakHandler:near

;--------------------------------------------------------
;  This is the start of the TRANSIENT portion of COMMAND.
;  The only assumption made is that DS = DGROUP upon
;  entry to this function.
;
;  The RESIDENT part is defined in the RES segment, not
;  the standard code segment.
;
;--------------------------------------------------------
	public	_astart
comment "Assembly function _astart"
_astart	proc	near

	; get stack. assumes DS = dgroup
	cli
	mov	DX, DS
	mov	AX, GOFFSET _stacktop
	mov	SS, DX
	mov	SP, AX
	sti

	; zero BSS
	mov	ES, DX
	mov	DI, GOFFSET begudata
	mov	CX, GOFFSET beglast
	sub	CX, DI
	xor	AL, AL
	cld
	rep	STOSB

	; fill stack with pattern
	mov	DI, GOFFSET _stack
	mov	CX, STACKSIZE/2
	mov	AX, 3412H
	cld
	rep	STOSW

	; move command line from PSP to DGROUP (only 1st time)
	cmp	word ptr [_c_main], offset _main
	jnz	no_copy
	mov	AX, [__psp]
	mov	DS, AX
	mov	DI, GOFFSET _c_cmdline
	mov	CX, 80H
	mov	SI, CX
	cld
	rep	movsb
no_copy:

	; get DGROUP back
	push	SS
	pop	DS

	; call main
	mov	AX, GOFFSET _c_cmdline
	push	AX
	call	word ptr [_c_main]

_astart	endp


;------------------------------------------------------
;  reenter command.  assumes that TRANSIENT command has
;  not been trashed.
;
	public	_restart
comment "Assembly function _restart"
_restart	proc	near

	; get stack. assumes DS = dgroup
	cli
	mov	DX, DS
	mov	AX, GOFFSET _stacktop
	mov	SS, DX
	mov	SP, AX
	sti

	; call the routine we want
	call	word ptr [_c_main]

_restart	endp

cEndCode



;	[]------------------------------[]
;	 |				|
;	 |	RESIDENT CODE		|
;	 |				|
;	[]------------------------------[]

_RES	segment
	assume	CS:_RES, DS:_RES

;-------------------------------------------------------
;   This is the real start of COMMAND  This code is
;   always RESIDENT.  Determine if we are to be a RESIDENT
;   COMMAND or a TRANSIENT one.
;
	public	res_start

	; this ensures we can be made into a COM file
	org	100H
res_start:

	; get a stack (DGROUP:_stacktop)
	cli
	mov	DX, CS
	mov	AX, OFFSET rstack_top
	mov	SS, DX
	mov	SP, AX
	sti

	; zero Data table from "start_local_res_vars" to "end_res_vars"
	push	DS
	push	ES
	mov	DX, CS
	mov	ES, DX
	mov	DS, DX
	mov	DI, OFFSET start_local_res_vars
	mov	CX, OFFSET _end_res_vars
	sub	CX, DI
	xor	AL, AL
	cld
	rep	STOSB
	pop	ES
	pop	DS

	; initialize some items in table to values other than 0
	mov	byte ptr CS:[res_crit_drive], 0FFH  ; Set res_crit_drive=FF
	mov	word ptr CS:[res_ctty], 'OC'	    ; Set res_ctty = CON
	mov	byte ptr CS:[res_ctty+2], 'N'
	mov 	byte ptr cs:[res_in_batch_banner], 'c' ; res_in_batch_banner = "cox"
	mov	word ptr cs:[res_in_batch_banner+1], 'xo'

IFE DEBUG_EXE
	jmp	we_are_com
ENDIF

;--------------------------------------------------------
;   It has been determined that COMMAND was loaded as
;   an EXE program.  That means we are fully resident
;   and will NOT reload COMMAND into upper memory.
;
we_are_exe	proc	near

IF DEBUG_EXE ; {
	; get _RES segment into DS (DX was set during zeroing above)
	mov	DS, DX

	; remember original SFT #s from STDERR, STDAUX and STDPRN
	; must reload these on ^C after closing all redirected handles
	;
	mov	AX, word ptr ES:[1AH]
	mov	BL, byte ptr ES:[1CH]
	mov	[_res_con_sft], AL
	mov	[_res_aux_sft], AH
	mov	[_res_prn_sft], BL

	; preserve RESIDENT CS and PSP
	mov	word ptr [res_resseg], CS
	mov	word ptr [respsp], ES

	; determine CS of TRANSIENT
	mov	BX, CS
	mov	AX, offset _RES:begcode
	mov	CL, 4
	shr	AX, CL
	add	AX, BX
	mov	word ptr [transient_cs], AX

	; save DS of TRANSIENT
	mov	AX, offset _RES:begdata
	mov	CL, 4
	shr	AX, CL
	add	AX, BX
	mov	word ptr [transient_ds], AX

	; make some room for copy, etc...
	mov	BX, offset _RES:beglast
	mov	CL, 4
	shr	BX, CL
	mov	AX, CS
	add	AX, BX
	mov	word ptr [res_trans_memseg], AX
	mov	word ptr [res_trans_memparas], 800H	; 32K

	; reallocate (shrink) memory to proper size
	add	BX, 10H				; for PSP
	add	BX, word ptr [res_trans_memparas]
	mov	AH, 4AH
	int	21H
ENDIF ;  } DEBUG_EXE

	; Assumes that DS = CS.  Do not jump here unless that is true.
start_cmd:

	; save the old INT 24H handler so we can call it
	mov	AX, 3524H
	int	21H
	mov	word ptr [old24], BX
	mov	word ptr [old24+2], ES

	; save the old INT 2EH handler so we can restore it
	mov	AX, 352EH
	int	21H
	mov	word ptr [old2e], BX
	mov	word ptr [old2e+2], ES

	; save the old INT 2FH handler so we can call it
	mov	AX, 352FH
	int	21H
	mov	word ptr [old2f], BX
	mov	word ptr [old2f+2], ES

	; install our INT handlers
	mov	AX, 2522H
	mov	DX, offset int22_handler
	int	21H
	mov	AX, 2523H
	mov	DX, offset int23_handler
	int	21H
	mov	AX, 2524H
	mov	DX, offset int24_handler
	int	21H
	mov	AX, 252EH
	mov	DX, offset int2e_handler
	int	21H
	mov	AX, 252FH
	mov	DX, offset int2f_handler
	int	21H

	; Let the Transient portion know where RES is
	push	DS
	mov	CX, CS
	mov	DS, word ptr [transient_ds]
	mov	BX, OFFSET _resseg
	mov	DS:[BX], CX

	mov   bx, offset _c_res_slashf_flag_ptr
	mov   cx, cs
	mov   word ptr ds:[bx+2], cx
	mov   cx, offset _res_c_fFailInt24
	mov   word ptr ds:[bx], cx
	pop	DS

	; get SEG:OFF of "_astart" so we can jump there
	mov	AX, word ptr [transient_cs]
	mov	word ptr [far_jmp+2], AX
	mov	word ptr [far_jmp], offset _TEXT:_astart

	; move critical data from RESIDENT to TRANSIENT
	mov	word ptr [res_main], offset _TEXT:_main
	call	crit_res_to_trans

	; jmp to transient command
	mov	DS, word ptr [transient_ds]
	jmp	dword ptr CS:[far_jmp]

we_are_exe	endp


;	It has been determined that COMMAND was loaded as
;	a COM program.  Move the TRANSIENT portion into
;	upper memory.
	public	we_are_com
comment "Assembly Function we_are_com"
we_are_com	proc	near

	; remember original SFT #s from STDERR, STDAUX and STDPRN
	mov	AX, word ptr DS:[1AH]
	mov	BL, byte ptr DS:[1CH]
	mov	[_res_con_sft], AL
	mov	[_res_aux_sft], AH
	mov	[_res_prn_sft], BL

	; record segments of things
	mov	word ptr [res_resseg], CS
	mov	word ptr [respsp], ES

	; free up all memory not to remain resident
	mov	BX, offset _RES:rstack_top + 15
	mov	CL, 4
	shr	BX, CL
	add	BX, 10H		; for PSP
	mov	AH, 4AH
	int	21H

	; COMMAND should NOT be loaded above the top of "real"
	; memory: that is, if EMM386 remaps and extends
	; conventional RAM, don't load COMMAND at the top
	int	12H			; returns K bytes of mem

   ; Look in the PSP for command /I, to include more than 640k regardless
   ;
   cmp   word ptr DS:[81h],492Fh       ; '/I' uppercase
   je    DontClamp

IF 0
        ;
        ; IR ???? JMB 05-01-03
        ;
        ; We only want to clamp down on the top of memory if extended
        ; by EMM386.  If the BIOS does it, then we need to see the
        ; memory as contiguous.
        ;
        push    ax
        call    emm_present
        cmp     ax, 0
        pop     ax
        je      DontClamp
ENDIF

	;  ETR 3849 BT 12-12-01
	;
	;  We don't want to acknowledge that the conventional memory
	;  has been expanded, so clamp the result at 640k
	;
	cmp	ax, 280h
	jbe	DontClamp
	mov	ax, 280h		; Don't acknowledge more than 640k
DontClamp:

	mov	CL, 6
	shl	AX, CL			; AX = 640K*40H = A000H
	mov	CX, word ptr ES:[2]	; top of mem from PSP
	xor	DX, DX
	cmp	CX, AX
	jbe	not_above
	sub	CX, AX
	mov	DX, CX
not_above:
	mov	word ptr CS:[top_paras], DX

	; copy the original path/filename into "res_cmdname"
	call	get_orgpath

	; reload TRANSIENT portion into upper memory
	call	load_trans

	; go start command
	jmp	start_cmd

we_are_com	endp

IF 0
dev_name        db      "EMM"
;
; emm_present
;
; this routine will check to see if EMM386 is present in memory (or any
; EMM386 similar type utility.
;
; returns
;   AX = 0 if not present
;   AX = 1 if EMM manager present
;
emm_present     proc    near
        push    bx
        push    cx
        push    es
        push    ds
        push    di
        push    si

	mov	AX, 3567H	; get int vector
	int	21H		; returns vector in ES:BX
	mov	DI, 10		; check ES:0AH
;	mov	DI, 11		; check ES:0BH

        push    cs
        pop     ds              ; temporarily set ds to cs

        mov     ax, 1
	mov	SI, offset dev_name
	mov	CX, 3
	cld
	rep	cmpsb
        jz      ep_true

;        ; look for dev_name
;        mov     ax, 1
;	mov	SI, offset dev_name
;	mov	CX, 7
;	cld
;	rep	cmpsb
;        jz      ep_true
;
;        ; loof for ems_name
;        mov     di, 11
;        mov     si, offset ems_name
;        mov     cx, 7
;        cld
;        rep     cmpsb
;        jz      ep_true
        xor     ax, ax

ep_true:

        pop     si
        pop     di
        pop     ds
        pop     es
        pop     cx
        pop     bx
        ret
emm_present     endp
ENDIF

COMMENT ~
/*
	Exit COMMAND
*/
void res_exit(void)
~
c_func	res_exit

	; restore old interrupts
	mov	AX, 252EH
	lds	DX, dword ptr CS:[old2e]
	int	21H
	mov	AX, 252FH
	lds	DX, dword ptr CS:[old2f]
	int	21H

	; terminate
	mov	AX, 4C00H
	int	21H

c_endp	res_exit

comment ~
void res_openhole()
void res_closehole()
~
	public	_res_openhole, _res_closehole
_res_closehole:
	xor	AX, AX		; close
	push	AX
	jmp	short res_open2

_res_openhole:
	mov	AX, 1		; open
	push	AX
res_open2:
	push	BP
	mov	BP, SP
	push	DS

	; TRANSIENT only code
IFE DEBUG_EXE ; {

	; copy TRANSIENT critical variables to RESIDENT
	call	crit_trans_to_res

	; get RESIDENT DS
	mov	AX, CS
	mov	DS, AX

	; free all memory
	mov	ES, word ptr [res_trans_memseg]
	mov	AH, 49H		; free memory
	int	21H

	; get size of TRANSIENT part in DX
	call	get_tran_size

	; are we closing the hole? or opening the hole?
	cmp	word ptr 2[BP], 0
	jz	close_hole

	; set strategy to last fit
	mov	AX, 5801H
	mov	BX, 2		; last fit
	int	21H

	; allocate just the top part
	inc	DX		; allow some memory for COPY, TYPE, etc..
	mov	BX, DX
	mov	AH, 48H
	int	21H		; this CANNOT fail

	mov	word ptr [res_trans_memseg], AX
	mov	word ptr [res_trans_memparas], 1

	; set strategy to first fit
	mov	AX, 5801H
	mov	BX, 0		; first fit
	int	21H
	jmp	short done_open

	; close the "hole" between RESIDENT and TRANSIENT portion
close_hole:
	; allocate ALL the memory
	mov	BX, -1
	mov	AH, 48H
	int	21H
	mov	AH, 48H
	int	21H		; this CANNOT fail

	mov	word ptr [res_trans_memseg], AX
	sub	BX, DX
	mov	word ptr [res_trans_memparas], BX

done_open:
	call	crit_res_to_trans

ENDIF ; } TRANSIENT only code

	pop	DS
	pop	BP
	pop	AX
	retf



COMMENT ~
/*
   Spawn a user program.  This must save some critical
   data from the TRANSIENT portion in case it goes away.
   It takes care of reloading COMMAND if need be.

   Returns error code (The error code < 0 if DOS could not
   run the program.  The error code >=0 if program ran.)
*/
void res_spawn(void)
~
c_func	res_spawn

	; copy TRANSIENT critical variables to RESIDENT
	call	crit_trans_to_res

	; set up EXE parameter block
	mov	DS, word ptr CS:[respsp]
	mov	BX, DS:[PSP_ENV]	; get seg of environment
	mov	AX, CS
	mov	DS, AX
	mov	word ptr [exec_parms], BX		; envseg
	mov	word ptr [exec_parms+2], offset res_exe_cmdline
	mov	word ptr [exec_parms+4], AX
	mov	word ptr [exec_parms+6], offset res_exe_fcb1
	mov	word ptr [exec_parms+8], AX
	mov	word ptr [exec_parms+10], offset res_exe_fcb2
	mov	word ptr [exec_parms+12], AX

; TRANSIENT ONLY CODE vvv
; TRANSIENT ONLY CODE vvv
; TRANSIENT ONLY CODE vvv
IFE DEBUG_EXE ; {

	; switch to our own stack
	mov	word ptr [exec_oldstk+2], SS
	mov	word ptr [exec_oldstk], SP
	mov	AX, OFFSET rstack_top
	mov	DX, DS
	cli
	mov	SS, DX
	mov	SP, AX
	sti

	; free up the memory of TRANSIENT command
	mov	ES, word ptr [res_trans_memseg]
	mov	AH, 49H		; free memory
	int	21H

	; remember a checksum of TRANSIENT code
	call	chksum_trans
	mov	word ptr [exec_chk], AX

ENDIF ; } !DEBUG_EXE
; TRANSIENT ONLY CODE ^^^
; TRANSIENT ONLY CODE ^^^
; TRANSIENT ONLY CODE ^^^

fully_res1:

	; get pointers to the parameters for an EXE
	mov	AX, CS
	mov	DS, AX	; DS = ES = RES
	mov	ES, AX
	mov	DX, OFFSET res_exe_name
	mov	BX, OFFSET exec_parms

	; let RESIDENT know we are spawning (for int 23H handler)
	mov	byte ptr [exec_inspawn], 1

	;  ETR 3647  BT 02-02-01
	;
	;  Save INT 22h, 23h, 24h vectors
	;
	push	es
	push	bx

	mov	ax, 3522h
	int	21h
	mov	word ptr [res_c_fpINT22Vector], bx
	mov	word ptr ds:[res_c_fpINT22Vector+2], es

	mov	ax, 3523h
	int	21h
	mov	word ptr [res_c_fpINT23Vector], bx
	mov	word ptr ds:[res_c_fpINT23Vector+2], es

	mov	ax, 3524h
	int	21h
	mov	word ptr [res_c_fpINT24Vector], bx
	mov	word ptr ds:[res_c_fpINT24Vector+2], es

	pop	bx
	pop	es

	; spawn the user EXE/COM file
	mov	AX, 4B00H
	int	21H

	; assume only CS is correct
	mov	DX, CS
	mov	DS, DX

	; if we weren't "in spawn", we are terminating a TSR (ala
	; SideKick), so don't realloc memory, just reenter COMMAND
	pushf
	cmp	byte ptr [exec_inspawn], 0
	jnz	we_did_exec
	popf
	jmp	int22_handler
we_did_exec:
	popf

	; let RESIDENT know we are out of spawn
	mov	byte ptr [exec_inspawn], 0

	; if there was a problem, what was it?
	jnc	exec_worked
	not	AX	; two's compliment (make the # negative)
	inc	AX	; AX = -AX (so error code of 8 == -8)
	jmp	short exec_failed

exec_worked:
	; get the return code
	mov	ah, 4DH
	int	21H
;	xor	AH, AH	; Don't remove AH because
			; 00=Normal,01=Cntl-C,02=Crit_Error,03=Term by func 31

	;  ETR 3647  BT 02-02-01
	;
	;  Restore INT 22h, 23h, 24h vectors
	;
	;  Note: These values will be restored from the PSP of the
	;        program we just spawned, but the values in the PSP
	;        may have been modified.
	;

	;  Preserve the registers we are about to destroy
	;
	push    cx
	push	si
	push	di
	push	es

	;  Point to INT 22h of the interrupt vector table
	;
	xor	di, di
	mov	es, di
	mov	di, (4 * 22h)

	;  Get the address the saved INT 22h vector
	;
	lea	si, res_c_fpINT22Vector

	;  Set the number of words we are going to move
	;
	mov	cx, 6

	;  Restore the INT 22h, 23h, and 24h vectors.
	;
	rep	movsw

	;  Restore the registers we destroyed
	;
	pop	es
	pop	di
	pop	si
	pop	cx

	;  Only change if ERRORLEVEL if successful
	;
	mov	word ptr [res_ErrorLevel], AX

exec_failed:
	mov	word ptr [res_c_iExecError], AX

;   vvv  TRANSIENT ONLY CODE  vvv
;   vvv  TRANSIENT ONLY CODE  vvv
;   vvv  TRANSIENT ONLY CODE  vvv
IFE DEBUG_EXE ; {

	; disable BREAK_FLAG during this critical operation
	mov	AX, 3300H
	int	21H
	mov	byte ptr [old_brk_flag], DL
	mov	AX, 3301H
	mov	DL, 0
	int	21H

	; allocate the TRANSIENT memory again
	call	alloc_tran_mem

	; Is TRANSIENT in same place or higher place?
	; Don't force reload if not at top of new block since Novel
	; RPL (boot ROM) code could have been freed by last exec in which case
	; the drive that the COMMAND.COM file is on will no longer exist.
	;
	cmp	AX, word ptr [transient_cs]
	je  	check_chksum

	; free the memory we just allocated, 'cause we're gonna reload
	cmp	AX, -1
	jz	exec_reload

do_reload:
	mov	ES, word ptr [res_trans_memseg]
	mov	AH, 49H
	int	21H
	jmp	exec_reload

	; is the checksum still the same?
check_chksum:
	call	chksum_trans
	cmp	AX, word ptr [exec_chk]
	jz	a_ok
	jmp	short do_reload

	; YES! restore the user stack and return
a_ok:	cli
	mov	SS, word ptr [exec_oldstk+2]
	mov	SP, word ptr [exec_oldstk]
	sti

	; restore the value of the break flag
	mov	DL, byte ptr [old_brk_flag]
	mov	AX, 3301H
	int	21H

	jmp	short fully_res2

	public exec_reload
exec_reload:

	; NO! reload command and reenter through _astart
	call	load_trans

	; restore the value of the break flag
	mov	DL, byte ptr old_brk_flag
	mov	AX, 3301H
	int	21H

	mov	AX, word ptr [transient_cs]
	mov	word ptr [far_jmp+2], AX
	mov	word ptr [far_jmp], offset _TEXT:_astart

	; move critical data from RESIDENT to TRANSIENT
	mov	word ptr [res_main], offset _TEXT:_CommandLoop
	call	crit_res_to_trans

	; jmp to transient command
	mov	DS, word ptr [transient_ds]
	jmp	dword ptr CS:[far_jmp]

ENDIF ; } !DEBUG_EXE
;  ^^^  TRANSIENT ONLY CODE  ^^^
;  ^^^  TRANSIENT ONLY CODE  ^^^
;  ^^^  TRANSIENT ONLY CODE  ^^^

fully_res2:

	; restore the value of the break flag
	mov	DL, byte ptr [old_brk_flag]
	mov	AX, 3301H
	int	21H

	; restore COMMAND critical variables from RES
	call	crit_res_to_trans

	; restore DGROUP for COMMAND and return
	mov	DS, word ptr [transient_ds]
	retf
c_endp	res_spawn


;  Copy the RESIDENT critical data to TRANSIENT.  makes
;  no assumptions about registers.
;
	public	crit_res_to_trans
comment "Assembly Function crit_res_to_trans"
crit_res_to_trans	proc	near
	public	crit_res_to_trans
	push	DS
	push	SI
	push	DI

	; move block of variables from RESident area to TRANSIENT
	mov	ES, word ptr CS:[transient_ds]
	mov	DI, GOFFSET _crit_vars
	push	CS
	pop	DS
	mov	SI, OFFSET _beg_res_vars
	mov	CX, (OFFSET _end_res_vars - OFFSET _beg_res_vars)
	cld
	rep	MOVSB

	pop	DI
	pop	SI
	pop	DS
	ret
crit_res_to_trans	endp


;  Copy the TRANSIENT critical data to RESIDENT.  makes
;  no assumptions about registers.
;
	public	crit_trans_to_res
comment "Assembly function crit_trans_to_res"
crit_trans_to_res	proc	near
	public	crit_trans_to_res
	push	DS
	push	SI
	push	DI

	; move block of variables from TRANSIENT area to RESident
	push	CS
	pop	ES
	mov	DI, OFFSET _beg_res_vars
	mov	DS, word ptr CS:[transient_ds]
	mov	SI, GOFFSET _crit_vars
	mov	CX, (OFFSET _end_res_vars - OFFSET _beg_res_vars)
	cld
	rep	MOVSB

	pop	DI
	pop	SI
	pop	DS
	ret
crit_trans_to_res	endp

;-----------------------------------------------------
;   Checksum the TRANSIENT part of COMMAND.  Returns a
;   word checkum in AX.
;
	public	chksum_trans
comment "Assembly function chksum_trans"
chksum_trans	proc	near
	push	SI
	push	DS

	; determine length of transient
	mov	CX, offset _TEXT:beglast
	shr	CX, 1
	xor	DX, DX
	mov	DS, word ptr CS:[transient_cs]
	xor	SI, SI

ch1:	lodsw
	add	DX, AX
	loop	ch1

	mov	AX, DX
	pop	DS
	pop	SI
	ret
chksum_trans	endp


IF 1
;-----------------------------
;  On Entry
;	AL = character
BIOSPUTC_WAIT:
	call	BIOSPUTC
	push	AX
	mov	AX, 0
	int	16H
	pop	AX
	ret

;-----------------------------
;  On Entry
;	AL = character
BIOSPUTC:
	push	AX
	push	BX
	push	CX
	push	DX
	mov	AH, 0EH
	mov	BX, 7
	int	10H
	pop	DX
	pop	CX
	pop	BX
	pop	AX
	ret

;-----------------------------
;  On Entry
;	AL = digit
BIOSPUTDIGIT:
	push	AX
	push	BX
	and	AL, 0FH
	cmp	AL, 0AH
	jae	bpd1
	add	AL, '0'
	jmp	short bpd2
bpd1:	add	AL, 'A'-0AH
bpd2:	mov	BX, 7
	mov	AH, 0EH
	int	10H
	pop	BX
	pop	AX
	ret

;-----------------------------
;  On Entry
;	AX = 16 bit hex #
BIOSPUTX:
	push	CX
	push	DX
	mov	DX, AX
	mov	CL, 12
bpx_again:
	mov	AX, DX
	shr	AX, CL
	push	CX
	push	DX
	call	BIOSPUTDIGIT
	pop	DX
	pop	CX
	sub	CL, 4
	cmp	CL, 0
	jge	bpx_again
	pop	DX
	pop	CX
	ret
ENDIF ;


;----------------------------------------------------------
;  Load the TRANSIENT portion into memory.  Assumes
;  COMMAND is a COM file and that there is some free
;  memory.  It also sets "transient_ds".  This function
;  adheres to C rules for register usage.
;
;  If an (critical) error occures during the load, the user will be
;  prompted for a new path to COMMAND; if one is supplied
;  it will become the new COMSPEC after the program is reloaded.
;
;   Possible Errors:
;	Not Enough Memory
;	Bad or Missing COMMAND
;
	public	load_trans
comment "Assembly function load_trans"
load_trans	proc	near
	push	DS

	; let the world know we do not have valid TRANSIENT
	push	CS
	pop	DS
	mov	word ptr [transient_cs], 0

	; allocate the memory
	call	alloc_tran_mem
	cmp	AX, -1
	jnz	gotmem
	jmp	bad_load_nomem			; Not Enough Memory
gotmem:	mov	word ptr [transient_cs], AX	; save transient CS

	public	retry_load
retry_load:
	; open the file
	mov	byte ptr res_new_COMSPEC, 0 ; which is the existing COMSPEC
	call	get_name	; DS:DX points to name to use

retry_load_with_name:
	mov	byte ptr cs:reloading, 1 ; attempting to reload COMMAND now
	mov	AX, 3D00H
	int	21H
	jc	bad_load
	mov	BX, AX

	; seek to the right place
	mov	AX, 4200H
	mov	DX, offset _RES:begcode
	sub	DX, 100H
	xor	CX, CX
	int	21H

	; read TRANSIENT part into memory
	mov	DS, word ptr CS:[transient_cs]
	xor	DX, DX
	mov	CX, offset _TEXT:begcritdata
	mov	AH, 3FH
	int	21H
	jc	bad_load

	; the length read should equal the length expected
	inc	AX		; account for word orientation of BSS
	and	AX, 0FFFEH	; BSS is word oriented
	cmp	AX, offset _TEXT:begcritdata
	jnz	bad_load

	; close the file
	mov	AH, 3EH
	int	21H

	; calculate transient DS
	mov	DX, DS			; DX = the TRANSIENT CS
	mov	AX, offset _TEXT:begdata
	mov	CL, 4
	shr	AX, CL
	add	AX, DX
	mov	word ptr CS:[transient_ds], AX

	; verify that this is the right version
	mov	ES, AX
	assume	ES:DGROUP

	mov	AX, CS:[ver_res]
	cmp	AX, ES:[_ver_tran]
	assume	ES:NOTHING
	jnz	bad_load

	mov	byte ptr cs:reloading, 0 ; COMMAND was reloaded
	pop	DS
	ret

	; Not enough memory, give up!
	public	bad_load_nomem
bad_load_nomem:
	push	CS
	pop	DS			; DS = CS = RES segment
	mov	DX, offset msg_nomem
	mov	AH, 9H
	int	21H

	; Failed to open/find the file COMMAND.COM or, if we did load it,
	; then it did not match the resident version
	;
	public	bad_load
bad_load:
	; print the "cannot load" message
	push	CS
	pop	DS			; DS = CS = RES segment
	mov	DX, offset msg_cannot
	mov	AH, 9H
	int	21H

	; print the path name of COMMAND
	push	DS
	cmp	byte ptr res_new_COMSPEC, 1
	jne	get_bad_comspec
	mov	dx, offset res_cmdname
	inc	dx
	inc	dx
	jmp	short have_bad_comspec

get_bad_comspec:
	call	get_name

have_bad_comspec:
	mov	DI, DX
	push	DS
	pop	ES			; ES:DI points to path string
	mov	CX, 100H
	xor	AL, AL
	cld
	repnz	scasb			; find the following 0
	dec	DI
	mov	byte ptr ES:[DI], '$'	; replace it with '$' for printing
	mov	AH, 9H
	int	21H
	mov	byte ptr ES:[DI], 0	; put 0 back
	pop	DS

	; hang if we didn't get memory for COMMAND
	; we do this here so it prints the message
	; Not enough memory: Cannot load C:\COMMAND.COM
	cmp	word ptr CS:[transient_cs], 0
	jnz	ok2retry
hang_nomem:
	jmp	short hang_nomem

	; print the "insert" message and get a key
ok2retry:
	mov	DX, offset msg_insert
	mov	AH, 9H
	int	21H

	; can't reload command, ask user if they know where it is
	;
  	mov	bx, offset res_cmdname ; will re-use COMMAND name string
  	mov	ax, offset res_no_exit
	sub 	ax, bx                  ; get size of buffer
	sub 	ax, 3			; account for DOS buffer ctrl data
	mov 	[bx], ax		; record max size of user data

	mov 	dx, bx
	mov 	ah, 0Ah
	int 	21h			; get buffered input

	mov 	bx, dx                  ; get back buffer offset in bx
	xor	ax, ax
	inc 	bx
	mov 	al, [bx]		; get chars read count
	inc 	bx
	mov 	dx, bx			; get start of input string in dx
	add 	bx, ax			; point to the terminating CR char
	mov 	[bx], ah		; replace with '\0' to make it ASCIIZ
	or  	ax, ax			; if no chars read
	jnz	have_user_spec
	jmp	retry_load		; try re-reading COMSPEC

have_user_spec:
	push	si
	push	di

	push	ds			; set ds:si-> res_cmdname
	pop	es			; set es:di-> res_exe_name
	mov	si, dx
	mov	di, offset res_exe_name
	mov	ah, 60h
	int	21h                    	; canonicalize res_cmdname

	mov	dx, di
	pop	di
	pop	si

	mov	byte ptr res_new_COMSPEC, 1 ; user gave us a new COMSPEC
	jmp	retry_load_with_name	    ; try reloading with it

load_trans	endp

get_tran_size	proc	near
	mov	DX, offset _RES:beglast
	sub	DX, offset _RES:begcode
	mov	CL, 4
	shr	DX, CL		; DX = length in paras
	add	DX, word ptr CS:[top_paras]
	ret
get_tran_size	endp

;-----------------------------------------
;  On Exit
;	AX = segment for TRANSIENT CS, or -1 on error
;  Also Sets
;	res_trans_memseg
;	res_trans_memparas
;
	public	alloc_tran_mem
alloc_tran_mem	proc	near

	; set strategy to first fit
	mov	AX, 5801H
	mov	BX, 0		; first fit
	int	21H

	; allocate all the memory
	mov	BX, -1
	mov	AH, 48H
	int	21H
	mov	AH, 48H		; BX = paras to allocate
	int	21H

	jc	nomem		; not enough memory!

	; is there enough for our transient portion?
	call	get_tran_size	; DX = size in paras
	inc	DX		; some extra, just so we ALWAYS have memory
				; for COPY, TYPE, etc...

	sub	BX, DX
	jb	notenomem 	; not enough memory for TRANSIENT!
	dec	BX		; account for the "extra"

	; remember the start of memory that we've just allocated
	mov	word ptr [res_trans_memseg], AX

	; remember size of "free" space in the memory block
	mov	word ptr [res_trans_memparas], BX

	add	AX, BX		; calculate start of TRANSIENT CODE

	ret

notenomem:
	mov	ES, AX		; make sure we free "too small" blocks
	mov	AH, 49H
	int	21H

nomem:	mov	AX, -1
	ret
alloc_tran_mem	endp

;--------------------------------------------------------
;  Return the full pathname from where to load the
;  TRANSIENT portion of COMMAND.  Returns a far ptr
;  to this name in DS:DX.
	public	get_name
comment "Assembly function get_name"
get_name	proc	near

	; try to get the COMSPEC name from environment
	call	get_comspec
	cmp	AX, 0
	jnz	gfound

	; otherwise use "from" name
	mov	AX, CS
	mov	DS, AX
	mov	DX, offset res_cmdname
gfound:	ret
get_name	endp


;-----------------------------------------------------------
;  Check the environment for the COMSPEC to see if we have
;  a special path/name to load from.  Returns AX == 0 on
;  fail (no COMSPEC) or DS:DX = path (AX != 0).
;
	public	get_comspec
comment "Assembly function get_comspec"
get_comspec	proc	near

	; search environment for "COMSPEC"
	mov	ES, word ptr CS:[respsp]
	mov	ES, ES:[PSP_ENV]
	xor	DI, DI			; ES:DI POINT TO ENV
	push	CS
	pop	DS

get1:	cmp	BYTE PTR ES:[DI], 0	; DONE SEARCHING ENV?
	jz	get7
	mov	SI, offset specname	; DS:SI POINT TO "COMSPEC"
	mov	CX, -1
	repz	CMPSB

	dec	DI
	cmp	byte ptr ES:[DI],'='	; DID WE FIND IT?
	jnz	get2

	; found it, skip past "=" and return it
	inc	DI
	push	ES
	pop	DS
	mov	DX, DI			; DS:DX = PATHNAME from COMSPEC
	mov	AX, 1
	ret

	; not found, try again
get2:	mov	AL,0
	repnz	SCASB
	jmp	get1

	; no COMSPEC, return FALSE
get7:	xor	AX, AX
	ret

get_comspec	endp

;-------------------------------
;  On Entry
;	DS = envseg
;  On Exit
;	DS:SI = null of last string, CX = len
get_envsize	proc	near
	mov	CX, 2			; always at least 2
	xor	SI, SI
size_again:
	cmp	word ptr DS:[SI], 0
	jz	gotsize
	inc	CX
	inc	SI
	test	CH, 80H
	jnz	create_env	; 32K is max env size
	jmp	size_again
gotsize: ret
get_envsize	endp

;-------------------------------
;  On Entry
;	ES = COMMAND's PSP
;  On Exit
;	AX = ES:[2CH] seg of a valid environment
make_env	proc	near
	push	ES
	push	DS
	push	DI
	push	SI

	; look to parent for valid environment
	xor	CX, CX			; environment size of 0
	mov	AX, ES:[PSP_PARENT]
	cmp	AX, 0			; if no parent, make a nul env
	jz	create_env
	mov	DS, AX
	mov	AX, DS:[PSP_ENV]
	cmp	AX, 0			; if no environment, make a nul one
	jz	create_env
	mov	DS, AX			; DS:0 = old environment

	; determine size of old env
	call	get_envsize

	; CX = size of old env
create_env:
	push	CX
	mov	BX, CX
	mov	CL, 4		; convert size (in BX) to paras
	shr	BX, CL
	inc	BX
	mov	AH, 48H		; allocate the memory
	int	21H
	pop	CX
	mov	ES, AX

	; start with a valid null environment
	mov	word ptr ES:[0], 0

	; copy old environment to new
	jcxz	done_cr_env
	xor	SI, SI
	xor	DI, DI
	cld
	rep	movsb

	; we're done with creating new environment
done_cr_env:
	pop	SI
	pop	DI
	pop	DS
	pop	ES

	; store env seg in our PSP
	mov	ES:[PSP_ENV], AX

	ret
make_env	endp

;------------------------------------------------------
;  Get the original path (found at the end of the
;  environment) of COMMAND.COM.  Save it in "res_cmdname".
;
get_orgpath proc near
	push	SI
	push	DI
	push	DS

	; get the current environment
	mov	ES, word ptr CS:[respsp]
	mov	AX, ES:[PSP_ENV]
	cmp	AX, 0
	jnz	env_ok
	call	make_env
env_ok:	mov	DS, AX

	; search for end of environment
	call	get_envsize		; DS:SI now points to end, CX = len
	cmp	word ptr [SI+2], 1
	jnz	no_move

	; the name at end of environment may be a relative (not abs) name
	add	SI, 4

	; use DOS to create an absolute path in "res_cmdname"
	push	CS
	pop	ES	; ES:DI = "res_cmdname"
	mov	DI, offset res_cmdname
	mov	AH, 60H
	int	21H			; sets ES:DI to abspath

	; also put a copy in "res_exe_name"
	mov	DI, offset res_exe_name
	mov	AH, 60H
	int	21H			; put abs name in res_exe_name
no_move:

	pop	DS
	pop	DI
	pop	SI
	ret
get_orgpath endp


;	[]--------------------------------------[]
;	 |					|
;	 |	RESIDENT INTERRUPT HANDLERS	|
;	 |					|
;	[]--------------------------------------[]

;
;  Our INT 2EH (run internal function) is just dummied up.
;
int2e_handler:		; not needed: RD sets this
	iret

;
;  Determine if we are in COMMAND or a user program.  If
;  in a user program, terminate.  If in COMMAND, jump back
;  into our command loop.
;
	public	int23_handler
comment "Assembly function int23_handler"
int23_handler	proc	far

	; if we are in COMMAND, simply go to our command loop
	cmp	byte ptr CS:[exec_inspawn], 0
	jz	getback23

	; make sure "critical drive" is invalid.  see "BreakHandler"
	mov	byte ptr CS:[res_crit_drive], 0FFH
	mov	word ptr CS:[res_crit_error], -1

	; tell DOS to terminate subprocess
	stc
	ret

	; "Get back, get back, get back to where you wanna belong"
	;				- the Beatles
	; We are still in COMMAND, simply get back into main loop

	; this address is where TERMINATE goes, because it shouldn't
	; really terminate
int22_handler:
	call	crit_trans_to_res
	mov	byte ptr CS:[res_crit_drive], 0
	mov	word ptr CS:[res_crit_error], 0
	jmp	short getback24

	; make sure "critical drive" is invalid.  see "BreakHandler"
getback23:
	call	crit_trans_to_res
	mov	byte ptr CS:[res_crit_drive], 0FFH
	mov	word ptr CS:[res_crit_error], -1

getback24:
	; we are restarting, so jump there
	push	CS
	pop	DS
	mov	AX, word ptr [transient_cs]
	mov	word ptr [far_jmp+2], AX
	mov	word ptr [far_jmp], offset _TEXT:_restart

	; move critical data from RESIDENT to TRANSIENT
	mov	word ptr [res_main], offset _TEXT:_BreakHandler
	call	crit_res_to_trans

	; jmp to transient command
	mov	DS, word ptr [transient_ds]
	jmp	dword ptr CS:[far_jmp]

int23_handler	endp


COMMENT ~
----------------------------------------------------------

   INT 24H handler

   If a critical error occurs, we must take care of it.
   Make sure that this handler was reached by COMMAND,
   not by some sub-process.

   Upon Entry:
   AH    = error bit map
   AL    = drive (0=A, 1=B)
   DI    = error code
   BP:SI = pointer to device

   Upon Exit:
   AL    = action (0=ignore, 1=retry, 2=abort, 3=fail)

   AH (error bit map)
   ------------------
   1xxx xxxx	Error on device (0=disk)
   xx1x xxxx	Ignore allowed
   xxx1 xxxx	Retry allowed
   xxxx 1xxx	Fail allowed
   xxxx x11x	disk: 00=boot, 01=FAT, 10=DIR, 11=DATA area
   xxxx xxx1	Error during write (0=read)

   DI (error code)
   ------------------
   0	Write protect
   1	Unknown unit
   2	Not ready
   3	Unknown command
   4	CRC
   5	Bad struct
   6	Seek
   7	Unknown media
   8	Sector not found
   9	No paper
   A	Write fault
   B	Read fault
   C	General failure

---------------------------------------------------------- ~

	public	int24_handler
comment "Assembly function int24_handler"
int24_handler	proc	far

	; did this error happen within COMMAND?
	pushf
	push	BX
	push	AX
	mov	AH, 51H
	int	21H
	cmp	BX, word ptr CS:[respsp]
	jz	our_psp

	; No, definitely someone else's problem
	pop	AX
	pop	BX
	popf

   cmp   byte ptr cs:[_res_c_fFailInt24], 0
   je    do_prev_i24
   mov   al, 3
   jmp   short int24_iret

do_prev_i24:
	jmp	DWORD PTR CS:[old24]

	; COMMAND must respond to this critical error
our_psp:
	pop	AX
	pop	BX

	; save the error code
	mov	word ptr CS:[temp2], DI

	; save the drive on which error occurred (FF=char device)
	; we save this in a temporary
	test	AH, 80H
	jz	isdrv
	mov	AL, 0FFH
isdrv:	mov	byte ptr CS:[temp], AL
	popf

	;  If the /f switch was specified then fail all int 24h calls
	;
	mov	al, 3h
	cmp	byte ptr cs:[_res_c_fFailInt24], 0
	jnz	SkipInt24

   mov   al, byte ptr CS:[temp]

	; get user response.  How shall we handle this?
	; return in AL (0=ignore, 1=retry, 2=abort, 3=fail)
	pushf
	call	dword ptr CS:[old24]

SkipInt24:

	; ROM-DOS handles Retry and Abort, COMMAND does not
	cmp	AL, 0
	jz	not_retry
	cmp	AL, 3
	jz	not_retry

int24_iret:
	iret

	; We have to know if attempting to reload the transient
	; portion of the program caused this critical error and,
	; if it has, we cannot blindly jump back into the program
	; because it's memory image will likely have been trashed
	; by the spawned program. We will fail calls in this case
	; and allow the user a chance to specify a new COMSPEC.
	;
not_retry:
	cmp	byte ptr cs:reloading, 0	; if 0
	je	not_reloading			; not reloading
	mov	al, 3           	; otherwise Fail the call
	jmp 	short int24_iret	; and return to ROM-DOS

not_reloading:
	; get our RES data segment back (DS = CS)
	push	CS
	pop	DS

	; let COMMAND know about critical drive (FF = char device)
	push	AX
	call	crit_trans_to_res
	mov	AL, byte ptr [temp]
	mov	byte ptr [res_crit_drive], AL
	mov	AX, word ptr [temp2]
	mov	word ptr [res_crit_error], AX
	pop	AX

	; ignore or fail will give "current drive invalid" msg
	cmp	AL, 2
	jnz	@@xx1
	jmp	getback24
@@xx1:
	mov	word ptr [res_ignore], 1
	jmp	getback24

int24_handler	endp

;------------------------------------------
;
;  Generic Error Table Handler
;
;  Some calls expect COMMAND.COM to keep a list of error
;  messages - notably DEBUG and DOS utilities.  We support
;  them in limited form, simply displaying a simple msg.
;
ERR_TBL_2	equ	0B34H	; 2 possible error tables
ERR_LIMIT_2	equ	0CH	; 0-0BH
ERR_TBL_1	equ	0D88H	; are at these addresses in DOS
ERR_LIMIT_1	equ	5BH	; 0-5AH
SIZE_MSGBUF	equ	48

; generic error message
hard_err_message	db 8,"Error 00"
msg_comext		db ".COM"
msg_helpext		db ".HLP"

;-------------------------------------
;  Used to generate a simple hard coded error message
;  from the error #.
;
;  On entry
;  ES:DI = buffer
;  AL    = byte to place in buffer
htoa	proc	near
	push	AX
	push	DI

	; write hi-order nybble
	mov	AH, AL
	shr	AH, 1
	shr	AH, 1
	shr	AH, 1
	shr	AH, 1
	call	wrdigit

	; write lo-order nyble
	mov	AH, AL
	and	AH, 0FH
	inc	DI
	call	wrdigit

	pop	DI
	pop	AX
	ret

wrdigit: cmp	AH, 0AH
	jb	digit10
	add	AH, 'A'-0AH-'0'
digit10:
	add	AH, '0'
	mov	ES:[DI], AH
	ret
htoa	endp


IF ERROR_TABLES

;----------------------------
;  On Entry
;	DS:DI = string
;  On Exit
;	DS:DI = null after string
;	AX    = length
;
	public	strlen
strlen	proc	near
	xor	AX, AX
sl1:	cmp	byte ptr [DI], 0
	jz	sl2
	inc	DI
	inc	AX
	jmp	short sl1
sl2:	ret
strlen	endp

;---------------------------------------------------------
;  Open COMMAND.HLP from the same place we get COMMAND.COM
;  Returns AX = handle, -1 on error
;
	public	open_help
open_help	proc near
	push	ES
	push	SI
	push	DI

	; use COMSPEC to open COMMAND.HLP
	call	get_name	; DS:DX points to name to use
	; rememember, DS could point to anywhere (not our data seg)

	; search for the end (strlen)
	mov	DI, DX
	call	strlen
	sub	DI, 4		; assume string ends in .COM
	cmp	byte ptr [DI], '.'
	jz	op_gotcom
	mov	AX, -1
	jmp	op_done
op_gotcom:

	; append .HLP
	push	DS
	pop	ES		; set ES = DS, ES:DI = dest
	push	DI		; save start of ".HLP"
	mov	SI, offset msg_helpext
	push	CS
	pop	DS		; set DS:SI = src
	cld
	movsw
	movsw

	; open COMMAND.HLP
	push	ES
	pop	DS		; DS:DX = name
	mov	AX, 3D00H
	int	21H
	jnc	op_opened
	mov	AX, -1
op_opened:

	; append .COM
	pop	DI		; ES:DI = end of str
	mov	SI, offset msg_comext
	push	CS
	pop	DS		; DS:SI = ".COM"
	cld
	movsw
	movsw

	; done, get out
op_done:
	pop	DI
	pop	SI
	pop	ES
	ret
open_help	endp

;----------------------------------
;  On Entry
;	AX = # of 0s to find
;	BX = handle
;	DX = index #
;  On Exit
;	AX = item #
	public	find_msg_ptr
find_msg_ptr	proc	near
	push	SI

	; skip all data until certain # of 0s
	cld
	push	CS
	pop	DS
	mov	CX, offset msgbuf + SIZE_MSGBUF
	mov	SI, CX
	jmp	short fmp_got_a_zero
fmp_read_zero:
	call	readmsgbuff
	jc	fmp_error
	mov	SI, offset msgbuf
fmp_again_zero:
	cmp	word ptr [SI], 0
	jz	fmp_got_a_zero
fmp_next_zero:
	inc	SI
	inc	SI
	cmp	SI, CX
	jae	fmp_read_zero
	jmp	short fmp_again_zero
fmp_got_a_zero:
	or	AX, AX
	jz	fmp_done_zeros
	dec	AX
	jmp	short fmp_next_zero
fmp_done_zeros:

	; now find the indexed pointer
fmp_next_index:
	inc	SI
	inc	SI
	cmp	SI, CX
	jb	fmp_no_read_index
	call	readmsgbuff
	jc	fmp_error
	mov	SI, offset msgbuf
fmp_no_read_index:
	cmp	word ptr [SI], 0	; shouldn't hit a zero in the
	jz	fmp_error		; middle of a table
	or	DX, DX
	jz	fmp_done_index
	dec	DX
	jmp	short fmp_next_index
fmp_done_index:
	mov	AX, [SI]
	jmp	short fmp_done

fmp_error:
	mov	AX, -1
fmp_done:
	pop	SI
	ret
find_msg_ptr	endp

	public	readmsgbuff
readmsgbuff	proc	near
	push	AX
	push	CX
	push	DX
	mov	AH, 3FH
	mov	CX, SIZE_MSGBUF
	mov	DX, offset msgbuf
	int	21H
	pop	DX
	pop	CX
	pop	AX
	ret
readmsgbuff	endp

ENDIF


;------------------------------------------
;  Get DOS error message
;  On Entry
;	AX = msg #
;	ES:DI = error table
;  On Exit
;	ES:DI = error message
;
	public	get_error_message
get_error_message proc far

IF ERROR_TABLES
	; save the registers
	push	DS
	push	AX
	push	BP
	mov	BP, SP
	push	BX
	push	CX
	push	DX

	; error table 1 or 2?
	cmp	DI, ERR_TBL_1
	jnz	tbl2
	cmp	AL, ERR_LIMIT_1
	jae	bad_tbl_msg
	jmp	short tbl1
tbl2:	cmp	DI, ERR_TBL_2
	jnz	bad_tbl_msg
	cmp	AL, ERR_LIMIT_2
	jae	bad_tbl_msg
tbl1:

	; try to open COMMAND.HLP
	call	open_help
	cmp	AX, -1
	jz	simple_msg
	mov	BX, AX		; put handle in BX

	; find start of message
	mov	AX, 1
	cmp	DI, ERR_TBL_2
	jnz	op2
	inc	AX			; # of arrays to skip
op2:	mov	DX, [BP+2] 		; index #
	call	find_msg_ptr
	cmp	AX, -1
	jz	bad_tbl_close

	; read in the message
	xchg	DX, AX		; put offset of message in DX
	mov	AX, 4200H	; seek
	xor	CX, CX
	int	21H
	mov	AH, 3FH		; read it
	mov	DX, offset msgbuf+1
	mov	CX, SIZE_MSGBUF-1
	int	21H

	; size it
	mov	DI, DX
	call	strlen
	mov	DI, offset msgbuf
	mov	byte ptr [DI], AL
	push	DS
	pop	ES	; ES:DI now points to string

	; close the file
	mov	AH, 3EH
	int	21H

	pop	DX
	pop	CX
	pop	BX
	pop	BP
	pop	AX
	pop	DS
	jmp	short gotmsg

bad_tbl_close:
	mov	AH, 3EH		; close the file
	int	21H
bad_tbl_msg:
	pop	DX
	pop	CX
	pop	BX
	pop	BP
	pop	AX
	pop	DS
	xor	DI, DI
	stc
	retf

simple_msg:
	pop	DX
	pop	CX
	pop	BX
	pop	BP
	pop	AX
	pop	DS
ENDIF

	; failed, make "standard" error message
	push	CS
	pop	ES
	mov	DI, offset hard_err_message + 7
	call	htoa
	mov	DI, offset hard_err_message
gotmsg:	clc
	retf
get_error_message endp


func_2f00:
func_2f04:
	mov	DI, 1
	mov	ES, DI
	mov	DI, 0D88H
	ret
func_2f02:
	mov	DI, 1
	mov	ES, DI
	mov	DI, ERR_TBL_2
	ret
func_2f06:
	xor	DI, DI
	mov	ES, DI
	ret
func_2f08:
	push	CS
	pop	ES
	mov	DI, offset CS:get_error_message
	ret

; these are the error message functions we support
handle2f dw	offset CS:func_2f00	; error tables
	dw	offset CS:func_2f02
	dw	offset CS:func_2f04
	dw	offset CS:func_2f06
	dw	offset CS:func_2f08	; get ptr to error msg handler

	public	int2f_handler
int2f_handler	proc	far
	pushf
	cmp	AX, 122EH
	jz	handle_it
	popf
	jmp	dword ptr CS:[old2f]

	; this 2FH call is for us
handle_it:
	test	DL, 1	; don't DO anything if they try to SET messages
	jnz	done2f
	cmp	DL, 8
	ja	done2f
	push	DX
	xor	DH, DH
	mov	DI, DX
	pop	DX
	call	word ptr CS:[handle2f+DI]
done2f:	popf
	iret
int2f_handler	endp


;	[]------------------------------[]
;	 |				|
;	 |	RESIDENT DATA		|
;	 |				|
;	[]------------------------------[]

	public	msg_cannot, msg_insert
msg_nomem	db	"Not enough memory: $"
msg_cannot	db	"Cannot load $"
msg_insert	db	13,10,"Press Enter to retry or type new filename: ",13,10,'$'

	public	ver_res
ver_res	dw	INTERNAL_VERSION	; version to check TRANSIENT

	public	specname
specname	db	"COMSPEC",0	; "CMDSPEC",0

	public	_res_con_sft,_res_aux_sft,_res_prn_sft
_res_con_sft	db	?
_res_aux_sft	db	?
_res_prn_sft	db	?

  	public res_curBCBSeg
	public res_cmdname
	public res_no_exit
	public res_one_only
	public res_errorlevel
	public res_c_iExecError
	public _res_c_fDisplayErrorlevel
	public res_pipe_ptr
	public res_pipe_num
	public res_pipe_del
	public res_redirect
	public res_country
	public res_resseg
	public res_ctty
	public res_crit_drive
	public res_crit_error
	public res_ignore
	public respsp
	public res_main
	public res_exe_fcb1
	public res_exe_fcb2
	public res_exe_name
	public res_exe_cmdline
	public res_lastline
	public _res_in_batch
	public _res_no_batch_echo
	public res_trans_memseg
	public res_trans_memparas
	public res_ask_autoexec
	public res_cmdline
	public res_new_COMSPEC
	public _res_c_fFailInt24

	public	res_cmdname, old_brk_flag
	public  res_curBCBSeg
	public	transient_cs, transient_ds
	public	errcode, far_jmp
	public	exec_oldstk, exec_chk, exec_inspawn, exec_return, exec_parms
	public	old24, old2e, old2f, msgbuf
	public	rstack,rstack_top
	public  reloading
	public	top_paras

;------------------------------------------------------------
;  The labels below are duplicated.  They are defined here
;  because COMMAND is being compiled as an EXE.  They are
;  defined again, but in a different form for the RESIDENT/
;  TRANSIENT COMMAND.COM.
;
if DEBUG_EXE
start_local_res_vars	label byte
  old_brk_flag	db	0	; the value of the break flag
  is_transient	dw	0	; no longer used
  transient_cs	dw	0	; segment of transient CODE
  transient_ds	dw	0	; segment of transient DGROUP
  temp		dw	0	; a temporary storage place
  temp2		dw	0	; a temporary storage place

  errcode	dw	0	; for returning errors
  far_jmp	dd	0	; tmp ptr for jumping to TRANSIENT code

  exec_oldstk	dd	0	; the user stack
  exec_chk	dw	0	; checksum (for reloading)
  exec_inspawn	db	0	; are we in the SPAWN right now?
  exec_return	db	0	; what byte did EXEC return?
  exec_parms	dw	7 dup (0)

  old24		dd	?
  old2e		dd	?
  old2f		dd	?
  top_paras	dw	?

  reloading	db	0
  msgbuf	db	SIZE_MSGBUF dup (?)

	public	_beg_res_vars
_beg_res_vars	label	word
  res_curBCBSeg		dw 0            ; seg of current BCB (0 if none)
  res_cmdname           db 66 dup (0)   ; full path of command.com
  res_no_exit		DW 0		; can we exit this COMMAND?
  res_one_only		DW 0		; when spawning for a single command
  res_errorlevel	DW 0		; error code returned from process
  res_pipe_ptr		DW 0
  res_pipe_num		DW 0
  res_pipe_del		DW 0
  res_redirect		DW 0, 0
  res_country		DB 34 dup (?)	; structure is 34 bytes in length
  res_dbcs_ptr		DD 0		; ptr to lead byte table
  res_resseg		DW 0		; segment of the resident CODE
  res_ctty		DB "CON", 13 DUP (0)
  res_crit_drive	DB 0FFH		; what drive did critcal error?
  res_crit_error	DW 0		; what critical error happened?
  res_ignore		DW 0
  respsp		DW 0
  res_main		DW 0
  res_exe_fcb1		DB 16 DUP (?)
  res_exe_fcb2		DB 16 DUP (?)
  res_exe_name		DB 260 DUP (?)

  res_exe_cmdline	DB 130 DUP (?)
  res_lastline		DB 130 DUP (?)	; a record of last line (for F3)

  res_in_batch_banner	db "cox"	; ala MSDOS, locates in_batch flag
                                        ; the same as the C struct "batch"
  _res_in_batch		DW 0		; are we in a batch?
  _res_no_batch_echo	DB 0            ; echo for current batch file

  res_trans_memseg	DW 0		; segment of "free" space
  res_trans_memparas	DW 0		; size (in paras) of "free" space
  res_umb_link		DW 0		; Upper Memory Block link
  res_ask_autoexec	DW 0		; ask? each line of AUTOEXEC
  res_cmdline		DB 130 DUP (0)	; ask? each line of AUTOEXEC
  res_new_COMSPEC	db 0            ; 1=c_exe_name has new COMSPEC value
  res_bat_redirect      db 2 dup (1);	; redirected handles for .BAT
  res_lfnfor		dw 0		; is FOR longname or shortname?
  res_c_in_batch_for	dw 0            ; are we in a batch?
  res_c_uPrevPSP	dw 0
  res_c_fpINT22Vector	dd 0	; INT 22h vector before INT 21h fn 4bh call
  res_c_fpINT23Vector	dd 0 	; INT 23h vector before INT 21h fn 4bh call
  res_c_fpINT24Vector	dd 0	; INT 24h vector before INT 21h fn 4bh call
  res_c_iExecError	dw 0
  _res_c_fFailInt24	dw 0	; /f switch fail all int 24h calls
  _res_c_fDisplayErrorlevel dw 0 ; /z switch to display errorlevel

	public _end_res_vars
_end_res_vars	label	word

  rstack	dw	RESSTACKSIZE DUP (0)
  rstack_top	dw	0


ELSE
;-------------------------------------------------------------
;  The labels are all OFFSETs so that they don't take up any
;  space in COMMAND.COM, but are allocated at the end of the
;  RESIDENT part of COMMAND.
;
start_local_res_vars	label byte
  old_brk_flag	equ	$-66+66	; the value of the break flag
  is_transient	equ	$-66+67	; no longer used
  transient_cs	equ	$-66+69	; segment of transient CODE
  transient_ds	equ	$-66+71	; segment of transient DGROUP
  temp		equ	$-66+73	; a temporary storage place
  temp2		equ	$-66+75	; a temporary storage place
  errcode	equ	$-66+77	; for returning errors
  far_jmp	equ	$-66+79	; tmp ptr for jumping to TRANSIENT code
  exec_oldstk	equ	$-66+83	; the user stack
  exec_chk	equ	$-66+87	; checksum (for reloading)
  exec_inspawn	equ	$-66+89	; are we in the SPAWN right now?
  exec_return	equ	$-66+90	; what byte did EXEC return?
  exec_parms	equ	$-66+91
  old24		equ	$-66+105	; previous int 24H vector
  old2e		equ	$-66+109	; previous int 2FH vector
  old2f		equ	$-66+113	; previous int 2FH vector
  top_paras	equ	$-66+117	; don't load command above "real" mem

  ; set to 1 prior to attempting to reload COMMAND. The int 24h
  ; handler checks for this value to see if the crit error occured
  ; while trying to reload COMMAND (as opposed to loading the help
  ; file or something) and in that case converts Ignores to Fails
  ; and IRETs so that we can prompt the user for a new COMSPEC value.
  ; This is set to zero at the end of the load_trans routine.
  ;
  reloading	equ	$-66+119
  msgbuf	equ	$-66+120	; 48 bytes of "buffer"


;-------------------------------------------------------------
;  This structure exactly corresponds to an identical one
;  in COMASM.  If you change one, you must change them both.
;  This must be here so that TRANSIENT can refer to near
;  pointers.  They are saved in RESIDENT in case a large EXE
;  trashes them.
;
	public	_beg_res_vars
_beg_res_vars	equ	msgbuf+SIZE_MSGBUF
bv		equ 	_beg_res_vars

  ; Novel VLM demands that the segment value of the current Batch Control
  ; Block (BCB) immediately proceed COMMAND.COM's internal copy of the
  ; COMSPEC environment variable. It also demands that COMMAND's internal
  ; copy of the COMSPEC variable by updated by each "SET COMSPEC=" command.
  ; Without these two things RPL (Novel's remote boot) won't work.
  ;
  res_curBCBSeg		equ bv

  ; the bad_load code determines the size of the res_cmdname buffer
  ; as the distance between res_cmdname and res_no_exit. Don't
  ; declare new variables between them without changing that code.
  ;
  ; res_cmdname must be preceeded by res_curBCBSeg for RPL to work
  ;
  res_cmdname		equ bv+2	; full path of command.com
  res_no_exit		equ bv+68	; can we exit this COMMAND?
  res_one_only		equ bv+68+2	; when spawning for a single command
  res_errorlevel	equ bv+68+4	; error code returned from process
  res_pipe_ptr		equ bv+68+6
  res_pipe_num		equ bv+68+8
  res_pipe_del		equ bv+68+10
  res_redirect		equ bv+68+12
  res_country		equ bv+68+16	; structure is 34 bytes in length
  res_dbcs_ptr		equ bv+68+50    ; ptr to lead byte table
  res_resseg		equ bv+68+54	; segment of the resident CODE
  res_ctty		equ bv+68+56
  res_crit_drive	equ bv+68+72	; what drive had critcal error?
  res_crit_error	equ bv+68+73	; what critical error happened?
  res_ignore		equ bv+68+75
  respsp		equ bv+68+77
  res_main		equ bv+68+79
  res_exe_fcb1		equ bv+68+81
  res_exe_fcb2		equ bv+68+97
  res_exe_name		equ bv+68+113

  res_exe_cmdline	equ bv+68+373
  res_lastline		equ bv+68+503   ; a record of last line (for F3)

  res_in_batch_banner	equ bv+68+633	; ala MSDOS, locates in_batch flag
                                        ; the same as the C struct "batch"
  _res_in_batch		equ bv+68+636 	; are we in a batch?
  _res_no_batch_echo	equ bv+68+638   ; echo for current batch file

  res_trans_memseg	equ bv+68+639	; segment of "free" space
  res_trans_memparas	equ bv+68+641	; size (in paras) of "free" space
  res_umb_link		equ bv+68+643   ; Upper Memory Block link
  res_ask_autoexec	equ bv+68+645	; ask? each line of AUTOEXEC
  res_cmdline		equ bv+68+647	; ask? each line of AUTOEXEC

  ; If, because of an error loading COMSPEC, the user supplies a new
  ; COMSPEC value in response to our prompt then this variable will be
  ; non-zero and res_exe_name will hold the new COMSPEC value. The
  ; CommandLoop() routine checks this variable and, when TRUE, will
  ; reset it once it has updated the COMSPEC environment variable
  ; using the contents of res_exe_name.
  ;
  res_new_COMSPEC	equ bv+68+777	; 1=c_exe_name has new COMSPEC value
  res_bat_redirect      equ bv+68+778	; redirected handles for .BAT
  res_lfnfor		equ bv+68+780	; is FOR longname or shortname?
  res_c_in_batch_for	equ bv+68+782	; are we in a batch?
  res_c_uPrevPSP	equ bv+68+784
  res_c_fpINT22Vector	equ bv+68+786	; INT 22h vector before INT 21h fn 4bh call
  res_c_fpINT23Vector	equ bv+68+790	; INT 23h vector before INT 21h fn 4bh call
  res_c_fpINT24Vector	equ bv+68+794	; INT 24h vector before INT 21h fn 4bh call
  res_c_iExecError	equ bv+68+798
  _res_c_fFailInt24	equ bv+68+800	; /f switch fail all int 24h calls
  _res_c_fDisplayErrorlevel equ bv+68+802 ; /z switch to display errorlevel

	public _end_res_vars
_end_res_vars		equ bv+68+804


;---------------------------------------------------------
;  Resident stack
;  This stack is used anytime the TRANSIENT portion calls
;  the RESIDENT part of COMMAND.
;
	public	rstack,rstack_top
  rstack	equ 	_end_res_vars
  rstack_top	equ 	rstack+RESSTACKSIZE

ENDIF

_RES	ends

	END	res_start
