//
//   $Id: ATAGLUE.H 1.4 2002/10/15 20:31:58Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/************************************************************************
 *  Source   : ATAGLUE.H
 *  Desc     : Provides defines, prototypes, and information about
 *             the interface setup and used with the PCIC hardware.
 *  Notes    : None
 *
 *     Created: 6-8-95 PKG
 *     Updated: 12-04-96 PKG
 *
 *  Copyright (c) 1995-2002 Datalight, Inc.
 *  All right reserved.
 *  Datalight Confidential and Proprietary
 ***********************************************************************/

/***********************************************************************/
/*   LOOK AT ITEMS BELOW   LOOK AT ITEMS BELOW   LOOK AT ITEMS BELOW   */
/***********************************************************************/

/* Default window numbers and addresses to use      */
/* If Resource managment is not available or unused */
/* The IO_START and MEM_STAT provide beginning      */
/* segment for memory windows.  Each socket will be */
/* provided one 4k window at seg:0, seg:1000, ...   */
/* IO windows will be the same.                     */
#define IO_START		0x240
#define MEM_START		0xc8000000L

/***********************************************************************/
/*   LOOK AT ITEMS ABOVE   LOOK AT ITEMS ABOVE   LOOK AT ITEMS ABOVE   */
/***********************************************************************/

/* publics in the glue.c module */
extern unsigned numSockets;
extern ulong memStartAddr;
extern unsigned ioStartAddr;


/*
	DO NOT CHANGE THESE
*/
#define IO_WIN_NUM	10
#define MEM_WIN_NUM	0

/* These are the IO window and memory window    */
/* multipliers.  Each socket will be multiplied */
/* by this number and added to the ???_START    */
/* address defined above. */
#define IO_WIN_MULT		(0x10)
#define MEM_WIN_MULT		(0x1000000L)


/* ATA specific CIS information */
#define MFG_ATA			0xDF
#define ATA_VPP_ON		0x01

/* Device info fields, DEV_TYPE is a mask for getting the */
/* device type.  device code should then be one of the    */
/* following */
#define DEV_TYPE			0xf0
#define DEV_SRAM			0x60
#define DEV_FLASH			0x50
#define DEV_EEPROM		0x40
#define DEV_ROM			0x10

#define TUPLE_JEDEC_C	0x18
#define TUPLE_DEVICE		0x01
#define TUPLE_DEFECTS	0x80
#define TUPLE_FUNC_ID	0x21
#define TUPLE_FUNC_E		0x22
#define TUPLE_CONFIG		0x1A
#define TUPLE_CFTABLE	0x1B

#define TPL_FID_FUNCTION_DISK		4
#define TPL_FE_TYPE_DISK			1
#define TPL_FE_DATA_ATA				1

#define EXT_SPEED		7

/* Maximum number of tuples to parse through */
#define MAX_TUPLES 100

/* Number of contiguous ATA IO bytes to allocate */
/* NOTE: the PCIC module will only allocate chunks of 0x10 bytes */
#define ATA_NUM_PORTS 0x10

/* These are a collection of bit masks used for CONFIG */
/* tuples, specifically the ATA config parsing         */
#define INTERFACE_DEF	0x80
#define IO_ENTRY			0x0F
#define IO_STRUCT			0x08
#define PWR_FEATURES		0x03
#define WAIT_BYTES		0x03
#define READY_SCALE		0x1c
#define RESERVED_SCALE	0xe0
#define IO_LINES			0x1f

/* These are the flags used for the status field of the  */
/* socketInfo structure.  They are used to keep track of */
/* the current state of the socket */
#define WAITING_FOR_RELEASE	0x001
#define HAVE_IO					0x002
#define HAVE_WINDOW				0x004
#define ATA_DEVICE				0x008
#define ACTIVE						0x010
#define HAS_CHANGED				0x020

/* Vpp control defines */
#define VPP_ON		12
#define VPP_OFF	5

/* Proto v1.01 */

/* glue.c */
unsigned Init365(uchar far *cmdline);
void Uninit365(void);
unsigned OpenWindow(uchar socket);
unsigned far * MapWindow(uchar socket, ulong start, unsigned type);
unsigned CloseWindow(uchar socket);
unsigned OpenIOWindow(uchar socket);
unsigned CloseIOWindow(uchar socket);
void DeactivateSocket(uchar socket);
void ActivateSocket(uchar socket);
unsigned CheckForChange(uchar socket);
unsigned IsOurATAConfigTuple(uchar * tuple);
unsigned IsATACard(uchar socket, uchar *mfgCode, uchar * devCode,
							ulong *configReg, unsigned *configValue);
