;
;   $Id: MEMDISK.ASM 1.4 2002/10/15 20:31:58Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
COMMENT ~
----------------------------------------------------------

   MEMDISK.ASM  created 08/12/91  by Drew Gislason

   Copyright (c) 1991-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   THE GENERIC DISK DRIVER
   -----------------------
   This device driver shell simplifies the process of
   creating a disk driver.  This includes ROM disks, RAM
   disks, Flash memory disks, Remote disks, Paged disks,
   or just about any kind of DOS FAT disk.

   It provides all the surrounding routines that interact
   with DOS, leaving only a few routines to code for any
   given disk device:

   int meminit(struct BPB bpb[], char far *cmdline, unsigned *endseg, int drv);
   int memchanged(struct BPB * bpb);
   bool memread(long offset, unsigned len, char far * buffer);
   bool memwrite(long offset, unsigned len, char far * buffer);

   Extended Interface (depending on options)
   -----------------------------------------
   bool memioctl(unsigned category, char far * buffer);

   Take a look at MEMIO.C for an "empty" C template, or
   MEMCRCIO.ASM, MEMPAGED.C or VDISK.C for complete working
   versions of this generic memory disk driver.


   OPTIONS
   -------
   MAXUNITS=1	How many disks can this one driver manage?
   		A typical memory disk has only 1 disk (ROM
   		or RAM), but anything up to 26 is allowed.

   BUILTIN=1	This option allows you to choose whether
   		this device driver will be built-in to
   		ROM-DOS or stand alone (installable from
   		CONFIG.SYS).

   REMOVABLE=1	Can the disk(s) be removed or changed?  If
   		not, then the "mem_changed" function is
   		never called.

   ROMDISK=1	This option allows you to choose between a
   		ROM disk (read only) and a RAM disk.  The
   		ROM disk option will always return Write-
   		Protect error on writes.  The function
   		"memwrite" will never be called with ROM-
   		DISKs.

   STACKSIZE=n	A stand-alone driver needs a stack.  This
   		defines the size of it in bytes.  A 1K
   		stack is sufficent for most implementations.

   GENIOCTL=1	Support generic IOCTL functions 440DH?  This
   		allows some communication between your
   		implementation of a disk driver, and a DOS
   		program.  Also automatically supports IOCTL
   		read and write 4404 and 4405H.

   TSRDEV=1	Allow the device to be installed as TSR, as
   		well as via DEVICE= in CONFIG.SYS.  This
   		switch has no effect if BUILTIN is TRUE.

   EXTMSG=1	Use external (user supplied) error messages
   		for the internal "memdisk" errors.  Only
   		used if TSRDEV is set.

----------------------------------------------------------
~
include macros.inc
include devhdr.inc
include dosver.inc
include memdisk.inc

;  If you wish to build this driver into ROM-DOS (as opposed to
;  loading it through CONFIG.SYS), you must specify in BUILD.EXE
;  that you will be including the generic memory disk driver.
public _memx

; how many "drives" can the disk device have?
; MAXUNITS=1

; relevant to both built-in and stand-alone drivers
; BUILTIN=1		; built-in or stand-alone(CONFIG.SYS)
; REMOVABLE=1		; can the disk(s) be removed or changed?
; ROMDISK=1		; disable write function(s)?
; GENIOCTL=1		; support generic IOCTL functions 440DH?

; relevant only to stand-alone drivers
IFNDEF BUILTIN
;STACKSIZE = 1024	; size of stack in bytes
; TSRDEV=1		; allow device to be installed as TSR (as well
			; as from CONFIG.SYS)
; EXTMSG=1		; use external (user supplied) error messages
ENDIF

IFDEF GENIOCTL
 IFDEF IBMBLK
  DEVATTR equ 6842H		; ioctl, ibmblk, rm, genioctl, 32-bit sectors
 ELSE
  DEVATTR equ 4842H		; ioctl, rm, genioctl, 32-bit sectors
 ENDIF
ELSE
 DEVATTR equ 0802H		; rm, 32-bit sectors
ENDIF




;---------------------------------------------------------
;
;	STANDALONE SEGMENT ORDERING
;
;	The segment ordering must be defined correctly
;	for a standalone device driver.  Built-in drivers
;	are taken care of by the ROM-DOS segment ordering.
;
;---------------------------------------------------------
IFNDEF BUILTIN ; {

cBegCode
cEndCode

BEGDATA	SEGMENT PARA PUBLIC '_BEGDATA'
	DGROUP GROUP BEGDATA
	public	datastart
datastart label word
BEGDATA	ENDS

cBegData
cEndData

; for the Microsoft C/Assembly users
; too many segments - yuck!
	DGROUP	GROUP	_CONST, _MSG
_CONST SEGMENT WORD PUBLIC 'CONST'
_CONST ENDS
_MSG SEGMENT WORD PUBLIC 'MSG'
_MSG ENDS

cBegUdata
	public	begbss
begbss	label word
cEndUdata

_DISK	SEGMENT PARA PUBLIC 'DISK'
	assume DS:_DISK
	public	diskstart
diskstart label word
_DISK	ENDS

ENDIF ; } NOT BUILT-IN


;---------------------------------------------------------
;
;	DEVICE HEADER
;
;	This is the device header.  It will be at the
;	beginning of the executable for the stand-alone
;	version, but will just be part of the DEVICE
;	segment in the built-in version
;
;---------------------------------------------------------

cBegCode
	assume CS:_TEXT, DS:DGROUP

IFDEF BUILTIN ; {
	; helping routines for built-in drivers
	EXTRN	dev_serv:near
	EXTRN	dev_cmd_err:near, dev_err_exit:near
	EXTRN	dev_busy_exit:near, dev_err_cnt:near
	EXTRN	dev_exit:near
ELSE

_memx:	; device header for stand-alone
	dw	-1, -1
	dw	DEVATTR
	dw	strategy	; strategy routine
	dw	service		; service routine
maxdrv	db	1,0		; 1 drive
ENDIF ; }

cmdtbl:
	dw	memdev_init	; 00 - init
	dw	memdev_media	; 01 - media check
	dw	memdev_bpb	; 02 - build a bpb
IFDEF GENIOCTL
	dw	memdev_input	; 03 - ioctl input (4404H)
ELSE
	dw	dev_cmd_err	; 03 - ioctl input (4404H)
ENDIF
	dw	memdev_read	; 04 - device read
	dw	dev_cmd_err	; 05 - non-destructive read
	dw	dev_cmd_err	; 06 - input status
	dw	dev_cmd_err	; 07 - input flush
	dw	memdev_write	; 08 - write
	dw	memdev_write	; 09 - write w/ verify
	dw	dev_cmd_err	; 0A - output status
	dw	dev_cmd_err	; 0B - flush output
IFDEF GENIOCTL
	dw	memdev_output	; 0C - ioctl write (4405H)
ELSE
	dw	dev_cmd_err	; 0C - ioctl write (4405H)
ENDIF
	dw	dev_exit	; 0D - device open
	dw	dev_exit	; 0E - device close
IFDEF REMOVABLE
	dw	dev_exit	; 0F - yes, removable
ELSE
	dw	dev_busy_exit	; 0F - no, not removable
ENDIF
IFDEF GENIOCTL
	dw	dev_cmd_err	; 10 -
	dw	dev_cmd_err	; 11 -
	dw	dev_cmd_err	; 12 -
	dw	memdev_gen_ioctl; 13 - generic ioctl (440DH)
ENDIF
cmdend:

cEndCode

IFDEF BUILTIN ; {

_DEVDATA segment word public 'DEVDATA'

	ASSUME CS:_DEVDATA, DS:_DEVDATA
	EXTRN	dev_fstrat:NEAR, cmd_ptr:DWORD

_memx:
	dw	-1, -1
	dw	DEVATTR
	dw	dev_fstrat	; strategy routine
	dw	service		; service routine
maxdrv	db	1,0		; 1 drive

service:
	push	AX
	push	SI

	; calc # of commands and where to find cmdtbl
	mov	AH, (OFFSET cmdend - OFFSET cmdtbl)/2
	mov	SI, OFFSET _TEXT:cmdtbl

	; Jump to the REAL service routine in ROM (CODE SEG)
	mov	WORD PTR CS:[cmd_ptr], OFFSET dev_serv
	jmp	DWORD PTR CS:[cmd_ptr]

_DEVDATA ENDS

; defined so we have proper ASSUMEs
cBegData
	EXTRN	_ptrsav:DWORD
cEndData

ENDIF ; } from "BUILTIN"


;---------------------------------------------------------
;
;	STANDALONE ONLY DATA
;
;	Some data is needed by a standalone driver.
;
;---------------------------------------------------------

IFNDEF BUILTIN ; {

cBegData
	public	_copyright
	_copyright db	COPYRIGHT	; copyright string
	zerobss	db	1	; only do it the 1st time

	public	_ptrsav		; MUST be in DATA, not BSS
	_ptrsav	dd	0	; far pointer to device request header


IFDEF TSRDEV
	; Drive Parameter Block - a DOS 5.x internal structure
	public	std_parm_blk
	std_parm_blk	label	byte
	db 00H,00H,00H,02H,0FEH,00H,01H,00H	; offset 00H
	db 02H,40H,00H,09H, 00H,60H,01H,02H	; offset 08H
	db 00H,05H,00H,6BH, 00H,70H,00H,00H	; offset 10H
	db 0FFH,8BH,13H,16H,01H,00H,00H,0FFH	; offset 18H
	db 0FFH					; offset 20H
	size_parm_blk	equ	21H

IFDEF	EXTMSG
	extrn	_msg_bad_ver:byte, _msg_no_drives:byte
ELSE
_msg_bad_ver	db	13,10,"DOS version must be at least 5.0!",13,10,'$'
_msg_no_drives	db	13,10,"Not enough drives available! "
		db	"Increase LASTDRIVE in CONFIG.SYS.",13,10,'$'
ENDIF

	tsr_ID		db	"MEMDSK1-*TSR&",0

	; special
	public	_mem_install_drives
	_mem_install_drives	db 1

ENDIF	; TSRDEV

cEndData

cBegUdata
IFDEF STACKSIZE
	public	oldstack, stacktop
	oldstack dd	?
	stackbottom	db STACKSIZE dup (?)
	stacktop	dw ?
ENDIF

IFDEF TSRDEV	; {
	public	_psp, _dosseg, dev_req_hdr, old_driver_CS, old_driver_DS

	_psp		dw ?
	_dosseg		dw ?
	old_driver_CS	dw ?
	old_driver_DS	dw ?
	dev_req_hdr	db 1EH dup (?)

	; allow 1 extra DPB in case of MSCDEX
	public	_drive_parm_blk
	_drive_parm_blk	db ((MAXUNITS+1) * size_parm_blk) dup (?)

	; valuable info for TSR versions of MEMDISK
	public	_tsr_instance
	_tsr_instance	label	byte
	tsr_version	dw	?	; version of this structure
	tsr_uninit_addr dd	?	; calls memuninit()
	tsr_start_drive db	?	; 0=A, 1=B, etc...
	tsr_num_drives	db	?
	tsr_id_ptr	dw	?	; ptr to unique ID string
	tsr_id_len	db	?
	tsr_hooked	db	?	; were DOS structured created?
	tsr_org_start	db	?	; may be different than start_drive
	tsr_cds_ptr	dd	?	; cdsptr
	tsr_end_inst	label byte	; for calculating size
	SIZE_TSR_INST	equ	(offset tsr_end_inst - offset _tsr_instance)
	TSR_VER 	equ	100H	; version 1.00 of TSR structure

	; a stack used while loading the TSR
	public	tsrstack
	tsrstack_base	db 384 dup (?)
	tsrstack	dw ?
ENDIF ; } from "IF TSRDEV"

cEndUdata

ENDIF ; } from "IF NOT BUILTIN"


;---------------------------------------------------------
;
;	STANDALONE and BUILT-IN DATA
;
;	Things like the BPB are universal to both
;	built-in and standalone device drivers.
;
;---------------------------------------------------------
cBegData
	; this is used, in case Client doesn't fill in BPBs
	std_bpb	bpbdef <512,2,1,2,112, 720,0FDH,2, 9,2,0>	; 360K disk

	loading_as_device dw 1	; device or tsr load
cEndData

cBegUdata
	public _memerr, _memunit, _memtop
	_memerr  	db	?	; set if rd/wr or init error
	_memunit	db	?	; current unit # (0-n)
	_memdrives	db	?	; # of drives (up to MAXUNITS)
	_memtop		dw	?	; top of conventional memory

		public	_mem_bpb
	_membpb_ptr	dw MAXUNITS dup (?)
	_mem_bpb	db (MAXUNITS * (SIZE bpbdef)) dup (?)
			dw	?	; extra space for overruns

	; all these are passed to meminit
	public	end_seg, _mem_start_drive
	_mem_start_drive db	?	; as shown to meminit()
	end_seg  dw	?	; end of device in DOS memory
	cmdline  dd	?	; cmdline to "\SUBDIR\DEVNAME..."
cEndUdata


;---------------------------------------------------------
;
;	STANDALONE ONLY FUNCTIONS
;
;	The standard device interface for stand-alone
;	DISK DEVICES (those device drivers loaded from
;	CONFIG.SYS)
;
;---------------------------------------------------------

IFNDEF BUILTIN ; {

cBegCode
	public strategy, service

; STANDALONE ONLY!!
strategy:
	push	DS
	call	getDGROUP
	mov	word ptr [_ptrsav], BX
	mov	word ptr [_ptrsav+2], ES
	pop	DS
	retf

; STANDALONE ONLY!!
service:
	pushf
	push	AX
	push	BX
	push	CX
	push	DX
	push	SI
	push	DI
	push	DS
	push	ES

	call	getDGROUP

	; Zero BSS (1st time only)
	cmp	byte ptr [zerobss], 0
	jz	no_zero
	mov	BX, offset CS:no_zero
	jmp	zero_bss
no_zero:

IFDEF STACKSIZE
	; save old stack
	mov	word ptr [oldstack+2], SS
	mov	word ptr [oldstack], SP

	; switch to our stack
	mov	BX, GOFFSET stacktop
	mov	CX, DS
	cli
	mov	SS, CX
	mov	SP, BX
	sti
ENDIF

	; determine the command
	les	BX, [_ptrsav]			; get pointer to i/o packet
	mov	AL, byte ptr ES:[BX+CMD]	; command code

	cmp	AL, (OFFSET cmdend - OFFSET cmdtbl) / 2
	jae	dev_cmd_err			; bad command
	cbw
	shl	AX, 1				; get index into cmd table
	mov	SI, offset _TEXT:cmdtbl
	add	SI, AX

	; load up the registers with common value
	mov	AL, byte ptr ES:[BX+UNIT]	; AL	= unit #
	mov	AH, byte ptr ES:[BX+MEDIA]	; AH	= media
	mov	CX, word ptr ES:[BX+COUNT]	; CX    = count
	mov	DX, word ptr ES:[BX+START]	; DX    = start sector
	les	DI, dword ptr ES:[BX+TRANS]	; ES:DI = transfer buffer

;	we've set up the following:
;	--------------------------
;	DS	= DGROUP
;	ES:DI	= transfer buffer
;	CX	= count
;	DX	= start
;	AL	= unit
;	AH	= media

	jmp	word ptr CS:[SI]	; do the command


; STANDALONE ONLY!!
; return address MUST be in BX because it may be the
; STACK that is ZEROED!!
	public	zero_bss
zero_bss:
	xor	AL, AL
	mov	byte ptr [zerobss], AL
	push	DS
	pop	ES
	mov	DI, GOFFSET begbss
	mov	CX, offset DGROUP:diskstart
	sub	CX, DI
	cld
	rep	stosb
	push	BX
	ret

	public	dev_cmd_err, dev_err_exit, dev_exit, dev_busy_exit
dev_busy_exit:
	mov	AH, 03H		; busy and done bits set
	jmp	short err1
dev_cmd_err:
	mov	AL, 3		; unknown cmd error
dev_err_exit:
	mov	AH, 81H		; mark error return
	jmp	SHORT err1

dev_exit:
	mov	AH, 01H		; done bit set

err1:	les	BX, [_ptrsav]
	mov	WORD PTR ES:[BX+STATUS], AX	; mark as complete

IFDEF STACKSIZE
	; note: this code makes the driver non-reentrant
	cli
	mov	SS, word ptr [oldstack+2]
	mov	SP, word ptr [oldstack]
	sti
ENDIF
	pop	ES
	pop	DS
	pop	DI
	pop	SI
	pop	DX
	pop	CX
	pop	BX
	pop	AX
	popf
	retf

; STANDALONE ONLY!!
; put DGROUP into DS
getDGROUP proc near
	push	AX
	mov	AX, DGROUP
	mov	DS, AX
	pop	AX
	ret
getDGROUP endp

; STANDALONE ONLY!!
; return DISK segment in AX
c_func	getDISK
	mov	AX, seg _DISK
	ret
c_endp	getDISK

cEndCode

ENDIF ; } from "IF NOT BUILTIN"


;---------------------------------------------------------
;
;	STANDALONE and BUILT-IN DEVICE FUNCTIONS
;
;	These are the function that DOS calls in order to
;	initialize, read and write the memory disk.  Uses
;	the standard device interface.
;
;---------------------------------------------------------

cBegCode
	; client must supply these functions
	extrn _meminit:near, _memread:near
IFDEF REMOVABLE
	; only required if removable
	extrn _memchanged:near
ENDIF

IFNDEF ROMDISK
	; only required if writable
	extrn _memwrite:near
ENDIF

	; DOS device calls end up here
	public	memdev_init, memdev_media, memdev_bpb
	public	memdev_read, memdev_write

IFDEF GENIOCTL
	; client must supply this function
	extrn _memioctl:near

	; DOS device calls
	public memdev_gen_ioctl, memdev_input, memdev_output
ENDIF


;---------------------------------------------------------
;
;	FUNCTION 0 - INIT THE DISK
;
; On Entry:
;
;	DS	= DGROUP
;	DX:CX	= "DEVICE = \dev\name.sys /1"
;	                    ^
;
; On Exit:
;	+-------------------------+
; 00H	| 13-Byte header          | (ignored)
;	+-------------------------+
; 0DH	| BYTE   Number of units  | (we set this)
;	+-------------------------+
; 0EH	| DWORD  End Address      | (we set this)
;	+-------------------------+
; 12H	| DWORD  Ptr to BPB array | (we set this)
;	+-------------------------+
;
;---------------------------------------------------------

memdev_init:

IFDEF SUITE
	; for use by the Datalight Test Suite
	push	AX
	mov	AL, 'I'
	call	do_logcmd
	pop	AX
ENDIF

IFNDEF BUILTIN ; {

	; save the ptr to the command line "C:\DEVNAME args..."
	mov	word ptr [cmdline], CX
	mov	word ptr [cmdline+2], DX

	; get the default ending segment "end_seg"
	call	getDISK
	mov	[end_seg], AX

ENDIF ; } from "IF NOT BUILTIN"

	; set up BPBs and array of pointers to them
	push	DS
	pop	ES
	mov	CX, MAXUNITS
	mov	BX, GOFFSET _membpb_ptr
	mov	DI, GOFFSET _mem_bpb
again_bpb_setup:
	jcxz	done_bpb_setup

	; set BPB pointer
	mov	word ptr [BX], DI

	; copy BPB strucutre
	mov	SI, GOFFSET std_bpb
	push	CX
	push	DI
	mov	CX, size bpbdef
	cld
	rep	movsb
	pop	DI
	pop	CX


	; on to next entry
	dec	CX
	inc	BX
	inc	BX
	add	DI, SIZE bpbdef
	jmp	again_bpb_setup
done_bpb_setup:

IFNDEF BUILTIN ; {
IFDEF TSRDEV	; {

	; determine location of DOS structures
	mov	AH, 52H
	int	21H
	mov	[_dosseg], ES		; save DOS segment

	; set the default ID
	mov	AX, GOFFSET tsr_ID
	push	AX
	call	_tsr_setidstr	; tsr_setidstr(char *id)
	pop	AX
	mov	[tsr_version], TSR_VER
ENDIF ; }
ENDIF ; } from "IF NOT BUILTIN"


	les	BX, [_ptrsav]
	mov	AX, ES:[BX+TRANS+2] 	; top of conventional memory
	mov	[_memtop], AX
	mov	AL, byte ptr ES:[BX+START+2] ; drive # (0=A, 1=B, etc)
	mov	[_mem_start_drive], AL

	; convert the "DOS style" device cmdline to a NUL
	; terminated asciiz string.  Skip past device name to args.
	les	BX, [cmdline]		; get * cmd tail in es:bx
IFNDEF BUILTIN
	call	asciiz_cmdline		; make the args an ASCIIZ string
	push	es			; save ptr to NUL char
	push	dx
	push	ax			; and the char it replaced (in AL)
ENDIF

	; call meminit
	;
	xor	ax, ax
	mov	al, [_mem_start_drive]	; push starting drive number
	push	ax

	mov	AX, GOFFSET end_seg
	push	AX			; and &endseg

	push	ES			; and cmdline FP
	push	BX

	mov	AX, word ptr [_membpb_ptr] ; bpb[]
	push	AX
	call	_meminit		; initialize the custom code
	add	SP, 10

IFNDEF BUILTIN
	pop	cx			; get back char (in CL)
	pop	bx			; get back offset and seg
	pop	es			; of cmdline NUL terminator
	mov	es:[bx], cl		; restore char under the NUL
ENDIF

	or	AX, AX
	jnz	initok


	; if there is an error, tell DOS about it
IFNDEF BUILTIN
	les	BX, DS:[_ptrsav]
	mov	byte ptr ES:[BX+MEDIA], 0 	; # units (drives)
	mov	word ptr ES:[BX+TRANS], 0	; DOS requires a bad
	mov	word ptr ES:[BX+TRANS+2], CS	; end address on error
ENDIF
	mov	AL, [_memerr]
	jmp	dev_err_exit

	; save # of drives returned
initok:	mov	[_memdrives], AL

	; no error, set up the i/o packet
	les	BX, DS:[_ptrsav]
	mov	byte ptr ES:[BX+MEDIA], AL	; # units (drives)
	mov	word ptr ES:[BX+COUNT], GOFFSET _membpb_ptr
	mov	word ptr ES:[BX+COUNT+2], DS		; point to BPB list

	; only the standalone device needs end address
IFNDEF BUILTIN
	mov	word ptr ES:[BX+TRANS], 0
	mov	AX, end_seg
	mov	word ptr ES:[BX+TRANS+2], AX
ENDIF
	mov	AL, 0
	jmp	dev_exit


IFNDEF BUILTIN ; {

;------------------------------
;  asciiz_cmdline
;
;	The command line is typically terminated in a CR-LF pair
;	though, in the case when the command line is empty, the
;	CR may be over-written by DOS leaving only the LF (this happens
;	when DOS builds the ASCIIZ program name for the load overlay
;	call). We replace the first of the CR-LF chars that we find
;	with a NUL char to make an ASCIIZ string.
;
;	Example:
;		Consider the following entry in a CONFIG.SYS file:
;
;		[DEVICE=D:\PATH\VDISK.SYS 1024 /e ]
;		        ^                 ^      ^
;		        |                 |      |
;		 entry ES:BX          exit ES:BX |
;                                 (ES:DX-> NUL after args)
;
;  On Entry;
;	ES:BX = cmdline from DOS during a driver init call.
;
;  On Exit
;	ES:BX = new asciiz cmdline (ASCIIZ string)
;	ES:DX = address of new terminating NUL char
;	AL    = char replaced by the new NUL
;
;  Warning! Make sure to restore the character pointed to by ES:DX
;  to the original value (returned in AL).  Failure to do so will
;  result in CONFIG.SYS processing errors.
;
	public	asciiz_cmdline
asciiz_cmdline:
	; skip "name" part of cmdline
azc1:	cmp	byte ptr ES:[BX], ' '
	jbe	azc2
	inc	BX
	jmp	short azc1

	; skip preceding white space (tabs and spaces)
azc2:	cmp	byte ptr ES:[BX], ' '
	jz	azc3
	cmp	byte ptr ES:[BX], 9	; tab
	jz	azc3
	jmp	short azc4	; neither tab nor space, done
azc3:	inc	BX
	jmp	short azc2

	; terminate string in a 0
azc4:	push	BX

azc5:	cmp	byte ptr ES:[BX], 13	; cr
	jz	azc6
	cmp	byte ptr ES:[BX], 10	; lf
	jz	azc6
	inc	BX
	jmp	short azc5

azc6:	xor	al, al			; make al a NUL
	xchg	byte ptr ES:[BX], al	; swap NUL with char being replaced
	mov	dx, bx			; remember NUL location

	pop	BX			; get back arg str start location
	ret

ENDIF ; } from "IF NOT BUILTIN"


;---------------------------------------------------------
;
;  FUNCTION 1 - MEDIA CHECK
;
;  This function checks to see if the BPB for a disk has
;  changed.  We assume it never changes.
;
;  Has the disk changed
;	-1 = Device HAS changed
;	 0 = Device may have Changed
;	 1 = Device has NOT Changed
;---------------------------------------------------------
memdev_media:

; potentially removable
IFDEF REMOVABLE
	mov	[_memunit], AL
	call	get_BPB
IFDEF SUITE
	; for use by the Datalight Test Suite
	push	AX
	mov	AL, 'C'
	call	do_logcmd
	pop	AX
ENDIF
	push	SI
	call	_memchanged
	pop	CX

; !REMOVABLE - no need to check, disk is never removed
ELSE
	mov	AL, 1		; not removable
ENDIF
	les	BX, DS:[_ptrsav]
	mov	byte ptr ES:[BX+TRANS], AL
	mov	AL, 0
	jmp	dev_exit


;---------------------------------------------------------
;
;  FUNCTION 2 - BUILD BPB
;
;  Returns the address of the BPB.  Assumes the "current"
;  BPB is correct.
;
;  On Entry
;	AL = unit
;
;---------------------------------------------------------
memdev_bpb:
	mov	[_memunit], AL
	call	get_BPB

IFDEF SUITE
	; for use by the Datalight Test Suite
	push	AX
	mov	AL, 'B'
	call	do_logcmd
	pop	AX
ENDIF

	les	BX, DS:[_ptrsav]
	mov	word ptr ES:[BX+COUNT], SI
	mov	word ptr ES:[BX+COUNT+2], DS	; DS:SI pts to BPB
	mov	AL, 0
	jmp	dev_exit

;------------------------------
;  get_BPB
;  On Entry
;	AL = unit #
;  On Exit
;	SI = ptr to BPB
get_BPB:
	push	AX
	cbw
	shl	AX, 1
	add	AX, GOFFSET _membpb_ptr
	xchg	SI, AX
	mov	SI, [SI]
	pop	AX
	ret


IFDEF GENIOCTL ; {
ENDIF

;---------------------------------------------------------
;
;  FUNCTION 4 - READ FROM DISK
;
;  On Entry:
;	ES:DI	= transfer
;	CX	= count
;	DX	= start
;
;---------------------------------------------------------
memdev_read:
	mov	[_memunit], AL

IFDEF SUITE
	; for use by the Datalight Test Suite
	push	AX
	mov	AL, 'R'
	call	do_logcmd
	pop	AX
ENDIF

	; convert # of sectors to # of bytes
	mov	AL, [_memunit]
	call	get_BPB
	xchg	BX, SI
	mov	AX, [BX+BPB_sec_size]
	mul	CX
	mov	CX, AX		; CX = # of bytes to transfer

	; calculate starting offset
	mov	AX, [BX+BPB_sec_size]
	call	get_start_offset	; DX:AX = offset (in bytes)

	; call memread(offset,len,buffer) to do the work
	push	ES
	push	DI
	push	CX
	push	DX
	push	AX
	call	_memread
	add	SP, 10
return_chk:
	or	AX, AX
	jz	return_failed
	mov	AL, 0		; worked!
	jmp	dev_exit

return_failed:
	mov	AL, byte ptr [_memerr]		; get error code from user
	jmp	dev_err_exit


;-------------------------------
;  On Entry
;	AX = sector size
;  On Exit
;	DX:AX = starting offset
;
get_start_offset:
	push	ES
	push	CX
	les	BX, [_ptrsav]		; ES:BX ptr to i/o packet
	mov	DX, ES:[BX+START32+2]	; hi part of sector #
	push	AX			; save sector size
	mul	DX
	mov	CX, AX			; hi part of sector * secsize
	pop	AX			; restore sector size
	mov	DX, ES:[BX+START32]	; lo part of sector #
	mul	DX			; DX:AX = lo part * secsize
	add	DX, CX			; + hi part
	pop	CX
	pop	ES
	ret				; DX:AX = offset

;----------------------------------------------------------------------
;
;  FUNCTION 8/9 - WRITE TO DISK
;
;  On Entry:
;	CX	= count
;	DX	= start
;	ES:DI	= buffer
;
;---------------------------------------------------------
memdev_write:
	mov	[_memunit], AL

; ROMDISK cannot be written to, just return WriteProtected
IFDEF ROMDISK
	mov	AL, 0			; write protect error
	jmp	dev_err_exit

; !ROMDISK disk is possibly writable
ELSE

IFDEF SUITE
	; for use by the Datalight Test Suite
	push	AX
	mov	AL, 'W'
	call	do_logcmd
	pop	AX
ENDIF

	; convert # of sectors to # of bytes
	mov	AL, [_memunit]
	call	get_BPB
	xchg	BX, SI
	mov	AX, [BX+BPB_sec_size]
	mul	CX
	mov	CX, AX		; CX = # of bytes to transfer

	; calculate starting offset
	mov	AX, [BX+BPB_sec_size]
	call	get_start_offset	; DX:AX = offset (in bytes)

	; call memwrite(offset,len,buffer) to do the work
	push	ES
	push	DI
	push	CX
	push	DX
	push	AX
	call	_memwrite
	add	SP, 10
	jmp	return_chk
ENDIF ; } !ROMDISK


IFDEF GENIOCTL ; {

;---------------------------------------------------------
;  FUNCTION 03H - IOCTL Read
;  On Entry:
;	ES:DI	= buffer
;---------------------------------------------------------
memdev_input:
	mov	[_memunit], AL
	mov	CX, 0FF03H	; claim this category
	push	ES
	push	DI
	push	CX
	; bool memioctl(unsigned category, char far * buffer);
	call	_memioctl
	add	SP, 6
	jmp	return_chk

;---------------------------------------------------------
;  FUNCTION 0CH - IOCTL Write
;  On Entry:
;	ES:DI	= buffer
;---------------------------------------------------------
memdev_output:
	mov	[_memunit], AL
	mov	CX, 0FF0Ch
	push	ES
	push	DI
	push	CX
	; bool memioctl(unsigned category, char far * buffer);
	call	_memioctl
	add	SP, 6
	jmp	return_chk

;---------------------------------------------------------
;  FUNCTION 13H - Generic IOCTL
;  On Entry:
;	DS = dgroup
;---------------------------------------------------------
memdev_gen_ioctl:
	mov	[_memunit], AL

IFDEF SUITE
	; for use by the Datalight Test Suite
	push	AX
	mov	AL, 'L'
	call	do_logcmd
	pop	AX
ENDIF

	les	BX, [_ptrsav]
	mov	CX, ES:[BX+MEDIA]	; get category (CX)
	xchg	CH, CL			; DOS rearranged CL/CH, put 'em back
	les	BX, ES:[BX+IOCTL]	; get user buffer ES:BX
	push	ES
	push	BX
	push	CX
	; bool memioctl(unsigned category, char far * buffer);
	call	_memioctl
	add	SP, 6
	jmp	return_chk

ENDIF ; } from "IF GENIOCTL"


;---------------------------------------------------------
;
;	CLIENT HELPER FUNCTIONS
;
;	This section has some routines the client may want
;	to use.
;
;---------------------------------------------------------

COMMENT ~ prototype ;
int memdev_isdevice(void)
{}
/* Are we loading as a device or a TSR? */
~
c_func	memdev_isdevice
	mov	AX, loading_as_device
	ret
c_endp	memdev_isdevice


COMMENT ~ prototype ;
int memdev_maxdrives(void)
{}
	maximum number of drives to install
~
c_func	memdev_maxdrives
	mov	AX, MAXUNITS
	ret
c_endp	memdev_maxdrives


;---------------------------------------------------------
;
;	DEVICE START
;
;	This section of code is what gets executed when
;	the device driver .EXE is called from the DOS
;	command-line.  Depending on options, this may
;	display a help screen, or install the device via
;	the Terminate-and-Stay-Resident method.
;
;---------------------------------------------------------


_devstart:

IFNDEF BUILTIN ; {

IFDEF TSRDEV ; {
	jmp	tsr_start

	; Offsets of DOS 5.x Internal Structures
	FIRST_MCB	EQU	24H	; in List of Lists
	FIRST_DPB	EQU	26H
	CDS_ARRAY	EQU	3CH
	FIRSTDEV	EQU	48H
	LOL_NUMDRIVES	EQU	46H	; offset for # of drives
	LOL_LASTDRIVE	EQU	47H	; offset for lastdrive
	PSP_ENVSEG	EQU	2CH	; environment

	; CDS structure
	CDS_CWD		EQU	00H	; current working dir
	CDS_STATUS	EQU	43H	;
	CDS_DPB_PTR	EQU	45H
	CDS_SUBDIR	EQU	49H
	CDS_SIZE	EQU	58H	; size in bytes of CDS structure

	; Drive Parameter Block structure
	DPB_DRIVE	EQU	00H
	DPB_UNIT	EQU	01H
	DPB_DEVICE	EQU	13H
	DPB_REBUILD	EQU	18H
	DPB_NEXT	EQU	19H
	DPB_SIZE	EQU	21H	; size in bytes of DPB structure


;-----------------------------
;  TSR only!!
;  Set up and return a pointer to a standard Drive
;  Parameter Block (DPB).
;
COMMENT ; prototype
struct parmblk * hook_std_parm_blk(uchar drive)
{}
;
hook_std_parm_blk	proc near
	; copy the "standard" into our array
	; drive # is in AL
	push	AX		; save drive # for later
	mov	DI, GOFFSET _drive_parm_blk
	mov	SI, GOFFSET std_parm_blk
	mov	CX, size_parm_blk
	sub	AL, [tsr_org_start]
	mul	CL		; AL * CL
	add	DI, AX		; DI = ptr to THIS parm blk
	push	DS
	pop	ES
	push	DI		; save ptr to dst DPB
	cld
	rep	movsb
	pop	DI		; restore ptr to dst DPB
	pop	AX		; restore drive #

	; set up some fields in the DPB
	mov	byte ptr [DI+DPB_DRIVE], AL	; drive
	mov	CX, -1
	mov	word ptr [DI+DPB_NEXT], CX
	mov	word ptr [DI+DPB_NEXT+2], CX		; next ptr
	mov	byte ptr [DI+DPB_REBUILD], CL

	; set up previous DPB to point to next
	cmp	AL, [tsr_org_start]
	jz	no_set_dpb	; no previous, nothing to do
	mov	SI, DI
	sub	SI, DPB_SIZE
	mov	word ptr [SI+DPB_NEXT], DI
	mov	word ptr [SI+DPB_NEXT+2], DS
no_set_dpb:

	ret
hook_std_parm_blk	endp


;-----------------------------
;  TSR only!!
;  Used internally to add and hook the proper DOS structures
;  to add the new disk(s).
;  On Entry
;	AL = drive
;
COMMENT ; prototype
void hook_drive(uchar drive)
{}
;
hook_drive	proc	near

	; get standard DPB into the DPB for THIS unit
	call	hook_std_parm_blk	; AX = drv, DS:DI = DPB

	; set up internal DPB for drive
	mov	CL, AL
	sub	CL, [tsr_start_drive]			; determine unit
	mov	byte ptr [DI+DPB_UNIT], CL
	mov	word ptr [DI+DPB_DEVICE], offset CS:_memx
	mov	word ptr [DI+DPB_DEVICE+2], CS		; device ptr

	; set up the CDS for the drive
	call	get_CDS_ptr				; set ES:BX to CDS
	mov	word ptr ES:[BX+CDS_STATUS], 4000H
	mov	word ptr ES:[BX+CDS_DPB_PTR], DI	; DPB ptr
	mov	word ptr ES:[BX+CDS_DPB_PTR+2], DS
	mov	word ptr ES:[BX+CDS_SUBDIR], 0

	ret
hook_drive	endp

extrn	_strlen:near

;--------------------------------------------
;  TSR only!!
;  Set the TSR Identification to something other
;  than the default.
;
COMMENT ; prototype
void tsr_setidstr(char *id)
{}
;
c_func	tsr_setidstr
	push	BP
	mov	BP, SP

	; tsr_id_len = strlen(id);
	push	P[BP]
	call	_strlen
	pop	CX
	mov	byte ptr [tsr_id_len], AL

	; tsr_id_ptr = id;
	mov	AX, P[BP]
	mov	word ptr [tsr_id_ptr], AX

	pop	BP
	ret
c_endp	tsr_setidstr

;---------------------------------------
;  TSR only!!
;  Get the CDS structure for this drive
;  On Entry
;	AL = drive #
;  On Exit
;	Returns a ptr to CDS in ES:BX
c_func	get_CDS_ptr
	mov	ES, [_dosseg]
	les	BX, ES:[CDS_ARRAY]
	mov	AH, CDS_SIZE		; size of CDS entry
	mul	AH			; AX = start of CDS for this drv
	add	BX, AX			; ES:BX pts to CDS
	ret
c_endp	get_CDS_ptr

;---------------------------------------------
;  TSR only!!
;  Is this our disk driver?
;  On Entry
;	ES = data segment of an installed driver?
;  On Exit
;	AL = 1 (found it), AL = 0 (not found)
;

compareIDs	proc	near
	push	SI
	push	DI

	; compare the IDs, DS:SI(ours) w/ ES:DI(previous)
	mov	SI, [tsr_id_ptr]
	mov	DI, SI
	xor	CX, CX
	mov	CL, [tsr_id_len]
	cld
	repz	cmpsb
	mov	AL, 1
	jcxz	gotit
	mov	AL, 0

gotit:	pop	DI
	pop	SI
	ret
compareIDs	endp


;--------------------------------------------
;  TSR only!!
;  Is a previous version of this TSR already in memory?
;
;  1) Check DPB List
;  2) Check MCB List
;
;  Returns TRUE (AX) if found, FALSE if not.
;  Sets "old_driver_CS" and "old_driver_DS" if found.
;
COMMENT ; prototype
int memdev_already_loaded(void)
{}
;
c_func	memdev_already_loaded
	push	SI
	push	DI

	; look through Drive Parameter Block list
	mov	CL, 0
	mov	ES, [_dosseg]
	les	BX, ES:[FIRST_DPB]
al1:	cmp	ES:[BX+DPB_NEXT], 0FFFFH	; last DPB
	jz	al_last_dpb
	les	BX, ES:[BX+DPB_NEXT]
	inc	CL
	cmp	CL, 26		; max 26 drives
	jae	al_chk_mcbs
	jmp	al1

	; check only the LAST DPB
al_last_dpb:
	call	compareIDs	; assumes DPB is in DGROUP
	or	AL, AL
	jz	al_chk_mcbs

	; get TSR code seg into AX
	mov	AX, word ptr ES:[BX+DPB_DEVICE+2]

al_found:
	; save old drivers CS and DS
	mov	[old_driver_CS], AX	; TSR CODE is device handler
	mov	[old_driver_DS], ES	; TSR DPB is in DATA

	; get some info about the previous driver
	mov	CX, (offset tsr_end_inst - offset _tsr_instance)
	mov	DI, GOFFSET _tsr_instance
	mov	SI, DI
	push	DS
	push	ES
	pop	DS
	pop	ES	; xchg ES, DS
	cld
	rep	movsb
	call	getDGROUP

	; found!
	mov	AX, 1
	jmp	short al_done

	; check memory control blocks
al_chk_mcbs:

	; do NOT check MCBs if loading as device (not TSR)
	call	memdev_isdevice
	or	AX, AX
	jnz	al_notfound

	; 2) Check memory blocks for TSR
	mov	ES, [_dosseg]
	mov	ES, ES:[FIRST_MCB]	; first memory control block
al2:	mov	AX, ES
	add	AX, 11H
	mov	BX, CS
	cmp	AX, BX		; is MCB ours (or past ours?)
	jae	al_notfound

	; check for PSP signature so we only look at program MCBs
	cmp	word ptr ES:[10H], 20CDH	; PSP sig
	jnz	chk_next_mcb

	; we have a program, is it ours?
	push	ES
	mov	CX, DS
	mov	AX, CS
	sub	CX, AX		; CX now = DS-CS (data seg relative to code)
	mov	AX, ES
	add	AX, 11H		; current MCB's code
	add	AX, CX		; current MCB's data
	mov	ES, AX		; data segment in ES
	call	compareIDs
	pop	CX
	or	AL, AL
	jnz	got_mcb_driver

	; not our program
	mov	ES, CX
chk_next_mcb:
	cmp	byte ptr ES:[0], 'Z'
	jz	al_notfound

	; on to next MCB
	mov	AX, ES
	add	AX, word ptr ES:[3]
	inc	AX
	mov	ES, AX
	jmp	short al2

got_mcb_driver:
	add	CX, 11H			; past MCB and PSP
	xchg	CX, AX			; AX pts to old CS
	jmp	short al_found

al_notfound:
	xor	AX, AX
al_done:
	pop	DI
	pop	SI
	ret
c_endp	memdev_already_loaded


;--------------------------------------------
;  TSR only!!
;  Remove a TSR installed disk from memory (and unhook
;  from DOS the structures it used).  Assumes a unique ID
;  string for this driver.
;
;  Returns 0 if failed.  Does NOT return if worked.
;
COMMENT ; prototype
int tsr_uninstall(void)
{}
;
c_func	tsr_uninstall

	; find the old driver
	call	memdev_already_loaded
unload_failed:
	or	AX, AX
	jnz	found_driver
	ret

found_driver:
	; uninitialize the older driver
	call	dword ptr [tsr_uninit_addr]

	; only unload if NO OTHER drives have been loaded
	mov	ES, [_dosseg]		; get DOS segment
	mov	AL, [tsr_start_drive]
	add	AL, [tsr_num_drives]
	cmp	AL, byte ptr ES:[LOL_NUMDRIVES]
	jnz	unload_failed

	; free the memory used by old driver
	mov	AX, [old_driver_CS]
	sub	AX, 11H			; for PSP + MCB
	mov	ES, AX
	cmp	byte ptr ES:[0], 'M'	; make sure it's an MCB
	jnz	no_free
	mov	word ptr ES:[1], 0	; free driver memory
	inc	AX
	mov	ES, AX			; get back old driver's PSP
	mov	AX, ES:[PSP_ENVSEG]
	dec	AX
	mov	ES, AX
	cmp	byte ptr ES:[0], 'M'	; make sure it's an MCB
	jnz	no_free
	mov	word ptr ES:[1], 0	; free environment
	jmp	short freed
no_free:
	xor	AX, AX		; call failed
	ret
freed:

	; only free DOS structures if we allocated them
	cmp	[tsr_hooked], 0
	jnz	definitely_hooked
	jmp	uninstall_done
definitely_hooked:

	; disable all CDSes that point to our drive
	mov	AL, [tsr_start_drive]
	mov	CL, [tsr_num_drives]
	xor	CH, CH
again_cds:
	jcxz	done_cds
	push	AX
	push	CX
	call	get_CDS_ptr	; returns CDS ptr in ES:BX
	pop	CX
	pop	AX

	; is this our CDS?
	mov	DX, [old_driver_DS]
	cmp	word ptr ES:[BX+CDS_DPB_PTR+2], DX
	jnz	no_free		; PROBLEM! CDS does NOT point to us!

	; found it, disable the CDS
	xor	DX, DX
	mov	word ptr ES:[BX+CDS_STATUS], DX
	mov	word ptr ES:[BX+CDS_DPB_PTR], DX
	mov	word ptr ES:[BX+CDS_DPB_PTR+2], DX
	mov	word ptr ES:[BX+CDS_SUBDIR], -1

	; on to next CDS
	dec	CL
	inc	AL
	jmp	short again_cds
done_cds:

	; remove all our DPBs from list
	mov	AX, [old_driver_DS]
	push	DS
	mov	DS, [_dosseg]
	lds	SI, DS:[FIRST_DPB]
rdpb1:	cmp	word ptr DS:[SI+DPB_NEXT+2], AX		; find last DPB
	jz	got_our_dpb
	cmp	word ptr DS:[SI+DPB_NEXT+2], -1
	jz	no_dpb_found				; PROBLEM!
	lds	SI, DS:[SI+DPB_NEXT]
	jmp	short rdpb1
got_our_dpb:
	mov	word ptr DS:[SI+DPB_NEXT], -1
	mov	word ptr DS:[SI+DPB_NEXT+2], -1
no_dpb_found:
	pop	DS

	; subtract out our drives
	mov	AL, [tsr_org_start]
	mov	ES, [_dosseg]
	mov	byte ptr ES:[LOL_NUMDRIVES], AL

	; remove device driver from list
	assume	ES:_TEXT
	mov	ES, [old_driver_CS]
	mov	AX, word ptr ES:[_memx]
	mov	DX, word ptr ES:[_memx+2]
	mov	CX, ES
	mov	ES, [_dosseg]
	cmp	word ptr ES:[FIRSTDEV+2], CX	; is it our segment?
	jnz	not_at_head			; no!, PROBLEM!
	cli
	mov	word ptr ES:[FIRSTDEV], AX	; save device header
	mov	word ptr ES:[FIRSTDEV+2], DX
	sti
not_at_head:
	assume	ES:NOTHING

	; terminate (no error)
uninstall_done:
	mov	AX, 4C00H
	int	21H
c_endp	tsr_uninstall


;---------------------------------------------------------
;  TSR only!!
;  This routine is never called from within this driver.
;  Instead, it is called by an external program that is
;  requesting this driver to disable itself.
;
;  This routine then switches to a local stack and data
;  segment, and calls memuninit
;
	extrn	_memuninit:near
	public	tsr_uninit
tsr_uninit:
	; save old stack
	push	DS
	call	getDGROUP
	mov	word ptr [oldstack+2], SS
	mov	word ptr [oldstack], SP

	; switch to local stack
	mov	DX, DS
	mov	AX, GOFFSET stacktop
	cli
	mov	SS, DX
	mov	SP, AX
	sti

	; uninstall
	call	_memuninit

	; get back to user program
	mov	DX, word ptr [oldstack+2]
	mov	AX, word ptr [oldstack]
	cli
	mov	SS, DX
	mov	SP, AX
	sti
	pop	DS
	retf

;--------------------------------------------
;  TSR only!!
;  Find enough free drives.  Checks both CDSs and DOS drive #s.
;  On Entry
;	AL = # of drives desired
;  On Exit
;	error:  AL = FFH (not enough drives)
;	worked: AL = start drive, ES:BX = start CDS
;
COMMENT ; prototype
find_free_drives
{}
;
find_free_drives	proc	near
	mov	AH, AL			; save # drives in AH
	mov	ES, [_dosseg]
	mov	AL, 0

ffloop:	cmp	AL, ES:[LOL_LASTDRIVE]	; max # of CDSs
	jae	ff_not			; didn't find a free one
	push	ES
	push	AX
	call	get_CDS_ptr
	cmp	word ptr ES:[BX+CDS_STATUS], 0	; free?
	jz	ff_found
	pop	AX		; drive #
	pop	ES		; DOS segment
ff_try_again:
	inc	AL
	jmp	short ffloop
ff_not:	mov	AX, -1
	ret
ff_found:
	; are there enough drives?
	pop	AX		; AX = drive #
	mov	DX, ES		; save CDS segment
	pop	ES		; get back DOS segment
	mov	CL, AL		; start drive
	add	CL, AH		; # drives
	cmp	CL, ES:[LOL_LASTDRIVE]	; max # of CDSs
	ja	ff_not		; not enough drives!
	cmp	AL, ES:[LOL_NUMDRIVES]
	jb	ff_try_again	; can't be below numdrives

	; got enough free drives, use 'em
	mov	ES, DX	; restore CDS segment
	cbw
	ret		; AX = drive #, ES:BX = ptr
find_free_drives	endp

comment ; prototype
int tsr_create_drives(int num)
{}
;
c_func	tsr_create_drives
	push	BP
	mov	BP, SP

	; make sure there are enough drive letters
	mov	AL, P[BP]
	mov	[tsr_num_drives], AL
	call	find_free_drives
	cmp	AL, 0FFH
	jnz	tcd_enough_drives
	xor	AX, AX
	jmp	tcd_done
tcd_enough_drives:

	; we've found an available CDS, remember it
	mov	[tsr_start_drive], AL
	mov	word ptr [tsr_cds_ptr], BX
	mov	word ptr [tsr_cds_ptr+2], ES

	; store other important TSR drive data
	inc	[tsr_hooked]
	mov	word ptr [tsr_uninit_addr], offset CS:tsr_uninit
	mov	word ptr [tsr_uninit_addr+2], CS

	; the DOS start drive might be different than our start
	; drive due to "network" drives that use a CDS but don't
	; have an associated DPB
	mov	ES, [_dosseg]
	mov	AL, ES:[LOL_NUMDRIVES]
	mov	[tsr_org_start], AL	; DOS thinks drives start here

	; fill in any dummy DPBs do get up to our start drive
	mov	AL, [tsr_org_start]
dagain:	cmp	AL, [tsr_start_drive]
	jae	no_dummies		; bring org_drive
	call	hook_std_parm_blk	; up to start drive
	inc	AL
	jmp	dagain
no_dummies:

	; hook in each drive into DOS (set up CDSs + DPBs)
	mov	AL, [tsr_start_drive]
	mov	CL, [tsr_num_drives]
hook_again:
	cmp	CL, 0
	jz	done_hooking
	push	AX
	push	CX
	call	hook_drive
	pop	CX
	pop	AX
	dec	CL
	inc	AL
	jmp	short hook_again
done_hooking:

	; link DPB chain into list
	mov	ES, [_dosseg]
	les	BX, ES:[FIRST_DPB]
nextdpb:
	cmp	word ptr ES:[BX+DPB_NEXT], -1		; find last DPB
	jz	gotlastdpb
	les	BX, ES:[BX+DPB_NEXT]
	jmp	short nextdpb
gotlastdpb:
	mov	word ptr ES:[BX+DPB_NEXT], GOFFSET _drive_parm_blk
	mov	word ptr ES:[BX+DPB_NEXT+2], DS		; link in ours

	; link device into list
	mov	ES, [_dosseg]			; get DOS segment back
	mov	AX, word ptr ES:[FIRSTDEV]
	mov	DX, word ptr ES:[FIRSTDEV+2]	; point our next to
	mov	word ptr CS:_memx, AX		; the next of 1st device
	mov	word ptr CS:_memx+2, DX
	cli
	mov	word ptr ES:[FIRSTDEV], offset CS:_memx
	mov	word ptr ES:[FIRSTDEV+2], CS
	sti

	; update # of drives
	mov	AL, [tsr_start_drive]
	add	AL, [tsr_num_drives]
	mov	ES:[LOL_NUMDRIVES], AL	; set # drives to new value

	; return the starting drive
	mov	AL, [tsr_start_drive]
	cbw

tcd_done:
	pop	BP
	ret
c_endp	tsr_create_drives

;--------------------------------------------
;  TSR only!!
;  The start of the TSR handling code.  Sets up the C
;  environment and eventually calls meminit().
;
;  The Client may (or may not) require MEMDISK to create
;  a certain number of drives (Drive Parm Blocks) when
;  installing as a TSR.
;
;  Some Clients reuse existing drive letters (sharing them
;  with another product, ala Datalight's Card Trick with
;  Award Card Services).
;
;  If MEMDISK must create drives (DPBs), then enough CDSs
;  (Current Directory Structures) must already exits to
;  fullfill the request.  More CDSs are created using
;  LASTDRIVE=n: in CONFIG.SYS.
;
;
COMMENT ; prototype
int tsr_start(void)
{}
;
	public	tsr_start
tsr_start:
	; standard C environment: DGROUP, stack, zero BSS
	mov	SI, DS		; save PSP segment
	call	getDGROUP	; get DGROUP into DS
	mov	DX, DS
	mov	AX, GOFFSET tsrstack
	cli
	mov	SS, DX		; create stack for TSR use
	mov	SP, AX
	sti
	mov	BX, offset CS:done_zero
	jmp	zero_bss	; BSS must contain all 0s
done_zero:

	; remember PSP segment
	mov	word ptr [_psp], SI

	; we are loading as a TSR, record that fact
	mov	[loading_as_device], 0

	; set the default ID
	mov	AX, GOFFSET tsr_ID
	push	AX
	call	_tsr_setidstr	; tsr_setidstr(char *id)
	pop	AX
	mov	[tsr_version], TSR_VER

	; DOS MUST be 5.0 or greater
	mov	AH, 30H
	int	21H
	cmp	AL, 5		; major version in AL
	jae	dos_ver_ok
	mov	DX, GOFFSET _msg_bad_ver
tsr_exit_error:
	mov	AH, 9		; display error message
	int	21H
	mov	AX, 4C01H	; terminate w/ error
	int	21H
dos_ver_ok:

	; determine location of DOS structures
	mov	AH, 52H
	int	21H
	mov	[_dosseg], ES		; save DOS segment

	; determine starting drive letter
	mov	AL, 1
	call	find_free_drives
	cmp	AL, 0FFH
	jnz	drv_num_ok
	mov	ES, [_dosseg]		; meminit may NOT need to
	mov	AL, ES:[LOL_LASTDRIVE]	; add new drives
drv_num_ok:

	; set up a pretend command line for MEMINIT call
	push	DS
	mov	ES, [_psp]
	mov	DS, [_psp]
	mov	CX, 7FH
	std
	mov	DI, 0FFH	; make room for a 1 byte program name
	mov	SI, 0FEH
	rep	movsb
	cld
	pop	DS
	mov	DI, 80H			; ES:DI = cmdline
	mov	word ptr ES:[DI], 2041H	; "name" and space

	; set up device header for INIT
	; (note: dev_req_hdr already zeroed)
	; mov	byte ptr [dev_req_hdr+UNIT], 0		; unit = 0
	; mov	byte ptr [dev_req_hdr+CMD], 0		; cmd = 0 (init)
	mov	DX, word ptr ES:[2]	; DX = top of mem, from PSP
	mov	word ptr [dev_req_hdr+COUNT], DI
	mov	word ptr [dev_req_hdr+START], ES	; cmdline ptr
	mov	byte ptr [dev_req_hdr+START+2], AL	; start drive
	mov	word ptr [dev_req_hdr+TRANS+2], DX	; top of memory

	; INIT device by calling strategy and service routines
	push	DS
	pop	ES
	mov	BX, GOFFSET dev_req_hdr	; ES:BX = req_hdr
	push	CS			; far call to strategy
	call	strategy
	push	CS			; far call to service
	call	service

	; worked?  how much mem?
	test	byte ptr [dev_req_hdr+STATUS+1], 80H	; error
	jz	install_worked
	jmp	install_failed
install_worked:

	; user may say ask we don't hook DOS structures,
	; but still TSR in memory
	cmp	byte ptr [_mem_install_drives], 0
	jz	keep_mem
	mov	AL, [_memdrives]
	push	AX
	call	tsr_create_drives
	pop	CX

	; enough free drives? No? Give up!
	or	AX, AX
	jnz	enough_drives
	call	_memuninit
	mov	DX, GOFFSET _msg_no_drives
	jmp	tsr_exit_error
enough_drives:

	; Terminate and Stay Resident
keep_mem:
	mov	DX, word ptr [dev_req_hdr+TRANS+2]
	sub	DX, _psp
	mov	AX, 3100H
	int	21H

install_failed:

ENDIF ; } TSRDEV

	; terminate
	mov	AX, 4C00H
	int	21H

ENDIF ; } from "IF NOT BUILTIN"

IFDEF SUITE
	extrn	_logcmd:near
do_logcmd:
	; for use by Datalight Test Suite
	push	BX
	push	CX
	push	DX
	push	ES
	push	AX	; the cmd character
	call	_logcmd
	pop	AX
	pop	ES
	pop	DX
	pop	CX
	pop	BX
	ret
ENDIF ; } SUITE

cEndCode


;---------------------------------------------------------
;
;	ASSEMBLE-TIME MESSAGES
;
;	These message serve as reminders, displaying the
;	current options during assembly.
;
;---------------------------------------------------------

; <<<<< Print a Message on Pass 1 >>>>>
outstr MACRO msg
    IFDEF ??version
	%out msg
    ELSE
	IF1
	    %out msg
	ENDIF
    ENDIF
ENDM

IFDEF BUILTIN
	outstr	<* Built-in>
ELSE
	outstr	<* Stand-alone>
IFDEF TSRDEV
	outstr	<* TSR-capable>
ENDIF
ENDIF

IFDEF REMOVABLE
	outstr	<  * Removable>
ELSE
	outstr	<  * Not Removable>
ENDIF

IFDEF GENIOCTL
	outstr	<  * Generic IOCTL-supporting>
ENDIF

IFDEF ROMDISK
	outstr	<* ROM-Disk>
ELSE
	outstr	<* RAM-Disk>
ENDIF

	END	_devstart
