//
//   $Id: CDDOS.H 1.5 2002/10/15 20:34:18Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*********************************************************
 *
 *  cddos.h   created mm/dd/yy  by Roy Sherrill
 *				updated 06/14/96	by John Burnham
 *
 *  Copyright (c) 1989-2002 Datalight, Inc.
 *  All Rights Reserved.
 *  Datalight Confidential and Proprietary
 *
 *	DOS Structures used by the CD-ROM Device Driver
 *
 *  revision history
 *
 * 07/15/98 jmb   removed the declaration for
 *                dirSizeInSectors and rootSearchFlag
 *                and combined them with parSector
 *                to create a bitmapped flag so that
 *                entryOffset field could be expanded
 *                to 32bits.
 * 12/04/96 jmb	Changed the SDB structure to allow
 *					storage of information to handle multiple
 *					find first/next requests.
 *********************************************************/

#define STACK_SIZE 1024			// # of bytes in 2F interrupt
#define ENAMESIZE 11					// size of name templates
#define DOSFNAMESIZE 13				// size of a DOS filename with null terminator
#define DEVICENAMESZ 8					// size of a device name

#define TSR_NOW 0x4000

struct SDB
{
	uchar drive;							// drive to search
	uchar szNameMask[11];				//	wildcard name in expanded form
	uchar srchAttr;						// attributes allowed in search
	unsigned long entryOffset;			// entry offset within directory extent
	unsigned long parSector;			// sector containing the directory extent
                                    // as well as the size of the extent and
                                    // a flag designating if the search was in
                                    // the root.
                                    // 31          20 19 18                0
                                    //  xxxxxxxxxxxx   x  xxxxxxxxxxxxxxxxxx
                                    //  |              |  |
                                    //  |              |  +-> extent sector
                                    //  |              +----> root search flag
                                    //  +-------------------> extent size

//	uchar dirSizeInSectors;				// size of the directory extent in sectors
//	char rootSearchFlag;					// this flag tells us whether or not
												// this find first/next is taking place
												// in the root directory


	// This is the sepparation between the SDB and the FOUND FILE

	uchar szFname[ENAMESIZE]; 			// filename
	uchar fAttr;							// tells whether this is a file, dir or volume label
	uchar f2[10];							// reserved
	unsigned time;							// file time stamp
	unsigned date;							// file date stamp
	unsigned	stClstr;						//
	unsigned long	size;					// File size
};



//
// The Swabble Data Area (SDA) structure
//
// See page 726 in Undocumented DOS for a description of each
// of the fields.

#define SDA_FILENAMESIZE 128

struct SDA5
{
	uchar		CritERR;						// 320h
	uchar		InDOS;						// 321h
	uchar		drive_no;					// 322h
	uchar		errLocus;					// 323h
	unsigned	errno;						// 324h
	unsigned	errClassAct;				// 326h
	uchar		unknown99[4];				// 328h
	void far *	dta;						// 32Ch
	unsigned	currentPSP;					// 330h
	unsigned 	spXInt23;				// 332h
	unsigned 	lastRc;					// 334h
	uchar		currDrive;					// 336h
	uchar		extBrk;						// 337h
	unsigned	unknown0;					// 338h
	unsigned	int21AX;						// 33Ah
	unsigned	shrnetPsp;					// 33Ch
	unsigned 	netMcNo;					// 33Eh
	unsigned	memBlkData[3];				// 340h
	uchar		unknown1[10];				// 346h
	uchar		dd;							// 350h
	uchar		mm;							// 351h
	unsigned	yy1980;						// 352h
	unsigned	d111980;						// 354h
	uchar		dayOfWeek;					// 356h
	uchar		unknown2[3];				// 357h
	uchar		devReqH1[30];				// 35Ah
	void far *	devDrvptr;				// 378h
	uchar		devReqH2[22];				// 37Ch
	uchar		devReqH3[30];				// 392h
	uchar		unknown3[6];				// 3B0h
	uchar		clockRxrec[6];				// 3B6h
	uchar		unknown3a[2];				// 3BCh
	uchar		fn1[SDA_FILENAMESIZE];	// 3BEh
	uchar		fn2[SDA_FILENAMESIZE];	// 43Eh
	struct SDB	sdb;						// 4BEh
	uchar		driveCDSCopy[88];			// 4F3h
	uchar		fcbFn1[11];					// 54Bh
	uchar		unknown4;
	uchar		fcbFn2[11];					// 557h
	uchar		unknown5[11];
	uchar		srchAttr;					// 56Dh
	uchar		openMode;					// 56Eh
	uchar		unknown6[3];				// 56Fh
	uchar		callType;					// 572h
	uchar		unknown7[9];				// 573h
	uchar		termProctyp;				// 57Ch
	uchar		unknown8[3];				// 57Dh
	void far *	critDbpptr;				// 580h
	void far *	int21SsSp;				// 584h
	uchar 		unknown9[16];			// 588h
	uchar		media_id;					// 598h
	uchar		unknown10[5];				// 599h
	void far *	currSFTPtr;				// 59Eh
	void far *	driveDSPtr;				// 5A2h
	uchar		unknown11[8];				// 5A6h
	void far *	jftPtr;					// 5AEh
	unsigned	fn1Csoff;					// 5b2h
	unsigned	fn2Csoff;					// 5b4h
	uchar		unknown12[52];				// 5b6h
	uchar		bxDsTmp[4];					// 5eah
	uchar		unknown15[2];				// 5eeh
	void far *	prevStack;		   // 5f0h
	uchar		unknown13[9];			// 5f4h
	unsigned	spopAct;					// 5fdh
	unsigned	spopAttr;				// 5ffh
	unsigned	spopMode;
	uchar		unknown14[29];
	uchar		renSrcfile[21];
	uchar		renFile[32];
};

#define CDS_SUBST       (1<<12)
#define CDS_JOIN        (1<<13)
#define CDS_PHYSICAL    (1<<14)
#define CDS_NETWORK     (1<<15)


//
//	File Attributes
//
#define RDONLY	0x1
#define HIDDEN	0x2
#define SLYSTEM	0x4
#define VOLLAB	0x8
#define SUBDIR	0x10
#define ARCHIVE	0x20

//
//	File Read/Write status
//
#define READ 0x1
#define WRITE 0x2


//
//	DTA FINDFIRST/FINDNEXT
//	Description: Used by Findfirst/Findnext, INT 21H call 4EH and 4FH
//	Reference: (Adv MS-DOS, p 445  -or-  DOS Ref, p 671)
//
struct FIND
{
	uchar		szEName[ENAMESIZE];					// NAME????EXT
	uchar		drive;									// 0-n
	unsigned	uSubDir;									// cluster # of subdir
	unsigned	dirNum;									// directory entry number
	unsigned	start;									// starting cluster of file
	uchar		reserved[2];
	uchar		mask;										// attribute mask
	uchar		attr;										// attribute found
	unsigned	time;										// file's time
	unsigned	date;										// file's date
	unsigned long	size;								// file's size
	char 		szName[DOSFNAMESIZE]; 				// filename followed by 0 byte
};

//
// Stack structure that is in effect during the interrupt 2F call
// 16 bit general purpose registers
//
struct STACK16
{
	unsigned bp;
	unsigned di;
	unsigned si;
	unsigned ds;
	unsigned es;
	unsigned dx;
	unsigned cx;
	unsigned bx;
	unsigned ax;
	unsigned ip;
	unsigned cs;
	unsigned flags;
	unsigned attrib;									// Only here on certain calls
};

//
// Stack structure that is in effect during the interrupt 2F call
// 8 bit general purpose registers
//
struct STACK8
{
	unsigned bp;
	unsigned di;
	unsigned si;
	unsigned ds;
	unsigned es;
	unsigned char dl;
	unsigned char dh;
	unsigned char cl;
	unsigned char ch;
	unsigned char bl;
	unsigned char bh;
	unsigned char al;
	unsigned char ah;
	unsigned ip;
	unsigned cs;
	unsigned flags;
	unsigned attrib;									// Only here on certain calls
};

//
// Stack structure that is in effect during the interrupt 2F call
// union to allow access from either 8bit or 16bit registers.
//
typedef union
{
	struct STACK16	x;
	struct STACK8	h;
} STACK;



//
// Current Directory Structure also referec to as the Logical Drive Table
// This is also called the Current Directory Structure (CDS).
//
struct CDS
{
	char desig[2];
	char cwd[65];
	unsigned drvAttrib;
	void far * dpb;
	unsigned firstCluster;
	unsigned known1;
	unsigned known2;
	unsigned known3;
};


#define CDS_5_SIZE 88
//
// List of List structure
//
#if 1
struct LOL {
	void far *dbc;
	void far *dummy;
	void far *clockDev;
	void far *conDev;
	unsigned blkSize;
	void far * dummy2;
	struct CDS far *cds;
	void far * dummy4;
	unsigned dummy5;
	unsigned char blkDevCount;
	unsigned char lastDrive;
	struct devhdr far *NUL;
};

#else
struct LOL {
	void far * dpb;
#if 0
	void far * dcb;
	void far * clock;
	void far * con;
	unsigned char logicalDrives;
	unsigned maxBytes;
	long	 bufChain;
	void far * driveTable;
	long	unknwon3;
	unsigned unknown4;
#else
	unsigned char dummy[0x12];
	struct CDS far *cds;
	unsigned char dummy2[6];
	unsigned char blkDevCount;
	unsigned char lastDrive;
#endif
};
#endif

typedef struct CD_ROM_DEVHDR DEV_HDR;
typedef DEV_HDR * PDEV_HDR;
typedef DEV_HDR far * LPDEV_HDR;
struct CD_ROM_DEVHDR
{
	long      		dhNext;        				// Next device pointer
  short     		dhAttr;        				// Attributes
  unsigned short dhStrat; 	  					// Driver strategy routine
  unsigned short dhInter;   						// Driver interrupt routine
  char				dhName[DEVICENAMESZ]; 		// Device name
	unsigned			dhReserved;	  					// Reserved field
	uchar				dhCDDriveLtr;	  				// Starting Drive Letter
	 														//		A=1, B=2, C=3, D=4
	uchar				dhNumUnits;	  					// Number of Units
};


struct REQHDR
{
	unsigned char length;
	unsigned char unit;
	unsigned char cmd;
	unsigned 	stat;
	unsigned char dummy[8];
	unsigned char adrMode;
	void far *buf;
	unsigned	secCount;
	long		startSec;
	unsigned char intrLeveSize;
	unsigned char intrLeveFactor;
};



//
// MEMORY CONTROL BLOCK (MCB)
//
// Description: each block of memory is owned by a process
//
// Reference: (Adv MS-DOS, p --  -or-  DOS Ref, p 77)
//
struct MCB
{
   uchar      id;       							// 'M' for normal, 'Z' for last MCB
   unsigned   owner;    							// 00 psp segment of owner
   unsigned   paraCnt; 							// 00 # of paragraphs in this MCB
};

struct PSP
{
	unsigned 		pspInt20;
	unsigned			pspNextParagraph;
	char				alignmentByte;
	char				pspDispatcher[5];
	unsigned long	pspTerminateVector;
	unsigned long	pspControlCVector;
	unsigned long	pspCriticalErrorVector;
	unsigned			reserved1[11];
	unsigned			pspEnvironment;
	unsigned			reserved2[23];
	char				pspFCB_1[16];
	char				pspFCB_2[16];
	unsigned long	reserved3;
	char				pspCommandTail[128];
};



extern struct LOL  far *lpListOfLists;			// List of List pointer
extern int errNo;
extern STACK far	*lpDosStack;						// DOS Stack ptr SS:SP to 2F
extern uchar *pLocalStack;							// Stack area for 2F Stack
extern struct SDA5 far *lpSDA;						// Swappable Data Area Ver 5.x
extern int in2FFlag;									// Flag wither currently doing 2f Call
extern uchar far *lpSDAFileName1; 					// File Name array 1 in DOS's SDA
extern uchar far *lpSDAFileName2;			  		// File Name array 2 in DOS's SDA
extern void far *lpSDADTA;			  				// Value of DTA from DOS's SDA
extern struct	SDB far *lpSDASDB;	  				// Pointer to the SDB in DOS's SDA
extern uchar	sdaOpenMode;		  					// Open mode from DOS's SDA
extern uchar	sdaSrchAttr;		  					// Search attribute for Find first/next call (SDA)
extern uchar	sdaSDBDrive;		  					// Drive number from the SDB of the SDA
extern int maxOpenFiles;								// number of file handles supported by CDEX
																// default is 15
extern struct CD_ROM_DEVHDR far *lpCDROMDevice;// Pointer to CD-ROM Device Driver
