;
;   $Id: CRITERR.ASM 1.5 2002/10/15 20:34:18Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;*****************************************************************************
;*
;* criterr.asm	created 12/06/96 by John Burnham
;*
;* Copyright (C) 1996-2002 Datalight, Inc.
;* All Rights Reserved
;* Datalight Confidential and Proprietary
;*
;* This file contains the critical error generator for CDEX
;*
;* History
;* 10/12/98 jmb Corrected problem with using the parameters passed on the
;*		stack incorrectly.
;*****************************************************************************

include macros.inc



cBegData
;
; external data
;
	extrn	_lpDosStack:dword
	extrn	_pLocalStack:word
	extrn	_in2FFlag:word

;
; local data
;

ourSS	dw	?
ourSP	dw	?

cEndData


;
; public procedures
;

	public	DoCriticalError

;
; external procedures
;

cBegCode

;---------------------------------------------------------------------------------------
;
;  unsigned PASCAL DoCriticalError(unsigned errCode,
;                                  void far *lpDevice,
;                                  unsigned critAX)
;
;
;   do_critical_error allows the CDEX to perform a DOS critical error.
;   The value of the
;   	int24
;   		di = err_code
;   		ax = crit_ax
;   Return
;   	Abort - Does not return
;   	Ignore	= 0
;   	Retry	= 1
;   	FAIL	= 3
;
;
DoCriticalError proc
	push	bp
	mov	bp, sp
	push	bx
	push	si
	push	di

	; get the passed parameters into the appropriate registers
	mov	cx, [bp+4]  ;critAX
	mov	si, [bp+8]  ;lpDevice
	mov	di, [bp+10] ;errCode
	mov	bp, [bp+6] ;lpDevice+2

	; move function and subfunction into ax
	mov	ax, 1206H

	; swap stacks
	cli
	mov	ourSS, SS
	mov	ourSP, SP

	mov	sp, word ptr [_lpDosStack]
	mov	bx, word ptr [_lpDosStack+2]
	mov	SS, bx
	sti

	; push value for AX in critical error handler
	push	cx

	int	2fH		; Do the critical error


	; swap back to our stack
	cli
	mov	SP, ourSP
	mov	bx, ourSS
	mov	ss, bx
	sti

	; and off return code
	and 	ax, 00FFH


	; return to caller
	pop	di
	pop	si
	pop	bx
	pop	bp
	ret	8
DoCriticalError endp

cEndCode

	end
