;
;   $Id: INT2F.ASM 1.4 2002/10/15 20:34:18Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;*****************************************************************************
;*
;* int2f.asm	created 7/11/96	by John Burnham
;*
;* Copyright (C) 1996-2002 Datalight, Inc.
;* All Rights Reserved
;* Datalight Confidential and Proprietary
;*
;* This file contains the interrupt 2f interface
;* for CDEX
;*
;*****************************************************************************

include macros.inc
include defines.inc


cBegData
;
; external data
;
	extrn	_lpDosStack:dword
	extrn	_pLocalStack:word
	extrn	_in2FFlag:word

;
; public data
;
public _Next2FLabel
_Next2FLabel	dd	?

;
; ReEntryFlag is incremented and decremented as we enter and leave our
; Interrupt 2Fh handler
;
public wReEntryFlag
wReEntryFlag	dw	0

;
; dwStackPtrSpace is used to store SS:SP when we are reentered
;
dwStackPtrSpace dd	MAX_RE_ENTRIES dup(0)

;
; location to save the value of the ax register
;
save_ax		dw	?

cEndData

;
; public procedures
;
	public _Int2FHandler
	public _GetCS
	public _GetDS

;
; external procedures
;
	extrn	_Int2F11xxh:near
	extrn	_Int2F15xxh:near
	extrn _CheckStackOverFlow:near

cBegCode


bx_save	dw	?
;-----------------------------------------------------------------------------
; _Int2FHandler is the public interface to the interrupt 2Fh functions 11h and
; 15h.  Only these will be passed through, all others will be passed to the
; previous handler, if there was one.
;-----------------------------------------------------------------------------
_Int2FHandler	proc	far

	cmp	ah, 11h				; DOS calling CDEX?
	jz	CheckSubFunc			; jump if yes

	cmp	ah, 15h				; User calling CDEX?
	jz	MightBeOurs			; jump if yes

	jmp	dword ptr cs:[_Next2FLabel]	; not for us, call previous 2fh



CheckSubFunc:

	cmp	al, 1dh				; we need to check all funcs
						; less than 1dh
	jl	MightBeOurs

	cmp	al, 21h				; seek from end of file?
	je	MightBeOurs			; might be ours

	cmp	al, 2Dh				; unknown
	je	MightBeOurs			; we need to check it

	cmp	al, 2Eh				; open extended
	je	MightBeOurs			; check it



	;
	; this function is unsupported by CDEX
	; we need to chain to the previous owner of INT 2Fh
	;
	jmp	dword ptr cs:[_Next2FLabel]



MightBeOurs:

	; save registers
	push	ax
	push	bx
	push	cx
	push	dx
	push	es
	push	ds
	push	si
	push	di
	push	bp

	; set up DS to local DGROUP
	push	ax
	mov	ax, DGROUP
	mov	ds, ax
	pop	ax

;	; have we been reentered more than MAX_RE_ENTRIES times?
;	; if so, set the carry flag and give a return code 1 (invalid function)
;	cmp	[wReEntryFlag], MAX_RE_ENTRIES
;	jl	NotIn2Fh
;
;	int	3
;	mov	bx, sp
;	mov	word ptr ss:[bx+16], BAD_FUNC	; invalid function
;	or	word ptr ss:[bx+18], CARRY_FLAG ; set carry flag
;	jmp  	RestoreStack


NotIn2Fh:
	; increment the reentry flag
	inc	[wReEntryFlag]

	; save user's stack registers
	mov	word ptr [_lpDosStack], sp
	mov	word ptr [_lpDosStack+2], ss


;	; save ax register
;	mov	[save_ax], ax
;	;
;	; get a place to store the stack pointer
;	;
;	mov	bx, offset dwStackPtrSpace
;	mov	ax, wReEntryFlag
;	dec	ax
;	mov	ah, 4
;	mul	ah
;	add	bx, ax
;
;	; save the stack pointer
;	mov	word ptr [bx], sp
;	mov	word ptr [bx+2], ss

	; set up local stack
	cli
	mov	cx, ds
	mov	ss, cx
	mov	sp, [_pLocalStack]
;	mov	ax, wReEntryFlag
;	dec	ax
;	mov	cx, LOCAL_STACK_SIZE
;	mul	cx
;	add	sp, ax
	sti

	; pass user's stack to INT 2Fh function 11h/15h procedure
	push	word ptr [_lpDosStack+2]
	push	word ptr [_lpDosStack]

;	; restore value of ax register
;	mov	ax, [save_ax]

	; check to see which procedure to call
	; on return from either procedure, ax will contain either a value
	; to tell us to chain to next handler or to iret
	cmp	ah, 11h
	jnz	SendTo15hProcessor

	call	_Int2F11xxh
	jmp	short Exit2FHandler

SendTo15hProcessor:
	call	_Int2f15xxh

Exit2FHandler:

	; Check if we overflowed the stack
	;
	call  _CheckStackOverFlow

	; clean up stack from call
	pop	cx
	pop	cx

	;
	; get the place to get the stack pointer from
	;
;	push	ax
;	mov	bx, offset dwStackPtrSpace
;	mov	ax, wReEntryFlag
;	dec	ax
;	mov	ah, 4
;	mul	ah
;	add	bx, ax
;	pop	ax
;
	; decrement rentrancy flag
	dec	[wReEntryFlag]

	; get caller's stack back
	cli
	mov	sp, word ptr [_lpDosStack]
	mov     bx, word ptr [_lpDosStack+2]

;	mov	sp, word ptr [bx]
;	mov	bx, word ptr [bx+2]
	mov	ss, bx
	sti

RestoreStack:
	; restore caller's registers from this stack
	pop	bp
	pop	di
	pop	si
	pop	ds
	pop	es
	pop	dx
	pop	cx
	pop	bx

	; before restoring ax, we need to check to see if we are returning
	; to the caller or chaining to the previous INT 2Fh handler.
	test	ax, ax
	pop	ax

	jz	Exit2FHandlerNow
ChainToPrior:
	jmp	dword ptr cs:[_Next2FLabel]

Exit2FHandlerNow:
	iret

_Int2FHandler	endp



;
; GetCS returns the value of the current code segment
;
_GetCS	proc	near
	mov	ax, cs
	ret
_GetCS	endp

;
; GetDS returns the current value of the DS register
;
_GetDS	proc	near
	mov	ax, DGROUP
	ret
_GetDS	endp


cEndCode

	end

