//
//   $Id: COUNTDAT.C 1.4 2002/10/15 20:35:36Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*********************************************************

	COUNTDAT.C  created 02/15/89  by Drew Gislason

   Copyright (c) 1989-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

	This file provides a description of each country
	supported.  It can be run as a stand-alone program
	or used with COUNTRY.SYS.  It works with both ROM-DOS
	and a desktop DOS (5.0 or greater).

**********************************************************/
#include <dos.h>
#include <mem.h>
#include "country.h"

// if you wish to set the country codes from the command line
// #define STANDALONE=1

typedef unsigned word;

// We support the following countries
#define USA 				1
#define CANADA				2
#define LATIN_AMERICA	3
#define RUSSIA          7
#define NETHERLANDS		31
#define BELGIUM			32
#define FRANCE				33
#define SPAIN				34
#define HUNGARY			36
#define YUGOSLAVIA		38		// also Croatia, Serbia, Slovenia
#define ITALY				39
#define SWITZERLAND		41
#define CZECHOSLOVAKIA	42		// also Slovakia
#define UNITED_KINGDOM	44
#define DENMARK			45
#define SWEDEN				46
#define NORWAY				47
#define POLAND				48
#define GERMANY			49
#define BRAZIL				55
#define AUSTRALIA			61
#define JAPAN				81
#define PORTUGAL			351
#define FINLAND			358

// We support the following Code Pages
#define CP_USA				437
#define CP_MULTI			850
#define CP_SLAVIC			852
#define CP_PORTUGUESE	860
#define CP_CANADA			863
#define CP_NORDIC			865
#define CP_RUSSIA       866  // Cyrillic ][


/*
	[]------------------------------------[]
    |                                    |
    |      COUNTRY (DATE/TIME) INFO      |
    |                                    |
	[]------------------------------------[]
*/


cdata usa				= { 0, "$", ',', '.', '-', ':', 0, 2, 0, NULL, ',' };
cdata canada 			= { 2, "$", ' ', ',', '-', ':', 3, 2, 1, NULL, ';' };
cdata latin_america	= { 1, "$", ',', '.', '/', ':', 0, 2, 0, NULL, ',' };
cdata russia         = { 1,"\xE0.", ' ', '.', '.', ':', 3, 2, 1, NULL, ';'  };
cdata netherlands    = { 1,"\x9F", '.', ',', '-', ':', 2, 2, 1, NULL, ';' };
cdata belgium			= { 1, "BF", '.', ',', '/', ':', 2, 2, 1, NULL, ';' };
cdata france			= { 1, "F", ' ', ',', '.', ':', 3, 2, 1, NULL, ';' };
// note: spain uses a different current symbol based on code page.
//       this is accounted for in the "set info" function.
cdata spain				= { 1, "Pts", '.', ',', '/', ':', 2, 0, 1, NULL, ';' };
cdata hungary			= { 2, "Ft", ' ', ',', '-', ':', 0, 2, 1, NULL, ',' };
cdata yugoslavia		= { 2, "Din", '.', ',', '-', ':', 2, 2, 1, NULL, ',' };
cdata italy				= { 1, "L.", '.', ',', '/', '.', 2, 0, 1, 0, ';', };
cdata switzerland		= { 1, "Fr.", '\'', '.', '.', ',', 2, 2, 1, NULL, ';' };
cdata czechoslovakia	= { 2, "K\x9Fs", '.', ',', '-', ':', 2, 2, 1, NULL, ',' };
cdata united_kingdom	= { 1, "\x9C", ',', '.', '/', ':', 0, 2, 1, NULL, ',' };
cdata denmark			= { 1, "kr", '.', ',', '-', '.', 2, 2, 1, NULL, ';' };
cdata sweden			= { 2, "Kr", ' ', ',', '-', '.', 3, 2, 1, NULL, ';' };
cdata norway			= { 1, "Kr", '.', ',', '.', ':', 2, 2, 1, NULL, ';' };
cdata poland			= { 2, "Z\x88", '.', ',', '-', ':', 0, 2, 1, NULL, ',' };
cdata germany			= { 1, "DM", '.', ',', '.', ':', 0, 2, 1, NULL, ';' };
cdata brazil			= { 1, "Cr$", '.', ',', '/', ':', 0, 2, 1, NULL, ';' };
cdata australia		= { 1, "$", ',', '.', '-', ':', 0, 2, 0, NULL, ',' };
cdata japan				= { 2, "\\", ',', '.', '-', ':', 0, 0, 1, NULL, ',' };
cdata portugal			= { 1, "Esc.", '.', ',', '-', ':', 3, 2, 1, NULL, ';' };
cdata finland			= { 1, "mk", ' ', ',', '.', '.', 3, 2, 1, NULL, ';' };


/*
	[]------------------------------------[]
    |                                    |
    |          UPPERCASE TABLES          |
    |                                    |
	[]------------------------------------[]
*/

#define upperLA437 upperUS437
#define upperFR437 upperUS437
#define upperSP437 upperUS437
#define upperIT437 upperUS437
#define upperUK437 upperUS437
#define upperGR437 upperUS437
#define upperBZ437 upperUS437
#define upperAU437 upperUS437
#define upperRU437 upperUS437

// upperUS437 = upperLA437 = upperFR437 = upperSP437 = upperIT437 = upperUK437 = upperGR437 = upperBZ437 = upperAU437
unsigned char upperUS437[] =
{
	0x80,0x9A,0x45,0x41,0x8E,0x41,0x8F,0x80,
	0x45,0x45,0x45,0x49,0x49,0x49,0x8E,0x8F,
	0x90,0x92,0x92,0x4F,0x99,0x4F,0x55,0x55,
	0x59,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F,
	0x41,0x49,0x4F,0x55,0xA5,0xA5,0xA6,0xA7,
	0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,
	0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,
	0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
	0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,
	0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,
	0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,
	0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};

#define upperCF850 upperUS850
#define upperFR850 upperUS850
#define upperIT850 upperUS850
#define upperUK850 upperUS850
#define upperAU850 upperUS850
#define upperPO850 upperUS850

// upperUS850 = upperCF850 = upperFR850 = upperIT850 = upperUK850 = upperAU850 = upperPO850
unsigned char upperUS850[] =
{
	0x43,0x55,0x45,0x41,0x41,0x41,0x41,0x43,
	0x45,0x45,0x45,0x49,0x49,0x49,0x41,0x41,
	0x45,0x92,0x92,0x4F,0x4F,0x4F,0x55,0x55,
	0x59,0x4F,0x55,0x4F,0x9C,0x4F,0x9E,0x9F,
	0x41,0x49,0x4F,0x55,0xA5,0xA5,0xA6,0xA7,
	0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,
	0xB0,0xB1,0xB2,0xB3,0xB4,0x41,0x41,0x41,
	0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0x41,0x41,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
	0xD1,0xD1,0x45,0x45,0x45,0x49,0x49,0x49,
	0x49,0xD9,0xDA,0xDB,0xDC,0xDD,0x49,0xDF,
	0x4F,0xE1,0x4F,0x4F,0x4F,0x4F,0xE6,0xE8,
	0xE8,0x55,0x55,0x55,0x59,0x59,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};

// upperCF863
unsigned char upperCF863[] =
{
	0x43,0x55,0x45,0x41,0x41,0x41,0x86,0x43,
	0x45,0x45,0x45,0x49,0x49,0x8D,0x41,0x8F,
	0x45,0x45,0x45,0x4F,0x45,0x49,0x55,0x55,
	0x98,0x4F,0x55,0x9B,0x9C,0x55,0x55,0x9F,
	0xA0,0xA1,0x4F,0x55,0xA4,0xA5,0xA6,0xA7,
	0x49,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,
	0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,
	0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
	0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,
	0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,
	0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,
	0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};

#define upperBE850 upperLA850
#define upperSP850 upperLA850
#define upperSF850 upperLA850
#define upperDK850 upperLA850
#define upperSV850 upperLA850
#define upperNO850 upperLA850
#define upperSU850 upperLA850

// upperLA850 = upperBE850 = upperSP850 = upperSF850 = upperDK850 = upperSV850 = upperNO850 = upperSU850
unsigned char upperLA850[] =
{
	0x80,0x9A,0x90,0xB6,0x8E,0xB7,0x8F,0x80,
	0xD2,0xD3,0xD4,0xD8,0xD7,0xDE,0x8E,0x8F,
	0x90,0x92,0x92,0xE2,0x99,0xE3,0xEA,0xEB,
	0x59,0x99,0x9A,0x9D,0x9C,0x9D,0x9E,0x9F,
	0xB5,0xD6,0xE0,0xE9,0xA5,0xA5,0xA6,0xA7,
	0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,
	0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,
	0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC7,0xC7,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
	0xD1,0xD1,0xD2,0xD3,0xD4,0x49,0xD6,0xD7,
	0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,
	0xE0,0xE1,0xE2,0xE3,0xE5,0xE5,0xE6,0xE8,
	0xE8,0xE9,0xEA,0xEB,0xED,0xED,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};

// upperNL850
unsigned char upperNL850[] =
{
	0x80,0x55,0x45,0x41,0x41,0x41,0x8F,0x80,
	0x45,0x45,0x45,0x49,0x49,0x49,0x41,0x8F,
	0x45,0x92,0x92,0x4F,0x4F,0x4F,0x55,0x55,
	0x98,0x4F,0x55,0x4F,0x9C,0x4F,0x9E,0x9F,
	0x41,0x49,0x4F,0x55,0xA5,0xA5,0xA6,0xA7,
	0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,
	0xB0,0xB1,0xB2,0xB3,0xB4,0x41,0x41,0x41,
	0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0x41,0x41,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
	0xD1,0xD1,0x45,0x45,0x45,0x49,0x49,0x49,
	0x49,0xD9,0xDA,0xDB,0xDC,0xDD,0x49,0xDF,
	0x4F,0xE1,0x4F,0x4F,0x4F,0x4F,0xE6,0xE8,
	0xE8,0x55,0x55,0x55,0x59,0x59,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};

// upperNL437
unsigned char upperNL437[] =
{
	0x80,0x55,0x45,0x41,0x41,0x41,0x8F,0x80,
	0x45,0x45,0x45,0x49,0x49,0x49,0x41,0x8F,
	0x45,0x92,0x92,0x4F,0x4F,0x4F,0x55,0x55,
	0x98,0x4F,0x55,0x9B,0x9C,0x9D,0x9E,0x9F,
	0x41,0x49,0x4F,0x55,0xA5,0xA5,0xA6,0xA7,
	0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,
	0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,
	0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
	0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,
	0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,
	0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,
	0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};

#define upperSF437 upperBE437
#define upperSV437 upperBE437
#define upperSU437 upperBE437

// upperBE437 = upperSF437 = upperSV437 = upperSU437
unsigned char upperBE437[] =
{
	0x80,0x9A,0x90,0x41,0x8E,0x41,0x8F,0x80,
	0x45,0x45,0x45,0x49,0x49,0x49,0x8E,0x8F,
	0x90,0x92,0x92,0x4F,0x99,0x4F,0x55,0x55,
	0x59,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F,
	0x41,0x49,0x4F,0x55,0xA5,0xA5,0xA6,0xA7,
	0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,
	0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,
	0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
	0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,
	0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,
	0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,
	0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};

#define upperYU852 upperHU852
#define upperCZ852 upperHU852
#define upperPL852 upperHU852

// upperHU852 = upperYU852 = upperCZ852 = upperPL852
unsigned char upperHU852[] =
{
	0x80,0x9A,0x90,0xB6,0x8E,0xDE,0x8F,0x80,
	0x9D,0xD3,0x8A,0x8A,0xD7,0x8D,0x8E,0x8F,
	0x90,0x91,0x91,0xE2,0x99,0x95,0x95,0x97,
	0x97,0x99,0x9A,0x9B,0x9B,0x9D,0x9E,0xAC,
	0xB5,0xD6,0xE0,0xE9,0xA4,0xA4,0xA6,0xA6,
	0xA8,0xA8,0xAA,0x8D,0xAC,0xB8,0xAE,0xAF,
	0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,
	0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBD,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC6,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
	0xD1,0xD1,0xD2,0xD3,0xD2,0xD5,0xD6,0xD7,
	0xB7,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,
	0xE0,0xE1,0xE2,0xE3,0xE3,0xD5,0xE6,0xE6,
	0xE8,0xE9,0xE8,0xEB,0xED,0xED,0xDD,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xEB,0xFC,0xFC,0xFE,0xFF
};

#define upperYU850 upperHU850
#define upperCZ850 upperHU850
#define upperPL850 upperHU850
#define upperBZ850 upperHU850

// upperHU850 = upperYU850 = upperCZ850 = upperPL850 = upperBZ850
unsigned char upperHU850[] =
{
	0x80,0x9A,0x90,0xB6,0x8E,0xB7,0x8F,0x80,
	0xD2,0xD3,0xD4,0xD8,0xD7,0xDE,0x8E,0x8F,
	0x90,0x92,0x92,0xE2,0x99,0xE3,0xEA,0xEB,
	0x98,0x99,0x9A,0x9D,0x9C,0x9D,0x9E,0x9F,
	0xB5,0xD6,0xE0,0xE9,0xA5,0xA5,0xA6,0xA7,
	0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,
	0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,
	0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC7,0xC7,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
	0xD1,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,
	0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,
	0xE0,0xE1,0xE2,0xE3,0xE5,0xE5,0xE6,0xE8,
	0xE8,0xE9,0xEA,0xEB,0xED,0xED,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};

#define upperNO865 upperDK865

// upperDK865 = upperNO865
unsigned char upperDK865[] =
{
	0x80,0x9A,0x90,0x41,0x8E,0x41,0x8F,0x80,
	0x45,0x45,0x45,0x49,0x49,0x49,0x8E,0x8F,
	0x90,0x92,0x92,0x4F,0x99,0x4F,0x55,0x55,
	0x59,0x99,0x9A,0x9D,0x9C,0x9D,0x9E,0x9F,
	0x41,0x49,0x4F,0x55,0xA5,0xA5,0xA6,0xA7,
	0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,
	0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,
	0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
	0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,
	0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,
	0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,
	0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};

// upperGR850
unsigned char upperGR850[] =
{
	0x43,0x9A,0x45,0x41,0x8E,0x41,0x41,0x43,
	0x45,0x45,0x45,0x49,0x49,0x49,0x8E,0x41,
	0x45,0x92,0x92,0x4F,0x99,0x4F,0x55,0x55,
	0x59,0x99,0x9A,0x4F,0x9C,0x4F,0x9E,0x9F,
	0x41,0x49,0x4F,0x55,0xA5,0xA5,0xA6,0xA7,
	0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,
	0xB0,0xB1,0xB2,0xB3,0xB4,0x41,0x41,0x41,
	0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0x41,0x41,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
	0xD1,0xD1,0x45,0x45,0x45,0x49,0x49,0x49,
	0x49,0xD9,0xDA,0xDB,0xDC,0xDD,0x49,0xDF,
	0x4F,0xE1,0x4F,0x4F,0x4F,0x4F,0xE6,0xE8,
	0xE8,0x55,0x55,0x55,0x59,0x59,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};

// upperPO860
unsigned char upperPO860[] =
{
	0x80,0x9A,0x90,0x8F,0x8E,0x91,0x86,0x80,
	0x89,0x89,0x92,0x8B,0x8C,0x98,0x8E,0x8F,
	0x90,0x91,0x92,0x8C,0x99,0xA9,0x96,0x9D,
	0x98,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F,
	0x86,0x8B,0x9F,0x96,0xA5,0xA5,0xA6,0xA7,
	0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,
	0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,
	0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
	0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,
	0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,
	0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,
	0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};

// upperJA932
unsigned char upperJA932[] =
{
	0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,
	0x88,0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F,
	0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,
	0x98,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F,
	0xA0,0xA1,0xA2,0xA3,0xA4,0xA5,0xA6,0xA7,
	0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,
	0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,
	0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
	0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,
	0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,
	0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,
	0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};


unsigned char upperRU866[] =
{
	0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,
	0x88,0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F,
	0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,
	0x98,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F,
	0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,
	0x88,0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F,
	0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,
	0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
	0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,
	0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,
	0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,
	0x98,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F,
	0xF0,0xF0,0xF2,0xF2,0xF4,0xF4,0xF6,0xF6,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};




/*
	[]------------------------------------[]
    |                                    |
    |      SORT (COLLATING) TABLES       |
    |                                    |
	[]------------------------------------[]
*/

#define sortFR437 sortUS437
#define sortIT437 sortUS437
#define sortUK437 sortUS437
#define sortGR437 sortUS437
#define sortBZ437 sortUS437
#define sortAU437 sortUS437
#define sortRU437 sortUS437

// sortUS437 = sortFR437 = sortIT437 = sortUK437 = sortGR437 = sortBZ437 = sortAU437
unsigned char sortUS437[] =
{
	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
	0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,
	0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,
	0x18,0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,
	0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,
	0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,
	0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,
	0x38,0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,
	0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,
	0x60,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x7B,0x7C,0x7D,0x7E,0x7F,
	0x43,0x55,0x45,0x41,0x41,0x41,0x41,0x43,
	0x45,0x45,0x45,0x49,0x49,0x49,0x41,0x41,
	0x45,0x41,0x41,0x4F,0x4F,0x4F,0x55,0x55,
	0x59,0x4F,0x55,0x24,0x24,0x24,0x24,0x24,
	0x41,0x49,0x4F,0x55,0x4E,0x4E,0xA6,0xA7,
	0x3F,0xA9,0xAA,0xAB,0xAC,0x21,0x22,0x22,
	0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,
	0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
	0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,
	0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,
	0xE0,0x53,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,
	0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};

#define sortCF850 sortUS850
#define sortFR850 sortUS850
#define sortIT850 sortUS850
#define sortUK850 sortUS850
#define sortGR850 sortUS850
#define sortBZ850 sortUS850
#define sortAU850 sortUS850
#define sortPO850 sortUS850

// sortUS850 = sortCF850 = sortFR850 = sortIT850 = sortUK850 = sortGR850 = sortBZ850 = sortAU850 = sortPO850
unsigned char sortUS850[] =
{
	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
	0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,
	0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,
	0x18,0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,
	0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,
	0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,
	0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,
	0x38,0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,
	0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,
	0x60,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x7B,0x7C,0x7D,0x7E,0x7F,
	0x43,0x55,0x45,0x41,0x41,0x41,0x41,0x43,
	0x45,0x45,0x45,0x49,0x49,0x49,0x41,0x41,
	0x45,0x41,0x41,0x4F,0x4F,0x4F,0x55,0x55,
	0x59,0x4F,0x55,0x4F,0x24,0x4F,0x9E,0x24,
	0x41,0x49,0x4F,0x55,0x4E,0x4E,0xA6,0xA7,
	0x3F,0xA9,0xAA,0xAB,0xAC,0x21,0x22,0x22,
	0xB0,0xB1,0xB2,0xB3,0xB4,0x41,0x41,0x41,
	0xB8,0xB9,0xBA,0xBB,0xBC,0x24,0x24,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0x41,0x41,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0x24,
	0x44,0x44,0x45,0x45,0x45,0x49,0x49,0x49,
	0x49,0xD9,0xDA,0xDB,0xDC,0xDD,0x49,0xDF,
	0x4F,0x53,0x4F,0x4F,0x4F,0x4F,0xE6,0xE8,
	0xE8,0x55,0x55,0x55,0x59,0x59,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};

// sortCF863
unsigned char sortCF863[] =
{
	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
	0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,
	0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,
	0x18,0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,
	0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,
	0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,
	0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,
	0x38,0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,
	0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,
	0x60,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x7B,0x7C,0x7D,0x7E,0x7F,
	0x43,0x55,0x45,0x41,0x41,0x41,0x86,0x43,
	0x45,0x45,0x45,0x49,0x49,0x8D,0x41,0x8F,
	0x45,0x45,0x45,0x4F,0x45,0x49,0x55,0x55,
	0x98,0x4F,0x55,0x9B,0x9C,0x55,0x55,0x9F,
	0xA0,0xA1,0x4F,0x55,0xA4,0xA5,0xA6,0xA7,
	0x49,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,
	0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,
	0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
	0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,
	0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,
	0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,
	0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};

#define sortSP850 sortLA850

// sortLA850 = sortSP850
unsigned char sortLA850[] =
{
	0x00,0x96,0x97,0x98,0x99,0x9A,0x9B,0x9C,
	0x9D,0x9E,0x9F,0xA0,0xA1,0xA2,0xA3,0xA4,
	0xA5,0xA6,0xA7,0xA8,0xA9,0xAA,0xAB,0xAC,
	0xAD,0xAE,0xAF,0xB0,0xB1,0xB2,0xB3,0xB4,
	0x00,0x3C,0x3D,0x3E,0x3F,0x40,0x41,0x00,
	0x42,0x43,0x44,0x45,0x46,0x00,0x47,0x48,
	0x22,0x23,0x24,0x25,0x26,0x27,0x28,0x29,
	0x2A,0x2B,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,
	0x4F,0x01,0x02,0x03,0x06,0x08,0x09,0x0A,
	0x0B,0x0C,0x0D,0x0E,0x0F,0x11,0x12,0x14,
	0x15,0x16,0x17,0x18,0x1A,0x1C,0x1D,0x1E,
	0x1F,0x20,0x21,0x50,0x51,0x52,0x53,0x54,
	0x55,0x01,0x02,0x03,0x06,0x08,0x09,0x0A,
	0x0B,0x0C,0x0D,0x0E,0x0F,0x11,0x12,0x14,
	0x15,0x16,0x17,0x18,0x1A,0x1C,0x1D,0x1E,
	0x1F,0x20,0x21,0x56,0x57,0x58,0x59,0x5A,
	0x04,0x1C,0x08,0x01,0x01,0x01,0x01,0x04,
	0x08,0x08,0x08,0x0C,0x0C,0x0C,0x01,0x01,
	0x08,0x01,0x01,0x14,0x14,0x14,0x1C,0x1C,
	0x20,0x14,0x1C,0x14,0x5C,0x14,0x5E,0x5F,
	0x01,0x0C,0x14,0x1C,0x13,0x13,0x01,0x14,
	0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,
	0x68,0x69,0x6A,0x6B,0x6C,0x01,0x01,0x01,
	0xB8,0x6D,0x6E,0x01,0x01,0x5B,0x5D,0x71,
	0x72,0x73,0x74,0x75,0x76,0x77,0xBB,0xBC,
	0x78,0x79,0x7A,0x7B,0x7C,0x7D,0x7E,0xBD,
	0x07,0x07,0x08,0x08,0x08,0x0C,0x0C,0x0C,
	0x0C,0x7F,0x80,0x81,0x82,0xC7,0x0C,0x83,
	0x14,0x19,0x14,0x14,0x14,0x14,0x84,0x1B,
	0x1B,0x1C,0x1C,0x1C,0x20,0x20,0xD5,0xD6,
	0x00,0x85,0xD8,0xD9,0xDA,0xDB,0x86,0xDC,
	0xDD,0xDE,0x00,0xDF,0xE0,0x87,0x88,0xE1
};

#define sortSP437 sortLA437

// sortLA437 = sortSP437
unsigned char sortLA437[] =
{
	0x00,0x96,0x97,0x98,0x99,0x9A,0x9B,0x9C,
	0x9D,0x9E,0x9F,0xA0,0xA1,0xA2,0xA3,0xA4,
	0xA5,0xA6,0xA7,0xA8,0xA9,0xAA,0xAB,0xAC,
	0xAD,0xAE,0xAF,0xB0,0xB1,0xB2,0xB3,0xB4,
	0x00,0x3C,0x3D,0x3E,0x3F,0x40,0x41,0x00,
	0x42,0x43,0x44,0x45,0x46,0x00,0x47,0x48,
	0x22,0x23,0x24,0x25,0x26,0x27,0x28,0x29,
	0x2A,0x2B,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,
	0x4F,0x01,0x02,0x03,0x06,0x08,0x09,0x0A,
	0x0B,0x0C,0x0D,0x0E,0x0F,0x11,0x12,0x14,
	0x15,0x16,0x17,0x18,0x1A,0x1C,0x1D,0x1E,
	0x1F,0x20,0x21,0x50,0x51,0x52,0x53,0x54,
	0x55,0x01,0x02,0x03,0x06,0x08,0x09,0x0A,
	0x0B,0x0C,0x0D,0x0E,0x0F,0x11,0x12,0x14,
	0x15,0x16,0x17,0x18,0x1A,0x1C,0x1D,0x1E,
	0x1F,0x20,0x21,0x56,0x57,0x58,0x59,0x5A,
	0x04,0x1C,0x08,0x01,0x01,0x01,0x01,0x04,
	0x08,0x08,0x08,0x0C,0x0C,0x0C,0x01,0x01,
	0x08,0x01,0x01,0x14,0x14,0x14,0x1C,0x1C,
	0x20,0x14,0x1C,0x5B,0x5C,0x5D,0x5E,0x5F,
	0x01,0x0C,0x14,0x1C,0x13,0x13,0x01,0x14,
	0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,
	0x68,0x69,0x6A,0x6B,0x6C,0xB5,0xB6,0xB7,
	0xB8,0x6D,0x6E,0x6F,0x70,0xB9,0xBA,0x71,
	0x72,0x73,0x74,0x75,0x76,0x77,0xBB,0xBC,
	0x78,0x79,0x7A,0x7B,0x7C,0x7D,0x7E,0xBD,
	0xBE,0xBF,0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,
	0xC6,0x7F,0x80,0x81,0x82,0xC7,0xC8,0x83,
	0xC9,0x19,0xCA,0xCB,0xCC,0xCD,0x84,0xCE,
	0xCF,0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,
	0xD7,0x85,0xD8,0xD9,0xDA,0xDB,0x86,0xDC,
	0xDD,0xDE,0x00,0xDF,0xE0,0x87,0x88,0xE1
};

// sortNL850
unsigned char sortNL850[] =
{
	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
	0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,
	0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,
	0x18,0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,
	0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,
	0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,
	0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,
	0x38,0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,
	0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,
	0x60,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x7B,0x7C,0x7D,0x7E,0x7F,
	0x43,0x55,0x45,0x41,0x41,0x41,0x8F,0x43,
	0x45,0x45,0x45,0x49,0x49,0x49,0x41,0x8F,
	0x45,0x92,0x92,0x4F,0x4F,0x4F,0x55,0x55,
	0x98,0x4F,0x55,0x4F,0x9C,0x4F,0x9E,0x9F,
	0x41,0x49,0x4F,0x55,0xA5,0xA5,0xA6,0xA7,
	0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,
	0xB0,0xB1,0xB2,0xB3,0xB4,0x41,0x41,0x41,
	0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0x41,0x41,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
	0xD1,0xD1,0x45,0x45,0x45,0x49,0x49,0x49,
	0x49,0xD9,0xDA,0xDB,0xDC,0xDD,0x49,0xDF,
	0x4F,0xE1,0x4F,0x4F,0x4F,0x4F,0xE6,0xE8,
	0xE8,0x55,0x55,0x55,0x59,0x59,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};

// sortNL437
unsigned char sortNL437[] =
{
	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
	0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,
	0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,
	0x18,0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,
	0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,
	0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,
	0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,
	0x38,0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,
	0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,
	0x60,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x7B,0x7C,0x7D,0x7E,0x7F,
	0x80,0x9A,0x90,0x41,0x8E,0x41,0x8F,0x80,
	0x45,0x45,0x45,0x49,0x49,0x49,0x8E,0x8F,
	0x90,0x92,0x92,0x4F,0x4F,0x4F,0x55,0x55,
	0x98,0x4F,0x55,0x9B,0x9C,0x9D,0x9E,0x9F,
	0x41,0x49,0x4F,0x55,0xA5,0xA5,0xA6,0xA7,
	0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,
	0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,
	0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
	0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,
	0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,
	0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,
	0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};

// sortBE850
unsigned char sortBE850[] =
{
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0xFF,0x21,0x22,0x23,0x24,0x25,0x26,0xFF,
	0x28,0x29,0x2A,0x2B,0x2C,0xFF,0x2E,0x2F,
	0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,
	0x38,0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,
	0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,
	0x60,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x7B,0x7C,0x7D,0x7E,0x7F,
	0x43,0x55,0x45,0x41,0x41,0x41,0x41,0x43,
	0x45,0x45,0x45,0x49,0x49,0x49,0x41,0x41,
	0x45,0x41,0x41,0x4F,0x4F,0x4F,0x55,0x55,
	0x59,0x4F,0x55,0x4F,0x9C,0x4F,0x9E,0x9F,
	0x41,0x49,0x4F,0x55,0x4E,0xA4,0xA6,0xA7,
	0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,
	0xFF,0xFF,0xFF,0xFF,0xFF,0x41,0x41,0x41,
	0xB8,0xFF,0xFF,0xFF,0xFF,0xBD,0xBE,0xFF,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x41,0x41,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xCF,
	0x44,0x44,0x45,0x45,0x45,0x49,0x49,0x49,
	0x49,0xFF,0xFF,0xFF,0xFF,0xDD,0x49,0xFF,
	0x4F,0x53,0x4F,0x4F,0x4F,0x4F,0xE6,0x54,
	0x54,0x55,0x55,0x55,0x59,0x59,0xEE,0xEF,
	0xFF,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFF,0xFF
};

// sortBE437
unsigned char sortBE437[] =
{
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0xFF,0x21,0x22,0x23,0x24,0x25,0x26,0xFF,
	0x28,0x29,0x2A,0x2B,0x2C,0xFF,0x2E,0x2F,
	0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,
	0x38,0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,
	0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,
	0x60,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x7B,0x7C,0x7D,0x7E,0x7F,
	0x43,0x55,0x45,0x41,0x41,0x41,0x41,0x43,
	0x45,0x45,0x45,0x49,0x49,0x49,0x41,0x41,
	0x45,0x41,0x41,0x4F,0x4F,0x4F,0x55,0x55,
	0x59,0x4F,0x55,0x9B,0x9C,0x9D,0x9E,0x9F,
	0x41,0x49,0x4F,0x55,0x4E,0x4E,0xA6,0xA7,
	0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0xE0,0x53,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,
	0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFF,0xFF
};

#define sortYU852 sortHU852
#define sortCZ852 sortHU852
#define sortPL852 sortHU852

// sortHU852 = sortYU852 = sortCZ852 = sortPL852
unsigned char sortHU852[] =
{
	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
	0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,
	0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,
	0x18,0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,
	0x6E,0x6F,0x70,0x71,0x72,0x73,0x74,0x75,
	0x76,0x77,0x78,0x79,0x7A,0x7B,0x7C,0x7D,
	0x64,0x65,0x66,0x67,0x68,0x69,0x6A,0x6B,
	0x6C,0x6D,0x7E,0x7F,0x80,0x81,0x82,0x83,
	0x84,0x21,0x27,0x28,0x2C,0x2F,0x34,0x35,
	0x36,0x37,0x3A,0x3B,0x3C,0x40,0x41,0x44,
	0x49,0x4A,0x4B,0x4E,0x53,0x56,0x5B,0x5C,
	0x5D,0x5E,0x60,0x85,0x86,0x87,0x88,0x89,
	0x8A,0x21,0x27,0x28,0x2C,0x2F,0x34,0x35,
	0x36,0x37,0x3A,0x3B,0x3C,0x40,0x41,0x44,
	0x49,0x4A,0x4B,0x4E,0x53,0x56,0x5B,0x5C,
	0x5D,0x5E,0x60,0x8B,0x8C,0x8D,0x8E,0x20,
	0x2B,0x59,0x30,0x26,0x23,0x58,0x29,0x2B,
	0x3F,0x33,0x48,0x48,0x39,0x62,0x23,0x29,
	0x30,0x3D,0x3D,0x46,0x47,0x3E,0x3E,0x52,
	0x52,0x47,0x59,0x54,0x54,0x3F,0x8F,0x2A,
	0x22,0x38,0x45,0x57,0x24,0x24,0x61,0x61,
	0x32,0x32,0x90,0x62,0x2A,0x51,0x91,0x92,
	0x97,0x98,0x99,0x9A,0x9B,0x22,0x26,0x31,
	0x51,0x9C,0x9D,0x9E,0x9F,0x63,0x63,0xA0,
	0xA1,0xA2,0xA3,0xA4,0xA5,0xA6,0x25,0x25,
	0xA7,0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0x93,
	0x2D,0x2D,0x2E,0x33,0x2E,0x42,0x38,0x39,
	0x31,0xAE,0xAF,0xB0,0xB1,0x55,0x58,0xB2,
	0x45,0x4F,0x46,0x43,0x43,0x42,0x50,0x50,
	0x4C,0x57,0x4C,0x5A,0x5F,0x5F,0x55,0xB4,
	0x94,0xB5,0xB6,0xB7,0xB8,0x95,0x96,0xB9,
	0xBA,0xBB,0xBC,0x5A,0x4D,0x4D,0xB3,0xFF
};

#define sortYU850 sortHU850
#define sortCZ850 sortHU850
#define sortPL850 sortHU850

// sortHU850 = sortYU850 = sortCZ850 = sortPL850
unsigned char sortHU850[] =
{
	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
	0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,
	0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,
	0x18,0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,
	0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,
	0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,
	0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,
	0x38,0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,
	0x40,0x41,0x43,0x44,0x45,0x47,0x49,0x4A,
	0x4B,0x4C,0x4E,0x4F,0x50,0x51,0x52,0x53,
	0x55,0x56,0x57,0x58,0x59,0x5A,0x5C,0x5D,
	0x5E,0x5F,0x61,0x28,0x2F,0x29,0x5E,0x5F,
	0x60,0x41,0x43,0x44,0x45,0x47,0x49,0x4A,
	0x4B,0x4C,0x4E,0x4F,0x50,0x51,0x52,0x53,
	0x55,0x56,0x57,0x58,0x59,0x5A,0x5C,0x5D,
	0x5E,0x5F,0x61,0x28,0x2F,0x29,0x7E,0x7F,
	0x44,0x5B,0x48,0x42,0x42,0x42,0x42,0x44,
	0x48,0x48,0x48,0x4D,0x4D,0x4D,0x42,0x42,
	0x48,0x63,0x63,0x54,0x64,0x54,0x5B,0x5B,
	0x60,0x64,0x5B,0x54,0x24,0x54,0x9E,0x24,
	0x42,0x4D,0x54,0x5B,0x52,0x52,0x41,0x54,
	0x3F,0xA9,0xAA,0xAB,0xAC,0x21,0x22,0x22,
	0xB0,0xB1,0xB2,0xB3,0xB4,0x42,0x42,0x42,
	0xB8,0xB9,0xBA,0xBB,0xBC,0x24,0x24,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0x42,0x42,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0x24,
	0x46,0x46,0x48,0x48,0x48,0x4C,0x4D,0x4D,
	0x4D,0xD9,0xDA,0xDB,0xDC,0xDD,0x4D,0xDF,
	0x54,0x43,0x54,0x54,0x54,0x54,0xE6,0x62,
	0x62,0x5B,0x5B,0x5B,0x60,0x60,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};

// sortSF850
unsigned char sortSF850[] =
{
	0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,
	0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF,
	0x00,0xA5,0xA8,0x85,0xB9,0x86,0x87,0xA9,
	0xAA,0xAB,0x88,0x9E,0xAC,0xAE,0xAF,0xB0,
	0x75,0x76,0x78,0x7A,0x7C,0x7D,0x7E,0x7F,
	0x80,0x81,0xB1,0xB2,0xA0,0xA1,0xA2,0xB3,
	0x89,0x02,0x12,0x14,0x18,0x1C,0x26,0x28,
	0x2A,0x2C,0x37,0x39,0x3B,0x3D,0x3F,0x43,
	0x51,0x53,0x55,0x57,0x5A,0x5E,0x68,0x6A,
	0x6C,0x6E,0x73,0x8A,0x8B,0x8C,0xBF,0xAD,
	0xBE,0x03,0x13,0x15,0x19,0x1D,0x27,0x29,
	0x2B,0x38,0x2D,0x3A,0x3C,0x3E,0x40,0x44,
	0x52,0x54,0x56,0x58,0x5B,0x5F,0x69,0x6B,
	0x6D,0x6F,0x74,0x8E,0x8F,0x90,0xC1,0x9D,
	0x16,0x67,0x1F,0x09,0x0B,0x07,0x0F,0x17,
	0x23,0x25,0x21,0x35,0x33,0x31,0x0A,0x0E,
	0x1E,0x11,0x10,0x4A,0x4C,0x48,0x65,0x63,
	0x72,0x4B,0x66,0x50,0xB8,0x4F,0xA4,0xBC,
	0x05,0x2F,0x46,0x61,0x42,0x41,0x95,0x94,
	0xB4,0x9A,0x9C,0x83,0x82,0xA6,0xB5,0xB6,
	0xCF,0xD0,0xD1,0xCE,0xCC,0x04,0x08,0x06,
	0x99,0xD2,0xD3,0xD4,0xD5,0xBA,0xBB,0xC6,
	0xC5,0xCA,0xC9,0xCB,0xCD,0xC8,0x0D,0x0C,
	0xD6,0xD7,0xD8,0xD9,0xDA,0xDB,0xDC,0xB7,
	0x1B,0x1A,0x22,0x24,0x20,0x36,0x2E,0x32,
	0x34,0xC7,0xC4,0xDF,0xDD,0x9B,0x30,0xDE,
	0x45,0x59,0x49,0x47,0x4E,0x4D,0x92,0x5C,
	0x5D,0x60,0x64,0x62,0x71,0x70,0x91,0xBD,
	0xA7,0x9F,0x8D,0x84,0x97,0x96,0xA3,0xC2,
	0x93,0xC0,0xC3,0x77,0x7B,0x79,0x98,0x01
};

// sortSF437
unsigned char sortSF437[] =
{
	0x01,0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,
	0xCF,0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,
	0xD7,0xD8,0xD9,0xDA,0x8C,0x8D,0xDB,0xDC,
	0xDD,0xDE,0xDF,0xE0,0xE1,0xE2,0xE3,0xE4,
	0x01,0x3C,0x3D,0x3E,0x3F,0x40,0x41,0x42,
	0x43,0x44,0x45,0x46,0x47,0x48,0x49,0x4A,
	0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,
	0x28,0x29,0x4B,0x4C,0x4D,0x4E,0x4F,0x50,
	0x51,0x02,0x03,0x04,0x05,0x07,0x08,0x09,
	0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,0x10,0x12,
	0x13,0x14,0x15,0x16,0x18,0x1A,0x1B,0x1C,
	0x1D,0x1E,0x1F,0x52,0x53,0x54,0x34,0x55,
	0x33,0x02,0x03,0x04,0x05,0x07,0x08,0x09,
	0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,0x10,0x12,
	0x13,0x14,0x15,0x16,0x18,0x1A,0x1B,0x1C,
	0x1D,0x1E,0x1F,0x56,0x57,0x58,0x36,0x59,
	0x04,0x1A,0x07,0x02,0x02,0x02,0x02,0x04,
	0x07,0x07,0x07,0x0B,0x0B,0x0B,0x02,0x02,
	0x07,0x02,0x02,0x12,0x12,0x12,0x1A,0x1A,
	0x1E,0x12,0x1A,0x6F,0x5A,0x70,0x96,0x5C,
	0x02,0x0B,0x12,0x1A,0x11,0x11,0x02,0x12,
	0x5D,0x97,0x5F,0x60,0x61,0x62,0x63,0x64,
	0x65,0x66,0x67,0x68,0x69,0x98,0x99,0x9A,
	0x9B,0x6B,0x6C,0x6D,0x6E,0x9C,0x9D,0x71,
	0x72,0x73,0x74,0x75,0x76,0x77,0x9E,0x9F,
	0x78,0x79,0x7A,0x7B,0x7C,0x7D,0x7E,0xA0,
	0xA1,0xA2,0xA3,0xA4,0xA5,0xA6,0xA7,0xA8,
	0xA9,0x80,0x81,0x82,0x83,0xAA,0xAB,0x85,
	0xAC,0x17,0xAD,0xAE,0xAF,0xB0,0x86,0xB1,
	0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,0xB8,0xB9,
	0xBA,0x89,0xBB,0xBC,0xBD,0xBE,0x8E,0xBF,
	0x8F,0xC0,0x90,0xC1,0xC2,0x93,0x94,0x01
};

// sortDK850
unsigned char sortDK850[] =
{
	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
	0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,
	0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,
	0x18,0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,
	0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,
	0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,
	0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,
	0x38,0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,
	0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x28,0x2F,0x29,0x5E,0x5F,
	0x60,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x28,0x2F,0x29,0x7E,0x7F,
	0x43,0x59,0x45,0x41,0x5B,0x41,0x5D,0x43,
	0x45,0x45,0x45,0x49,0x49,0x49,0x5B,0x5D,
	0x45,0x5B,0x5B,0x4F,0x5C,0x4F,0x55,0x55,
	0x59,0x5C,0x59,0x5C,0x24,0x5C,0x9E,0x24,
	0x41,0x49,0x4F,0x55,0x4E,0x4E,0x41,0x4F,
	0x3F,0xA9,0xAA,0xAB,0xAC,0x21,0x22,0x22,
	0xB0,0xB1,0xB2,0xB3,0xB4,0x41,0x41,0x41,
	0xB8,0xB9,0xBA,0xBB,0xBC,0x24,0x24,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0x41,0x41,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0x24,
	0x44,0x44,0x45,0x45,0x45,0x49,0x49,0x49,
	0x49,0xD9,0xDA,0xDB,0xDC,0xDD,0x49,0xDF,
	0x4F,0x53,0x4F,0x4F,0x4F,0x4F,0xE6,0x50,
	0x50,0x55,0x55,0x55,0x59,0x59,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};

// sortDK865
unsigned char sortDK865[] =
{
	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
	0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,
	0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,
	0x18,0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,
	0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,
	0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,
	0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,
	0x38,0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,
	0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x28,0x2F,0x29,0x5E,0x5F,
	0x60,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x28,0x2F,0x29,0x7E,0x7F,
	0x43,0x59,0x45,0x41,0x5B,0x41,0x5D,0x43,
	0x45,0x45,0x45,0x49,0x49,0x49,0x5B,0x5D,
	0x45,0x5B,0x5B,0x4F,0x5C,0x4F,0x55,0x55,
	0x59,0x5C,0x59,0x5C,0x24,0x5C,0x24,0x24,
	0x41,0x49,0x4F,0x55,0x4E,0x4E,0x41,0x4F,
	0x3F,0xA9,0xAA,0xAB,0xAC,0x21,0x22,0x24,
	0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,
	0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
	0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,
	0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,
	0xE0,0x53,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,
	0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};

#define sortSU437 sortSV437

// sortSV437 = sortSU437
unsigned char sortSV437[] =
{
	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
	0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,
	0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,
	0x18,0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,
	0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,
	0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,
	0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,
	0x38,0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,
	0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,
	0x60,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x7B,0x7C,0x7D,0x7E,0x7F,
	0x43,0x59,0x45,0x41,0x5C,0x41,0x5B,0x43,
	0x45,0x45,0x45,0x49,0x49,0x49,0x5C,0x5B,
	0x45,0x5C,0x5C,0x4F,0x5D,0x4F,0x55,0x55,
	0x59,0x5D,0x59,0x24,0x24,0x24,0x24,0x24,
	0x41,0x49,0x4F,0x55,0x4E,0x4E,0xA6,0xA7,
	0x3F,0xA9,0xAA,0xAB,0xAC,0x21,0x22,0x22,
	0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,
	0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
	0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,
	0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,
	0xE0,0x53,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,
	0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};

// sortSV850
unsigned char sortSV850[] =
{
	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
	0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,
	0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,
	0x18,0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,
	0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,
	0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,
	0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,
	0x38,0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,
	0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,
	0x60,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x7B,0x7C,0x7D,0x7E,0x7F,
	0x43,0x59,0x45,0x41,0x5C,0x41,0x5B,0x43,
	0x45,0x45,0x45,0x49,0x49,0x49,0x5C,0x5B,
	0x45,0x5C,0x5C,0x4F,0x5D,0x4F,0x55,0x55,
	0x59,0x5D,0x59,0x5D,0x24,0x5D,0x9E,0x24,
	0x41,0x49,0x4F,0x55,0x4E,0x4E,0xA6,0xA7,
	0x3F,0xA9,0xAA,0xAB,0xAC,0x21,0x22,0x22,
	0xB0,0xB1,0xB2,0xB3,0xB4,0x41,0x41,0x41,
	0xB8,0xB9,0xBA,0xBB,0xBC,0x24,0x24,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0x41,0x41,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0x24,
	0x44,0x44,0x45,0x45,0x45,0x49,0x49,0x49,
	0x49,0xD9,0xDA,0xDB,0xDC,0xDD,0x49,0xDF,
	0x4F,0x53,0x4F,0x4F,0x5D,0x5D,0xE6,0xE8,
	0xE8,0x55,0x55,0x55,0x59,0x59,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};

// sortNO850
unsigned char sortNO850[] =
{
	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
	0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,
	0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,
	0x18,0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,
	0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,
	0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,
	0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,
	0x38,0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,
	0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,
	0x60,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x7B,0x7C,0x7D,0x7E,0x7F,
	0x43,0x55,0x45,0x41,0x5B,0x41,0x5D,0x43,
	0x45,0x45,0x45,0x49,0x49,0x49,0x5B,0x5D,
	0x45,0x5B,0x5B,0x4F,0x5C,0x4F,0x55,0x55,
	0x59,0x5C,0x59,0x5C,0x24,0x5C,0x9E,0x24,
	0x41,0x49,0x4F,0x55,0x4E,0x4E,0x41,0x4F,
	0x3F,0xA9,0xAA,0xAB,0xAC,0x21,0x22,0x22,
	0xB0,0xB1,0xB2,0xB3,0xB4,0x41,0x41,0x41,
	0xB8,0xB9,0xBA,0xBB,0xBC,0x24,0x24,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0x41,0x41,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0x24,
	0x44,0x44,0x45,0x45,0x45,0x49,0x49,0x49,
	0x49,0xD9,0xDA,0xDB,0xDC,0xDD,0x49,0xDF,
	0x4F,0x53,0x4F,0x4F,0x4F,0x4F,0xE6,0x50,
	0x50,0x55,0x55,0x55,0x59,0x59,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};

// sortNO865
unsigned char sortNO865[] =
{
	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
	0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,
	0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,
	0x18,0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,
	0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,
	0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,
	0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,
	0x38,0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,
	0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,
	0x60,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x7B,0x7C,0x7D,0x7E,0x7F,
	0x43,0x59,0x45,0x41,0x5B,0x41,0x5D,0x43,
	0x45,0x45,0x45,0x49,0x49,0x49,0x5B,0x5D,
	0x45,0x5B,0x5B,0x4F,0x5C,0x4F,0x55,0x55,
	0x59,0x5C,0x59,0x5C,0x24,0x5C,0x24,0x24,
	0x41,0x49,0x4F,0x55,0x4E,0x4E,0x41,0x4F,
	0x3F,0xA9,0xAA,0xAB,0xAC,0x21,0x22,0x24,
	0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,
	0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
	0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,
	0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,
	0xE0,0x53,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,
	0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};

// sortPO860
unsigned char sortPO860[] =
{
	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
	0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,
	0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,
	0x18,0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,
	0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,
	0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,
	0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,
	0x38,0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,
	0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,
	0x60,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x7B,0x7C,0x7D,0x7E,0x7F,
	0x43,0x55,0x45,0x41,0x41,0x41,0x41,0x43,
	0x45,0x45,0x45,0x49,0x4F,0x49,0x41,0x41,
	0x45,0x41,0x45,0x4F,0x4F,0x4F,0x55,0x55,
	0x49,0x4F,0x55,0x24,0x24,0x55,0x24,0x4F,
	0x41,0x49,0x4F,0x55,0x4E,0x4E,0xA6,0xA7,
	0x3F,0x4F,0xAA,0xAB,0xAC,0x21,0x22,0x22,
	0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,
	0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
	0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,
	0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,
	0xE0,0x53,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,
	0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};

// sortSU850
unsigned char sortSU850[] =
{
	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
	0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,
	0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,
	0x18,0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,
	0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,
	0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,
	0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,
	0x38,0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,
	0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,
	0x60,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x7B,0x7C,0x7D,0x7E,0x7F,
	0x43,0x59,0x45,0x41,0x5C,0x41,0x5B,0x43,
	0x45,0x45,0x45,0x49,0x49,0x49,0x5C,0x5B,
	0x45,0x5C,0x5C,0x4F,0x5D,0x4F,0x55,0x55,
	0x59,0x5D,0x59,0x5D,0x24,0x5D,0x9E,0x24,
	0x41,0x49,0x4F,0x55,0x4E,0x4E,0xA6,0xA7,
	0x3F,0xA9,0xAA,0xAB,0xAC,0x21,0x22,0x22,
	0xB0,0xB1,0xB2,0xB3,0xB4,0x41,0x41,0x41,
	0xB8,0xB9,0xBA,0xBB,0xBC,0x24,0x24,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0x41,0x41,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0x24,
	0x44,0x44,0x45,0x45,0x45,0x49,0x49,0x49,
	0x49,0xD9,0xDA,0xDB,0xDC,0xDD,0x49,0xDF,
	0x4F,0x53,0x4F,0x4F,0x4F,0x4F,0xE6,0xE8,
	0xE8,0x55,0x55,0x55,0x59,0x59,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};

// sortJA932
unsigned char sortJA932[] =
{
	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
	0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,
	0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,
	0x18,0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,
	0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,
	0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,
	0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,
	0x38,0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,
	0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,
	0x60,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x7B,0x7C,0x7D,0x7E,0x7F,
	0x80,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
	0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,
	0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,
	0x81,0x82,0x83,0x84,0x85,0xBD,0x86,0x87,
	0x88,0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F,
	0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,
	0x98,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F,
	0xA0,0xA1,0xA2,0xA3,0xA4,0xA5,0xA6,0xA7,
	0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,
	0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,
	0xB8,0xB9,0xBA,0xBB,0xBC,0xBE,0xBF,0xC0,
	0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,
	0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};

unsigned char sortRU866[] =
{
	0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,
	0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,
	0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,
	0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,
	0x01,0x08,0x10,0x1E,0x19,0x1F,0x1C,0x0F,
	0x11,0x12,0x1A,0x20,0x05,0x04,0x0B,0x0A,
	0x26,0x27,0x28,0x29,0x2A,0x2B,0x2C,0x2D,
	0x2E,0x2F,0x07,0x06,0x21,0x22,0x23,0x09,
	0x18,0x31,0x33,0x35,0x37,0x39,0x3B,0x3D,
	0x3F,0x41,0x43,0x45,0x47,0x49,0x4B,0x4D,
	0x4F,0x51,0x53,0x55,0x57,0x59,0x5B,0x5D,
	0x5F,0x61,0x63,0x13,0x1B,0x14,0x0D,0x02,
	0x0C,0x30,0x32,0x34,0x36,0x38,0x3A,0x3C,
	0x3E,0x40,0x42,0x44,0x46,0x48,0x4A,0x4C,
	0x4E,0x50,0x52,0x54,0x56,0x58,0x5A,0x5C,
	0x5E,0x60,0x62,0x15,0x24,0x16,0x0E,0xAC,
	0x65,0x67,0x69,0x6B,0x6D,0x6F,0x73,0x75,
	0x77,0x79,0x7B,0x7D,0x7F,0x81,0x83,0x85,
	0x87,0x89,0x8B,0x8D,0x8F,0x91,0x93,0x95,
	0x97,0x99,0x9B,0x9D,0x9F,0xA1,0xA3,0xA5,
	0x64,0x66,0x68,0x6A,0x6C,0x6E,0x72,0x74,
	0x76,0x78,0x7A,0x7C,0x7E,0x80,0x82,0x84,
	0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,
	0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,
	0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,
	0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,
	0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,
	0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,
	0x86,0x88,0x8A,0x8C,0x8E,0x90,0x92,0x94,
	0x96,0x98,0x9A,0x9C,0x9E,0xA0,0xA2,0xA4,
	0x71,0x70,0xA7,0xA6,0xA9,0xA8,0xAB,0xAA,
	0x25,0x25,0x25,0xAD,0x1D,0x19,0xF0,0xFF
};


unsigned char leadJA932[] = { 0x81, 0x9F, 0xE0, 0xFC, 0 };

// country code page map
struct
{
	unsigned countryCode;
	cdata * c;
	unsigned codePage;
	unsigned char * upperTable;
	unsigned char * sortTable;
	unsigned char * leadBytes;
} maps[] =
{
	{USA,					&usa,					437, upperUS437, sortUS437},	// 001
	{USA,					&usa,					850, upperUS850, sortUS850},	// 001
	{CANADA,				&canada,				863, upperCF863, sortCF863},	// 002
	{CANADA,				&canada,				850, upperCF850, sortCF850},	// 002
	{LATIN_AMERICA,	&latin_america,	850, upperLA850, sortLA850},	// 003
	{LATIN_AMERICA,	&latin_america,	437, upperLA437, sortLA437},	// 003
	{RUSSIA,				&russia,          437, upperRU437, sortRU437}, // 007
	{RUSSIA,				&russia,          866, upperRU866, sortRU866}, // 007
	{NETHERLANDS,		&netherlands,		850, upperNL850, sortNL850},	// 031
	{NETHERLANDS,		&netherlands,		437, upperNL437, sortNL437},	// 031
	{BELGIUM,			&belgium,			850, upperBE850, sortBE850},	// 032
	{BELGIUM,			&belgium,			437, upperBE437, sortBE437},	// 032
	{FRANCE,				&france,				850, upperFR850, sortFR850},	// 033
	{FRANCE,				&france,				437, upperFR437, sortFR437},	// 033
	{SPAIN,				&spain,				850, upperSP850, sortSP850},	// 034
	{SPAIN,				&spain,				437, upperSP437, sortSP437},	// 034
	{HUNGARY,			&hungary,			852, upperHU852, sortHU852},	// 036
	{HUNGARY,			&hungary,			850, upperHU850, sortHU850},	// 036
	{YUGOSLAVIA,		&yugoslavia,		852, upperYU852, sortYU852},	// 038
	{YUGOSLAVIA,		&yugoslavia,		850, upperYU850, sortYU850},	// 038
	{ITALY,				&italy,				850, upperIT850, sortIT850},	// 039
	{ITALY,				&italy,				437, upperIT437, sortIT437},	// 039
	{SWITZERLAND,		&switzerland, 		850, upperSF850, sortSF850},	// 041
	{SWITZERLAND,		&switzerland, 		437, upperSF437, sortSF437},	// 041
	{CZECHOSLOVAKIA,	&czechoslovakia,	852, upperCZ852, sortCZ852},	// 042
	{CZECHOSLOVAKIA,	&czechoslovakia,	850, upperCZ850, sortCZ850},	// 042
	{UNITED_KINGDOM,	&united_kingdom,	437, upperUK437, sortUK437},	// 044
	{UNITED_KINGDOM,	&united_kingdom,	850, upperUK850, sortUK850},	// 044
	{DENMARK,			&denmark,			850, upperDK850, sortDK850},	// 045
	{DENMARK,			&denmark,			865, upperDK865, sortDK865},	// 045
	{SWEDEN,				&sweden,				437, upperSV437, sortSV437},	// 046
	{SWEDEN,				&sweden,				850, upperSV850, sortSV850},	// 046
	{NORWAY,				&norway,				850, upperNO850, sortNO850},	// 047
	{NORWAY,				&norway,				865, upperNO865, sortNO865},	// 047
	{POLAND,				&poland,				852, upperPL852, sortPL852},	// 048
	{POLAND,				&poland,				850, upperPL850, sortPL850},	// 048
	{GERMANY,			&germany,			850, upperGR850, sortGR850},	// 049
	{GERMANY,			&germany,			437, upperGR437, sortGR437},	// 049
	{BRAZIL,				&brazil,				850, upperBZ850, sortBZ850},	// 055
	{BRAZIL,				&brazil,				437, upperBZ437, sortBZ437},	// 055
	{AUSTRALIA,			&australia,			437, upperAU437, sortAU437},	// 061
	{AUSTRALIA,			&australia,			850, upperAU850, sortAU850},	// 061
	{JAPAN, 				&japan,				932, upperJA932, sortJA932, leadJA932},	// 081
	{PORTUGAL,			&portugal,			850, upperPO850, sortPO850},	// 351
	{PORTUGAL,			&portugal,			860, upperPO860, sortPO860},	// 351
	{FINLAND,			&finland,			850, upperSU850, sortSU850},	// 358
	{FINLAND,			&finland,			437, upperSU437, sortSU437},	// 358
	{0}
};

typedef struct
{
	char infoID;
	char far * table;
} TableReturn;

/*
	Return the address of the Uppercase Table.
*/
char far *	get_uppercase_table(int subfunction)
{
	TableReturn buffer;

	_DI = (unsigned)&buffer;
	_ES = _SS;
	_AX = 0x6500 + subfunction;
	_BX = 0xFFFF;
	_CX = 5;
	_DX = 0xFFFF;
	__int__(0x21);

	return buffer.table;
}

/*
	Return the address of the Collating Table.
*/
char far *	get_collating_table(void)
{
	TableReturn buffer;

	_DI = (unsigned)&buffer;
	_ES = _SS;
	_AX = 0x6506;
	_BX = 0xFFFF;
	_CX = 5;
	_DX = 0xFFFF;
	__int__(0x21);
	return buffer.table;
}

/*
	Return the address of the Lead Byte Table.
*/
char far *	get_lead_bytes(void)
{
	unsigned seg, off;

	_ES = _DS;
	_AX = 0x6300;
	__int__(0x21);
	seg = _DS;
	off = _SI;
	_DS = _ES;
	return MK_FP(seg,off);
}

void do_dos(word ax,word bx,word cx,word dx,word si,word di)
{
	_ES = _DS;
	_AX = ax;
	_BX = bx;
	_CX = cx;
	_DX = dx;
	_SI = si;
	_DI = di;
	geninterrupt(0x21);
}

/*
	Returns the value at "s" and updates
*/
char far *far_atoi(char far *s, int *val)
{
	char c;

	// get the number
	*val = 0;
	while(1)
	{
		c = *s;
		if(!c || c=='\n' || c=='\r' || c==',')
			break;

		if(c>='0' && c<='9')
			*val = (*val) * 10 + (c-'0');

		++s;
	}

	// skip trailing whitespace (and commas)
	while(1)
	{
		c = *s;
		if(!c || c=='\n' || c=='\r')
			break;
		if(c>='0' && c<='9')
			break;
		++s;
	}

	return s;
}

unsigned char leadByteTable[16];
cdata country_data;
void far (*oldfunc)();

/*
	The "s" parameter points to a far string that should
	contain the country code and an optional CodePage.

	Examples:	"COUNTRY.SYS 1,437"
					"COUNTRY.SYS 032"
					"D:\123\COUNTRY.SYS 047 865"

	Returns country code.
	Returns 0 on error (Country/CodePage combo not found).
*/
int set_country_data(char far *s)
{
	int ccode;
	int codepage;
	int i;
	char c;

	/*
		skip device name in string (remember, there may be a full
		path, including the numbers 0-9 in the path).
	*/
	i = 0;
	while(1)
	{
		c = *s;
		if(!c || c=='\r' || c=='\n')
			break;
		if(c==' ' || c=='\t')
			++i;
		if(i && c>='0' && c<='9')
			break;
		++s;
	}

	/* find the country # from the string */
	s = far_atoi(s,&ccode);
	s = far_atoi(s,&codepage);

	// see if we support this country
	for(i=0; maps[i].countryCode; ++i)
	{
		if(ccode == maps[i].countryCode &&
			// no code page specified; use default (1st one in list)
			(!codepage || codepage==maps[i].codePage))
		{
			int len;
			char far * table;

			// get current original case map (function ptr)
			do_dos(0x3800,ccode,0,(unsigned)&country_data,0,0);
			oldfunc = country_data.case_map;
			country_data = *maps[i].c;
			country_data.case_map = oldfunc;

			// use default code page for given country
			if(!codepage)
				codepage = maps[i].codePage;

			// special case: Spain has 2 different currency symbols
			if(ccode == SPAIN && codepage==437)
				*(unsigned *)country_data.currency_symbol = 0x9E;

			// ROM-DOS unique function, 30H extension:
			// AX = 0x30DB
			// BX = country code
			// CX = code page
			// DX = (near) pointer to country data
			// SI = magic number (0xB2D2)
			// DI = subfunction 4 to set country information
			do_dos(0x30DB,ccode,codepage,(unsigned)&country_data,0xB2D2,4);

			// alter the uppercase table (0x6502)
			table = get_uppercase_table(2);
			len = *(unsigned far *)table;
			_fmemcpy(table+2, (void far *) maps[i].upperTable, len);

			// alter the filename uppercase table (0x6504)
			table = get_uppercase_table(4);
			len = *(unsigned far *)table;
			_fmemcpy(table+2, (void far *) maps[i].upperTable, len);

			// alter the collating table (0x6506)
			table = get_collating_table();
			len = *(unsigned far *)table;
			_fmemcpy(table+2, (void far *) maps[i].sortTable, len);

			// update lead byte table
			for(len = 0; len<sizeof(leadByteTable); ++len)
				leadByteTable[len] = 0;
			if(maps[i].leadBytes)
				for(len=0; maps[i].leadBytes[len]; ++len)
					leadByteTable[len] = maps[i].leadBytes[len];
			table = get_lead_bytes();
			_fmemcpy(table, (void far *)leadByteTable, sizeof(leadByteTable));

			break;
		}
	}

	return maps[i].countryCode;
}

#ifdef STANDALONE

char cmdline[66] = "COUNTRY.SYS ";

/*
	Returns country if worked, 0 if failed.
*/
int main(int argc, char *argv[])
{
	int worked;
	if(argc < 2)
	{
		printf("setcntry countryCode[,CodePage]\n"
			"Examples: setcntry 41\n"
			"          setcntry 61,850\n");
		return 0;
	}
	strcat(cmdline,argv[1]);
	worked = set_country_data((void far *)cmdline);
	if(!worked)
		printf("Failed!\n");
	return worked;
}
#endif
