//
//   $Id: DISPLAY.C 1.4 2002/10/15 20:36:54Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*********************************************************

	DISPLAY.C	created 08/02/93	by Kevin Smith

   Copyright (c) 1993-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

	The beginnings of the DOS DISPLAY.SYS driver

	Syntax:

	DEVICE = DISPLAY.SYS codepage

**********************************************************/
#include <dos.h>
#include <fcntl.h>
#include <io.h>
#include <string.h>
#include <stdlib.h>

#include "datalght.h"
#include "dosver.h"
#include "fatworld.h"
#include "display.h"

#ifndef standalone
int errno;
#endif

#define ega 1
#define mcga 2
#define vga 3

#define load8x8	0x01
#define load8x14	0x02
#define load8x16	0x04

extern void print_str(char * text);

bool fIsFat32World;

typedef struct
{
	int codePage;
	int size;
	int filler[6];
} CodePageStruct;

#define DISPLAYSYS 1
#include "dosmsg.c"

unsigned videoType;
unsigned currentCodePage;
unsigned char far * font8x8;
unsigned char far * font8x14;
unsigned char far * font8x16;

typedef struct
{
	unsigned len;
	unsigned codePage;
} QueryCodePage;

typedef unsigned far *	QueryCPList;

typedef struct
{
	int	mode;
	int	points;
	int	rows;
	int	isGraphics;
} ModeFontMap;

ModeFontMap modes[] =
{
	{0x00,	16,	25,	0},
	{0x01,	16,	25,	0},
	{0x02,	16,	25,	0},
	{0x03,	16,	25,	0},
	{0x04,	8,		25,	1},
	{0x05,	8,		25,	1},
	{0x06,	8,		25,	1},
	{0x07,	16,	25,	0},
	{0x08,	8,		25,	1},
	{0x09,	8,		25,	1},
	{0x0A,	8,		25,	1},
	{0x0D,	8,		25,	1},
	{0x0E,	8,		25,	1},
	{0x0F,	14,	25,	1},
	{0x10,	14,	25,	1},
	{0x11,	16,	30,	1},
	{0x12,	16,	30,	1},
	{0x13,	8,		25,	1},
	{-1}
};

int	dos_open(char * fileName, int mode)
{
	union REGS r;
	struct SREGS sr;

	r.h.ah = 0x3D;
	r.h.al = mode;
	sr.ds = FP_SEG(fileName);
	r.x.dx = FP_OFF(fileName);
	r.h.cl = 0;
	intdosx(&r,&r,&sr);
	if (r.x.cflag)
		return -1;
	return r.x.ax;
}

long	dos_lseek(int fd, long offset, int whence)
{
	union REGS r;

	r.h.ah = 0x42;
	r.h.al = whence;
	r.x.bx = fd;
	r.x.cx = (offset >> 16);
	r.x.dx = (offset & 0xFFFF);
	intdos(&r,&r);
	if (r.x.cflag)
		return -1L;
	return ((long)r.x.dx) << 16 + r.x.ax;
}

int	dos_close(int fd)
{
	union REGS r;

	r.h.ah = 0x3E;
	r.x.bx = fd;
	intdos(&r,&r);
	if (r.x.cflag)
		return -1;
	return 0;
}

int	dos_read(int fd, char far * buffer, int len)
{
	union REGS r;
	struct SREGS sr;

	r.h.ah = 0x3F;
	r.x.bx = fd;
	r.x.cx = len;
	sr.ds = FP_SEG(buffer);
	r.x.dx = FP_OFF(buffer);
	intdosx(&r,&r,&sr);
	if (r.x.cflag)
		return r.x.ax;
	return len;
}

#pragma argsused
int memioctl(unsigned category, char far * buffer)
{
	// return true for success; false for failure
	// can set memerr for failure
	return 0;
}

int isdigit(char c)
{
	return (c>='0' && c<='9');
}

int isterminator(unsigned char c)
{
	return (c<=' ' && c!='\t');
}

void	SetInt(unsigned intNum, void far * ptr)
{
	union REGS r;
	struct SREGS sr;
	r.x.ax = 0x2500 + intNum;
	r.x.dx = FP_OFF(ptr);
	sr.ds = FP_SEG(ptr);
	intdosx(&r, &r, &sr);
}

void far * GetInt(unsigned intNum)
{
	union REGS r;
	struct SREGS sr;
	r.x.ax = 0x3500 + intNum;
	intdosx(&r, &r, &sr);
	return MK_FP(sr.es, r.x.bx);
}

void far *	GetFontInfo(unsigned infoType)
{
	void far * ptr = 0;

	switch(infoType)
	{
		case 0:	ptr = GetInt(0x1F);	break;
		case 1:	ptr = GetInt(0x43);	break;
		case 2:	ptr = font8x14;		break;
		case 3:	ptr = font8x8;			break;
		case 6:	ptr = font8x16;		break;
	}

	return ptr;
}

void far *	GetInt43Font(unsigned subfunction)
{
	void far * result = 0;

	switch(subfunction)
	{
		case 0x22:	result = font8x14;	break;
		case 0x23:	result = font8x8;		break;
		case 0x24:	result = font8x16;	break;
	}
	return result;
}

void	SetFont(unsigned subfunction)
{
	unsigned points;
	unsigned fontNum;
	unsigned fontSeg;
	unsigned fontOff;
	unsigned char far * font;
	extern void far * old10;

	fontNum = subfunction & 0x0F;

	switch(fontNum)
	{
		case 1:
			font = font8x14;
			points = 14;
			break;
		case 2:
			font = font8x8;
			points = 8;
			break;
		case 4:
			font = font8x16;
			points = 16;
			break;
	}

	if (font)
		subfunction &= 0xFFF0;

	fontSeg = FP_SEG(font);
	fontOff = FP_OFF(font);

	asm {
		push	BP
		push	ES

		mov	AH, 11H
		mov	AL, subfunction
		mov	BH, points
		mov	BL, 0
		mov	CX, 100H

		mov	DX, fontSeg
		mov	ES, DX
		mov	BP, fontOff

		mov	DX, 0

		pushf
		call	dword ptr CS:[old10]

		pop	ES
		pop	BP
	}
}

void	SetMode(unsigned mode)
{
	int i;

	for (i = 0; modes[i].mode >= 0; ++i)
	{
		ModeFontMap * m = &modes[i];
		if (m->mode == mode)
		{
			switch(m->points)
			{
				case 8:
					if (m->isGraphics)
					{
						SetInt(0x1F, font8x8);
						SetInt(0x43, font8x8);
					}
					else
						SetFont(2);
					break;
				case 14:
					if (m->isGraphics)
						SetInt(0x43, font8x14);
					else
						SetFont(1);
					break;
				case 16:
					if (m->isGraphics)
						SetInt(0x43, font8x16);
					else
						SetFont(4);
					break;
			}
			break;
		}
	}
}

#pragma argsused

int meminit(char far * command, unsigned * lastSeg)
{
	#define DOINSTALL 1
	#define DONTINSTALL 1

	int i;
	int fd;
	int codePageNum;
	union REGS r;
	char buffer[81];
	char codePageStr[11];
	char fileSpec[129];

	//  Determine if we are operating in a DOS 7.1 enviornment
	//
	fIsFat32World = dlIsFat32World();

	strcpy(buffer, string[6]);
	if( fIsFat32World )
	{
		strcat(buffer, SHORTVERSION);
		strcat(buffer, " ");
		strcat(buffer, BUILDVERSION);
	}
	else
	{
		strcat(buffer, SHORTVERSION622);
		strcat(buffer, " ");
		strcat(buffer, BUILDVERSION);
	}
	strcat(buffer, "\r\n$");
	print_str(buffer);

	// first, check to see if we are already installed
	{
		r.x.ax = 0xAD00;
		int86(0x2F, &r, &r);
		if (r.h.al == 0xFF)
		{
			print_str(string[0]);
			return DONTINSTALL;
		}
	}

	// check to see if this is EGA/VGA, and abort if not
	{
		r.x.ax = 0x1A00;
		int86(0x10, &r, &r);
		// if the call worked, note whether it's ega/vga/pga etc...
		if (r.h.al == 0x1A)
		{
			int result = r.h.bl;
			videoType = 0;
			if (result == 4 || result == 5 || result == 6)
				videoType = ega;
			else if (result == 7 || result == 8)
				videoType = vga;
			else if (result == 0x0A || result == 0x0B || result == 0x0C)
				videoType = mcga;
		}
		if (!videoType)
		{
			print_str(string[1]);
			return DONTINSTALL;
		}
	}

	// 8x16 is on VGA and MCGA
	if (videoType != ega)
	{
		font8x16 = MK_FP(*lastSeg, 0);
		*lastSeg += ((256*16) / 16);
	}

	// 8x14 is on EGA and VGA
	if (videoType != mcga)
	{
		font8x14 = MK_FP(*lastSeg, 0);
		*lastSeg += ((256*14) / 16);
	}

	// skip the reference to ourselves, and trailing spaces
	while(!isterminator(*command) && !isdigit(*command))
		++command;
	while (*command == ' ')
		++command;

#ifdef DEBUG
	{
		char temp[100];
		i = 0;
		while (command[i] != 0 && command[i] >= ' ')
		{
			temp[i] = *(command+i);
			++i;
		}
		temp[i++] = '$';
		temp[i++] = 0;
		print_str(temp);
	}
#endif

	// 8x8 is on EGA, VGA and MCGA
	font8x8 = MK_FP(*lastSeg, 0);
	*lastSeg += ((256*8) / 16);

	// skip ahead to the code page number
	while(!isterminator(*command) && !isdigit(*command))
	{
		++command;
	}

	// grab the code page number
	i = 0;
	while (isdigit(*command) && i < 10)
	{
		codePageStr[i++] = *command++;
	}
	codePageStr[i] = 0;
	if (!*codePageStr)
		strcpy(codePageStr, "850");
	codePageNum = atoi(codePageStr);

	while (*command == ' ' || *command == ',')
		++command;

	// skip ahead to the filespec
	// can't have isdigit() blowing off the last of part of filenames
	// like ega3.cpi
	//
	i = 0;
	while(!isterminator(*command) && /*isdigit(*command) &&*/ i < 128)
	{
		fileSpec[i++] = *command++;
	}
#ifndef DEBUG
	fileSpec[i] = 0;
#else
	fileSpec[i++] = '$';
	fileSpec[i] = 0;
	print_str("[$");
	print_str(fileSpec);
	print_str("]$");
#endif

	if (!*fileSpec)
		strcpy(fileSpec, "ega.cpi");

	fd = dos_open(fileSpec, 0);
	strcat(fileSpec, "$");
	if (fd == -1)
	{
		print_str(string[2]);
		print_str(fileSpec);
		print_str("\r\n$");
		return DONTINSTALL;
	}

	{
		int i;
		long offset;
		CPIHeader		header;
		CodePageList	codePageList;

		// read header
		dos_read(fd, (void far *)&header, sizeof(header));
		if (strcmp(header.id, id) != 0)
		{
			print_str(string[3]);
			print_str(fileSpec);
			print_str("\r\n$");
			goto DontInstall;
		}

		// read code page list
		dos_read(fd, (void far *)&codePageList, sizeof(codePageList));

		// Read lower 128 ascii codes into all three sizes
		if (font8x16)
			dos_read(fd, font8x16, 16*128);
		if (font8x14)
			dos_read(fd, font8x14, 14*128);
		if (font8x8)
			dos_read(fd, font8x8, 8*128);

		// locate our area of interest
		for (i = 0; i < header.maxCodePages && codePageList[i]; ++i)
			if (codePageList[i] == codePageNum)
				break;
		if (codePageList[i] != codePageNum)
		{
			print_str(string[4]);
			goto DontInstall;
		}

		offset = header.firstCodePage + (i * header.chunkSize);
		dos_lseek(fd, offset, SEEK_SET);

		// read upper 128 characters
		if (font8x16)
			dos_read(fd, font8x16 + (128*16), 128 * 16);
		if (font8x14)
			dos_read(fd, font8x14 + (128*14), 128 * 14);
		if (font8x8)
			dos_read(fd, font8x8 + (128*8), 128 * 8);

		dos_close(fd);

		strcpy(buffer, string[5]);
		strcat(buffer, codePageStr);
		strcat(buffer, "\r\n$");
		print_str(buffer);

		currentCodePage = codePageNum;

		Install2F();
		Install10();

		// choose our newly installed font
		r.x.ax = 0x1104;
		if (videoType == ega)
			r.x.ax = 0x1101;
		int86(0x10, &r, &r);
	}

	return DOINSTALL;		// go ahead and install us

DontInstall:

	dos_close(fd);
	return DONTINSTALL;	// nope, we failed
}

#ifdef standalone

void print_str(char * text)
{
	printf("%s\n", text);
}

#pragma argsused
void main(int argc, char * argv[])
{
	unsigned dummy;
	meminit(argv[1], &dummy);
//	system("vidtest");
{
	union REGS r;

	r.x.ax = 0x1112;
	r.h.bl = 0;
	int86(0x10, &r, &r);
}
{
	union REGS r;
	struct SREGS sr;

	r.x.ax = 3;
	int86x(0x10, &r, &r, &sr);

}



	Uninstall2F();
	Uninstall10();
}
#endif


#if 0
NOTES:

	Mode uses IOCTL 440C calls to prepare, select, and query code pages
	Presumably KEYB does as well, since it only reports the CON code page
	if DISPLAY.SYS is loaded.  See "PC Interrupts" p. 8-33.

	DISPLAY.SYS calls the "set code page" function of KEYB to establish
	the new typing code page as needed.

	For now, I would prefer a short cut instead of using MODE to prepare
	and select code pages.

#endif
