//
//   $Id: DISPLAY.H 1.4 2002/10/15 20:36:54Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*********************************************************

	DISPLAY.H	created 08/02/93	by Kevin Smith

   Copyright (c) 1993-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

	This file describes the structure of the data in the
	EGA.CPI code page (font bitmap) file.

   The EGA.CPI file is layed out in the following manner:

   [ CPIHeader    ]     defined below
   [ CodePageList ]     defined below
   [ codes 0-127  ]     common bitmaps for ALL code pages
   { codes 128-255 }    the upper 128 character codes look
                        different in each code page.

   Each code table is 128 codes in length, and is layed out
   in the following manner:

	[ font8x16 ]         8 bits wide by 16 high by 128 = 2048 bytes
	[ font8x14 ]         8 bits wide by 14 high by 128 = 1792 bytes
	[ font8x8  ]         8 bits wide by  8 high by 128 = 1024 bytes
	                                                    -----
                                                total   4864 bytes

**********************************************************/
#define MAX_CODE_PAGES 8

typedef struct
{
	char	id[8];			// = "CPIKBS";
	int	chunkSize;		// = 128 codes * (16+14+8 rows) * 1 byte/row
	int	maxCodePages;	// = 8	(multiple of 8, please!)
	long	firstCodePage;	// = sizeof(CPIHeader)+maxCodePages*sizeof(int)+
								//				chunkSize
} CPIHeader;

typedef unsigned CodePageList[MAX_CODE_PAGES];

#define SIZE_FONT16   2048
#define SIZE_FONT14   1792
#define SIZE_FONT8    1024

char id[] = "CPIKBS";

#define FILENAME "EGA.CPI"
