;
;   $Id: VDS.ASM 1.4 2002/10/15 20:39:22Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
comment &
                                        VDS.asm

        This file contains most of the code and data required to
        support VDS.  (Virtual DMA Services)

   Copyright (c) 1994-2002 by Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary
&

.386p

VDS=1           ;set to 0 for no VDS services

_TEXT   segment dword use16 public 'CODE'
assume cs:_TEXT, ds:_TEXT

extrn call_VMM:near,DATA_ZERO_BASE:abs,VMM_chain:word,VMM_fail:near,VMM_suc:near
extrn DATA_0:abs,vds_buff_memk:word,_phys_memptr:dword

ife VDS
public vds_init
vds_init:
        ret

public int_4b_81
int_4b_81:      ;interrupt 4b, function 81 is used for all VDS calls.
        iret

else
physical_addr   dd      0       ;temporary storage for physical address
max_size        dd      0       ;temporary storage for maximum size
vmm_call_chain  dw      0       ;old chain vector

buff_alloc      db      0       ;0 if buffer is available, 1 if in use
error_code      db      0       ;temporary storage for error codes

comment &
        This function must be called to initialize the vds driver.  Currently,
        there are no parameters passed and no return value.  The function
        always succeeds.
&
public vds_init
vds_init:
        pushf
        push    ds
        xor     ax,ax
        mov     ds,ax
        or byte ptr ds:[47bh],32        ;set bit 5 to indicate VDS is available
        cli
        mov     ax,offset vds_prot
        xchg    ax,cs:VMM_chain                 ;hook into the VMM
        mov     cs:vmm_call_chain,ax
        pop     ds
        popf
        ret

comment &
        Automatic remapping is not supported. DMA translation is not
        supported.  Execution arrives here only for interrupt 4bh AND ah =
        81h.
&

public int_4b_81
int_4b_81:      ;interrupt 4b, function 81 is used for all VDS calls.
        push    edi
        push    esi
        push    bp
        mov     bp,sp
        and byte ptr ss:[bp+14],0feh    ;clear the carry flag on the stack
        movzx   bp,al
        sub     bp,2
        jb short func_not_supported     ;jmp if al was 0, or 1
        je short vds_2                  ;jmp if al was 2
        cmp     bp,10
        ja short func_not_supported     ;jmp if al was greater than 0ch
        shl     bp,1                    ;for addressing table of words
        mov     ah,al                   ;vds function number
        mov     al,11h                  ;vmm function number for vds calls
        push    ebx
        xor     ebx,ebx
        mov     bx,ds
        shl     ebx,4                   ;convert selector to offset
        movzx   esi,si
        add     esi,ebx                 ;esi is absolute of ds:si
        xor     ebx,ebx
        mov     bx,es
        shl     ebx,4
        movzx   edi,di
        add     edi,ebx                 ;edi is absolute of es:di
        pop     ebx
        call    call_VMM                ;transfers to vds_prot
;returns CF indicating success or failure
        jnc short vds_success

return_error:
        mov     bp,sp
        or byte ptr ss:[bp+14],1        ;set the carry flag
vds_success:
        pop     bp
        pop     esi
        pop     edi
        iret

func_not_supported:
        mov     al,0fh
        jmp     return_error

vds_2:  ;Get Version, this is real mode code, other funcs are protected mode
        pop     bp
        add     sp,8                    ;pop garbage off stack
        mov     ax,100h                 ;verson 1.0
        mov     bx,'RD'                 ;product ID number, RD for Rom-Dos
        mov     di,4000h                ;max buffer size
        mov     cx,1                    ;product revision number
        xor     dx,dx                   ;flags
        xor     si,si
        iret

vds_jmp_table   dw      offset vds_3
                dw      offset vds_8    ;vds_4 and vds_8 are the same
                dw      offset vds_5
                dw      offset vds_6
                dw      offset vds_7
                dw      offset vds_8
                dw      offset vds_9
                dw      offset vds_a
                dw      offset vds_b
                dw      offset vds_c

vds_prot:       ;if al = 11h, it is a vds call
        cmp     al,11h
        je short vds_call
        jmp word ptr cs:vmm_call_chain          ;chain to next handler
vds_call:
comment &
        Execution arrives here with eax, esi and ebp pushed on the stack.  bp
        contains an index into the vds_jmp_table for the proper handler.  ah
        contains the vds call number (passed in al to the int 4bh handler) edi
        contains a 32 bit pointer equivalent to the original es:di, esi
        contains a 32 bit pointer equivalent to the original ds:si.  Unlike
        other VMM functions, this function may trash some non return
        registers, but only esi, edi and bp.
&
        pop     eax
        pop     esi
        pop     bp                              ;restore all registers
        push    DATA_ZERO_BASE
        pop     es
        push    DATA_0
        pop     ds
        jmp word ptr vds_jmp_table[bp-2]        ;jmp to the proper handler

extended_mem_region:    ;DMA region is entirely in extended memory
;ignore all flags, return success.  esi = physical address
        mov     es:[edi+0ch],esi        ;insert physical address
        pop     ecx
        pop     ebx
        pop     eax
        jmp     prot_suc

vds_3:  ;lock DMA region, dx = flags, edi points to DMA structure
        push    eax
        push    ebx
        push    ecx
        movzx   esi,word ptr es:[edi+8]         ;segment
        shl     esi,4
        add     esi,dword ptr es:[edi+4]        ;add in offset
;esi = start address of desired DMA region
        cmp     esi,(1024+64)*1024      ;check against top of HMA
        mov     error_code,1            ;non-contiguous error code
;jmp if area is entirely in extended memory
        jae     extended_mem_region
        xor     eax,eax
        sub     eax,esi
        mov     max_size,eax            ;start calculating max_size
        movzx   eax,si
        shr     esi,10                  ;convert to offset in page table
        and     si,0fffch               ;4K align
        add     esi,3976*1024           ;add offset of page table
        mov     ecx,es:[esi]            ;first page table entry
        add     esi,4
        and     cx,0f000h               ;clear 12 lsbs
;the high word of eax is already zero, clear all but the 12 lsbs
        and     ah,0fh
        mov     ebx,ecx
        mov     ebp,ecx
        add     ecx,eax                 ;starting physical address in ecx
        mov     physical_addr,ecx
        mov     ecx,es:[edi]            ;size
comment &
        If we add the non-4K aligned bits of the start address with the size
        (which may also have non-4K aligned bits), the rounding operation
        below will indicate exactly how many page comparisons we must make.
        We actually need to be 1 byte less than the sum since we don't
        actually access the address specified by the size + start.  If the
        region does not cross a 4K boundary, we don't need to do any checks.
&
        lea     ecx,[eax+ecx-1]
        shr     ecx,12                  ;calculate number of pages to check
        jz short c_b_okay               ;jmp if no checking is required
;we now need to calculate the comparison value which will be used for checking
;boundary problems.  This value will be stored in ebx and will be compared
;against the page table entries to see if we have crossed a 64K or 128K
;boundary.  ebx currently has the physical address of the first page.
        test    dl,30h
        mov     eax,10000000h           ;256 megabyte boundary checking
        jz short c_b_1                  ;jmp if no boundary checking
        test    dl,10h
        mov     eax,10000h              ;64K boundary checking
        jnz short c_b_1                 ;jmp if 64K checking
        mov     eax,20000h              ;128K boundary checking
c_b_1:
        add     ebx,eax
        dec     eax
        not     eax
        and     ebx,eax                 ;calculate nearest boundary problem
;if we read a page table entry that is >= ebx, we have crossed a boundary.
        cld
c_b_loop:
;check to see if we are over the HMA, treat it as non-contiguous if it is
;over the HMA and don't allocate a buffer.
        cmp     esi,3976*1024+1024+64   ;check against top end of HMA
        jae short c_b_no_buf
        mov     eax,es:[esi]            ;read a page from the page table
        add     esi,4
;check for boundary problems
        cmp     eax,ebx
        jae short c_b_boundary
;check if contiguous
        and     ax,0f000h               ;clear the don't care bits
        sub     ebp,eax
        cmp     ebp,-4096
        mov     ebp,eax                 ;save old entry
        jne short c_b_not_cont          ;jmp if error
        loop    c_b_loop

c_b_okay:
        mov word ptr es:[edi+0ah],0     ;buffer ID
        mov     ecx,physical_addr
        mov     es:[edi+0ch],ecx
        pop     ecx
        pop     ebx
        pop     eax
prot_suc:
        push    bp
        push    esi
        push    eax                     ;restore stack
        jmp     VMM_suc

c_b_boundary:
        mov     error_code,2
c_b_not_cont:
;we will first calculate the maximum size, assuming the current esi is 4 bytes
;over the faulting page table entry.
        sub     esi,3976*1024+4
        shl     esi,10          ;esi is now the highest acceptable address
;max_size currently has the negative of the starting address
        add     max_size,esi    ;calculate max_size
;now check to see if we can use the buffer to avoid returning an error.
        test    dl,4            ;check if we are allowed to use a buffer
        jnz short c_b_no_buf    ;jmp if no buffer allowed
        cmp     buff_alloc,0    ;0 if buffer is available
        mov     error_code,6    ;error code, buffer currently in use
        jne short c_b_no_buf    ;jmp if buffer is allocated
        movzx   ecx,word ptr vds_buff_memk
        shl     ecx,10          ;convert K bytes into bytes
        cmp     ecx,es:[edi]    ;check against requested size
        mov     error_code,5    ;region too large for buffer
        jae short c_b_buf       ;jmp if we can use the buffer
c_b_no_buf:     ;adjust DDS for max_size.
        mov     ecx,max_size
        mov     es:[edi],ecx
vds_3_fail:
        pop     ecx
        pop     ebx
        pop     eax
        mov     al,error_code

prot_fail:
        push    bp
        push    esi
        push    eax                     ;restore stack
        jmp     VMM_fail

c_b_buf:        ;restore registers and allocate the buffer
        pop     ecx
        pop     ebx
        pop     eax
        jmp     vds_7_b

vds_5:  ;lock scatter gather region
        push    eax
        push    ebx
        push    ecx
        push    edx
        push    es
        pop     ds
        movzx   esi,word ptr es:[edi+8]         ;get segment
        shl     esi,4
        add     esi,es:[edi+4]                  ;add offset
        movzx   ebx,si
        and     bh,0fh                          ;save just 12 lsbs
;ebx now has the offset of region in the first page
        sub     esi,ebx
;esi now has the offset of the start of the first page
        shr     esi,10
        add     esi,3976*1024
;esi now points to the first page table entry
        mov     ecx,es:[edi]            ;region size in bytes
        mov     al,dl
        xor     edx,edx                 ;index into EDDS
        test    al,64
        cld
        mov     bp,ds:[edi+0ch]         ;number available
        jnz     page_t_entries          ;jmp if page table entries
;we need to fill in the EDDS in the form of regions and sizes
vds_5_loop1:
        or      bp,bp
        jz short vds_5_insuf_avail      ;check if EDDS is big enough
        db      67h
        lodsd
        and     ax,0f000h               ;clear 12 lsbs
        add     eax,ebx                 ;start address of region
        mov     ds:[edi+edx+10h],eax    ;place start address
        neg     ebx
        add     ebx,4096                ;number of bytes so far
        mov     ds:[edi+edx+14h],ebx    ;initialize size
        sub     ecx,ebx                 ;subtract number of bytes so far
vds_5_loop2:
        jbe short vds_5_done            ;jmp if we are done
        db      67h
        lodsd                           ;get another page table entry
        or      ax,0fffh                ;set the 12 lsbs
        sub     eax,ds:[esi-8]
        and     ax,0f000h               ;clear the 12 lsbs
        cmp     eax,4096                ;check if contiguous
        jne short vds_5_1               ;jmp if not contiguous
        add     ds:[edi+edx+14h],eax    ;add to number of bytes
        sub     ecx,eax
        jmp     vds_5_loop2             ;caution!! preserve flags

vds_5_1:        ;found a non-contiguous point
        sub     si,4                    ;reset back one page table entry
        add     dx,8                    ;okay to use only 16 bit regs here
        dec     bp                      ;remaining size of EDDS
        xor     ebx,ebx                 ;offset into next page
        jmp     vds_5_loop1

vds_5_done:     ;ecx has the negative of the over shoot on size
        add     ds:[edi+edx+14h],ecx    ;adjust the size accordingly
vds_5_done3:
        neg     bp
        inc     bp
        add     bp,ds:[edi+0ch]
        mov     ds:[edi+0eh],bp         ;number used
        pop     edx
        test    dl,64                   ;check if page table entries
        pop     ecx
        jz short restore_bx
;restore high word of ebx, but keep the current value of bx
        pop     ax                      ;pop original bx
        push    bx
restore_bx:
        pop     ebx                     ;restore high word of ebx
        pop     eax
        jmp     prot_suc

vds_5_insuf_avail:      ;EDDS is too small for specified region
        sub     ds:[edi],ecx    ;calculate max size region for this size EDDS
;calculate the number of entries needed for function to succeed, ecx has
;the remaining bytes
vds_5_insuf_avail2:
        add     ecx,4095
        shr     ecx,12                  ;convert bytes to pages
        add     cx,ds:[edi+0ch]         ;add number available entries
        mov     ds:[edi+0eh],cx         ;place number of required in EDDS
        pop     edx
        pop     ecx
        pop     ebx
        pop     eax
        mov     al,9            ;EDDS too small
        jmp     prot_fail

page_t_entries: ;fill in EDDS with page table entries
;bp is the number of available entries
;esi is a pointer to the page table, ebx contains the offset into the
;first page, ecx is the region size in bytes.
        push    edi
        push    bx
        neg     bx
        add     bx,4096
;ebx is now the number of region bytes in first page
        add     edi,10h         ;point to EDDS page table entry
vds_5_loop3:
        db      67h
        lodsd
        and     ax,0f001h       ;clear bits 1 - 11
        db      67h
        stosd
        sub     ecx,ebx         ;calculate bytes left to go
        mov     bx,4096         ;number of bytes in next page
        jbe short vds_5_done2   ;jmp if done
        dec     bp
        jnz     vds_5_loop3     ;loop if space is still available
;the EDDS is too small.
        pop     bx
        pop     edi
        jmp     vds_5_insuf_avail2

vds_5_done2:
        pop     bx
        pop     edi
        jmp     vds_5_done3

vds_6:  ;unlock a scatter/gather locked region
;currently, we indicate success for all calls
        jmp     prot_suc

map_buffer:     ;trashes edi,eax and ecx.  ds must = DATA_0, es must =
                ;DATA_ZERO_BASE.  maps in entire DMA buffer at 1088 K bytes
        mov     edi,3976*1024+1088      ;location for page table entries
        mov     eax,_phys_memptr
        mov     al,7
        mov     cx,vds_buff_memk
        shr     cx,2                    ;convert kbytes to pages
        cld
map_loop:
        db      67h
        stosd
        add     eax,4096
        loop    map_loop                ;map in entire buffer
        ret

vds_7:  ;allocate a DMA buffer
        ;DX contains flags, bit 1 = 1 if data should be copied into buffer
        ;edi points to DDS
        mov     al,6                    ;buffer currently in use
        cmp     buff_alloc,0
        jne     prot_fail
        movzx   esi,vds_buff_memk
        shl     esi,10                  ;convert to bytes
        cmp     esi,es:[edi]            ;check against required size
        mov     al,5                    ;region too large for buffer
        jb      prot_fail
vds_7_b:
        mov     buff_alloc,1            ;allocate the buffer
        mov     esi,_phys_memptr
        mov     es:[edi+0ch],esi        ;insert the physical address of buffer
        mov byte ptr es:[edi+0ah],1     ;Buffer ID
        test    dl,2
        jz      prot_suc
;we must copy data into the buffer.
        push    eax
        push    ecx
        push    ds
        push    edi
        movzx   esi,word ptr es:[edi+8] ;segment
        shl     esi,4                   ;convert segment to offset
        add     esi,es:[edi+4]          ;esi points to source
        call    map_buffer
        push    es
        pop     ds
        pop     edi
        mov     ecx,ds:[edi]            ;size of region
        mov     edi,1088*1024           ;point to buffer
vds_7_a:
        call    move_data
        pop     ds
        pop     ecx
        pop     eax
        jmp     prot_suc

move_data:      ;trashes edi,esi ecx and al
        mov     al,cl                   ;save lsbs
        shr     ecx,2                   ;convert bytes to dwords
        db      67h
        rep     movsd                   ;move the dwords
        mov     cl,al
        and     cl,3                    ;remainder bytes
        db      67h
        rep     movsb                   ;move the bytes
        ret

vds_8:  ;deallocate DMA buffer  (also serves for function 4)
        mov     al,0ah                  ;invalid buffer ID
        cmp word ptr es:[edi+0ah],1     ;check if buffer ID is 1
        ja      prot_fail               ;jmp if invalid buffer ID
;for function 4, a buffer ID of zero means there was no buffer allocated
        jb      prot_suc                ;jmp if no buffer was allocated
;buffer ID was 1
        mov     buff_alloc,0            ;free the buffer
        test    dl,2
        jz      prot_suc
;we must copy data out of the buffer, into the specified DMA region
        push    eax
        push    ecx
        push    ds
        push    edi
        call    map_buffer
        push    es
        pop     ds
        pop     edi
        mov     ecx,ds:[edi]            ;size of region in bytes
        mov     esi,ds:[edi+4]          ;offset
        movzx   edi,word ptr ds:[edi+8] ;segment
        shl     edi,4
        add     edi,esi
        mov     esi,1088*1024
        jmp     vds_7_a

vds_9:          ;copy into DMA buffer
        push    eax
        push    ecx
        push    ds
        push    bx
        push    cx              ;offset into buffer
        push    edi
        call    map_buffer      ;returns with DF = 0
        pop     edi
        push    es
        pop     ds
        movzx   esi,word ptr ds:[edi+8] ;segment
        shl     esi,4
        add     esi,ds:[edi+4]          ;add offset
        mov     ecx,ds:[edi]            ;size to move
        pop     edi                     ;offset into buffer
        lea     eax,[edi+ecx]           ;ending buffer offset
        add     eax,1023
        shr     eax,10                  ;convert to Kbytes
        cmp     ax,cs:vds_buff_memk
        ja short vds_9_e_b              ;jmp if copy past end of buffer
        add     edi,1088*1024           ;point to buffer
        jmp     vds_7_a

vds_9_e_b:      ;copy past end of buffer, return error code 0bh
        mov     al,0bh
        pop     ds
        pop     ecx
        add     sp,2
        push    ax
        pop     eax
        jmp     prot_fail

vds_a:          ;copy out of DMA buffer
        push    eax
        push    ecx
        push    ds
        push    bx
        push    cx              ;offset into dma buffer
        push    edi
        call    map_buffer      ;returns with DF = 0
        push    es
        pop     ds
        pop     edi
        mov     ecx,ds:[edi]                    ;size in bytes
        mov     esi,ds:[edi+4]                  ;offset
        movzx   edi,word ptr ds:[edi+8]         ;segment
        shl     edi,4
        add     edi,esi
        pop     esi                             ;offset into buffer
        lea     eax,[esi+ecx]                   ;ending buffer offset
        add     eax,1023
        shr     eax,10                          ;convert bytes to Kbytes
        cmp     ax,cs:vds_buff_memk
        ja short vds_9_e_b
        add     esi,1024*1088                   ;add offset of buffer
        jmp     vds_7_a

vds_b:  ;disable DMA translation, we don't have any translation

vds_c:  ;enable DMA translation, indicate success even though we don't
        ;have any DMA translation
        jmp     prot_suc

endif   ;if VDS

_TEXT   ends
end
