//
//   $Id: CONVERT.CPP 1.2 2002/10/15 20:43:38Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
   Copyright (c) 1989-1997 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary
*/
#include <fcntl.h>
#include <io.h>
#include <mem.h>
#include <string.h>

#include "display.h"

CPIHeader header;
CodePageList codePageList;

unsigned char font8x16[256*16];
unsigned char font8x14[256*14];
unsigned char font8x8[256*8];

void	Compress(void)
{
	unsigned char * source = font8x16;
	unsigned char * dest8x14 = font8x14;
	unsigned char * dest8x8 = font8x8;

	for (int i=0; i < 256; ++i)
	{
		for (int row = 0; row < 16; ++row)
		{
			unsigned char x = *source++;

			// copy all but rows 13 and 15 into the 8x14 font
			if (row != 13 && row != 15)
				*dest8x14++ = x;

			// copy rows 2, 4, 5, 7, 8, 10, 11, 13 to 8x8 font
			switch(row)
			{
				case 2:
				case 4:
				case 5:
				case 7:
				case 8:
				case 10:
				case 11:
				case 13:		*dest8x8++ = x;	break;
			}
		}
	}
}

void main()
{
	strcpy(header.id, id);
	header.chunkSize = 128 * (16+14+8);
	header.maxCodePages = MAX_CODE_PAGES;
	header.firstCodePage = sizeof(CPIHeader) + 	// skip header
			header.maxCodePages*sizeof(int) +		// skip code page list
			header.chunkSize;								// skip lower 128 chunk

	int fd = _open("vga.cpi", O_RDONLY);
	if (fd != -1)
	{
		_read(fd, font8x16, 256*16);
		int fd2 = _creat(FILENAME, 0);
		if (fd2 != -1)
		{
			// write header
			_write(fd2, &header, sizeof(header));

			// write code page list
			codePageList[0] = 437;
			_write(fd2, &codePageList, sizeof(codePageList));

			// compress 8x16 into the other fonts
			Compress();
						
			// write lower 128 in all three sizes
			write(fd2, font8x16, 128*16);
			write(fd2, font8x14, 128*14);
			write(fd2, font8x8, 128*8);

			// write upper 128 for code page 437 in all three sizes
			write(fd2, font8x16 + 128*16, 128*16);
			write(fd2, font8x14 + 128*14, 128*14);
			write(fd2, font8x8 + 128*8, 128*8);

			_close(fd2);
		}
		_close(fd);
	}
}
