//
//   $Id: DUMPCNT.C 1.2 2002/10/15 20:43:38Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
	Dump Country Info
	This program dumps all the current country information.

   Copyright (c) 1992-1997 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

	DUMPCNT [/noptr]
	/noptr  does not print ptrs, only the info

	Tests the Returns of:

*/
#include <dos.h>

char buff[0x400];
int  noptr;

void error(int errno)
{
	if(errno)
		printf("Error %d\n",errno);
	exit(errno);
}

/*
	Dump a near area of memory
*/
void dump(char *buff, int length)
{
	int start=0, len, i;
	unsigned char *dumpbuf = (unsigned char *)buff;

	while(length>0)
	{
		len = length<16 ? length : 16;
		for(i=0;i<16;++i)
		{
			printf(i<len ? "%02X " : "   ",dumpbuf[start+i]);
			if(i==7)
				printf(i<len ? "| " : "  ");
		}
		printf(" ");
		for(i=0;i<16;++i)
		{
			if(i<len)
				printf(isprint(dumpbuf[start+i]) ? "%c" : ".",dumpbuf[start+i]);
			else
				printf(" ");
		}
		printf("\n");
		length -= len;
		start  += len;
	}
}

/*
	Dump a far area of memory
*/
void fardump(char far *p, int len)
{
	char s[16];
	int i,n;
	while(len>0)
	{
		n = len < 16 ? len : 16;
		for(i=0;i<n;++i)
			s[i]=*p++;
		dump(s,n);
		len-=16;
	}
	printf("\n");
}


void dump_func38(void)
{
	union REGS r;

	/* make sure ALL of the buffer gets set */
	memset(buff,'G',sizeof(buff));

	printf("INT 21H, 3800H - Get Country Info\n");
	r.x.ax = 0x3800;
	r.x.dx = (unsigned)buff;
	intdos(&r,&r);
	if(r.x.cflag)
		error(0x38);

	if(noptr)
	{
		dump(buff, 0x12);
		dump(buff+0x16,2+10);
	}
	else
		dump(buff, 0x18+10);
}

void print_table(void)
{
	char far * p;
	int len;
	char id;

	id = buff[0];
	p  = MK_FP(*(unsigned *)(buff+3),*(unsigned *)(buff+1));
	len= *(int far *)p;

	printf("id %d",id);
	if(!noptr)
		printf(", ptr %04X:%04X",FP_SEG(p),FP_OFF(p));
	printf("\nlen = %X\n",len);
	fardump(p+2, len);
}

void main(int argc, char *argv[])
{
	union REGS r;
	struct SREGS sr;
	char far * p;
	int len;

	/* look for command line parameters (for test suite purposes) */
	if(argc > 1 && (*argv[1]=='/' || *argv[1]=='-'))
		noptr = 1;

	/* Get Current Country Info */
	dump_func38();

	/* Extended country information */
	printf("\nINT 21H, 6501H - Extended Country Info\n");
	memset(buff, 'G', sizeof(buff));
	r.x.ax = 0x6501;
	r.x.bx = -1;
	r.x.cx = 0x400;
	r.x.dx = -1;
	r.x.di = (unsigned)buff;
	_ES = _DS;
	intdos(&r,&r);
	if(r.x.cflag)
		error(1);

	printf("Size %d, Country %d, Code Page %d, Date/Time format %d\n",
		*(unsigned *)(buff+1),
		*(unsigned *)(buff+3),
		*(unsigned *)(buff+5),
		*(unsigned *)(buff+7));
	printf("Currency %c, %c, %c, Date sep %c, Time sep %c, Curr format %d\n",
		buff[9],
		buff[0xE],
		buff[0x10],
		buff[0x12],
		buff[0x14],
		buff[0x16]);
	dump(buff, 0x40);

	/* Extended country uppercase table */
	printf("\nINT 21H, 6502H - Country Uppercase Table\n");
	r.x.ax = 0x6502;
	r.x.bx = -1;
	r.x.cx = 0x400;
	r.x.dx = -1;
	r.x.di = (unsigned)buff;
	_ES = _DS;
	intdos(&r,&r);
	if(r.x.cflag)
		error(2);
	print_table();


	/* Extended country file name table */
	printf("\nINT 21H, 6504H - Country File Name Table\n");
	r.x.ax = 0x6504;
	r.x.bx = -1;
	r.x.cx = 0x400;
	r.x.dx = -1;
	r.x.di = (unsigned)buff;
	_ES = _DS;
	intdos(&r,&r);
	if(r.x.cflag)
		error(4);
	print_table();


	if ((_version & 0xFF) >= 5)
	{
		/* Extended country name character table */
		printf("\nINT 21H, 6505H - Country Name Character Table\n");
		r.x.ax = 0x6505;
		r.x.bx = -1;
		r.x.cx = 0x400;
		r.x.dx = -1;
		r.x.di = (unsigned)buff;
		_ES = _DS;
		intdos(&r,&r);
		if(r.x.cflag)
			error(5);
		print_table();
	}


	/* Extended country collating table */
	printf("\nINT 21H, 6506H - Country Collating Table\n");
	r.x.ax = 0x6506;
	r.x.bx = -1;
	r.x.cx = 0x400;
	r.x.dx = -1;
	r.x.di = (unsigned)buff;
	_ES = _DS;
	intdos(&r,&r);
	if(r.x.cflag)
		error(6);
	print_table();


	printf("\nINT 21H, 6300H - Get Lead Byte Table\n");
	r.x.ax = 0x6300;
	intdosx(&r,&r,&sr);
	if (r.x.cflag || r.h.al == 0xFF)
		printf("Function not supported\n");
	else
	{
		p = MK_FP(sr.ds,r.x.si);
		if(!noptr)
			printf("%04X:%04X - ",sr.ds,r.x.si);
		fardump(p, 4);
	}

	error(0);
}
