//
//   $Id: CF863.H 1.4 2002/10/15 20:48:06Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
   Copyright (c) 1989-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary
*/
unsigned char cf863canPrefixList[MAX_CAN_PREFIX] = " aAeEiIoOuUyYcC";

Prefix cf863prefixes[] =
{
    {0x1A, NORMAL, // caret
        {
        '^',
        131,    132,    136,    146,    140,    168,    147,    153,
        150,    158,    0,      0,      0,      0
        }
    },
    {0x1A, SHIFT, // caret
        {
        '^',
        131,    132,    136,    146,    140,    168,    147,    153,
        150,    158,    0,      0,      0,      0
        }
    },
    {0x1B, SHIFT, // umlaut
        {
        164,
        132,    0,      137,    148,    139,    149,    0,      0,
        129,    154,    152,    0,      0,      0
        }
    },
    {0x35, ALTGR, // accent aigue
        {
        161,
        0,      0,      130,    144,    0,      0,      162,    0,
        163,    0,      0,      0,      0,      0
        }
    },
    {0x28, NORMAL, // accent grave
        {
        '`',
        133,    142,    138,    145,    0,      0,      0,      0,
        151,    157,    0,      0,      0,      0
        }
    },
    {0x28, SHIFT, // accent grave
        {
        '`',
        133,    142,    138,    145,    0,      0,      0,      0,
        151,    157,    0,      0,      0,      0
        }
    },
    {0x56, ALTGR, // circle above letter
        {
        248,
        0,      0,      0,      0,      0,      0,      228,    229,
        0,      0,      0,      0,      0,      0
        }
    },
    {0x1B, NORMAL, // cedilla
        {
        0,
        0,      0,      0,      0,      0,      0,      0,      0,
        0,      0,      0,      0,      135,    128
        }
    },
    {0}
};

NormalKey cf863normalKeys[] =
{
    {0x78, ALTGR,  241},
    {0x03, SHIFT,  '"'},
    {0x79, ALTGR,  '@'},
    {0x04, SHIFT,  '/'},
    {0x7A, ALTGR,  156},
    {0x7B, ALTGR,  155},
    {0x7C, ALTGR,  152},
    {0x07, SHIFT,  '?'},
    {0x7D, ALTGR,  170},
    {0x7E, ALTGR,  ';'},
    {0x7F, ALTGR,  166},
    {0x80, ALTGR,  252},
    {0x81, ALTGR,  172},
    {0x82, ALTGR,  171},
    {0x83, ALTGR,  173},
    {0x18, ALTGR,  21},
    {0x19, ALTGR,  134},
    {0x1A, ALTGR,  '['},
    {0x1B, ALTGR,  ']'},
    {0x28, SHIFT,  '{'},
    {0x29, NORMAL, '#'},
    {0x29, SHIFT,  160},
    {0x29, ALTGR,  '\\'},
    {0x2B, NORMAL, '<'},
    {0x2B, SHIFT,  '>'},
    {0x2B, ALTGR,  '}'},
    {0x33, NORMAL, ','},
    {0x33, SHIFT,  39},
    {0x33, ALTGR,  167},
    {0x34, NORMAL, '.'},
    {0x34, SHIFT,  '.'},
    {0x56, NORMAL, 174},
    {0x56, SHIFT,  175},
    {0}
};

NormalKey cf863letters[] =
{
    {0x35, NORMAL, 130},
    {0x35, SHIFT,  144},
    {0}
};

NormalKey cf863numbers[] =
{
    {0}
};
