//
//   $Id: GR437.H 1.4 2002/10/15 20:48:06Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
   Copyright (c) 1989-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary
*/
unsigned char gr437canPrefixList[MAX_CAN_PREFIX] = " aAeEiIoOuUyY";

Prefix gr437prefixes[] =
{
	//	key,	shift,
	//		<space>
	//		a		A		e		E		i		I		o		O
	//		u		U		y		Y
	//
	{0x29, NORMAL,	// caret
		{
			'^',
			131,	0,		0,		0,		140,	0,		147,	0,
			150,	0,		0,		0
		}
	},
	{0x0D, NORMAL,	// apostrophe
		{
			239,
			160,	0,		130,	144,	161,	0,		162,	0,
			163,	0,		236,	0
		}
	},
	{0x0D, SHIFT,	// back-apostrophe
		{
			'`',
			133,	0,		138,	0,		141,	0,		149,	0,
			151,	0,		0,		0
		}
	},
	{0}
};

NormalKey gr437normalKeys[] =
{
	{0x79, ALTGR,	253},		// Alt-2
	{0x7A, ALTGR,	252},		// Alt-3
	{0x7E, ALTGR,	123},		// Alt-7
	{0x7F, ALTGR,	91},			// Alt-8
	{0x80, ALTGR,	93},			// Alt-9
	{0x81, ALTGR,	125},		// Alt-0
	{0x82, ALTGR,	92},			// Alt--
	{0x10, ALTGR,	64},
	{0x1b, ALTGR,	126},
	{0x32, ALTGR,	230},
	{0x15, ALT,		0x2C},		// Alt-Y
	{0x2C, ALT,		0x15},		// Alt-Z
	{0x03, SHIFT,	'"'},
	{0x04, SHIFT,	21},
	{0x07, SHIFT,	'&'},
	{0x08, SHIFT,	'/'},
	{0x09, SHIFT,	'('},
	{0x0A, SHIFT,	')'},
	{0x0B, SHIFT,	'='},
	{0x0C, NORMAL,	225},
	{0x0C, SHIFT,	63},
	{0x15, CTRL,	26},
	{0x1B, NORMAL,	'+'},
	{0x1B, SHIFT,	'*'},
	{0x29, SHIFT,	248},
	{0x2B, NORMAL,	'#'},
	{0x2B, SHIFT,	'\''},
	{0x2C, CTRL,	25},
	{0x33, SHIFT,	';'},
	{0x34, SHIFT,	':'},
	{0x35, NORMAL,	'-'},
	{0x35, SHIFT,	'_'},
	{0x56, NORMAL,	'<'},
	{0x56, SHIFT,	'>'},
	{0x56, ALTGR,	'|'},
	{0}
};

NormalKey gr437letters[] =
{
	{0x15, NORMAL,	'z'},
	{0x15, SHIFT,	'Z'},
	{0x1A, NORMAL,	129},
	{0x1A, SHIFT,	154},
	{0x2C, NORMAL,	'y'},
	{0x2C, SHIFT,	'Y'},
	{0x27, NORMAL,	148},
	{0x27, SHIFT,	153},
	{0x28, NORMAL,	132},
	{0x28, SHIFT,	142},
	{0}
};

NormalKey gr437numbers[] =
{
	{0x53, SHIFT, ','},
	{0}
};
