;
;   $Id: KEYB3.ASM 1.4 2002/10/15 20:48:06Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;   Copyright (c) 1991-2002 Datalight, Inc.
;   All Rights Reserved.
;   Datalight Confidential and Proprietary
include macros.inc

STACKSIZE = 2048	; stack space for stack hogs

cBegUdata
	extrn	stacktop:word
	extrn	_psp:word
	extrn	_internalData:unknown

	funcptr	 dw	?
	oldstack dd	?
	doneInit db	?
	stackCount db	?

	public _errno
	_errno	dw	?

cEndUdata

cBegCode

	extrn	_IsEuroCaps:near

	active	dw	0
	old16	dd	?
	old2F	dd	?
	old15	dd	?
	pInternalData	dd ?



comment ~

 This is entry point to the int 16h handler. It mostly just calls
 GetTranslatedKey (in keyb.c) and returns the key it gets from
 that function. Note that GetTranslatedKey actually does the translations
 of all keystrokes.

end_comment ~
	public handler16
handler16:

	; pass the call through?
	pushf

;	cmp	CS:[active],1
;	jz	notrap16

	cmp	AH, 1
	jbe	trap16
	cmp	AH, 10H
	je	trap16
	cmp	AH, 11H
	je	trap16

notrap16:
	popf
	jmp	dword ptr CS:[old16]

	; save all register that we'll change
trap16:
	mov	CS:[active],1
	popf
	push	DS
	push	ES
	push	BX
	push	CX
	push	DX

	; get our data
	mov	CX, DGROUP
	mov	DS, CX

	; save user command
	mov	CX, AX

	call	UseOurStack			; destroys AX and BX

	; restore user command
	mov	AX, CX

	; save user command on stack
	push	AX

	; get to the C program
	mov	AL, AH
	xor	AH, AH
	push	AX
	call	word ptr [funcptr]
	pop	CX

	; get original command in CX
	pop	CX

	; save return value in DX
	mov	DX, AX

	; restore original stack
	call	UseOldStack			; destroys AX

	; restore return value
	mov	AX, DX

	; for check calls, set or clear Zero Flag
	test	CH, 1
	jz	donetrap
	mov	BX, SP
	cmp	AX, -1
	jnz	clearZero
	or	word ptr SS:[BX+14], 40H	; set zero
	mov	AX, CX
	jmp	short donetrap
clearZero:
	and	word ptr SS:[BX+14], 0FFBFH	; clear zero

	; pop registers and return
donetrap:
	pop	DX
	pop	CX
	pop	BX
	pop	ES
	pop	DS

	mov	CS:[active],0

	iret

	public handler2F
handler2F:

	; pass the call through?
	cmp	AX, 0AD80H
	jz	trap2F
	jmp	dword ptr CS:[old2F]

trap2F:
	mov	AL, 0FFH	; yes KEYB is installed
	mov	BX, 0100H	; version 1.00
	les	DI, pInternalData
	iret


RING_STAT	equ	17h
RING_TAIL	equ	1Ah
RING_HEAD	equ	1Ch
RING_START	equ	1Eh
RING_END	equ	3Eh

BIOSSEG		equ	40h

CTRLBIT		equ	4
ALTBIT		equ	8
CAPSBIT		equ	40h
LEFTALTBIT	equ	200h

LSHIFTSCAN	equ	2Ah
RSHIFTSCAN	equ	36h
CAPSSCAN	equ	3Ah

EUROSCAN	equ	56h
EUROASC		equ	0
SEMISCAN	equ	27h
SEMIASC		equ	0

CFLAG		equ	1


comment ~

 This is a handler for the software interrupt generated by the BIOS
 int 9h hardware keyboard interrupt handler. Its purpose is to allow
 the O/S to qualify a keystroke (change it/discard it/preempt it...).
 In this program we use this interrupt to stuff magic cookies into
 the BIOS keyboard buffer which are later translated by the
 GetTranslatedKey function (in keyb.c.) which is called by the int 16h
 handler above. Magic cookies are needed for the additional key on the
 European keyboard in the AltGr shift state as well as for the
 "semi-colon" key in the Ctrl shift state. These keys are not handled
 by the keyboard BIOS (which uses US translation tables).

end_comment ~
		public handler15
handler15:
	pushf
	cmp	AH, 04Fh
	jnz	PassThrough

	; if it's a Euro-Key press, check for special casing the AltGr
	cmp	al, EUROSCAN
	jne	NotEuroKey
	jmp	HandleEuroKey

NotEuroKey:
	; if it's a semi-colon, check for special casing the Ctrl
	cmp	al, SEMISCAN
	jne	NotSemicolon
	jmp	HandleSemicolon

NotSemicolon:
	; if it's a shift downpress, turn off caps lock
	cmp	AL, LSHIFTSCAN
	jz	TurnOffCaps
	cmp	AL, RSHIFTSCAN
	jz	TurnOffCaps

	; if it's a capslock downpress, turn on caps lock
	cmp	AL, CAPSSCAN
	jnz	PassThrough

	; turn on caps lock status and shift
	call	CheckEuroCaps
	jz	PassThrough

	push	ES
	push	AX
	mov	AX, BIOSSEG
	mov	ES, AX
	or	byte ptr ES:[RING_STAT], CAPSBIT

	pop	AX
	pop	ES

	popf			; remove our push from the stack

	push	BP		; clear carry
	mov	BP, SP
	and	word ptr [BP+6], NOT CFLAG
	pop	BP
	iret

TurnOffCaps:
	; turn off caps lock
	call	CheckEuroCaps
	jz	PassThrough

	push	ES
	push	AX
	mov	AX, BIOSSEG
	mov	ES, AX
	and	byte ptr ES:[RING_STAT], NOT CAPSBIT
	pop	AX
	pop	ES

PassThrough:
	popf
	jmp	dword ptr CS:[old15]

CheckEuroCaps:
	; Returns with Z SET if normal Capslock; NZ if euro caps lock
	push	DS
	push	AX
	push	BX
	push	CX
	push	DX

	; get our data
	mov	CX, DGROUP
	mov	DS, CX

	call	UseOurStack			; destroys AX and BX

	call	_IsEuroCaps

	; save result
	mov	DX, AX

	; restore original stack
	call	UseOldStack			; destroys AX

	; SET Z if FALSE, CLEAR Z if TRUE
	cmp	DX, 0

	pop	DX
	pop	CX
	pop	BX
	pop	AX
	pop	DS
	ret

HandleEuroKey:
	; Get the status byte (shift state)
	push	ax
	call	GetShiftState

	; Is one of the ALT keys pressed?
	test	al, ALTBIT
	jnz	euro_alt

	; Nope, not our key!
	pop	ax
	jmp	PassThrough
euro_alt:
	; An ALT is pressed.  Is it ALTGR?
	test	ax, LEFTALTBIT
	jz	euro_altgr

	; Nope, skip it!
	pop	ax
	jmp	PassThrough
euro_altgr:
	pop	ax

	; Okay, this is ours, ALTGR+Euro key. Stuff our key into
	; the ring buffer
	mov	ah, EUROSCAN
	mov	al, EUROASC
	call	StuffKey

	jmp	short setcarryexit

HandleSemicolon:
	; Get the status byte (shift state)
	push	ax
	call	GetShiftState

	; Is one of the CTRL keys pressed?
	test	al, CTRLBIT
	jnz	semi_ctrl

	; Nope, not our key!
	pop	ax
	jmp	PassThrough
semi_ctrl:
	; CTRL+; is pressed, stuff a ';' into the ring buffer
	pop	ax
	mov	ah, SEMISCAN
	mov	al, SEMIASC
	call	StuffKey

setcarryexit:

	; Return the key in AX
	xchg	ah, al

	; Restore earlier pushf
	popf

	; Indicate that we've handled the key
	push	BP
	mov	BP, SP
	and	word ptr [BP+6], NOT CFLAG
	pop	BP
	iret


StuffKey:
	push	es
	push	bx
	push	ax

	; Load ES with the BIOS data seg
	mov	bx, BIOSSEG
	mov	es, bx

	; Store the new key at the head of the ring
	mov	bx, word ptr es:[RING_HEAD]
	mov	word ptr es:[bx], ax

	; Increment the buffer head
	mov	ax, word ptr es:[RING_HEAD]
	inc	ax
	inc 	ax

	;	Be sure we don't overflow the buffer
	cmp	ax, RING_END
	jb	IncHead
	mov	ax, RING_START
IncHead:
	mov	es:[RING_HEAD], ax
	pop	ax
	pop	bx
	pop	es
	ret

GetShiftState:
	push	es
	mov	ax, BIOSSEG
	mov	es, ax
	mov	ax, word ptr es:[RING_STAT]
	pop	es
	ret




COMMENT ~ prototype
void Install16(fnptr);
{}
~
;
c_func	Install16
	push	BP
	mov	BP, SP

	; remember function pointer
	mov	AX, P[BP]
	mov	funcptr, AX

	; save old INT 16H handler
	mov	AX, 3516H
	int	21H
	mov	word ptr CS:[old16], BX
	mov	word ptr CS:[old16+2], ES

	; set new handler (25H, DS:DX)
	push	DS
	mov	AX, CS
	mov	DS, AX
	mov	DX, offset handler16
	mov	AX, 2516H
	int	21H
	pop	DS

	pop	BP
	ret
c_endp	Install16

COMMENT ; prototype
void Uninstall16(void)
{}
;
c_func	Uninstall16
	; set back to old handler
	push	DS
	lds	DX, CS:[old16]
	mov	AX, 2516H
	int	21H
	pop	DS
	ret
c_endp	Uninstall16

COMMENT ; prototype
unsigned Call16(int func)
{}
;
c_func	Call16
	push	BP
	mov	BP, SP

	; call the original INT 16H handler
	mov	AH, P[BP]
	pushf
	call	dword ptr CS:[old16]

	; if CheckKey, look at zero flag
	pushf
	pop	DX
	test	byte ptr P[BP], 1
	jz	notcheck
	test	DL, 40H		; zero bit is true if no characters
	jz	notcheck
	mov	AX, -1		; no characters waiting

notcheck:
	pop	BP
	ret
c_endp	Call16



COMMENT ; prototype
void Install2F(void)
{}
;
c_func	Install2F
	push	BP
	mov	BP, SP

	; save old INT 2FH handler
	mov	AX, 352FH
	int	21H
	mov	word ptr CS:[old2F], BX
	mov	word ptr CS:[old2F+2], ES

	; set new handler (25H, DS:DX)
	push	DS
	mov	AX, CS
	mov	DS, AX
	mov	DX, offset handler2F
	mov	AX, 252FH
	int	21H
	pop	DS

	; set up pointer to data
	mov	word ptr CS:[pInternalData], OFFSET _internalData
	mov	word ptr CS:[pInternalData+2], SEG _internalData

	pop	BP
	ret
c_endp	Install2F

COMMENT ; prototype
void Uninstall2F(void)
{}
;
c_func	Uninstall2F
	; set back to old handler
	push	DS
	lds	DX, CS:[old2F]
	mov	AX, 252FH
	int	21H
	pop	DS
	ret
c_endp	Uninstall2F

COMMENT ; prototype
void Install15(void)
{}
;
c_func	Install15
	push	BP
	mov	BP, SP

	; save old INT 15H handler
	mov	AX, 3515H
	int	21H
	mov	word ptr CS:[old15], BX
	mov	word ptr CS:[old15+2], ES

	; set new handler (25H, DS:DX)
	push	DS
	mov	AX, CS
	mov	DS, AX
	mov	DX, offset handler15
	mov	AX, 2515H
	int	21H
	pop	DS

	; set up pointer to data
	mov	word ptr CS:[pInternalData], OFFSET _internalData
	mov	word ptr CS:[pInternalData+2], SEG _internalData

	pop	BP
	ret
c_endp	Install15

COMMENT ; prototype
void Uninstall15(void)
{}
;
c_func	Uninstall15
	; set back to old handler
	push	DS
	lds	DX, CS:[old15]
	mov	AX, 2515H
	int	21H
	pop	DS
	ret
c_endp	Uninstall15

COMMENT ; prototype
int CheckEnhanced(void)
{}
;
c_func	CheckEnhanced
	; determine if we have an extended keyboard or not
con_init:
	; clear the zero flag and check for key
	mov	AX, 1100H	; Extended check, AL = 0
	cmp	AL, 1		; Always false to clear ZF
	int	16H
	jz	yesext		; if BIOS says no char, believe it
	or	AL, AL
	jz	notext		; if char, but char==0, don't believe it

yesext:
	mov	AX, 1
	ret

notext:
	mov	AX, 0
	ret

c_endp	CheckEnhanced

COMMENT ; prototype
void	UseOurStack(void)
{}
;
public UseOurStack
UseOurStack:

	; don't switch stacks when in our PSP
	cmp	[doneInit], 0
	jnz	init_is_over	; optimization: don't do get PSP calls
	mov	AH, 51H		; when we're done initing.
	int	21H
	cmp	BX, [_psp]
	jz	UsingOurStack
	mov	[doneInit], 1
init_is_over:

	; don't reenter our stack
	cli
	inc	[stackCount]
	cmp	[stackCount], 1
	ja	UsingOurStack

	; remember where to return to
	pop	BX

	; save old stack
	mov	word ptr [oldstack+2], SS
	mov	word ptr [oldstack], SP

	; set up a NEW stack
	mov	AX, DS
	mov	SS, AX
	mov	AX, GOFFSET stacktop
	mov	SP, AX

	; return to the proper place
	push	BX

UsingOurStack:
	sti
	ret


COMMENT ; prototype
void	UseOldStack(void)
{}
;
public UseOldStack
UseOldStack:

	; on our PSP, don't switch stacks
	cmp	[doneInit], 0
	jz	UsingOldStack

	; we've reentered, don't switch stacks
	cli
	dec	[stackCount]
	cmp	[stackCount], 0
	jnz	UsingOldStack

	; remember where to return to
	pop	AX

	; switch back to their stack
	mov	SS, word ptr [oldstack+2]
	mov	SP, word ptr [oldstack]

	; return to the correct place
	push	AX

UsingOldStack:
	sti
	ret



COMMENT ~ ;
/*
   Create a file with a normal attribute.
*/
int dos_creat(char *name)
{}
~
c_func	dos_creat
	push	BP
	mov	BP,SP

	mov	AH,3CH		; CREATE
	mov	CX,0		; file attr
	mov	DX,P[BP]	; pathname
doint21:
	int	21H

	jnc	CR1
	mov	_errno, AX	; PRESERVE ERROR CODE
	mov	AX,-1
	jmp	short xxx

CR1:	mov	_errno, 0
xxx:	pop	BP
	ret
c_endp	dos_creat

COMMENT ~ ;
/*
   Open a file/device.  Returns -1 or the handle.
*/
int dos_open(char *name,int mode)
{}
~
c_func	dos_open
	push	BP
	mov	BP,SP

	mov	AH,3DH		; OPEN
	mov	AL,P+2[BP]	; rd/wr mode
	mov	DX,P[BP]	; pathname
	jmp	doint21
c_endp	dos_open


COMMENT ~ ;
/*
   Close a file/device.
*/
void dos_close(int fd)
{}
~
c_func	dos_close
	push	BP
	mov	BP,SP

	mov	AH,3EH		; CLOSE
	mov	BX,P[BP]	; handle
	jmp	doint21
c_endp	dos_close

COMMENT ~ ;
/*
   Read from a file/device.  Returns the # of characters
   read.  "errno" is set if there is an error, cleared otherwise
*/
int dos_read(int fd,char far *buff,unsigned len)
{}
~
c_func	dos_read
	push	BP
	mov	BP,SP
	push	DS

	mov	AH,3FH
rdwr:	mov	BX,P[BP]
	mov	DX,P+2[BP]
	mov	DS,P+4[BP]	; DS:DX = POINTER TO BUFFER
	mov	CX,P+6[BP]
	int	21H

	jnc	rdout
	pop	DS
	mov	_errno, AX	; preserve error code on error
	mov	AX,-1
	pop	BP
	ret

rdout:	pop	DS
	mov	_errno, 0
	pop	BP
	ret
c_endp	dos_read


COMMENT ~ ;
/*
   Write to a file/device.  Returns the # of characters
   written.
*/
int dos_write(int fd,char far *buff,unsigned len)
{}
~
c_func	dos_write
	push	BP
	mov	BP,SP
	push	DS

	mov	AH,40H
	jmp	rdwr
c_endp	dos_write


COMMENT ~ ;
/*
   Seek within a file
*/
long dos_lseek(int fd, long pos, int mode)
{}
~
c_func	dos_lseek
	push	BP
	mov	BP,SP

	mov	AH, 42H		; seek
	mov	BX, P[BP]
	mov	DX, P+2[BP]
	mov	CX, P+4[BP]	; CX:DX = pos
	mov	AL, P+6[BP]	; seek mode
	jmp	doint21
c_endp	dos_lseek

cEndCode
	END
