;
;   $Id: STDOS.ASM 1.4 2002/10/15 20:48:06Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
COMMENT ~
----------------------------------------------------------

   STDOS.ASM  created 08/23/93  by Drew Gislason

   Copyright (c) 1993-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   This startup code works for any utility where size is
   critical.  It is standard "DOS" startup code without
   all the normal trappings of the full blown C library.

   Upon return from main(), checks return code.  A value
   if "TSR" tells the startup to Terminate and Stay
   Resident.

---------------------------------------------------------- ~
include macros.inc

TSR		equ	4000H		; install as a TSR?
STACKSIZE	equ	512


;-----------------------------------------
;	Define SEGMENT ORDERING
;-----------------------------------------
cBegCode
cEndCode

cBegData
cEndData

cBegUdata
begbss	label	word
cEndUdata

	dgroup group endingseg
ENDINGSEG	segment para public 'ENDSEG'
bssend	label	word
ENDINGSEG	ends


;-----------------------------------------
;	Define DATA AREA
;-----------------------------------------
cBegData
	assume ES:DGROUP
	tsrseg	dw	seg ENDINGSEG
cEndData

cBegUdata
	public	_psp, _envseg
	_psp	dw	?
	_envseg	dw	?

	public	stackbottom, stacktop
	stackbottom	db STACKSIZE dup (?)
	stacktop	dw ?

	argc	dw	?
	argv	dw	2 dup (?)
cEndUdata


cBegCode
	extrn	_main:near

_astart:
	; set up a stack
	cli
	mov	DX, DGROUP
	mov	SS, DX
	mov	SP, GOFFSET stacktop
	sti

	; zero BSS
	xor	AL, AL
	mov	ES, DX			; DGROUP from above
	mov	DI, GOFFSET begbss
	mov	CX, offset DGROUP:bssend
	sub	CX, DI
	cld
	rep	stosb

	; DS=ES=SS=DGROUP
	mov	ES:[_psp], DS		; save PSP
	mov	DS, DX			; DGROUP from above

	; push filename on stack (found in environment)
	mov	ES, [_psp]
	mov	ES, ES:[2CH]	; environment segment
	mov	[_envseg], ES
	xor	DI, DI
again:	cmp	word ptr ES:[DI],0	; find end of environment
	jz	end_of_strings
	inc	DI
	jmp	again
end_of_strings:
	add	DI, 4		; skip to filename
	call	push_name	; ES:DI pts to filename, push on stack
	mov	argv, BP	; argv[0]
	mov	argc, 1		; argc = 1 argument so far

	; push command-line on stack
	mov	ES, [_psp]
	mov	DI, 80H
	mov	BL, ES:[DI]	; is there a command line?
	or	BL, BL
	jz	noargs		; no? only 1 arg
	xor	BH, BH
	inc	DI
	mov	byte ptr ES:[DI+BX], 0	; zero terminate the cmdline

skipspaces:
	cmp	byte ptr ES:[DI], ' '	; non-space is first arg
	jnz	foundargs
	cmp	byte ptr ES:[DI], 0	; eol is no args
	jz	noargs
	inc	DI
	jmp	skipspaces		; keep going

foundargs:
	inc	argc
	call	push_name
	mov	word ptr [argv+2], BP	; argv[1]

	; call main(int argc, char *argv[])
noargs:	mov	AX, GOFFSET argv
	push	AX
	push	[argc]
	call	_main

	; do we install a TSR?
	test	AH, (TSR/256)
	jz	terminate

	; don't install TSR if there was an error
	or	AL, AL
	jnz	terminate

	; Terminate and Stay Resident
	mov	DX, [tsrseg]
	sub	DX, [_psp]	; DX contains # of paras
	mov	AX, 3100H
	int	21H
tsr1:	jmp	tsr1

terminate:
	mov	AH, 4CH
	int	21H

	; Borland C 2.0 requires this if main has argv
	public	__setargv__
__setargv__:

t1:	jmp	t1

; On Entry
;   ES:DI = string
; On Exit
;   SS:BP = offset on stack of string
push_name	proc	near
	; remember return address
	pop	BX

	; determine length of string
	mov	SI, DI
	xor	CX, CX
strlen:	cmp	byte ptr ES:[SI], 0
	jz	gotlen
	inc	SI
	inc	CX
	jmp	strlen
gotlen:	inc	CX	; account for 0 terminator

	; get the space on the stack
	mov	BP, CX
	test	BP, 1
	jz	noinc
	inc	BP		; always allocate words on stack
noinc:	sub	SP, BP
	mov	BP, SP		; point SS:BP to memory

	; copy the bytes
	mov	SI, BP		; assume DS=SS
copyb:	mov	AL, ES:[DI]
	mov	DS:[SI], AL
	inc	SI
	inc	DI
	cmp	AL, 0
	jnz	copyb

	; return to caller
	push	BX
	ret
push_name	endp


; void * AllocateBytes(unsigned bytes)
c_func	AllocateBytes
	push	BP
	mov	BP, SP

	; convert bytes requested to paras
	mov	AX, P[BP]
	add	AX, 0FH
	mov	CL, 4
	shr	AX, CL

	; determine start of "current" allocation block
	mov	DX, [tsrseg]
	mov	CX, DS
	sub	DX, CX	; DX = paras from start of DGROUP

	; can we allocate the memory?
	mov	BX, DX
	add	BX, AX
	cmp	BX, 1000H
	jae	nomem		; small model, can't alloc >64K

	; update allocated memory
	mov	CX, DS
	add	BX, CX
	mov	[tsrseg], BX

	; make a pointer out of paras
	mov	AX, DX
	mov	CL, 4
	shl	AX, CL
	jmp	short donemem

	; no? return 0
nomem:	xor	AX, AX

donemem:
	pop	BP
	ret
c_endp	AllocateBytes

cEndCode

	END	_astart

