;
;   $Id: RTC2000.ASM 1.4 2002/10/15 21:19:10Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
COMMENT ~
-----------------------------------------------------------

   RTC2000.ASM  created 03/10/97  by Dennis Edwards
   Copyright (c) 1997-2002 by Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   RTC2000.ASM is the full source to RTC2000.EXE, a DOS device
   drive that can also be run from the command line as a normal
   executable. In the latter case RTC2000 can determine if your
   Real Time Clock (RTC) and/or BIOS has a problem with the year
   2000.

   If your RTC/BIOS does not handle the year 2000 correctly but
   ROM-DOS can accommodate the error then the program will let
   you know. In such cases you may install RTC2000.EXE as a
   device driver in your CONFIG.SYS file instead of using
   ROM-DOS revision 2.50.03 or later.

   When run as a device driver, this program only supports the
   init function and filters int 1Ah.

----------------------------------------------------------- ~
include macros.inc
include dosver.inc


	;[]-------------------------------------[]
	; |		Equates			|
	;[]-------------------------------------[]

CR	equ	13
LF	equ	10

CMDLEN	=	0
UNIT	=	1
CMD	=	2	; cmd code
STATUS	=	3	; status word
MEDIA	=	13
TRANS	=	14	; transfer address
COUNT	=	18	; count for read/write
START	=	20



	;[]-------------------------------------[]
	; |	   SEGMENT Ordering		|
	;[]-------------------------------------[]

cBegCode
cEndCode
cBegData
cEndData
cBegUdata
cEndUdata



	public	strategy,service,ptrsav,cmdtbl
	public	dev2000_init, int1A_handler, old_int1A_handler



COMMENT ^ ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		The Device Header

	Attribute Word Bits
	15	(0=block, 1=char)
	14	(1=ioctl supported)
	 3	(1= CLOCK)
	 2	(1= NUL)
	 1	(1= STDOUT)
	 0	(1= STDIN)

~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ ^

cBegCode


dev2000x:
	dw	-1,-1
	dw	8000H
	dw	offset strategy
	dw	offset service
	db	"DEV2000 "

ptrsav	dd 0	; the pointer to request header
oldstack dd 0	; the stack pointer on the way in here


cmdtbl:
	dw	dev2000_init	; 0  - INIT
	dw	cmd_err		; 1  - MEDIA CHK (reserved for block devs)
	dw	cmd_err		; 2  - BUILD BPB			""
	dw	cmd_err		; 3  - IOCTL INPUT (not enabled)
	dw	cmd_err		; 4  - READ
	dw	cmd_err		; 5  - NON_DESTRUCTIVE READ
	dw	cmd_err		; 6  - INPUT STATUS
	dw	cmd_err		; 7  - INPUT FLUSH
	dw	cmd_err		; 8  - WRITE
	dw	cmd_err		; 9  - WRITE W/ VERIFY
	dw	cmd_err		; 10 - WRITE STATUS
	dw	cmd_err		; 11 - WRITE FLUSH
	dw	cmd_err		; 12 - IOCTL OUTPUT (not enabled)



;-----------------------------------------------------------
;
;	Strategy routine -- sets up ptrsav
;
strat proc far
strategy:
	mov	word ptr cs:[ptrsav],bx
	mov	word ptr cs:[ptrsav+2],es	; ES:BX = packet
	ret
strat endp



;-----------------------------------------------------------
;
;	Service routine must preserve all registers
;
service:
	pushf
	sti
	push	ax
	push	bx
	push	cx
	push	dx
	push	si
	push	di
	push	ds
	push	es

	; save the old stack pointer
	mov	word ptr cs:oldstack+2,ss
	mov	word ptr cs:oldstack,sp

	; get pointer to the header
	lds	bx,cs:[ptrsav]		; DS:BX = packet
	mov	cx,word ptr [bx].COUNT	; CX    = count
	les	di,dword ptr [bx].TRANS	; ES:DI = transfer area

	mov	al,byte ptr [bx].CMD	; get the command
	cbw
	mov	si,offset cmdtbl	; get a code ptr into function
	add	si,ax
	add	si,ax
	cmp	al,12
	ja	cmd_err

	; set up a C usable stack and DGROUP
	mov	ax,DGROUP
	mov	ds,ax
	cli
	mov	ss,ax
	mov	sp,GOFFSET stacktop
	sti

	jmp	word ptr cs:[si]	; do the command


;----------------------------------------------------------------------
;
;		Exit Routines
;
cnt_exit:
	lds	bx,cs:[ptrsav]
	mov	word ptr [BX+COUNT], AX
	jmp	short exit

busy_exit:
	mov	ah,3H		; mark as busy
	jmp	short err1

cmd_err:
	mov	al,3		; unknown command

err_exit:
	mov	ah,81H		; mark as error
	jmp	short err1

exitp	proc	far
exit:
	mov	ah,1H
err1:
	lds	bx,cs:[ptrsav]
	mov	word ptr [bx].STATUS,ax		; return the status


	; restore the old stack pointer
	cli
	mov	ss,word ptr cs:oldstack+2
	mov	sp,word ptr cs:oldstack
	sti

	pop	es
	pop	ds
	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	popf
	retf
exitp 	endp


old_int1A_handler	label	dword
	old_1A_offs	dw	offset int1A_handler
	old_1A_segm	dw	@curseg

	public	int1A_handler
int1A_handler	proc	far
	cmp	ah, 0        			; tick read?
	je	I1A_handle_tick_read
	cmp	ah, 4				; RTC date read?
	je	I1A_handle_RTC_date_read
	jmp	dword ptr cs:old_int1A_handler

    I1A_handle_tick_read:
	pushf
	call	dword ptr cs:old_int1A_handler
	cmp	al, 0				; if no roll-over, done
	je	I1A_exit

	push	ax				; save BIOS tick info
	push	cx
	push	dx

	mov	ah, 4				; get date from RTC
	pushf
	call	dword ptr cs:old_int1A_handler
	cmp	cx, 1900h                      	; if 1900 then its 2000
	jne	I1A_not_2000

	mov	ah, 5				; make it so
	mov	cx, 2000h
	mov	dx, 101h
	pushf
	call	dword ptr cs:old_int1A_handler

    I1A_not_2000:
	pop	dx				; get back tick info
	pop	cx
	pop	ax
	jmp	short I1A_exit			; and give it to user

    I1A_handle_RTC_date_read:
	pushf
	call	dword ptr cs:old_int1A_handler
	cmp	cx, 1900h                      	; get RTC date, if not 1900
	jne	I1A_exit			; then we're done

	mov	ah, 5				; else make it 2000
	mov	cx, 2000h
	mov	dx, 101h
	pushf
	call	dword ptr cs:old_int1A_handler

	mov	ah, 4				; and read it back
	pushf
	call	dword ptr cs:old_int1A_handler

    I1A_exit:
	iret                                    ; return result of int 1A
int1A_handler	endp


;----------------------------------------------------------------------
;
;		Write a String to Console (BIOS INT 10H)
;
;		Assumes string is in CS:[SI]
;		note: preserves all registers
write_string proc near
	push	ax		; save the registers used
	push	bx
	push	si

wrstr:
	mov	al,cs:[si]	; get byte
	cmp	al,0
	jz	ws_done
	mov	ah,14
	mov	bh,0
	int	10H		; write it out to the BIOS
	inc	si
	jmp	wrstr

ws_done:
	pop	si		; restore registers
	pop	bx
	pop	ax
	ret
write_string endp

initmsg		db CR,LF,"Installing RTC year 2000 device "
		db FULLVERSION,CR,LF,0

;---------------------------------------------------------
;
;		FUNCTION 0  -  INIT DEVICE
;
;	DS    = dgroup
;	ES:DI = transfer area
;	CX    = count
;
dev2000_init:

	; sign on message
	mov	si,offset initmsg
	call	write_string

	; It could happen that the RTC rolled over while the machine was
	; off and that the BIOS didn't handle that. When MS-DOS (or an
	; old ROM-DOS) sees the date as 1900 it will change it to 1980.
	; If we see the RTC as 1900 when we init() then we need to change
	; both the RTC and DOS' date to ?/?/2000.
	;
	mov	ah, 4				; get date from RTC
	int	1Ah
	cmp	cx, 1900h                      	; if 1900 then its 2000
	jne	d2000_keep

	mov	ah, 5				; make it so
	mov	cx, 2000h
	push	cx
	push	dx
	int 	1Ah
	pop	dx
	pop	cx
	mov	ax, cx
	call	bcd_to_int
	mov	cx, ax
	xor	ax, ax
	mov	al, dh
	call	bcd_to_int
	mov	dh, al
	xor	ax, ax
	mov	al, dl
	call	bcd_to_int
	mov	dl, al
	mov	ah, 2Bh
	int	21h

	; The clock roll-over fix has been made.
	; No need to go resident.
	;
    d2000_problem_solved:
    	lds	bx, cs:[ptrsav]
	xor	ax, ax
	mov	[bx].UNIT, al
	mov	ax, offset dev2000x
	mov	word ptr [bx].TRANS,   ax
	mov	ax, cs
	mov	word ptr [bx].TRANS+2, ax
	jmp	err_exit

	; Century hasn't changed yet, hook int 1A and go resident.
	;
    d2000_keep:
	xor	ax, ax
	mov	es, ax
	mov	bx, 1Ah*4
	mov	ax, word ptr cs:old_int1A_handler
	mov	dx, word ptr cs:old_int1A_handler[2]
	cli
	xchg	es:[bx], ax
	xchg	es:[bx][2], dx
	mov	word ptr cs:old_int1A_handler, ax
	mov	word ptr cs:old_int1A_handler[2], dx
	sti

	; save the code segment
	;
    	lds	bx,cs:[ptrsav]		; DS:BX = packet
	mov	word ptr [bx].TRANS,offset end_of_everything
	mov	word ptr [bx].TRANS+2,seg end_of_everything
	jmp	exit


bcd_to_int	proc	near

	push	bx
	push	cx
	push	dx
	push	si
	push	di
	mov	bx, ax

	mov	di, 10d
	xor	ax, ax
	mov	si, ax
	mov	cx, 3

   BCD2I_loop:
	push	cx
	mov	cx, 4
	mov	al, bh
	shr	ax, cl
	shl	bx, cl
	add	ax, si
	mul	di
	mov	si, ax
	pop	cx
	loop	BCD2I_loop

	xor	ax, ax
	mov	cx, 4
	mov	al, bh
	shr	ax, cl
	add	ax, si

	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	bx
	ret
bcd_to_int	endp

cEndCode

; When run from the command line, this routine gets control to
; see determine if the RTC/BIOS has year 2000 problem and, if so,
; if we know how to fix it yet.
;

_LASTSEG	SEGMENT PARA PUBLIC	'LAST'

	 public	end_of_everything, _main

; placeholder to know how big we are
end_of_everything	label	byte

	assume	cs:_LASTSEG, ds:_DATA, es:_DATA
_main:
	mov	ax, seg _DATA
	mov	ds, ax
	mov	es, ax
	lea	di, time

	mov	ah, 4
	int	1Ah
	mov	org_date_cx,cx
	mov	org_date_dx,dx
	mov	ah, 2
	int	1Ah
	mov	org_time_cx,cx
	mov	org_time_dx,dx
	lea	dx, no_RTC_msg
	jnc	RTC_is_there

	mov	ah, 9
	int	21h
	jmp	exe_exit

    RTC_is_there:
	lea	dx, info
	mov	ah, 9
	int	21h

	mov	ah, 8
	int	21h
	or	al, al
	jnz	RTC_do_it
	mov	ah, 8
	int	21h


	; set RTC to 23:59:59 on 12/31/1999
	;
    RTC_do_it:
	mov	ah, 05h
	mov	ch, 19h
	mov	cl, 99h
	mov	dh, 12h
	mov	dl, 31h
	int	1Ah

	mov	ch, 23h
	mov	cl, 59h
	mov	dh, 59h
	mov	ah, 3
	int	1Ah

	lea	dx, time_set_msg
	mov	ah, 9
	int	21h
	lea	dx, waiting_msg
	mov	ah, 9
	int	21h

	; wait for RTC time to come back with hour EQ 0
	;
    top:
	lea	dx, tick
	mov	ah, 9
	int	21h
	xor	cx, cx

    looper:
	loop	looper

	mov	ah, 2
	int	1Ah
	or	ch, ch
	jnz	top

	; The RTC has rolled over. Print out the time.
	;
    new_day:
	mov	ax, cx
	mov	cl, 4

	push	ax
	mov	al, ah
	shr	ah, cl
	and	ax, 0F0Fh
	or	ax, 3030h
	xchg	ah, al
	cld
	stosw
	inc	di

	pop	ax
	mov	ah, al
	shr	ah, cl
	and	ax, 0F0Fh
	or	ax, 3030h
	xchg	ah, al
	cld
	stosw
	inc	di

	mov	al, dh
	mov	ah, dh
	shr	ah, cl
	and	ax, 0F0Fh
	or	ax, 3030h
	xchg	ah, al
	cld
	stosw

	; Read and print out the RTC date
	;
	lea	di, date
	mov	ah, 4
	int	1Ah
	mov	ax, cx
	push	cx

	push	ax
	mov	cl, 4
	mov	al, dh
	mov	ah, dh
	shr	ah, cl
	and	ax, 0F0Fh
	or	ax, 3030h
	xchg	ah, al
	cld
	stosw
	inc	di

	mov	al, dl
	mov	ah, dl
	shr	ah, cl
	and	ax, 0F0Fh
	or	ax, 3030h
	xchg	ah, al
	cld
	stosw
	inc	di

	pop	ax
	push	ax
	mov	al, ah
	shr	ah, cl
	and	ax, 0F0Fh
	or	ax, 3030h
	xchg	ah, al
	cld
	stosw

	pop	ax
	mov	ah, al
	shr	ah, cl
	and	ax, 0F0Fh
	or	ax, 3030h
	xchg	ah, al
	cld
	stosw
	inc	di

	lea	dx, new_time_msg
	mov	ah, 9
	int	21h
	lea	dx, time
	mov	ah, 9
	int	21h

	; Get back the year. If 2000 then all is well.
	;
	pop	ax
	cmp	ah, 20h
	lea	dx, ok_msg
	je	done

	; If 1900 then there is a problem but we can deal with it.
	;
	push	ax
	lea	dx, too_bad_msg
	mov	ah, 9
	int	21h
	pop	ax

	cmp	ax, 1900h
	lea	dx, we_can_help_msg
	je	done

	; If not 2000 or 1900 then we have a problem...
	;
	lea	dx, way_too_bad_msg

	; DS:DX = last string to print
	;
    done:
	mov	ah, 9
	int	21h

	; Restore the original time and display it.
	;
	mov 	ah, 3
	mov	cx, org_time_cx
	mov	dx, org_time_dx
	int	1Ah

	mov	ah, 5
	mov	cx, org_date_cx
	mov	dx, org_date_dx
	int 	1Ah

	lea	di, time
	mov	ah, 2
	int	1Ah
	mov	ax, cx
	mov	cl, 4

	push	ax
	mov	al, ah
	shr	ah, cl
	and	ax, 0F0Fh
	or	ax, 3030h
	xchg	ah, al
	cld
	stosw
	inc	di

	pop	ax
	mov	ah, al
	shr	ah, cl
	and	ax, 0F0Fh
	or	ax, 3030h
	xchg	ah, al
	cld
	stosw
	inc	di

	mov	al, dh
	mov	ah, dh
	shr	ah, cl
	and	ax, 0F0Fh
	or	ax, 3030h
	xchg	ah, al
	cld
	stosw

	lea	di, date
	mov	ah, 4
	int	1Ah
	mov	ax, cx
	push	cx

	push	ax
	mov	cl, 4
	mov	al, dh
	mov	ah, dh
	shr	ah, cl
	and	ax, 0F0Fh
	or	ax, 3030h
	xchg	ah, al
	cld
	stosw
	inc	di

	mov	al, dl
	mov	ah, dl
	shr	ah, cl
	and	ax, 0F0Fh
	or	ax, 3030h
	xchg	ah, al
	cld
	stosw
	inc	di

	pop	ax
	push	ax
	mov	al, ah
	shr	ah, cl
	and	ax, 0F0Fh
	or	ax, 3030h
	xchg	ah, al
	cld
	stosw

	pop	ax
	mov	ah, al
	shr	ah, cl
	and	ax, 0F0Fh
	or	ax, 3030h
	xchg	ah, al
	cld
	stosw
	inc	di

	lea	dx, date_restored_msg
	mov	ah, 9
	int	21h
	lea	dx, time
	mov	ah, 9
	int	21h


    exe_exit:
	mov	ah, 4Ch
	int	21h

_LASTSEG	ENDS


cBegData

CRLF	equ	13,10
BELL	equ	07

info	db "RTC2000 ", FULLVERSION, CRLF
	db CRLF
	db "This program determines if your BIOS supports Real Time Clock date", CRLF
	db "rollover from the year 1999 to 2000. Some BIOSes do not update the", CRLF
	db "century.", CRLF
	db CRLF
	db "Press any key to continue..."
	db '$'

no_RTC_msg	db "No or inoperable RTC",CRLF,'$'
time_set_msg	db CRLF, CRLF, "RTC time set to "
time		db "23:59:59 on "
date		db "12/31/1999.",CRLF,'$'
waiting_msg	db "Waiting until RTC reads midnight"
tick		db ".",'$'
new_time_msg	db CRLF,"RTC time rolled over to ",'$'

ok_msg		db "Your RTC/BIOS handles the year 2000 correctly.",CRLF,'$'
too_bad_msg	db CRLF
		db "Your RTC/BIOS has a problem with the year 2000.", CRLF
		db BELL,CRLF,'$'
we_can_help_msg	db "ROM-DOS Revision 2.50.03 or later will correct the BIOS problem. Optionally, ", CRLF
		db "with an older ROM-DOS, install RTC2000.EXE as a device driver in CONFIG.SYS", CRLF
		db CRLF
		db "   DEVICE = RTC2000.EXE",CRLF
		db CRLF
		db "to correct the problem. RTC2000 will update Int 1AH to support century", CRLF
		db "rollover.", CRLF, '$'

way_too_bad_msg db "RTC2000 cannot help with this BIOS/RTC error. Please note the time", CRLF
		db "above and contact Datalight for assistance.", CRLF, '$'
date_restored_msg db CRLF, "RTC date restored to ",'$'

org_date_dx	dw	?
org_date_cx	dw	?
org_time_cx	dw	?
org_time_dx	dw	?

cEndData


cBegUdata

	; define a stack
stackbot	db	512 dup (?)
stacktop	dw	(?)

cEndUdata

	end _main
