;
;   $Id: STACKDEV.ASM 1.6 2002/10/15 21:23:22Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
comment ~ *************************************************

   STACKDEV.ASM  created 04/14/94  by Drew Gislason

   Copyright (c) 1994-2002 Datalight, Inc.
   All Rights Reserved
   Datalight Confidential and Proprietary

   Add software stacks for certain hardware interrupts,
   just in case the available stack isn't large enough.
   The interrupts covered are at the variable int_list :

      21H, 02H, 08H, 09H, 0AH, 0BH, 0CH, 0DH, 0EH, 013h
      70H, 72H, 73H, 74H, 75H

   Note: num_stacks is hard-coded for these 15 vectors
         stack_size is also hard-coded to 256 (bytes)
         similarly hard-coded is the space at start_stacks

*********************************************************** ~
include ..\include\macros.inc

TRAP21	= 1	; do we trap INT 21H, get/set vector?

; equates for offsets into the device's request header
;
CMDLEN	=	0
UNIT	=	1
CMD	=	2	; cmd code
STATUS	=	3	; status word
MEDIA	=	13
TRANS	=	14	; transfer address
COUNT	=	18	; count for read/write
START	=	20

; The structure defining a (non-reentrant) stack for a given interrupt
;
StackInfo STRUC
	stk_newhandler	dw	?	; the INT routine (new handler)
	stk_oldhandler	dd	?	; old handler
	stk_sp		dw	?	; stack ptr (new stack)
	stk_user	dd	?	; user stack (old stack)
	stk_entered	db	?	; don't allow reentrancy
	stk_bx	dw	?	; caller's original BX
StackInfo ENDS


cBegCode
	assume	DS:_TEXT
	public	_astart
_astart:

;---------------------------
; Device header
trapx:	dw	-1,-1
	dw	8000H
	dw	offset strategy
	dw	offset service
	db	"STACKSX0"

strategy:
	retf

	signon	db "Installing STACKS","$"

service:
	; fill in request header with our size
	mov	word ptr ES:[BX+STATUS], 100H
	mov	word ptr ES:[BX+TRANS], offset enddev
	mov	ES:[BX+TRANS+2], CS

	; display a signon
	mov	DX, offset signon
	mov	AX, CS
	mov	DS, AX
	mov	AH, 9
	int	21h

	call	tsr_part

	retf


tsr_part:

	; set up the Data segment
	mov	AX, CS
	mov	DS, AX
	mov	[ourCS], CS

	; install our interrupt handlers
	call	install_ints
	ret

	; we should never get here, but just in case...
never:	jmp	short never

	public	num_stacks, stack_size, ourCS
num_stacks	dw	15	; 15 stacks (default), note: ms uses 9
stack_size	dw	256	; 256 bytes per stack (default)
ourCS		dw	?

	public	atoi
;  On Entry
;	ES:DI = ptr to digits
;  On Exit
;	ES:DI = ptr to just past digits
;	DX = number
atoi	proc near
	push	DX
	xor	DX, DX
againatoi:
	mov	AL, ES:[DI]
	sub	AL, '0'
	cmp	AL, 9
	ja	atoidone
	xor	AH, AH		; AX = digit
	push	AX
	mov	AX, 10
	mul	DX
	xchg	DX, AX		; DX *= 10
	pop	AX
	add	DX, AX		; DX += digit
	inc	DI
	jmp	short againatoi
atoidone:
	xchg	DX, AX
	pop	DX
	ret
atoi	endp

; set TRUE during init process, FALSE afterwards
	public	during_init
during_init	db 1

	public	install_ints
install_ints proc near
	mov	DI, offset info_list
	mov	SI, offset int_list
	xor	CX, CX
again_ints:
	cmp	byte ptr [SI], 0	; any ints left?
	jz	done_ints
	cmp	CX, [num_stacks]
	jae	done_ints
	push	CX
	mov	AH, 35H			; get old handler
	mov	AL, byte ptr [SI]
	int	21H
	mov	word ptr [DI.stk_oldhandler], BX
	mov	word ptr [DI.stk_oldhandler+2], ES
	mov	AX, [alloc_sp]		; allocate a stack
	add	AX, [stack_size]
	mov	word ptr [DI.stk_sp], AX
	mov	[alloc_sp], AX
	mov	AH, 25H			; set new handler
	mov	AL, byte ptr [SI]
	mov	DX, [DI.stk_newhandler]
	int	21H	; DS = CS = seg new handler
	inc	SI
	add	DI, size StackInfo
	pop	CX
	inc	CX
	jmp	short again_ints
done_ints:
	mov	[during_init], 0
	ret
install_ints endp


ifdef 0
	public usage
usage	db 13,10
	db "Usage = STACKS [numstacks [,stacksize]]",13,10
	db "Copyright (c) 1989-1994 Datalight, Inc.",13,10
	db 13,10
	db "Default is 14,128  The interrupts supported (in order)",13,10
	db "are: 2H,8H,9H,AH,BH,CH,DH,EH,13H,70H,72H,73H,74H and 75H.",13,10
	db '$'
endif

	; if not get/set vector, jump to original INT 21H handler
	public	int21
int21:	pushf
	cmp	AH, 25H		; set vector
	jz	check_if_ours
	cmp	AH, 35H		; get vector
	jz	check_if_ours
do_old_21:
	popf
	jmp	dword ptr CS:[int21_info.stk_oldhandler]
not_ours:
	pop	BX
	jmp	short do_old_21

	; we now know it's get/set vector...
	; but, is it one of OUR interrupts?
check_if_ours:
	; we aren't ready during our init process
	cmp	byte ptr CS:[during_init], 0
	jnz	do_old_21

	; ROM-DOS needs stackdev for use with the ADAPTEC SCSI BIOS (spr 1403)
	; but ADAPTEC's ASPICD reads the int vector table entry for int 13h
	; directly and then calls int 21h fn 2513h to set the vector:
	; If we do our "stay in front" dance for int 13h, we will end
	; up in an infinite loop with that SCSI CD device driver...
	;
	cmp	al, 13h
	jz	do_old_21

	push	BX
	mov	BX, offset int_list + 1
check_again:
	cmp	byte ptr CS:[BX], 0	; got to end of list, give up!
	jz	not_ours
	cmp	CS:[BX], AL
	jz	getset_vect
	inc	BX
	jmp	short check_again

	; get or set the vector UNDERNEATH the STACKS vector
getset_vect:
	; get the info structure in question
	sub	BX, offset int_list	; get index into intlist
	push	AX
	mov	AL, size StackInfo
	mul	BL
	mov	BX, offset info_list
	add	BX, AX			; get ptr to the info_list of choice
	pop	AX

	; actually do the get/set
	cmp	AH, 25H
	jz	set_vect
get_vect:
	cli
	mov	ES, word ptr CS:[BX.stk_oldhandler+2]
	mov	BX, word ptr CS:[BX.stk_oldhandler]
	add	SP, 2			; pop BX (throw old BX away)
	jmp	short done_getset

set_vect:
	cli
	mov	word ptr CS:[BX.stk_oldhandler+2], DS
	mov	word ptr CS:[BX.stk_oldhandler], DX
	pop	bx

done_getset:
	popf
	iret

; a NULL terminated list of interrupts
	public	int_list, info_list
int_list db	21H
	 db	02H, 08H, 09H, 0AH, 0BH, 0CH, 0DH, 0EH, 013h
	 db	70H, 72H, 73H, 74H, 75H, 0

; The IRET IP used by the software interrupt handler. Making this
; a CS relative variable saves us from some stack contortions without
; increasing the size of the StackInfo struc. Note that push <mem16>
; is a valid 8088 instruction (though push <imm16> is not).
;
swint_iret_IP	dw	offset back_from_swint_handler

; all StackInfo structures must follow in the same order as
; the above list of interrupts
info_list	label byte
int21_info	StackInfo <offset int21>
int02_info	StackInfo <offset int02>
int08_info	StackInfo <offset int08>
int09_info	StackInfo <offset int09>
int0A_info	StackInfo <offset int0A>
int0B_info	StackInfo <offset int0B>
int0C_info	StackInfo <offset int0C>
int0D_info	StackInfo <offset int0D>
int0E_info	StackInfo <offset int0E>
int13_info	StackInfo <offset int13>
int70_info	StackInfo <offset int70>
int72_info	StackInfo <offset int72>
int73_info	StackInfo <offset int73>
int74_info	StackInfo <offset int74>
int75_info	StackInfo <offset int75>


; Stack code for Software Interrupt handlers. These interrupts
; must pass the callers registers to the old Interrupt Service Routine
; (ISR) and also return the registers and flags passed back from the old
; ISR (the code at cs:[bx].stk_oldhandler).
;
int13:	push	BX
	mov	BX, offset int13_info
	jmp	short generic_swint_handler

	public	generic_swint_handler
generic_swint_handler:

	; don't reenter
	cmp	byte ptr CS:[BX.stk_entered], 0
	jz	ok2switch_swstacks
	push	BX	; just adding 2 to SP, save room for far return
	push	BP
	mov	BP, SP
	push	AX
	mov	AX, word ptr CS:[BX.stk_oldhandler]
	mov	[BP+2], AX
	pop	AX
	mov	BX, word ptr CS:[BX.stk_oldhandler+2]
	xchg	BX, [BP+4]	; seg of old handler
	pop	BP
	retf		; jmp to old handler

	public	ok2switch_swstacks
ok2switch_swstacks:

	; save originial stack
	mov	byte ptr CS:[BX.stk_entered], 1
	pop	cs:[bx].stk_bx
	mov	word ptr CS:[BX.stk_user+2], SS
	mov	word ptr CS:[BX.stk_user], SP

	; switch to our stack
	mov	SS, word ptr CS:[ourCS]
	mov	SP, CS:[BX.stk_sp]

	; call old handler
	push	bx			; save *(struc StackInfo)
	pushf                           ; flags and
	push	cs			; CS:IP for IRET
	push	cs:swint_iret_IP
	push	word ptr cs:[bx].stk_oldhandler+2; push old ISR's CS:IP
	push	word ptr cs:[bx].stk_oldhandler
	mov	bx, cs:[bx].stk_bx    	; restore caller's BX
	retf				; "call" old ISR

	public	back_from_swint_handler
back_from_swint_handler:

	; swap the BX value returned by the ISR with the
	; offset of our StackInfo struc
	;
	push	bp
	mov	bp, sp
	xchg	bx, [bp+2]
	pop	bp
	pop	cs:[bx].stk_bx

	; restore original stack
	mov	SS, word ptr CS:[BX.stk_user+2]
	mov	SP, word ptr CS:[BX.stk_user]

	; return to user program
	push	cs:[bx].stk_bx
	mov	byte ptr CS:[BX.stk_entered], 0
	pop	bx
	retf 	2


; Stack code for Hardware Interrupt handlers (IRQs). These interrupts
; need only maintain the interrupted program's registers and flags.
; The IRQ handlers don't (and cannot) depend on any passed registers.
;
int02:	push	BX
	mov	BX, offset int02_info
	jmp	short generic_hwint_handler
int08:	push	BX
	mov	BX, offset int08_info
	jmp	short generic_hwint_handler
int09:	push	BX
	mov	BX, offset int09_info
	jmp	short generic_hwint_handler
int0A:	push	BX
	mov	BX, offset int0A_info
	jmp	short generic_hwint_handler
int0B:	push	BX
	mov	BX, offset int0B_info
	jmp	short generic_hwint_handler
int0C:	push	BX
	mov	BX, offset int0C_info
	jmp	short generic_hwint_handler
int0D:	push	BX
	mov	BX, offset int0D_info
	jmp	short generic_hwint_handler
int0E:	push	BX
	mov	BX, offset int0E_info
	jmp	short generic_hwint_handler
int70:	push	BX
	mov	BX, offset int70_info
	jmp	short generic_hwint_handler
int72:	push	BX
	mov	BX, offset int72_info
	jmp	short generic_hwint_handler
int73:	push	BX
	mov	BX, offset int73_info
	jmp	short generic_hwint_handler
int74:	push	BX
	mov	BX, offset int74_info
	jmp	short generic_hwint_handler
int75:	push	BX
	mov	BX, offset int75_info
	jmp	short generic_hwint_handler


	public	generic_hwint_handler
generic_hwint_handler:

	; don't reenter
	cmp	byte ptr CS:[BX.stk_entered], 0
	jz	ok2switch_hwstacks
	push	BX	; just adding 2 to SP, save room for far return
	push	BP
	mov	BP, SP
	push	AX
	mov	AX, word ptr CS:[BX.stk_oldhandler]
	mov	[BP+2], AX
	pop	AX
	mov	BX, word ptr CS:[BX.stk_oldhandler+2]
	xchg	BX, [BP+4]	; seg of old handler
	pop	BP
	retf		; jmp to old handler

	public	ok2switch_hwstacks
ok2switch_hwstacks:

	; save originial stack
	mov	byte ptr CS:[BX.stk_entered], 1
	mov	word ptr CS:[BX.stk_user+2], SS
	mov	word ptr CS:[BX.stk_user], SP

	; switch to our stack
	mov	SS, word ptr CS:[ourCS]
	mov	SP, CS:[BX.stk_sp]

	; emulate an interrupt to the old handler
	;
	pushf
	call	dword ptr cs:[bx].stk_oldhandler

	public	back_from_hwint_handler
back_from_hwint_handler:

	; restore original stack
	mov	SS, word ptr CS:[BX.stk_user+2]
	mov	SP, word ptr CS:[BX.stk_user]

	; return to user program
	mov	byte ptr CS:[BX.stk_entered], 0
	pop	bx
	iret


; here are the actual stacks
	public	alloc_sp
alloc_sp	dw offset start_stacks
start_stacks	label byte

	db	256*15 dup (?)

enddev:

cEndCode
	END	_astart
