;
;   $Id: VERSION.ASM 1.4 2002/10/15 21:31:32Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
Comment ~ -------------------------------------------------
   VERSION.ASM  created by Riley Eller
   Copyright (c) 1995-2002 by Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   Examples:
	device=version.sys 6.2
	device=version.sys 3.11

   History:

   02-03-1999 bt   SPR#1907

----------------------------------------------------------- ~
.MODEL  SMALL
.STACK  0

ERROR   EQU     8000h                   ;Set error bit
BUSY    EQU     0200h                   ;Set busy bit
DONE    EQU     0100h                   ;Set completion bit
FAILURE EQU     8003h                   ;Set FAILURE status

;============================================================================
cseg    segment public 'code'         ;Start the code segment
        org     0                     ;Zero origin
        assume  cs:cseg,ds:cseg,es:cseg
	public	strategy, parse_clp

	; BT 6-15-99
	;
	; In order to use TLINK 7.1 we must declare an entry point.  This
	; is not an entry point.  Comparing the SYS file created using
	; TLINK 4.0 without an entry point and the SYS file created using
	; TLINK 7.1 revealed no differences.
	;
falsestart:

;============================================================================
;version proc    far                     ;FAR procedure
        dd      -1                      ;Next driver pointer
attrib  dw      8000h                   ;Attribute: character device
        dw      strategy                ;Pointer to strategy
        dw      interrupt               ;Pointer to interrupt
	db	'VERSION '

;============================================================================
maj_ver db	0			; no defaults
min_ver db	0

rh_ptr	label	DWORD
rh_off  dw      ?                       ;RH offset address
rh_seg  dw      ?                       ;RH segment address

strategy:
        mov     cs:[rh_seg],es
        mov     cs:[rh_off],bx
        retf

;============================================================================
; interrupt routine
;============================================================================
interrupt:
	; debugging, easy to trap w/ SOFTICE
;	int	30h

        cld
        push    es
        push    ds
        push    si
        push    di

	; get request header in es:bx
	lds	bx, cs:[rh_ptr]

	; is this the init command?
        mov     al, ds:[bx+2]
	cmp	al, 0			; init
	jz	short s_init

	; we support no other commands but init
        mov     ax, FAILURE
        jmp     short finish

finish:
	lds	bx, cs:[rh_ptr]		; es:bx = ptr to req hdr
        or      ax, DONE		; Set the DONE bit
        mov     ds:[bx+3], ax

        pop     di
        pop     si
        pop     ds
        pop     es

   	; 02-03-1999 bt   SPR#1907
	; Changed this to a retf instead of a ret
	;
        retf                             ;Back to DOS

;============================================================================
; main body of driver
;============================================================================

parse_clp_retn:
;	For debugging, ax = new version#.  Use SoftICE to trap Int 30
;	mov	ah, cs:[maj_ver]
;	mov	al, cs:[min_ver]
;	int	30h

	; tell ROM-DOS to set the version
	mov	ax, 30DBh
	mov	si, 0B2D2h
	mov	ch, cs:[min_ver]
	mov	cl, cs:[maj_ver]
	mov	di, 2
	int	21H

parse_clp_error:
	lds	bx, cs:[rh_ptr]			; es:bx = req hdr
        mov     word ptr ds:[bx+0Eh], 0		; no need to install driver
        mov     word ptr ds:[bx+10h], 0		; as we've already set the
						; version.
        mov	ax, FAILURE			; just fail the init call
        jmp     finish

s_init:
;============================================================================
; command line parameter checking
;============================================================================
parse_clp:
	lds	bx, cs:[rh_ptr]	; ds:bx = request header
	lds	bx, ds:[bx+12h]	; ds:bx = cmdline

	; parse the command line. should be in the form of:
	; VERSION.SYS 6.22
skip_to_parm:
	mov	al, ds:[bx]
	cmp	al, 9			; tab is ok
	jz	next_char
	cmp	al, ' '			; are we at the end of cmdline?
	jb	parse_clp_error		; we hit end before we found a #!
	cmp	al, '0'
	jb	next_char
	cmp	al, '9'
	jbe	find_clp		; got a number, '0'-'9'
next_char:
	inc	bx
	jmp	short skip_to_parm

find_clp:
	; assume version of 0
	mov	cs:[maj_ver], 0
	mov	cs:[min_ver], 0


parse_majver:
	; are we at the '.' for minor version?
	mov	al, ds:[bx]
	cmp	al, '.'
	je	parse_minver

	; are we still on a number?
	cmp	al, '0'
	jb	parse_clp_done
	cmp	al, '9'
	ja	parse_clp_done

	; yes, update major version
	mov	dl, cs:[maj_ver]
	mov	al, 10
	mul	dl
	add	al, ds:[bx]
	sub	al, '0'
	mov	cs:[maj_ver], al
	inc	bx
	jmp	short parse_majver

parse_clp_done:
	cmp	cs:[maj_ver], 2
	jae	parse_clp_retn		; at least 2.0
	mov	cs:[maj_ver], 2
	mov	cs:[min_ver], 0
	jmp	parse_clp_retn

	; minor version is ALWAYS a 2 digit number
	; 3.11, the .11 would be represented as byte 0BH (11)
	; 3.1, the .1 would be represented by byte 0AH (10)
parse_minver:
	inc	bx
	mov	al, ds:[bx]
	cmp	al, '0'
	jb	parse_clp_done
	cmp	al, '9'
	ja	parse_clp_done
	mov	dl, al
	sub	dl, '0'
	mov	al, 10
	mul	dl
	mov	dl, al		; save version high value in dl
	inc	bx
	mov	al, ds:[bx]
	cmp	al, '0'
	jb	done_minor
	cmp	al, '9'
	ja	done_minor
	sub	al, '0'
	add	dl, al
done_minor:
	mov	cs:[min_ver], dl
	jmp	short parse_clp_done

;version endp
cseg    ends

	; BT 6-15-99
	;
	; In order to use TLINK 7.1 we must declare an entry point.  This
	; is not an entry point.  Comparing the SYS file created using
	; TLINK 4.0 without an entry point and the SYS file created using
	; TLINK 7.1 revealed no differences.
	;
	end falsestart
