;
;   $Id: WX2SWAP.ASM 1.4 2002/10/15 21:32:48Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
COMMENT ~
----------------------------------------------------------

   WX2FIX.ASM  created 01/24/94  by Drew Gislason

   Copyright (c) 1994-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   This character device supports reentering DOS through
   a method expected by the WX2 program from A.I.Soft.

   It supports:
   INT 2FH, 4D00H - install check, CX:DX = handler
            4D01H - get error status
            4D02H - install/remove FEP control

---------------------------------------------------------- ~

include macros.inc
include devhdr.inc

STACKSIZE = 1024	; stack space


;
;  Define SEGMENT ORDERING
;
cBegCode
cEndCode

BEGDATA	SEGMENT PARA PUBLIC '_BEGDATA'
	DGROUP GROUP BEGDATA
datastart label word
BEGDATA	ENDS

cBegData
cEndData

cBegUdata
begbss	label word
cEndUdata

	DGROUP GROUP MOREBSS
MOREBSS	SEGMENT word PUBLIC 'BSS'
		public	sda_buffer
	sda_buffer	db	?
MOREBSS	ENDS

;---------------------------------------------------------
;
;	STANDALONE DEVICE HEADER
;
;	This device header handles a stand alone
;	RAM or ROM disk.
;
;---------------------------------------------------------

cBegCode

	public _wx2x
_wx2x:
	dw	-1, -1
	dw	8000H		; character device
	dw	strategy	; strategy routine
	dw	service		; service routine
	db	"WX2FIX$$"	; name


cmdtbl:
	dw	wx2_init	; 00 - init
cmdend:

cEndCode

cBegData
	zerobss	db	1	; only do it the 1st time

	; the Request Header Pointer MUST be in DATA, not BSS
	; because BSS segment is zeroed DURING the 1st request
	public	_ptrsav
	_ptrsav	dd	0
cEndData

cBegUdata

	public	oldstack, stacktop
	stackbottom	db STACKSIZE dup (?)
	stacktop	dw	?
	oldstack 	dd	?

	public	sda_start, sda_len
	sda_start	dd	?
	sda_len		dw	?
	local_sda	dd	?

	last_error	dw	?	; remember last error
	in_wx2		db	?	; for reentrancy issues
	dos1_call	db	?	; was this a DOS1 call?
cEndUdata

cBegCode

	public strategy
strategy:
	push	DS
	call	getDGROUP
	mov	word ptr [_ptrsav], BX
	mov	word ptr [_ptrsav+2], ES
	pop	DS
	retf

	public service
service:
	pushf
	push	AX
	push	BX
	push	CX
	push	DX
	push	SI
	push	DI
	push	DS
	push	ES

	call	getDGROUP

	; Zero BSS (1st time only)
	cmp	byte ptr [zerobss], 0
	jz	no_zero
	mov	BX, offset CS:no_zero
	jmp	zero_bss
no_zero:

	; save old stack
	mov	word ptr [oldstack+2], SS
	mov	word ptr [oldstack], SP

	; switch to our stack
	mov	BX, GOFFSET stacktop
	mov	CX, DS
	cli
	mov	SS, CX
	mov	SP, BX
	sti

	; determine the command
	les	BX, [_ptrsav]			; get pointer to i/o packet
	mov	AL, byte ptr ES:[BX+CMD]	; command code
	cmp	AL, (OFFSET cmdend - OFFSET cmdtbl) / 2
	jae	dev_cmd_err			; bad command
	cbw
	shl	AX, 1				; get index into cmd table
	mov	SI, offset _TEXT:cmdtbl
	add	SI, AX

	; load up the registers with common value
	mov	AL, byte ptr ES:[BX+UNIT]	; AL	= unit #
	mov	AH, byte ptr ES:[BX+MEDIA]	; AH	= media
	mov	CX, word ptr ES:[BX+COUNT]	; CX    = count
	mov	DX, word ptr ES:[BX+START]	; DX    = start sector
	les	DI, dword ptr ES:[BX+TRANS]	; ES:DI = transfer buffer

;	we've set up the following:
;	--------------------------
;	DS	= DGROUP
;	ES:DI	= transfer buffer
;	CX	= count
;	DX	= start
;	AL	= unit
;	AH	= media

	jmp	word ptr CS:[SI]	; do the command


; return address MUST be in BX because it may be the
; STACK that is ZEROED!!
zero_bss:
	xor	AL, AL
	mov	byte ptr [zerobss], AL
	push	DS
	pop	ES
	mov	DI, GOFFSET begbss
	mov	CX, GOFFSET sda_buffer
	sub	CX, DI
	cld
	rep	stosb
	push	BX
	ret

	public	dev_cmd_err, dev_err_exit, dev_exit, dev_busy_exit
dev_busy_exit:
	mov	AH, 03H		; busy and done bits set
	jmp	short err1
dev_cmd_err:
	mov	AL, 3		; unknown cmd error
dev_err_exit:
	mov	AH, 81H		; mark error return
	jmp	SHORT err1

dev_exit:
	mov	AH, 01H		; done bit set

err1:	les	BX, [_ptrsav]
	mov	WORD PTR ES:[BX+STATUS], AX	; mark as complete

	; note: this code makes the driver non-reentrant
	cli
	mov	SS, word ptr [oldstack+2]
	mov	SP, word ptr [oldstack]
	sti

	pop	ES
	pop	DS
	pop	DI
	pop	SI
	pop	DX
	pop	CX
	pop	BX
	pop	AX
	popf
	retf

; STANDALONE ONLY!!
; put DGROUP into DS
c_func	getDGROUP
	push	AX
IF 0
	; easy method
	mov	AX, DGROUP
	mov	DS, AX
ELSE
	; no fixups method
	push	CX
	mov	CX, CS
	mov	AX, offset _TEXT:datastart
	shr	AX, 1
	shr	AX, 1
	shr	AX, 1
	shr	AX, 1
	add	AX, CX
	mov	DS, AX
	pop	CX
ENDIF
	pop	AX
	ret
c_endp	getDGROUP


;---------------------------------------------------------
;
;	FUNCTION 0 - INIT
;
; On Entry:
;
;	DS	= DGROUP
;	DX:CX	= "DEVICE = \dev\name.sys /1"
;	                    ^
;
; On Exit:
;	+-------------------------+
; 00H	| 13-Byte header          | (ignored)
;	+-------------------------+
; 0DH	| BYTE   Number of units  | (we set this)
;	+-------------------------+
; 0EH	| DWORD  End Address      | (we set this)
;	+-------------------------+
; 12H	| DWORD  Ptr to BPB array | (we set this)
;	+-------------------------+
;
;---------------------------------------------------------

	public	wx2_init
wx2_init:

	; check if we're already installed
	mov	AX, 4D00H
	int	2FH
	cmp	AX, 4D00H
	jz	not_installed

	; don't install if we already are
	les	BX, [_ptrsav]
	mov	word ptr ES:[BX+TRANS], 0
	mov	word ptr ES:[BX+TRANS+2], 0
	mov	AL, ERR_GENERALFAIL
	jmp	dev_err_exit
not_installed:

	; determine how much memory we need
	;R_DS = ROM_DS;
	;R_SI = (unsigned)(&CritErr);
	;R_CX = (unsigned)(&end_sda)  - (unsigned)(&CritErr);
	;R_DX = (unsigned)(&int21_ax) - (unsigned)(&CritErr);
	push	DS
	mov	AX, 5D06H
	int	21H
	mov	DX, DS
	pop	DS
	mov	[sda_len], CX
	mov	word ptr [sda_start], SI
	mov	word ptr [sda_start+2], DX

	; save far ptr to sda buffer
	mov	word ptr [local_sda], GOFFSET sda_buffer
	mov	word ptr [local_sda+2], DS

	; remember old 2FH interrupt
	mov	AX, 352FH
	int	21H
	mov	word ptr CS:[old_2f], BX
	mov	word ptr CS:[old_2f+2], ES

	; set new 2FH handler
	push	DS
	mov	AX, CS
	mov	DS, AX
	mov	DX, offset _TEXT:wx2_handler
	mov	AX, 252FH
	int	21H
	pop	DS

	; no error, set up the i/o packet
	les	BX, [_ptrsav]
	mov	AX, GOFFSET sda_buffer
	add	AX, [sda_len]
	add	AX, 10H
	mov	word ptr ES:[BX+TRANS], AX
	mov	word ptr ES:[BX+TRANS+2], DS
	mov	AL, 0
	jmp	dev_exit

;---------------------------------------------------------
;  This handler supports 3 functions.  It is available via
;  INT 2FH, 4DxxH.
;
;  4D00H - Install Check
;	Returns AX=0, CX:DX = reentrant_handler
;  4401H - Error Status
;	Returns AX=error code (0=none)
;  4402H - Install FEP
;	Returns AX=0, BX=hdl

old_2f	dd	?

wx2_handler:
	pushf			; preserve flags
	cmp	AH, 4DH
	jz	its_ours
	popf
	jmp	dword ptr CS:[old_2f]
its_ours:
	popf

	; Install Check
f4D00:	cmp	AL, 0
	jnz	not_4D00
	xor	AX, AX
	mov	CX, CS
	mov	DX, offset _TEXT:reenter_DOS
	iret
not_4D00:

	; Error Status
f4D01:	cmp	AL, 1
	jnz	not_4D01
	push	DS
	call	getDGROUP
	mov	AX, [last_error]
	pop	DS
	iret
not_4D01:

	; Install/Uninstall FEP
f4D02:	cmp	AL, 2
	jnz	not_4D02
	cmp	CL, 0
	jnz	uninstall
	xor	AX, AX
	mov	BX, 10H
	iret
uninstall:
	xor	AX, AX
	iret

not_4D02:
	iret

ERR_BADFUNC	equ 1
ERR_BUSY	equ 2
ERR_CRITICAL	equ 3

;---------------------------------------------------------
;  This function can reenter DOS at any time.  It does
;  NOT pay attention to
;
reenter_DOS:
	pushf
	push	DS
	push	ES
	push	AX
	call	getDGROUP

	; don't allow anyone to reenter our reenter routine
	cli
	cmp	byte ptr [in_wx2], 0
	jz	ok_2_enter
busy:	sti
	mov	word ptr [last_error], ERR_BUSY
	pop	AX
	mov	AX, -1
	jmp	short reenter_done

ok_2_enter:
	inc	byte ptr [in_wx2]
	sti
	mov	word ptr [last_error], 0

	; was this a DOS1 call?
	mov	byte ptr [dos1_call], 0
	cmp	AH, 37H
	ja	not_dos1
	inc	byte ptr [dos1_call]
not_dos1:

	; save more registers
	push	CX
	push	SI
	push	DI

	; save SDA
	les	DI, [local_sda]
	mov	CX, [sda_len]
	lds	SI, [sda_start]
	cld
	rep	movsb

	; do the DOS call
	pop	DI
	pop	SI
	pop	CX
	pop	AX
	pop	ES
	pop	DS
	popf
	int	21H
	pushf
	push	DS
	push	ES
	push	SI
	push	DI
	push	CX
	pushf

	; restore SDA
	call	getDGROUP
	les	DI, [sda_start]
	mov	CX, [sda_len]
	lds	SI, [local_sda]
	cld
	rep	movsb

	; set error flag (or not) depending on DOS return
	cmp	byte ptr [dos1_call], 0
	jz	isdos2
	popf
	cmp	AL, 0FFH
	jz	dos_error
	jmp	short reenter_out
isdos2:	popf
	jnc	reenter_out

dos_error:
	mov	AX, -1		; indicate error

	; no error, just return registers from DOS
reenter_out:
	pop	CX
	pop	DI
	pop	SI

reenter_done:
	pop	ES
	cli
	mov	byte ptr [in_wx2], 0	; no longer in this routine
	pop	DS
	popf
	retf

cEndCode

	END _wx2x
