;  $Id: DEVHDR.INC 1.5 2003/03/20 17:11:16Z thomd Exp $
;
;  *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;  Copyright (c) 1989-2003 Datalight, Inc.
;  All Rights Reserved
;
;  Datalight, Inc. is a Washington corporation located at:
;
;  21520 30th Dr SE, Suite 110,          Tel: +1.425.951.8086
;  Bothell, WA  98021                    Fax: +1.425.951.8094
;  USA                                   Http://www.datalight.com
;
;  This software, including without limitation all source code and
;  documentation, is the confidential, trade secret property of
;  Datalight, Inc., and is protected under the copyright laws of
;  the United States and other jurisdictions.  Portions of the
;  software may also be subject to one or more the following US
;  patents: US#5860082, US#6260156.
;
;  In addition to civil penalties for infringement of copyright
;  under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;  penalties for violation of (a) the restrictions on circumvention
;  of copyright protection systems found in 17 U.S.C. 1201 and
;  (b) the protections for the integrity of copyright management
;  information found in 17 U.S.C. 1202.
;
;  U.S. Government Restricted Rights.  Use, duplication,
;  reproduction, or transfer of this commercial product and
;  accompanying documentation is restricted in accordance with
;  FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;  PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;  AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;  INC. AND THE LICENSEE ("BINDING AGREEMENT").  YOUR RIGHT, IF ANY,
;  TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;  TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;  USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;  TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT.  CONTACT
;  DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;  THIS SOFTWARE IN ERROR.
;
COMMENT ~
----------------------------------------------------------

   DEVHDR.INC  created  02/15/89  by Drew Gislason

   Copyright (c) 1989-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   Included in all built-in device drivers

   History:
   01-25-1999 bt  SPR 1882 - added constants
---------------------------------------------------------- ~

CR	equ	13
LF	equ	10

;------------------------------------------------
;  Device Request Header Fields
;
;  When DOS calls the device driver, the request
;  header (pointed to by ES:BX) may contain some
;  or all of the following fields:
;
CMDLEN	equ	00H	; length of command
UNIT	equ	01H	; unit # for disks
CMD	equ	02H	; the command itself
STATUS	equ	03H	; status word (0 on start)
MEDIA	equ	0DH	; media byte (disks)
TRANS	equ	0EH	; (far *) transfer address
COUNT	equ	12H	; count for read/write
IOCTL	equ	13H	; (far *) buffer for generic IOCTL (440DH)
START	equ	14H	; start for read/write
START32	equ	1AH	; start for read/write on 32 bit sectors

; other header fields
DEVH_ENDADDR	equ	0EH	; ending address (init)
DEVH_CMDLINE	equ	12H	; cmdline offset (init)
RETURN  	equ	0Eh	; media changed return value
VOLUME_NAME_PTR	equ	0Fh	; pointer to the volume name in the bpb


;------------------------------------------------
;  Device Attribute Bits
;
DEVA_CHAR	equ 8000H	; 1=char, 0=disk device
DEVA_IOCTL	equ 4000H	; device supports ioctl calls
DEVA_IBMBLK	equ 2000H	; 1=fat, 0=scratch
DEVA_REMOVE	equ 0800H	; Removeable media call supported
DEVA_OPNCLS	equ 0800H	; Open/Close device call supported
DEVA_QUERY	equ 0080H	; query generic IOCTL
DEVA_GENIO	equ 0040H	; generic IOCTL
DEVA_FAST	equ 0010H	; INT 29H is supported
DEVA_CLOCK	equ 0008H	; this is the CLOCK driver
DEVA_NUL	equ 0004H	; this is the NUL driver
DEVA_CON	equ 0003H	; this is the CONsole driver
DEVA_32BIT	equ 0002H	; device supports 32 bit sectors


;------------------------------------------------
;  Device Status Bits
;
;  These values are in the upper byte of the device status
;  word. The lower byte contains error codes.
;
DEVS_BUSY	equ	0200h	; device is busy
DEVS_DONE	equ	0100h	; device done
DEVS_ERROR	equ	8000h	; device error

;------------------------------------------------
;  Device Error Codes
;
;  If the device must return an error, the following
;  defines the possible error conditions:
;
;  NOTE: These are the same errors identified by MSDOS v6.22 COMMAND.COM.
;        Microsoft only documents errors 0-C in their prog. ref.
;        See PC Interrupts (2nd Ed.) Pg. 524.
;
ERR_WRITEPROT		        equ	   00H
ERR_BADUNIT		        equ	   01H
ERR_NOTREADY		        equ	   02H
ERR_BADCMD		        equ	   03H
ERR_CRC			        equ	   04H
ERR_BADSTRUCT		        equ	   05H
ERR_SEEK		        equ	   06H
ERR_BADMEDIA		        equ	   07H
ERR_SECTORNOTFOUND	        equ	   08H
ERR_NOPAPER		        equ	   09H
ERR_WRITEFAULT		        equ	   0AH
ERR_READFAULT		        equ	   0BH
ERR_GENERALFAIL		        equ	   0CH
ERR_SHARINGVIOLATION	        equ	   0DH
ERR_LOCKVIOLATION	        equ	   0EH
ERR_INVALIDDISKCHANGE	        equ	   0FH
ERR_FCBUNAVAILABLE              equ	   10H
ERR_SHARINGBUFFEROVERFLOW       equ	   11H
ERR_CODEPAGEMISMATCH            equ	   12H
ERR_OUTOFINPUT                  equ	   13H
ERR_INSUFFICIENTDISKSPACE       equ	   14H


VOLUME_LABEL_SIZE	equ	11
FAT_TYPE_SIZE		equ	9
