//
//   $Id: DISPLAY.H 1.3 2002/10/15 21:41:22Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*****************************************************************************
	$DOCMODULE: DISPLAY.H

   Copyright (c) 1999-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   Header file for the Datalight video bios libraries

	$DOCHISTORY:
   11-02-1999 BT 	created

*****************************************************************************/

#if !defined( DISPLAY_H )
#define       DISPLAY_H 1


//  dli10f00.asm : INT 10h fn 00h
//
//  Set Video Mode
//
bool PASCAL DlSetVideoMode( uchar ucVideoModeNumber );


//  dli10f01.asm : INT 10h fn 01h
//
//  Set cursor type
//
bool PASCAL DlSetCursorType( uchar ucCursorStart, uchar ucCursorEnd );


//  dli10f02.asm : INT 10h fn 02h
//
//  Set cursor position
//
bool PASCAL DlSetCursorPosition( uchar ucPage, uchar ucRow,
		uchar ucColumn );


//  dli10f03.asm : INT 10h fn 03h
//
//  Get cursor position and configuration
//
bool PASCAL DlGetCursorPositionAndCfg( uchar ucPage, uchar * pucCursorStart,
		uchar * pucCursorEnd, uchar * pucRow, uchar * pucColumn );


//  dli10f05.asm : INT 10h fn 05h
//
//  Set active display page
//
bool PASCAL DlSetDisplayPage( uchar ucPage );


//  dli10f06.asm : INT 10h fn 06h
//
//  Scroll window up
//
bool PASCAL DlScrollWindowUp( uchar ucScrollLines, uchar ucFillAttribute,
		uchar ucUpperLeftRow, uchar ucUpperLeftColumn,
		uchar ucLowerRightRow, uchar ucLowerRightColumn );


//  dli10f07.asm : INT 10h fn 07h
//
//  Scroll window down
//
bool PASCAL DlScrollWindowDown( uchar ucScrollLines, uchar ucFillAttribute,
		uchar ucUpperLeftRow, uchar ucUpperLeftColumn,
		uchar ucLowerRightRow, uchar ucLowerRightColumn );


//  dli10f08.asm : INT 10h fn 08h
//
//  Read Character and Attribute at Current Cursor Position
//
bool PASCAL DlReadCharacterAndAttribute( uchar ucPage,
		uchar * pucCharacter, uchar * pucAttribute );


//  dli10f09.asm : INT 10h fn 09h
//
//  Write Character and Attribute at Current Cursor Position
//
bool PASCAL DlWriteCharacterAndAttribute( uchar ucPage,
		uchar ucCharacter, uchar ucAttribute, unsigned uCount );


//  dli10f0f.asm : INT 10h fn 0fh
//
//  Get current display mode
//
bool PASCAL DlGetCurrentDisplayMode( uchar * pucMode, uchar * pucPage,
		uchar * pucColumns );


#endif  //!defined(DISPLAY_H)
