//
//   $Id: DLBIOSIO.H 1.5 2002/10/15 21:41:22Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*****************************************************************************

   DLBIOSIO.H
   Created 08-21-97 by Dennis Edwards

   Copyright (c) 1997-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   Header file for the DLx libraries (Datalight BIOS I/O functions).

*****************************************************************************/

#ifndef __DATALGHT_H
#include "datalght.h"
#endif

#if !defined( DLBIOSIO_H )
#define       DLBIOSIO_H 1

// dlgetflp.asm
//
// Returns the number of floppy drives. If the number of
// floppy drives cannot be determined it returns 0.
//
unsigned PASCAL dlGetBIOSFloppyCount(void);


// dlbkbd.asm	-- invokes the specified int 16h BIOS keyboard function
//
unsigned PASCAL BIOSKeyboard(unsigned function);

// function values for BIOSKeyboard
//
#define _KEYBRD_READ            0       /* read key */
#define _NKEYBRD_READ           0x10    /* read key - enhanced */
#define _KEYBRD_READY           1       /* check key ready */
#define _NKEYBRD_READY          0x11    /* check key ready - enhanced */
#define _KEYBRD_SHIFTSTATUS     2       /* get shift status */
#define _NKEYBRD_SHIFTSTATUS    0x12    /* get shift status - enhanced */


// dlbvid08.asm
//
// This function returns the video attribute and character at
// the current cursor position on the specified page.
//
void PASCAL BIOSVidGetCurCharAndAttr(unsigned char  page,
                                     unsigned char* pCurChar,
                                     unsigned char* pCurAttribute);


// commaddr.asm
//
// Given a com port number in {0,1,2,3}, retrieves the I/O Base
//	address of a BIOS supported UART from the BIOS data area. The
//	input port number is not validated. The UART is assumed to be
//	an 8250/16x50 but no check is made to verify this.
//
unsigned PASCAL GetCommPortBaseAddress(unsigned CommPortNumber);


// pushkey.asm
//
//	uses int 16h fn 05h to push a char into the
//	BIOS keyboard buffer. The extended scan code
//	that is retrieved will be the same as if the
//	character's extended ASCII code was typed in
//	using the <Alt><NumPad> method (the scan code
//	byte -- B8..B15 -- will be 0). The function
//	returns TRUE on success.
//
bool pushkey(char key);


//  getticks.asm
//
//  retrieve the number of timer ticks (which occure 18.2 times per
//  second) since midnight.
//
bool PASCAL dlGetTimerTicks( ulong * pulTimerTicks );

#endif 	// !defined(DLBIOSIO_H)

