//
//   $Id: DLDOSIO.H 1.17 2002/10/15 21:41:22Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*****************************************************************************
	$DOCMODULE: DLDOSIO.H

   Copyright (c) 1997-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   Header file for the DLDOSIOx libraries (Datalight DOS I/O functions).

	$DOCHISTORY:
	04-16-2001 aj  Added i21f5a.asm
	02-27-1999 de  Added dlgetlol.asm
	02-27-1999 de  Added dldfre32.c
	02-27-1999 de  Added dlgdpb32.asm
	02-05-1999 bt  Added bootltr.c
	02-05-1999 bt  Added getver.asm
	02-05-1999 bt  Added bootdrv.asm
	01-04-1999 bt  Added dlGetDTA
	01-04-1999 bt  Added dlAlloc
	01-04-1999 bt  Added dlAllocMem
	01-04-1999 bt  Added dlFreeMem
	01-04-1999 bt  Added dlResizeMem
	01-04-1999 bt  Added dlAbsWrite32
	01-04-1999 bt  Added dlAbsRead32
	01-04-1999 bt  Added dlGetSwitchCharacter
	01-04-1999 bt  Added dlIsDriveRemote
   08-09-1997 de 	created

*****************************************************************************/

#if !defined( DLDOSIO_H )
#define       DLDOSIO_H 1


// dldoserr.asm: return (and reset) record of last DOS I/O error code
//
int PASCAL dlCheckDOSError(void);
int PASCAL dlResetDOSError(void);
int PASCAL dlSetDOSError(int ErrorCode);

// dlabserr.asm: return (and reset) record of last absolute read/write
// error code.
//
int PASCAL __dlCheckAbsRdWrError(void);
int PASCAL __dlResetAbsRdWrError(void);

//  wildren.c:
//
//  Rename all files which match the wildcard mask.  This function
//  does not use the INT 21h fn 5dh back door call becuase it bypasses
//  network drivers which path int 21h.  It does not use FCB calls
//  because they are not supported in DOS 7.1
//
//  There is not a version of this file yet.  It needs to be cut out
//  of command and placed in a smart function only becuase 7156h does
//  not support wild cards.  Because you have to support LFNs too, you
//  will need all the unicode functions for name and path munipulations
//  as well.  For the sake of time, it was decided to fix it in command
//  which already had the functions rather than making this and all the
//  required functions autonimus.
//
//bool dlWildcardRename( char * szFileName, FIND * pFFBlock,
//		char * szTmpNameAndPath );
//

//  wilddel.c:
//
//  Delete all files which match the wildcard mask.  This function
//  does not use the INT 21h fn 5dh back door call becuase it bypasses
//  network drivers which patch int 21h.  It does not use FCB calls
//  because they are not supported in DOS 7.1
//
bool dlWildcardDelete( char * szFileName, FIND * pFFBlock,
		char * szTmpNameAndPath );

// dirinput.asm : DOS fn 06ffh
//
bool PASCAL dlDirectConsoleInput( char * pcCharacter );

// getkey.asm : DOS fn 08h
//
bool PASCAL dlGetKey( char * pucCharacter );

// getline.asm : DOS fn 0ah
//
bool PASCAL dlGetLine( uchar * pucBuffer );

//  i21f0c07.asm : DOS fn 0c07h
//
bool PASCAL dlFlushAndGetKeyWithEcho( uchar * pucCharacter );

//  i21f0c08.asm : DOS fn 0c08h
//
bool PASCAL dlFlushAndGetKeyNoEcho( uchar * pucCharacter );

//  i21f0c0a.asm : DOS fn 0c0ah
//
bool PASCAL dlFlushAndGetLine( uchar * pucBuffer );

// rsetdisk.asm: DOS fn 0dh
//
bool PASCAL dlResetDisk( void );

// fcbopen.asm: DOS fn 0fh
//
bool PASCAL dlFCBOpen( PFCB pFCB );

// fcbclose.asm: DOS fn 10h
//
bool PASCAL dlFCBClose( PFCB pFCB );

// dlfcbdir.asm: DOS fns 11h, 12h
//
bool PASCAL dlFcbFindFirst(char *pFcb);

// fcbdel.asm: DOS fn 13h
//
bool PASCAL dlFCBDelete( PFCB pFCB );

// fcbcreat.asm: DOS fn 16h
//
bool PASCAL dlFCBCreate( PFCB pFCB );

// dlgetdir.asm: DOS fns 19h, 47h
//
bool PASCAL dlGetCurrentDrive(int *pDrive);
bool PASCAL dlGetCurrentDirectory(int drive, char *pPathName);

// dlsetdir.asm: DOS fns 0Eh, 3Bh
//
bool PASCAL dlSetCurrentDrive(int drive);
bool PASCAL dlSetCurrentDirectory(char *pPathName);

// fcbparse.asm: DOS fn 29h
//
bool PASCAL dlFCBParse( uchar ucParseControlFlag, char * szName, PFCB pFCB );

// dldosdat.asm: DOS fns 2Ah, 2Bh
//
struct DOSDate
{
	unsigned char day;  			// 1-31
	unsigned char month;			// {1=Jan, 2=Feb,...}
	unsigned year; 				// 1980...
	unsigned char dayOfTheWeek;//	{0=Sun, 1=Mon,...}
};
typedef struct DOSDate DOSDate;

bool PASCAL dlGetDOSDate(DOSDate *pDate);
bool PASCAL dlSetDOSDate(DOSDate *pDate);


// dldostim.asm: DOS fns 2Ch, 2Dh
//
struct DOSTime
{
	unsigned char minute;   	// 0-59
	unsigned char hour; 			// 0-23
	unsigned char hundredths; 	// 0-99
	unsigned char second;   	// 0-59
};
typedef struct DOSTime DOSTime;

bool PASCAL dlGetDOSTime(DOSTime *pTime);
bool PASCAL dlSetDOSTime(DOSTime *pTime);


// getver.asm: DOS fns 30h
//
bool PASCAL dlGetDosVersion( unsigned * puDosVersion );


// i21f32.asm: DOS fn 32h
//
bool PASCAL dlGetDriveDPB( uchar ucDriveNumber, LPDPB * pfpDPB );


// dlbreak.asm: DOS fns 3300h, 3301h
//
bool PASCAL dlGetBreakLevel(int *pBreakLevel);
bool PASCAL dlSetBreakLevel(int level);

// Values for DOS break level..
//
#define	BREAK_ON		1
#define	BREAK_OFF	0


// bootdrv.asm: DOS fns 3305h
// bootltr.c: Changes drive number into drive letter
//
bool PASCAL dlGetBootDriveNumber( uchar * pucDriveNumber );
bool PASCAL dlGetBootDriveLetter( uchar * pucDriveLetter );


// _dldfree.asm: DOS fn 36h
// dldfree.c
//
bool PASCAL __dlGetFreeSpaceOnDrive(int drive,
				unsigned *pSectorsPerCluster,
				unsigned *pFreeClusters,
				unsigned *pBytesPerSector,
				unsigned *pTotalClusters);
bool PASCAL dlGetFreeSpaceOnDrive(int drive, ulong *pulFreeSpace);


// DLGTSWCH.ASM: DOS fn 3700h
//
bool PASCAL dlGetSwitchCharacter( unsigned char * pucSwitchChar );


// dldir.asm: DOS fns 39h, 3Ah
//
bool PASCAL dlMakeDirectory(char szPathName[]);
bool PASCAL dlRemoveDirectory(char szPathName[]);


// dlbigdrv.asm:  determine if the number of sectors exceeds 16 bits
//
bool PASCAL dlIsBigDrive(int drive);


// dlopen3.asm: DOS fn 3dh
//
bool PASCAL dlOpenFile( char * szName, uchar ucOpenMode, int * piHandle );


// dlfcreat.asm: DOS fn 3ch
//
bool PASCAL dlCreateFile( unsigned uAttributes, char * szName,
		int * piHandle );


// dlfrdwr.asm: DOS fns 3Fh, 40h
//
bool PASCAL dlReadFile(int handle, unsigned *pByteCount,
		char far * lpBuffer);
bool PASCAL dlWriteFile(int handle, unsigned *pByteCount,
		char far * lpBuffer);


// dldelete.asm: DOS fn 41h
//
bool PASCAL dlDeleteFile(char *pName);


// dlfseek.asm: DOS fn 42h
//
bool PASCAL dlSeekFile(char from, int handle, long *pDistance);

// Location codes for SeekFile. To determine current location (as in ftell())
// just SEEK_CUR 0 bytes.
//
#define SEEK_CUR    1					// from here
#define SEEK_END    2					// from EOF
#define SEEK_SET    0					// from the beginning


// dlfattr.asm: DOS fns 4300h, 4301h
//
bool PASCAL dlGetFileAttributes(char *pName, unsigned *pAttributes);
bool PASCAL dlSetFileAttributes(unsigned attributes, char *pName);


// dldattr.asm: DOS fns 4400h, 4401h
//
bool PASCAL dlGetDeviceAttributes(int handle, unsigned *pAttributes);
bool PASCAL dlSetDeviceAttributes(int handle, int newAttributes);

// device header attributes make up B7-B15 of word from fn 4400h
//
#define DEVA_CHAR		0x8000	/* 1=char, 0=disk device */
#define DEVA_IOCTL	0x4000	/* device supports ioctl calls */
#define DEVA_IBMBLK	0x2000	/* 0=fat, 1=scratch */
#define DEVA_REMOVE	0x0800	/* Removeable media call supported */
#define DEVA_OPNCLS	0x0800	/* Open/Close device call supported */
#define DEVA_QUERY	0x0080	/* query generic IOCTL */
#define DEVA_GENIO	0x0040	/* generic IOCTL */
#define DEVA_RAWMODE 0x0020   /* Raw mode */
#define DEVA_FAST		0x0010	/* INT 29H is supported */
#define DEVA_CLOCK	0x0008	/* this is the CLOCK driver */
#define DEVA_NUL		0x0004	/* this is the NUL driver */
#define DEVA_CON		0x0003	/* this is the CONsole driver */
#define DEVA_32BIT	0x0002	/* device supports 32 bit sectors */

// ioctl bits from SFTs make up B0-B6 of word from fn 4400h
//
#define IO_NETWORK		0x8000
#define IO_SETDATE		0x4000
#define IO_NOCHILD		0x1000 // don't bequeath file (open mode & O_NOCHILD)
#define IO_DEVICE			0x0080
#define IO_NOTEOF			0x0040 // device
#define IO_NOTWRITTEN	0x0040 // file
#define IO_RAW				0x0020
#define IO_FAST			0x0010
#define IO_NUL				0x0008
#define IO_CLK				0x0004
#define IO_CON				0x0003

// dlioctl.asm: DOS fns 4402h, 4403h
//
bool PASCAL dlDeviceIOCTLRead(int handle, unsigned *pLength, void *pBuffer);
bool PASCAL dlDeviceIOCTLWrite(int handle, unsigned *pLength, void *pBuffer);


// DLREMOVE.ASM: DOS fn 4408h
//
bool PASCAL dlIsDriveRemovable( unsigned char ucDriveNumber,
		bool * pbIsRemovable );

// DLREMOTE.ASM: DOS fn 4409h
//
bool PASCAL dlIsDriveRemote( uchar ucDriveNumber, bool * pfIsRemote );

// DLSUBST.ASM: DOS fn 4409h
//
bool PASCAL dlIsDriveSubst( uchar ucDriveNumber, bool * pfIsSubst );

//  GENIOCTL.ASM: DOS fn 440dh (helper function for 440dh calls)
//
bool PASCAL dlGenericIOCTLForBlockDevices( uchar ucDriveNumber,
		uchar ucCategoryCode, uchar ucMinorFunctionCode,
		void * pParameterBlock );

//  SETPARM.C: DOS fn 440dh minor code 40h
//
bool dlSetParametersForBlockDevice( uchar ucDriveNumber,
		void * pParameterBlock );
bool dlSetParameters32ForBlockDevice( uchar ucDriveNumber,
		void * pParameterBlock );

//  FMTIOCTL.C: DOS fn 440dh minor code 42h
//
bool dlIOCTLFormatAndVerifyTrack( uchar ucDriveNumber,
		unsigned uHead, unsigned uTrack,	uchar ucSpecialFunction,
		bool fIsFat32World );

// SETFLAGS.C: DOS fn 440dh minor code 47h
//
bool dlSetAccessFlags( uchar ucDriveNumber, uchar ucAccessFlags,
		bool fFat32World );

// LCKLOG.ASM: DOS fn 440dh minor code 4ah
//
bool PASCAL dlLockLogicalVolume( uchar ucDriveNumber, uchar ucLockLevel,
		unsigned uDrivePermissions );

// LCKPHY.ASM: DOS fn 440dh minor code 4bh
//
bool PASCAL dlLockPhysicalVolume( uchar ucBIOSDriveNumber,
		uchar ucLockLevel, unsigned uDrivePermissions );

//  GETPARM.C: DOS fn 440dh minor code 60h
//
bool dlGetParametersForBlockDevice( uchar ucDriveNumber,
		void * pParameterBlock );
bool dlGetParameters32ForBlockDevice( uchar ucDriveNumber,
		void * pParameterBlock );

// GETFLAGS.C: DOS fn 440dh minor code 67h
//
bool dlGetAccessFlags( uchar ucDriveNumber, bool fFat32World,
		uchar * pucAccessFlags );

// UNLCKLOG.ASM: DOS fn 440dh minor code 6ah
//
bool PASCAL dlUnlockLogicalVolume( uchar ucDriveNumber );

// UNLCKPHY.ASM: DOS fn 440dh minor code 6bh
//
bool PASCAL dlUnlockPhysicalVolume( uchar ucBIOSDriveNumber );

// GTDRVMAP.ASM: DOS fn 440eh
//
//  ucDriveNumber (0=unknown,1=A,2=B, etc)
//
bool PASCAL dlGetLogicalDriveMap( uchar ucDriveNumber,
		uchar * MappedDriveNumber );

// STDRVMAP.ASM: DOS fn 440fh
//
//  ucDriveNumber (0=unknown,1=A,2=B, etc)
//
bool PASCAL dlSetLogicalDriveMap( uchar ucDriveNumber );

// DLALLOC.ASM: DOS fn 48h
//
bool PASCAL dlAllocMem( unsigned uNumberOfParagraphs,	unsigned * puSegment );

// DLFREMEM.ASM: DOS fn 49h
//
bool PASCAL dlFreeMem( unsigned uSegment );

// DLRESIZE.ASM: DOS fn 4ah
//
bool PASCAL dlResizeMem( unsigned uNewNumberOfParagraphs,
		unsigned uSegment, unsigned * puAvailPargraphs );

// exec00.asm: DOS fn 4b00h
//
bool PASCAL dlExec( char * szExecName, union EXEPARM * pLoadArgs );

// exec01.asm: DOS fn 4b01h
//
bool PASCAL dlExecLoad( char * szExecName, union EXEPARM * pLoadArgs );

// dlffirst.asm: DOS fns 1Ah, 2Fh, 4Eh, 4Fh
//
bool PASCAL dlGetDTA(void * pfpDTAAddress);
bool PASCAL dlSetDTA(void far * pNewDTA);
bool PASCAL dlFindFirstFile(unsigned uAttributes, char * szPathAndName);
bool PASCAL dlFindNextFile(void);


// dlgetlol.asm: 	int 21h fn 52h
//					  	Fills in a far pointer to the START of the LOL, not to the
//					  	head of the list of DPBs in the middle of the LOL as int
//						21h fn 52h does...
// gtdrvdpb: 		get the DPB for a drive from the LOL
// gtdrvcds: 		get the CDS for a drive from the LOL
// gtdrvddt:		get the DDT for a drive
// dlgetddt:		get address of the first DDT
//
bool PASCAL dlGetLOLPointer(LPLOL *plpLOL);
bool PASCAL dlGetCDSForDrive(uchar ucDriveNumber, LPCDS *plpCDS);
bool PASCAL dlGetDPBForDrive(uchar ucDriveNumber, LPDPB *plpDPB);
bool PASCAL dlGetDDTForDrive(uchar ucDriveNumber, LPDDT *plpDDT);
bool PASCAL dlGetFirstDDT(LPDDT * plpDDT );

void far * PASCAL dlGetLOL( void );  //  DREWG's version

// dlrename.asm: DOS fn 56h
//
bool PASCAL dlRenameFileOrDirectory(char *pOldName, char *pNewName);


// dlftime.asm: DOS fns 5700h, 5701h
//
struct DOSFileTime {unsigned second:5, minute:6, hour:5; };
struct DOSFileDate {unsigned day:5,    month:4,  year:7; };
typedef struct DOSFileTime DOSFileTime;
typedef struct DOSFileDate DOSFileDate;

bool PASCAL dlGetFileDateAndTime(int handle, DOSFileTime *pTime,
		DOSFileDate *pDate);
bool PASCAL dlSetFileDateAndTime(int handle, DOSFileTime *pTime,
		DOSFileDate *pDate);

// getxerr.asm: DOS fn 59h
//
bool PASCAL dlGetExtendedErrorInfo( unsigned * puExtendedErrorCode,
	 	uchar * pucErrorClass, uchar * pucRecomendAction,
		uchar * pucErrorLocus );


// i21f5a.asm: DOS fn 5ah
//
bool PASCAL dlCreateUniqueFile( unsigned uAttrib, char * szPath,
									  unsigned * uHandle );


// dlfcrea2.asm: DOS fn 5bh
//
bool PASCAL dlCreateNewFile( unsigned uAttributes, char * szName,
		int * piHandle );


// expand.asm: DOS fn 60h
//
bool PASCAL dlExpandPath( char * szRelativePath, char * szAbsolutePath );


// dldbcs.asm: DOS fn 63h
//
void far * PASCAL dlGetDBCS(void);


//  cntryinf.asm : DOS fn 65h
//
bool PASCAL dlGetCountryInfo( uchar ucInfoType, unsigned uCodePage,
		unsigned uDataAmount, unsigned uCountryID, uchar * pBuffer );


// dlcommit.asm: DOS fn 68h
//
bool PASCAL dlCommitFile(int handle);


// dlfopen.asm: DOS fns 6Ch, 3Eh
//
bool PASCAL dlOpenOrCreateFile(unsigned openMode,unsigned attributes,
			     unsigned *pAction,char *pName,int *pHandle);
bool PASCAL dlCloseFile(int handle);

// openMode values for OpenOrCreatFile()
//
#if !defined(O_RDONLY)
#define O_RDONLY     0x0000
#define O_WRONLY     0x0001
#define O_RDWR       0x0002
#define O_RESERVED   0x0008   /* must not be used - reserved */
#define O_DENYOPEN   0x0010
#define O_DENYWRITE  0x0020
#define O_DENYREAD   0x0030
#define O_DENYNONE   0x0040
#define O_SHARE      0x0070   /* share bits */
#define O_SHARESHFT  4
#define O_NOCHILD    0x0080
#define O_NO24       0x2000
#define O_WRITENOW   0x4000
#endif

// file/directory attributes for OpenOrCreateFile() and FindFirst()
//
#define A_NORMAL     0x00           // OK for OpenOrCreatFile()
#define A_READONLY   0x01           // OK for OpenOrCreatFile()
#define A_HIDDEN     0x02           // OK for OpenOrCreatFile()
#define A_SYSTEM     0x04           // OK for OpenOrCreatFile()
#define A_VOLUME     0x08
#define A_LONGNAME   0x0F           // a long filename
#define A_SUBDIR     0x10
#define A_ARCHIVE    0x20           // OK for OpenOrCreatFile()
#define A_DEVICE     0x40

//  action values for OpenOrCreatFile() (input *pAction values)
//
#define ACT_EXIST_OPEN     0x0001	// fail if file does not exist
#define ACT_EXIST_REPLACE  0x0002   // truncates file on open
#define ACT_NEXIST_CREATE  0x0010	// fail if file exists

// action values returned by OpenOrCreatFile()
//
#define ACTION_OPENED      1
#define ACTION_CREATED     2
#define ACTION_TRUNCATED   3

// standard file handles
#define	STDIN		0
#define  STDOUT   1
#define  STDERR   2
#define  STDAUX   3
#define  STDPRN   4


// isromdos.asm: Int 21h fn 0DBh: Is romdos the current OS?
//
bool PASCAL dlIsRunningRomdos( void );

// trurdver.asm: Int 21h fn 30dbh minor 3h: Compatibility version
//
bool PASCAL dlKernelSupportVersion( unsigned * puVersion );

// absdskrd.c: Int 25h absolute sector read
//
bool PASCAL dlAbsDiskRead(int iDriveNumber, int iNumberOfSectors,
		long lStartingSectorNumber, void far * lpBuffer);

// absdskwr.c: Int 26h absolute sector write
//
bool PASCAL dlAbsDiskWrite(int iDriveNumber, int iNumberOfSectors,
		long lStartingSectorNumber, void far * lpBuffer);

// absread.c: Int 25h absolute sector read (Borland like)
//
int absread(int drive, int nsects, long lsect, void * buffer);

// abswrite.c: Int 26h absolute sector write (Borland like)
//
int abswrite(int drive, int nsects, long lsect,	void * buffer);

// dlbigdrv.asm:  determine if the number of sectors exceeds 16 bits
//
bool PASCAL dlIsBigDrive(int drive);

// dlabsrd.asm: Int 25h absolute sector read
//
bool PASCAL dlAbsRead(bool bIsBig, int iDrive, int iSects, long lStart,
		void far * lpBuffer);

// dlabswr.asm: Int 26h absolute sector write
//
bool PASCAL dlAbsWrite(bool bIsBig, int iDrive, int iSects, long lStart,
		void far * lpBuffer);


// The following functions are only available on ROM-DOS v7.1 or later
// or Win95 OSR/2 or later.
//
#if USING_FAT32

// drvfre32.asm: 	int 21h fn 7303h
// 				  	Fills in the user supplied structure with FAT32
//					  	drive space information.
//
bool PASCAL dlGetDriveFreeSpace32( char * pszDriveString,
		PGDF32 psFreeSpace );

// dldfre32.c: 	provides a single interface to either int 21h fn 7303h
// 					(FAT32/16/12) or to int 21h fn 36h (FAT16/12 only).
//
bool PASCAL SmartGetFreeSpace( int iDrive, PGDF32 pDiskSpace );


// setdpb.asm: DOS fn 7304h
//
bool PASCAL dlSetDBPForFormat( uchar ucDriveNumber, void * pParmBlock );


// absrd32.asm: 	Int 21h function 7305h in read mode
// abswr32.asm: 	Int 21h function 7305h in write mode
// 					These are FAT32 logical sector reads/writes
//
bool PASCAL dlAbsRead32(int iDrive, int iSects, long lStart,
		void far * lpBuffer);
bool PASCAL dlAbsWrite32(int iDrive, int iSects, long lStart,
		void far * lpBuffer, int iFlags);

#define	ABS32WRITE_UNKNOWN      0x0001
#define	ABS32WRITE_FAT          0x2001
#define	ABS32WRITE_DIRECTORY    0x4001
#define	ABS32WRITE_NORMAL   		0x6001


// dlgdpb32.asm	Int 21h fn 7302h, get extended (FAT32) DPB
//
bool PASCAL dlGetExtDPB( int iDrive, int iBufferSize, void * pBuffer );

#endif  // USING_FAT32

#endif  //!defined(DLDOSIO_H)
