//
//   $Id: DLERRCOD.H 1.4 2002/10/15 21:41:22Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//   ERRCODES.H
//   Standard Datalight error code values
//   Created 04-28-97 Dennis Edwards
//
//   Copyright (c) 1997-2002 Datalight, Inc.
//   All Rights Reserved.
//   Datalight Confidential and Proprietary
//

#define ERR_NONE                        0     // all OK
#define ERR_INVALID_FUNCTION            0x01  // invalid function
#define ERR_FILE_NOT_FOUND              0x02  // file not found
#define ERR_PATH_NOT_FOUND              0x03  // path not found
#define ERR_TOO_MANY_FILES              0x04  // too many open files
#define ERR_ACCESS_DENIED               0x05  // access denied
#define ERR_INVALID_HANDLE              0x06  // invalid handle
#define ERR_ARENA_TRASHED               0x07  // memory arena trashed
#define ERR_NOT_ENOUGH_MEMORY           0x08  // not enough memory
#define ERR_INVALID_BLOCK               0x09  // invalid block
#define ERR_BAD_ENVIRONMENT             0x0A  // bad environment
#define ERR_BAD_FORMAT                  0x0B  // bad format error
#define ERR_INVALID_ACCESS              0x0C  // invalid access
#define ERR_INVALID_DATA                0x0D  // invalid data

// reserved                             0x0E

#define ERR_INVALID_DRIVE               0x0F  // invalid drive
#define ERR_CURRENT_DIRECTORY           0x10  // current directory error
#define ERR_NOT_SAME_DEVICE             0x11  // not same device
#define ERR_NO_MORE_FILES               0x12  // no more files
#define ERR_WRITE_PROTECT               0x13  // attempted write to protected media
#define ERR_BAD_UNIT                    0x14  // unknown unit
#define ERR_DRIVE_NOT_READY             0x15  // drive not ready
#define ERR_UNKNOWN_COMMAND             0x16  // unknown command
#define ERR_CRC                         0x17  // data error (bad CRC)
#define ERR_BAD_LENGTH                  0x18  // bad request structure length
#define ERR_SEEK                        0x19  // disk seek error
#define ERR_UNKNOWN_MEDIA_TYPE          0x1A  // unknown media type
#define ERR_SECTOR_NOT_FOUND            0x1B  // specified sector not found
#define ERR_OUT_OF_PAPER                0x1C  // printer is out of paper
#define ERR_WRITE_FAULT                 0x1D  // write fault
#define ERR_READ_FAULT                  0x1E  // read fault
#define ERR_GENERAL_FAILURE             0x1F  // general failure
#define ERR_SHARING_VIOLATION           0x20  // sharing violation
#define ERR_LOCK_VIOLATION              0x21  // locking violation
#define ERR_INVALID_DISK_CHANGE         0x22  // invalid disk change
#define ERR_FCB_UNAVAILABLE             0x23  // File Control Block unavailable
#define ERR_SHARING_BUFFER_EXCEEDED     0x24  // sharing buffer overflow
#define ERR_CODE_PAGE_MISMATCH          0x25
#define ERR_HANDLE_EOF                  0x26
#define ERR_HANDLE_DISK_FULL            0x27

// reserved                             0x28
// reserved                             0x29
// reserved                             0x2A
// reserved                             0x2B
// reserved                             0x2C
// reserved                             0x2D
// reserved                             0x2E
// reserved                             0x2F
// reserved                             0x30
// reserved                             0x31

#define ERR_NOT_SUPPORTED               0x32  // network request not supported
#define ERR_REMOTE_NOT_LISTENING        0x33  // remote computer not listening
#define ERR_DUP_NET_NAME                0x34  // duplicate name on network
#define ERR_NET_NAME_NOT_FOUND          0x35  // network name not fond
#define ERR_NET_BUSY                    0x36  // network busy
#define ERR_NET_DEVICE_GONE             0x37  // network device no longer exists
#define ERR_NET_CMD_LIMIT               0x38  // net BIOS command limit exceeded
#define ERR_BAD_NET_HARDWARE            0x39  // network adapter hardware error
#define ERR_BAD_NET_RESPONSE            0x3A  // incorrect response from network
#define ERR_UNEXPECTED_NET              0x3B  // unexpected network error
#define ERR_BAD_REMOTE_HARDWARE         0x3C  // incompatible remote adapter
#define ERR_PRINT_Q_FULL                0x3D  // print queue full
#define ERR_NO_PRINT_FILE_SPACE         0x3E  // not enough space for print file
#define ERR_PRINT_FILE_DELETED          0x3F  // print file was deleted
#define ERR_NET_NAME_DELETED            0x40  // network name was deleted
#define ERR_NET_ACCESS_DENIED           0x41  // access denied
#define ERR_NET_DEV_TYPE_BAD            0x42  // network device type incorrect
#define ERR_NET_NAME_NOT_FOUND_1        0x43  // (??? - dup of error 35h?)
#define ERR_NET_NAME_LIMIT              0x44  // network name limit exceeded
#define ERR_NET_SESSION_LIMIT           0x45  // net BIOS session limit exceeded
#define ERR_TEMP_PAUSE                  0x46  // temporarily paused
#define ERR_NET_REQUEST_REJECTED        0x47  // network request not accepted
#define ERR_REDIR_PAUSED                0x48  // print or disk redirection is paused

// reserved                             0x49
// reserved                             0x4A
// reserved                             0x4B
// reserved                             0x4C
// reserved                             0x4D
// reserved                             0x4E
// reserved                             0x4F

#define ERR_FILE_EXISTS                 0x50  // file already exists
#define ERR_DUP_FCB                     0x51  // FCB already exists
#define ERR_CANNOT_MAKE                 0x52  // cannot make item (directory)
#define ERR_INT_24_FAILURE              0x53  // fail returned on intr. 0x24
#define ERR_OUT_OF_STRUCS               0x54  // too many redirections
#define ERR_ALREADY_ASSIGNED            0x55  // duplicate redirection
#define ERR_INVALID_PASSWORD            0x56  // invalid password
#define ERR_INVALID_PARAMETER           0x57  // invalid parameter
#define ERR_NET_DATA_FAULT              0x58  // network data fault

#define ERR_SYS_COMPONENT_NOT_LOADED    5Ah   // missing system component

// from European DOS 4.x (multi-tasking variant not sold in USA)
//
#define ERR_NO_PROC_SLOTS               0x59  // no process slots available
#define ERR_NOT_FROZEN                  0x5A  // not frozen error
#define ERR_TIMER_OVERFLOW              0x5B  // timer service table overflow
#define ERR_TIMER_DUP                   0x5C  // timer service table duplicate
#define ERR_NO_ITEMS                    0x5D  // no items found to work on
#define ERR_SYSTEM_INTERRUPTED          0x5E  // system call interrupted
#define ERR_TOO_MANY_SEMAPHORES         0x5F  // too many semaphores
#define ERR_EXCLUSIVE_SEMAPHORE         0x60  // exclusive semaphore already owned
#define ERR_SEMAPHORE_SET               0x61  // semaphore was already set

// OMNIVIEW error definitions
//
#define ERR_NOT_FIRST_IN_CHAIN          0x62  // access blocked by later chained item(s)
#define ERR_CHAINING_FAULT              0x63  // item(s) unexpectedly deleted from chain
#define ERR_TABLE_OVERFLOW              0x64  // table was already full
#define ERR_TABLE_UNDERFLOW             0x65  // table was already empty
#define ERR_TABLE_DUPLICATE             0x66  // unique item already in table

// reserved                             0x67
// reserved                             0x68
// reserved                             0x69
// reserved                             0x6A
// reserved                             0x6B
// reserved                             0x6C
// reserved                             0x6D
// reserved                             0x6E
// reserved                             0x6F
// reserved                             0x70
// reserved                             0x71
// reserved                             0x72
// reserved                             0x73
// reserved                             0x74
// reserved                             0x75
// reserved                             0x76
// reserved                             0x77
// reserved                             0x78
// reserved                             0x79
// reserved                             0x7A
// reserved                             0x7B
// reserved                             0x7C
// reserved                             0x7D
// reserved                             0x7E
// reserved                             0x7F

// Datalight application error codes
//
#define ERR_INTERNAL                    0x80  // use with ASSERT()
#define ERR_USER_ABORT                  0x81  // ^C, ^Brk, Abort on int 24h, etc.
#define ERR_PARAMETER_MISSING           0x82  // required input missing











