;  $Id: MACROS.INC 1.5 2003/03/20 17:16:58Z thomd Exp $
;
;  *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;  Copyright (c) 1989-2003 Datalight, Inc.
;  All Rights Reserved
;
;  Datalight, Inc. is a Washington corporation located at:
;
;  21520 30th Dr SE, Suite 110,          Tel: +1.425.951.8086
;  Bothell, WA  98021                    Fax: +1.425.951.8094
;  USA                                   Http://www.datalight.com
;
;  This software, including without limitation all source code and
;  documentation, is the confidential, trade secret property of
;  Datalight, Inc., and is protected under the copyright laws of
;  the United States and other jurisdictions.  Portions of the
;  software may also be subject to one or more the following US
;  patents: US#5860082, US#6260156.
;
;  In addition to civil penalties for infringement of copyright
;  under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;  penalties for violation of (a) the restrictions on circumvention
;  of copyright protection systems found in 17 U.S.C. 1201 and
;  (b) the protections for the integrity of copyright management
;  information found in 17 U.S.C. 1202.
;
;  U.S. Government Restricted Rights.  Use, duplication,
;  reproduction, or transfer of this commercial product and
;  accompanying documentation is restricted in accordance with
;  FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;  PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;  AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;  INC. AND THE LICENSEE ("BINDING AGREEMENT").  YOUR RIGHT, IF ANY,
;  TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;  TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;  USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;  TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT.  CONTACT
;  DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;  THIS SOFTWARE IN ERROR.
;
COMMENT ~
-----------------------------------------------------------

   MACROS.INC  created  02/15/89  by Drew Gislason

   Copyright (c) 1989-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   These macros make writing ROM-DOS assembly code a snap!
   That is: quite simple, easy, insouciant, unimaginiably
   trivial, and much less than perplexing.

----------------------------------------------------------- ~


IFDEF FAR_LFN
USING_FARLFN	= 	1
ELSE
USING_FARLFN	= 	0
ENDIF

IF USING_FARLFN

cBegCode	macro	module
_LFN_TEXT	segment	byte public 'CODE'
	assume	cs:_LFN_TEXT
	endm

cEndCode	macro	module
_LFN_TEXT	ENDS
	endm

ELSE	; IF USING_FARLFN

cBegCode	macro	module
_TEXT	segment	byte public 'CODE'
	assume	cs:_TEXT
	endm

cEndCode	macro	module
_TEXT	ENDS
	endm

ENDIF	; IF USING_FARLFN

cBegData	macro
_DATA	segment byte public 'DATA'
_DATA	ends

_BSS	segment byte public 'BSS'
_BSS	ends

; group definitions
DGROUP	GROUP	_DATA,_BSS

_DATA	segment
	assume DS:DGROUP
	ENDM

cEndData	MACRO
_DATA	ENDS
	ENDM

cBegUdata	MACRO
_DATA	segment byte public 'DATA'
_DATA	ends

_BSS	segment byte public 'BSS'
_BSS	ends

DGROUP	group	_DATA,_BSS

_BSS	segment
	assume DS:DGROUP
	endm

cEndUdata	MACRO
_BSS	ENDS
	ENDM

; hineous macros
SPTR		equ	1
LPTR		equ	0
SAVESIDI	equ	1
SIZEPTR		equ	2	; Size of a pointer
ESEQDS		equ	1


COMMENT ~ ----------------------------------------------------------
	SOME OTHER HANDY MACROS

	func		; declares a function callable from C
	callm		; calls a C function
	P		; offset of first parameter on stack


func	name			; function declaration
	PUSH	BP
	MOV	BP,SP
	.
	.
	MOV	AX,P[BP]	; get first argument (word)
	MOV	BX,P+2[BP]	; get next argument (word)
	.
	callm	a_routine	; call a C routine from assembly
	MOV	BX,AX		; return value (if any) is in AX
	.
	POP	BP
	RET
name	endp
---------------------------------------------------------------- ~

P	equ	4
GOFFSET	EQU	<OFFSET DGROUP:>


c_func	macro	name
	public	_&name
	name equ _&name
_&name	proc	near
	endm

c_endp	macro	name
_&name	endp
	endm

c_callm	macro	name
	call	near ptr _&name
	endm

c_public macro	a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
    ifnb <a>			; recursve check for blank argument
	public	_&a
	a equ _&a
      ifnb <b>
	c_public b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      endif
    endif
	endm

c_extrn	macro	a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
    ifnb <a>			; recursive check for blank argument
	extrn	_&a:b
	a equ _&a
      ifnb <c>
	c_extrn	c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      endif
    endif
	endm
