//
//   $Id: stdc.h 1.9 2002/10/15 21:43:06Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*****************************************************************************
	$DOCMODULE: STDC.H

   Copyright (c) 2001-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   Header file for the standard C libraries

	$DOCHISTORY:
   04-11-2001 bt 	created

*****************************************************************************/

#if !defined( STDC_H )
#define       STDC 1


//  memcpy
//  _fmemcpy
//
void * memcpy( void * pDest, const void * pSrc, unsigned uSize );
#if !defined(__LARGE__)
void far * far _fmemcpy( void far * pDest, const void far * pSrc, unsigned uSize );
#else
#define _fmemcpy(pDest, pSrc, uSize) memcpy((pDest), (pSrc), (uSize))
#endif


//  memccpy
//  _fmemccpy
//
void * memccpy( void * pDest, const void * pSrc, int iCharacter,
		unsigned uSize );
#if !defined(__LARGE__)
void far * far _fmemccpy( void far * pDest, const void far * pSrc, int iCharacter,
		unsigned uSize );
#else
#define _fmemccpy(pDest, pSrc, ucCharacter, uSize) memccpy((pDest), (pSrc), (ucCharacter), (uSize))
#endif


//  memchr
//  _fmemchr
//
void * memchr( const void * pSrc, int iCharacter, unsigned uSize );
#if !defined(__LARGE__)
void far * far _fmemchr( const void far * pSrc, int iCharacter, unsigned uSize );
#else
#define _fmemchr( pSrc, iCharacter, uSize ) memchr( (pSrc), (iCharacter), (uSize) )
#endif


//  memcmp
//  _fmemcmp
//
int memcmp( const void * pS1, const void * pS2, unsigned uSize );
#if !defined(__LARGE__)
int far _fmemcmp( const void far * pS1, const void far * pS2, unsigned uSize );
#else
#define _fmemcmp( pS1, pS2, uSize ) memcmp( (pS1), (pS2), (uSize) )
#endif


//  memicmp
//  _fmemicmp
//
int memicmp( const void * pS1, const void * pS2, unsigned uSize );
#if !defined(__LARGE__)
int far _fmemicmp( const void far * pS1, const void far * pS2, unsigned uSize );
#else
#define _fmemicmp( pS1, pS2, uSize ) memicmp( (pS1), (pS2), (uSize) )
#endif


//  memmove
//  _fmemmove
//
void * memmove( void * pDest, const void * pSrc, unsigned uSize );
#if !defined(__LARGE__)
void far * far _fmemmove( void far * pDest, const void far * pSrc, unsigned uSize );
#else
#define _fmemmove(pDest, pSrc, uSize) memmove((pDest), (pSrc), (uSize))
#endif


//  memset
//  _fmemset
//
void * memset( void * pData, int iValue, unsigned uSize );
#if !defined(__LARGE__)
void far * far _fmemset( void far * pData, int iValue, unsigned uSize );
#else
#define _fmemset(pData, iValue, uSize) memset((pData), (iValue), (uSize))
#endif


//  stpcpy
//  _fstpcpy
//
char * stpcpy( char * szDest, const char * szSrc );
#if !defined(__LARGE__)
char far * far _fstpcpy( char far * szDest, const char far * szSrc );
#else
#define _fstpcpy(szDest, szSrc) stpcpy((szDest), (szSrc))
#endif


//  strcat
//  _fstrcat
//
char * strcat( char * szDest, const char * szSrc );
#if !defined(__LARGE__)
char far * far _fstrcat( char far * szDest, const char far * szSrc );
#else
#define _fstrcat( szDest, szSrc ) strcat( (szDest), (szSrc) )
#endif


//  strchr
//  _fstrchr
//
char * strchr( const char * szString, int iCharacter );
#if !defined(__LARGE__)
char far * far _fstrchr( const char far * szString, int iCharacter );
#else
#define _fstrchr( szString, iCharacter ) strchr( (szString), (iCharacter) )
#endif


//  strcmp
//  _fstrcmp
//
int strcmp( const char * szDest, const char * szSrc );
#if !defined(__LARGE__)
int far _fstrcmp( const char far * szDest, const char far * szSrc );
#else
#define _fstrcmp(szDest, szSrc) strcmp((szDest), (szSrc))
#endif


//  strcmpi
//  _fstrcmpi
//
#define strcmpi(s1,s2) stricmp(s1,s2)
#define _fstrcmpi(s1,s2) _fstricmp(s1,s2)


//  strcpy
//  _fstrcpy
//
char * strcpy( char * szDest, const char * szSrc );
#if !defined(__LARGE__)
char far * far _fstrcpy( char far * szDest, const char far * szSrc );
#else
#define _fstrcpy(szDest, szSrc) strcpy((szDest), (szSrc))
#endif


//  strcspn
//  _fstrcspn
//
unsigned strcspn( const char * szString, const char * szContains );
#if !defined(__LARGE__)
unsigned far _fstrcspn( const char far * szString, const char far * szContains );
#else
#define _fstrcspn(szString, szContains) strcspn((szString), (szContains))
#endif


//  stricmp
//  _fstricmp
//
int stricmp( const char * szDest, const char * szSrc );
#if !defined(__LARGE__)
int far _fstricmp( const char far * szDest, const char far * szSrc );
#else
#define _fstricmp(szDest, szSrc) stricmp((szDest), (szSrc))
#endif


//  strlen
//  _fstrlen
//
unsigned strlen( const char * szString );
#if !defined(__LARGE__)
unsigned far _fstrlen( const char far * szString );
#else
#define _fstrlen( szString ) strlen( (szString) )
#endif


//  strlwr
//  _fstrlwr
//
char * strlwr( char * szString );
#if !defined(__LARGE__)
char far * far _fstrlwr( char far * szString );
#else
#define _fstrlwr( szString ) strlwr( (szString) )
#endif


//  strncat
//  _fstrncat
//
char * strncat( char * szDest, const char * szSrc, unsigned uSize );
#if !defined(__LARGE__)
char far * far _fstrncat( char far * szDest, const char far * szSrc, unsigned uSize );
#else
#define _fstrncat( szDest, szSrc, uSize ) strncat( (szDest), (szSrc), (uSize) )
#endif


//  strncmp
//  _fstrncmp
//
int strncmp( const char * szDest, const char * szSrc, unsigned uSize );
#if !defined(__LARGE__)
int far _fstrncmp( const char far * szDest, const char far * szSrc, unsigned uSize );
#else
#define _fstrncmp(szDest, szSrc, uSize) strncmp((szDest), (szSrc), (uSize))
#endif


//  strncmpi
//  _fstrncmpi
//
#define strncmpi(s1,s2,n) strnicmp(s1,s2,n)
#define _fstrncmpi(s1,s2,n) _fstrnicmp(s1,s2,n)


//  strncpy
//  _fstrncpy
//
char * strncpy( char * szDest, const char * szSrc, unsigned uSize );
#if !defined(__LARGE__)
char far * far _fstrncpy( char far * szDest, const char far * szSrc, unsigned uSize );
#else
#define _fstrncpy(szDest, szSrc, uSize ) strncpy((szDest), (szSrc), (uSize))
#endif


//  strnicmp
//  _fstrnicmp
//
int strnicmp( const char * szDest, const char * szSrc, unsigned uSize );
#if !defined(__LARGE__)
int far _fstrnicmp( const char far * szDest, const char far * szSrc, unsigned uSize );
#else
#define _fstrnicmp(szDest, szSrc, uSize) strnicmp((szDest), (szSrc), (uSize))
#endif


//  strnset
//  _fstrnset
//
char * strnset( char * szString, int iCharacter, unsigned uSize );
#if !defined(__LARGE__)
char far * far _fstrnset( char far * szString, int iCharacter, unsigned uSize );
#else
#define _fstrnset( szString, iCharacter, uSize ) strnset((szString), (iCharacter), (uSize))
#endif


//  strrchr
//  _fstrrchr
//
char * strrchr( const char * szString, int iCharacter );
#if !defined(__LARGE__)
char far * far _fstrrchr( const char far * szString, int iCharacter );
#else
#define _fstrrchr( szString, iCharacter ) strrchr( (szString), (iCharacter) )
#endif


//  strset
//  _fstrset
//
char * strset( char * szString, int iCharacter );
#if !defined(__LARGE__)
char far * far _fstrset( char far * szString, int iCharacter );
#else
#define _fstrset( szString, iCharacter ) strset( (szString), (iCharacter) )
#endif


//  strspn
//  _fstrspn
//
unsigned strspn( const char * szString, const char * szContains );
#if !defined(__LARGE__)
unsigned far _fstrspn( const char far * szString, const char far * szContains );
#else
#define _fstrspn(szString, szContains) strspn((szString), (szContains))
#endif


//  strupr
//  _fstrupr
//
char * strupr( char * szString );
#if !defined(__LARGE__)
char far * far _fstrupr( char far * szString );
#else
#define _fstrupr( szString ) strupr( (szString) )
#endif


//  toupper
//
int tolower( int iCharacter );


//  toupper
//
int toupper( int iCharacter );


//  <extracted from borland>
//
int atoi( const char * szString );
long atol( const char * szString );


//  printf*.c (also uses lib\comnsrc\printf.c)
//
#define STDOUT 1
#define STDERR 2
int fprintf( int iHandle, const char * szFormat, ... );
int printf( const char * szFormat, ... );
int sprintf( char * szUserBuffer, const char * szFormat, ...);
int vprintf( const char * szFormat, void * ArgList );
int vfprintf( int iHandle, const char * szFormat, void * ArgList );
int vsprintf( char * szUserBuffer, const char * szFormat, void * ArgList );


//  for use with the fn(...) argument lists
//
typedef void * va_list;
#define va_start(ap, parmN) ((void)((ap) = (va_list)((char *)(&parmN)+((sizeof(parmN)+1) & 0xFFFE))))
#define va_arg(ap, type) (*(type *)(((*(char * *)&(ap))+=((sizeof(type)+1) & 0xFFFE))-(((sizeof(type)+1) & 0xFFFE))))
#define va_end(ap)          ((void)0)



//  This function is built into STDOS.ASM
//
void exit( unsigned char ucExitCode );


//  gtenvptr.c
//
//  This is a replacement function for Borland's getenv().  However, note
//  that this function returns a far pointer.
//
char far * GetEnvEntry( const char * szName );


//  outportb.asm
//
#define outp( uPortNumber, ucValue ) outportb( uPortNumber, ucValue );
unsigned char outportb( unsigned uPortNumber, unsigned char ucValue );


//  outport.asm
//
unsigned outport( unsigned uPortNumber, unsigned uValue );


//  inportb.asm
//
char inportb( unsigned uPortNumber );


//  inport.asm
//
unsigned inport( unsigned uPortNumber );


//  clock.c
//
unsigned long clock( void );


#endif  //!defined(STDC_H)
