;  $Id: DEVCOM.ASM 1.8 2003/03/20 17:03:56Z thomd Exp $
;
;  *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;  Copyright (c) 1989-2003 Datalight, Inc.
;  All Rights Reserved
;
;  Datalight, Inc. is a Washington corporation located at:
;
;  21520 30th Dr SE, Suite 110,          Tel: +1.425.951.8086
;  Bothell, WA  98021                    Fax: +1.425.951.8094
;  USA                                   Http://www.datalight.com
;
;  This software, including without limitation all source code and
;  documentation, is the confidential, trade secret property of
;  Datalight, Inc., and is protected under the copyright laws of
;  the United States and other jurisdictions.  Portions of the
;  software may also be subject to one or more the following US
;  patents: US#5860082, US#6260156.
;
;  In addition to civil penalties for infringement of copyright
;  under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;  penalties for violation of (a) the restrictions on circumvention
;  of copyright protection systems found in 17 U.S.C. 1201 and
;  (b) the protections for the integrity of copyright management
;  information found in 17 U.S.C. 1202.
;
;  U.S. Government Restricted Rights.  Use, duplication,
;  reproduction, or transfer of this commercial product and
;  accompanying documentation is restricted in accordance with
;  FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;  PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;  AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;  INC. AND THE LICENSEE ("BINDING AGREEMENT").  YOUR RIGHT, IF ANY,
;  TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;  TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;  USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;  TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT.  CONTACT
;  DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;  THIS SOFTWARE IN ERROR.
;
COMMENT ~
----------------------------------------------------------

   DEVCOM.ASM  created 05/11/89  by Drew Gislason

   Copyright (c) 1989-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   This file contains the internal (built-in) serial port
   device driver for ROM-DOS.  This device is actually 5
   devices with the names of "AUX", "COM1", "COM2", "COM3"
   and "COM4".

---------------------------------------------------------- ~
include macros.inc
include devhdr.inc
include profile.inc

PUBLIC	_comx

; BIOS interrupts used
BIOSCOM		EQU 14H		; serial
BIOSEQUIP	EQU 11H		; equipment list

;----------------------------------------------------------------------
;
;		The Device Header
;
cBegCode
	EXTRN	dev_serv:near
	EXTRN	dev_cmd_err:near, dev_err_exit:near
	EXTRN	dev_busy_exit:near, dev_err_cnt:near
	EXTRN	dev_exit:near

cmdtbl:
	DW	com_init	; 0  - INIT
	DW	dev_cmd_err	; 1  - MEDIA CHK (reserved for block devs)
	DW	dev_exit	; 2  - BUILD BPB			""
	DW	dev_cmd_err	; 3  - IOCTL INPUT (not enabled)
	DW	com_read	; 4  - READ
	DW	com_ndread	; 5  - NON_DESTRUCTIVE READ
	DW	dev_cmd_err	; 6  - INPUT STATUS
	DW	dev_cmd_err	; 7  - INPUT FLUSH
	DW	com_write	; 8  - WRITE
	DW	com_write	; 09 - WRITE W/ VERIFY
	DW	dev_busy_exit	; 0A - OUTPUT STATUS
cmdend:

IF 0
	DW	com_write	; 9  - WRITE W/VERFIY
	DW	com_outstat	; 10 - OUTPUT STATUS
ENDIF

cEndCode

cBegData
	EXTRN	_ptrsav:DWORD
cEndData

_DEVDATA segment byte public 'DEVDATA'

	ASSUME CS:_DEVDATA, DS:_DEVDATA
	EXTRN	dev_fstrat:NEAR, cmd_ptr:DWORD
	EXTRN	nul_serv:NEAR
	EXTRN	dev_dgroup:word


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	The Device Header (in DATA)
;
; total header length is 20 bytes
DEV_HDR_LEN equ 20
; service offset in header is at byte 8
SERV_OFF equ 8
; offset of "retries" and "port #"
RETRY_OFF equ 18

_comx:
	DW	offset _com1,-1
	DW	8000H
	DW	offset dev_fstrat
	DW	offset com_serv_aux
	DB	"AUX     ",0,0

; alternate device headers
	public	_com1
_com1:
	DW	offset _com2,-1		; 0
	DW	8000H			; 4
	DW	offset dev_fstrat	; 6
	DW	offset nul_serv		; 8
	DB	"COM1    ",0,0		; 10

_com2:
	DW	offset _com3,-1
	DW	8000H
	DW	offset dev_fstrat
	DW	offset nul_serv
	DB	"COM2    ",0,1

_com3:
	DW	offset _com4,-1
	DW	8000H
	DW	offset dev_fstrat
	DW	offset nul_serv
	DB	"COM3    ",0,2

_com4:
	DW	-1,-1
	DW	8000H
	DW	offset dev_fstrat
	DW	offset nul_serv
	DB	"COM4    ",0,3

; each 5 byte service routine has an ID # (0-4)
SERV_HDR_LEN equ 5

com_serv4:
	push	AX
	mov	AL, 4
	jmp	short com_serv
com_serv3:
	push	AX
	mov	AL, 3
	jmp	short com_serv
com_serv2:
	push	AX
	mov	AL, 2
	jmp	short com_serv
com_serv1:
	push	AX
	mov	AL, 1
	jmp	short com_serv
com_serv_aux:
	push	AX
	mov	AL, 0

	public	com_serv
com_serv:
	push	SI

	; get the port # and retries, common serial routines use 'em
	mov	AH, DEV_HDR_LEN
	mul	AH
	mov	SI, offset _DEVDATA:_comx
	add	SI, AX
	mov	AX, CS:[SI+RETRY_OFF]

	; tell device driver about port # and retries
	push	DS
	mov	DS, CS:dev_dgroup
	ASSUME DS:DGROUP
	mov	retries, AL
	mov	comport, AH
	ASSUME DS:_DEVDATA
	pop	DS

	; calc # of commands and where to find cmdtbl
	mov	AH, (OFFSET cmdend - OFFSET cmdtbl)/2
	mov	SI, OFFSET cmdtbl

	; Jump to the REAL service routine in ROM (CODE SEG)
	jmp	DWORD PTR CS:cmd_ptr
_DEVDATA ENDS


cBegUdata
	extrn	byteQueued:byte	; is a char pushed back from an ND read?
	extrn	newByte:byte	; if so then this is the char
	extrn	comport:byte
	extrn	retries:byte
	extrn	comtemp:byte
	extrn	cominit:byte	; have we initialized COM yet?
cEndUdata


cBegCode
	c_extrn	getDEVDATA,near

IF 0
;---------------------------------------------------------
;
;	FUNCTION 10  -  OUTPUT STATUS
;
;	DS    = DGROUP
;
com_outstat:

	ENTER_FUNCTION

	; check port status for
	mov	AH, 3
	xor	DX, DX
	mov	DL, comport
	int	BIOSCOM

	; test for txd buffer empty
	test	AH, 20H
	jnz	stat_ok

	EXIT_FUNCTION

	jmp	dev_busy_exit
stat_ok:

	EXIT_FUNCTION

	jmp	dev_exit
ENDIF


;---------------------------------------------------------
;
;	FUNCTION 4  -  READ FROM DEVICE
;
;	DS    = DGROUP
;	ES:DI = transfer area
;	CX    = count
;
	PUBLIC	com_read
com_read:

	ENTER_FUNCTION

	jcxz	LR2
	push	CX		; save the count requested

	; CHECK FOR A BYTE FROM NDREAD
	;

	cmp	byteQueued,0	; get the byte from "look ahead"
	jz	readx		; NULL byte, ignore
	mov	AL,newByte
	mov	byteQueued,0
	jmp	SHORT LR1

readx:	call	com_getch
LR1:	mov	ES:[DI], AL
	inc	DI

	loop	readx

rdone:	pop	AX		; count requested
	lds	BX, _ptrsav
	mov	[BX+COUNT], AX
LR2:	mov	AL, 0

	EXIT_FUNCTION

	jmp	dev_exit


;---------------------------------------------------------
;
;	FUNCTION 5  -  NON-DESTRUCTIVE READ
;
;	DS	= DGROUP
;
	PUBLIC	com_ndread
com_ndread:

	ENTER_FUNCTION

	mov	ah, byteQueued
	or	ah, ah
	jz	L2
	mov	AL,newByte
	jmp	SHORT L3

	; try to receive a character
L2:	call	get_stat
	mov	AL,0
	test	AH,1		; see if char has been received
	mov	ah,0
	jz	L2A
	call	com_getch
	mov	ah, 1
L2A:
	mov	byteQueued, ah

L3:	mov	newByte, AL
	lds	BX, _ptrsav
	mov	byte ptr [BX+MEDIA], AL
	or	ah, ah
	jz	L5X

	EXIT_FUNCTION

	jmp	dev_exit	; chars in buffer
L5X:

	EXIT_FUNCTION

	jmp	dev_busy_exit	; no chars


;  Waits for a character and returns it in AL.  This will
;  wait forever if no character appears.
	public	com_getch
com_getch:

	ENTER_FUNCTION

	; MAKE SURE WE ARE ALLOWED TO READ (TRANSMIT IS OVER)
	call	get_stat
	sti
	test	AH, 40H		; SHIFT & TRANS BUFF EMPTY???
	jz	com_getch
	test	AH, 20H
	jz	com_getch
	test	AH, 1		; IS A CHARACTER WAITING???
	jz	com_getch	; no, just wait

	mov	AH, 2		; READ THE CHARACTER
	xor	DX, DX
	mov	DL, comport
	int	BIOSCOM

	test	AH, 80H		; CHECK FOR ERROR
	jz	LG2
	mov	AL, 0		; IF ERR, RETURN 0
LG2:
	EXIT_FUNCTION

	ret

;  Returns the status in AX.  AH&1 means character has
;  been received.
	PUBLIC get_stat
get_stat:

	ENTER_FUNCTION

	mov	AH, 3
	xor	DX, DX
	mov	DL, comport
	int	BIOSCOM

	EXIT_FUNCTION

	ret


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	FUNCTION 8/9  -  WRITE (VERIFY IGNORED)
;
;	DS    = DGROUP
;	ES:DI = transfer area
;	CX    = count
;
	PUBLIC	com_write
com_write:

	ENTER_FUNCTION

	push	CX		; save count requested

writex:
	mov	AX, 0300H
	mov	DH, 0
	mov	DL, comport
	int	BIOSCOM		; READ COM PORT STATUS
	cmp	AX, 0300H
	jz	wdone		; NO COM PORT, do nothing

	test	AH, 20H		; is tranmit holding reg empty?
	jz	writex		; no, just wait

	; set up retries
	mov	AL, retries
	mov	[comtemp], AL

wr0:	mov	AL, ES:[DI]
	mov	AH, 1		; WRITE A CHAR TO COM PORT
	mov	DH, 0
	mov	DL, comport
	int	BIOSCOM

	; was there an error
	test	AH, 80H
	jz	wr2		; no error, next char

	; should we retry?
	cmp	[comtemp], 0
	jz	wr1		; no
	dec	[comtemp]
	jmp	wr0		; try again

wr1:	pop	CX
	mov	AL, 0AH		; Write fault

	EXIT_FUNCTION

	jmp	dev_err_exit

wr2:	inc	DI
	loop	writex

wdone:	pop	AX		; requested count
	lds	BX, _ptrsav
	mov	[BX+COUNT], AX	; # of bytes actually transferred

	EXIT_FUNCTION

	jmp	dev_exit


;---------------------------------------------------------
;
;		FUNCTION 0  -  INIT DEVICE
;
;	DS    = DGROUP
;	ES:DI = transfer area
;	CX    = count
;
	PUBLIC com_init
com_init:

	ENTER_FUNCTION

	; don't initialize twice
	cmp	[cominit], 0
	jnz	done
	inc	[cominit]

	; determine # of COM ports
	int	BIOSEQUIP		; Equipment list (COM ports in bits 9-11)
	mov	CL, 9
	shr	AX, CL
	and	AL, 111B		; only look at COM port bits
	mov	CX, AX

	; no serial ports
	jcxz	done

	; allow for 4 ports maximum
	cmp	CL, 4
	jbe	init0
	mov	CL, 4

	; link in each comport (set service routine)
init0:	push	CX
	push	DS

	assume	DS:_DEVDATA
	call	getDEVDATA
	mov	DS, AX
	mov	AX, OFFSET _DEVDATA:com_serv1
	mov	SI, OFFSET _DEVDATA:_com1 + SERV_OFF
init1:	mov	WORD PTR [SI], AX
	add	SI, DEV_HDR_LEN
	sub	AX, SERV_HDR_LEN
	loop	init1
	assume	DS:DGROUP

	pop	DS
	pop	CX

	; during REMOTE debugging, don't initialize port
IFNDEF REMOTEDEB
	; initialize each com port
init3:	dec	CX
	mov	AH, 0

	; mov	AL, 0E3H	; 111 00 0 11 = 9600, 8N1

	mov	AL, 0A3H	; 101 00 0 11 = 2400, 8N1
	mov	DX, CX		; port 0
	int	BIOSCOM

	jcxz	done
	jmp	init3
ENDIF

done:

	EXIT_FUNCTION

	jmp	dev_exit

cEndCode

	END

