;
;   $Id: DOSCFG5A.ASM 1.8 2002/10/15 21:46:18Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
COMMENT ~
----------------------------------------------------------

   DOSCFG5A.ASM  created 12/16/93  by Drew Gislason

   Copyright (c) 1993-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   This code is used in DOS 5.0 (and up) CONFIG.SYS
   processing.  It is in its own separate file so that
   when ROM-DOS is linked via library, it is not pulled
   in if NO CONFIG.SYS processing is required by the
   OEM.

   The code is thrown away (in RAM) after initialization.

---------------------------------------------------------- ~
include macros.inc
include profile.inc

DOS_IN_HMA	equ	10H

cBegData
	extrn	_error_no:word
	extrn	_InDOS:byte
	extrn	xms_addr:dword
	extrn	_dos5_flags:word
	extrn	_hma_used:word
cEndData

cBegCode
	extrn	getDGROUP:near

;	[]----------------------------------------------[]
;	 |						|
;	 |		DOS 5+ ROUTINES			|
;	 |						|
;	[]----------------------------------------------[]

IF (VDOS GE 5)	; DOS 5+ only

;-------------------------------------------
;   Run Only On Bootup:
;
;   Do the INSTALL= from CONFIG.SYS
;   Returns TRUE if worked, FALSE if failed.
;
COMMENT ;
int spawn_tsr(char *name, union EXEPARM *parms)
{}
;
c_func	spawn_tsr

	ENTER_FUNCTION

	; save the important registers
	push	BP
	mov	BP, SP
	push	SI
	push	DI

	; get parameters off stack
	mov	DX, P[BP]	; DS:DX = name
	mov 	BX, P+2[BP]	; ES:BX = parms
	mov	AX, DS
	mov	ES, AX

	; actually do the spawn
	mov	AX, 4B00H
	int	21H

	; did the exec work?
	jnc	exec_worked
	xor	AX, AX
	jmp	short exec_failed
exec_worked:
	mov	AX, 1
exec_failed:

	; assume all registers besides stack were trashed
	call	getDGROUP

	; update DOS internals
	mov	_error_no, 0		; reset error condition
	mov	_InDOS, 1		; we are still inDOS

	; restore register off stack
	pop	DI
	pop	SI
	pop	BP

	EXIT_FUNCTION

	ret
c_endp	spawn_tsr

comment ~ ; prototype ;
int alloc_hma(unsigned bytes)
{}
~
c_func	alloc_hma

	ENTER_FUNCTION

	push	BP
	mov	BP, SP
	push	es
	push	bx
	push	dx

	; is an XMS driver installed?
	mov	AX, 4300H
	int	2FH
	cmp	AL, 80H
	jnz	no_hma

	; get the address of the XMS driver
	mov	AX, 4310H
	int	2FH
	mov	word ptr [xms_addr], BX
	mov	word ptr [xms_addr+2], ES

	; allocate has much of the HMA as we need
	mov	AH, 1
	mov	DX, 0FFF0H
	call	dword ptr [xms_addr]
	cmp	AX, 1
	jnz	no_hma

	; enable the HMA area
	mov	AH, 5
	call	dword ptr [xms_addr]
	mov	AL, 1

	; record # of bytes used
	mov	DX, P[BP]
	mov	[_hma_used], DX
	jmp	short hma_ok

	; no HMA available
no_hma:	xor	AX, AX
hma_ok:
	pop	dx
	pop	bx
	pop	es
	pop	BP

	EXIT_FUNCTION

	ret

c_endp	alloc_hma

comment ~ ; prototype ;
void enable_hma(void)
{}
~
c_func	enable_hma

	ENTER_FUNCTION

	test	byte ptr [_dos5_flags+1], DOS_IN_HMA
	jz	no_enable
	mov	AH, 5
	call	dword ptr [xms_addr]
no_enable:

	EXIT_FUNCTION

	ret

c_endp	enable_hma

ENDIF	; DOS 5+ only

cEndCode

	END
