;
;   $Id: DOSCFG6A.ASM 1.9 2002/10/15 21:46:18Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
COMMENT ~
----------------------------------------------------------

   DOSCFG6A.ASM  created 12/16/93  by Drew Gislason

   Copyright (c) 1993-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   This code is used in DOS 6.0 (and up) CONFIG.SYS
   processing.  It is in its own separate file so that
   when ROM-DOS is linked via library, it is not pulled
   in if NO CONFIG.SYS processing is required by the
   OEM.

   The code is thrown away (in RAM) after initialization.


---------------------------------------------------------- ~
include macros.inc
include profile.inc

	;-------------------------------------------------
	;
	;   BIOS RESOURCES USED
	;
	;   This area defines all the possible BIOS calls
	;   that are can be called SYSGEN.ASM.  Only BIOSMEM
	;   is required; the rest are included only be
	;   certain options.
	;
	BIOSVID		EQU 10H ; Video calls
	BIOSVID_SETXY	EQU 02H	; INT 10H, set cursor position
	BIOSVID_PUTCHAR	EQU 09H	; INT 10H, print 1 or more chars
	BIOSVID_GETMODE EQU 0FH	; INT 10H, get the current mode

cBegData

IF (VDOS GE 6)	; { DOS6+ only
	extrn	_seconds:byte
	extrn	_cfg_ask:byte
	extrn	_cfg_color:byte
	extrn	_cfg_seconds:word
	extrn   _nagware_key:byte
	extrn	_cfg_nobypass:byte
	extrn	_starting_msg:byte

	oldtime	DB	?	; for use in Bypassing Config
ENDIF	; }

cEndData

cBegCode


;	[]----------------------------------------------[]
;	 |						|
;	 |		DOS 6+ ROUTINES			|
;	 |						|
;	[]----------------------------------------------[]

IF (VDOS GE 6)	; { DOS6+ only

	extrn	TOUCH_TIME:near
	extrn	_printf:near
	extrn	TOUPPER:near
	extrn	_process_switches:near
	extrn	_con_getkey:near
	extrn	_con_chkkey:near
	extrn	_con_shstat:near
;	extrn	BIOS_PUTC:near

	; Below we are adding SERIALF5 and SERIALF8 because we have had
	; customers request being able to bypass or step through the CONFIG
	; and AUTOEXEC files, when running a remote console, but our COMM
	; utility does not support sending word values for the function
	; keys across the serial line.

F5 		= 3F00H
SERIALF5 	= 003FH	; Could come across serial port as '?'
F8 		= 4200H
SERIALF8 	= 0042H	; Could come across serial port as 'B'
ESCKEY 		= 27

;-------------------------------------------
;   Run Only On Bootup:
;
;   Clears the screen
;
COMMENT ;
void clear_screen(int startrow)
{}
;
c_func	clear_screen

	ENTER_FUNCTION

	push	BP
	mov	BP, SP

	; set cursor to upper left
	push	P[BP]	; row
	xor	AX, AX
	push	AX	; col 0
	call	SET_CURSOR

	; clear the screen
	mov	AX, BIOSVID_PUTCHAR*100H + 20H
	mov	BL, _cfg_color
	mov	CX, 80*25;
	int	BIOSVID

	pop	BP

	EXIT_FUNCTION

	ret

c_endp	clear_screen

;----------------------------------------------------
;  Set the hardware cursor to someplace on the screen
;
COMMENT ;
void PASCAL set_cursor(int row, int col)
{}
;
	public	SET_CURSOR
SET_CURSOR proc near

	ENTER_FUNCTION

	push	BP
	mov	BP, SP

	mov	AH, BIOSVID_GETMODE
	int	BIOSVID

	; set cursor to row, col
	mov	AH, BIOSVID_SETXY
	mov	DH, P+2[BP]	; row
	mov	DL, P[BP]	; col
	int	BIOSVID

	pop	BP

	EXIT_FUNCTION

	ret	4

SET_CURSOR endp

IF 0
;----------------------------------------------------
;  Set the hardware cursor to someplace on the screen
;
COMMENT ;
void PASCAL write_char(char c, int color)
{}
;
	public	WRITE_CHAR
WRITE_CHAR

	ENTER_FUNCTION

	push	BP
	mov	BP, SP

	; get proper page
	mov	AH, BIOSVID_GETMODE
	int	BIOSVID

	mov	AH, BIOSVID_PUTCHAR
	mov	AL, P+2[BP]
	mov	BL, P[BP]
	mov	CX, 1
	int	BIOSVID

	EXIT_FUNCTION

	ret	4

WRITE_CHAR

ENDIF


;-------------------------------------------
;   Run Only On Bootup:
;
;   This function allows the user to bypass CONFIG.SYS
;   or at least provide question marks on each line in
;   CONFIG.
;
;   Returns
;
COMMENT ;
int bypass_config(void)
{}
;
c_func	bypass_config	; {

	ENTER_FUNCTION

	; if(!process_switches())
	;    return;
	call	_process_switches
	cmp	[_cfg_nobypass], 0
	jnz	short bc_dont

	; display "starting ROM-DOS..."
	mov	AX, GOFFSET _starting_msg
	push	AX
	call	_printf
	pop	AX

	; save current time
	xor	AX, AX
	push	AX
	call	TOUCH_TIME
	mov	AL, [_seconds]
	mov	[oldtime], AL

	; the loop
bc_again:

	; A SHIFT key means user wants to skip CONFIG.SYS
	call	_con_shstat
	test	AL, 3		; left or right shift
	jnz	short bc_bypass

	; no KEY? just skip to next item
	call	_con_chkkey
	cmp	AX, -1
	jz	short bc_nokey

	; F5 key means user wants to skip CONFIG.SYS
	cmp	AX, F5
	jz	short bc_bypass

	; F5 Over serial Port can come through as 0000H, 003FH
	; If we get a 003FH, User wants to skip CONFIG.SYS
	cmp	AX, SERIALF5
	jz	short bc_bypass

	; we got the Esc key, just do normal config.sys
	cmp	AL, ESCKEY
	jz	short bc_dont

	; F8 key means to question every line in CONFIG.SYS
	cmp	AX, F8
	jz	bc_ask

	; F8 Over serial port can come through as 0000H, 0042H
	; If we get a 0042H, User wants to question every line in CONFIG.SYS
	cmp	AX, SERIALF8
	jnz	bc_nokey

bc_ask:
	mov	[_cfg_ask], 1
	jmp	short bc_dont

bc_nokey:
	; Nagging an Evaluation Kit user about registering?
	; If so, we will never time-out of the sign-on msg.
	;
	cmp	byte ptr [_nagware_key], 0
	jne	bc_again

	; don't wait if user said not to. only use lower byte as
	; limit of seconds is 0-90
	cmp	byte ptr [_cfg_seconds], 0
	jz	bc_dont

;  ETR 3930  BT 2-7-02
;
;  Note:  The below code will appear to hang (continous loop) if the
;         clock returns the same value (hence no clock).
;
IF 1
	; have we waited long enough?
	xor	AX, AX
	push	AX
	call	TOUCH_TIME
	mov	AL, [_seconds]
	cmp	AL, [oldtime]
	jz	bc_again		; no time has passed
	mov	[oldtime], AL
ENDIF
	dec	byte ptr [_cfg_seconds]
	jmp	short bc_again

	; bypassing config.sys
bc_bypass:
	mov	AX, 1
	jmp	short bc_done

	; not bypassing config.sys
bc_dont:
	xor	AX, AX	; do NOT bypass CONFIG.SYS
bc_done:
	mov	[_cfg_seconds], -1

	EXIT_FUNCTION

	ret

c_endp	bypass_config ; }

;-------------------------------------------
;   Run Only On Bootup and used by only one config.sys processing routine:
;
;   Returns 'Y' or 'N', no other character accepted.
;   Does convert lower to upper case.
;
COMMENT ;
int getyesno(void)
{}
;
c_func	getyesno

	ENTER_FUNCTION

yn_go:	call	_con_getkey
	or	al, al
	jz	yn_maybeF5
	push	AX
	call	TOUPPER
	cmp	AL, 'Y'
	jz	yn_ok
	cmp	AL, 'N'
	jz	yn_ok
yn_maybeF5:
	cmp	ax, F5
	jz	yn_ok
	jmp	short yn_go
yn_ok:
	EXIT_FUNCTION

	ret

c_endp	getyesno

ENDIF	; } DOS6+ only

cEndCode

	END
