;
;   $Id: DOSFAT.ASM 1.12 2002/10/15 21:46:18Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;---------------------------------------------------------------------------
; $DOCFILE:DOSFAT.ASM
;
; Copyright (c) 1999-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
; This module includes the FAT file system get and set fat entry routines.
; The routines work with 12, 16 and 32-bit FATs.
;
; $DOCHISTORY
; 02/05/1999 dg  Created by Drew Gislason
;---------------------------------------------------------------------------


; prototypes
;
; these must be in comment form for PROTO.EXE to recognize them as C
; prototypes for automatically including the prototypes in DOSPROTO.H.

comment ~
unsigned PASCAL GetFat12Entry(unsigned n, unsigned uFatStart, unsigned uBytesPerSec)
void PASCAL SetFat12Entry(unsigned n, unsigned value, unsigned wFatStart, unsigned wBytesPerSec)
unsigned PASCAL GetFat16Entry(unsigned n, unsigned wFatStart, unsigned wBytesPerSec)
void PASCAL SetFat16Entry(unsigned n, unsigned value, unsigned wFatStart, unsigned wBytesPerSec)
CLUSTER PASCAL GetFat32Entry(CLUSTER n, unsigned wFatStart, unsigned wBytesPerSec)
void PASCAL SetFat32Entry(CLUSTER n, CLUSTER value, unsigned wFatStart, unsigned wBytesPerSec)
~

include use186.inc
include datalght.inc
include dostruct.inc
include profile.inc

InitModel Small, Pascal, Use16

.data
	extrn	_sda_dpbptr:near

.code
	; --------------------------------------------------------
	; The get/set FAT routines require 2 support routines:
	;
	; BUFLIST far * PASCAL buf_getsector(ulong sector);
	; void PASCAL buf_set_modified(BUFLIST far * lpSomething);
	;
	; However, the BUFLIST structure may be ANY sturcture that
	; allows the app to uniquely identify the sector.
	;
	extrn	BUF_GETSECTOR:near
	extrn	BUF_SET_MODIFIED:near

IF USE_186 EQ 1
        extrn   DIV_QL:near
        extrn   MUL_UU:near
ENDIF

IF USING_FAT32 ; {
IF USE_186 EQ 0
.386
ENDIF   ;; USE_186

;---------------------------------------------------------------------------
; $DOCPROC:GetFat32EntryPtr
;
; Helper routine to get/set fat32entry routines. Gets the fat sector into
; memory, and returns a pointer to the fat entry inside that sector
;
; On Entry	eax	ulFatEntry (386 mode)
;               dx:ax   ulFatEntry (186 mode)
;		cx	uFatSector
;		bx	uBytesPerSector
; On Exit	es:bx	pointer to fat entry
;---------------------------------------------------------------------------
ProcBegin	GetFat32EntryPtr, public
IF USE_186 EQ 0
ProcUses	si
ELSE
ProcUses	si, di
ENDIF
ProcSetup

	ENTER_FUNCTION

IF USE_186 EQ 0
	; determine 64-bit fat entry offset (in edx:eax)
	xor	edx, edx
	mov	dx, 4
	mul	edx		; 64-bit in edx:eax

	; convert to sector # and offset
	movzx	ebx, bx
	div	ebx		; sector now in eax, remainder in edx

	; save the remainder into si (always 0-1FFh in dx only)
	mov	si, dx

	; read the sector
	movzx	ecx, cx		; add in start of FAT
	add	eax, ecx
	push	eax
	call	BUF_GETSECTOR

ELSE    ;; USE_186
	; determine 64-bit fat entry offset (in edx:eax)
        push    cx
        push    bx
        xor     bx, bx
        mov     cx, 4
        call    MUL_UU          ; 64-bit in dx:cx:bx:ax
        pop     si
	; convert to sector # and offset
        xor     di, di
        call    DIV_QL
        ; 64-bit sector number in dx:cx:bx:ax
        ; 32-bit remainder in di:si


        ; get the sector (from saved CX on stack)
        pop     di
        add     ax, di
        adc     bx, 0

        push    bx
        push    ax
        call    BUF_GETSECTOR

ENDIF   ;; USE_186


	; get the data ptr for this sector
	mov	es, dx
	mov	bx, ax
	add	bx, OFFSET BUF_buffer

	; add in the offset (remainder) to return a pointer to
	; the 16-bit fat entry in es:bx
	add	bx, si

	EXIT_FUNCTION

ProcEnd

;---------------------------------------------------------------------------
; $DOCPROC:GetFat32Entry
;
; Return the value of the FAT entry from a 32-bit FAT. Does no limit
; checking if ulFatEntry is out of range for the given FAT.
;
; Parameters	ulFatEntry
;		uFatStart
;		uBytesPerSector
; Returns	ulValue
;---------------------------------------------------------------------------
ProcBegin	GetFat32Entry, public
ProcArgs	ulFatEntry:dword, uFatStart:word, uBytesPerSector:word
ProcSetup

	ENTER_FUNCTION

	; get stack variables into registers
IF USE_186 EQ 0
	mov	eax, ulFatEntry
ELSE    ;; USE_186
        mov     ax, word ptr ulFatEntry
        mov     dx, word ptr ulFatEntry[2]
ENDIF   ;; USE_186
	mov	cx, uFatStart
	mov	bx, uBytesPerSector

	; call helper routine to get the sector
	call	GetFat32EntryPtr

	; return the fat entry in dx:ax
	mov	dx, es:[bx+2]
	mov	ax, es:[bx]

	EXIT_FUNCTION

ProcEnd

;---------------------------------------------------------------------------
; $DOCPROC:SetFat32Entry
;
; Set a 32-bit fat entry to the value given. Does not limit checking
; to see if the fat entry passed will fit in the fat.
;
; On Entry	ulFatEntry
;		ulValue
;		uFatStart
;		uBytesPerSector
; On Exit	nothing
;---------------------------------------------------------------------------
ProcBegin	SetFat32Entry, public
ProcArgs	ulFatEntry:dword, ulValue:dword, uFatStart:word, uBytesPerSector:word
ProcSetup

	ENTER_FUNCTION

	; get stack variables into registers
IF USE_186 EQ 0
	mov	eax, ulFatEntry
ELSE    ;; USE_186
        mov     ax, word ptr ulFatEntry
        mov     dx, word ptr ulFatEntry[2]
ENDIF   ;; USE_186
	mov	cx, uFatStart
	mov	bx, uBytesPerSector

	; call helper routine to get the sector
	call	GetFat32EntryPtr

	; set the fat entry in dx:ax
	mov	dx, word ptr ulValue+2
	mov	ax, word ptr ulValue
	mov	es:[bx+2], dx
	mov	es:[bx], ax

	EXIT_FUNCTION

ProcEnd

.186

ENDIF ; } USING_FAT32


;---------------------------------------------------------------------------
; $DOCPROC:GetFat16EntryPtr
;
; Helper routine to get/set fat16 routines. Gets the fat sector into
; memory, and returns a pointer to the fat entry inside that sector
;
; On Entry	ax	uFatEntry
;		cx	uFatSector
;		bx	uBytesPerSector
; On Exit	es:bx	pointer to fat entry
;---------------------------------------------------------------------------
ProcBegin	GetFat16EntryPtr, public
ProcUses	si
ProcSetup

	ENTER_FUNCTION

	; determine 32-bit fat entry offset (in dx:ax)
	xor	dx, dx
	shl	ax, 1
	rcl	dx, 1		; 32-bit offset in dx:ax

	; convert byte offset to logical sector # and remainder
	div	bx		; sector now in ax, remainder in dx

	; save the remainder into si (always 0-1FFh in dx only)
	mov	si, dx

	; read the sector
	xor	dx, dx
	push	dx
	add	ax, cx		; add in FAT start to logical sector #
	push	ax
	call	BUF_GETSECTOR

	; get the data ptr
	mov	es, dx
	mov	bx, ax
	add	bx, OFFSET BUF_buffer

	; add in the offset (remainder) to return a pointer to
	; the 16-bit fat entry in es:bx
	add	bx, si

	EXIT_FUNCTION
ProcEnd

;---------------------------------------------------------------------------
; $DOCPROC:GetFat16Entry
;
; Return the value of the FAT entry from a 16-bit FAT. Does no limit
; checking if uFatEntry is out of range for the given FAT.
;
; Parameters	uFatEntry
;		uFatStart
;		uBytesPerSector
; Returns	uValue
;---------------------------------------------------------------------------
ProcBegin	GetFat16Entry, public
ProcArgs	uFatEntry:word, uFatStart:word, uBytesPerSector:word
ProcSetup

	ENTER_FUNCTION

	; get stack variables into registers
	mov	ax, uFatEntry
	mov	cx, uFatStart
	mov	bx, uBytesPerSector

	; get the buffer sector
	call	GetFat16EntryPtr

	; return the fat entry
	mov	ax, es:[bx]

	EXIT_FUNCTION

ProcEnd

;---------------------------------------------------------------------------
; $DOCPROC:SetFat16Entry
;
; Set a FAT16 entry to the given value
;
; Parameters	uFatEntry
;		uValue
;		uFatStart
;		uBytesPerSector
; Returns	ulValue
;---------------------------------------------------------------------------
ProcBegin	SetFat16Entry, public
ProcArgs	uFatEntry:word, uValue:word, uFatStart:word, uBytesPerSector:word
ProcSetup

	ENTER_FUNCTION

	; get stack variables into registers
	mov	ax, uFatEntry
	mov	cx, uFatStart
	mov	bx, uBytesPerSector

	; get the buffer sector
	call	GetFat16EntryPtr

	; return the fat entry
	mov	ax, uValue
	mov	es:[bx], ax

	EXIT_FUNCTION

ProcEnd


;---------------------------------------------------------------------------
; $DOCPROC:GetFat12EntryPtr
;
; Helper routine to get/set fat12 routines. Gets the fat sector into
; memory, and returns a pointer to the fat entry inside that sector.
;
; On Entry	ax	uFatEntry
;		cx	uFatSector
;		bx	uBytesPerSector
; On Exit	es:bx	pointer to fat entry
;		dx:cx	far pointer to BUFLIST structure
;		ax	the sector # found
;		si	offset (remainder) into sector
;
; Warning! This function trashes si! not callable from C!
;
;---------------------------------------------------------------------------
ProcBegin	GetFat12EntryPtr, public
ProcUses	di
ProcLocals	lpBufList:dword
ProcSetup

	ENTER_FUNCTION

	; make sure ax is in range
	and	ax, 0FFFh

	; determine 16-bit fat entry offset
	mov	dx, ax
	shr	dx, 1
	add	ax, dx		; 16-bit offset into FAT now in ax

	; convert byte offset to logical sector # and remainder
	xor	dx, dx
	div	bx		; logical sector in ax, remainder in dx

	; save the remainder into si (always 0-1FFh in dx only)
	mov	si, dx

	; read the appropriate FAT sector
	xor	dx, dx
	push	dx
	add	ax, cx		; add in FAT start to logical sector
	mov	di, ax		; save sector # in di
	push	ax
	call	BUF_GETSECTOR

	; store pointer to buffer
	mov	word ptr lpBufList+2, dx
	mov	word ptr lpBufList, ax

	; get the data ptr
	mov	es, dx
	mov	bx, ax
	add	bx, OFFSET BUF_buffer

	; add in the offset (remainder) to return a pointer to
	; the 16-bit fat entry in es:bx
	add	bx, si

	; return sector # in ax, and remainder in si
	mov	ax, di		; restore sector #

	; return pointer to buffer in dx:cx
	mov	dx, word ptr lpBufList+2
	mov	cx, word ptr lpBufList

	EXIT_FUNCTION

ProcEnd

;--------------------------------------------------------------------
; $DOCPROC:GetFat12Entry
;
; Get a FAT12 entry. Does no limit checking to verify entry # is in
; range of this FAT.
;
; Parameters	uFatEntry
;		uFatStart
;		uBytesPerSector
; Returns	ulValue
;--------------------------------------------------------------------
ProcBegin	GetFat12Entry, public
ProcArgs	uFatEntry:word, uFatStart:word, uBytesPerSector:word
ProcUses	si
ProcSetup

	ENTER_FUNCTION

	; put values from stack variables into registers
	mov	ax, uFatEntry
	mov	cx, uFatStart
	mov	bx, uBytesPerSector

	; get the fat sector
	call	GetFat12EntryPtr

	; does this entry cross sector boundaries?
	mov	cx, uBytesPerSector
	dec	cx
	cmp	cx, si
	jz	@@Use2Sectors

	; nope, easy, just get word at es:bx
	mov	ax, es:[bx]
	jmp	short @@FinishUp

	; read from the next sector
    @@Use2Sectors:

	; save sector # in si
	mov	si, ax

	; put sector # into ax, put low byte of FAT entry into si
	mov	al, es:[bx]	; get low byte 12-bit FAT entry
	xchg	si, ax		; put sector # in ax, and save lo byte

	; read the next sector
	xor	dx, dx
	push	dx
	inc	ax		; read next sector
	push	ax
	call	BUF_GETSECTOR

	; get pointer to the buffer data
	mov	es, dx
	mov	bx, ax
	add	bx, OFFSET BUF_buffer

	; form a 16-bit word for 12-bit FAT entry
	xchg	si, ax		; get low byte back into al
	mov	ah, es:[bx]	; get hi byte

	; convert from 16-bit word to 12-bit FAT entry
    @@FinishUp:

	; is this an odd or even 12-bit entry? (LL HL HH)
	test	uFatEntry, 1
	jnz	@@OddEntry
	and	ax, 0FFFh		; (even) get low 3 nybbles
	jmp	short @@Done
    @@OddEntry:
	mov	cl, 4
	shr	ax, cl			; (odd) get hi 3 nybbles
    @@Done:

	EXIT_FUNCTION

ProcEnd

;--------------------------------------------------------------------
; $DOCPROC:SetFat12Entry
;
; Set a FAT12 entry. Does no limit checking to verify entry # is in
; range of this FAT.
;
; Parameters	uFatEntry
;		uValue
;		uFatStart
;		uBytesPerSector
; Returns	ulValue
;--------------------------------------------------------------------
ProcBegin	SetFat12Entry, public
ProcUses	si
ProcArgs	uFatEntry:word, uValue:word, uFatStart:word, uBytesPerSector:word
ProcLocals	lpBufList:dword, uMask:word
ProcSetup

	ENTER_FUNCTION

	; first, determine the mask, and adjust value
	; depends on whethere the FatEntry # is odd or even
	test	uFatEntry, 1
	jnz	@@OddMask
	mov	uMask, 0F000h		; (even) preserve only upper nybble
	and	uValue, 0FFFh		; value must be 12 bits
	jmp	short @@DoneMask
    @@OddMask:
	mov	uMask, 000Fh		; (odd) preserve only lower nybble
	mov	cl, 4
	shl	uValue, cl		; value is shifted to high bits
    @@DoneMask:

	; put values from stack variables into registers
	mov	ax, uFatEntry
	mov	cx, uFatStart
	mov	bx, uBytesPerSector

	; get the fat sector
	call	GetFat12EntryPtr

	; save pointer to BUFLIST structure for this sector
	mov	word ptr lpBufList+2, dx
	mov	word ptr lpBufList, cx

	; save next fat sector # in uFatStart
	inc	ax
	mov	uFatStart, ax

	; does this entry cross sector boundaries?
	mov	cx, uBytesPerSector
	dec	cx
	cmp	cx, si
	jz	@@Use2Sectors

	; nope, easy, just modify word at es:bx
	mov	ax, es:[bx]
	and	ax, uMask
	or	ax, uValue
	mov	es:[bx], ax
	jmp	short @@Done

	; read from the next sector
    @@Use2Sectors:

	; update the 1 byte in this sector
	mov	al, es:[bx]
	and	al, byte ptr uMask
	or	al, byte ptr uValue
	mov	es:[bx], al

	; mark this sector as dirty (modified)
	push	word ptr lpBufList+2
	push	word ptr lpBufList
	call	BUF_SET_MODIFIED

	; read the next sector
	xor	dx, dx
	push	dx
	push	uFatStart
	call	BUF_GETSECTOR

	; get pointer to the buffer data
	mov	es, dx
	mov	bx, ax
	add	bx, OFFSET BUF_buffer

	; update 1 byte in next sector
	mov	al, es:[bx]
	and	al, byte ptr uMask+1
	or	al, byte ptr uValue+1
	mov	es:[bx], al

    @@Done:

	EXIT_FUNCTION

ProcEnd

	end
