;
;   $Id: DOSHMA.ASM 1.8 2002/10/15 21:46:18Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
COMMENT ~
-----------------------------------------------------------

   DOSHMA.ASM  created 09/16/92  by Drew Gislason

   Copyright (c) 1992-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

----------------------------------------------------------- ~
include macros.inc
include profile.inc

DOS_IN_HMA	equ	10H
DOS5_ROM	equ	800h


cBegData
	extrn	_dos5_flags:word
	extrn	_trydoshi:byte
cEndData

cBegUdata
	public	_hma_used, xms_addr
	_hma_used	dw	?
	xms_addr 	dd 	?

	public	_codeparas, _bufparas
	_codeparas	dw	?
	_bufparas	dw	?
cEndUdata

cBegCode
	extrn	getDGROUP:near

	extrn _int_00:near
	extrn _int_1B:near
	extrn _int_20:near
	extrn _int_21:near
	extrn _int_23:near
	extrn _int_24:near
	extrn _int_25:near
	extrn _int_26:near
	extrn _int_27:near
	extrn _int_29:near
	extrn _int_2F:near
	extrn _alloc_hma:near

;-------------------------------------------
;  INT 2FH, Function 4AH
;
;	4A01	query free HMA space
;	Returns  ES:DI = ptr to memory, BX = bytes free
;
;	4A02	allocate HMA space
;	On Entry BX = requested bytes
;	Returns  ES:DI = ptr to memory, BX = bytes allocated
;
;  This is a way for programs to allocate HMA memory space,
;  since DOS has taken it all for itself upon bootup.
;
comment ~ ; prototype ;
void hma_alloc_handler(void)
{}
~
c_func	hma_alloc_handler

	ENTER_FUNCTION

	; set ES to FFFFH, used during all calls
	mov	DI, -1
	mov	ES, DI

	; is DOS in the HMA?
	push	DS
	call	getDGROUP
	test	byte ptr [_dos5_flags+1], DOS_IN_HMA
	jz	check_trydoshi

	; query free memory
try1again:
	cmp	AL, 1
	jnz	try2
	mov	DI, [_hma_used]
	xor	BX, BX
	sub	BX, DI
	jmp	short done

	; allocate part of HMA
try2:	cmp	AL, 2
	jnz	done

	; is there enough memory?
	mov	DI, [_hma_used]
	add	DI, BX
	jc	not_in_hma

	; got the memory
	mov	DI, [_hma_used]
	add	[_hma_used], BX
	jmp	short done

check_trydoshi:

	cmp     _trydoshi, 0
	je	not_in_hma
	test	_dos5_flags, DOS5_ROM
	jnz	not_in_hma
	cmp	_hma_used, 0
	jne     not_in_hma

	push	ax
	mov	ax, _codeparas
	add	ax, _bufparas
	shl	ax, 4
	add	ax, 20h
	push	ax
	call	_alloc_hma
	or	ax, ax
	pop	ax
	pop	ax
	jz	not_in_hma
	or	byte ptr [_dos5_flags+1], DOS_IN_HMA
	jmp	short try1again

not_in_hma:
	xor	BX, BX
	mov	DI, -1
	mov	ES, DI		; report no memory available

done:	pop	DS

	EXIT_FUNCTION

	iret

c_endp	hma_alloc_handler

cEndCode

cBegData
	assume CS:DGROUP, DS:DGROUP

;-----------------------------------------------------
;  Here is an IRET in LOW memory for those interrupts
;  that don't DO anything.
;
	public	_hma_iret
_hma_iret: iret

;-----------------------------------------------------
;  These interrupts will go into DOS code, so they may
;  need to enable the HMA.
;

hma_int_00:
	call	check_enable_hma
	DB	0EAH		; far JMP
	DW	offset _int_00
	DW	?		; segment fixed up later
hma_int_1B:
	call	check_enable_hma
	DB	0EAH		; far JMP
	DW	offset _int_1B
	DW	?		; segment fixed up later
hma_int_20:
	call	check_enable_hma
	DB	0EAH		; far JMP
	DW	offset _int_20
	DW	?		; segment fixed up later
hma_int_21:
	call	check_enable_hma
	DB	0EAH		; far JMP
	DW	offset _int_21
	DW	?		; segment fixed up later
hma_int_23:
	call	check_enable_hma
	DB	0EAH		; far JMP
	DW	offset _int_23
	DW	?		; segment fixed up later
hma_int_24:
	call	check_enable_hma
	DB	0EAH		; far JMP
	DW	offset _int_24
	DW	?		; segment fixed up later
hma_int_25:
	call	check_enable_hma
	DB	0EAH		; far JMP
	DW	offset _int_25
	DW	?		; segment fixed up later
hma_int_26:
	call	check_enable_hma
	DB	0EAH		; far JMP
	DW	offset _int_26
	DW	?		; segment fixed up later
hma_int_27:
	call	check_enable_hma
	DB	0EAH		; far JMP
	DW	offset _int_27
	DW	?		; segment fixed up later
hma_int_29:
	call	check_enable_hma
	DB	0EAH		; far JMP
	DW	offset _int_29
	DW	?		; segment fixed up later
hma_int_2F:
	call	check_enable_hma
	DB	0EAH		; far JMP
	DW	offset _int_2F
	DW	?		; segment fixed up later


	PUBLIC	_int_array, _int_deb_array, _end_int_array

_int_array	label byte
		db	01H		; 01H trace
		dw	offset _hma_iret
		db	03H		; 03H break point
		dw	offset _hma_iret
		db	04H		; 04H divide overflow
		dw	offset _hma_iret
_int_deb_array	label byte
		db	00H
		dw 	offset hma_int_00	; 00H  divide-by-zero
		db	1BH
		dw	offset hma_int_1B	; 1BH  BIOS ctrl-break
		db	20H
		dw	offset hma_int_20	; 20H  DOS terminate
		db	21H
		dw	offset hma_int_21	; 21H  DOS function
		db	23H
		dw	offset hma_int_23	; 23H  ctrl-c
		db	24H
		dw	offset hma_int_24	; 24H  critical error
		db	25H
		dw	offset hma_int_25	; 25H  DOS abs read
		db	26H
		dw	offset hma_int_26	; 26H  DOS abs write
		db	27H
		dw	offset hma_int_27	; 27H  DOS terminate with keep
		db	29H
		dw	offset hma_int_29	; 29H  fast putchar
		db	2FH
		dw	offset hma_int_2F	; 2FH  DOS network
_end_int_array	label byte

cEndData

cBegData
	assume CS:DGROUP, DS:DGROUP

;--------------------------------
;  Check if the HMA is enabled
;  ZF = HMA not enabled ()
;  NZ = HMA enabled     (different)
	public	is_hma_enabled
is_hma_enabled:

	ENTER_FUNCTION

	push	CX
	push	SI
	push	DI
	push	ES
	push	DS

	; check to see if HMA already enabled
	xor	SI, SI
	mov	DS, SI		; Compare 0:0H
	mov	DI, 0FFFFH
	mov	ES, DI
	mov	DI, 10H		; with FFFF:10H
	mov	CX, 10H
	cld
	repz	cmpsb		; if the same, HMA disabled

	pop	DS
	pop	ES
	pop	DI
	pop	SI
	pop	CX

	EXIT_FUNCTION

	ret

	;--------------------------------------------
	;   The interrupt entry points must reside in
	;   DGROUP for two purposes:
	;
	;   1) The HMA may not be enabled when a DOS INT
	;      occurs, so we need to enable it
	;   2) The interrupt handlers cannot move, even
	;      though the ROM-DOS code might

comment ~ ; prototype ;
void check_check_enable_hma(void)
{}
~
c_func	check_enable_hma

	ENTER_FUNCTION
	test	byte ptr CS:[_dos5_flags+1], DOS_IN_HMA
	jnz	we_need_hma

	EXIT_FUNCTION

	ret

	; at this point, we know we want to use the HMA
we_need_hma:
	; is HMA enabled?
	call	is_hma_enabled
	jnz	already_enabled

	; enable the HMA area, preserving all registers
	push	AX
	push	BX
	push	CX
	push	DX
	push	BP
	mov	AH, 5
	call	dword ptr CS:[xms_addr]
	pop	BP
	pop	DX
	pop	CX
	pop	BX
	pop	AX

already_enabled:

	EXIT_FUNCTION

	ret

c_endp	check_enable_hma

cEndData

	END
