;
;   $Id: DOSINIT.ASM 1.5 2002/10/15 21:46:18Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
COMMENT ~
----------------------------------------------------------

   DOSINIT.ASM  created 09/09/92  by Drew Gislason

   Copyright (c) 1992-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   This file contains initialization code that couldn't
   be coded in C.  This code can be thrown away after
   DOS comes up.

---------------------------------------------------------- ~
include macros.inc

_DEVDATA segment word public 'DEVDATA'
	extrn	cmd_ptr:dword
	extrn	dev_dgroup:word
_DEVDATA ends

comment ~ the actual code of ROM-DOS LFNs~
_LFN_TEXT segment para public 'CODE'
_LFN_TEXT ends

cBegData
	extrn	_int_deb_array:byte
	extrn	_end_int_array:byte
	extrn	_data_ptr_array:byte
	extrn	_ROM_DEVSEG:word
	extrn	_ROM_DS:word

	; country stuff
	extrn	_country_info:byte
	extrn	_uppercase_table:byte
	extrn	_collating_table:byte
   	extrn	_patch_uppercase:byte
   	extrn	_patch_6506:byte
   	extrn	_casemap:byte
	extrn	_mem_top:word

	extrn	_pDiskStack:word
	extrn	_pCharStack:word
	extrn	_pDiskStackTop:word
	extrn	_pCharStackTop:word
	extrn   _disk_stackbase:word
	extrn   _disk_stack:word
	extrn   _char_stackbase:word
	extrn   _char_stack:word

	extrn	_uFarLFNCallSegment:word
	extrn	_uFarDOSCallSegment:word
cEndData

cBegCode
	extrn	_getDEVDATA:near
	extrn	dev_serv:near
	extrn	MEMMOVE:near
	extrn	_getDS:near
	extrn	_SetupStacks:near

;---------------------------------------
;  Initialize Device Variables
;
;  these variables are used by all built-in drivers,
;  but due to fixups, etc.., cannot be initialized
;  until run-time.
;
c_func	init_dev_vars
	push	DS

	; store DGROUP
	mov	[_ROM_DS], DS

	; get segments and offsets
	mov	DX, DS
	mov	CX, offset dev_serv
	call	_getDEVDATA

	; set up segment variables
	mov	[_ROM_DEVSEG], AX

	assume	DS:_DEVDATA

	mov	DS, AX
	mov	[dev_dgroup], DX

	; point to service routine for internal devices
	mov	WORD PTR [cmd_ptr], CX

	assume	DS:DGROUP

	pop	DS
	ret
c_endp	init_dev_vars

;
;   Decompress DGROUP.  Checks to make sure the COMPRESS
;   program has been used.  Assumes that DS points to
;   DGROUP upon entry.
;
comment ~ ; prototype ;
void decompress(void)
{}
~
c_func	decompress

	; make sure ES points to DGROUP as well
	PUSH	DS
	POP	ES

	; get the total size of DGROUP (only works if data is COMPRESSed)
	XOR	SI, SI
	MOV	DX, [SI]

	; check to make sure COMPRESS has indeed been run
	; if not, don't do anything.
	CMP	DX, 0
	JZ	done
	MOV	WORD PTR [SI], 0
	INC	SI
	INC	SI

	; get # of bytes for this block
moveblk:
	SUB	DX, 4	; subtract length of Blk data
	PUSH	DX	; save size of DGROUP
	PUSH	[SI]	; save # of bytes to zero
	PUSH	[SI+2]	; save next block pointer

	; skip the block if nothing to move
	CMP	DX,0
	JZ	skipblk

	; move the initialized data
	MOV	AX, SI
	ADD	AX, [SI]
	PUSH	AX	; "dst"
	MOV	AX, SI
	ADD	AX, 4
	PUSH	AX	; "src"
	PUSH	DX	; "length"
	CALL	MEMMOVE

	; restore block size, etc...
skipblk:
	POP	BX	; next blk
	POP	CX	; blk size
	POP	DX	; size of DGROUP

	; calculate new DGROUP size
	SUB	DX, BX

	; point SI to next block
	MOV	DI, SI
	ADD	SI, CX
	ADD	SI, BX

	; zero out the area
	MOV	AL, 0
	CLD
	REP	STOSB

	; check to see if there is a next block
	CMP	BX, 0FFFFH
	JNZ	moveblk

done:	RET

c_endp	decompress


;   This function must put the "current" CS into all the
;   interrupt handlers that point into DOS code.  Some
;   handlers point into DOS data and need not be changed.
;
comment ~ ; prototype ;
void fixup_int_handlers(void)
{}
~
c_func	fixup_int_handlers
	push	SI

	; loop through interrupt array
	mov	SI, GOFFSET _int_deb_array
fih_loop:
	cmp	SI, GOFFSET _end_int_array
	jae	fih_done

	; put our code segment in the handler
	mov	BX, [SI+1]
	mov	[BX+6], CS
fih_noset:
	add	SI, 3
	jmp	fih_loop

fih_done:
	; also, fix up the device command pointer in DEVDATA
	assume	DS:_DEVDATA
	push	DS
	call	_getDEVDATA
	mov	DS, AX
	mov	word ptr [cmd_ptr+2], CS
	pop	DS
	assume	DS:DGROUP

	; fix up all Data Pointers (an array of ptrs to segments)
	mov	SI, GOFFSET _data_ptr_array
dp_again:
	mov	BX, [SI]
	cmp	BX, 0
	jz	dp_done
	mov	[BX], DS	; put DS into segment of far ptr
	inc	SI
	inc	SI
	jmp	dp_again
dp_done:

	pop	SI
	ret
c_endp	fixup_int_handlers


;   This function will return only the DOS code size (not including
;   the LFN module size)
;
comment ~ ; prototype ;
unsigned get_DOScodeparas(void)
{}
~
c_func	get_DOScodeparas
	extrn	beg_devdata:byte
	extrn	beg_lfn_text:byte

	push	CX
	mov	AX, offset _TEXT:beg_lfn_text + 10H
	mov	CL, 4
	shr	AX, CL
	pop	CX
	ret

c_endp	get_DOScodeparas


;   This function will return only the LFN code size (not including
;   the DOS module size)
;
comment ~ ; prototype ;
unsigned get_LFNcodeparas(void)
{}
~
c_func	get_LFNcodeparas
	extrn	beg_devdata:byte
	extrn	beg_lfn_text:byte

	push	CX
	mov	AX, offset _LFN_TEXT:beg_devdata
	mov	cl, 4
	shr	AX, CL
	pop	CX
	ret

c_endp	get_LFNcodeparas


;   This function will return the total code size (DOS+LFN).
;
comment ~ ; prototype ;
unsigned get_codeparas(void)
{}
~
c_func	get_codeparas

	call	get_DOScodeparas
	push	ax
	call	get_LFNcodeparas
	pop	CX
	add	ax, cx
	ret

c_endp	get_codeparas


;   This function will move the ROM-DOS code from its
;   present segment to another.
;
comment ~ ; prototype ;
void move_dos(unsigned seg)
{}
~
c_func	move_dos

	extrn	beg_devdata:byte
	extrn	beg_lfn_text:byte
	extrn	getDGROUP:proc

	; set up C stack frame
	push	BP
	mov	BP, SP
	push	SI
	push	DI
	push	DS

	; assume NEW DOS location and OLD DOS location don't overlap
	push	CS
	mov	bx, P[BP] ; save the new romdos code segment
	pop	ds
	mov	es, bx
	xor	si, si
	xor	di, di
	mov	CX, offset _TEXT:beg_lfn_text
	push	cx

	; copy the code
	cld
	rep	movsb


	; Because the lfn code can make romdos exceed 64k, the
	; pointers need to be normallized.
	;
	push	es
	mov	cl, 4

	mov	ax, si
	and	si, 000fh
	shr	ax, cl
	mov	dx, ds
	add	dx, ax
	mov	ds, dx

	mov	ax, di
	and	di, 000fh
	shr	ax, cl
	mov	dx, es
	add	dx, ax
	mov	es, dx

	mov	CX, offset _LFN_TEXT:beg_devdata
	rep	movsb
	pop	es

	; save the new segment for LFNs
	;
	pop	ax
	mov	cl, 4
	shr	ax, cl

	add	bx, ax ; bx was set above to the new romdos code segment

	push	ds
	call	getDGROUP
	mov	_uFarLFNCallSegment, bx
	push	bx
	mov	bx, P[BP] ; save the new romdos code segment
	mov	_uFarDOSCallSegment, bx
	pop	bx
	pop	ds

	; store new segment at 70:0
	call	_getDEVDATA
	mov	DS, AX
	mov	DS:[0], ES

	; jump to new code segment
	push	ES
	mov	AX, offset move_done
	push	AX
	public	moveit
moveit:
	retf

	; let everybody know we have moved
move_done:
	pop	DS
	pop	DI
	pop	SI
	pop	BP
	ret
c_endp	move_dos

;   This function will move the ROM-DOS code from its
;   present segment 0ffffh (HMA).  The LFN module will
;   be moved low.
;
comment ~ ; prototype ;
void move_dos_hma(unsigned DOSseg,unsigned LFNseg)
{}
~
c_func	move_dos_hma

	extrn	beg_devdata:byte
	extrn	beg_lfn_text:byte
	extrn	getDGROUP:proc

	; set up C stack frame
	push	BP
	mov	BP, SP
	push	SI
	push	DI
	push	DS

	; assume NEW DOS location and OLD DOS location don't overlap
	push	CS
	mov	bx, [BP+4] ; save the new romdos code segment
	call	getDGROUP
	mov	_uFarDOSCallSegment, bx
	pop	ds
	mov	es, bx
	mov	SI, 10H
	mov	DI, SI
	mov	CX, offset _TEXT:beg_lfn_text
	sub	CX, SI

	; copy the code
	cld
	rep	movsb

	; Because the lfn code can make romdos exceed 64k, the
	; pointers need to be normallized.
	;
	push	es	; save romdos code segment

	mov	ax, si
	and	si, 000fh
	mov	cl, 4
	shr	ax, cl
	mov	dx, ds
	add	dx, ax
	mov	ds, dx

	mov	ax, [BP+6]
	mov	es, ax
;;	and	di, 000fh
	xor	di, di

	mov	CX, offset _LFN_TEXT:beg_devdata
	rep	movsb

	pop	es	; restore romdos code segment

	; save the new segment for LFNs
	;

	push	ds
	call	getDGROUP
	mov	bx, [BP+6]
	mov	_uFarLFNCallSegment, bx
	pop	ds

	; store new segment at 70:0
	call	_getDEVDATA
	mov	DS, AX
	mov	DS:[0], ES

	; jump to new code segment
	push	ES
	mov	AX, offset move_done
	push	AX

	jmp	moveit

c_endp	move_dos_hma

;---------------------------------------------------
;   Initialize the country information.  This is in
;   assembly for size efficiency, and it's in the
;   init file so it can be thrown away after ROM-DOS
;   comes up.
;
comment ~ ; prototype ;
void init_country_info(void)
{}
~
c_func	init_country_info
	push	BP
	mov	BP, SP
	push	SI
   ;
   ;	{
   ;	/*
   ;	   [ externals ]
   ;	*/
   ;	extern struct COUNTRY_INFO country_info;
   ;	extern uchar uppercase_table[];
   ;	extern uchar collating_table[];
   ;	extern uchar term_table[0x30];
   ;	extern uchar patch_uppercase[0x24];
   ;
   ;	int i;
   ;
   ;	/* this code is simply to reduce initialized DATA size */
   ;	*(int *)uppercase_table = 0x80;
   ;
	mov	word ptr DGROUP:_uppercase_table,128
   ;
   ;	for(i=0x80;i<=0xFF;++i)
   ;	   uppercase_table[i-0x80+2] = i;
   ;
	mov	SI, 80H
	jmp	short @1@98
@1@50:	mov	AX, SI
	mov	byte ptr _uppercase_table[SI-126], AL
	inc	SI
@1@98:	cmp	SI, 0FFH
	jbe	short @1@50
   ;
   ;	memmove(uppercase_table+1+2, patch_uppercase, sizeof(patch_uppercase));
   ;
	mov	ax,offset DGROUP:_uppercase_table+3
	push	ax
	mov	ax,offset DGROUP:_patch_uppercase
	push	ax
	mov	ax, 36
	push	ax
	call	near ptr MEMMOVE
   ;
   ;
   ;	/* this code is simply to reduce initialized DATA size */
   ;	*(int *)collating_table = 0x100;
   ;
	mov	word ptr [_collating_table], 100H
   ;
   ;		for(i=0;i<=0xFF;++i)
   ;
	xor	SI, SI
	jmp	short @1@290
@1@146:
   ;
   ;	collating_table[i+2] = (i<0x61 || i>0x7A ? i : i-0x20);
   ;
	mov	AX, SI
	cmp	SI, 61H
	jb	short @1@242
	cmp	SI, 7AH
	ja	short @1@242
	sub	AL, 020H
@1@242:
	mov	byte ptr _collating_table[SI+2], AL
	inc	SI
@1@290:
	cmp	SI, 0FFH
	jbe	short @1@146
   ;
   ;	memmove(collating_table+0x80+2, patch_6506,sizeof(patch_6506));
   ;
	mov	ax,offset DGROUP:_collating_table+80H+2
	push	ax
	mov	ax,offset DGROUP:_patch_6506
	push	ax
	mov	ax, 48
	push	ax
	call	near ptr MEMMOVE
   ;
   ;	collating_table[0xE1+2] = 0x53;
   ;
	mov	byte ptr [_collating_table+0E1H+2], 53H
   ;
   ;	}
   ;
	pop	SI
	pop	BP
	ret
c_endp	init_country_info

comment ~ ; prototype ;
int PASCAL smart_calc(int minval, int maxval)
~
	public	SMART_CALC
SMART_CALC	proc	near
	push	bp
	mov	bp, sp
	mov	bx, word ptr [bp+6]	; bx is "minval"
   ;
   ;	{
   ;		extern unsigned mem_top;
   ;
   ;		unsigned scale = 0xA000 / maxval;
   ;		int num = mem_top / scale;
   ;
	mov	ax, 0A000H
	xor	dx, dx
	div	word ptr [bp+4]
	xchg	cx, ax			; cx is "scale"
	mov	ax, word ptr DGROUP:_mem_top
	xor	dx, dx
	div	cx		; ax is "num = mem_top / scale"
   ;
   ;	if(num < minval)
   ;	   num = minval;
   ;
	cmp	ax, bx
	jge	short @1@74
	mov	ax, bx
@1@74:
   ;
   ;	return num;
   ;
   ;	}
   ;
	pop	bp
	ret	4
SMART_CALC	endp

comment ~ ; prototype ;
void set_umb_link(int link)
~
c_func	set_umb_link
	push	BP
	mov	BP, SP
	mov	AX, 5803H
	mov	BX, P[BP]
	int	21H
	pop	BP
	ret
c_endp	set_umb_link

;----------------------------------------------------
; Return extended memory size from BIOS.
; some programs like MS-DOS MEM require this value in
; DOS data area
comment ~ ; prototype ;
unsigned get_extmemsize(void)
~
c_func	get_extmemsize
	mov	AX, 8800H
	int	15H
	ret
c_endp	get_extmemsize


COMMENT ~ ;prototype;
/* Returns the segment of the end of memory below RPL. */
unsigned GoAskRPL(unsigned)
{}
~
; Takes the end of RAM seg address from BIOS int 12h (typically A000h).
; If Novel Remote Program Loader (RPL -- boot ROM) code is found
; in memory this calls RPL to get the end of usable RAM (normally A000h
; without RPL or 9000h with it). Returns the segment of the end of memory.
;
;
c_func	GoAskRPL
	push	bp
	mov	bp, sp

	; look for "RPL" in the int 2Fh ISR
	;
	xor	dx, dx
	mov	es, dx
	mov	bx, 2Fh*4
	les	bx, es:[bx]

	mov	dx, P[BP]	; must return BIOS value if RPL not there

	cmp	word ptr es:[bx+3], "PR"
	jne	GARPL_done

	cmp	byte ptr es:[bx+5], 'L'
	jne	GARPL_done

	mov	ax, 4A06h	; call with end of RAM seg in dx (from BIOS)
	int	2Fh

    GARPL_done:
	mov	ax, dx		; return adjusted end of RAM segment
	pop	bp
	ret
c_endp 	GoAskRPL


COMMENT ~ ;prototype;
/* Returns the segment of the end of memory. */
unsigned getmemtop(void)
{}
~
BIOSMEM		EQU 12H	; Get total memory in K

c_func	getmemtop

	; pretend there's only 512K for UMB testing
IFDEF UMBTESTING
	mov	AX, 8000H	; 512K
ELSE
	int	BIOSMEM	; BIOS: total memory (in K) reported in AX
	mov	DX, 64	; multiply by 64 to convert K into paragraphs
	mul	DX	; returned in AX, 640K = A000H
ENDIF
	ret
c_endp	getmemtop




comment ~ ; prototype ;
void UseSTACKSStacks(void)
end_comment ~
c_func  UseSTACKSStacks
	push	si
	push	di
	push	es

	; actually allocate the STACKS stacks and set up the SDA
	; stack pointer variables to point to the new stacks.
	;
	call	_SetupStacks
	push	ds
	pop	es		; STACKS stacks must be in DGROUP!

	mov	si, GOFFSET _disk_stackbase
	mov	cx, GOFFSET _disk_stack
	mov	di, _pDiskStack
    	cmp	si, di
	je	USS_copy_char_stack

	; The top of the disk stack has moved, it may have replaced the
	; statically allocated char_stack or it may have just been allocated
	; from our near heap in DGROUP. Copy the current stack data to
	; the top of the new disk stack
	;
	mov	di, _pDiskStackTop
	sub	cx, si
	sub	di, cx
	cld
	rep	movsb

    USS_copy_char_stack:
	mov	si, GOFFSET _char_stackbase
	mov	cx, GOFFSET _char_stack
	mov	di, _pCharStack
	cmp	si, di
	je	USS_switch_stacks

	; The top of the char has been moved to a new dynamically allocated
	; stack. Copy the current stack data to the top of the new char stack.
	;
	mov	di, _pCharStackTop
	sub	cx, si
	sub	di, cx
	cld
	rep	movsb

	; During init, ROM-DOS uses the char_stack as its internal
	; stack and relies on the disk_stack for all int 21h calls.
	;
    USS_switch_stacks:
	mov	ax, _pCharStackTop
	mov	cx, GOFFSET _char_stack
	cmp	ax, cx
	je	USS_done

	; The char stack has moved. Switch onto the new char stack.
	;
	mov	dx, sp
	sub	dx, cx
	add	ax, dx

	cli
	mov	sp, ax
	sti

	; _main() calls this routine with local variables, make sure
	; that we can access them
	;
	mov	dx, bp
	sub	dx, cx
	add	dx, _pCharStackTop
	mov	bp, dx

    USS_done:
	pop	es
	pop	di
	pop	si
	ret
c_endp  UseSTACKSStacks

cEndCode

	END
