;
;   $Id: DOSPROF.ASM 1.7 2002/10/15 21:46:18Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
COMMENT ~
---------------------------------------------------------------

   DOSPROF.ASM  created 01/01/93  by Drew Gislason

   Copyright (c) 1993-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   Some functions were re-written in assembly for performance
   reasons.  The goal is to eventually be FASTER than the
   other DOSes on the market.

--------------------------------------------------------------- ~
include macros.inc
include dostruct.inc
include profile.inc

cBegData
	; used by buf_exist()
	extrn	_sda_cur_buf:dword
	extrn	_sda_dpbptr:dword
cEndData

cBegCode
	extrn	BUF_GETSECTOR:near



COMMENT ~ ; prototype ;
bool PASCAL buf_exist(ulong sector)
~
BUF_VALID	equ	20h

	public	BUF_EXIST
BUF_EXIST	proc	near

	ENTER_FUNCTION

	push	bp
	mov	bp, sp

	push	si
	push	di
	push	ds

	mov	di, ds
	mov	es, di

	ASSUME	es:DGROUP, ds:nothing

   	; CL    = REAL drive # from DPB (in case it is SUBST)
	; CH    = buffer flags bit value indicating that buffer
	;         is valid
	; DX:BX = 32-bit sector number that we want a buffer for
	;
   	lds	di, dword ptr _sda_dpbptr
	mov	cl, [di].DPB_drive	; cl = current drive #
	mov	ch, BUF_VALID		; ch = buffer valid bit
	mov	bx, word ptr [bp+4]	; lo word of 32-bit sector #
	mov	dx, word ptr [bp+6]     ; hi word of 32-bit sector #

	; ES:DI = ptr to head of list, segment of BUFFERs never changes
	; SI = offset of head of BUFFER list
	;
	lds	di, dword ptr es:_sda_cur_buf ; start at head of list
	mov	si, di
	jmp	short BE_LoopTop

	;
    BE_NextBuffer:
	mov	di,word ptr [di].BUF_next ; buf = buf->next
	cmp	di,si			; if back to head again, it ain't here
	jz	BE_NotFound

    BE_LoopTop:
	mov	ax, word ptr [di].BUF_drive ; al = buf->drive, ah= buf->flags
	cmp	al, cl			; is it for the drive?
	jnz	BE_NextBuffer

	test	ah, ch			; is buffer valid
	jz	BE_NextBuffer

	cmp	bx, word ptr [di].BUF_sector	; lo word of long sector
	jnz	BE_NextBuffer

	cmp	dx, word ptr [di].BUF_sector[2]	; hi word of long sector
	jnz	BE_NextBuffer

	; we've found the right buffer, if it is already at the
	; head of the buffer list then just return TRUE
	;
	cmp	di, si
	jz	BE_FoundIt

	; We have to move the sought buffer to the head of the list
	;
	; First delete it from where it is...
	;
	mov	dx, word ptr [di].BUF_next ; dx = buf->next
	mov	bx, word ptr [di].BUF_prev ; bx = buf->prev (bx)
	mov	word ptr [bx].BUF_next, dx	; prev->next = buf->next
	xchg	bx, dx			;
	mov	word ptr [bx].BUF_prev, dx	; next->prev = buf->prev

	; Now put it at the head of the list, SI has the offset
	; of the 1st.  Buffer in the list already...
	;
	mov	bx, word ptr [si].BUF_prev	; bx = head->prev (bx)
	mov	word ptr [di].BUF_next, si	; buf->next = head
	mov	word ptr [di].BUF_prev, bx	; buf->prev = head->prev
	mov	word ptr [bx].BUF_next, di	; head->prev->next= buf
	mov	word ptr [si].BUF_prev, di	; head->prev = buf
	mov	word ptr es:_sda_cur_buf, di	; record new head of list

    BE_FoundIt:
	mov	ax, 1
	jmp	short BE_exit

    BE_NotFound:
	xor	ax, ax		; buffer not found, return FALSE

	ASSUME	ds:DGROUP, es:nothing

    BE_exit:
	pop	ds
	pop	di
	pop	si

	pop	bp

	EXIT_FUNCTION

	ret	4

BUF_EXIST	endp

cEndCode

	END
