;
;   $Id: UMBLINK.ASM 1.6 2003/05/07 18:30:18Z thomd Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
comment ~ -------------------------------------------------

   UMBLINK.ASM created 08-21-96 by Dennis Edwards

   Copyright (c) 1996-2002 by Datalight, Inc.
   Datalight Confidential and Proprietary
   All Rights Reserved.

   UMBLINK.SYS allows for the conversion of various RAM memory
   regions into DOS UMBs into which device drivers and TSRs may
   be loaded. UMBLINK is a simple device driver that, once
   installed, does nothing but filter the INT 21h, Fn 5803h
   calls to link/unlink the UMB arena from the normal DOS MCB
   chain. During device init, UMBLINK looks for RAM memory in
   the "adapter space" (from C0000h - F0000h). UMBLINK can work
   with a variety of memory types and looks for memory in the
   following order: 1) S-ICE upper memory 2) XMS UMBs and 3)
   other non-excluded RAM regions. Any such regions are
   converted to DOS UMBs prior to returning from the DOS device
   init call. UMBLINK must be appear before any DEVICEHIGH lines
   in your CONFIG.SYS file.

   SYNTAX: device = umblink.exe [x=mmmm-nnnn]

   where mmmm and nnnn specify an hex segment range of existing
   RAM to be excluded from the UMB conversion process. Both mmmm
   and nnnn must be in the range C000h-F000h.

   See MSDOS Prog. Ref. pg. 353. This program was condensed from
   EMM386.ASM.

   HISTORY
   -------

   04-22-98 Added autoedection of physical RAM that is not controlled
	by a formal provider interface (S-ICE, XMS UMBs). Also added
	the "x=" command line option.


   TODO
   ----
   - Allow multiple instances to be run
   - Provide an include option to allow for RAM regions outside the
     C0000-EFFFF range.

---------------------------------------------------------- ~
include macros.inc
include dosver.inc

.186

;/////////////////////////////////////////////////////////////////////////
;//	User/Programmer Options						//
;/////////////////////////////////////////////////////////////////////////

SIGNON	equ	1	; set to FALSE for no signon

TSR	  equ	0	; is this program a TSR and device driver (1)
   			; or device driver only (0)
STACKSIZE equ	2048	; size of stack in bytes

; PROG_DEBUG level 0 = none
; PROG_DEBUG level 1 = unsupported call message
; PROG_DEBUG level 2 = all debugging
PROG_DEBUG = 0


;/////////////////////////////////////////////////////////////////////////
;//	Macros, etc..							//
;/////////////////////////////////////////////////////////////////////////

printm	macro	name
	mov	DX, offset DGROUP:name
	call	print_dos
	endm

prerror	macro	name
	mov	DX, offset DGROUP:error_msg
	call	print_dos
	mov	DX, offset DGROUP:name
	call	print_dos
	endm

; Request header fields
cmdlen	=	00H	; length of this command
unit	=	01H	; sub unit specifier
cmdc	=	02H	; command code
status	=	03H	; status
endaddr	=	0EH	; end address
cmdline	=	12H	; cmdline ptr

; ptr to arguments
P	equ	4


;/////////////////////////////////////////////////////////////////////////
;//	Segment Ordering						//
;/////////////////////////////////////////////////////////////////////////

_DEVDATA segment para public 'DEVDATA'
_DEVDATA ends

_ENDDEV	 segment para public 'DEVDATA'
_ENDDEV  ends

cBegCode
cEndCode

; paragraph align DGROUP
BEGDATA	SEGMENT PARA PUBLIC '_BEGDATA'
	DGROUP GROUP BEGDATA
datastart label word
BEGDATA	ENDS

cBegData
cEndData

; For the Microsoft C/Assembly users...
; too many segments - yuck!
IFNDEF	??version
	DGROUP	GROUP	CONST, MSG
CONST SEGMENT WORD PUBLIC 'CONST'
CONST ENDS
MSG SEGMENT WORD PUBLIC 'MSG'
MSG ENDS
ENDIF

cBegUdata
begbss	label word
cEndUdata

_ENDSEG	SEGMENT PARA PUBLIC 'ENDSEG'
	public endsegmarker
endsegmarker dw	?
_ENDSEG ENDS


;/////////////////////////////////////////////////////////////////////////
;//	Device Driver Header						//
;/////////////////////////////////////////////////////////////////////////

_DEVDATA segment
	assume CS:_DEVDATA, DS:NOTHING

	public	_umblinkx
_umblinkx:
	dd	-1		; 0 link to next device
	dw	8000H		; 4 character device
	dw	strategy	; 6 strategy routine
	dw	service		; 8 service routine
	db	"UMBLINK0",0	; 10 this name required for installed check

	; these variables make _DEVDATA not ROMable
	;
	public	cmd_ptr
cmd_ptr		dw	?
		dw	seg _TEXT

strategy:
	mov	word ptr CS:[cmd_ptr], offset _TEXT:umblink_strat
	jmp	dword ptr CS:[cmd_ptr]

service:
	mov	word ptr CS:[cmd_ptr], offset _TEXT:umblink_serve
	jmp	dword ptr CS:[cmd_ptr]

IF TSR
	public	req_hdr
	req_hdr		db (cmdline+4) dup (?)
ENDIF

_DEVDATA	ends

;/////////////////////////////////////////////////////////////////////////
;//	Data Area							//
;/////////////////////////////////////////////////////////////////////////

cBegData

	; data segment of DOS
	public	DOS_DS
DOS_DS	dw	?


	public	signon_msg
signon_msg	label byte
	db	13,10,"UMBLINK ",FULLVERSION,13,10
	db	COPYRIGHT,13,10,"$"

IFE TSR
device_only	label byte
	db	13,10
	db	"In CONFIG.SYS use:",13,10
	db	"DEVICE=UMBLINK.EXE [x=mmmm-nnnn]"
	db	13,10
	db	"where mmmm-nnnn specifies an excluded hex segment range."
	db	13,10
	db	"$"
ENDIF

_noUMBsMessage	db	0Dh,0Ah,"No High Memory Available.",0Dh,0Ah,'$'

; The SoftICE device name string
;
SoftICE	db	"SOFTICE1",0

; This is the segment (16K EMS page) map maintained by SOFTICE and
; established by EMMSETUP.
;
SEGMAP	label	byte
		db	40h dup (0FFh)		; assume everything is eXcluded

; The segment of the MCB of the first UMB in the UMB chain
;
firstUMB	dw	-1
xms_addr	dd	0

cEndData

cBegUdata

	public	ptrsav
	ptrsav	dd	?

IF STACKSIZE
	public	user_stack, stacktop, stackbottom, use_array
	user_BX		dw	?
	user_CX		dw	?
	user_stack 	dd	?
	stackbottom	db	STACKSIZE dup (?)
	stacktop	dw	?
ENDIF


; start and end of the RAM scan range
;
RAM_SCAN_START_SEG = 0A000h
RAM_SCAN_VIDEO_SEG = 0C000h
RAM_SCAN_END_SEG   = 0F000h

; the number of 4K pages (blocks) that are in the RAM scan range
;
RAM_SCAN_PARAGRAPHS	=	(RAM_SCAN_END_SEG - RAM_SCAN_START_SEG)
BLOCKS_TO_CHECK 	= 	(RAM_SCAN_PARAGRAPHS / ((4*1024) shr 4))
VIDEO_PARAGRAPHS  =  (RAM_SCAN_VIDEO_SEG - RAM_SCAN_START_SEG)
VIDEO_BLOCKS      =  (VIDEO_PARAGRAPHS / ((4*1024) shr 4))
NON_VIDEO_BLOCKS  =  (BLOCKS_TO_CHECK - VIDEO_BLOCKS)

; initialize the "video" region to 0 (exclude from check)
;  and the rest of the region to 1 (include in the check)
;
use_array   db VIDEO_BLOCKS dup(0)
            db NON_VIDEO_BLOCKS dup(1)


cEndUdata


;/////////////////////////////////////////////////////////////////////////
;//	Device Driver Service						//
;/////////////////////////////////////////////////////////////////////////
cBegCode
	; note: These code-segment variables make the code
	; not ROMable
	public	old_21
	old_21	dd	?


	public	umblink_strat, umblink_serve, umblink_init, cmderr
umblink_strat:
	push	DS
	call	getDGROUP

	mov	word ptr [ptrsav], BX
	mov	word ptr [ptrsav+2], ES
	pop	DS
	retf

umblink_serve:
	pushf
	push	AX
	push	BX
	push	CX
	push	DX
	push	SI
	push	DI
	push	DS
	push	ES

	call	getDGROUP
IF STACKSIZE
	call	switch_stacks
ENDIF
	; get pointer to i/o packet
	les	BX, [ptrsav]

	; get output status to appease TLINK
	cmp	byte ptr ES:[BX.cmdc], 0AH
	jz	exit

	; make sure this is the INIT(0) command (the only one we support)
	cmp	byte ptr ES:[BX.cmdc], 0	; command code
	jnz	cmderr

	; call the init routine, returns 0 if OK
	call	umblink_init
	jz	exit		; worked
	; fall thru to cmderr...

;
;  An error occurred.  Tell DOS not to install by returning
;  a bogus end address.
;
cmderr:	les	BX, [ptrsav]
	mov	word ptr ES:[BX.endaddr], 0
	mov	word ptr ES:[BX.endaddr+2], 0
	mov	AL, 3		; unknown cmd error
err_exit:
	mov	AH, 81H		; mark error return
	jmp	short err1

exit:	mov	AH, 01H
err1:	les	BX, [ptrsav]
	mov	word ptr ES:[BX.status], AX	; mark as complete

IF STACKSIZE
	call	restore_stack
ENDIF
	pop	ES
	pop	DS
	pop	DI
	pop	SI
	pop	DX
	pop	CX
	pop	BX
	pop	AX
	popf
	retf

IF STACKSIZE
;------------------------------------------------
;  Switch from user to our stack.  Will not do
;  the switch if already on our stack.
;  Assumes DS = DGROUP.
;
;  No registers (other than SS:SP) affected
;
;  note: this code makes the driver non-reentrant
	public	switch_stacks
switch_stacks:
	; save old stack
	mov	word ptr [user_stack+2], SS
	mov	word ptr [user_stack], SP
	add	word ptr [user_stack], 2	; don't include return
	mov	[user_BX], BX
	mov	[user_CX], CX

	; switch to our stack (if not already on our stack)
	mov	BX, SS
	mov	CX, DS
	cmp	BX, CX
	jz	no_switch
	pop	BX		; retrieve return address
	cli
	mov	SS, CX
	mov	SP, offset stacktop
	push	BX		; store return address
no_switch:
	mov	BX, [user_BX]
	mov	CX, [user_CX]
	sti
	ret

;------------------------------------------------
;  Switch from our stack to user stack.
;  Assumes DS = DGROUP.
;
;  No registers (other than SS:SP) affected
;
;  note: this code makes the driver non-reentrant
	public	restore_stack
restore_stack:
	mov	[user_BX], BX
	pop	BX		; retrieve return address
	cli
	mov	SS, word ptr [user_stack+2]
	mov	SP, word ptr [user_stack]
	sti
	push	BX		; store return address
	mov	BX, [user_BX]
	ret
ENDIF

cEndCode

;/////////////////////////////////////////////////////////////////////////
;//	Upper Memory Block Support					//
;/////////////////////////////////////////////////////////////////////////

; DOS locations
;
FIRST_MCB	equ	24H	; segment in DOS DS of 1st MCB
UMB_LINK	equ	89H
UMB_ARENA	equ	8CH

; Memory Control Block fields
;
MCB_ID		equ	0
MCB_OWNER	equ	1
MCB_SIZE	equ	3	; offset for size part of MCB
MCB_INIT_ID	equ	7	; offset for RD specific ID used during BOOT
MCB_NAME	equ	8	; offset for name part of MCB

SYSTEM_ID	equ	8	; SYSTEM "owner" of MCBs
FREE		equ	0	; owner of a free MCB

; The values that S-ICE/EMMSETUP use to describe the 16K page entries
; in the SEGMAP array
;
SICE_PG_FRAME_ID	equ	0F8h
SICE_UMB_ID		equ	0FAh
SICE_VIDEO_ID		equ	0FBh
SICE_ROM_ID		equ	0FCh
SICE_EMS_ID		equ	0FDh
SICE_EXCLUDED_ID	equ	0FFh


cBegCode

int_21_handler:
	cmp	AX, 5803H
	jz	set_umb_link
	jmp	dword ptr CS:[old_21]

set_umb_link:
	push	DS
	push	ES
	push	AX
	push	BX

	; get DOS data segment
	call	getDGROUP
	mov	DS, [DOS_DS]

	; set or clear the link
	or	BX, BX
	jz	clear_link

	; set the link
	cmp	byte ptr DS:[UMB_LINK], 0
	jnz	done_link
	call	hook_umbs
	mov	BL, 1
	jmp	short set_link

	; clear link
clear_link:
	cmp	byte ptr DS:[UMB_LINK], 0
	jz	done_link
	call	unhook_umbs
	mov	BL, 0
set_link:
	mov	byte ptr DS:[UMB_LINK], BL

	; restore registers
done_link:
	pop	BX
	pop	AX
	pop	ES
	pop	DS
	clc
	retf	2


comment ~ ; prototype ;
void hook_umbs(void)
~
c_func	hook_umbs
	push	DS		; save DOS data segment
	call	getDGROUP
	call	get_last_mcb	; get pointer to last MCB
	pop	DS		; restore DOS data segment
	mov	byte ptr ES:[MCB_ID], 'M'
	ret
c_endp	hook_umbs

comment ~ ; prototype ;
void unhook_umbs(void)
~
c_func	unhook_umbs

	; assumes DS = DOS DS upon entry

	; find the MCB that includes the arena
	mov	ES, DS:[FIRST_MCB]
	mov	AX, ES
un_again:
	add	AX, ES:[MCB_SIZE]
	inc	AX
	cmp	AX, DS:[UMB_ARENA]
	jae	un_found
	mov	ES, AX
	jmp	short un_again
un_found:
	; unhook it from the memory list
	mov	byte ptr ES:[MCB_ID], 'Z'
	ret
c_endp	unhook_umbs

	public	get_next_mcb
get_next_mcb	proc	near
	mov	AX, ES
	add	AX, word ptr ES:[MCB_SIZE]
	inc	AX
	mov	ES, AX
	ret
get_next_mcb	endp

	public	get_last_mcb
get_last_mcb	proc	near
	mov	ES, [DOS_DS]
	mov	ES, ES:[FIRST_MCB]
again_mcb	proc	near
	cmp	byte ptr ES:[MCB_ID], 'Z'
	jz	got_last_mcb
	call	get_next_mcb
	jmp	again_mcb
got_last_mcb:
	ret
again_mcb	endp
get_last_mcb	endp

; Returns CF and AX != 0 if the SoftICE device could not be opened
; or if the installed version does not support the IOCTL call to
; fill in the SEGMAP page map array.
;
comment ~
int GetSoftICEPageMap(void)

~
	public	_GetSoftICEPageMap
_GetSoftICEPageMap	proc	near

	mov     ax, 3D00h	; open the SoftICE device
	lea     dx, SoftICE
	int     21h
	jc	GSIPM_done

	push	ax		; ask it to fill in our page map
	mov     bx,ax
	mov     ax, 4402h
	lea     dx, SEGMAP
	mov     cx, 5
	int     21h
	pop	bx
	jc	GSIPM_done

	mov     ax,3E00h   	; close the device and exit
	int     21h
	jc  	GSIPM_done

	xor	ax, ax		; return success

    GSIPM_done:
	ret
_GetSoftICEPageMap	endp

comment ~
void VerifyPageMap(void);
~
	public	_VerifyPageMap
_VerifyPageMap	proc	near

	push   	ds
	push	si
	push	di

	push	ds
	pop   	es			; point es:di to SoftICE's segmap
	lea    	di, SEGMAP
	mov	si, di
	inc	si			; set si to offset SEGMAP+1
	mov    	cx, 40h               	; 40h 16K pages in 1M
	cld

    VPM_verify_one:
	jcxz	VPM_done 		; more pages?
	mov	al, SICE_UMB_ID		; look for a SostICE UMB ID
	repnz	scasb
	jne	VPM_done             	; exit if none

	mov	ax, di                	; get page seg in DS
	sub	ax, si
	shl	ax, 0Ah
	mov	ds, ax
	mov	al, byte ptr ds:[MCB_SIZE] ; make sure page is writeable
	mov	ah, al
	inc	byte ptr ds:[MCB_SIZE]
	xchg	byte ptr ds:[MCB_SIZE],ah
	cmp	al,ah
	jne	VPM_verify_one

	mov	byte ptr es:[di-1], SICE_EXCLUDED_ID	; mark it unusable if not
	jmp	VPM_verify_one

    VPM_done:
	pop	di
	pop	si
	pop	ds
	ret
_VerifyPageMap	endp


; Returns the segment value of the last UMB MCB in the UMB chain or
; -1 if no UMBs are available. Also sets firstUMB to the segment
; value of the first UMB MCB in the UMB chain.
;
comment ~
unsigned BuildUMBChain(void)
~
	public 	_BuildUMBChain
_BuildUMBChain	proc	near

	push	ds
	push	si
	push	di

	push    ds
	pop     es
	lea     di, SEGMAP
	mov	si, di
	inc	si
	mov     cx, 40h
	mov     al, SICE_UMB_ID
	mov     dx, -1
	cld
	repnz   scasb
	jne     BUC_exit

	mov     ax, di
	sub     ax, si
	shl	ax, 0Ah
	mov	firstUMB, ax

    BUC_mark_one_free:
	mov     ds, ax
	mov     dx, ax
	mov     byte ptr ds:[MCB_ID], 'M'
	mov     word ptr ds:[MCB_OWNER], 0
	mov     word ptr ds:[MCB_SIZE], 3FFh

    BUC_merge_free_UMBs:
	jcxz    BUC_no_more_UMBs
	cmp     byte ptr es:[di], SICE_UMB_ID
	jne     BUC_skip_ROMs

	add     word ptr ds:[MCB_SIZE], 400h
	inc     di
	dec     cx
	jmp     BUC_merge_free_UMBs

    BUC_skip_ROMs:
	mov     al, SICE_UMB_ID
	repnz   scasb
	jne     BUC_no_more_UMBs

	mov     ax, di
	sub	ax, si
	shl     ax, 0Ah
	mov     dx, ax
	mov     bx, ds
	sub     dx, bx
	sub     dx, ds:[MCB_SIZE]
	dec     dx
	add     bx, ds:[MCB_SIZE]
	dec     word ptr ds:[MCB_SIZE]

	mov     ds, bx
	mov     byte ptr ds:[MCB_ID], 'M'
	mov     ds:[MCB_OWNER], bx
	mov     ds:[MCB_SIZE], dx
	jmp     BUC_mark_one_free

    BUC_no_more_UMBs:
	cmp     dx, -1
	je      BUC_exit

	mov     ds, dx
	add	dx, ds:[MCB_SIZE]
	dec     word ptr ds:[MCB_SIZE]
	mov	ds, dx
	mov     byte ptr ds:[MCB_ID], 'Z'

    BUC_exit:
	mov     ax, dx
	pop	di
	pop	si
	pop     ds
	ret

_BuildUMBChain	endp


	public	_GetXMSEntry
_GetXMSEntry	proc	near

	mov	ax, 4300h
	int 	2Fh
	cmp	al, 80h
	mov	al, 0B1h		; no UMBs available
	jne	GXMSE_exit

    GXMSE_is_there:
	mov	ax, 4310h
	int	2Fh
	mov	word ptr xms_addr, bx
	mov	word ptr xms_addr[2], es

    GXMSE_exit:
	ret
_GetXMSEntry	endp


; Tries to allocate all available UMBs from the XMS mapping extension
; (eg EMM386, S-ICE). It builds an UMB memory chain in the allocated
; blocks.
;
; Returns a negative XMS error code on failure else 0.
;
comment ~
unsigned _GetUMBs(void)
~
	public _GetUMBs
_GetUMBs	proc	near

	xor	cx, cx
	jmp	short GUMBS_loop

    GUMBS_first_loop:
	mov	firstUMB, cx		; record SEG of first UMB

    GUMBS_loop:
	mov	ah, 10h			; find biggest remaining UMB
	xor	dx, dx
	dec	dx
	push	cx
	call	dword ptr xms_addr
	pop	cx
	or	dx, dx
	mov	al, bl
	jnz	GUMBS_more_UMBs		; if another UMB
	jcxz	GUMBS_exit		; if no UMBs at all
	jmp	short GUMBS_done	; if no more UMBs

    GUMBS_more_UMBs:
	mov	ah, 10h			; allocate next UMB
	push	cx
	call	dword ptr xms_addr
	pop	cx
	cmp	ax, 1
	mov	al, bl
	jnz	GUMBS_exit

	mov	es, bx				; set up its UMB MCB
	mov	byte ptr es:[MCB_ID], 'M'
	mov	word ptr es:[MCB_OWNER], 8
	dec	dx
	dec	dx
	mov	word ptr es:[MCB_SIZE], dx

	mov	ax, bx
	add	bx, dx				; and an empty next UMB MCB
	inc	bx
	mov	es, bx
	mov	byte ptr es:[MCB_ID], 'Z'
	mov	word ptr es:[MCB_OWNER], 9
	mov	word ptr es:[MCB_SIZE], 0
	or	cx, cx				; if this is the first UMB
	xchg	cx, ax				; CX is start seg of cur UMB
	jz	GUMBS_first_loop                ; record it

	mov	es, ax				; AX is start seg of prev UMB
	add	ax, es:[MCB_SIZE]
	inc	ax
	mov	es, ax		               	; es:bx->old 'Z' MCB
	mov	byte ptr es:[MCB_ID], 'M'
	mov	word ptr es:[MCB_OWNER], 9	; ROM's are owned by system
	sub	ax, cx
	not	ax
	mov	word ptr es:[MCB_SIZE], ax
	jmp	short GUMBS_loop		; next

    GUMBS_done:
	xor	ax, ax				; have at least one UMB

    GUMBS_exit:
	cbw					; ret error code in AX
	ret
_GetUMBs	endp


	public	_MStifyUMBs
_MStifyUMBs	proc	near

	mov	es, firstUMB
	inc	firstUMB
	mov	bx, firstUMB

	; es:0->outer UMB start MCB, bx=es+1
	;
    MStify_loop:
	mov	ax, es:[MCB_SIZE]
	mov	dx, bx
	add	dx, ax			; dx = seg of UMB end MCB
	dec	ax
	dec	ax			; built inner UMB start MCB
	mov	es, bx
	mov	es:[MCB_SIZE], ax
	mov	word ptr es:[MCB_OWNER], 0
	mov	byte ptr es:[MCB_ID], 'M'

	add	bx, ax
	inc	bx			; bx = seg of inner end MCB
	mov	es, dx
	mov	al, es:[MCB_ID]
	cmp	al, 'Z'
	je	MStify_done

	push	ds
	mov	ds, bx
	mov	ax, es:[MCB_SIZE]
	inc	ax
	inc	ax
	mov	ds:[MCB_SIZE], ax
	mov	word ptr ds:[MCB_OWNER], 8
	mov	byte ptr ds:[MCB_ID], 'M'
	pop	ds

	add	bx, ax
	mov	es, bx
	inc	bx
	jmp	short MStify_loop

    MStify_done:
	mov	es, bx
	mov	word ptr es:[MCB_SIZE], 0
	mov	word ptr es:[MCB_OWNER], 8
	mov	byte ptr es:[MCB_ID], 'Z'

	ret
_MStifyUMBs	endp


NOP_OP		= 	0090h
TWO_NOPs	=	9090h
JMP_SHORT	=	00EBh
FAR_CALL	=	009Ah
FAR_JUMP	=	00EAh


; the XMS INT_TRAP "struct"
; the int_num value will be the actual <JMP SHORT $+5> opcodes
; contained in the XMS entry point prior to our patching it.
;
; If we were to be deinstalled then we would need the relative
; address field to undo the patch. The XMS calls will be displayed
; as "INT-EB" (the "jump short" opcode).
;
XMS_int_ID	db	0EBh, 3
XMS_entry	dd	?


; the stuff we use to patch the XMS handler
;
XMS_patch	db	FAR_JUMP
    hook_offs   dw	?
    hook_segm	dw	?
XMS_patch_len	dw	$-offset XMS_patch


	public	_PatchXMSHandler
_PatchXMSHandler	proc	near

	push	si
	push	di
	push	ds

	push 	bx			; ES:BX -> XMS handler
	add	bx, 5			; save OUR entry point address
	mov	word ptr XMS_entry, bx	; which is just following our patch
	mov	word ptr XMS_entry[2], es
	pop	bx
	mov	ax, word ptr es:[bx] 	; and the <JMP SHORT $+5> opcodes
	mov	word ptr XMS_int_ID, ax

comment ~
	; assume failure, then make sure we are patching the right thing
	;
	xor	ax, ax
	cmp	byte ptr es:[bx], JMP_SHORT
	jne	PXMS_exit
	cmp	word ptr es:[bx][2], TWO_NOPs
	jne	PXMS_exit
	cmp	byte ptr es:[bx][4], NOP_OP
end_comment ~

	; fix up our patch and install it
	;
	mov	cs:hook_offs, offset _XMS_hook
	mov	ax, cs
	mov	cs:hook_segm, ax
	mov	ds, ax
	mov	di, bx
	mov 	si, offset XMS_patch
	mov	cx, cs:XMS_patch_len

	cld
	rep	movsb

    PXMS_exit:
	pop	ds
	pop	di
	pop	si
	ret
_PatchXMSHandler	endp


	public	_XMS_hook
_XMS_hook	proc	far

	cmp	ah, 10h
	jb	XMSH_chain
	je	XMSH_alloc

	cmp	ah, 12h
	ja	XMSH_chain
	je	XMSH_realloc

;	cmp	ah, 11h
;	je	XMSH_release

    XMSH_release:
    XMSH_chain:
	jmp	dword ptr cs:XMS_entry

    XMSH_alloc:
	mov	bx, dx

    XMSH_realloc:
	or	bx, bx
	mov	bl, 0A7h		; zero paras is invalid arg
	jz	XMSH_return
	mov	bl, 0B0h		; specified size was too big

    XMSH_return:
	xor	dx, dx			; only 0 byte or smaller UMBs availble
	mov	ax, dx
	retf
_XMS_hook	endp

cEndCode

;/////////////////////////////////////////////////////////////////////////
;//	Device Driver Initialization					//
;/////////////////////////////////////////////////////////////////////////
cBegCode

;----------------------------------------------
; bool umblink_init(void)
;
	public umblink_init
umblink_init:
IF SIGNON
	; print a sign-on message
	;
	mov	ah, 30h			; give S-ICE a reason to live...
	int	21h
	printm	signon_msg
ENDIF
	; store DOS data segment
	;
	mov	AH, 52H
	int	21H
	mov	[DOS_DS], ES

   call  CheckForEMM386
   jc    CannotLoad

	; Make sure that there are UMBs and that we can map them in
	;
	call	_GetXMSEntry
	call	_GetSoftICEPageMap
	jc	noSiceUMBs
	call	_VerifyPageMap
	call	_BuildUMBChain
	cmp	ax, -1
	jne	haveUMBs

    noSiceUMBs:
	mov	ax, word ptr xms_addr[2]
	or	ax, word ptr xms_addr
	jz	noUMBs
	call	_GetUMBs
	or	ax, ax
	jns	haveUMBs

    noUMBs:
	les	BX, dword ptr [ptrsav]
	les	BX, ES:[BX.cmdline]
	push	ES
	push	BX
	call	_parse_cmdline
        pop     ax                     ;pop garbage off the stack
	pop	ax

	call	FindRAMBlocks
	call	_GetRAMs
	or	ax, ax
	jns	haveUMBs

    noRAM:
	lea	dx, _noUMBsMessage
	call	print_dos
    CannotLoad:
	jmp	umblink_initerr

    haveUMBs:
	les	bx, xms_addr
	mov	ax, bx
	or	ax, bx
	jz	UMBHandlerInstalled
	call	_PatchXMSHandler

    UMBHandlerInstalled:
	call	_MStifyUMBs

	; trap INT 21H to support Get/Set Link, functions 5803h
	;
	mov	BX, 21H*4
	mov	CX, offset int_21_handler
	mov	DX, offset old_21
	call	set_interrupt

	; shrink last MCB in the outer MCB chain by 1 paragraph
	; to make room for the UMB chain
	;
	call	get_last_mcb
	dec	word ptr ES:[MCB_SIZE]
	mov	byte ptr es:[MCB_ID], 'M'
	call	get_next_mcb		; ES now points past MCB chain

	; record arena (1st UMB) in DOS data area
	;
	push	DS
	mov	DS, [DOS_DS]
	mov	DS:[UMB_ARENA], ES
	pop	DS

	; set up an MCB header in conventional memory that points
	; to the first UMB MCB, the outer MCB chain already points
	; to this MCB
	;
	mov 	byte ptr es:[MCB_ID], 'M'
	mov	word ptr es:[MCB_OWNER], SYSTEM_ID
	mov	ax, firstUMB
	mov	bx, es
	sub	ax, bx
	dec	ax
	mov	word ptr es:[MCB_SIZE], ax

	; If in CONFIG.SYS processing now, find the last MCB in the
	; inner MCB chain
	;
	mov	es, [DOS_DS]
	mov	es, es:[FIRST_MCB]
	cmp	byte ptr es:[MCB_INIT_ID], 0
	jne	UMBs_linked_in

	; Link the UMBs to the inner MCB chain so we can load
	; devices high
	;
	mov	ax, es
	inc	ax
	mov	es, ax
	call	again_mcb
	dec	word ptr es:[MCB_SIZE]
	mov	byte ptr es:[MCB_ID], 'M'

	; Set the "UMBs are linked in right now" flag
	;
	mov	es, [DOS_DS]
	mov	byte ptr es:[UMB_LINK], 1

    UMBs_linked_in:
	; determine size of this driver
	;
	mov	AX, SEG _ENDSEG
	les	BX, [ptrsav]
	mov	word ptr ES:[BX.endaddr], 0
	mov	word ptr ES:[BX.endaddr+2], AX

	; everthing worked (0=OK)
	xor	AX, AX
	ret

umblink_initerr:
	mov	AX, 1
	ret

;-----------------------------------
;   On Entry
;	0:BX = ptr to int vector
;	CS:CX = ptr to new code
;	CS:DX = ptr for storing old vector
;
	public	set_interrupt
set_interrupt	proc	near
	push	DS
	xor	AX, AX
	mov	DS, AX
	cli
	les	AX, DS:[BX]
	mov	word ptr DS:[BX], CX
	mov	word ptr DS:[BX+2], CS
	sti
	xchg	DX, BX
	mov	word ptr CS:[BX], AX
	mov	word ptr CS:[BX+2], ES
	pop	DS
	ret
set_interrupt	endp


cEndCode

;/////////////////////////////////////////////////////////////////////////
;//	Utilities                                                       //
;/////////////////////////////////////////////////////////////////////////

cBegCode

;-------------------------------------------
;  Get DGROUP into DS relative to current CS
;  Affects no registers.
	public	getDGROUP
getDGROUP proc near
	push	AX
	push	CX
	mov	AX, offset _TEXT:datastart
	mov	CL, 4
	shr	AX, CL
	mov	CX, CS
	add	AX, CX
	mov	DS, AX
	pop	CX
	pop	AX
	ret
getDGROUP endp

	public	getDEVDATA
getDEVDATA proc near
	mov	AX, SEG _DEVDATA
	ret
getDEVDATA endp


IF PROG_DEBUG GE 1

;-----------------------------
;  On Entry
;	AL = character
BIOSPUTC_WAIT:
	call	BIOSPUTC
	push	AX
	xor	AX, AX
	int	16H
	pop	AX
	ret

;-----------------------------
;  On Entry
;	AL = character
public BIOSPUTC
BIOSPUTC:
	push	AX
	push	BX
	mov	AH, 0EH
	mov	BX, 7
	int	10H
	pop	BX
	pop	AX
	ret

;-----------------------------
;  On Entry
;	DS:SI = string
BIOSPUTS:
	push	SI
again_puts:
	mov	AL, [SI]
	cmp	AL, 0
	jz	done_puts
	call	BIOSPUTC
	inc	SI
	jmp	again_puts
done_puts:
	pop	SI
	ret

;-----------------------------
;  On Entry
;	AL = digit
BIOSPUTDIGIT:
	push	AX
	push	BX
	and	AL, 0FH
	cmp	AL, 0AH
	jae	hexdigit
	add	AL, '0'
	jmp	short digit10
hexdigit:
	add	AL, 'A'-0AH
digit10:
	mov	BX, 7
	mov	AH, 0EH
	int	10H
	pop	BX
	pop	AX
	ret

;-----------------------------
;  On Entry
;	AX = 16 bit hex #
BIOSPUTX:
	push	CX
	push	DX
	mov	DX, AX
	mov	CL, 12
bpx_again:
	mov	AX, DX
	shr	AX, CL
	push	CX
	push	DX
	call	BIOSPUTDIGIT
	pop	DX
	pop	CX
	sub	CL, 4
	cmp	CL, 0
	jge	bpx_again
	pop	DX
	pop	CX
	ret

;-----------------------------
;  On Entry
;	DX:AX = 32 bit hex #
	public	BIOSPUTLX
BIOSPUTLX:
	push	AX
	mov	AX, DX
	call	BIOSPUTX
	pop	AX
	call	BIOSPUTX
	ret

	public	BIOSCRLF
BIOSCRLF:
	push	AX
	mov	AL, 13
	call	BIOSPUTC
	mov	AL, 10
	call	BIOSPUTC
	pop	AX
	ret

ENDIF ; PROG_DEBUG


;----------------------------------------
; On Entry
;	DS:DX points to a string to print
	public	print_dos
print_dos:
	mov	AH, 9
	int	21h
	ret


cEndCode

cBegCode

; Determines if there is RAM at es:bx
;
;->: 	es:bx	ptr to start of block to check
;<-:	ZF set if block contains RAM
;
	public	CheckIfRAM
CheckIfRAM	proc near

	push	ax
	push	cx

	mov	ax, es:[bx]
	not	ax
	mov	cx, ax
	pushf
	cli
	xchg	ax, es:[bx]
	xchg	ax, es:[bx]
	popf
	cmp	ax, cx

	pop	cx
	pop	ax
	retn
CheckIfRAM	endp


; adds 4K to es
;
; ->:	es	seg of a 4K block
; <-:	es	seg of next highest 4K block
;
	public	Next4K
Next4K	proc	near

	push	ax

	mov	ax, es
	add	ax, ((4*1024) shr 4)
	mov	es, ax

	pop	ax
	retn
Next4K	endp


; We want to look for RAM in each non-excluded 4K block in the range
; of RAM_SCAN_START_SEG to RAM_SCAN_END_SEG, inclusive
;
; ->:	void
; <-:	void	sets up the use_array array to have a 1 for each block that
;		holds a block of RAM that we are to convert to a UMB
;		Any eXclude command line args must have been processed
;		before this routine is called and the appropriate elements
;		of the use_array array must have been cleared.
;
	public	FindRAMBlocks
FindRAMBlocks	proc	near

	push	bx
	push	cx
	push	si
	push	es

	mov	bx, RAM_SCAN_START_SEG
	mov	es, bx
	xor	bx, bx
	xor	si, si
	mov	cx, BLOCKS_TO_CHECK

    TryAgain:
	cmp	use_array[si], 0
	je	short TryNext4K		; if excluded

	call	CheckIfRAM
	jz	short TryNext4K		; or if no RAM here

	mov	use_array[si], 0 	; don't make block a UMB

    TryNext4K:
	inc	si
	call	Next4K
	loop	TryAgain

	pop	es
	pop	si
	pop	cx
	pop	bx
	retn
FindRAMBlocks	endp


; After the use_array array has be set up, this routine will return the starting
; segment address and the size (in paras) of the least, RAM block to use_array.
; This routine destroys the data in the use_array array for the returned block
;
;
; ->:	void
; <-:	bx	seg of next RAM block
;	dx	size of block in paras (0 => no more blocks)
;
	public	GetNextBlockFromTable
GetNextBlockFromTable	proc	near

	push	ax
	push	cx
	push	si
	push	di
	push	es

	xor	ax, ax
	xor	bx, bx
	xor	dx, dx
	mov	cx, BLOCKS_TO_CHECK
	lea	di, use_array
	mov	si, di
	push	ds
	pop	es

	cld
	repe	scasb
	jz	Done

	dec	di
	inc	cx
	push	di
	sub	di, si
	mov	ax, ((4*1024) shr 4)
	mov	bx, RAM_SCAN_START_SEG
	mul	di
	pop	di
	add	bx, ax

	xor	dx, dx
	xor	ax, ax

    CountEm:
	cld
	scasb
	jz	short ComputeParas

	dec	di
	cld
	stosb
	inc	dx
	loop	CountEm

    ComputeParas:
	mov	ax, ((4*1024) shr 4)
	mul	dx
	mov	dx, ax

    Done:
	pop	es
	pop	di
	pop	si
	pop	cx
	pop	ax
	retn
GetNextBlockFromTable	endp


; Builds MCBs inside any non-excluded RAM that was not owned by S-ICE or
; an XMS UMB provider. The MCB chain is not linked in to DOS' MCB chain
;
; ->:	void
; <-:	ax	0 on success else -1
;
comment ~
unsigned _GetRAMs(void)
~
	public _GetRAMs
_GetRAMs	proc	near

	xor	cx, cx
	jmp	short GRAMs_loop

    GRAMs_first_loop:
	mov	firstUMB, cx		; record SEG of first UMB

    GRAMs_loop:
	call	GetNextBlockFromTable
	or	dx, dx
	mov	al, -1
	jnz	GRAMs_more_RAMs		; if another UMB
	jcxz	GRAMs_exit		; if no RAMs at all
	jmp	short GRAMs_done	; if no more RAMs

    GRAMs_more_RAMs:
	mov	es, bx				; set up its UMB MCB
	mov	byte ptr es:[MCB_ID], 'M'
	mov	word ptr es:[MCB_OWNER], 8
	dec	dx
	dec	dx
	mov	word ptr es:[MCB_SIZE], dx

	mov	ax, bx
	add	bx, dx				; and an empty next UMB MCB
	inc	bx
	mov	es, bx
	mov	byte ptr es:[MCB_ID], 'Z'
	mov	word ptr es:[MCB_OWNER], 9
	mov	word ptr es:[MCB_SIZE], 0
	or	cx, cx				; if this is the first UMB
	xchg	cx, ax				; CX is start seg of cur UMB
	jz	GRAMs_first_loop                ; record it

	mov	es, ax				; AX is start seg of prev UMB
	add	ax, es:[MCB_SIZE]
	inc	ax
	mov	es, ax		               	; es:bx->old 'Z' MCB
	mov	byte ptr es:[MCB_ID], 'M'
	mov	word ptr es:[MCB_OWNER], 9	; ROM's are owned by system
	sub	ax, cx
	not	ax
	mov	word ptr es:[MCB_SIZE], ax
	jmp	short GRAMs_loop		; next

    GRAMs_done:
	xor	ax, ax				; have at least one UMB

    GRAMs_exit:
	cbw					; ret error code in AX
	ret
_GetRAMs	endp



;/////////////////////////////////////////////////////////////////////////
;//	Command Line Parsing					       	//
;/////////////////////////////////////////////////////////////////////////

comment ~ ; prototype ;
int toupper(char c)
~
	public _toupper
_toupper	proc	near
	push	bp
	mov	bp,sp
	mov	dl,byte ptr [bp+4]
   ;
   ;	{
   ;		if(c>='a' && c<='z')
   ;
	cmp	dl,97
	jl	short @2@98
	cmp	dl,122
	jg	short @2@98
   ;
   ;			c = c-'a'+'A';
   ;
	mov	al,dl
	add	al,224
	mov	dl,al
@2@98:
   ;
   ;		return c;
   ;
	mov	al,dl
	cbw
	jmp	short @2@122
@2@122:
   ;
   ;	}
   ;
	pop	bp
	ret
_toupper	endp


comment ~ ; prototype ;
int isterminator(char c)
~
	public _isterminator
_isterminator	proc	near
	push	bp
	mov	bp,sp
	mov	dl,byte ptr [bp+4]
	xor	ax,ax
   ;
   ;	{
   ;		return (c<' ' && c!='\t');
   ;
	cmp	dl, ' '
	jge	short @3@98
	cmp	dl, 9
	je	short @3@98
	inc	ax
@3@98:
   ;
   ;	}
   ;
	pop	bp
	ret
_isterminator	endp


comment ~ ; prototype ;
int isseparator(char c)
~
	public _isseparator
_isseparator	proc	near
	push	bp
	mov	bp,sp
	mov	dl,byte ptr [bp+4]
	xor	ax, ax
   ;
   ; {
   ;	return (c==' ' || c=='\t' || c==',' || c=='/' || c=='-' || c=='=');
   ;
	cmp	dl, ' '
	je	short @4@98
	cmp	dl, 9
	je	short @4@98
	cmp	dl, ','
	je	short @4@98
	cmp	dl, '/'
	je	short @4@98
	cmp	dl, '-'
	je	short @4@98
	cmp	dl, '='
	jne	short @4@122
@4@98:
	inc	ax
@4@122:
   ;
   ; }
   ;
	pop	bp
	ret
_isseparator	endp


comment ~ ; prototype ;
int isdigit(char c)
~
	public _isdigit
_isdigit	proc	near
	push	bp
	mov	bp,sp
	mov	dl,byte ptr [bp+4]
   ;
   ;	{
   ;		return (c>='0' && c<='9');
   ;
	cmp	dl,48
	jl	short @5@98
	cmp	dl,57
	jg	short @5@98
	mov	ax,1
	jmp	short @5@122
@5@98:
	xor	ax,ax
@5@122:
	jmp	short @5@146
@5@146:
   ;
   ;	}
   ;
	pop	bp
	ret
_isdigit	endp


comment ~ ; prototype ;
int isxdigit(char c)
~
	public _isxdigit
_isxdigit	proc	near
	push	bp
	mov	bp,sp
   ;
   ;	{
   ;		c = toupper(c);
   ;
	mov	al,byte ptr [bp+4]
	push	ax
	call	near ptr _toupper
	pop	cx
	mov	byte ptr [bp+4],al
   ;
   ;		return (isdigit(c) || (c>='A' && c<='F'));
   ;
	mov	al,byte ptr [bp+4]
	push	ax
	call	near ptr _isdigit
	pop	cx
	or	ax,ax
	jne	short @6@98
	cmp	byte ptr [bp+4],65
	jl	short @6@122
	cmp	byte ptr [bp+4],70
	jg	short @6@122
@6@98:
	mov	ax,1
	jmp	short @6@146
@6@122:
	xor	ax,ax
@6@146:
	jmp	short @6@170
@6@170:
   ;
   ;	}
   ;
	pop	bp
	ret
_isxdigit	endp


comment ~ ; prototype ;
unsigned far_atoi(char far *s)
~
	public _far_atoi
_far_atoi	proc	near
	push	bp
	mov	bp,sp
	push	si
   ;
   ;	{
   ;		unsigned val=0;
   ;
	xor	si,si
	jmp	short @7@74
@7@50:
   ;
   ;		while(isdigit(*s))
   ;		{
   ;			val*= 10;
   ;
	mov	dx,10
	mov	ax,si
	imul	dx
	mov	si,ax
   ;
   ;			val+= *s-'0';
   ;
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	cbw
	add	ax,65488
	add	si,ax
   ;
   ;			++s;
   ;
	inc	word ptr [bp+4]
@7@74:
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _isdigit
	pop	cx
	or	ax,ax
	jne	short @7@50
   ;
   ;		}
   ;		return val;
   ;
	mov	ax,si
	jmp	short @7@122
@7@122:
   ;
   ;	}
   ;
	pop	si
	pop	bp
	ret
_far_atoi	endp


comment ~ ; prototype ;
unsigned far_atoh(char far *s)
~
	public _far_atoh
_far_atoh	proc	near
	push	bp
	mov	bp,sp
	push	si
   ;
   ;	{
   ;		unsigned h=0;
   ;
	xor	si,si
	jmp	short @8@170
@8@50:
   ;
   ;		char c;
   ;
   ;		while(isxdigit(*s))
   ;		{
   ;			h*= 16;
   ;
	mov	dx,16
	mov	ax,si
	imul	dx
	mov	si,ax
   ;
   ;			h+= (*s>='0' && *s<='9' ? *s-'0' : toupper(*s) - 'A' + 10);
   ;
	les	bx,dword ptr [bp+4]
	cmp	byte ptr es:[bx],48
	jl	short @8@122
	les	bx,dword ptr [bp+4]
	cmp	byte ptr es:[bx],57
	jg	short @8@122
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	cbw
	add	ax,65488
	jmp	short @8@146
@8@122:
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _toupper
	pop	cx
	add	ax,65481
@8@146:
	add	si,ax
   ;
   ;			++s;
   ;
	inc	word ptr [bp+4]
@8@170:
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _isxdigit
	pop	cx
	or	ax,ax
	jne	short @8@50
   ;
   ;		}
   ;		return h;
   ;
	mov	ax,si
	jmp	short @8@218
@8@218:
   ;
   ;	}
   ;
	pop	si
	pop	bp
	ret
_far_atoh	endp


comment ~ ; prototype ;
char far *nextparm(char far *s)
~
	public _nextparm
_nextparm	proc	near
	push	bp
	mov	bp,sp
	jmp	short @9@74
@9@50:
   ;
   ;	{
   ;		while(!isterminator(*s) && !isseparator(*s))
   ;			++s;
   ;
	inc	word ptr [bp+4]
@9@74:
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _isterminator
	pop	cx
	or	ax,ax
	jne	short @9@122
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _isseparator
	pop	cx
	or	ax,ax
	je	short @9@50
@9@122:
	jmp	short @9@170
@9@146:
   ;
   ;		while(!isterminator(*s) && isseparator(*s))
   ;			++s;
   ;
	inc	word ptr [bp+4]
@9@170:
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _isterminator
	pop	cx
	or	ax,ax
	jne	short @9@218
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _isseparator
	pop	cx
	or	ax,ax
	jne	short @9@146
@9@218:
   ;
   ;		return s;
   ;
	mov	dx,word ptr [bp+6]
	mov	ax,word ptr [bp+4]
	jmp	short @9@242
@9@242:
   ;
   ;	}
   ;
	pop	bp
	ret
_nextparm	endp


comment ~ ; prototype ;
int fmemcmpi(char far *s1, char far * s2, int n)
~
	public _fmemcmpi
_fmemcmpi	proc	near
	push	bp
	mov	bp,sp
	dec	sp
	dec	sp
	push	si
	mov	si,word ptr [bp+12]
	jmp	short @10@74
@10@50:
   ;
   ;	{
   ;		char c1,c2;
   ;		while(--n>0 && (c1=toupper(*s1))==(c2=toupper(*s2)))
   ;			++s1, ++s2;
   ;
	inc	word ptr [bp+4]
	inc	word ptr [bp+8]
@10@74:
	dec	si
	jle	short @10@122
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _toupper
	pop	cx
	mov	byte ptr [bp-1],al
	push	ax
	les	bx,dword ptr [bp+8]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _toupper
	pop	cx
	mov	byte ptr [bp-2],al
	pop	dx
	cmp	dl,al
	je	short @10@50
@10@122:
   ;
   ;		if(c1 == c2)
   ;
	mov	al,byte ptr [bp-1]
	cmp	al,byte ptr [bp-2]
	jne	short @10@194
   ;
   ;			return 0;
   ;
	xor	ax,ax
	jmp	short @10@266
@10@194:
   ;
   ;		else if(c1 < c2)
   ;
	mov	al,byte ptr [bp-1]
	cmp	al,byte ptr [bp-2]
	jge	short @10@242
   ;
   ;			return -1;
   ;
	mov	ax,65535
	jmp	short @10@266
@10@242:
   ;
   ;		return 1;
   ;
	mov	ax,1
@10@266:
   ;
   ;	}
   ;
	pop	si
	mov	sp,bp
	pop	bp
	ret
_fmemcmpi	endp


comment ~ ; prototype ;
unsigned getnum(char far **sptr, int base)
~
	public _getnum
_getnum	proc	near
	push	bp
	mov	bp,sp
	push	si
	push	di
	mov	si,word ptr [bp+4]
   ;
   ;	{
   ;		unsigned val;
   ;		if(base == 16)
   ;
	cmp	word ptr [bp+6],16
	jne	short @11@74
   ;
   ;			val = far_atoh(*sptr);
   ;
	push	word ptr [si+2]
	push	word ptr [si]
	call	near ptr _far_atoh
	pop	cx
	pop	cx
	mov	di,ax
	jmp	short @11@98
@11@74:
   ;
   ;		else
   ;			val = far_atoi(*sptr);
   ;
	push	word ptr [si+2]
	push	word ptr [si]
	call	near ptr _far_atoi
	pop	cx
	pop	cx
	mov	di,ax
@11@98:
	jmp	short @11@146
@11@122:
   ;
   ;		while(isxdigit(**sptr))
   ;			++(*sptr);
   ;
	inc	word ptr [si]
@11@146:
	les	bx,dword ptr [si]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _isxdigit
	pop	cx
	or	ax,ax
	jne	short @11@122
   ;
   ;		return val;
   ;
	mov	ax,di
	jmp	short @11@194
@11@194:
   ;
   ;	}
   ;
	pop	di
	pop	si
	pop	bp
	ret
_getnum	endp


comment ~ ; prototype ;
void parse_cmdline(char far * s)
~
	public	_parse_cmdline

   include_flag   db  0       ; Command line "i"nclude or e"x"clude

_parse_cmdline	proc	near
	push	bp
	mov	bp,sp
	push	si
	push	di
	push	es

@12@98:
        les     bx,dword ptr [bp+4]

        mov     cs:include_flag,1         ; assume it's an include
        cmp     word ptr es:[bx],'=I'
        je      get_range

        mov     cs:include_flag,0         ; nope, it's an exclude instead
        cmp     word ptr es:[bx],'=X'
        je      get_range

        jmp     @12@410
get_range:

	add 	word ptr [bp+4],2       ; get rid of the 'X='
        push    16
        lea     ax,[bp+4]
        push    ax
        call    _getnum         	; returns ax = number
        pop     cx
        pop     cx
        xor     al,al          		; round down to nearest 4K
        push    ax              	; save for now
        jmp 	short @12@290

@12@266:
	inc	word ptr [bp+4]

@12@290:
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _isterminator
	pop	cx
	or	ax,ax
	jne	short @12@338

	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _isxdigit
	pop	cx
	or	ax,ax
	je	short @12@266

@12@338:
	mov	ax,16
	push	ax
	lea	ax,word ptr [bp+4]
	push	ax
	call	near ptr _getnum
        pop     cx
        pop     cx

	;ax has the end segment address, round up to nearest 4K
	;
        add     ax,255
        jnc 	short rl_1

	;We have wrapped over the top, ah is now zero, set it back down
	;
        dec     ah

rl_1:
        mov     al,0
        pop     bx              ;start of block

	; clamp limits to range of use_array
	;
	cmp	bx, RAM_SCAN_START_SEG
	jae	rl_2
	mov	bx, RAM_SCAN_START_SEG

rl_2:
	cmp	ax, RAM_SCAN_END_SEG
	jbe	rl_3
	mov	ax, RAM_SCAN_END_SEG

	;check if start and stop addresses are appropriate
	;
rl_3:
        sub     ax,bx           ;is top below or equal to start?
        jbe 	short @12@410       ;jmp if not appropriate
        or      bx,bx           ;is the start zero?
        jz 	short @12@410        ;jmp if not appropriate

	xor	cx, cx
	mov	cl, bh       	; cx = 4K use_array index to start with
	sub	cl, (RAM_SCAN_START_SEG shr 8)
	lea	di, use_array
	add	bx, BLOCKS_TO_CHECK
	add	di, cx          ; di is address of first excluded element
	mov	cl, ah		; number of 4K pages in excluded range
	cld
	push	ds
	pop	es
        mov    al,cs:include_flag   ; Value to stosb (1=include, 0=exclude)
        rep    stosb                ; set (or clear) values as appropriate

@12@410:
	push	word ptr [bp+6]
	push	word ptr [bp+4]
	call	near ptr _nextparm
	pop	cx
	pop	cx
	mov	word ptr [bp+6],dx
	mov	word ptr [bp+4],ax

@12@434:
	les	bx,dword ptr [bp+4]
	mov	al,byte ptr es:[bx]
	push	ax
	call	near ptr _isterminator
	pop	cx
	or	ax,ax
	jnz	@12@900
        jmp     @12@98                  ;loop until we find the termination

@12@900:
	pop	es
	pop	di
	pop	si
	pop	bp
	retn
_parse_cmdline	endp

cEndCode


;/////////////////////////////////////////////////////////////////////////
;//	Terminate and Stay Resident Code				//
;/////////////////////////////////////////////////////////////////////////
cBegCode

   ; get the interrupt 67h vector, then check it for EMM
   ; no registers preserved - they are not in use when called.
   ;
   public CheckForEMM386
CheckForEMM386 proc	near

   mov   AX, 3567H   ; get int vector
   int   21H         ; returns vector in ES:BX

   mov   BX, 10      ; check ES:0AH for EMM signature
   cld

   mov   AL, ES:[BX]
   cmp   AL, 'E'     ; 'E' first byte
   jne   NoEMM386

   inc   BX
   mov   AX, ES:[BX]
   cmp   AX, 4D4Dh   ; 'MM' next two bytes
   jne   NoEMM386

   stc               ; EMM386 found, set flag
NoEMM386:
   ret
CheckForEMM386 endp


_astart:
   call  CheckForEMM386
   jc    tsr_error

IF TSR
	; set up our stack
	mov	AX, DGROUP
	mov	DS, AX
	cli
	mov	SS, AX
	mov	SP, GOFFSET stacktop
	sti

	; zero the uninitialized C data (BSS)
	call	zero_bss

	; call the originial INIT routine
	mov	SI, ES				; save ES (PSP)
	call	getDEVDATA
	mov	ES, AX
	mov	BX, offset _DEVDATA:req_hdr
	mov	byte ptr ES:[BX.cmdc], 0
	mov	word ptr ES:[BX.cmdline], 81H
	mov	word ptr ES:[BX+cmdline+2], SI	; PSP:81H

	; initialize the device
	push	CS
	call	umblink_strat
	; we can (and must) call umblink_init directly, not through umblink_serve
	call	umblink_init
	or	AX, AX
	jnz	tsr_error

	; hook into device chain
	assume	DS:_DEVDATA
	push	DS
	call	getDEVDATA
	mov	DS, AX
	mov	AH, 52H
	int	21H		; returned in ES:BX
	mov	AX, ES:[48H]
	mov	DX, ES:[48H+2]	; get pointer to 1st device
	mov	word ptr DS:[_umblinkx], AX
	mov	word ptr DS:[_umblinkx+2], DX
	cli
	mov	word ptr ES:[48H], offset _DEVDATA:_umblinkx
	mov	word ptr ES:[48H+2], DS
	sti
	pop	DS
	assume	DS:DGROUP

	; Terminate and Stay Resident
	call	getDEVDATA
	mov	ES, AX
	mov	BX, offset _DEVDATA:req_hdr
	mov	DX, ES:[BX.endaddr+2]	; end address (calcd by init)
	sub	DX, AX
	add	DX, 10H		; for PSP
	mov	AX, 3100H
	int	21H
ELSE

	call	getDGROUP
IF SIGNON
	; print a sign-on message
	printm	signon_msg
ENDIF
	printm	device_only

ENDIF ; TSR

	; Error! Terminate
tsr_error:
	mov	AX, 4C01H
	int	21H
cEndCode

	END	_astart
