;
;   $Id: dlint15y.asm 1.3 2002/10/15 22:43:50Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:DLINT15.ASM created 06/25/1998 by Drew Gislason
;
; Copyright (c) 1998-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary
;
; Interface to Int 15H memory routines.
;--------------------------------------------------------------------
include datalght.inc

; MEMMODEL is assumed to be defined using a /D argument on the
; assembler command line.
;
; Establish segment model, calling conventions, etc.
;
InitModel %MEMMODEL, C, use16

.code

;--------------------------------------------------------------------
; $DOCPROC:SetDescriptorAddr
;
; void SetDescriptorAddr(Descriptor *pDescriptor, ulong lAddr)
;
; This routine is defined in assembly simply because it is a hard
; operation to do in C. This sets the 32-bit linear address in a
; 386+ descriptor.
;--------------------------------------------------------------------
ProcBegin	SetDescriptorAddr, PUBLIC
ProcArgs	@@pDescriptor:ptr, @@lAddr:dword
ProcSetup
	lptr_es	bx, @@pDescriptor
	mov	dx, word ptr @@lAddr+2
	mov	ax, word ptr @@lAddr

	; copy linear address fields into
	mov	es:[bx+2], ax	; bits  0-15 of addr
	mov	es:[bx+4], dl	; bits 16-23 of addr
	mov	es:[bx+7], dh	; bits 24-31 of addr
ProcEnd

	END
