;
;   $Id: EMSERMSG.ASM 1.4 2002/10/15 22:47:08Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
comment ~

EMSLIBx -- Low level LIM 4.0 EMS function library source module
Created 10-25-97 by Dennis Edwards
This module implements the function (DLEMSLIB.H):

char *GetEMSErrorCodeString(int EMSErrorCode);

Copyright (c) 1997-2002 Datalight, Inc.
All Rights Reserved.
Datalight Confidential and Proprietary

end_comment ~
;
; use the /i switch on the assembler command line to specify
; the include path if these files are not in the current dir
;
include datalght.inc

; MEMMODEL is assumed to be defined using a /D argument on the
; assembler command line.
;
; Establish segment model, calling conventions, etc.
;
InitModel %MEMMODEL, pascal, use16

; internal include module for EMSLIBx.LIB
;
include _emslib.inc

MAX_KNOWN_EMS_ERROR	= 0A4h

.Data

EMSError00String        db "EMS function successful.",0
EMSError80String        db "EMM software error.",0
EMSError83String        db "EMS handle not found.",0
EMSError84String        db "Undefined EMS function.",0
EMSError85String        db "No more EMS handles.",0
EMSError86String        db "Can't delete EMS handle, context saved.",0
EMSError87String        db "Not enough total EMS pages.",0
EMSError88String        db "Not enough free EMS pages.",0
EMSError89String        db "Cannot allocate 0 EMS pages.",0
EMSError8AString        db "Invalid logical EMS page.",0
EMSError8BString        db "Invalid physical EMS page.",0
EMSError8CString        db "EMS context save area full.",0
EMSError8DString        db "EMS handle context already saved.",0
EMSError8EString        db "EMS handle context not found.",0
EMSError8FString        db "Undefined EMS sub-function.",0
EMSError90String        db "Undefined EMS handle attribute.",0
EMSError91String        db "EMS OS capability not supported.",0
EMSError92String        db "EMS MOV source/destination regions overlap.",0
EMSError93String        db "EMS MOV/XCHG length greater than allocated.",0
EMSError94String        db "Conventional MOV/XCHG range overlaps EMS.",0
EMSError95String        db "EMS MOV/XCHG offset exceeds length.",0
EMSError96String        db "EMS MOV/XCHG region length exceeds 1M-byte.",0
EMSError97String        db "EMS XCHG source/destination regions overlap.",0
EMSError98String        db "EMS MOV/XCHG undefined memory type.",0
EMSError9AString	db "AMRS number undefined.",0
EMSError9BString	db "No more AMRSs.",0
EMSError9CString        db "EMS AMRS/DMARS not supported.",0
EMSError9DString	db "AMRS number not allocated.",0
EMSErrorA0String        db "EMS named handle not found.",0
EMSErrorA1String        db "EMS named handle already exists.",0
EMSErrorA2String        db "EMS MOV/XCHG wraps at 1M-byte.",0
EMSErrorA3String        db "EMS data structure invalid.",0
EMSErrorA4String        db "EMS access denied to function.",0
EMSErrorB0String        db "EMS stack over-flow.",0
UnknownEMSErrorString 	db "Unknown EMS error: "
ErrorCodeBytes		db ?,?,'h.',0
EMSErrorStringTable 	dw offset EMSError80String
			dw offset UnknownEMSErrorString
			dw offset UnknownEMSErrorString
			dw offset EMSError83String
			dw offset EMSError84String
			dw offset EMSError85String
			dw offset EMSError86String
			dw offset EMSError87String
			dw offset EMSError88String
			dw offset EMSError89String
			dw offset EMSError8AString
			dw offset EMSError8BString
			dw offset EMSError8CString
			dw offset EMSError8DString
			dw offset EMSError8EString
			dw offset EMSError8FString
			dw offset EMSError90String
			dw offset EMSError91String
			dw offset EMSError92String
			dw offset EMSError93String
			dw offset EMSError94String
			dw offset EMSError95String
			dw offset EMSError96String
			dw offset EMSError97String
			dw offset EMSError98String
			dw offset UnknownEMSErrorString
			dw offset EMSError9AString
			dw offset EMSError9BString
			dw offset EMSError9CString
			dw offset EMSError9DString
			dw offset UnknownEMSErrorString
			dw offset UnknownEMSErrorString
			dw offset EMSErrorA0String
			dw offset EMSErrorA1String
			dw offset EMSErrorA2String
			dw offset EMSErrorA3String
			dw offset EMSErrorA4String

.Code
if @DataSize
	assume	cs:@curseg, ds:nothing, es:nothing, ss:nothing
else
	assume	cs:@curseg, ds:@data, es:nothing, ss:nothing
endif
comment ~
char *GetEMSErrorCodeString(int EMSErrorCode);
end_comment ~
ProcBegin   	GetEMSErrorCodeString,public
if @DataSize
ProcUses	ds,cx,bx
else
ProcUses	cx,bx
endif
ProcArgs	@@EMSErrorCode:word
ProcSetup

if @DataSize
	mov	bx, @data
	mov	ds, bx
	assume  ds: @data
endif
	mov	ax, @@EMSErrorCode
	lea	bx, EMSError00String            ; assume there was no error
	or	ax, ax
	jz	@@done
	lea	bx, UnknownEMSErrorString       ; all error codes <=0
	jns	@@done
	and	ax, 0FFh			; isolate error code in low byte
	cmp	ax, MAX_KNOWN_EMS_ERROR         ; don't go past end of table
	ja	@@done

	; Have valid error code in AX, use it as an 80h based index into
	; our table of word length message pointers.
	;
   @@get_it:
	mov	bx, ax
	sub	bx, 80h
	shl	bx, 1
	mov	bx, EMSErrorStringTable[bx]

	; Return a pointer to the appropriate message
	;
    @@done:
	cmp	bx, offset UnknownEMSErrorString
	jne	@@return

	mov	ah, al
	shr	al, 4    		; high nybble in AL
	and	ax, 0F0Fh		; low  nybble in AH
	mov	cx, 3030h		; assume both nybbles are digits
	cmp	ah, 9
	jbe	@@ah_is_ok
	sub	ah, 10 			; not a digit, adjust for alpha base
	mov	ch, 'A'			; make hex digit addend

   @@ah_is_ok:
	cmp	al, 9
	jbe	@@al_is_ok
	sub	al, 10
	mov	cl, 'A'

   @@al_is_ok:
	add	ax, cx
	mov	word ptr ErrorCodeBytes, ax

    @@return:
	mov	ax, bx
if @DataSize
	mov	dx, ds
endif
ProcEnd

	end
