;
;   $Id: _EMSLIB.INC 1.4 2002/10/15 22:47:08Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
comment ~

   _EMSLIB.H -- Low level LIM 4.0 EMS function library private include file.
   Created 10-25-97 by Dennis Edwards

   Copyright (c) 1997-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

end_comment ~

; Interrupt numbers used by EMMLIBx
;
DOS_INT					EQU	21h
EMS_INT					EQU	67h

; DOS function to return an interrupt vector
;
DOS_GET_INT_VECTOR			EQU	35h

; Function numbers for LIM 4.0 EMS calls via int 67h
;
EMS_GET_STATUS_FCN			equ	40h
EMS_GET_PAGE_FRAME_FCN			equ	41h
EMS_GET_UNALLOC_PAGE_CNT_FCN		equ	42h
EMS_ALLOCATE_PAGES_FCN			equ	43h
EMS_MAP_PAGE_FCN			equ	44h
EMS_DEALLOC_FCN				equ	45h
EMS_GET_EMM_VERSION_FCN			equ	46h
EMS_SAVE_LIM32_PAGE_MAP_FCN    		equ	47h
EMS_RESTORE_LIM32_PAGE_MAP_FCN		equ	48h
EMS_GET_HANDLE_COUNT_FCN		equ	4Bh
EMS_GET_HANDLE_PAGES_FCN		equ	4Ch
EMS_GET_ALL_HANDLE_PAGES_FCN		equ	4Dh
EMS_GET_PAGE_MAP_FCN			equ	4E00h
EMS_SET_PAGE_MAP_FCN			equ	4E01h
EMS_GET_AND_SET_PAGE_MAP_FCN		equ	4E02h
EMS_GET_SIZE_PAGE_MAP_ARRAY_FCN		equ	4E03h

EMS_GET_PARTIAL_PAGE_MAP_FCN		equ	4F00h
EMS_SET_PARTIAL_PAGE_MAP_FCN		equ	4F01h
EMS_GET_SIZE_P_PAGE_MAP_ARRAY_FCN	equ	4F02h


EMS_MAP_MULT_PAGE_FCN			equ	50h
MAPPABLE_PAGE_MODE      	=	0
SEG_MODE                	=	1
EMS_MAP_STRUCT	struc
	logicalPage		dw	?	; logicl page to map
	mappablePageOrSegment	dw	?	; mappable page or segment
EMS_MAP_STRUCT	ends


EMS_REALLOC_FCN				equ	51h

; Handle attribute functions are not supported by EMM386
; See NOTEs at beginning of DLEMMLIB.H.
;
EMS_GET_HANDLE_ATTRIB_FCN		equ	5200h
EMS_SET_HANDLE_ATTRIB_FCN		equ	5201h
EMS_GET_ATTRIB_CAPABILITY_FCN		equ	5202h


EMS_GET_HANDLE_NAME_FCN			equ	5300h
EMS_SET_HANDLE_NAME_FCN			equ	5301h

EMS_GET_HANDLE_DIR_FCN			equ	5400h
EMS_SEARCH_FOR_NAMED_HANDLE_FCN		equ	5401h
EMS_GET_TOTAL_HANDLES_FCN		equ	5402h


EMS_ALTER_PAGE_MAP_AND_JMP_FCN		equ	55h
EMS_MAP_JUMP_STRUCT	struc
	lpJumpTargetFunction	dw	?	; far proc to call
				dw	?
	initJumpMapStructCount	db	?	; page count to map before call
	lpInitJumpMapStruct	dw	?	; far ptr to page map array
				dw	?
EMS_MAP_JUMP_STRUCT	ends


EMS_ALTER_PAGE_MAP_AND_CALL_FCN		equ	56h
EMS_GET_PAGE_MAP_STACK_SPACE_SIZE_FCN	equ	5602h
EMS_MAP_CALL_STRUCT	struc
	lpCallTargetFunction	dw	?	; offset far proc to call
				dw	?	; segment "
	initCallMapStructCount	db	?	; page count to map before call
	lpInitCallMapStruct	dw	?	; offs far ptr: page map array
				dw	?       ; segment "
	finalCallMapStructCount	db	?	; page count to map before iret
	lpFinalCallMapStruct	dw	?       ; offs far ptr: page map array
				dw	?       ; segment "
	reserved		db	8 dup(?); reserved for use by EMM
EMS_MAP_CALL_STRUCT	ends

EMS_MOVE_MEMORY_FCN 			equ	5700h
EMS_EXCHANGE_MEMORY_FCN			equ	5701h
EMS_MOVEX_STRUCT	struc
	regionSize       	dd	?
	sourceMemType		db	?
	sourceHandle		dw	?
	sourceOffset		dw	?
	sourcePageOrSegment     dw      ?
	destMemType             db      ?
	destHandle              dw      ?
	destOffset              dw      ?
	destPageOrSegment       dw      ?
EMS_MOVEX_STRUCT	ends


EMS_GET_MAPPABLE_PHYS_ADDR_ARRAY_FCN	equ	5800h
EMS_GET_MAPPABLE_ARRAY_ENTRIES_FCN	equ	5801h
EMS_MAPPABLE_PAGE_STRUCT 	struc
	mappableSegment		dw	?
	mappablePageNumber	dw	?
EMS_MAPPABLE_PAGE_STRUCT 	ends


EMS_GET_EMM_HARDWARE_INFO_FCN		equ	5900h
EMS_GET_UNALLOCATED_RAW_PG_CNT_FCN	equ	5901h

EMS_ALLOC_STANDARD_PAGES_FCN		equ	5A00h
EMS_ALLOC_RAW_PAGES_FCN			equ	5A01h

; Not all OS calls not supported by EMM386.EXE
; See NOTEs at beginning of DLEMMLIB.H.
;
EMS_GET_ALT_MAP_REG_SET_FCN 		equ	5B00h
EMS_SET_ALT_MAP_REG_SET_FCN 		equ	5B01h
EMS_GET_ALT_MAP_SAVE_ARRAY_SIZE_FCN 	equ	5B02h
EMS_ALLOCATE_ALT_MAP_REGS_FCN		equ	5B03h
EMS_DEALLOCATE_ALT_MAP_REGS_FCN  	equ	5B04h
EMS_ALLOCATE_DMA_REG_SET_FCN		equ	5B05h
EMS_ENABLE_DMA_ON_ALT_FCN		equ	5B06h
EMS_DISABLE_DMA_ON_ALT_MAP_REGS_FCN 	equ	5B07h
EMS_DEALLOCATE_DMA_REG_SET_FCN		equ	5B08h

EMS_PREPARE_FOR_WARMBOOT_FCN		equ	5Ch

EMS_ENABLE_OS_FCN_SET_FCN		equ	5D00h
EMS_DISABLE_OS_FCN_SET_FCN		equ	5D01h
EMS_RETURN_ACCESS_KEY_FCN		equ	5D02h

; Status codes returned by LIM EMS 4.0 EMMs in the AH register.
;
EMS_FCN_PASSED_STAT				equ	000h
EMS_SOFTWARE_ERR_STAT				equ	080h
EMS_HANDLE_NOT_FOUND_STAT			equ	083h
EMS_UNDEFINED_FCN_STAT		  		equ	084h
EMS_INSUFFICIENT_UNALLOC_HANDLES_STAT		equ	085h
EMS_SAVE_RESTORE_CONTEXT_ERR_STAT		equ	086h
EMS_INSUFFICIENT_TOTAL_PAGES_STAT		equ	087h
EMS_INSUFFICIENT_UNALLOC_PAGES_STATE		equ	088h
EMS_ALLOCATE_ZERO_PAGES_STAT			equ	089h
EMS_LOG_PAGE_OUT_OF_BOUNDS_STAT			equ	08Ah
EMS_PHYS_PAGE_OUT_OF_BOUNDS_STAT		equ	08Bh
EMS_HANDLE_CONTEXT_FULL_STAT	  		equ	08Ch
EMS_HANDLE_CONTEXT_ALREADY_SAVED_STAT		equ	08Dh
EMS_HANDLE_CONTEXT_NOT_PRESENT_STAT		equ	08Eh
EMS_UNDEFINED_SUB_FCN_STAT			equ	08Fh
EMS_UNDEFINED_ATTRIB_STAT			equ	090h
EMS_CAPABILITY_NOT_SUPPORTED_STAT		equ	091h
EMS_MOVE_SOURCE_DEST_OVERLAP_STAT		equ	092h
EMS_SOURCE_DEST_LEN_LESS_THAN_REGION_STAT	equ	093h
EMS_CONV_EXP_MEM_REGION_OVERLAP_STAT		equ	094h
EMS_EXP_OFFSET_GREATER_THAN_PAGE_LEN_STAT	equ	095h
EMS_REGION_LEN_EXCEEDS_MEGABYTE_STAT		equ	096h
EMS_XCHG_SOURCE_DEST_OVERLAP_STAT		equ	097h
EMS_SOURCE_DEST_TYPE_NOT_DEFINED_STAT		equ	098h
EMS_ALT_MAP_DMA_SET_NOT_SUPPORTED_STAT		equ	09Ch
EMS_HANDLE_NAME_NOT_FOUND_STAT			equ	0A0h
EMS_DUPLICATE_HANDLE_NAME_FOUND_STAT		equ	0A1h
EMS_MEGABYTE_WRAP_STAT				equ	0A2h
EMS_ARRAY_CORRUPT_STAT	   			equ	0A3h
EMS_FCN_ACCESS_DENIED_STAT			equ	0A4h
EMS_LOCAL_STACK_OVERFLOW_STAT			equ	0B0h


; Converts any of the above LIM EMS 4.0 status codes to a signed int
; for return to a C function in AX. Any return value <0 indicates
; an error.
;
RETURN_EMS_STATUS macro
	mov	al, ah
	cbw
endm
