;
;   $Id: GETFAT.ASM 1.6 2002/10/15 22:48:04Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;---------------------------------------------------------------------------
; $DOCFILE:GETFAT.ASM
;
; Copyright (c) 1999-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
; This module includes the FAT file system get and set fat entry routines.
; The routines work with 12, 16 and 32-bit FATs.
;
; The following functions may be utilized outside of this module:
;
; Retrieve a cluster value for the specified cluster number.  You are
; required to pass it a far pointer to the DPB so that it can determine
; the FAT type.  This function returns TRUE if it was successful.  If
; there is an error a FALSE value will be returned.  You can determine
; the nature of the error be examining the error code returned by the
; abs error code (error number for absread/abswrite functions).  If
; an invalid cluster number is passed to this function it will assert.
; Invalid cluster numbers are less than 2 and greater than
; lpDPB->hiclus (lpDPB->ulMaxCluster).
;
; Note: The value being set at the specified cluster is NOT range checked.
;
; bool PASCAL GetFatEntry( LPDPB lpDPB, ulong ulClusterNumber,
;	ulong * pulClusterValue )
;
; --------------------------------------------------------
; Although this module was designed to use a buffering
; scheme, a buffering scheme is not requried.  These
; functions must exist to perform the required action.
; This module requires 4 support routines:
;
; //  Locate a specific sector for a drive in the buffers.
; //  Sets the ppBufferHandle variable with a handle used
; //  by the other buffer functions. This function returns
; //  TRUE if the function was successful, FALSE otherwise.
; //
; bool PASCAL ReadSectorBuffer( uchar ucDOSDriveNumber,
;	ulong ulAbsSector, void ** ppBufferHandle );
;
; //  Retrieve an address in conventional memory where
; //  the contents of the buffer are located.  Use the
; //  buffer handle returned by the ReadSectorBuffer
; //  function.  This function returns TRUE if successful,
; //  FALSE otherwise.
; //
; bool PASCAL GetBufferDataAddress( void * pBufferHandle,
;	void far * * plpBufferAddress );
;
; //  Mark a buffer as dirty (modified).  Use the buffer
; //  handle returned by the ReadSectorBuffer function.
; //  This function returns TRUE if successful, FALSE
; //  otherwise.
; //
; bool PASCAL MarkBufferDirty( void * pBufferHandle );
;
; //  Change the number of copies of this sector and
; //  specify the distance between the copies.  Use the
; //  buffer handle returned by the ReadSectorBuffer
; //  function.  The number of copies of this sector is
; //  set to 1 by ReadSectorBuffer by default.
; //
; bool PASCAL SetBufferCopiesAndDistance( void * pBufferHandle,
;	unsigned uCopiesOfThisSector, ulong ulDistanceToNextSector );
;
;
; $DOCHISTORY
;
; 01/17/2002 jmb Added conditional code which will perform
;                the 386 operations using 16-bit operands
; 07-21-2000 bt  Split up FATLIB.ASM into UNIFY.ASM,PUTFAT.ASM,
;                and GETFAT.ASM
; 03/31/1999 bt  Created (modeled from dosfat.asm by dg)
;
;---------------------------------------------------------------------------


; prototypes
;
; these must be in comment form for PROTO.EXE to recognize them as C
; prototypes for automatically including the prototypes in DOSPROTO.H.

comment ~
bool PASCAL GetFatEntry( LPDPB lpDPB, ulong ulClusterNumber,
	ulong * pulClusterValue )

bool PASCAL GetFat32Entry( uchar ucDOSDriveNumber, ulong ulClusterNumber,
	ulong ulStartingFATSector, unsigned uBytesPerSector,
	ulong * pulClusterValue )

bool PASCAL GetFat16Entry( uchar ucDOSDriveNumber, unsigned uClusterNumber,
	unsigned uStartingFATSector, unsigned uBytesPerSector,
	unsigned * puClusterValue )

bool PASCAL GetFat12Entry( uchar ucDOSDriveNumber, unsigned uClusterNumber,
	unsigned uStartingFATSector, unsigned uBytesPerSector,
	unsigned * puClusterValue )

~
include use186.inc
include datalght.inc
include dostruct.inc
include dosdef.inc

InitModel %MEMMODEL, Pascal, Use16

;
;  [ CONSTANTS ]
;


include fatlib.inc


.code
	extrn	READSECTORBUFFER:proc
	extrn	GETBUFFERDATAADDRESS:proc
	extrn	MARKBUFFERDIRTY:proc
	extrn	SETBUFFERCOPIESANDDISTANCE:proc
	extrn	_GETFAT32ENTRYPTR:proc
	extrn	_GETFAT16ENTRYPTR:proc
	extrn	_GETFAT12ENTRYPTR:proc
	extrn	_UNIFYCLUSTERVALUE:proc

IF USING_FAT32 ; {

IF USE_186 EQ 0
.386
ENDIF

;---------------------------------------------------------------------------
; $DOCPROC:GetFat32Entry
;
; bool PASCAL GetFat32Entry( uchar ucDOSDriveNumber, ulong ulClusterNumber,
;	ulong ulStartingFATSector, unsigned uBytesPerSector,
;	ulong * pulClusterValue );
;
; Return the value of the FAT entry from a 32-bit FAT. Does no limit
; checking if ulFatEntry is out of range for the given FAT.
;
; Parameters	ucDOSDriveNumber
;		ulClusterNumber
;		ulStartingFATSector
;		uBytesPerSector
;		uCopies
;		ulDistance
;
; Returns	pulClusterValue
;
;---------------------------------------------------------------------------
ProcBegin	GetFat32Entry, public
ProcUses	si, di
 ProcArgs	@@ucDOSDriveNumber:byte,@@ulClusterNumber:dword,@@ulStartingFATSector:dword,@@uBytesPerSector:word,@@pulClusterValue:PTR
ProcSetup

	; get stack variables into registers
	;
IF USE_186 EQ 0
	mov	eax, @@ulClusterNumber
ELSE    ;; USE_186
	mov	ax, word ptr @@ulClusterNumber
        mov     di, word ptr @@ulClusterNumber[2]
ENDIF   ;; USE_186
	mov	bx, @@uBytesPerSector
IF USE_186 EQ 0
	mov	ecx, @@ulStartingFATSector
ELSE    ;; USE_186
	mov	cx, word ptr @@ulStartingFATSector
        mov     si, word ptr @@ulStartingFATSector[2]
ENDIF   ;; USE_186
	mov	dl, @@ucDOSDriveNumber

	; call helper routine to get the address of the cluster entry
	; in the sector in memory and retrieve a buffer handle.
	;
	call	_GetFat32EntryPtr
	or	ax, ax			; Check for an error
	jz	@@Error

	; save the current entry value
	;
	mov	ax, word ptr es:[bx]
	mov	dx, word ptr es:[bx][2]

	; set the cluster value in the return variable
	;
	LPTR_ES	bx, @@pulClusterValue
	mov	word ptr es:[bx], ax
	mov	word ptr es:[bx][2], dx

 	; Set the boolean return value of the function to TRUE (successful)
	;
	mov	ax, TRUE

    @@Error:

ProcEnd

.186

ENDIF ; } USING_FAT32

;---------------------------------------------------------------------------
; $DOCPROC:GetFat16Entry
;
; bool PASCAL GetFat16Entry( uchar ucDOSDriveNumber, unsigned uClusterNumber,
;	unsigned uStartingFATSector, unsigned uBytesPerSector:word,
;	unsigned * puClusterValue );
;
; Return the value of the FAT entry from a 16-bit FAT. Does no limit
; checking if uFatEntry is out of range for the given FAT.
;
; Parameters	ucDOSDriveNumber
;		uClusterNumber
;		uStartingFATSector
;		uBytesPerSector
;
; Returns	puClusterValue
;
;---------------------------------------------------------------------------
ProcBegin	GetFat16Entry, public
ProcUses	si, di
ProcArgs	@@ucDOSDriveNumber:byte,@@uClusterNumber:word,@@uStartingFATSector:word,@@uBytesPerSector:word,@@puClusterValue:PTR
ProcSetup

	; Set the parameters for GetFat16EntryPtr in the registers
	;
	mov	ax, @@uClusterNumber
	mov	bx, @@uBytesPerSector
	mov	cx, @@uStartingFATSector
	mov	dl, @@ucDOSDriveNumber

	; Get the address of the sector in memory and set the index
	; into that sector
	;
	call	_GetFat16EntryPtr

	; Check if there was an error
	;
	or	ax, ax			; Check for an error
	jz	@@Error

	; set the cluster value in the return variable
	;
	mov	ax, word ptr es:[bx]
	LPTR_ES	bx, @@puClusterValue
	mov	word ptr es:[bx], ax

 	; Set the boolean return value of the function to TRUE (successful)
	;
	mov	ax, TRUE

    @@Error:

ProcEnd

;--------------------------------------------------------------------
; $DOCPROC:GetFat12Entry
;
; bool PASCAL GetFat12Entry( uchar ucDOSDriveNumber, unsigned uClusterNumber,
;	unsigned uStartingFATSector, unsigned uBytesPerSector,
;	unsigned * puClusterValue );
;
; Get a FAT12 entry. Does no limit checking to verify entry # is in
; range of this FAT.
;
; Parameters	ucDOSDriveNumber
;		uClusterNumber
;		uStartingFATSector
;		uBytesPerSector
;
; Returns	puClusterValue
;
;--------------------------------------------------------------------
ProcBegin	GetFat12Entry, public
ProcUses	si, di
ProcArgs	@@ucDOSDriveNumber:byte,@@uClusterNumber:word,@@uStartingFATSector:word,@@uBytesPerSector:word,@@puClusterValue:PTR
ProcSetup

	; put values from stack variables into registers
	;
	mov	ax, @@uClusterNumber
	mov	bx, @@uBytesPerSector
	mov	cx, @@uStartingFATSector
	mov	dl, @@ucDOSDriveNumber

	; Get the address of the sector in memory and set the index
	; into that sector
	;
	call	_GetFat12EntryPtr

	; Check if there was an error
	;
	or	ax, ax
	jz	@@Error

	; does this entry cross sector boundaries?
	mov	cx, @@uBytesPerSector
	dec	cx
	cmp	cx, dx
	jz	@@Use2Sectors

	; nope, easy, just get word at es:bx
	mov	ax, es:[bx]
	jmp	short @@FinishUp

	; read from the next sector
    @@Use2Sectors:

	; put the low byte of FAT entry into al
	;
	mov	al, byte ptr es:[bx]
	push	ax

	; put values from stack variables into registers
	;
	mov	ax, @@uClusterNumber
	inc	ax
	mov	bx, @@uBytesPerSector
	mov	cx, @@uStartingFATSector
	mov	dl, @@ucDOSDriveNumber

	; Get the address of the sector in memory and set the index
	; into that sector
	;
	call	_GetFat12EntryPtr

	; Check if there was an error
	;
	or	ax, ax
	jz	@@Error

	; Restore the low byte of the fat entry
	;
	pop	ax		; get low byte back into al

	; is this an odd or even 12-bit entry? (LL HL HH)
	;
	test	@@uClusterNumber, 1
	jnz	@@GetPreviousByte

	; form a 16-bit word for 12-bit FAT entry
	;
	mov	ah, es:[bx]
	jmp	short @@FinishUp

    @@GetPreviousByte:

    	; form a 16-bit word for 12-bit FAT entry
	;
	mov	ah, es:[bx - 1]	; get hi byte

	; convert from 16-bit word to 12-bit FAT entry
    @@FinishUp:

	; is this an odd or even 12-bit entry? (LL HL HH)
	;
	test	@@uClusterNumber, 1
	jnz	@@OddEntry
	and	ax, FAT12_MAXIMUM_NUMBER ; (even) get low 3 nybbles
	jmp	short @@Done

    @@OddEntry:

	; form a 16-bit word for 12-bit FAT entry
	;
	mov	cl, SHIFT_VALUE_FOR_AN_ODD_ENTRY
	shr	ax, cl			 ; (odd) get hi 3 nybbles

    @@Done:

	LPTR_ES	bx, @@puClusterValue
	mov	word ptr es:[bx], ax

 	; Set the boolean return value of the function to TRUE (successful)
	;
	mov	ax, TRUE

    @@Error:

ProcEnd

;--------------------------------------------------------------------
; $DOCPROC:GetFatEntry
;
; bool PASCAL GetFatEntry( LPDPB lpDPB, ulong ulClusterNumber,
;	ulong * pulClusterValue )
;
; Get a FAT entry. This determines the FAT type (FAT12/FAT16/FAT32) and
; call the appropriate function to get the FAT entry.  Does no limit
; checking to verify entry # is in range of this FAT.
;
; Parameters	lpDPB
;		ulClusterNumber
;
; Returns	pulClusterValue
;
;--------------------------------------------------------------------
ProcBegin	GetFatEntry, public
ProcArgs	@@lpDPB:dword,@@ulClusterNumber:dword,@@pulClusterValue:PTR
ProcSetup

	;  Load the address of the DPB
	;
	les	bx, @@lpDPB

IF USING_FAT32

	; Check if this is a FAT32 drive
	;
	cmp	word ptr es:[bx].DPB_fat_len, 0
;	IsFat32Drive es:[bx]
	jnz	@@CheckFAT12

	; This is a FAT32 drive
	;

	; bool PASCAL GetFat32Entry( uchar ucDOSDriveNumber,
	;	ulong ulClusterNumber, ulong ulStartingFATSector,
	;	unsigned uBytesPerSector, ulong * pulClusterValue );
	;
	mov	al, es:[bx].DPB_drive
	push	ax				; drive number
	mov	ax, word ptr @@ulClusterNumber[2]
	push	ax
	mov	ax, word ptr @@ulClusterNumber
	push	ax				; cluster number
	xor	ax, ax
	push	ax
	mov	ax, word ptr es:[bx].DPB_fat_start
	push	ax				; starting fat sector
	mov	ax, word ptr es:[bx].DPB_bytes_per_sec
	push	ax				; bytes per sector
if @DataSize
	mov	ax, word ptr @@pulClusterValue[2]
	push	ax
endif
	mov	ax, word ptr @@pulClusterValue
	push	ax			; pointer to store the clsuter value

	call	GetFat32Entry
	jmp	@@Done

ENDIF	; IF USING_FAT32


	; Check if this is a FAT12 drive
	;
    @@CheckFAT12:
	cmp	word ptr es:[bx].DPB_hiclus, HICLUS12
	ja	@@IsFAT16

	; This is a FAT12 drive
	;

	; bool PASCAL GetFat12Entry( uchar ucDOSDriveNumber,
	;	unsigned uClusterNumber, unsigned uStartingFATSector,
	;	unsigned uBytesPerSector, unsigned * puClusterValue );
	;
	mov	al, es:[bx].DPB_drive
	push	ax				; drive number
	mov	ax, word ptr @@ulClusterNumber
	push	ax				; cluster number
	mov	ax, word ptr es:[bx].DPB_fat_start
	push	ax				; starting fat sector
	mov	ax, word ptr es:[bx].DPB_bytes_per_sec
	push	ax				; bytes per sector
if @DataSize
	mov	ax, word ptr @@pulClusterValue[2]
	push	ax
endif
	mov	ax, word ptr @@pulClusterValue
	push	ax			; pointer to store the cluster value

	call	GetFat12Entry
	or	ax, ax
	jz	@@Error

	;  We need to extend values +0ff7h become +0ffffff7h
	;
	push	ax
if @DataSize
	mov	ax, word ptr @@pulClusterValue[2]
	push	ax
endif
	mov	ax, word ptr @@pulClusterValue
	push	ax		  	; pointer to store the cluster value
	mov	ax, HICLUS12
	push	ax				; maximum cluster number
	call	_UnifyClusterValue
	pop	ax
	jmp	short @@Done


	; This is a FAT16 drive
	;
    @@IsFAT16:

	; bool PASCAL GetFat16Entry( uchar ucDOSDriveNumber,
	;	unsigned uClusterNumber, unsigned uStartingFATSector,
	;	unsigned uBytesPerSector:word, unsigned * puClusterValue );
	;
	mov	al, es:[bx].DPB_drive
	push	ax				; drive number
	mov	ax, word ptr @@ulClusterNumber
	push	ax				; cluster number
	mov	ax, word ptr es:[bx].DPB_fat_start
	push	ax				; starting fat sector
	mov	ax, word ptr es:[bx].DPB_bytes_per_sec
	push	ax				; bytes per sector
if @DataSize
	mov	ax, word ptr @@pulClusterValue[2]
	push	ax
endif
	mov	ax, word ptr @@pulClusterValue
	push	ax		  	; pointer to store the cluster value

	call	GetFat16Entry
	or	ax, ax
	jz	@@Error

	;  We need to extend values +0fff7h become +0ffffff7h
	;
	push	ax
if @DataSize
	mov	ax, word ptr @@pulClusterValue[2]
	push	ax
endif
	mov	ax, word ptr @@pulClusterValue
	push	ax			; pointer to store the cluster value
	mov	ax, HICLUS16
	push	ax				; maximum cluster number
	call	_UnifyClusterValue
	pop	ax

    @@Done:
    @@Error:

ProcEnd

	end
