;
;   $Id: PUTFAT.ASM 1.6 2002/10/15 22:48:04Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;---------------------------------------------------------------------------
; $DOCFILE:PUTFAT.ASM
;
; Copyright (c) 1999-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
; This module includes the FAT file system get and set fat entry routines.
; The routines work with 12, 16 and 32-bit FATs.
;
; The following functions may be utilized outside of this module:
;
; Set a cluster value for the specified cluster number and return the
; value which was previously at that cluster number.  You are required
; to pass it a far pointer to the DPB so that it can determine the FAT
; type.  This function returns TRUE if it was successful.  If there is
; an error a FALSE value will be returned.  You can determine the nature
; of the error be examining the error code returned by the abs error code
; (error number for absread/abswrite functions).  If an invalid cluster
; number is passed to this function it will assert.  Invalid cluster
; numbers are less than 2 and greater than lpDPB->hiclus
; (lpDPB->ulMaxCluster).
;
; Note: The value being set at the specified cluster is NOT range checked.
;
; bool PASCAL PutFatEntry( LPDPB lpDPB, ulong ulClusterNumber,
;	ulong ulNewClusterValue, ulong * pulOldClusterValue )
;
; --------------------------------------------------------
; Although this module was designed to use a buffering
; scheme, a buffering scheme is not requried.  These
; functions must exist to perform the required action.
; This module require 4 support routines:
;
; //  Locate a specific sector for a drive in the buffers.
; //  Sets the ppBufferHandle variable with a handle used
; //  by the other buffer functions. This function returns
; //  TRUE if the function was successful, FALSE otherwise.
; //
; bool PASCAL ReadSectorBuffer( uchar ucDOSDriveNumber,
;	ulong ulAbsSector, void ** ppBufferHandle );
;
; //  Retrieve an address in conventional memory where
; //  the contents of the buffer are located.  Use the
; //  buffer handle returned by the ReadSectorBuffer
; //  function.  This function returns TRUE if successful,
; //  FALSE otherwise.
; //
; bool PASCAL GetBufferDataAddress( void * pBufferHandle,
;	void far * * plpBufferAddress );
;
; //  Mark a buffer as dirty (modified).  Use the buffer
; //  handle returned by the ReadSectorBuffer function.
; //  This function returns TRUE if successful, FALSE
; //  otherwise.
; //
; bool PASCAL MarkBufferDirty( void * pBufferHandle );
;
; //  Change the number of copies of this sector and
; //  specify the distance between the copies.  Use the
; //  buffer handle returned by the ReadSectorBuffer
; //  function.  The number of copies of this sector is
; //  set to 1 by ReadSectorBuffer by default.
; //
; bool PASCAL SetBufferCopiesAndDistance( void * pBufferHandle,
;	unsigned uCopiesOfThisSector, ulong ulDistanceToNextSector );
;
;
; $DOCHISTORY
;
; 01/17/2002 jmb Added conditional code which will perform
;                the 386 operations using 16-bit operands
; 07-21-2000 bt  Split up FATLIB.ASM into UNIFY.ASM,PUTFAT.ASM,
;                and GETFAT.ASM
; 03/31/1999 bt  Created (modeled from dosfat.asm by dg)
;
;---------------------------------------------------------------------------


; prototypes
;
; these must be in comment form for PROTO.EXE to recognize them as C
; prototypes for automatically including the prototypes in DOSPROTO.H.

comment ~
bool PASCAL PutFatEntry( LPDPB lpDPB, ulong ulClusterNumber,
	ulong ulNewClusterValue, ulong * pulOldClusterValue )

bool PASCAL PutFat32Entry( uchar ucDOSDriveNumber, ulong ulClusterNumber,
	ulong ulNewClusterValue, ulong ulStartingFATSector,
	unsigned uBytesPerSector, unsigned uCopies, ulong ulDistance,
	ulong * pulOldClusterValue )

bool PASCAL PutFat16Entry( uchar ucDOSDriveNumber, unsigned uClusterNumber,
	unsigned uNewClusterValue, unsigned uStartingFATSector,
	unsigned uBytesPerSector, unsigned uCopies, ulong ulDistance,
	unsigned * puOldClusterValue )

bool PASCAL PutFat12Entry( uchar ucDOSDriveNumber, unsigned uClusterNumber,
	unsigned uNewClusterValue, unsigned uStartingFATSector,
	unsigned uBytesPerSector, unsigned uCopies, ulong ulDistance,
	unsigned * puOldClusterValue )
~

include use186.inc

include datalght.inc
include dostruct.inc
include dosdef.inc

InitModel %MEMMODEL, Pascal, Use16

;
;  [ CONSTANTS ]
;


include fatlib.inc


.code
	extrn	READSECTORBUFFER:proc
	extrn	GETBUFFERDATAADDRESS:proc
	extrn	MARKBUFFERDIRTY:proc
	extrn	SETBUFFERCOPIESANDDISTANCE:proc
	extrn	_GETFAT32ENTRYPTR:proc
	extrn	_GETFAT16ENTRYPTR:proc
	extrn	_GETFAT12ENTRYPTR:proc
	extrn	_UNIFYCLUSTERVALUE:proc

IF USING_FAT32 ; {

IF USE_186 EQ 0
.386
ENDIF

;---------------------------------------------------------------------------
; $DOCPROC:PutFat32Entry
;
; bool PASCAL PutFat32Entry( uchar ucDOSDriveNumber, ulong ulClusterNumber,
;	ulong ulNewClusterValue, ulong ulStartingFATSector,
;	unsigned uBytesPerSector, unsigned uCopies, ulong ulDistance,
;	ulong * pulOldClusterValue );
;
; Set a 32-bit fat entry to the value given. Does not limit checking
; to see if the fat entry passed will fit in the fat.
;
; Parameters	ucDOSDriveNumber
;		uClusterNumber
;		ulNewClusterValue
;		uStartingFATSector
;		uBytesPerSector
;		uCopies
;		ulDistance
;
; Returns	puOldClusterValue
;
;---------------------------------------------------------------------------
ProcBegin	PutFat32Entry, public
ProcUses	si, di
ProcArgs	@@ucDOSDriveNumber:byte,@@ulClusterNumber:dword,@@ulNewClusterValue:dword,@@ulStartingFATSector:dword,@@uBytesPerSector:word,@@uCopies:word,@@ulDistance:dword,@@pulOldClusterValue:PTR
ProcSetup

	; get stack variables into registers
	;
IF USE_186 EQ 0
	mov	eax, @@ulClusterNumber
ELSE    ;; USE_186
	mov	ax, word ptr @@ulClusterNumber
        mov     di, word ptr @@ulClusterNumber[2]
ENDIF   ;; USE_186
	mov	bx, @@uBytesPerSector
IF USE_186 EQ 0
	mov	ecx, @@ulStartingFATSector
ELSE    ;; USE_186
	mov	cx, word ptr @@ulStartingFATSector
        mov     si, word ptr @@ulStartingFATSector[2]
ENDIF   ;; USE_186
	mov	dl, @@ucDOSDriveNumber

	; call helper routine to get the address of the cluster entry
	; in the sector in memory and retrieve a buffer handle.
	;
	call	_GetFat32EntryPtr
	or	ax, ax			; Check for an error
	jz	@@Error

if @DataSize
	;  Save the segment of the buffer handle
	;
	push	si
endif

	; save the current entry value
	;
	mov	cx, word ptr es:[bx]
	mov	si, word ptr es:[bx][2]

	; set the new FAT entry
	;
	mov	ax, word ptr @@ulNewClusterValue
	mov	dx, word ptr @@ulNewClusterValue[2]
	mov	word ptr es:[bx], ax
	mov	word ptr es:[bx][2], dx

	; set the previous cluster value in the return variable
	;
	LPTR_ES	bx, @@pulOldClusterValue
	mov	word ptr es:[bx], cx
	mov	word ptr es:[bx][2], si

	; bool MarkBufferDirty( void * pBufferHandle )
	;
if @DataSize
	; This value needs to be in si for the after this call so
	; (push si) + (pop si) + (push si) != (push si) because
	; the value never gets set in si.
	;
	pop	si
	push	si
endif
	push	di
	call	MarkBufferDirty
	or	ax, ax			; Check for an error
	jz	@@Error

	; bool SetBufferCopiesAndDistance( void * pBufferHandle,
	;	unsigned uCopiesOfThisSector, ulong ulDistanceToNextSector )
	;
if @DataSize
	push	si
endif
	push	di
	mov	ax, @@uCopies
	push	ax
	mov	ax, word ptr @@ulDistance[2]
	push	ax
	mov	ax, word ptr @@ulDistance
	push	ax
	call	SetBufferCopiesAndDistance
	or	ax, ax			; Check for an error
	jz	@@Error

 	; Set the boolean return value of the function to TRUE (successful)
	;
	mov	ax, TRUE

    @@Error:

ProcEnd

.186

ENDIF ; } USING_FAT32

;---------------------------------------------------------------------------
; $DOCPROC:PutFat16Entry
;
; bool PASCAL PutFat16Entry( uchar ucDOSDriveNumber, unsigned uClusterNumber,
;	unsigned uNewClusterValue, unsigned uStartingFATSector,
;	unsigned uBytesPerSector, unsigned uCopies, ulong ulDistance,
;	unsigned * puOldClusterValue );
;
; Parameters	ucDOSDriveNumber
;		uClusterNumber
;		uNewClusterValue
;		uStartingFATSector
;		uBytesPerSector
;		uCopies
;		ulDistance
;
; Returns	puOldClusterValue
;
;---------------------------------------------------------------------------
ProcBegin	PutFat16Entry, public
ProcUses	si, di
ProcArgs	@@ucDOSDriveNumber:byte,@@uClusterNumber:word,@@uNewClusterValue:word,@@uStartingFATSector:word,@@uBytesPerSector:word,@@uCopies:word,@@ulDistance:dword,@@puOldClusterValue:PTR
ProcSetup

	; Set the parameters for GetFat16EntryPtr in the registers
	;
	mov	ax, @@uClusterNumber
	mov	bx, @@uBytesPerSector
	mov	cx, @@uStartingFATSector
	mov	dl, @@ucDOSDriveNumber

	; Get the address of the sector in memory and set the index
	; into that sector
	;
	call	_GetFat16EntryPtr

	; Check if there was an error
	;
	or	ax, ax			; Check for an error
	jz	@@Error

	; Save the old value of the cluster
	;
	mov	ax, word ptr es:[bx]

	; Set the new value of the cluster
	;
	mov	cx, @@uNewClusterValue
	mov	es:[bx], cx

	; Set the previous value of the cluster in the return variable
	;
	LPTR_ES	bx, @@puOldClusterValue
	mov	es:[bx], ax

	; bool MarkBufferDirty( void * pBufferHandle )
	;
if @DataSize
	push	si
endif
	push	di
	call	MarkBufferDirty
	or	ax, ax			; Check for an error
	jz	@@Error

	; bool SetBufferCopiesAndDistance( void * pBufferHandle,
	;	unsigned uCopiesOfThisSector, ulong ulDistanceToNextSector )
	;
if @DataSize
	push	si
endif
	push	di
	mov	ax, @@uCopies
	push	ax
	mov	ax, word ptr @@ulDistance[2]
	push	ax
	mov	ax, word ptr @@ulDistance
	push	ax
	call	SetBufferCopiesAndDistance
	or	ax, ax			; Check for an error
	jz	@@Error

 	; Set the boolean return value of the function to TRUE (successful)
	;
	mov	ax, 1

    @@Error:

ProcEnd

;--------------------------------------------------------------------
; $DOCPROC:PutFat12Entry
;
; bool PASCAL PutFat12Entry( uchar ucDOSDriveNumber, unsigned uClusterNumber,
;	unsigned uNewClusterValue, unsigned uStartingFATSector,
;	unsigned uBytesPerSector, unsigned uCopies, ulong ulDistance,
;	unsigned * puOldClusterValue );
;
; Set a FAT12 entry. Does no limit checking to verify entry # is in
; range of this FAT.
;
; Parameters	ucDOSDriveNumber
;		uClusterNumber
;		uNewClusterValue
;		uStartingFATSector
;		uBytesPerSector
;		uCopies
;		ulDistance
;
; Returns	puOldClusterValue
;
;--------------------------------------------------------------------
ProcBegin	PutFat12Entry, public
ProcUses	si, di
ProcArgs	@@ucDOSDriveNumber:byte,@@uClusterNumber:word,@@uNewClusterValue:word,@@uStartingFATSector:word,@@uBytesPerSector:word,@@uCopies:word,@@ulDistance:dword,@@puOldClusterValue:PTR
ProcLocals	@@uMask:word, @@uOldClusterValue:word
ProcSetup

	; first, determine the mask, and adjust value
	; depends on whethere the FatEntry # is odd or even
	;
	test	@@uClusterNumber, BIT_FOR_TESTING_ODD_AND_EVEN
	jnz	@@OddMask
	mov	@@uMask, FAT12_EVEN_ENTRY_MASK ; (even) preserve only upper nybble
	and	@@uNewClusterValue, FAT12_MAXIMUM_NUMBER
	jmp	short @@DoneMask
    @@OddMask:
	mov	@@uMask, FAT12_ODD_ENTRY_MASK ; (odd) preserve only lower nybble
	mov	cl, SHIFT_VALUE_FOR_AN_ODD_ENTRY
	shl	@@uNewClusterValue, cl		; value is shifted to high bits
    @@DoneMask:

	; put values from stack variables into registers
	;
	mov	ax, @@uClusterNumber
	mov	bx, @@uBytesPerSector
	mov	cx, @@uStartingFATSector
	mov	dl, @@ucDOSDriveNumber

	; Get the address of the sector in memory and set the index
	; into that sector
	;
	call	_GetFat12EntryPtr

	; Check if there was an error
	;
	or	ax, ax
	jz	@@ErrorJP

	; does this entry cross sector boundaries?
	;
	mov	cx, @@uBytesPerSector
	dec	cx
	cmp	cx, dx
	jz	@@Use2Sectors

	; nope, easy, just modify word at es:bx
	;
	mov	ax, es:[bx]
	mov	@@uOldClusterValue, ax
	and	ax, @@uMask
	or	ax, @@uNewClusterValue
	mov	es:[bx], ax
	jmp	short @@Done

	; read from the next sector
    @@Use2Sectors:

	; update the 1 byte in this sector
	;
	mov	al, es:[bx]
	mov	byte ptr @@uOldClusterValue, al
	and	al, byte ptr @@uMask
	or	al, byte ptr @@uNewClusterValue
	mov	es:[bx], al

	; bool MarkBufferDirty( void * pBufferHandle )
	;
if @DataSize
	push	si
endif
	push	di
	call	MarkBufferDirty
	or	ax, ax		; Check for an error
	jz	@@ErrorJP

	; bool SetBufferCopiesAndDistance( void * pBufferHandle,
	;	unsigned uCopiesOfThisSector, ulong ulDistanceToNextSector )
	;
if @DataSize
	push	si
endif
	push	di
	mov	ax, @@uCopies
	push	ax
	mov	ax, word ptr @@ulDistance[2]
	push	ax
	mov	ax, word ptr @@ulDistance
	push	ax
	call	SetBufferCopiesAndDistance
	or	ax, ax		; Check for an error
	jz	@@Error

	; put values from stack variables into registers
	mov	ax, @@uClusterNumber
	inc	ax
	mov	bx, @@uBytesPerSector
	mov	cx, @@uStartingFATSector
	mov	dl, @@ucDOSDriveNumber

	; Get the address of the sector in memory and set the index
	; into that sector
	;
	call	_GetFat12EntryPtr

	; Check if there was an error
	;
	or	ax, ax
    @@ErrorJP:
	jz	@@Error

	; update 1 byte in next sector
	;
	test	@@uClusterNumber, BIT_FOR_TESTING_ODD_AND_EVEN
	jnz	@@SetPreviousByte

	mov	al, es:[bx]
	mov	byte ptr @@uOldClusterValue[1], al
	and	al, byte ptr @@uMask[1]
	or	al, byte ptr @@uNewClusterValue[1]
	mov	es:[bx], al
	jmp	short @@Done

    @@SetPreviousByte:

	mov	al, es:[bx - 1]
	mov	byte ptr @@uOldClusterValue[1], al
	and	al, byte ptr @@uMask[1]
	or	al, byte ptr @@uNewClusterValue[1]
	mov	es:[bx - 1], al

    @@Done:

	; Save the previous cluster value
	;
	mov	ax, @@uOldClusterValue
	test	@@uClusterNumber, BIT_FOR_TESTING_ODD_AND_EVEN
	jnz	@@OddMask2
	and	ax, FAT12_MAXIMUM_NUMBER ; value must be 12 bits
	jmp	short @@DoneMask2
    @@OddMask2:
	mov	cl, SHIFT_VALUE_FOR_AN_ODD_ENTRY
	shr	ax, cl		; value is shifted to high bits
    @@DoneMask2:
	LPTR_ES	bx, @@puOldClusterValue
	mov	es:[bx], ax

	; bool MarkBufferDirty( void * pBufferHandle )
	;
if @DataSize
	push	si
endif
	push	di
	call	MarkBufferDirty
	or	ax, ax		; Check for an error
	jz	@@Error

	; bool SetBufferCopiesAndDistance( void * pBufferHandle,
	;	unsigned uCopiesOfThisSector, ulong ulDistanceToNextSector )
	;
if @DataSize
	push	si
endif
	push	di
	mov	ax, @@uCopies
	push	ax
	mov	ax, word ptr @@ulDistance[2]
	push	ax
	mov	ax, word ptr @@ulDistance
	push	ax
	call	SetBufferCopiesAndDistance
	or	ax, ax		; Check for an error
	jz	@@Error

 	; Set the boolean return value of the function to TRUE (successful)
	;
	mov	ax, TRUE

    @@Error:

ProcEnd

;--------------------------------------------------------------------
; $DOCPROC:PutFatEntry
;
; bool PASCAL PutFatEntry( LPDPB lpDPB, ulong ulClusterNumber,
;	ulong ulNewClusterValue, ulong * pulOldClusterValue );
;
; Set a FAT entry. This determines the FAT type (FAT12/FAT16/FAT32) and
; call the appropriate function to set the FAT entry.  Does no limit
; checking to verify entry # is in range of this FAT.
;
; Parameters	lpDPB
;		ulClusterNumber
;		ulNewClusterValue
;
; Returns	pulOldClusterValue
;
;--------------------------------------------------------------------
ProcBegin	PutFatEntry, public
ProcArgs	@@lpDPB:dword,@@ulClusterNumber:dword,@@ulNewClusterValue:dword,@@pulOldClusterValue:PTR
ProcSetup

	;  Load the address of the DPB
	;
	les	bx, @@lpDPB

IF USING_FAT32

	; Check if this is a FAT32 drive
	;
	cmp	word ptr es:[bx].DPB_fat_len, 0
;	IsFat32Drive es:[bx]
	jnz	@@CheckFAT12

	; This is a FAT32 drive
	;

	; bool PASCAL PutFat32Entry( uchar ucDOSDriveNumber,
	;	ulong ulClusterNumber, ulong ulNewClusterValue,
	;	ulong ulStartingFATSector, unsigned uBytesPerSector,
	;	unsigned uCopies, ulong ulDistance,
	;	ulong * pulOldClusterValue );
	;
	mov	al, es:[bx].DPB_drive
	push	ax				; drive number
	mov	ax, word ptr @@ulClusterNumber[2]
	push	ax
	mov	ax, word ptr @@ulClusterNumber
	push	ax				; cluster number
	mov	ax, word ptr @@ulNewClusterValue[2]
	push	ax
	mov	ax, word ptr @@ulNewClusterValue
	push	ax				; new cluster value
	xor	ax, ax
	push	ax
	mov	ax, word ptr es:[bx].DPB_fat_start
	push	ax				; starting fat sector
	mov	ax, word ptr es:[bx].DPB_bytes_per_sec
	push	ax				; bytes per sector
	xor	ax, ax
	mov	al, byte ptr es:[bx].DPB_num_fats
	push	ax				; fat copies
	mov	ax, word ptr es:[bx].DPB_ulSectorsPerFAT[2]
	push	ax
	mov	ax, word ptr es:[bx].DPB_ulSectorsPerFAT
	push	ax				; distance to next copy
if @DataSize
	mov	ax, word ptr @@pulOldClusterValue[2]
	push	ax
endif
	mov	ax, word ptr @@pulOldClusterValue
	push	ax				; pointer to old cluster value

	call	PutFat32Entry
	jmp	@@Done

ENDIF 	; IF USING_FAT32


	; Check if this is a FAT12 drive
	;
    @@CheckFAT12:
	cmp	word ptr es:[bx].DPB_hiclus, HICLUS12
	ja	@@IsFAT16

	; This is a FAT12 drive
	;

	; bool PASCAL PutFat12Entry( uchar ucDOSDriveNumber,
	;	unsigned uClusterNumber, unsigned uNewClusterValue,
	;	unsigned uStartingFATSector, unsigned uBytesPerSector,
	;	unsigned uCopies, ulong ulDistance,
	;	unsigned * puOldClusterValue );
	;
	mov	al, es:[bx].DPB_drive
	push	ax				; drive number
	mov	ax, word ptr @@ulClusterNumber
	push	ax				; cluster number
	mov	ax, word ptr @@ulNewClusterValue
	and	ax, 0FFFh
	push	ax				; new cluster value
	mov	ax, word ptr es:[bx].DPB_fat_start
	push	ax				; starting fat sector
	mov	ax, word ptr es:[bx].DPB_bytes_per_sec
	push	ax				; bytes per sector
	xor	ax, ax
	mov	al, byte ptr es:[bx].DPB_num_fats
	push	ax				; fat copies
	xor	ax, ax
	push	ax
	mov	ax, word ptr es:[bx].DPB_fat_len
	push	ax                              ; distance to next copy
if @DataSize
	mov	ax, word ptr @@pulOldClusterValue[2]
	push	ax
endif
	mov	ax, word ptr @@pulOldClusterValue
	push	ax				; pointer to old cluster value

	call	PutFat12Entry
	or	ax, ax		; Check for an error
	jz	@@Error

	;  We need to extend values +0ff7h become +0ffffff7h
	;
	push	ax
if @DataSize
	mov	ax, word ptr @@pulOldClusterValue[2]
	push	ax
endif
	mov	ax, word ptr @@pulOldClusterValue
	push	ax				; pointer to old cluster value
	mov	ax, HICLUS12
	push	ax				; maximum cluster number
	call	_UnifyClusterValue
	pop	ax
	jmp	short @@Done


	; This is a FAT16 drive
	;
    @@IsFAT16:

	; bool PASCAL PutFat16Entry( uchar ucDOSDriveNumber,
	;	unsigned uClusterNumber, unsigned uNewClusterValue,
	;	unsigned uStartingFATSector, unsigned uBytesPerSector,
	;	unsigned uCopies, ulong ulDistance,
	;	unsigned * puOldClusterValue );
	;
	mov	al, es:[bx].DPB_drive
	push	ax				; drive number
	mov	ax, word ptr @@ulClusterNumber
	push	ax				; cluster number
	mov	ax, word ptr @@ulNewClusterValue
	push	ax				; new cluster value
	mov	ax, word ptr es:[bx].DPB_fat_start
	push	ax				; starting fat sector
	mov	ax, word ptr es:[bx].DPB_bytes_per_sec
	push	ax				; bytes per sector
	xor	ax, ax
	mov	al, byte ptr es:[bx].DPB_num_fats
	push	ax				; fat copies
	xor	ax, ax
	push	ax
	mov	ax, word ptr es:[bx].DPB_fat_len
	push	ax                              ; distance to next copy
if @DataSize
	mov	ax, word ptr @@pulOldClusterValue[2]
	push	ax
endif
	mov	ax, word ptr @@pulOldClusterValue
	push	ax				; pointer to old cluster value

	call	PutFat16Entry
	or	ax, ax
	jz	@@Error

	;  We need to extend values +0fff7h become +0ffffff7h
	;
	push	ax
if @DataSize
	mov	ax, word ptr @@pulOldClusterValue[2]
	push	ax
endif
	mov	ax, word ptr @@pulOldClusterValue
	push	ax				; pointer to old cluster value
	mov	ax, HICLUS16
	push	ax				; maximum cluster number
	call	_UnifyClusterValue
	pop	ax

    @@Done:
    @@Error:

ProcEnd

	end
