//
//   $Id: ABSDSKRD.C 1.5 2002/10/15 22:49:52Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//  $DOCMODULE:ABSDSKRD.C
//  Created 07-22-1998 by Brandon Thomas
//
//  Copyright (c) 1998-2002 Datalight, Inc.
//  All Rights Reserved.
//  Datalight Confidential and Proprietary.
//
//  This module is an interface to dlAbsRead, it also calls dlIsBigDrive
//  and is part of the Datalight Library.
//
//  bool PASCAL dlAbsDiskRead(int iDriveNumber , int iNumberOfSectors,
//  		long lStartingSectorNumber, void far * lpBuffer)
//
//  $DOCHISTORY
//  01-30-1999 bt  Added dostruct.h include
//  07/22/1998 bt  Created.
//
//


//  Datalight libraries
//
#include "datalght.h"
#include "dostruct.h"
#include "dldosio.h"


//  $DOCPROC: dlAbsDiskRead
//
//  This function first calls IsBigDrive which determines if the drive
//  has more that 65536 sectors and then performs an absolute sector
//  read using dlAbsRead.  This function returns FALSE if it fails
//  and TRUE otherwise.  The parameters are described below:
//
//		iDriveNumber				- drive number (A=0,B=1,C=2,...)
//		iNumberOfSectors			- number of sectors to read
//		iStartingSectorNumber	- sector to start reading at
//		pBuffer						- pointer to where the data should
//										  be read to
//
bool PASCAL dlAbsDiskRead(int iDriveNumber , int iNumberOfSectors,
		long lStartingSectorNumber, void far * lpBuffer)
{
	bool bIsBigDrive;
	bool bFunctionReturn;


	bIsBigDrive = dlIsBigDrive( iDriveNumber );
	bFunctionReturn = dlAbsRead( bIsBigDrive , iDriveNumber , iNumberOfSectors ,
			lStartingSectorNumber , lpBuffer );


	return bFunctionReturn;
}
