;
;   $Id: ABSWR32.ASM 1.5 2002/10/15 22:52:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:ABSWR32.ASM
; Created 1-4-1999 by Brandon Thomas
;
; Copyright (c) 1999-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
; This module is a wrapper for interrupt 21h function 7305h which
; is an absolute sector write when running WIN95 OSR2 or higher.  It
; is a necessity for accessing a FAT32 drive while running windows
; 95.  This is part of the Datalight Library.
;
; bool PASCAL dlAbsWrite32( int iDrive, int iSects, long lStart,
;	void far * lpBuffer, int iFlags )
;
; $DOCHISTORY
; 02/17/1999 dm  Moved the drive set for DL after structure setup because
;                DL was getting trashed and the drive number was being lost
; 02/16/1999 dm  Fixed typo in Abs write function header, 0 is default
;                drive, and A begins at drive number 1
; 02/01/1999 bt  Another attempt to make it work
; 01/04/1998 bt  Created.
;--------------------------------------------------------------------
include datalght.inc
InitModel %MEMMODEL, pascal, use16
include _dldosi2.inc


ABS_DISK_IO	struc
	startingSector	dd	?
	sectorCount	dw    	?
	buffer		dd	?
ABS_DISK_IO	ends


.code

;--------------------------------------------------------------------
; $DOCPROC: dlAbsWrite32
;
; bool PASCAL dlAbsWrite32( int iDrive, int iSects, long lStart,
;						void * pBuffer, int iFlags )
;
; This function uses INT-21h function 7305 in write mode to perform
; a an absolute write of logical sectors.  The function returns
; TRUE if successful, FALSE if it failed.
;
; On Entry
;
;	dl    (iDrive)	Drive number (A=1,B=2,C=3,...)
;	cx    (none)	-1
;	ds:bx (none)	parameters structure
;
; On Exit
;
;	ax		TRUE if the function was successful, FALSE otherwise
;
;--------------------------------------------------------------------
ProcBegin 	dlAbsWrite32, public
ProcUses  	ds, si
ProcArgs	@@drive:word, @@sects:word, @@start:dword, @@lpBuff:dword, @@Flags:word
ProcLocals	@@absWriteData:ABS_DISK_IO
ProcSetup


	; Set the starting sector number
	;
	mov	dx, word ptr @@start
	mov	word ptr @@absWriteData.startingSector, dx
	mov	dx, word ptr @@start[2]
	mov	word ptr @@absWriteData.startingSector[2], dx

	; Set the number of sectors to write
	;
	mov	dx, @@sects
	mov	@@absWriteData.sectorCount, dx

	; Set the destination buffer
	;
	mov	dx, word ptr @@lpBuff
	mov	word ptr @@absWriteData.buffer, dx

	mov	dx, word ptr @@lpBuff[2]
	mov	word ptr @@absWriteData.buffer[2], dx

	; Set the call to use a parameters structure
	;
	mov	cx, -1

	; Set the function call for a write / the type of write is determined
	; by the flags that are passed in.
	;
	mov	si, @@Flags

	; Set the drive number (1 based)
	;
	mov	dl, byte ptr @@drive

	; Set DS:BX to point to the parameters structure
	;
	push	ds
	mov	bx, ss
	mov	ds, bx
	lea	bx, @@absWriteData

	; Set the function number
	;
	mov	ax, 7305h

	; Perform the absolute sector write
	;
	int	21h
	pop	ds

	; Set the return value and the internal error code variable
	;
	SET_ABSRDWR_ERROR

ProcEnd

@curseg	ends
	end
