;
;   $Id: DL5D.ASM 1.4 2002/10/15 22:52:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:DL5D.ASM
;
; Copyright (c) 1999-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
; Access to Int 21h calls through Int 21h, 5Dh. Allows for wildcard
; delete and renames. Otherwise identical.
;
; Int21_5D: is not callable from "C". It is expected that the
; registers are set up as normal for an Int 21h call, then instead of
; calling Int 21, issue a:
;
;	call	INT21_5D
;
; $DOCHISTORY
; 02/26/1999 dg  Created by Drew Gislason
;--------------------------------------------------------------------
include datalght.inc
InitModel %MEMMODEL, pascal, use16
include _dldosio.inc

.data

.code

;--------------------------------------------------------------------
; $DOCPROC:Int21_5D
;
; Call the backdoor Int 21h functions, for wildcard delete and rename.
;
; On Entry	registers set up as normal for Int 21h call
; On Exit	same returns as that Int 21h call.
;--------------------------------------------------------------------
ProcBegin	Int21_5D, PUBLIC
ProcSetup

	; save registers in order DOS expects
	push	es
	push	ds
	push	di
	push	si
	push	dx
	push	cx
	push	bx
	push	ax

	; now point ds:dx to buffer (on stack)
	mov	dx, ss
	mov	ds, dx
	mov	dx, sp

	; call DOS and return
	mov	ax, 5D00h
	stc
	int	21h

	; return back to caller, preserving carry flag
	jc	@@Fail
	add	sp, 16		; will clear carry
	jmp	short @@Done

    @@Fail:
	add	sp, 16		; will clear carry
	stc

    @@Done:
ProcEnd

	end
