;
;   $Id: SETDPB.ASM 1.4 2002/10/15 22:52:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:SETDPB.ASM
; Created 9-2-1999 by Brandon Thomas
; Copyright (c) 1999-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
; This module is a wrapper for interrupt 21h function 7304h which
; sets a new DPB after formatting
;
; bool PASCAL dlSetDBPForFormat( uchar ucDriveNumber, void * pParmBlock );
;
; $DOCHISTORY
; 09/02/1999 bt  Created
;
;--------------------------------------------------------------------
include datalght.inc
InitModel %MEMMODEL, pascal, use16
include _dldosio.inc

.code

;--------------------------------------------------------------------
; $DOCPROC: dlSetDBPForFormat
;
; bool PASCAL dlSetDBPForFormat( uchar ucDriveNumber, void * pParmBlock );
;
; This module is a wrapper for interrupt 21h function 7304h which
; sets a new DPB after formatting
;
; On Entry
;
;	dl    (ucDriveNumber) Drive number (0=default,1=A,...)
;	es:di (pParmBlock)    Parameter block for the function
;
; On Exit
;
;	ax 	TRUE if the function was successful, FALSE otherwise
;
;--------------------------------------------------------------------
ProcBegin	dlSetDBPForFormat,public
ProcArgs	@@ucDriveNumber:byte,@@pParmBlock:PTR
ProcUses	es,di
ProcSetup

	; Set the function number
	;
	mov	ax, 7304h

	; Set the drive number
	;
	mov	dl, @@ucDriveNumber

	; Set the address of the parameter block
	;
	LPTR_ES	di, @@pParmBlock

	; Perform the interrupt
	;
	int	21h

	SET_DOS_ERROR

ProcEnd
	end
