;
;   $Id: TRURDVER.ASM 1.4 2002/10/15 22:52:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:TRURDVER.ASM
; Created 2-5-1999 by Brandon Thomas
;
; Copyright (c) 1999-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
; This module is a wrapper for interrupt 21h function 30dbh which
; returns the true kernel support version for ROMDOS and MSDOS. This
; function returns TRUE if successful.  This is part of the Datalight
; Library.
;
; bool PASCAL dlKernelSupportVersion( unsigned * puVersion )
;
; $DOCHISTORY
; 06/17/1999 bt  Created.
;--------------------------------------------------------------------
include datalght.inc
InitModel %MEMMODEL, pascal, use16
include _dldosio.inc

.code

;--------------------------------------------------------------------
; $DOCPROC: dlKernelSupportVersion
;
; bool PASCAL dlKernelSupportVersion( unsigned * puVersion )
;
; This function calls INT-21h function 30dbh which is used to determine
; if romdos is the current OS.  If it is ROMDOS it retrieves the version
; number of the structure support.  Otherwise it calls MSDOS to get the
; real version number.  Thus it returns the true kernel support version
; for ROMDOS and MSDOS. This function returns TRUE if successful.
;
; On Entry
;
;	none
;
; On Exit
;	puVersion Real version number of ROMDOS or MSDOS
;	ax  TRUE if romdos is running, FALSE otherwise
;
;--------------------------------------------------------------------
ProcBegin 	dlKernelSupportVersion, public
ProcArgs	@@puVersion:PTR
ProcUses	ds,es,si,di
ProcSetup

	; Set the function number
	;
	mov	ax, 30dbh
	xor	cx, cx
	mov	si, 0b2d2h
	mov	di, 3

	; Perform the Get ROM-DOS Revision and support version
	;
	int	21h
	jc	short NotRomdos

	; Check if this is romdos
	;
	cmp	cx, 0b2d2h
	jnz	short NotRomdos

	; Save the support version
	;

	jmp	short SaveVersion


	; Call MSDOS to get the real version number
	;

    NotRomdos:

	; Set the function number
	;
	mov	ax, 3306h

	; Perform the get boot drive number
	;
	int	21h

	xchg	bh, bl
	mov	dx, bx

	; Save the dos version number
	;

    SaveVersion:

	LPTR_DS bx, @@puVersion
	mov	word ptr [bx], dx

    Done:

    	; Set the return value and the internal error code variable
	;

	mov	ax, 1

ProcEnd

@curseg	ends
	end
