;
;   $Id: _DLDOSIO.INC 1.6 2002/10/15 22:52:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
comment ~

   _DLDOSIO.INC
   Created 08-09-97 by Dennis Edwards

   Copyright (c) 1997-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   This include file provides support for the modules in the
   DLDOSIO library.


end_comment ~


; Declare our int 21h error variable for the lib modules to see
;
extrn	LAST_DOS_ERROR:word


; if your assembler does not suport @DataSize and @CodeSize then
; you will have to provide these definitions, possibly based on the
; command line definition of the MEMMODEL string equate.
;
; include MEMMODEL.inc


; If there was an error, updates the internal error code
; variable and then sets up a boolean return value in AX (TRUE
; means the function succeeded). It assumes that the state of the
; CF and the value of AX are those returned by DOS (or if not and
; there was no error that the CF is clear and AX is zero).
;
SET_DOS_ERROR macro
local @@error_recorded

	jnc	@@error_recorded		;; don't erase errors
	cbw					;; force 16 bit error code
    if @DataSize
	push	ds
	push	ax
	mov	ax, SEG LAST_DOS_ERROR		;; can only keep one error
	mov	ds, ax
	pop	LAST_DOS_ERROR
	pop	ds
    else
	mov	LAST_DOS_ERROR, ax
    endif

    @@error_recorded:
	mov	ax, 0
	cmc
	adc	ax, ax
ENDM
