;
;   $Id: i21f32.asm 1.4 2002/10/15 22:52:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:i21f32.ASM
; Created 11-12-1999 by Brandon Thomas
;
; Copyright (c) 1999-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
; This module is a wrapper for interrupt 21h function 32h which
; sets returns a DPB for the specified drive.
;
; bool PASCAL dlGetDriveDPB( uchar ucDriveNumber, LPDPB * pfpDPB );
;
; $DOCHISTORY
; 11-12-1999 bt  Created
;
;--------------------------------------------------------------------
include datalght.inc
InitModel %MEMMODEL, pascal, use16
include _dldosio.inc

.code

;--------------------------------------------------------------------
; $DOCPROC: dlGetDriveDPB
;
; This module is a wrapper for interrupt 21h function 32h which
; sets returns a DPB for the specified drive.
;
; bool PASCAL dlGetDriveDPB( uchar ucDriveNumber, LPDPB * pfpDPB );
;
; On Entry
;
;	dl    ucDriveNumber  The drive number (0=default,1=a,2=b)
;
; On Exit
;
;	ds:bx pfpDPB  The DPB address for the drive
;
;--------------------------------------------------------------------
ProcBegin	dlGetDriveDPB,public
ProcArgs	@@ucDriveNumber:byte,@@pfpDPB:PTR
ProcUses	es, ds
ProcSetup

	; Set the function number
	;
	mov	ah, 32h

	; Set the drive number
	;
	mov	dl, @@ucDriveNumber

	; Perform the interrupt
	;
	push	ds
	int	21h

	; Check for error
	;

	mov	cx, ds
	pop	ds
	mov	dx, ax
	xor	ax, ax
	cmp	dl, 0ffh
	jz	Done

	; Save the DPB address
	;

	mov	dx, bx
	LPTR_DS	bx, @@pfpDPB
	mov	word ptr [bx], dx
	mov	word ptr [bx+2], cx

	inc	ax

	; exit (return code set above)
	;

    Done:

ProcEnd
	end
