//
//   $Id: _FIND.H 1.3 2002/10/15 22:54:22Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/********************************************************************
	$DOCMODULE:_FIND.H

	Copyright (c) 1998-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

	$DOCHISTORY
	04-20-2001 bt  Put into a seperate file for library granularity
	02/16/1999 dg  Added findfirst/next and file functions
	01-30-1999 bt  Added dostruct.h include
	07/17/1998 dg  Created by Drew Gislason
*********************************************************************/


/*
	This structure is designed for backwards compatibility with existing
	code that uses the "C" ffblk structure.

	For short name systems, used exactly like ffblk. In long name systems,
	the SMARTFIND structure contains the LFN handle, and a signature to
	identify it.
*/
typedef struct SmartFindFirstNext SMARTFIND;
typedef SMARTFIND * PSMARTFIND;
typedef SMARTFIND far * LPSMARTFIND;
struct SmartFindFirstNext
{
	unsigned		uSignature;				// 00  will be 'SF'
	int			iHandle;					// 02  handle to long findfirst/next
	unsigned		uLastAccessDate;		// 04  last access date
   uchar      	res1[7];      			// 06  not used
   unsigned   	dirnum;      			// 0D  will be 0xFFFF for smart dir
   uchar      	res[6];      			// 0F  not used
   uchar      	attr;        			// 15  attribute found
   unsigned   	time;        			// 16  file's time
   unsigned   	date;        			// 18  file's date
   ulong      	size;        			// 1A  file's size
   char       	name[13];    			// 1E  filename in dot form
};


#define SMARTFIND_SIG	'FS'		// appears as SF in memory
#define IsSmartFind(pSF) (((PSMARTFIND)(pSF))->uSignature==SMARTFIND_SIG && \
	((PSMARTFIND)(pSF))->dirnum==0xFFFF)
#define SmartFindHandle(pSF) (((PSMARTFIND)(pSF))->iHandle)

// maximum # of handles open at once with SmartFindFirst(). Also limited
// by # available from DOS.
#define MAXHANDLES 20

