;
;   $Id: i21f71a8.asm 1.4 2002/10/15 22:55:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:i21f71A8.ASM
;
; Copyright (c) 2000-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
; This module is a wrapper for interrupt 21h function 71A8h which
; generates a short filename from the specified long filename.
;
; $DOCHISTORY
; 9-19-2000 aj  Created
;
;--------------------------------------------------------------------
include datalght.inc
InitModel %MEMMODEL, pascal, use16
include _dllfn.inc

.code

;--------------------------------------------------------------------
; $DOCPROC: dlGenShortFilename
;
; This module is a wrapper for interrupt 21h function 71A8h which
; generates a short filename from the specified long filename.
;
; bool PASCAL dlGenShortFilename( char * szLongFilename,
;	uchar ucReturnFormat, uchar ucCharSetMask, char * szShortFilename );
;
; On Entry
;
;    szLongFilename  = The long filename to be converted
;    szShortFilename = 13 byte work buffer (26 bytes for Unicode)
;    ucReturnFormat  = 00h 11-char directory entry/FCB filename format
;		       01h DOS 8.3
;    ucCharSetMask   = bits 7-4: short name's character set
;		       bits 3-0: long name's character set
;		         00h Windows ANSI
;			 01h current OEM character set
;			 02h Unicode
;
; On Exit
;
;  if the function is successful, the szShortFilename will contain
;  the short filename with respect to the long filename.
;
;	ax  TRUE if function is successful
;
;--------------------------------------------------------------------
ProcBegin	dlGenShortFilename,public
ProcArgs	@@szLongFilename:PTR,@@ucReturnFormat:byte,@@ucCharSetMask:byte,@@szShortFilename:PTR
IF @DataSize
ProcUses	es,ds,si,di
ELSE
ProcUses	si,di
ENDIF
ProcSetup

	;  Set the function number
	;
	mov	ax, 71A8h
	mov	dh, @@ucReturnFormat
	mov	dl, @@ucCharSetMask
	LPTR_DS si, @@szLongFilename
	LPTR_ES di, @@szShortFilename

	;  Perform the Generate Short Filename function
	;
	int	21h
	jc	Error

	;  zero ax, clear CF
	;
	xor	ax, ax

	;  Set the global error variable and the functions
	;  boolean return value (success/failure)
	;
	Error:
	LFN_SET_DOS_ERROR

ProcEnd

@curseg	ends
	end

