;
;   $Id: lfndate4.asm 1.3 2002/10/15 22:55:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:LFNDATE.ASM
; Created 06-29-1998 by Drew Gislason
;
; Copyright (c) 1998-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
; $DOCHISTORY
; 06/29/1998 dg  Created.
;--------------------------------------------------------------------
include datalght.inc
InitModel %MEMMODEL, pascal, use16

include _dllfn.inc

.code

;--------------------------------------------------------------------
; $DOCPROC:LFNSetCreateTimeDate (I21h fn 5707h)
;
; bool PASCAL LFNSetCreateTimeDate(int nHandle, word createTime,
;				word createDate, int createMilli);
;
; Sets the date and time the file was created. Used to make times and
; dates match for things like a backup set. The "CreateMilli" is in
; 10 millisecond intervals, from 0-199, representing up to 2 seconds
; (since the createTime only goes to seconds/2).
;
; On Entry
;	bx (nHandle)		DOS file handle
;	cx (createTime)		DOS file time
;	dx (createDate)		DOS file date
;	si (createMilli)	0-199 milliseconds (0-2 seconds)
; On Exit
;	nothing
;
; Returns TRUE if worked. Returns FALSE if failed (no LFN support, or
; disk or handle error).
;--------------------------------------------------------------------
ProcBegin	LFNSetCreateTimeDate, PUBLIC
ProcArgs	@@nHandle:word, @@createTime:word, @@createDate:word, @@createMilli:word
if @DataSize
ProcUses	ds, si
else
ProcUses	si
endif
ProcSetup
	; set last access date
	mov	ax, 5707h
	mov	bx, @@nHandle
	mov	cx, @@createTime
	mov	dx, @@createDate
	mov	si, @@createMilli
	int	21h

	; set pass/failed here (ax=TRUE if worked, FALSE if failed)
	LFN_SET_DOS_ERROR
ProcEnd

	END
