//
//   $Id: DL2LONG2.C 1.3 2002/10/15 22:57:12Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*******************************************************************

   DL2LONG2.C  created 04/24/97  by Drew Gislason

	Copyright (c) 1997-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

	Datalight ROM-DOS Tools Library:

	long atolong(char *s);

********************************************************************/
#define __FILENUM__ 508
#include <ctype.h>
#include <string.h>
#include <stdlib.h>

// datalight includes
#include "datalght.h"
#include "dlpath.h"

long atolx(char *pHexStr);

/*
	Given a number in the below forms, convert it to a long.
	0x400000[L]			12345678[L]
	400000H				128K					4M

	Returns the number.  Will return 0 if the string is not
   a number, just like atol().
*/
long atolong(char *s)
{
	long lVal;
	bool hex = FALSE;

	ASSERT(s);

	// user specified in K bytes?
	if(strchr(s, 'K') || strchr(s, 'k'))
	{
		lVal = atol(s) * 1024L;
		return lVal;
	}

	// user specified in Megabytes?
	if(strchr(s, 'M') || strchr(s, 'm'))
	{
		lVal = atol(s) * 1024L * 1024L;
		return lVal;
	}

	// C style 0xNNNN number
	if(strncmpi(s, "0x", 2) == 0)
	{
		s += 2;		// skip the 0x
		hex = TRUE;
	}

	// Assembly style xxxxH number
	if(strchr(s, 'H') || strchr(s, 'h'))
		hex = TRUE;

	// determine the hex/normal value
	if(hex)
		lVal = atolx(s);
	else
		lVal = atol(s);

	// return the value
	return lVal;
}
