;
;   $Id: DL64ADD.ASM 1.5 2002/10/15 22:57:48Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:DL64ADD.ASM
;
; Copyright (c) 1999-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
; This module contains 64-bit math add functions.
;
; bool AddQuadLong(uquad *pQuad, ulong ulValue);
;
; $DOCHISTORY
; 07/21/1998 dg  Created by Drew Gislason
;--------------------------------------------------------------------
include datalght.inc
InitModel %MEMMODEL, pascal, use16


.code

;--------------------------------------------------------------------
; $DOCPROC:AddQuad
;
; On Entry
;	pDstQuad	ptr to 64 bit for destination
;	pSrcQuad	ptr to 64 bit # to be added to dst
; On Exit
;	ax = TRUE if worked, FALSE if overflow
;--------------------------------------------------------------------
ProcBegin	AddQuad, public
ProcArgs	pDstQuad:ptr, pSrcQuad:ptr
ProcUses	ds, si
ProcSetup
	; get pointers to structures
	lptr_es	bx, pDstQuad
	lptr_ds	si, pSrcQuad

	; add quad words with 16-bit math
	mov	ax, [si]
	add	es:[bx], ax
	mov	ax, [si+2]
	adc	es:[bx+2], ax
	mov	ax, [si+4]
	adc	es:[bx+4], ax
	mov	ax, [si+6]
	adc	es:[bx+6], ax

	; overflow?
	jc	@@OverFlow
	mov	ax, 1
	jmp	short @@Done

    @@OverFlow:
	xor	ax, ax
    @@Done:

ProcEnd
	end
