//
//   $Id: DL64DIV.C 1.5 2002/10/15 22:57:12Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/***************************************************************************
   $DOCMODULE:DL64DIV.C

	Copyright (c) 1999-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary.

	$DOCHISTORY
	02/23/1999 dg  Created by Drew Gislason
***************************************************************************/
#include "datalght.h"
#include "dl64.h"

// returns the result. Does not modify inputs
void PASCAL DivideQuadByUnsigned(uquad * pQuad, unsigned uDivisor,
		unsigned *upRemainder, uquad * puqResult )
{
	int i;
	uquad		uqReturn;
	QuadHelp qhRemainder;
	ulong 	ulTemp;
	unsigned *upValue = (unsigned *)(&pQuad->ulHi);
	unsigned *upQuotient = (unsigned *)(&uqReturn.ulHi);

	// test for divide by zero
	if(uDivisor == 0)
	{
		uqReturn.ulLo =
		uqReturn.ulHi = 0xffffffffL;
	}
	else
	{
		// compute hi part, and get remainder
		uqReturn.ulHi = pQuad->ulHi / uDivisor;
		qhRemainder.ulValue = pQuad->ulHi - uqReturn.ulHi * uDivisor;

		// compute next two words
		for(i=0; i<2; i++)
		{
			// next lowest word
			--upValue;
			--upQuotient;

			// compute next part and get remainder
			qhRemainder.u.uHi = qhRemainder.u.uLo;
			qhRemainder.u.uLo = *upValue;
			ulTemp = qhRemainder.ulValue / uDivisor;

			// assign to uqReturn
			*upQuotient = (unsigned)ulTemp;
			qhRemainder.ulValue -= *upQuotient * uDivisor;
		}

		// return final remainder
		*upRemainder = (unsigned)(qhRemainder.ulValue);
	}

	puqResult->ulHi = uqReturn.ulHi;
	puqResult->ulLo = uqReturn.ulLo;
}

#if UNIT_TEST
void main(void)
{
	uquad q;
	unsigned uRemainder;

	// comprehensive test :-) divide by 10
	q.ulLo = 0x23456789L;
	q.ulHi = 1;
	DivideQuadByUnsigned(&q, 10, &uRemainder, &q );
}
#endif
