//
//   $Id: DLCHAR.C 1.6 2002/10/15 22:57:12Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*********************************************************

   DLCHAR.C  created 04/25/97  by Drew Gislason

	Copyright (c) 1997-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

	Handles some international character things, determining
	the LastChar and so on.

**********************************************************/
#define __FILENUM__ 503

#include "datalght.h"
#include "dlpath.h"

// note: not implemented yet!
// Is this character one of the double-byte characters?
#pragma argsused
bool Is2ByteChar(unsigned char c)
{
#if 0
	static unsigned char far * c_dbcs_ptr;
	int i;

	// check the list of double byte characters
	for(i=0; c_dbcs_ptr[i]; i+=2)
	{
		if(c >= c_dbcs_ptr[i] && c <= c_dbcs_ptr[i+1])
			return TRUE;
	}
#endif
	return FALSE;
}

#if UNIT_TEST	// {
#include <stdio.h>
#include <stdlib.h>

void InternalError(int fileNum, int lineNum)
{
	printf("ASSERT file %u, line %u\n",fileNum,lineNum);
	exit(99);
}

int main(void)
{
	// test LastChar
	ASSERT(LastChar("") == 0);
	ASSERT(LastChar("a") == 'a');
	ASSERT(LastChar("a\b\c") == 'c');

	printf("passed");
	return 0;
}

#endif	// } UNIT_TEST
