//
//   $Id: DLDUMP.C 1.4 2002/10/15 22:57:12Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
	$DOCMODULE:DLDUMP.C  created 06/25/1998 by Drew Gislason

	Copyright (c) 1998-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary.

	Simple dump program. Used to dump memory.

	Example:
	1234: 00 11 22 33 44 55 66 77 | 88 99 AA BB CC DD EE FF  ........
*/
#include <stdio.h>
#include <ctype.h>

/*
	$DOCPROC:Dump

	Dump some memory to the screen. Displays address (either near or
	far depending on memory model) on each line.
*/
void Dump(void *pBuffer, unsigned nLen)
{
	register unsigned n, i;
	unsigned char *pChar;
	unsigned char c;

	n = 0;
	pChar = pBuffer;
	while(n < nLen)
	{
		/* display address for line */
		printf("%04X: ",(unsigned)pChar);

		/* display bytes in hex */
		for(i=0;i<16;++i)
		{
			/* middle of the line. display vertical bar. */
			if(i==8)
			{
				if(n+i < nLen)
					printf("| ");
				else
					printf("  ");		/* incomplete line, so just use spaces */
			}

			/* incomplete line, use spaces */
			if(n+i >= nLen)
				printf("   ");
			else
				printf("%02X ",pChar[i]);
		}

		/* now display the ascii version of each byte */
		printf(" ");
		for(i=0; i<16; ++i)
		{
			if(n+i >= nLen)
				c = ' ';				/* incomplete line, use spaces */
			else
			{
				c = pChar[i];
				if(!isprint(c))	/* non-printable chars are dots */
					c = '.';
			}
			printf("%c",c);
		}
		printf("\n");

		/* on to next line */
		pChar += 16;
		n += 16;
	}
}
