//
//   $Id: DLGETATR.C 1.6 2002/10/15 22:57:12Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*******************************************************************

   DLGETATR.C  created 04/28/97  by Drew Gislason

	Copyright (c) 1997-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

	Datalight ROM-DOS Tools Library:

	bool Exist( char * szFileName );

********************************************************************/
#define __FILENUM__	516

// includes
#include <dos.h>

#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "dldosio.h"
#include "dllfn.h"
#include "dlpath.h"

/*
	Does the file exist?
*/
bool Exist( char * szFileName )
{
	unsigned attr;
	return SmartGetFileAttributes( szFileName, &attr);
}

#if UNIT_TEST

#include <dir.h>
#include <stdio.h>
#include <stdlib.h>

void InternalError(int fileNum, int lineNum)
{
	printf("ASSERT %u.%u\n",fileNum,lineNum);
	exit(99);
}

int main(void)
{
	static char szFileName[] = "x.y";
	FILE * fp;
	struct ffblk ff;
	int	err;

	// create a file for setting attribute
	fp = fopen(szFileName,"w");
	ASSERT(fp);
	fclose(fp);

	// try setting Archive bit
	if(!SetFileAttr(szFileName, A_ARCHIVE))
		ABORT();
	err = findfirst(szFileName, &ff, A_NORMAL);
	ASSERT(!err);
	ASSERT((ff.ff_attrib & A_ARCHIVE) != 0);

	// try clearing Archive bit
	if(!SetFileAttr(szFileName, A_NORMAL))
		ABORT();
	err = findfirst(szFileName, &ff, A_NORMAL);
	ASSERT(!err);
	ASSERT((ff.ff_attrib & A_ARCHIVE) == 0);

	// try setting invalid bits
	if(SetFileAttr(szFileName, 0x80))
		ABORT();

	// done with file
	unlink(szFileName);

	printf("passed");
	return 0;
}
#endif
