//
//   $Id: FATWORLD.C 1.4 2002/10/15 22:57:12Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//  $DOCMODULE:FATWORLD.C
//
//  Copyright (c) 1999-2002 Datalight, Inc.
//  All Rights Reserved.
//  Datalight Confidential and Proprietary.
//
//  This module is an contains a function used to determine if we are
//  operating in an MS-DOS 7.1 or an MS-DOS 6.22 enviornment.  This is
//  part of the Datalight Library.
//
//  bool PASCAL dlIsFat32World( void );
//
//  $DOCHISTORY
//  06/17/1999 bt  Created.
//

//
//  [CONSTANTS]
//


//  Datalight libraries
//
#include "datalght.h"
#include "dostruct.h"
#include "dldosio.h"


//  $DOCPROC: dlIsFat32World
//
//  bool PASCAL dlIsFat32World( void );
//
//  This function used to determine if we are operating in an MS-DOS 7.1
//  or an MS-DOS 6.22 enviornment.  It returns TRUE if we are operating
//  in DOS 7.1 (a FAT32 world).The parameters are described below:
//
//  ON ENTRY:
//    none
//
//  ON EXIT:
//    returns TRUE if in a DOS 7.1 enviornment
//
bool PASCAL dlIsFat32World( void )
{
	//  [LOCALS]
	//
	bool bSuccessful = FALSE;
	unsigned uRealVersion;


	//  [CODE]
	//

	//  Attempt to perform a function which only exists in a DOS 7.1
	//  enviornment.
	//
	bSuccessful = dlKernelSupportVersion( &uRealVersion );
	if( bSuccessful )
	{
		if( uRealVersion == 0x070a )
		{
			bSuccessful = TRUE;
		}
		else
		{
			bSuccessful = FALSE;
		}
	}

	//  Return whether the function was successful
	//
	return bSuccessful;
}
