//
//   $Id: GTENVPTR.C 1.3 2002/10/15 22:57:12Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//  $DOCMODULE: STDC.H
//
//  Copyright (c) 2001-2002 Datalight, Inc.
//  All Rights Reserved.
//  Datalight Confidential and Proprietary
//
//
//  $DOCHISTORY:
//
//  04-20-2001 bt 	created
//


#include "stdc.h"
#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "dldosio.h"


//  Return the value of an environment variable
//
char far * GetEnvEntry( const char * szName )
{
	LPPSP lpPSP;
	extern unsigned _psp;
	char far * lpEnv;
	unsigned uEnvSegment;
	unsigned uIndex;


	//  Get the address of the PSP
	//
	lpPSP = MK_FP( _psp, 0 );


	//  Get the segment of the environment out of the PSP
	//
	uEnvSegment = lpPSP->env_seg;
	if( uEnvSegment )
	{
		//  Set a pointer to the environment
		//
		lpEnv = MK_FP( uEnvSegment, 0 );


		//  Search for the string in the environment
		//
		while( TRUE )
		{
			for( uIndex = 0; toupper(szName[uIndex]) == toupper(lpEnv[uIndex]);
					uIndex++ )
			{
				//
				//  Condition above is performing a case sensitive compare
				//
			}


			//  Determine if the entry was found
			//
			if( (szName[uIndex] == 0) && (lpEnv[uIndex] == '=') )
			{
				//  Found the entry
				//
				return &lpEnv[uIndex+1];
			}


			//  Determine if this is the end of the environment
			//
			if( (lpEnv[0] == 0) && (lpEnv[0] == 0) )
			{
				break;
			}


			//  The entry was not found, set the address of the next entry
			//
			lpEnv += _fstrlen(lpEnv) + 1;
		}
	}


	//  Entry not found, return NULL
	//
	return MK_FP(0,0);
}
