//
//   $Id: LFNABORT.C 1.5 2002/10/15 22:57:12Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//  LFNABORT.C
//
//  Copyright (c) 2000-2002 Datalight, Inc.
//  All Rights Reserved.
//  Datalight Confidential and Proprietary.
//
//


#include <dos.h>
#include <stdio.h>
#include <stdlib.h>

#include "datalght.h"



//  Abort if there are LFNs on the command line
//
void AbortForLFNArgs( void )
{
	char far * fpCommandLine;
	unsigned uCommandLineSize;
	unsigned uIndex = 0;
	char cChar;


	//  Get the address of the command line in the PSP
	//
	uCommandLineSize = *((uchar far *)(MK_FP( _psp, 0x80 )));
	fpCommandLine = MK_FP( _psp, 0x81 );

	while( uIndex < uCommandLineSize )
	{
		cChar = fpCommandLine[uIndex];

		if(( cChar == '/' ) || ( cChar == '-' ))
		{
			//  Skip over any parameters
			//
			do
			{
				uIndex++;
				cChar = fpCommandLine[uIndex];

				if( uIndex >= uCommandLineSize )
				{
					break;
				}
			}
			while( cChar != ' ');
		}
		else if( cChar != ' ' )
		{
			//  Names in quotes constitute a long file name
			//
			if( cChar == '\"' )
			{
				printf("This utility does not support long file names\n");
				exit(255);
			}
		}

		uIndex++;
	}
}
