//
//   $Id: dlatime3.c 1.4 2002/10/15 22:57:12Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*******************************************************************

   DLATIME.C  created 04/30/97  by Drew Gislason

	Copyright (c) 1997-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

	Convert file date/time to ascii versions, using foreign
	country date/time separators.

	Datalight ROM-DOS Tools Library:
	void InitCountryInfo(void);
	void TimeToAscii(unsigned time, char szStr[]);
	void DateToAscii(unsigned date, char szStr[]);
	bool AsciiToDate(unsigned *puDate, char szStr[]);

	Revision History
	03/16/99	jmb	added AsciiToDate

********************************************************************/
#define __FILENUM__ 511

// includes
#include <dos.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "dostruct.h"
#include "datalght.h"
#include "dldate.h"

extern struct COUNTRY_INFO countryInfo;

/*
	Place the given file date, in international format, into
	the string.
*/
void DateToAscii(unsigned date, char szStr[])
{
	unsigned year, month, day;
	static char szDateFmt[] = "%02u%s%02u%s%02u";

	// extract y/m/d from the file date
	year = (date >> 9) + 1980;
	month = (date >> 5) & 0xF;
	day  = date & 0x1F;

	// invalid date, we're done
	if(date == 0)
	{
		strcpy(szStr, "        ");
		return;
	}

	switch(countryInfo.datefmt)
	{
		/* mm-dd-yy*/
		case 1:
			sprintf(szStr, szDateFmt, day, countryInfo.datesep,
				month, countryInfo.datesep, year%100);
			break;

		/* yy-mm-dd*/
		case 2:
			sprintf(szStr, szDateFmt, month, countryInfo.datesep,
				day, countryInfo.datesep, year%100);
			break;

		/* dd-mm-yy */
		default:

			// only valid formats are 0,1,2
			ASSERT(countryInfo.datefmt == 0);

			sprintf(szStr, szDateFmt, month, countryInfo.datesep,
				day, countryInfo.datesep, year%100);
			break;
	}
}
