;
;   $Id: XMSERMSG.ASM 1.4 2002/10/15 23:06:00Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
comment ~

  XMSERMSG.ASM  Created 10-25-97 by Dennis Edwards

  Copyright (c) 1997-2002 Datalight, Inc.
  All Rights Reserved.
  Datalight Confidential and Proprietary

  XMSLIBx -- Low level XMS 2.0 function library source module
  This module implements the function (DLXMSLIB.H):

  char *GetXMSErrorCodeString(int XMSErrorCode);

end_comment ~
;
; use the /i switch on the assembler command line to specify
; the include path if these files are not in the current dir
;
include datalght.inc

; MEMMODEL is assumed to be defined using a /D argument on the
; assembler command line.
;
; Establish segment model, calling conventions, etc.
;
InitModel %MEMMODEL, pascal, use16


; internal include module for XMSLIBx.LIB
;
include _xmslib.inc

MAX_KNOWN_XMS_ERROR	= 0B2h

.Data

XMSError00String	db "XMS functions succeeded.",0
XMSError80String	db "XMS function not implemented.",0
XMSError81String	db "VDISK detected.",0
XMSError82String	db "XMS A20 error.",0

XMSError8EString	db "XMS general driver failure.",0
XMSError8FString	db "XMS unrecoverable error.",0
XMSError90String	db "No HMA.",0
XMSError91String	db "HMA already in use.",0
XMSError92String	db "HMAIN value bigger.",0
XMSError93String	db "HMA not allocated.",0
XMSError94String	db "A20 line enabled.",0

XMSErrorA0String	db "No more XMS.",0
XMSErrorA1String	db "No more XMS handles.",0
XMSErrorA2String	db "XMS handle invalid.",0
XMSErrorA3String	db "XMS source handle invalid.",0
XMSErrorA4String	db "XMS source offset invalid.",0
XMSErrorA5String	db "XMS destination handle invalid.",0
XMSErrorA6String	db "XMS destination offset invalid.",0
XMSErrorA7String	db "XMS length invalid.",0
XMSErrorA8String	db "XMS overlap invalid.",0
XMSErrorA9String	db "Parity error.",0
XMSErrorAAString	db "XMS block not locked.",0
XMSErrorABString	db "XMS block is locked.",0
XMSErrorACString	db "XMS block count overflow.",0
XMSErrorADString	db "XMS block lock failed.",0
XMSErrorB0String	db "UMB alloc failed. Have smaller one.",0
XMSErrorB1String	db "No more UMBs.",0
XMSErrorB2String	db "UMB segment invalid.",0
XMSUnknownErrorString	db "Unknown XMS error.",0

XMSErrorStringTable1	dw offset XMSError80String
			dw offset XMSError81String
			dw offset XMSError82String

XMSErrorStringTable2    dw offset XMSError8EString
			dw offset XMSError8FString
			dw offset XMSError90String
			dw offset XMSError91String
			dw offset XMSError92String
			dw offset XMSError93String
			dw offset XMSError94String

XMSErrorStringTable3	dw offset XMSErrorA0String
			dw offset XMSErrorA1String
			dw offset XMSErrorA2String
			dw offset XMSErrorA3String
			dw offset XMSErrorA4String
			dw offset XMSErrorA5String
			dw offset XMSErrorA6String
			dw offset XMSErrorA7String
			dw offset XMSErrorA8String
			dw offset XMSErrorA9String
			dw offset XMSErrorAAString
			dw offset XMSErrorABString
			dw offset XMSErrorACString
			dw offset XMSErrorADString
			dw offset XMSUnknownErrorString
			dw offset XMSUnknownErrorString
			dw offset XMSErrorB0String
			dw offset XMSErrorB1String
			dw offset XMSErrorB2String


.Code
if @DataSize
	assume	cs:@curseg, ds:nothing, es:nothing, ss:nothing
else
	assume	cs:@curseg, ds:@data, es:nothing, ss:nothing
endif


comment ~
char *GetXMSErrorCodeString(int XMSErrorCode);
end_comment ~
ProcBegin	GetXMSErrorCodeString,public
if @DataSize
ProcUses	ds,bx
else
ProcUses	bx
endif
ProcArgs	@@XMSErrorCode:word
ProcSetup

if @DataSize
	mov	ax, @data
	mov	ds, ax
	assume	ds: @data
endif

	mov	ax, @@XMSErrorCode
	or	ax, ax
	lea	bx, XMSError00String            ; there was no error
	jz	@@done
	lea	bx, XMSUnknownErrorString       ; all error codes <=0
	jns	@@done
	and	ax, 0FFh			; isolate error code in low byte
	cmp	ax, MAX_KNOWN_XMS_ERROR         ; don't go past end of table
	ja	@@done

	; Have an error code in AX but, just as you would expect from
	; MS, there are significant gaps in the error values.
	; Figure out which look up table to use...
	; (We already know that 80h <= AX <= MAX.)
	;
    	cmp	al, 82h
	jbe	@@useTable1

	cmp	al, 8Eh
	jb	@@done			; unknown error code

	cmp	al, 94h
	jb	@@useTable2

	cmp	al, 0A0h
	jb	@@done			; unknown error code

	; Error code A0h <= AX <= B2h
	;
    @@useTable3:
	mov	bx, ax
	sub	bx, 0A0h
	shl	bx, 1
	mov	bx, XMSErrorStringTable3[bx]
	jmp	short @@done

	; Error code 80h <= AX <= 82h
	;
    @@useTable1:
	mov	bx, ax
	sub	bx, 80h
	shl	bx, 1
	mov	bx, XMSErrorStringTable1[bx]
	jmp	short @@done

	; Error code 8Eh <= AX <= 94h
	;
    @@useTable2:
	mov	bx, ax
	sub	bx, 8Eh
	shl	bx, 1
	mov	bx, XMSErrorStringTable2[bx]
	jmp	short @@done

	; Return a pointer to the appropriate message
	;
    @@done:
	mov	ax, bx
if @DataSize
	mov	dx, ds
endif

ProcEnd

	end
