;
;   $Id: _XMSLIB.INC 1.4 2002/10/15 23:06:00Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
comment ~

  _XMSLIB.INC  Created 10-25-97 by Dennis Edwards

  Copyright (c) 1997-2002 Datalight, Inc.
  All Rights Reserved.
  Datalight Confidential and Proprietary

end_comment ~

; XMS error codes
;
; If AX=0000h when a function returns and the high bit of BL is set,
;
XMS_SUCCESS			  = 0	 ; grroooovee
XMS_ERR_FUNCTION_NOT_IMPLEMENTED  = 080h ; the function is not implemented
XMS_ERR_VDISK_DETECTED       	  = 081h ; a VDISK device is detected
XMS_ERR_A20_ERROR       	  = 082h ; an A20 error occurs
XMS_ERR_GENERAL_DRIVER_ERROR	  = 08Eh ; a general driver error occurs
XMS_ERR_UNRECOVERABLE_DRIVER_ERROR= 08Fh ; an unrecoverable driver error occurs
XMS_ERR_NO_HMA       		  = 090h ; the HMA does not exist
XMS_ERR_HMA_IN_USE       	  = 091h ; the HMA is already in use
XMS_ERR_HMAIN_BIGGER       	  = 092h ; DX is less than the /HMAMIN= parameter
XMS_ERR_HMA_NOT_ALLOCATED         = 093h ; the HMA is not allocated
XMS_ERR_A20_LINE_ENABLED       	  = 094h ; the A20 line is still enabled
XMS_ERR_NO_MORE_XMS       	  = 0A0h ; all extended memory is allocated
XMS_ERR_NO_MORE_XMS_HANDLES       = 0A1h ; all available extended memory handles are in use
XMS_ERR_HANDLE_INVALID		  = 0A2h ; the handle is invalid
XMS_ERR_SOURCE_HANDLE_INVALID	  = 0A3h ; the SourceHandle is invalid
XMS_ERR_SOURCE_OFFSET_INVALID	  = 0A4h ; the SourceOffset is invalid
XMS_ERR_DEST_HANDLE_INVALID       = 0A5h ; the DestHandle is invalid
XMS_ERR_DEST_OFFSET_INVALID       = 0A6h ; the DestOffset is invalid
XMS_ERR_LENGTH_INVALID       	  = 0A7h ; the Length is invalid
XMS_ERR_INVALID_OVERLAP       	  = 0A8h ; the move has an invalid overlap
XMS_ERR_PARITY_ERROR       	  = 0A9h ; a parity error occurs
XMS_ERR_BLOCK_NOT_LOCKED       	  = 0AAh ; the block is not locked
XMS_ERR_BLOCK_IS_LOCKED       	  = 0ABh ; the block is locked
XMS_ERR_BLOCK_LOCK_COUNT_OVERFLOW = 0ACh ; the block's lock count overflows
XMS_ERR_LOCK_FAILED       	  = 0ADh ; the lock fails
XMS_ERR_HAVE_SMALLER_UMB       	  = 0B0h ; a smaller UMB is available
XMS_ERR_NO_MORE_UMBS       	  = 0B1h ; no UMBs are available
XMS_ERR_UMB_SEGMENT_INVALID       = 0B2h ; the UMB segment number is invalid

RETURN_XMS_STATUS macro
local	@@done

	dec	ax
	jz	@@done

	mov	al, bl
    @@done:
	pop	es
endm

CHECK_XMM_LINKAGE macro
	push	es
	mov	ax, seg lpXMMEntry
	mov	es, ax
	xor	ax, ax
	assume  es: seg lpXMMEntry
	cmp	XMMEntrySegm, ax
endm

CALL_XMM macro
	call	dword ptr es:lpXMMEntry
endm
