;
;   $Id: MEMMOVE.ASM 1.7 2002/10/15 23:04:54Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:MEMMOVE.ASM
; Created 2-25-2001 by Brandon Thomas
;
; Copyright (c) 2001-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
; $DOCHISTORY
; 02/25/2001 bt  Created.
;--------------------------------------------------------------------
include datalght.inc
InitModel %MEMMODEL, C, use16

IF FARSEG
.code
ELSE
.code _TEXT
ENDIF

;--------------------------------------------------------------------
; $DOCPROC: memmove
;
; void * memmove( void * pDest, void * pSrc, unsigned uSize );
;
;--------------------------------------------------------------------
ProcBegin_f 	memmove, public
IF @DataSize
ProcUses  	es,ds,di,si
ELSE
ProcUses  	di,si
ENDIF
ProcArgs	@@pDest:PTR,@@pSrc:PTR,@@uSize:word
ProcSetup

	;
	;  *** This function is using 8086 instructions ***
	;


	;  Set the size of the move
	;
	mov	cx, @@uSize


	;  Set the source and destination in registers
	;  ds:si and es:di respectively.   Also save
	;  a copy of the destination on the stack
	;  so that it can be returned at the end of the
	;  function
	;
	LPTR_DS	si, @@pSrc
	LPTR_ES	di, @@pDest
	push	di
IF @DataSize
	push	es
ENDIF


	;  set the direction flag for the move and a variable
	;  to indicate the direction
	;
	cld			; Set direction flag to forward move
	xor	ax, ax		; AX contains flag for direction
IF @DataSize
	; Normalize the pointers so they can
	; be compared
	;
	push	cx

	mov	bx, si
	shr	bx, 4
	mov	dx, ds
	add	dx, bx
	mov	ds, dx
	and	si, 000fh

	mov	bx, di
	shr	bx, 4
	mov	cx, es
	add	cx, bx
	mov	es, cx
	and	di, 000fh

	cmp	dx, cx	; equivilent to: cmp	ds, es
	pop	cx
	ja	@@M1
	jb	@@M2
ENDIF
	cmp	si, di
	jnb	@@M1

    @@M2:

	; move backward if "to" is greater
	;
	std
	inc	ax


	; Intentional fall-through (safe here and saves code)


    @@M1:

	; move forward if "from" is greater
	;
	; NOTE: AX is zero (set above) indicating a forward move
	;       and the direction flag is already clear.  This
	;       is an optimization for size
	;


	;  Perform the move
	;
	;  es:di = dest
	;  ds:si = src
	;  cx    = length
	;  ax    = direction (0=forward, 1=backward)
	;
    @@DO_MOVE:


	;  Determine if this is a forward move
	;
	or	ax, ax
	je	@@M3


	;  Adjust ds:si and es:di for a backwards move
	;
	add	si, cx
	dec	si
	add	di, cx
	dec	di


	;  ??? Word alignment ???
	;
    @@M3:
	jcxz	@@Done
	test	di, 1
	je	@@M4
	movsb
	dec	cx


	;
	;
    @@M4:
	sub	si, ax
	sub	di, ax
	shr	cx, 1


	;
	;
	; NOTE: do not cld here, we may be going the other way
	;
	rep	movsw
	jnb	@@Done
	add	si, ax
	add	di, ax
	movsb


	;  Now clear the direction flag so it is forward like normal
	;
    @@Done:
	cld


	;  Set the return variable to the destination
	;
IF @DataSize
	pop	dx
ENDIF
	pop	ax


ProcEnd

@curseg	ends
	end
