;
;   $Id: memchr.asm 1.5 2002/10/15 23:04:54Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:MEMCHR.ASM
; Created 2-24-2001 by Brandon Thomas
;
; Copyright (c) 2001-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
; $DOCHISTORY
; 02/24/2001 bt  Created.
;--------------------------------------------------------------------
include datalght.inc
InitModel %MEMMODEL, C, use16

IF FARSEG
.code
ELSE
.code _TEXT
ENDIF

;--------------------------------------------------------------------
; $DOCPROC: memchr
;
; void * memchr( const void * pSrc, int iCharacter, unsigned uSize );
;
;--------------------------------------------------------------------
ProcBegin_f 	memchr, public
IF @DataSize
ProcUses  	es,di
ELSE
ProcUses  	di
ENDIF
ProcArgs	@@pSrc:PTR,@@ucCharacter:byte,@@uSize:word
ProcSetup


	;  Get the address of the string
	;
	LPTR_ES	di, @@pSrc


	;  Get the size of the block to search
	;
	mov	cx, @@uSize


	;  Set the search character
	;
	mov	al, @@ucCharacter


	;  Find the character in the string
	;
	repne	scasb
	je	@@Found

    @@NotFound:

	;  Set null
	;
	xor	di, di
IF @DataSize
	mov	es, di
ENDIF
	inc	di

    @@Found:

	;  Set the address of the matched character
	;
	mov	ax, di
	dec	ax

IF @DataSize
	mov	dx, es
ENDIF

    @@Done:

ProcEnd

@curseg	ends

	end
