//
//   $Id: MEMVALID.C 1.6 2002/10/17 14:56:40Z thomd Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/********************************************************************
	$DOCMODULE:MEMVALID.C

	Copyright (c) 1997-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary.

	$DOCHISTORY
	07/23/1998 dg  Created by Drew Gislason
*********************************************************************/
#define __FILENUM__	223
#include "compiler.h"
#include "memdisk.h"

/*
	$DOCPROC:IsValidDisk

	Is this a valid disk?
*/
bool IsValidDisk(void)
{
	struct BPB *pBPB;

	/* read the boot sector */
	if(!memread(0L, DEF_SEC_SIZE, aMemBuff))
		return FALSE;

	/* is our signature there? */
	if(memcmp(aMemBuff, DiskIntro, sizeof(DiskIntro)) != 0)
		return FALSE;

	/* does the BPB look OK? */
	pBPB = (struct BPB *)(aMemBuff+START_BPB);
	if(!pBPB->TotalSecs || !(pBPB->BytesPerSector==128 ||
			pBPB->BytesPerSector==256 || pBPB->BytesPerSector==512))
		return FALSE;

	/* todo: is CHKSUM OK? */

	return TRUE;
}

/*
	$DOCPROC:GetDiskBPB

	Get the BPB from a formatted RAM/ROM disk. Does not checking to
	verify disk is formated.

	Returns TRUE if worked, FALSE if not.
*/
bool GetDiskBPB(struct BPB * pBPB)
{
	/* read BPB from sector 0 of disk */
	memset( aMemBuff, 0xab, DEF_SEC_SIZE );
	if(!memread(0L, 48, aMemBuff))
		return FALSE;
	memmove(pBPB, (struct BPB *)(aMemBuff+START_BPB), sizeof(struct BPB));
	return TRUE;
}


//  Compare two BPBs to make sure that they are the same
//
bool IsSameBPB( struct BPB * pBPB1, struct BPB * pBPB2 )
{
#if 0
//	printf("BPB.BytesPerSector: %x %x\n",pBPB1->BytesPerSector,
//			pBPB2->BytesPerSector );
//	printf("BPB.SecPerCluster: %x %x\n",pBPB1->SecPerCluster,
//			pBPB2->SecPerCluster );
//	printf("BPB.Reserved: %x %x\n",pBPB1->Reserved,pBPB2->Reserved );
	printf("BPB.NumbFats: %x %x\n",pBPB1->NumbFats,pBPB2->NumbFats );
	printf("BPB.MaxDirs: %x %x\n",pBPB1->MaxDirs,pBPB2->MaxDirs );
	printf("BPB.TotalSecs: %x %x\n",pBPB1->TotalSecs,pBPB2->TotalSecs );
//	printf("BPB.MediaDescrip: %x %x\n",pBPB1->MediaDescrip,
//			pBPB2->MediaDescrip );
	printf("BPB.SecPerFAT: %x %x\n",pBPB1->SecPerFAT,pBPB2->SecPerFAT );
//	printf("BPB.SecPerTrak: %x %x\n",pBPB1->SecPerTrak,pBPB2->SecPerTrak );
//	printf("BPB.Sides: %x %x\n",pBPB1->Sides,pBPB2->Sides );
//	printf("BPB.Hidden: %lx %lx\n",pBPB1->Hidden,pBPB2->Hidden );
//	printf("BPB.LNumSec: %lx %lx\n",pBPB1->LNumSec,pBPB2->LNumSec );
#endif

	if( memcmp(pBPB1, pBPB2, sizeof(struct BPB)) )
	{
		return FALSE;
	}
	else
	{
		return TRUE;
	}
}
