//
//   $Id: NEWFDRV.H 1.5 2002/10/17 14:59:26Z thomd Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/********************************************************************
	$DOCMODULE:NEWFDRV.H

	Copyright (c) 1997-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary.

	Include file for NEWFDRV.C, defines the following functions:

	char FindDiskVolume(char *szDriveName);
	int PatchConfigBufferNEWFILEDrive(char *szNewFileName,
				char newDriveLetter);

	FindDiskVolume() returns drive letter ('A'-'Z') of the volume
	with the label defined by szDriveName.

		2) Patch the drive letter of a specified NEWFILE path name
			in the ROM-DOS CONFIG processing buffer.

	See NEWFEXAM.C for a simple application that uses these routines.

	$DOCHISTORY
	10-09-1997 de  Created by Dennis Edwards
*********************************************************************/
#if !defined(_NEWFDRV_H_)
#define _NEWFDRV_H_ 1

/* Searches drives {2..lastDrive} looking for the volume label
 	specified in szDriveName. The case of the label is significant.

  	Returns the drive letter of the sought drive if successful else 0.
*/
char FindDiskVolume(char *szDriveName);

/* Looks for the command "NEWFILE=<szNewFileName>" in the ROM-DOS CONFIG
   processing buffer. If the line is found, patches the NEWFILE drive to
   be newDriveLetter. The ASCIIZ string pointed to by szNewFileName must
   be of the form:

  			D:[\path\]filename.ext

   The case of all characters in szNewFileName must match those in the
   the CONFIG.SYS file currently being processed by DOS and all "NEWFILE"
   commands in the file must be in upper case.

   Returns FALSE (0) if the entry wasn't found in the buffer,
           TRUE (!0) if successful.
*/
int PatchConfigBufferNEWFILEDrive(char *szNewFileName, char newDriveLetter);

#endif /* !defined(_NEWFDRV_H_) */

