//
//   $Id: VDISK.H 1.5 2002/10/17 14:59:26Z thomd Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/********************************************************************
	$DOCMODULE:VDISK.H

	Copyright (c) 1997-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   This header contains the prototypes and functions necessary
   for VDISK to interact with Int15h, XMS and EMS memory.

	$DOCHISTORY
	07/12/1998 dg	Updated to Solid Code standards
	11/12/1997 dg  Created by Drew Gislason
*********************************************************************/

/* some VDISK defaults */
#define DEF_DIRS  64			/* default # of root directory entries */
#define DEF_SIZEK 64			/* default size of VDISK in KBytes */
#define VDISK_ID 0xF0		/* media ID, should be F8 for SCANDISK */

/* where does the disk reside? */
enum DiskType { dtConventional=1, dtInt15, dtXMS, dtEMS };

/*
	------------------------------
	     Int 15h Interface
	------------------------------
*/
unsigned AvailInt15Memory(void);
bool AllocateInt15Memory(unsigned sizeK, ulong *pStartAddr);
void RestoreInt15Used(void);

/*
	------------------------------
	     XMS (HIMEM) Interface
	------------------------------
*/

int IsHimemInstalled(void);
unsigned TotalXMS(void);
unsigned AllocateXMS(unsigned sizeK);
void FreeXMS(unsigned handle);
void CopyToXMS(unsigned hXMS, long offset, void far *lpMem, long numBytes);
void CopyFromXMS(void far *lpMem, unsigned hXMS, long offset, long numBytes);


/*
	-------------------------------
	     EMS (EMM386) Interface
	-------------------------------
*/

/* all functions return success if worked */
#define EMS_SUCCESS	((int)0x0000)

int PASCAL CheckEMMInstalled(void);
int PASCAL GetLIM32PageFrameSeg(unsigned *pPageFrameSeg);
int PASCAL GetEMSFreePageCount(unsigned *pPagesFree);
int PASCAL AllocateEMSPages(unsigned int pagesToAlloc, unsigned *pHandle);
int PASCAL MapUnmapEMSPage(unsigned handle, unsigned logicalPage,
									unsigned mappablePage);

/* from VDISK.C */
bool ParseCmdline(char far *lpCmdline);
bool RdWrEMS(long lOffset, unsigned nLen, char far *lpBuffer, bool bRead);
