;
;   $Id: CON_8250.ASM 1.4 2002/10/15 23:49:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
;  CON_8250.ASM
;
;  Copyright (C) 1994-2002 Datalight, Inc.
;  All rights reserved
;  Datalight Confidential and Proprietary
;
;


include minibios.inc    ;for Baud and com port assignments

; 8259 Interrupt Controller Ports  (PIC #1)
EOIPORT         equ     20h
MASKPORT        equ     21h

if Console_Port EQ 1
        Con_Port        equ     3f8h
        Console_IRQ     equ     4
endif

if Console_Port EQ 2
        Con_Port        equ     2f8h
        Console_IRQ     equ     3
endif

if Console_Port EQ 3
        Con_Port        equ     3e8h
        Console_IRQ     equ     4
endif

if Console_Port EQ 4
        Con_Port        equ     2e8h
        Console_IRQ     equ     3
endif

Console_Baud_Divisor equ COM_PORT_DIVIDEND/Console_Baud_Rate

; 8250 UART offsets relative to COM port base address
DATAREG         equ     0
BAUDLOW         equ     0
BAUDHIGH        equ     1
INTENABLE       equ     1
INTID           equ     2
LINECONTROL     equ     3
MODEMCONTROL    equ     4
LINESTATUS      equ     5

_TEXT   segment byte public 'CODE'
_TEXT   ends

_DATA Segment public byte 'DATA'
_DATA Ends

DGROUP  group  _DATA

extrn   _Int16PutChar:near,_Int10PutChar:near
public _console_putchar,_console_init

_TEXT   segment byte public 'CODE'
        assume  cs:_TEXT,ds:DGROUP
comment &

        void console_init()

        This function initializes the specified communications port in the
        mode specified in minibios.inc and prepares to use it as the console.
        Console_parms controls stop/data/parity bits. Possible values are:
                3 =  N81
                26 = E71

        Console_Baud_Divisor controls the baud rate divisor.

        For standard 8250 UART, values are:
                Desired Baud Rate       Console_Baud_Divisor
                300                     384
                1200                    96
                2400                    48
                4800                    24
                9600                    12
                19200                   6
                38400                   3
                57600                   2
                115200                  1

        Con_Port  - The port where the Serial device for the console can be
        found.  Normally 3F8 for COM1, 2F8 for COM2, 3E8 for COM3, 2E8 for
        COM4.

        Console_IRQ  - The IRQ# used by Serial port used for the console.
        Normally 4 for COM1 and COM3, 3 for COM2 and COM4.

        Input variables are normally defined in minibios.inc, no checking is
        done on the validity of any input variables.
&
_console_init   proc    near
        mov     di,Con_Port
        call    flush_com_port
; initialize the serial port
        lea     dx,[di+LINECONTROL]
        mov     al,128
        out     dx,al           ;set high bit, so we can set baud
        lea     dx,[di+BAUDLOW]
.386
;calculating constant below requires 386 directive even though answer is < 64K!
        mov     ax,Console_Baud_Divisor         ;Divisor for UART
.8086
        out     dx,al                           ;set the low byte of divisor
        mov     al,ah                           ;high byte of divisor
        inc     dx                              ;adjust to BAUDHIGH
        out     dx,al
        lea     dx,[di+LINECONTROL]
        mov     al,Console_parms                ;stop/data/parity bits
        out     dx,al
;set the interrupt vector to point to _comm_rec_char_int
        mov     bx,(Console_IRQ+8)*4
        xor     ax,ax
        mov     es,ax
        cli
        mov word ptr es:[bx],offset _comm_rec_char_int
        mov     es:[bx+2],cs
        sti

        mov     dx,MASKPORT
        in      al,dx                   ;get the current mask
        mov     cl,Console_IRQ
        mov     bl,1
        shl     bl,cl
        not     bl
        and     al,bl                   ;clear the desired mask bit in al
        mov     dx,MASKPORT             ;enable interrupt mask
        out     dx,al
        mov     di,Con_Port
        lea     dx,[di+MODEMCONTROL]
        mov     al,0bh          ;enable interrupts (bit3), and pins high
        out     dx,al
        lea     dx,[di+INTENABLE]
        mov     al,1
        out     dx,al           ;enable receive interrupt
        lea     dx,[di+INTID]
        in      al,dx           ;read the interrupt port to clear bits
        call    flush_com_port
;console com port has now been initialized
        ret
_console_init   endp

flush_loop:
        lea     dx,[di+DATAREG]         ;throw away pending data on open
        in      al,dx
flush_com_port: ;flushes com port specified by address in di
        lea     dx,[di+LINESTATUS]
        in      al,dx
        test    al,3
        jnz     flush_loop              ;loop if data waiting
        ret

;console com port interrupt handler
_comm_rec_char_int:
        push    ax
        push    bx
        push    cx
        push    dx
        push    es
        push    ds
        mov     ax,DGROUP
        mov     ds,ax
        mov     dx,Con_Port
        in      al,dx
;put data in buffer and check for overflow in buffer
        xor             ah,ah           ;no scan code available
        call    near ptr _Int16PutChar  ;returns CF = 1 if buffer is full
        jnc     no_error
;there was an error, sound the bell
        mov     ax, 0E07H               ; Ring the Bell
        call    _Int10PutChar
no_error:
        mov     al,20h
        out     EOIPORT,al      ;send an end-of-interrupt to the 8259
        int     9       ;inform Power.exe there was keyboard input
        pop     ds
        pop     es
        pop     dx
        pop     cx
        pop     bx
        pop     ax
        iret

;
;    void console_putchar(char c)
;
_console_putchar        proc    near
        push    bp
        mov     bp,sp
L1:
        mov     dx,Con_Port
        add     dx,LINESTATUS
        in      al,dx
        test    al,20h
        jz      short L1                ;loop until trans buffer is empty
        mov     dx,Con_Port
        mov     al,byte ptr [bp+4]      ;data byte passed top putchar
        out     dx,al                   ;send data to 8250
        pop     bp
        ret
_console_putchar        endp
_TEXT   ends
        end

