;
;   $Id: INT08.ASM 1.4 2002/10/15 23:49:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
;  INT08.ASM
;
;  Copyright (c) 1994-2002 Datalight, Inc.
;  All Rights Reserved
;  Datalight Confidential and Proprietary
;

;       scalars
msw_24hr        equ     0018h
lsw_24hr        equ     00B0h

_TEXT Segment byte public 'CODE'

        assume cs:_TEXT, ds:_DATA
extrn int8_eoi:near

;
; Interrupt Service Routine
;
public _INT08_isr
_INT08_isr:
; -----------------------------------------------------------
;           BIOS Hardware Services
;

; ------------------------------------------------------------
; ***       TIME-OF-DAY COUNTER [service for IRQ 0]        ***
; ------------------------------------------------------------

;       *** increment time-of-day, & test for overflow ***
;TICK_update:
        push    ax
        push    cx
        push    ds
        mov     ax, Seg _DATA
        mov     ds,ax
        inc     TICK_low                 ; inc lsw
        jnz     ov_check                ; update done, check for wrap
        inc     TICK_hi                  ; inc msw
ov_check:
        mov     cx,TICK_hi
        cmp     cx,msw_24hr             ; check for 24 hour timeout
        jl      ud_ok
        jg      ovfl                    ; precaution in case bad caller-init val
        mov     cx,TICK_low
        cmp     cx,lsw_24hr
        jng     ud_ok
ovfl:   call    zero_TICK               ; reset counter
        inc     TICK_ovflow             ; set 24 hr wrap flag
ud_ok:

        inc     bios_timer      ; general purpose timer variable
        int     1Ch             ; do user timer interrupt
        call    int8_eoi        ; send eoi to int ctlr
        sti                     ; allow interrupts early
        pop     ds
        pop     cx
        pop     ax

        IRET

; --------------------------------------------------------
; >>>            clear time-of-day counter             <<<
; --------------------------------------------------------
; assumes that ds already points to bios data area

zero_TICK:
        xor     ax,ax                   ; zero counter
        mov     TICK_low,ax
        mov     TICK_hi,ax
        ret


_TEXT Ends

_DATA Segment word  public 'DATA'
        extrn _bios_ticks:dword, TICK_low:word, TICK_hi:word, TICK_ovflow:byte, reset_flag:word
        extrn bios_timer:word
_DATA Ends

        End

