;
;   $Id: INT14.ASM 1.4 2002/10/15 23:49:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
;  INT14.ASM
;
;  Copyright (c) 1994-2002 Datalight, Inc.
;  All Rights Reserved
;  Datalight Confidential and Proprietary
;
include minibios.inc

_DATA   segment para public 'DATA'
extrn _com_bases:word,com_time_out:byte,equip_list:word,bios_timer:word
_DATA   ends

;_TEXT Segment byte public 'CODE'
_TEXT Segment para public 'CODE'

        assume cs:_TEXT, ds:_DATA

;
; Interrupt Initialization routine
;
        public _Int14_Init
_Int14_Init:
        push    ds
        mov     ax,_DATA
        mov     ds,ax
; Check for presence of com ports.  We will check the list at 40:00, any
; nonzero port addresses will be checked.  If nothing responds the address will
; be set to zero to indicate no port available.
        xor     si,si
;ds:si points to com port base addresses in bios data area
        mov     bx,4            ;bx is max number of com ports
        cld
loop_addr:
        lodsw                   ;load com port address
;if the address = 0, we are to ignore the port, this is usually because it is
;used as the console.
        or      ax,ax           ;check if address = 0
        mov     dx,ax
        jz short no_port
;the address was not zero, check to see if a com port exists there
        mov     al,3
        add     dl,al           ;point to data format register
        out     dx,al           ;select 8 data bits
        jmp     $+2
        in      al,dx
        cmp     al,3
        je short check_done     ;jmp if com port exists
;The com port does not respond properly, zero that address in the bios data area
        xor     ax,ax
        mov     ds:[si-2],ax
no_port:
        dec     bx              ;decrement number of ports
check_done:
        cmp     si,8
        jb      loop_addr       ;loop four times
;bx now contains the number of COM ports, we must initialize bits 9 - 11 in
;equip_list with the calculated number.  Those bits should be zero right now.
        mov     cl,9
        shl     bx,cl
        or      ds:equip_list,bx

        pop     ds
        ret                     ; Done with initialization


; Interrupt Service Routine
; Provides support for the following BIOS calls:
; ah = 0, initialize com port
; ah = 1, write to com port
; ah = 2, read from com port
; ah = 3, get port status
; in all cases a port number specified as 0 = com1, 1 = com2 etc.

public _INT14_isr
_INT14_isr:
        push    bx
        push    cx
        push    dx
        push    bp
        push    ds
        mov     bx,_DATA
        mov     ds,bx
        mov     bx,dx                   ;com number, 0 = com1 etc
        mov     cl,ds:com_time_out[bx]
;cl contains time out in seconds.
        shl     bx,1                    ;adjust for addressing words
        mov     dx,ds:_com_bases[bx]    ;get base address of com port
        or      dx,dx                   ;check if com port available
        mov     bx,ax                   ;save original ax
        jz short int14_ret2             ;jmp if invalid com port
        mov     al,18                   ;timer ticks/second
        mul     cl
        mov     bp,ax           ;number of ticks for time out in bp
        add     dx,4            ;point to modem control register
        sti                     ;enable interrupts since it may take a long time
        cmp     bh,1
        jne short bh_not_1
;write the character in bl to the com port specified in dx
;the 30h in ah below indicates DSR and CTS in the status register must = 1
;the 3h in al will set the RST and DTR bits
        mov     ax,3003h
        out     dx,al
        add     dl,2            ;point to modem status register
        call    time_out_chk    ;see if UART is responding in appropriate time
;no return if time out.
        dec     dx              ;point to serialization status register
        mov     ah,20h          ;check if Transmitter buffer is empty
        call    time_out_chk
;no return if time out, returns status in ah if okay.
        sub     dl,5            ;point to transmitter hold register
        mov     al,bl           ;character to send
        out     dx,al           ;send the character
int14_ret2:
        jmp     int14_ret

bh_not_1:
        cmp     bh,2
        jne short bh_not_2
; Read a character from the com port specified in dx
        mov     ax,2001h
;the 1 in al will enable the DTR bit
;the 20h in ah indicates time_out_chk must test the DDSR bit
        out     dx,al           ;enable DTR bit
        add     dl,2            ;point to modem status register
        call    time_out_chk
        dec     dx              ;point to serialization status register
        mov     ah,1            ;check if received data ready
        call    time_out_chk    ;no return if no data ready
;returns ah = status if data is ready
        sub     dl,5            ;point to Receiver Buffer Register
        in      al,dx           ;read the input data
        and     ah,1eh          ;mask don't care bits in returned status
        jmp     int14_ret

bh_not_2:
        or      bh,bh
        jnz short bh_not_0
comment &
        initialize the com port specified in dx with parameters in bl
        bits 5 - 7  indicates baud rate:
                0 = 110
                1 = 150
                2 = 300
                3 = 600
                4 = 1200
                5 = 2400
                6 = 4800
                7 = 9600

        bits 3-4 indicate parity
                0 = none
                1 = odd
                2 = none
                3 = even
        bit 2 indicates stop bits
                0 = 1 stop bit
                1 = 2 stop bits

        bits 0 - 1 indicate data bits
                0 = 5 bits
                1 = 6 bits
                2 = 7 bits
                3 = 8 bits
&
        sub     dl,3            ;point to interrupt enable register
        xor     ax,ax
        out     dx,al           ;disable all interrupts
        add     dl,2            ;point to data format register
        mov     ch,bl           ;get parameters
        mov     cl,1fh          ;mask to strip off baud bits
        test    ch,8            ;check bit 3
        jnz short parity        ;jmp if even or odd parity
;parity indicated is none
        mov     cl,07h          ;mask to strip off baud and parity bits
parity: and     ch,cl
        mov     al,ch
        or      al,80h          ;set DLAB
        out     dx,al           ;prepare to set baud divisor
        mov     al,bl           ;get parameters
        mov     cl,5
        shr     al,cl           ;get baud parameter in lsbs
        jz short baud_110
        mov     cl,al                           ;baud parameter
.386
;calculating constant below requires 386 directive even though answer is < 64K!
        mov     ax,COM_PORT_DIVIDEND/75         ;get divisor for 75 baud
.8086
        shr     ax,cl                           ;calculate desired divisor in ax
set_baud:
        sub     dl,3                            ;point to low byte of divisor
        out     dx,al
        inc     dl                              ;point to high byte of divisor
        mov     al,ah
        jmp     $+2
        out     dx,al
;baud divisor is now set
        add     dl,2                            ;point to data format register
        mov     al,ch
        jmp     $+2
        out     dx,al                           ;disable DLAB
        inc     dx
        jmp short get_status

baud_110:
.386
;calculating constant below requires 386 directive even though answer is < 64K!
        mov     ax,COM_PORT_DIVIDEND/110        ;get divisor for 110 baud
.8086
        jmp     set_baud

bh_not_0:
        cmp     bh,3
        jne short int14_ret
; return ah = serialization status, al = modem status
get_status:
        inc     dx
        in      al,dx                   ;get serialization status
        mov     ah,al
        inc     dx
        in      al,dx                   ;get modem status
        jmp     int14_ret

int14_ret:
        pop     ds
        pop     bp
        pop     dx
        pop     cx
        pop     bx
        iret

time_out_chk:   ;call with bx = original ax
                ;dx = status port to check
                ;ah = mask to use in checking status port
                ;bp = number of timer ticks for a time out
                ;returns status in ah if no time out, returns to
                ;application if time out.
        xor     cx,cx
        mov     bios_timer,cx
chk_loop:
        in      al,dx
        mov     cl,al                   ;save status
        xor     al,ah                   ;toggle tested bits
        test    al,ah                   ;check if tested bits were set
        jz short time_out_ret           ;jmp if all tested bits were set
        cmp     bp,bios_timer
        jae     chk_loop                ;loop until time out
;we have timed out, return to the application
        mov     ax,bx                   ;restore original ax
        or      ah,80h                  ;set bit 7 to indicate error
        pop     bx                      ;discard time_out_chk return address
        jmp     int14_ret

time_out_ret:   ;success!, return status in ah
        mov     ah,cl
        ret

_TEXT Ends
end
