;
;   $Id: INT19.ASM 1.4 2002/10/15 23:49:14Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
;  INT19.ASM
;
;  Copyright (c) 1994-2002 Datalight, Inc.
;  All Rights Reserved
;  Datalight Confidential and Proprietary
;
;  INT 19 - Boot BIOS Interrupt
;



_TEXT Segment byte public 'CODE'

	assume cs:_TEXT

LOAD_SEG	equ	0
LOAD_OFFSET	equ	07C00H
BIOS_DISK	equ	13H

;
; Interrupt Service Routine
;
	public _INT19_isr
_INT19_isr:
	mov	dl, 0		; Try Booting from a Floppy Disk
	call	TryDiskBoot
	mov	dl, 80H		; Try Booting from Hard Disk
	call	TryDiskBoot
	int	18H		; Boot Failure

Done:	pop	ds
	iret

;
; TryDiskBoot
; Attempts to load the boot sector into the boot location (0:7C00) and
; if successful, then it jmps to it, otherwise it returns!
;
TryDiskBoot:
	push	ds
	push	ax
	mov	bx, LOAD_SEG
	mov	es, bx

	mov	ax, 0201H	; Read 1 Sector
	mov	bx, LOAD_OFFSET	; Address = 0:7C00H  LOAD_SEG:LOAD_OFFSET
	mov	cx, 1		; Track 0 Sector 1
	mov	dh, 0		; Head 0, Drive Passed from INT-19_isr
	INT	BIOS_DISK
	jc	BootFailure
	db	0EAH		; Far Jump
	dw	LOAD_OFFSET, LOAD_SEG
BootFailure:
	pop	ax
	pop	ds
	ret

_TEXT Ends


	End

