//
//   $Id: PRINT.H 1.4 2002/10/15 23:53:04Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
	Print Header file

	Copyright (c) 1989-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

*/

#define DEBUG FALSE 			/* Include DEBUGGING Code */

#define TRUE !FALSE
#define FALSE 0

#define BUF_SIZE	512
#define MIN_BUF_SIZE 256
#define MAX_BUF_SIZE ((unsigned)32*1024)
#define CARRY		1
#define NAMESIZE	66
#define MAX_FILE	10
#define MINFILES	2
#define MAXFILES	32

#define WRITE_SIZE (8)			/* # of bytes written at each spooler call */
#define FUDGE_FACTOR (0x100)	/* # of para for PRINT  as a TSR */

#define INT_1C	0x1C			/* Timer Interrupt */
#define INT_28	0x28			/* Idle Interrupt */
#define INT_2F	0x2F			/* Interface Interrupt */

struct prdata
{
		/* on_hold MUST BE FIRST in STRUCT */
		unsigned on_hold;			/* TRUE if printing on hold */

		char     device[9];		/* Device Name */
		unsigned max_files;		/* Number of files */
		unsigned infile;			/* Handle of file to read */
		unsigned outfile;			/* Handle of file to write */
		unsigned count;			/* Bytes output from buffer */
		unsigned total;			/* Total # of bytes in buffer */
		unsigned long offset;	/* Offset into the file  */
		unsigned buffer_size;	/* Size of buffer allocated */
		unsigned print_errors;	/* Number of write failures */
		char * buffer;				/* Point just past files */
		char files[MAXFILES][NAMESIZE];	/* Actual # set by install_print */
};

struct sub_packet
{
	char priority;
	char far *file;
};

extern struct prdata *pr;

void far * get_vector(unsigned);
set_vector(unsigned int_numb, void far *func);

/*
 * Print Errors from int 2F
 */
#define INVALID		0x1
#define NOT_FOUND	0x2
#define PATH_NOTFOUND	0x3
#define OPEN_FAIL	0x4
#define ACCESS		0x5
#define QUEUE_FULL	0x8
#define NAME_TO_LONG	0xC
#define DRIVE_INVALID	0xF
