;
;   $Id: PRINTA.ASM 1.4 2002/10/15 23:53:04Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;*********************************************************
;
;   PRINTA.ASM
;
;   Copyright (c) 1989-2002 Datalight, Inc.
;   All Rights Reserved.
;   Datalight Confidential and Proprietary
;
;   This file contains the low-level print spooler
;   routines.
;
;*********************************************************
include macros.inc

cBegData
	extrn _pr:word
	extrn _buffer_size:word

	c_public overflow
_overflow	dw	055AAH
		dw	400 dup (0)		; Stack area for
pr_STACK	dw	0

cEndData

cBegCode

	public	_PR_DS
_PR_DS	DW	0

COMMENT ~ ; prototype ;
void set_code_ds(void)
{}
~
c_func	set_code_ds
	mov	CS:_PR_DS, DS
	ret
c_endp	set_code_ds

VECT28	EQU	4*98H		; Idle interrupt handler
VECT2F	EQU	4*99H		; Multiplex inerrupt

	c_extrn int2f,near, spooler,near, print_errors,near

	c_public crit_err, in_DOS_ptr

SS_REG		DW	?
SP_REG		DW	?
old_psp		DW	?
_crit_err	DW	0	; True when print_crit_err is executed
_in_DOS_ptr	DD	0	; Pointer to IN DOS

	public	_next1c, _next28, _next2f
_next1c 	dd 	?
_next28		dd	?
_next2f		dd	?

IF 0
	c_public pr
_pr:	dw	dat		; Address of area for PRINT data
ENDIF


;
;   Timer Tic handler.
;
;   Fake an interrupt to REAL timer interrupt! then
;   Check if IN-DOS is true;
;   If !IN_DOS then If PRINT !on_hold then do spooler
;
c_func	int_1c

	; Fake interrupt to original INT 1CH handler
	pushf
	call	dword ptr CS:[_next1c]

	; save registers so we can use 'em
	push	BX
	push	ES

	; If already in DOS, don't spool
	les	BX, CS:in_DOS_ptr
	cmp	byte ptr ES:[BX], 0
	jnz	_1c_1

	call	do_spool

_1c_1:	pop	ES
	pop	BX
	iret
c_endp	int_1c


c_func	init_int2f

	; we only handle function 01H calls
	cmp	AH, 01
	jnz	_int2f_2
	jmp	_int2f		; our interrupt handler never returns
_int2f_2:
	jmp	dword ptr CS:[_next2f]
c_endp	init_int2f


;  DOS has generated an INT 28H, we KNOW it's OK to attempt spool
;
c_func	init_int28
	CALL	do_spool

	; Jump Far to next int 28 handler
	jmp	dword ptr CS:[_next28]
c_endp	init_int28


;
;   Set up for the print spooler.
;
	public	do_spool
do_spool PROC NEAR
	push	DS	; save working registers
	push	BX

	cli
	mov	DS, WORD PTR CS:_PR_DS
	mov	BX, WORD PTR _pr	; Check if PRINT on_hold
	cmp	byte ptr [BX], 0
	jnz	dont_spool

	; Set on hold
	mov	WORD ptr [BX], 1

	mov	WORD ptr CS:SS_REG, SS	; Save Stack ptr
	mov	WORD ptr CS:SP_REG, SP

	; get internal stack
	mov	BX, GOFFSET pr_STACK
	push	DS
	pop	SS
	mov	SP, BX
	sti

	push	ES	; save all the rest of the registers
	push	AX
	push	CX
	push	DX

	; switch to our PSP
	mov	AH, 51H
	int	21H
	mov	CS:old_psp, BX
	mov	AH, 50H
	mov	BX, CS
	int	21H

	call 	_spooler			; DO C routine!

	; switch back to old PSP
	mov	AH, 50H
	mov	BX, CS:old_psp
	int	21H

	pop	DX
	pop	CX
	pop	AX
	pop	ES

	; retrieve old stack
	cli
	mov	SS, WORD ptr CS:SS_REG
	mov	SP, WORD ptr CS:SP_REG

	mov	BX, WORD ptr _pr
	mov	WORD ptr [BX], 0		; on_hold = FALSE

dont_spool:
	sti

	pop	BX	; get back registers
	pop	DS
	ret
do_spool ENDP


; get CODE segment
;
COMMENT ~ ; prototype ;
int getCS( void )
{}
~
	c_public getCS
c_func	getCS
	mov	AX, CS
	ret
c_endp	getCS

; get DGROUP segment
;
COMMENT ~ ; prototype ;
int getDS( void )
{}
~
	c_public getDS
c_func	getDS
	mov	AX, DS
	ret
c_endp	getDS

COMMENT ~ ; prototype ;
void far * print_hold( void )
{}
~
c_func	print_hold
	push	BP
	mov	BP, SP
	push	DS
	mov	AX, 0104H
	int	2FH
	mov	BX, DX
	mov	DX, DS
	mov	AX, SI
	pop	DS
	mov	WORD ptr _print_errors, BX
	pop	BP
	ret
c_endp	print_hold



;
;	set_vector(int_no, handler)
;
	c_public set_vector
c_func	set_vector
	push	BP
	mov	BP, SP
	push	DS
	mov	AH, 25H
	mov	AL, BP[4]
	mov	DX, BP[6]
	mov	DS, BP[8]
	int	21h
	pop	DS
	pop	BP
	ret
c_endp	set_vector

;
;	get_vector(int_no)
;
	c_public get_vector
c_func	get_vector
	push	BP
	mov	BP, SP
	push	ES
	mov	AH, 35H
	mov	AL, BP[4]
	push	CS
	pop	ES
	int	21h
	mov	DX, ES
	mov	AX, BX
	pop	ES
	pop	BP
	ret
c_endp	get_vector


;
;   void get_indos(void)
;
;   Set the far pointer to the "in DOS" flag
;
COMMENT ~ ; prototype ;
void get_indos( void )
{}
~
c_func	get_indos
	push	BP
	push	ES
	mov	AH, 34H		; get far ptr to inDOS
	int	21H
	mov	word ptr CS:in_DOS_ptr+2, ES
	mov	word ptr CS:in_DOS_ptr, BX
	pop	ES
	pop	BP
	ret
c_endp	get_indos

;
;	print_crit_err
;
;	This Critical error handler is installed before a write to the
;	printer.
;
c_func	print_crit_err
	push	DS
	push	CS
	pop	DS
	mov	AL, 3		; Act as if a 'F' entered at
				; Abort Retry Ignore Fail Prompt
	mov	_crit_err, AX	; Flag got a crit Err
	pop	DS
	iret
c_endp	print_crit_err

c_func	terminate_and_stay_res

	mov	DX, offset _TEXT:_last_byte
	add	DX, _buffer_size
	shr	DX, 1
	shr	DX, 1
	shr	DX, 1
	shr	DX, 1

	add	DX, 20H		; enough room for the PSP plus extra

	mov	AX, 3100H
	int	21H

c_endp	terminate_and_stay_res

cEndCode

;  Define the  end of memory - this is where
;  the print buffer will go.
;
	DGROUP GROUP END_TSR
	public	_last_byte

END_TSR	SEGMENT PARA PUBLIC	'BSS'
	; note: the print buffer goes here
	_last_byte	db	200 dup (?)
END_TSR	ENDS

	END
