//
//   $Id: PRMAIN.C 1.7 2002/10/15 23:53:04Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*********************************************************

	PRMAIN.C  created 2/2/91  by Roy Sherrill

   Copyright (c) 1989-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

	BUGS
	1) PRINT Does not use the Interrupt 1C timer tick!

	01-07-2001  pb  Moved the signon to be the first thing
	                displayed on the screen.
	3-1-92 Fixed by Roy Sherrill
	1) PRINT /h Asks for [PRN] device with out giving help!
	2) PRINT cannot handle *.C
	3) "PRINT /C abc" does not cancel the file abc

**********************************************************/

#include <stdio.h>
#include <dos.h>
#include <dir.h>
#include <stdlib.h>
#include <ctype.h>
#include <io.h>

#include "dosver.h"
#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "dldosio.h"
#include "fatworld.h"
#include "abortlfn.h"

#define PRINT 1
#include "dosmsg.c"

#include "print.h"
#include "print.pt"
dos_open(char *name, unsigned mode);

char signon[] = "\nPRINT %s %s\n%s\n\n";


int submit = TRUE;
int first_time = FALSE;
int max_files = MAX_FILE;

union REGS regs;				/* For test only */

int doing_install = FALSE;
unsigned buffer_size = BUF_SIZE;

unsigned extra_size;				/* buffer_size+filename space */

char device[25] = {"PRN"};

char name[NAMESIZE];

int print_errors = 0;

int Quiet = FALSE;			/* Print the Version and Copyright msg */

struct prdata far * far_pr;

bool fIsFat32World;

/* PROTO  Version 1.00 */

/* File PRMAIN.C */
int main(int argc, char *argv[]);
void error(char *msg, ...);
void do_help(void);
int installed(void);
void submit_file(char *file);
void cancel(char *file);
void install_print(void);
void terminate_and_stay_res(void);
void get_device(void);
void cancel_all(void);
void release_hold(void);
void get_resident_pr(void);
void status(void);


void DisplaySignOnMessage( void )
{
	if( fIsFat32World )
	{
		printf(signon,SHORTVERSION,BUILDVERSION,COPYRIGHT);
	}
	else
	{
		printf(signon,SHORTVERSION622,BUILDVERSION,COPYRIGHT);
	}
}

int main(int argc, char *argv[])
{
	int i, j, tmp;
	char far *fp, *p;
	extern int no_data;
	extern void dummy();
	extern void far * print_hold();
	FIND Find;
	bool fSuccessful;


	//  Determine if we are operating in a DOS 7.1 enviornment
	//
	fIsFat32World = dlIsFat32World();

	//  Abort if there are LFNs on the command line
	//
	AbortForLFNArgs();

	/* are we asking for help? */
	for(i=1; i<argc; ++i)
	{
		if(*argv[i] == '?' || (*argv[i] == '/' &&
			(argv[i][1]=='?' || toupper(argv[i][1]) == 'H')))
		{
			do_help();
			return 1;
		}
	}

	set_code_ds();

	/* Process arguments */
	for(i=1; i<argc; ++i)
	{
		/* Submitting a file */
		if(*argv[i] != '/')
		{
			dlSetDTA( &Find );
			fSuccessful = dlFindFirstFile( A_HIDDEN | A_SYSTEM, argv[i] );
			if( fSuccessful )
			{
				while( fSuccessful )
				{
					if(submit)
					{
						submit_file(Find.name);
					}
					else
					{
						cancel(Find.name);
					}
					dlSetDTA( &Find );
					fSuccessful = dlFindNextFile();
				}
			}
			else
			{
				printf( szNoFilesFound, argv[i] );
			}
		}
		else
		{
			switch(toupper(argv[i][1]))
			{
				case 'B':		/* Buffer Size */
					if(!first_time)
					{
						error(first_time_str,'B');
						do_help();
						exit(1);
					}
					tmp=2;
					if(argv[i][2] == ':')
						++tmp;
					buffer_size=atoi(argv[i]+tmp);
					if(buffer_size < MIN_BUF_SIZE)
						buffer_size = MIN_BUF_SIZE;
					if(buffer_size > MAX_BUF_SIZE)
						buffer_size = MAX_BUF_SIZE;
					break;

				case 'C':		/* Cancel Mode */
					submit = FALSE;
					break;

				case 'F':		/* # of Files Size */
					if(!first_time)
					{
						error(first_time_str,'F');
						do_help();
						exit(1);
					}
					tmp=2;
					if(argv[i][2] == ':')
						++tmp;
					max_files=atoi(argv[i]+tmp);
					if(max_files < MINFILES)
						max_files = MINFILES;
					if(max_files > MAXFILES)
						max_files = MAXFILES;
					break;

				case 'H':		/* Help */
					do_help();
					exit(1);

				case 'P':		/* PRINT mode */
					submit = TRUE;
					break;

#if DEBUG
				case 'S':
					status();
					break;
#endif

				case 'T':		/* Cancel all files */
					cancel_all();
					break;

				case '[':		/* Don't print copyright and version */
					Quiet = TRUE;
					break;

				default:
					printf(bad_opt, argv[i]);
					exit(1);
			}
		}
	}

	if(!Quiet)
	{
		DisplaySignOnMessage();
	}

	if(!installed())
	{
		first_time = TRUE;
		get_device();
		install_print();
		printf(installed_str);
	}

#if INT_28 != 0x28
	for(i=0; i<1000; ++i)
	{
		asm	push	bx
		asm	push	si
		asm	push	di
		asm	push	ds
		asm	int	28h
		asm	pop	ds
		asm	pop	di
		asm	pop	si
		asm	pop	bx
	}
#endif

	fp = print_hold();
	if(print_errors)
		printf(offline_str);
	if(*fp == '\0')
		printf(queue_empty_str);
	else
	{
		p = printed_str;

		for(j=0; j <max_files && *fp; ++j)
		{
			for(i=0; i < NAMESIZE; ++i)
				name[i] = fp[i];
			printf("    %s %s\n", name, p);
			fp += NAMESIZE;
			p = in_queue_str;
		}
	}

	/* allow printing to occur */
	release_hold();

#if 0
	/* test print */
	geninterrupt(INT_1C);
#endif

	/* install the TSR part of print */
	if(doing_install)
		terminate_and_stay_res();

	/* Else normal exit */
	return(0);
}

void error(char *msg, ...)
{
	unsigned *p, a1, a2, a3;
	p = (unsigned *) &msg;
	a1 = p[1];
	a2 = p[2];
	a3 = p[3];

	printf(fatal_str);
	printf(msg, a1, a2, a3);
}

void do_help(void)
{
	DisplaySignOnMessage();
	printf(USAGE);
}

/*
	Install returns TRUE if it is installed
	or a FALSE if print is not installed.
*/
int installed(void)
{
	unsigned uValue;


	/* Install Check */
	asm	push	bx
	asm	push	si
	asm	push	di
	asm	push	ds
	asm	mov	ax, 0100h
	asm	int	2fh
	asm	pop	ds
	asm	pop	di
	asm	pop	si
	asm	pop	bx
	asm	mov	uValue, ax

	return ((uchar)uValue == 0xFF);
}



/*
 * Submit a file to be printed
 */
void submit_file(char *file)
{
	char abs[NAMESIZE];
	struct sub_packet s;
	struct sub_packet * ps;
	FIND ff_blk;
	bool fSuccessful;


	path_rel_to_abs(file, abs);
	dlSetDTA( &ff_blk );
	fSuccessful = dlFindFirstFile( A_SYSTEM | A_HIDDEN, abs );
	if( !fSuccessful )
	{
		printf(cant_open_str, file);
	}
	else
	{
		while( fSuccessful )
		{
			del_path(abs);
			add_path(abs, ff_blk.name);

			s.priority = 1;
			s.file = MK_FP(getDS(), abs);

			//  Submit a file
			//
			ps = &s;
			asm	push	bx
			asm	push	si
			asm	push	di
			asm	push	ds
			asm	mov	ax, 0101h
			asm	mov	dx, ps
			asm	int	2fh
			asm	pop	ds
			asm	pop	di
			asm	pop	si
			asm	pop	bx

			fSuccessful = dlFindNextFile();
		}
	}
}

/*
 * Cancel a file for printing
 */
void cancel(char *file)
{
	char abs[NAMESIZE];
	union REGS regs;
	path_rel_to_abs(file, abs);

	//  Cancel a file for printing
	//
	asm	push	bx
	asm	push	si
	asm	push	di
	asm	push	ds
	asm	mov	ax, 0102h
	asm	mov	dx, word ptr abs
	asm	int	2fh
	asm	pop	ds
	asm	pop	di
	asm	pop	si
	asm	pop	bx
}


/*
 *	Install the print interrupt 28H and interrupt 2FH handlers.
 */
void install_print(void)
{
	extern void far *next28, far *next2f, far *next1c;
	extern void init_int28(), init_int2f(), int_1c();
	extern char last_byte;

	int i;

	strcpy(pr->device, device);
	pr->print_errors = 0;
	pr->offset  = 0;
	pr->infile  = 0;
	pr->outfile = 0;
	pr->total = 0;
	pr->count = 0;
	pr->max_files = max_files;
	pr->buffer = &last_byte;
	pr->buffer_size = buffer_size;
	pr->on_hold = TRUE;

	for(i=0; i<pr->max_files; ++i)
		pr->files[i][0] = '\0';

	get_indos();

	doing_install = TRUE;

	next28 = get_vector(INT_28);
	next2f = get_vector(INT_2F);

#if 0
	next1c = get_vector(INT_1C);
	set_vector(INT_1C, MK_FP(getCS(), int_1c));
#endif
	set_vector(INT_28, MK_FP(getCS(), init_int28));
	set_vector(INT_2F, MK_FP(getCS(), init_int2f));

}

void get_device(void)
{
	char string[40];
	int fd;
	bool fSuccessful;
	unsigned uDevAttributes;


	string[0] = 8;
	printf(get_devname_str, device);
	dlGetLine( string );
	string[string[1]+2] = '\0';
	printf("\n");

	if(string[1] > 1)
	{
		fd = dos_open(string+2, 0);
		fSuccessful = dlGetDeviceAttributes( fd, &uDevAttributes );
		if( (!fSuccessful) || (!(uDevAttributes | DEVA_CHAR)) )
		{
			printf(not_device_str);
			exit(1);
		}
		dlCloseFile(fd);
	}
	strncpy(device, &string[2], string[1]);
}

void cancel_all(void)
{
	/* Cancel ALL FILES */
	asm	push	bx
	asm	push	si
	asm	push	di
	asm	push	ds
	asm	mov	ax, 0103h
	asm	int	2fh
	asm	pop	ds
	asm	pop	di
	asm	pop	si
	asm	pop	bx
}


void release_hold(void)
{
	/* Release Hold */
	asm	push	bx
	asm	push	si
	asm	push	di
	asm	push	ds
	asm	mov	ax, 0105h
	asm	int	2fh
	asm	pop	ds
	asm	pop	di
	asm	pop	si
	asm	pop	bx
}

#if DEBUG

void get_resident_pr(void)
{
	struct data far *p;

	/* Get Status from Resident */
	asm	push	bx
	asm	push	si
	asm	push	di
	asm	push	ds
	asm	mov	ax, 0106h
	asm	int	2fh
	asm	pop	ds
	asm	pop	di
	asm	pop	si
	asm	pop	bx
	asm	mov	word ptr far_pr, dx
	asm	mov	word ptr far_pr+2, ax

	printf("regs.ax = %04x bx = %04x\n", regs.x.ax, regs.x.bx);
}

void status(void)
{
	int i;
	struct data far *pr;
	char far *fp;
	get_resident_pr();
	pr = far_pr;
	printf("\nPRINT: Status is as follows\n");
	printf("pr at %04X:%04X\n", FP_SEG(pr), FP_OFF(pr));
	printf("\tbuffer = %04X:%04X\n", FP_SEG(pr), pr->buffer);
	printf("\tfiles  = %04X:%04X\n", FP_SEG(pr), pr->files);
	printf("\tcount = %u\n", pr->count);
	printf("\ttotal = %u\n", pr->total);
	printf("\toffset = %lu\n", pr->offset);
	printf("\tmax_files = %u \n\tbuf_size = %u\n", pr->max_files, pr->buffer_size);
	printf("\tPrint Errors = %u\n", pr->print_errors);
	for(i=0; i < MAX_FILE; ++i)
	{
		if(pr->files[i][0])
		{
			printf("\tFile(%u) = '", i);
			fp = pr->files[i];
			while(*fp)
				printf("%c", *fp++);
			printf("\n");
		}
	}
}
#endif
