//
//   $Id: SHARE.H 1.4 2002/10/15 23:56:38Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*********************************************************

	SHARE.H  created 3/94  by Drew Gislason

	Copyright (c) 1994-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

	Share uses this, so do SHARE tests.

**********************************************************/

// error codes
#define ERR_DENIED		5
#define ERR_BADHANDLE 	6			/* invalid handle */
#define ERR_SHARE			0x20		/* sharing violation */
#define ERR_LOCKED		0x21		/* portion of file is locked */
#define ERR_NOLOCKS		0x24		/* all locks used */

// file open modes
#define O_RDONLY		0x00
#define O_WRONLY		0x01
#define O_RDWR			0x02

// SHARE open modes
#define O_DENYOPEN	0x10	// deny others from opening at all
#define O_DENYWRITE	0x20	// deny others from opening for write
#define O_DENYREAD	0x30	// deny others from opening for read
#define O_DENYNONE	0x40	// deny none compatibility mode
#define O_DENYMASK	0x70	// used to strip off all deny bits

// ioctl bits
#define IO_NETWORK		0x8000
#define IO_SETDATE		0x4000
#define IO_DEVICE			0x80
#define IO_NOTEOF			0x40
#define IO_NOTWRITTEN	0x40
#define IO_RAW				0x20
#define IO_FAST			0x10
#define IO_NUL				0x08
#define IO_CLK				0x04
#define IO_CON				0x03

// the # of locks is fixed at SHARE install-time
#define DEFLOCKS		 20
#define MINLOCKS		  4
#define MAXLOCKS		100

// user passes a region
typedef struct
{
	int handle;
	unsigned long start;
	unsigned long length;
} Region;

#if SHARE

#define NULLF		((void *)0xFFFF)
#define MK_FP(seg,off) \
	((void far *)(((unsigned long)(seg)<<16) | (unsigned)(off)))
#define FP_SEG(farptr)	((unsigned)((unsigned long)(farptr) >> 16))
#define FP_OFF(farptr)	((unsigned)(farptr))

// Return this value from main to terminate as a TSR
#define TERM_TSR		0x4000

typedef struct
{
	unsigned owner;			// 0
	unsigned reserved;		// 2  this is here to make dumps more readable
	LPSFT 	sft;				// 4
	unsigned long start;		// 8
	unsigned long length;	// C
} ShareLock;

#endif
