;
;   $Id: SHAREA.ASM 1.4 2002/10/15 23:56:38Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
COMMENT ~
/*********************************************************

   SHAREA.ASM  created 3/94  by Drew Gislason

   Copyright (c) 1994-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary.

   The portions of SHARE.EXE that couldn't be written
   in C are supplied here.

**********************************************************/ ~
include macros.inc

MCOOKIE	equ	0B2D2H
CARRY	equ	1
IFSFILE	equ	8000H	; hi bit set if SFT refers to Network file
SFT_IOCTL equ	5	; offset in SFT for ioctl bits
SDA_EXTERR equ	324H	; offset in SDA of extended error

; error codes
ERR_INVALIDHANDLE equ 6

cBegData
	extrn	_lol:dword
	extrn	_uErrorCode:word
cEndData

cBegCode
	extrn	_lock_handle:near
	extrn	_unlock_handle:near
	extrn	_sync_handle:near
	extrn	_open_sync:near
	extrn	_unlock_close:near
	extrn	_unlock_close_all:near
	extrn	_is_locked:near
	extrn	_is_denied:near
	extrn	_others_have_open:near
	extrn	_handle2sft:near

comment ; prototype
void puts(char *s)
{}
;
c_func	puts
	push	BP
	mov	BP, SP
	push	SI
	mov	SI, P[BP]
aputs:	mov	AL, [SI]
	cmp	AL, 0
	jz	xputs
	cmp	AL, 0AH		; lf
	jnz	nputs
	mov	AL, 0DH
	push	AX
	call	putc
	pop	AX
	mov	AL, [SI]
nputs:	push	AX
	call	putc
	pop	AX
	inc	SI
	jmp	aputs
xputs:	pop	SI
	pop	BP
	ret
c_endp	puts

comment ; prototype
void putc(char c)
{}
;
c_func	putc
	push	BP
	mov	BP, SP
	mov	DX, P[BP]
	mov	AH, 2
	int	21H
	pop	BP
	ret
c_endp	putc


comment ; prototype
int already_installed(void)
{}
;
c_func	already_installed
	mov	AX, 1000H
	int	2FH
	mov	AH, 0
	ret
c_endp	already_installed

comment ; prototype
struct LOL far * getLOL(void)
{}
;
c_func	getLOL
	mov	AH, 52H
	int	21H	; get List of Lists
	mov	DX, ES
	mov	AX, 0	; return it in DX:AX
	ret
c_endp	getLOL

comment ; prototype
unsigned getPSP(void)
{}
;
c_func	getPSP
	mov	AH, 51H
	int	21H
	xchg	BX, AX
	ret
c_endp	getPSP

;---------------------------------
;  On Entry
;	AL = int #
;	CS:[SI] = dword for old INT
;	CS:DX   = new int
trap_int proc near
	push	AX
	mov	AH, 35H		; get the old one (ES:BX)
	int	21H
	mov	word ptr CS:[SI], BX
	mov	word ptr CS:[SI+2], ES
	mov	AX, CS
	mov	DS, AX
	pop	AX
	mov	AH, 25H		; set the new (DS:DX)
	int	21H
	ret
trap_int endp

comment ; prototype
void trap_ints(void)
{}
;
c_func	trap_ints
	push	SI
	push	DS

	; trap INT 20H
	mov	AL, 20H
	mov	SI, offset CS:old20
	mov	DX, offset _int20
	call	trap_int

	; trap INT 21H
	mov	AL, 21H
	mov	SI, offset CS:old21
	mov	DX, offset _int21
	call	trap_int

	; trap INT 2FH
	mov	AL, 2FH
	mov	SI, offset CS:old2F
	mov	DX, offset _int2F
	call	trap_int

	pop	DS
	pop	SI
	ret
c_endp	trap_ints

comment ; prototype
int uninstall(void)
{}
;
c_func	uninstall
	mov	AX, 1011H
	mov	BX, MCOOKIE	; use a magic cookie as a verify
	int	2FH		; uninstall Datalight's SHARE
	cmp	AX, MCOOKIE
	jz	unok
	xor	AX, AX		; failed
unok:	ret
c_endp	uninstall

; get DGROUP into DS without affecting any other regs
getDGROUP proc near
	push	AX
	mov	AX, DGROUP
	mov	DS, AX
	pop	AX
	ret
getDGROUP endp


;	[]----------------------------------------------[]
;	 |						|
;	 |		INT 2FH support			|
;	 |						|
;	[]----------------------------------------------[]

old2f	dd	?
	public	_int2f
_int2f:	cmp	AH, 10H
	jnz	not_our_2f

	; Maybe it's installation check (1000H)
	cmp	AL, 0
	jnz	not_check
	mov	AL, 0FFH		; Yes, we are installed!
	iret
not_check:

	; Maybe it's uninstall (1011H)
	cmp	AL, 11H
	jnz	not_uninstall
	cmp	BX, MCOOKIE
	jnz	not_uninstall

	; unhook interrupts
	push	DS
	push	DX
	mov	DX, word ptr CS:[old20]
	mov	DS, word ptr CS:[old20+2]
	mov	AX, 2520H
	int	21H
	mov	DX, word ptr CS:[old21]
	mov	DS, word ptr CS:[old21+2]
	mov	AX, 2521H
	int	21H
	mov	DX, word ptr CS:[old2f]
	mov	DS, word ptr CS:[old2f+2]
	mov	AX, 252FH
	int	21H
	pop	DX
	pop	DS

	; free our memory block
	push	ES
	mov	AX, CS
	sub	AX, 10H
	mov	ES, AX
	mov	AH, 49H
	int	21H
	pop	ES

	; return the magic cookie
	mov	AX, MCOOKIE
	iret
not_uninstall:

	; not for us!
not_our_2f:
	jmp	dword ptr CS:[old2f]
our_2f:	cmp	AL, 0



;	[]----------------------------------------------[]
;	 |						|
;	 |		INT 21H support			|
;	 |						|
;	[]----------------------------------------------[]

	; the old Int 21H vector, used to call through to
	; DOS because SHARE traps Int 21H
	old21	dd	?

	; INT 21H, 4CH - Terminate
	public	i21_4C
i21_31:
i21_4C:
	; unlock all handles belonging to this PSP
	; (preserves all registers)
	call	unlock
	jmp	short not_us

	public	_int21
_int21:	sti			; enable interrupts
	cmp	AH, 4CH		; terminate
	jz	i21_4C
	cmp	AH, 31H		; terminate and stay resident
	jz	i21_31

	cmp	AH, 41H		; delete
	jz	i21_us

	cmp	AH, 5CH		; lock/unlock
	jz	i21_us

	cmp	AH, 3DH		; open
	jz	i21_3D

	; (save a few bytes by comparing a range)
	cmp	AH, 3EH		; close
	jb	not_us
	cmp	AH, 40H		; for read,write
	jbe	i21_us
not_us:	jmp	dword ptr CS:[old21]


	; INT 21H, 3DH - Open must watch DENIALs
	; INT 21H, 40H - Write must keep SFTs syncronized
	public	i21_3d
i21_3D:
i21_40x:
	; save the call #
	push	AX

	; call the original DOS call, with user flags
	push	BP
	mov	BP, SP
	push	[BP+8]			; get user flags
	popf				; into current flags
	pop	BP
	pushf
	call	dword ptr CS:[old21]	; do the DOS open call

	; move returned flags to user space
	push	BP
	mov	BP, SP
	pushf				; move the returned flags
	pop	word ptr [BP+8]		; into the user flags
	pop	BP

	; only check denial on the opens that worked
	jnc	no_dos_error
	add	SP, 2		; "pop" saved call #
	iret

	; there was no error opening the file
	; but there might be a denial error

	; save registers into our standard form on stack
	; DS, ES, AX, BX, CX, DX
no_dos_error:
	push	ES		; note: there is already a space on
	push	AX		; the stack where DS will go.  this
	push	BX		; spot is currently taken up by the
	push	CX		; calling AX.
	push	DX
	push	BP
	mov	BP, SP
	mov	CX, [BP+12]	; get user call # (ie 3Dxx, 40xx)
	mov	[BP+12], DS	; save DS on stack
	pop	BP
	call	getDGROUP

	; is this call 3DH or 40H (the original AH is in CH)
	cmp	CH, 40H
	jz	i21_40x2

	; check for denial
	push	AX			; handle
	call	_is_denied
	pop	BX
	or	AX, AX
	jnz	denied

	; not denied, synchronize the open, in case another
	; file has it open
	push	BX
	call	_open_sync
	pop	BX

	jmp	i21_worked

	; denial error!  close the newly opened file
denied:	push	AX		; save the error code
	push	BP
	mov	BP, SP
	mov	BX, [BP+10]	; handle
	mov	AH, 3EH
	int	21H
	pop	BP
	pop	AX		; error code

	; set the Extended Error Code
	mov	ES, word ptr [_lol+2]
	mov	word ptr ES:[SDA_EXTERR], AX
	jmp	i21_err

	; The write worked, make sure ALL SFTs are in sync
i21_40x2:
	push	BX	; handle
	call	_sync_handle
	pop	BX
	jmp	i21_worked


	; INT 21H, 3EH  File Close
	; INT 21H, 3FH  File Read
	public	i21_us
i21_us:	push	DS
	push	ES
	push	AX
	push	BX
	push	CX
	push	DX
	call	getDGROUP

	; Lock/Unlock handle
	cmp	AH, 5CH
	jz	i21_5C

	; Delete
	cmp	AH, 41H
	jnz	Not21_41
	jmp	i21_41
    Not21_41:

	; Close
	cmp	AH, 3EH
	jz	i21_3E

	; Read/Write File
i21_40:
i21_3F:	push	CX		; length of read/write
	push	BX		; handle
	call	_is_locked
	add	SP, 4
	or	AX, AX
	jz	NotLocked
	jmp	i21_err
    NotLocked:

	; is the call for a write?
	push	BP
	mov	BP, SP
	mov	AX, [BP+8]	; get user AX (DOS call #)
	pop	BP
	cmp	AH, 40H
	jnz	i21_go		; other calls don't need to return

	; restore user registers
	pop	DX
	pop	CX
	pop	BX
 	pop	AX
	pop	ES
	pop	DS

	; go call DOS to handle write
	jmp	i21_40x

	; unlock any regions that should be
i21_3E:	push	BX
	call	_unlock_close
	add	SP, 2

	; now do the DOS call
i21_go:	pop	DX
	pop	CX
	pop	BX
	pop	AX
	pop	ES
	pop	DS
	jmp	dword ptr CS:[old21]


	; INT 21H, 5CxxH  Lock/Unlock Region
	; all x registers have been saved, DS=DGROUP at this point
	public	i21_5C
i21_5C:

	; save registers that handl2sft() might trash
	push	AX	; set/clear lock function
	push	CX	; hi word region
	push	DX	; lo word region
	push	BX	; handle

	; convert handle (BX on stack) to sft ptr (DX:AX)
	call	_handle2sft

	; do we have an invalid handle?
	cmp	AX, 0FFFFh		; invalid handle?
	jnz	TestNetworkBit
	mov	AX, ERR_INVALIDHANDLE	; yup!
	pop	BX
	pop	DX
	pop	CX
	add	SP, 2	; throw away saved AX
	jmp	i21_err

	; ok, we've got an SFT, test the network bit
    TestNetworkBit:
	mov	ES, DX
	mov	BX, AX
	test	word ptr ES:[BX+SFT_IOCTL], IFSFILE
	jz	NotNetworkFile

	; since it is a network file, call through to network
	; we don't need to remember a thing.. the network does!
	add	SP, 8	; throw away 4 words on stack
	pop	DX
	pop	CX
	pop	BX
	pop	AX
	pop	ES
	pop	DS
	jmp	dword ptr CS:[old21]

	; restore registers
    NotNetworkFile:
    	pop	BX
    	pop	DX
    	pop	CX
    	pop	AX

	; call the lock/unlock function
	push	DI
	push	SI	; SI:DI = length
	push	DX
	push	CX	; CX:DX = start
	push	BX	; BX    = handle
	or	AL, AL
	jnz	f5C_01
	call	_lock_handle
	jmp	short f5C_02

f5C_01:	call	_unlock_handle
f5C_02:	add	SP, 10

	; regardless of local success, call DOS to broadcast the
	; lock request to any IFSs out there... (see SPR1425)
	;
	;
	;
	; ETR 2346 (BT)
	;
	; If we call dos and there is no IFSs to handle the call,
	; DOS will return an unsupported function error.  So it
	; works like this:  If we have some sort of error, we will
	; call DOS and then regardless of the result return that
	; there was an error.  If we have no error and DOS returns
	; that there was an error (other than unsupported function
	; which means that there is no IFS), we will return the
	; error code from DOS.
	;

;	or	AX, AX
;	jnz	i21_go

	mov	word ptr cs:_uErrorCode, ax
	pop	DX
	pop	CX
	pop	BX
	pop	AX
	pop	ES
	pop	DS
	stc
	pushf
	call	dword ptr CS:[old21]
	jc	DetermineError

    NoIFS:

	cmp	word ptr cs:_uErrorCode, 0
	je	i21_noerr

    ReturnOurErrorCode:

	mov	ax, bp
	mov	bp, sp
	or	byte ptr [bp+4], 1	; set carry
	mov	bp, ax
	mov	ax, word ptr cs:_uErrorCode
	iret


	; Determine the type of error
	;

    DetermineError:

	; If dos returns an unsupported function, it only
	; means that there is no IFS
	;

	cmp	ax, 1
	je	NoIFS

	; Otherwise, the IFS is reporting some sort of error.  If
	; we have an error then we want to report our error, otherwise
	; return the error from DOS (IFS).
	;

	cmp	word ptr cs:_uErrorCode, 0
	jne	ReturnOurErrorCode

	retf	2


i21_noerr:
	mov	ax, bp
	mov	bp, sp
	and	byte ptr [bp+4], 0feh	; clear carry
	mov	bp, ax
	mov	ax, word ptr cs:_uErrorCode
	xor	ax, ax
	iret

	; call failed, set carry and return
i21_err:
	push	BP
	mov	BP, SP
	mov	[BP+8], AX		; set error code
	or	byte ptr [BP+18], 1	; set carry
	pop	BP
	jmp	short i21_done

	; call worked, clear carry
i21_worked:
	push	BP
	mov	BP, SP
	and	byte ptr [BP+18], 0FEH	; clear carry
	pop	BP
i21_done:
	pop	DX
	pop	CX
	pop	BX
	pop	AX
	pop	ES
	pop	DS
	iret

	;-------------------------------------------------
	;  Delete - the file MAY be in use by someone else
	;  don't allow delete if so
	public	i21_41
i21_41:
	; we need to get items off the stack
	push	BP
	mov	BP, SP

	; find out if it's alright to delete
	push	[BP+12]			; DS, (caller's DS:DX)
	push	[BP+2]			; DX, push filename
	call	IsOkToDelete
	add	SP, 4
	cmp	AX, 0			; set z flag accordingly

	; done with base pointer
	pop	BP

	; pop registers
	pop	DX
	pop	CX
	pop	BX
	pop	AX
	pop	ES
	pop	DS

	; was it OK to delete?
	jz	DeleteDenied

	; ok to delete, call DOS
	jmp	dword ptr CS:[old21]

	; note: we should generate a critical error here
DeleteDenied:
	mov	AX, 5		; denied
	push	BP
	mov	BP, SP
	or	byte ptr [BP+6], CARRY		; set the carry
	pop	BP
	iret

	public	IsOkToDelete
IsOkToDelete proc near
	push	BP
	mov	BP, SP

	; try to open the file - does it exist?
	push	DS
	mov	AX, 3D00H
	lds	DX, P[BP]
	pushf
	call	dword ptr CS:[old21]
	pop	DS

	; file doesn't seem to exist, just pass on through to
	; delete so user gets the right error codes.
	jc	okToDelete

	; save handle
	push	AX

	; file exists, see if anyone else is accessing it
	push	AX
	call	_others_have_open
	pop	CX

	; get original handle # into BX
	pop	BX

	; save the TRUE/FALSE return value from others_have_open()
	push	AX

	; close the file (BX already has handle)
	mov	AH, 3EH
	pushf
	call	dword ptr CS:[old21]

	; if others have it open, don't delete
	pop	AX
	cmp	AX, 0
	jz	okToDelete	; no others have this file open
	mov	AX, 0		; NOT OK to delete, others DO have
	jmp	short doneOkDel	; this file open

okToDelete:
	mov	AX, 1

doneOkDel:
	pop	BP
	ret
IsOkToDelete endp

	;----------------------------------
	;  Terminate via Int 20H
	;
old20	dd	?
	public	_int20
_int20:	call	unlock
	jmp	dword ptr CS:[old20]

unlock:	push	DS
	push	ES
	push	AX
	push	BX
	push	CX
	push	DX
	call	getDGROUP
	call	_unlock_close_all
	pop	DX
	pop	CX
	pop	BX
	pop	AX
	pop	ES
	pop	DS
	ret

cEndCode

	END
