//
//   $Id: RXE_ERRO.C 1.6 2002/10/16 15:53:20Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
 *  Copyright (c) 1989-2002 Datalight, Inc.
 *  All Rights Reserved.
 *  Datalight Confidential and Proprietary
 *
 * Error message file for RXE_CVT and RXECHECK.
 */

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <varargs.h>

static char *msg_list[] = {
	"Invalid Error ZERO", 							/* 0 */
	"File '%s' not an EXE file\n",
	"Not enough memory",
	"Non convertable EXE file: Too many data segments",
	"Non convertable EXE file:\n"
	"\tUnsupported instructions at fix-up in Code Block at %04X:%04X\n",

	"Error : Five",										/* 5 */
	"EXE and MAP files were not created by the same LINK run",
	"Read/Write failure",
	"Non converatable EXE file: EXE does not have any fixups!",
	"Could not find segment '%s' in the file '%s'",

	"Invalid parameter '%s'",							/* 10 */
	"File '%s' is already an RXE format file",
	"Data Seg value '%04X' is too large; Greater than EXE size",
	"Cannot execute '%s'",
	"Cannot find the RXE Loader! (RXE_INIT.EXE)",

	"MAP File has already been converted to RXE format", 	/* 15 */
	"RXE Specified interrupt value invalid",
	"Data Block segment is not on a segment boundry\n\tIt must be!",
	"Unsupported \"MOV SP, SEG\" at fix-up in Code Block at %04X:%04X\n",
	"Ambigous RXE Fixup at %04X:%04X\n",

	"Cannot open '%s'\n",									/* 20 */
	"Segment overrides not supported.\n"
	"\tPossible segment override at fix-up in Code Block at %04X:%04X\n"
};

extern int quit, exit_status;

/*
 * Error displays an error message per the message passed
 * and exits if the user did not requested to continue on Error!
 */
void error(int msg, ...)
{
	extern int continue_on_error;
	extern FILE *RXE_output;
	va_list argptr;

	argptr = &msg+1;

	if(!quit)
	{
		printf("\nError: ");
		vprintf(msg_list[msg], argptr);

	}
	else if(RXE_output != NULL)
	{
		fprintf(RXE_output, "\nError: ");
		vfprintf(RXE_output, msg_list[msg], argptr);
	}

	if(!continue_on_error)
	{
		exit(msg);
	}
}

/*
 * Warning displays a message per the message number!
 */
void warning(int msg, ...)
{
	extern int continue_on_error;
	extern int DisplayWarningMessages;
	int quit_save = quit;
	va_list argptr;

	argptr = &msg+1;

	quit_save = quit;
	quit = 0;

	printf("Warning: ");
	vprintf(msg_list[msg], argptr);
	quit = quit_save;
}

