//
//   $Id: RXE_UTIL.C 1.6 2002/10/16 15:53:20Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
	Copyright (c) 1989-2002 Datalight, Inc.
	All Rights Reserved.
	Datalight Confidential and Proprietary
*/
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <io.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>

#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "rxe.h"
#include "exehdr.h"

extern int output;

char map_name[66];
char found_seg_name[66];
char found_class_name[66];

int partial = FALSE;		/* TRUE if find_segment find partial seg */

void dump(void *v, unsigned count)
{
	unsigned char *p = v;
	unsigned i,j;
	int c;
	for(i=0; i<count; i+=16){
		printf("%p  ", p);
		for(j=0; j<16; ++j){
			if(j==7)
				printf("%02x-", p[j]);
			else
				printf("%02x ", p[j]);
		}
		printf("  ");
		for(j=0; j<16; ++j){
			c = p[j];
			printf("%c", isprint(c) ? c : '.');
		}
		p += 16;
		printf("\n");
	}
}

/*
 * Find_segment_value
 *
 * Finds the START value from a MAP file.
 * if the segment value is a partial value, meaning that it does not
 * start on a segment boundry, (align type == "para"), then
 * it sets the variable "partial" to TRUE.
 */

unsigned find_segment_value(char *exe_name, char *seg_name)
{
	FILE *fd;
	char line[133];
	int got_a_line= FALSE;
	unsigned long seg;

	strcpy(map_name, exe_name);

	mk_ext(map_name, "MAP");

	fd = fopen(map_name, "r");

	if(fd == NULL)
	{
		error(20, map_name);
		exit(20);
	}

	strupr(seg_name);			/* Make the name upper case */

	do{
		fgets(line, sizeof(line), fd);
		if(feof(fd))
			 return -1;
	}while(!strfnd(line, "Start"));

	got_a_line = FALSE;			/* Don't have any seg lines*/

	do{
		fgets(line, sizeof(line), fd);
		if(!got_a_line && strlen(line) > 3)
			got_a_line = TRUE;
		if(feof(fd) || ((strlen(line) < 3) && got_a_line))
			 return -1;
	}while(!seg_find(line, seg_name));
	sscanf(line, "%lX", &seg);

	partial = (unsigned) (seg & 0xF);			/* Get lowest nibble of actual item */

	seg >>= 4;
	return (unsigned) seg;
}


int seg_find(char *map_line, char *name)
{

	if(strlen(map_line) < 23)
		return FALSE;

	getword(map_line+21, found_seg_name);

	getword(map_line+40, found_class_name);

	if(strcmp(found_seg_name, name) == 0)
		return TRUE;

	if(strcmp(found_class_name, name) == 0)
		return TRUE;

	return (FALSE);
}



/*
 * strfnd Finds a sub string in a larger string.
 *
 * str1 = large string
 * Str2 = sub string
 * Return
 *	1 = Sub string found
 *	0 = Sub NOT string found
 */
int strfnd(char *str1, char *str2)
{
	int len = strlen(str2);
	while(*str1){
		if(!DL_IS_SPACE(*str1))
			if(strncmp(str1, str2, len) == 0 && DL_IS_SPACE(str1[len]))
					return 1;
		 ++str1;
	}
	return 0;
}




#include <dir.h>

void chk_times(char *exe_name, char *map_name)
{
	struct ffblk F_exe, F_map;
	if(findfirst(exe_name, &F_exe, 0xFF))
		error(20, exe_name);
	if(findfirst(map_name, &F_map, 0xFF))
		error(20, map_name);
	if(F_exe.ff_fdate != F_map.ff_fdate)
		error(6);
	if(abs(F_exe.ff_ftime != F_map.ff_ftime) > 2)
		error(6);
}



/*
 * Build a file name from a path and a extension.
 * Watch out for "..\file.abc" and ".\..\..\prog.exe"
 * The user must make sure that fname is big enough
 * to handle the fname + ext.
 */
void mk_ext(char *fname, char *ext)
{
	char *p;
	*(fname + strlen(fname) + strlen(ext)) = '\0';
	p=fname+strlen(fname)-1;
	while(p >= fname){
		if(*p == '.'){			/* already an extension */
			strcpy(p+1, ext);
			return;
		}
		else if(*p == '\\')
			goto add_ext;
		else
			;			/* do nothing */
		--p;
	}
add_ext:
	strcat(fname, ".");
	strcat(fname, ext);
}



/*
 * Check_sum
 * This routine produces the check sum for a segment and a length
 */
#define MAX_CHK (30 *1024L)
unsigned check_sum(unsigned seg, unsigned long length)
{
	unsigned long total;
	unsigned sum = 0, far *fp = MK_FP(seg, 0);
	unsigned tmp;

	total = 0L;
	while(total < length){
		if((length - total) > MAX_CHK)
			tmp = (unsigned) MAX_CHK;
		else
			tmp = (unsigned) (length - total);

		fp = MK_FP(seg + (unsigned)(total / 16), 0);

		sum -= short_sum(fp, tmp/2);

		total += tmp;

	}
	return sum;
}

unsigned short_sum( unsigned huge * hp, unsigned long count )
{
	unsigned long i;
	unsigned sum = 0;


	for(i=0; i<count; ++i)
	{
		sum += *hp++;
	}

	return sum;
}



void update_map(char *map_name, unsigned rxe_base_paras, unsigned d_seg)
{
	char out_name[66], line[128], *name = "RXE_BASE               RXE_BASE";
	FILE *out, *map;
	long start, stop, length;
	unsigned s = rxe_base_paras * 16, d;
	int first_time = 1;

	strcpy(out_name, map_name);
	out_name[strlen(out_name) -3] = '\0';
	strcat(out_name, "$$$");

	map = fopen(map_name, "r");
	out = fopen(out_name, "w");

	do {
		fgets(line, sizeof(line), map);
		fputs(line, out);
	}while(strncmp(line + 1, "Start", 5) != 0);

	do
		fgets(line, sizeof(line), map);
	while(strlen(line) < 4);

	while(strlen(line) > 3){
		sscanf(line, " %lx%c %lx%c %lx", &start, &d,&stop,&d,&length);
		if((unsigned)(start >> 4) < d_seg)
			fputs(line, out);
		else{
			if(first_time){
				fprintf(out," %05lXH %05lXH %05lXH %s\n",
					start, start+s, (long)s, name);
				first_time = 0;
			}
			fprintf(out, " %05lXH %05lXH %05lXH %s",
				start+s, stop+s, length, line+22);
		}
		fgets(line, sizeof(line), map);
	}
	fclose(map);
	fclose(out);
	unlink(map_name);
	rename(out_name, map_name);
}





no_ext(char *file)
{
	char *p;
	int i;

	p = file + strlen(file) -1;
	for(i=0; i<4; ++i){
		if(*p == '.')
			return (FALSE);
		else
			--p;
	}
	return (TRUE);
}

void getword(char *line, char *word)
{
	int i=0, Started = FALSE;

	while(1){
		switch(*line){
			case ' ':
			case '\t':		/* Skip past space */
				++line;
				if(Started)
					goto Done;
				break;

			case '\n':			/* End of line */
				goto Done;

			default:
				word[i++] = *line++;
				Started = TRUE;
				break;
		}
	}
Done:
	word[i] = '\0';
}

