#
#   $Id: MAKEFILE.MAK 1.2 2002/10/16 15:58:32Z peterb Exp $
#
#   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
#
#   Copyright (c) 1993 - 2002 Datalight, Inc.
#   All Rights Reserved
#
#   Datalight, Inc. is a Washington corporation with an address at
#   21520 30TH DR SE MS110 Bothell, WA, 98021
#   Tel: 800.221.6630  Fax: 425.951.8091
#   Http://www.datalight.com
#
#   This software, including without limitation all source code and
#   documentation, is the confidential, trade secret property of
#   Datalight, Inc., and is protected under the copyright laws of
#   the United States and other jurisdictions. Portions of the
#   software may also be subject to one or more the following US
#   patents: US#5860082, US#6260156.
#
#   In addition to civil penalties for infringement of copyright
#   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
#   penalties for violation of (a) the restrictions on circumvention
#   of copyright protection systems found in 17 U.S.C. 1201 and
#   (b) the protections for the integrity of copyright management
#   information found in 17 U.S.C. 1202.
#
#   U.S. Government Restricted Rights. Use, duplication,
#   reproduction, or transfer of this commercial product and
#   accompanying documentation is restricted in accordance with
#   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
#
#   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
#   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
#   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
#   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
#   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
#   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
#   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
#   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
#   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
#   THIS SOFTWARE IN ERROR.
#
#
# Makefile for RXE Examples using the Borland C++ Compilers
#
# You may want to change some of the paths, memory model and
# compiler version number to be compatible with your system
# and project needs.
#
# This makefile assumes that the C0 Startup code has been
# modified to be RXE ROMable. And that the RXE libraries have
# been built.
#


# The FLOATPT example assumes that you have the US Software
# GoFast Floating Point Package!
#
FP_LIB_DIR = C:\GOFAST
FP_LIBS   = $(FP_LIB_DIR)\emuir7.obj\
           +$(FP_LIB_DIR)\usemund.lib

# Compiler specific stuff
#
!if $d(MEM_MODEL)
!else
MEM_MODEL =l
!endif

!if $d(BCC_VER)
!else
BCC_VER   =5
!endif

!if $d(BCC_ROOT)
!else
BCC_ROOT  =C:\bc$(BCC_VER)
!endif


RXE_C0    =..\b-start\bc$(BCC_VER)\c0$(MEM_MODEL).obj
RXE_LIB   =..\libsrc\rxe_b_$(MEM_MODEL).lib


!if $(BCC_VER) >= 4
NO_EXCEPTIONS = -x-
BCC_LIBS      =  $(BCC_ROOT)\lib\noeh$(MEM_MODEL).lib\
                +$(BCC_ROOT)\lib\c$(MEM_MODEL).lib
!else
BCC_LIBS      =  $(BCC_ROOT)\lib\c$(MEM_MODEL).lib
!endif
BCC_MATH      =  $(BCC_ROOT)\lib\math$(MEM_MODEL).lib

CC        =bcc -v -c -m$(MEM_MODEL) $(NO_EXCEPTIONS)
LINK      =tlink /c/s/C/n/v

System : Basic.exe cpp.exe Floatpt.exe

Basic.exe : basic.c
   $(CC) -f- $*.c
   echo $(RXE_C0)+$*.obj            >link.rsp
   echo $*.exe                     >>link.rsp
   echo $*.map                     >>link.rsp
   echo $(RXE_LIB)+                >>link.rsp
   echo $(BCC_LIBS)                >>link.rsp
   $(LINK) @link.rsp
   $(COMSPEC) /E:4096 /c check DATA $*
   convert DATA $*

FloatPt.exe : FloatPt.c
   $(CC) $*.c
   echo $(RXE_C0)+$*.obj            >link.rsp
   echo $*.exe                     >>link.rsp
   echo $*.map                     >>link.rsp
   echo $(RXE_LIB)+                >>link.rsp
   echo $(FP_LIBS)+                >>link.rsp
   echo $(BCC_MATH)+               >>link.rsp
   echo $(BCC_LIBS)                >>link.rsp
   $(LINK) @link.rsp
   $(COMSPEC) /E:4096 /c check DATA $*
   convert DATA $*

cpp.exe : cpp.cpp
   $(CC) -f- $*.cpp
   echo $(RXE_C0)+$*.obj            >link.rsp
   echo $*.exe                     >>link.rsp
   echo $*.map                     >>link.rsp
   echo $(RXE_LIB)+                >>link.rsp
   echo $(BCC_LIBS)                >>link.rsp
   $(LINK) @link.rsp
   $(COMSPEC) /E:4096 /c check DATA $*
   convert DATA $*

clean:
   del *.obj
   del *.exe
   del *.map
   del *.cod
   del *.dif
   del *.tmp
   del *.bad
