#
#   $Id: MAKEFILE.MAK 1.2 2002/10/16 16:01:26Z peterb Exp $
#
#   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
#
#   Copyright (c) 1993 - 2002 Datalight, Inc.
#   All Rights Reserved
#
#   Datalight, Inc. is a Washington corporation with an address at
#   21520 30TH DR SE MS110 Bothell, WA, 98021
#   Tel: 800.221.6630  Fax: 425.951.8091
#   Http://www.datalight.com
#
#   This software, including without limitation all source code and
#   documentation, is the confidential, trade secret property of
#   Datalight, Inc., and is protected under the copyright laws of
#   the United States and other jurisdictions. Portions of the
#   software may also be subject to one or more the following US
#   patents: US#5860082, US#6260156.
#
#   In addition to civil penalties for infringement of copyright
#   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
#   penalties for violation of (a) the restrictions on circumvention
#   of copyright protection systems found in 17 U.S.C. 1201 and
#   (b) the protections for the integrity of copyright management
#   information found in 17 U.S.C. 1202.
#
#   U.S. Government Restricted Rights. Use, duplication,
#   reproduction, or transfer of this commercial product and
#   accompanying documentation is restricted in accordance with
#   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
#
#   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
#   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
#   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
#   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
#   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
#   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
#   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
#   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
#   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
#   THIS SOFTWARE IN ERROR.
#
#
# Makefile for build an RXE.LIB using Borland-C
# Copyright Datalight 1996
# All rights reserved
#
# You may want to change some of the paths, memory model and
# compiler version number to be compatible with your system
# and project needs.
#

#BCC_VER   =5
#BCC_ROOT  =C:\bc5

!if $(BCC_VER) >= 4
NO_EXCEPTIONS = -x-
!endif

CC        =bcc -v -c -m$(MEM_MODEL) $(NO_EXCEPTIONS)

!if $d(MEM_MODEL)
!	if $(MEM_MODEL) != s && $(MEM_MODEL) != m \
   && $(MEM_MODEL) != c && $(MEM_MODEL) != l
!		error Invalid Memory Model for RXE library.
!  endif
!else
MEM_MODEL = s
!endif

!if   $(MEM_MODEL) == c || $(MEM_MODEL) == l
MODULES = \
		malloc.obj  \
		setargv.obj \
		setargx.obj \
		dlspawn.obj


!elif	$(MEM_MODEL) == m || $(MEM_MODEL) == s
MODULES = \
		setargv.obj \
		setargx.obj \
		dlspawn.obj
!endif

.c.obj:
	$(CC) $*.c
.asm.obj:
	tasm /Mx /m10 /DMEMMODEL=$(ASM_MODEL) $*.asm

RXE.LIB : $(MODULES)
	del rxe.lib
	respond $(MODULES)
	tlib rxe.lib @rxe.rsp, rxelib.lst

clean:
	del *.obj
	del *.exe
	del *.lst
	del *.lib
    del *.rsp



