REM
REM   $Id: APINIT.BAT 1.2 2002/10/16 16:27:00Z peterb Exp $
REM
REM   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
REM
REM   Copyright (c) 1993 - 2002 Datalight, Inc.
REM   All Rights Reserved
REM
REM   Datalight, Inc. is a Washington corporation with an address at
REM   21520 30TH DR SE MS110 Bothell, WA, 98021
REM   Tel: 800.221.6630  Fax: 425.951.8091
REM   Http://www.datalight.com
REM
REM   This software, including without limitation all source code and
REM   documentation, is the confidential, trade secret property of
REM   Datalight, Inc., and is protected under the copyright laws of
REM   the United States and other jurisdictions. Portions of the
REM   software may also be subject to one or more the following US
REM   patents: US#5860082, US#6260156.
REM
REM   In addition to civil penalties for infringement of copyright
REM   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
REM   penalties for violation of (a) the restrictions on circumvention
REM   of copyright protection systems found in 17 U.S.C. 1201 and
REM   (b) the protections for the integrity of copyright management
REM   information found in 17 U.S.C. 1202.
REM
REM   U.S. Government Restricted Rights. Use, duplication,
REM   reproduction, or transfer of this commercial product and
REM   accompanying documentation is restricted in accordance with
REM   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
REM
REM   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
REM   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
REM   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
REM   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
REM   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
REM   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
REM   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
REM   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
REM   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
REM   THIS SOFTWARE IN ERROR.
REM
@echo %echo%

REM ----------------------------------------------------------------------
REM $DOCFILE:APINIT.BAT
REM
REM This is a required batch file called as a part of Stage 1 of the
REM AUTOPROJ process.  It is used to initialize environment variables
REM that are required to complete the process.  It can optionally be
REM used to verify that necessary system resources are available.
REM
REM All the standard environment variables are set on entry.  On exit,
REM ERROR must be set to null if no error, or the error message text to
REM use if an error occurred.
REM ----------------------------------------------------------------------

REM ------- Required Info --------

REM People who get email results
set EMAIL=socketsteam

REM Location in project of files (%SRCFILES%) to update with SPROJBLD.EXE
set SRCDIR=.

REM Names of the files to update with SPROJBLD.EXE (located in %SRCDIR%)
set SRCFILES=version.h

REM Make sure the network resources are available
if not exist t:\products\testing\sockets\nul goto badnet
if not exist t:\mks\autoproj\sockets\nul goto badnet

REM Get a valid compiler
if exist %localdrv%\bc45\bin\bcc.exe goto gotbc
if exist %localdrv%\bc45 deltree -y %localdrv%\bc45 >nul
md %localdrv%\bc45
xcopy /s t:\apps\bc452\*.* %localdrv%\bc45\.
:gotbc

REM Set up environment to use mks tools on local system and t:\bin
set path=%localdrv%\bc45\bin;%path%;t:\bin;t:\mks;t:\mks\mkssi;t:\mks\mksnt;
set tmpdir=c:\temp
set rootdir=t:\mks
set winbootdir=c:\windows

REM ------- Optional Info --------

REM Success!
set ERROR=
goto fini

:badnet
set ERROR=No T: Drive
goto fini

:fini
