REM
REM   $Id: ROB.BAT 1.2 2002/10/16 16:27:00Z peterb Exp $
REM
REM   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
REM
REM   Copyright (c) 1993 - 2002 Datalight, Inc.
REM   All Rights Reserved
REM
REM   Datalight, Inc. is a Washington corporation with an address at
REM   21520 30TH DR SE MS110 Bothell, WA, 98021
REM   Tel: 800.221.6630  Fax: 425.951.8091
REM   Http://www.datalight.com
REM
REM   This software, including without limitation all source code and
REM   documentation, is the confidential, trade secret property of
REM   Datalight, Inc., and is protected under the copyright laws of
REM   the United States and other jurisdictions. Portions of the
REM   software may also be subject to one or more the following US
REM   patents: US#5860082, US#6260156.
REM
REM   In addition to civil penalties for infringement of copyright
REM   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
REM   penalties for violation of (a) the restrictions on circumvention
REM   of copyright protection systems found in 17 U.S.C. 1201 and
REM   (b) the protections for the integrity of copyright management
REM   information found in 17 U.S.C. 1202.
REM
REM   U.S. Government Restricted Rights. Use, duplication,
REM   reproduction, or transfer of this commercial product and
REM   accompanying documentation is restricted in accordance with
REM   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
REM
REM   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
REM   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
REM   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
REM   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
REM   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
REM   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
REM   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
REM   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
REM   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
REM   THIS SOFTWARE IN ERROR.
REM
REM
REM History:
REM   03/27/2001 pb  Changed sapi to capi in the XCOPY portion.
REM   03/21/2001 pb  Added sock_root environment variable to look for the
REM                  included files needed for building in their default
REM                  directories.
REM

set prjroot=%localdrv%\autoproj
set bldroot=%localdrv%\autoproj\build
set relroot=%localdrv%\autoproj\release
set blddest=t:\products\sockets\testing
set sock_root=%prjroot%

REM - Check to see if build and release directories exist
REM - and delete them if they do.

if exist %localdrv%\autoproj\build\nul deltree -y %localdrv%\autoproj\build
if exist %localdrv%\autoproj\release\nul deltree -y %localdrv%\autoproj\release

REM - make directories
MD %localdrv%\autoproj\build
MD %localdrv%\autoproj\release
MD %blddest%\%sibldnum%

REM - release directories
MD %relroot%\dos
MD %relroot%\dos\clients
MD %relroot%\dos\server
MD %relroot%\dos\configs
MD %relroot%\dos\examples
MD %relroot%\dos\utils
MD %relroot%\dos\capi
MD %relroot%\demodos
MD %relroot%\demodos\clients
MD %relroot%\demodos\server
MD %relroot%\demodos\configs
MD %relroot%\demodos\examples
MD %relroot%\demodos\utils
MD %relroot%\demodos\capi
MD %relroot%\win
MD %relroot%\demowin
MD %relroot%\demowin\apps

REM - build mail
rem xcopy %prjroot%\sapi\*.* 	%bldroot%
xcopy %prjroot%\apps\mail\*.* 	%bldroot%
cd %bldroot%
make -f%bldroot%\mail.mak
lzexe %bldroot%\makemail.exe
lzexe %bldroot%\sendmail.exe
lzexe %bldroot%\makemail.exe
del %bldroot%\*.old
del %bldroot%\*.obj
cd %prjroot%

REM - copy mail applications to release tree
del %bldroot%\capi.*
del %bldroot%\compiler.*
del %bldroot%\_capi.*
xcopy %bldroot%\*.* %relroot%\dos\clients\
xcopy %bldroot%\*.* %relroot%\demodos\clients\

REM - copy all other client files
xcopy %prjroot%\apps\ftpclien\*.* %relroot%\dos\clients\
xcopy %prjroot%\apps\httpcli\*.exe %relroot%\dos\clients\
xcopy %prjroot%\apps\print\*.* %relroot%\dos\clients\
xcopy %prjroot%\apps\netbios\*.* %relroot%\dos\clients\
xcopy %prjroot%\apps\ftpclien\*.* %relroot%\demodos\clients\
xcopy %prjroot%\apps\httpcli\*.exe %relroot%\demodos\clients\
xcopy %prjroot%\apps\print\*.* %relroot%\demodos\clients\
xcopy %prjroot%\apps\netbios\*.* %relroot%\demodos\clients\

REM - copy server applications
xcopy %prjroot%\apps\server\httpd\*.htm %relroot%\dos\server
xcopy %prjroot%\apps\server\httpd\*.jpg %relroot%\dos\server
xcopy %prjroot%\apps\server\httpd\cgi*.* %relroot%\dos\server
xcopy %prjroot%\apps\server\httpd\form.* %relroot%\dos\server
xcopy %prjroot%\apps\server\httpd\num.* %relroot%\dos\server
xcopy %prjroot%\apps\server\httpd\htaccess %relroot%\dos\server
xcopy %prjroot%\apps\server\httpd\rc.jar %relroot%\dos\server
xcopy %prjroot%\apps\server\httpd\httpd.exe %relroot%\dos\server
xcopy %prjroot%\apps\server\httpd\ssi.exe %relroot%\dos\server

xcopy %prjroot%\apps\server\ftpd\ftpd.exe %relroot%\dos\server
xcopy %prjroot%\apps\server\ftpd\socket.upw %relroot%\dos\server
xcopy %prjroot%\apps\server\ftpd\ftpapi.* %relroot%\dos\server
xcopy %prjroot%\apps\server\ftpd\findftps.* %relroot%\dos\server
xcopy %prjroot%\apps\server\ftpd\ftptest.exe %relroot%\dos\server

xcopy %prjroot%\apps\server\httpd\*.htm %relroot%\demodos\server
xcopy %prjroot%\apps\server\httpd\*.jpg %relroot%\demodos\server
xcopy %prjroot%\apps\server\httpd\cgi*.* %relroot%\demodos\server
xcopy %prjroot%\apps\server\httpd\form.* %relroot%\demodos\server
xcopy %prjroot%\apps\server\httpd\num.* %relroot%\demodos\server
xcopy %prjroot%\apps\server\httpd\htaccess %relroot%\demodos\server
xcopy %prjroot%\apps\server\httpd\rc.jar %relroot%\demodos\server
xcopy %prjroot%\apps\server\httpd\httpd.exe %relroot%\demodos\server
xcopy %prjroot%\apps\server\httpd\ssi.exe %relroot%\demodos\server

xcopy %prjroot%\apps\server\ftpd\ftpd.exe %relroot%\demodos\server
xcopy %prjroot%\apps\server\ftpd\socket.upw %relroot%\demodos\server
xcopy %prjroot%\apps\server\ftpd\ftpapi.* %relroot%\demodos\server
xcopy %prjroot%\apps\server\ftpd\findftps.* %relroot%\demodos\server
xcopy %prjroot%\apps\server\ftpd\ftptest.exe %relroot%\demodos\server

REM - copy configs
xcopy %prjroot%\configs\*.* %relroot%\dos\configs
xcopy %prjroot%\configs\*.* %relroot%\demodos\configs

REM - copy examples
xcopy %prjroot%\examples\*.* %relroot%\dos\examples
xcopy %prjroot%\examples\*.* %relroot%\demodos\examples

REM - copy capi
xcopy %prjroot%\capi\*.* %relroot%\dos\capi
xcopy %prjroot%\capi\*.* %relroot%\demodos\capi

REM - copy utils
xcopy %prjroot%\utils\*.* %relroot%\dos\utils
xcopy %prjroot%\utils\*.* %relroot%\demodos\utils

REM - copy windows files
xcopy %prjroot%\win\*.* /s %relroot%\win
xcopy %prjroot%\demowin\*.* %relroot%\demowin
xcopy %prjroot%\win\apps\*.* /s %relroot%\demowin\apps

REM - kernel copy
xcopy %prjroot%\socketm.exe %relroot%\dos
xcopy %prjroot%\socketp.exe %relroot%\dos
xcopy %prjroot%\sconfig.exe %relroot%\dos
xcopy %prjroot%\hosts %relroot%\dos

xcopy %prjroot%\demodos\socketmd.exe %relroot%\demodos
xcopy %prjroot%\demodos\socketpd.exe %relroot%\demodos
xcopy %prjroot%\sconfig.exe %relroot%\demodos
xcopy %prjroot%\hosts %relroot%\demodos


REM - move everything to build number in destination
xcopy %relroot%\*.* /s %blddest%\%sibldnum%
