#
#   $Id: makefile.ms 1.1 2003/02/20 20:51:40Z johnb Exp $
#
#   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
#
#   Copyright (c) 1993 - 2002 Datalight, Inc.
#   All Rights Reserved
#
#   Datalight, Inc. is a Washington corporation with an address at
#   21520 30TH DR SE MS110 Bothell, WA, 98021
#   Tel: 800.221.6630  Fax: 425.951.8091
#   Http://www.datalight.com
#
#   This software, including without limitation all source code and
#   documentation, is the confidential, trade secret property of
#   Datalight, Inc., and is protected under the copyright laws of
#   the United States and other jurisdictions. Portions of the
#   software may also be subject to one or more the following US
#   patents: US#5860082, US#6260156.
#
#   In addition to civil penalties for infringement of copyright
#   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
#   penalties for violation of (a) the restrictions on circumvention
#   of copyright protection systems found in 17 U.S.C. 1201 and
#   (b) the protections for the integrity of copyright management
#   information found in 17 U.S.C. 1202.
#
#   U.S. Government Restricted Rights. Use, duplication,
#   reproduction, or transfer of this commercial product and
#   accompanying documentation is restricted in accordance with
#   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
#
#   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
#   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
#   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
#   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
#   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
#   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
#   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
#   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
#   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
#   THIS SOFTWARE IN ERROR.
#
#
# MAKEFILE for Datalight's Socket Library Routines
#
# ROM-DOS Copyright (c) 1991-2003 by Datalight, Inc.
# All Rights Reserved.
# Datalight Confidential and Proprietary
#
# This file to build libraries for the small, medium, compact and large
# memory models.
#
CC       = cl
CFLAGS   = /f- /c /Gs /Ox /A$(MEM_MODEL) /D_SAPI_LIBRARY /I..\include
LIB      = LIB

# RELEASE
# -------------
release : clean sockets socketm socketc socketl copyrel

copyrel:
        @if exist ..\LIB\ms_sock?.lib del ..\lib\ms_sock?.lib  >nul
        @if not exist ..\LIB\nul md ..\lib >nul
        @copy ms_sock?.lib ..\lib >nul

sockets:
	nmake /A -fmakefile.ms MEM_MODEL=S MEM_MODEL_NAME=SMALL socklib

socketm:
	nmake /A -fmakefile.ms MEM_MODEL=M MEM_MODEL_NAME=MEDIUM socklib

socketc:
	nmake /A -fmakefile.ms MEM_MODEL=C MEM_MODEL_NAME=COMPACT socklib

socketl:
	nmake /A -fmakefile.ms MEM_MODEL=L MEM_MODEL_NAME=LARGE socklib


# Define the modules of the library.
#
OBJ1 = accept.obj bind.obj closesoc.obj connect.obj ioctlsoc.obj 
OBJ2 = getpeern.obj getsockn.obj getsocko.obj htonl.obj htons.obj 
OBJ3 = inetaddr.obj inetntoa.obj listen.obj ntohl.obj ntohs.obj 
OBJ4 = recv.obj recvfrom.obj select.obj send.obj sendto.obj 
OBJ5 = setsocko.obj shutdown.obj socket.obj ghostbya.obj ghostbyn.obj 
OBJ6 = ghostnam.obj gservbyp.obj gservbyn.obj gprotonu.obj gprotona.obj 
OBJ7 = isset.obj fdclr.obj fdset.obj maperror.obj getreadc.obj 
OBJ8 = getnextp.obj checkudp.obj database.obj base.obj 

MODULES = $(OBJ1) $(OBJ2) $(OBJ3) $(OBJ4) $(OBJ5) $(OBJ6) $(OBJ7) $(OBJ8)


#
# build the librarian response file
#
ms_sock.rsp : makefile
 @echo +base.obj +accept.obj +bind.obj +closesoc.obj +connect.obj +ioctlsoc.obj &> ms_sock.rsp
 @echo +getpeern.obj +getsockn.obj +getsocko.obj +htonl.obj +htons.obj &>> ms_sock.rsp
 @echo +inetaddr.obj +inetntoa.obj +listen.obj +ntohl.obj +ntohs.obj &>> ms_sock.rsp
 @echo +recv.obj +recvfrom.obj +select.obj +send.obj +sendto.obj &>> ms_sock.rsp
 @echo +setsocko.obj +shutdown.obj +socket.obj +ghostbya.obj +ghostbyn.obj &>> ms_sock.rsp
 @echo +ghostnam.obj +gservbyp.obj +gservbyn.obj +gprotonu.obj +gprotona.obj &>> ms_sock.rsp
 @echo +isset.obj +fdclr.obj +fdset.obj +maperror.obj +getreadc.obj &>> ms_sock.rsp
 @echo +getnextp.obj +checkudp.obj +database.obj; >> ms_sock.rsp

#
# build the specified library
#
socklib : $(MODULES) ms_sock.rsp
	 $(LIB) ms_sock$(MEM_MODEL).lib @ms_sock.rsp
	 @del *.obj

accept.obj:	socket.c
	 $(CC) $(CFLAGS) /Foaccept /D_SAPI_ACCEPT socket.c
bind.obj:	socket.c
	$(CC) $(CFLAGS) /Fobind /D_SAPI_BIND socket.c
closesoc.obj:	socket.c
	$(CC) $(CFLAGS) /Foclosesoc /D_SAPI_CLOSESOCKET socket.c
connect.obj:	socket.c
	$(CC) $(CFLAGS) /Foconnect /D_SAPI_CONNECT socket.c
ioctlsoc.obj:	socket.c
	$(CC) $(CFLAGS) /Foioctlsoc /D_SAPI_IOCTLSOCKET socket.c
getpeern.obj:	socket.c
	$(CC) $(CFLAGS) /Fogetpeern /D_SAPI_GETPEERNAME socket.c
getsockn.obj:	socket.c
	$(CC) $(CFLAGS) /Fogetsockn /D_SAPI_GETSOCKNAME socket.c
getsocko.obj:	 socket.c
	$(CC) $(CFLAGS) /Fogetsocko /D_SAPI_GETSOCKOPT socket.c
htonl.obj:	socket.c
	$(CC) $(CFLAGS) /Fohtonl /D_SAPI_HTONL socket.c
htons.obj:	socket.c
	$(CC) $(CFLAGS) /Fohtons /D_SAPI_HTONS socket.c
inetaddr.obj:	socket.c
	$(CC) $(CFLAGS) /Foinetaddr /D_SAPI_INETADDR socket.c
inetntoa.obj:	socket.c
	$(CC) $(CFLAGS) /Foinetntoa /D_SAPI_INETNTOA socket.c
listen.obj:	socket.c
	$(CC) $(CFLAGS) /Folisten /D_SAPI_LISTEN socket.c
ntohl.obj:	socket.c
	$(CC) $(CFLAGS) /Fontohl /D_SAPI_NTOHL socket.c
ntohs.obj:	socket.c
	$(CC) $(CFLAGS) /Fontohs /D_SAPI_NTOHS socket.c
recv.obj:	socket.c
	$(CC) $(CFLAGS) /Forecv /D_SAPI_RECV socket.c
recvfrom.obj:	socket.c
	$(CC) $(CFLAGS) /Forecvfrom /D_SAPI_RECVFROM socket.c
select.obj:	socket.c
	$(CC) $(CFLAGS) /Foselect /D_SAPI_SELECT socket.c
send.obj:	socket.c
	$(CC) $(CFLAGS) /Fosend /D_SAPI_SEND socket.c
sendto.obj:	socket.c
	$(CC) $(CFLAGS) /Fosendto /D_SAPI_SENDTO socket.c
setsocko.obj:	socket.c
	$(CC) $(CFLAGS) /Fosetsocko /D_SAPI_SETSOCKOPT socket.c
shutdown.obj:	socket.c
	$(CC) $(CFLAGS) /Foshutdown /D_SAPI_SHUTDOWN socket.c
socket.obj:	socket.c
	$(CC) $(CFLAGS) /Fosocket /D_SAPI_SOCKET socket.c
ghostbya.obj:	socket.c
	$(CC) $(CFLAGS) /Foghostbya /D_SAPI_GHOSTBYADDR socket.c
ghostbyn.obj:	socket.c
	$(CC) $(CFLAGS) /Foghostbyn /D_SAPI_GHOSTBYNAME socket.c
ghostnam.obj:	socket.c
	$(CC) $(CFLAGS) /Foghostnam /D_SAPI_GHOSTNAME socket.c
gservbyp.obj:	socket.c
	$(CC) $(CFLAGS) /Fogservbyp /D_SAPI_GSERVBYPORT socket.c
gservbyn.obj:	socket.c
	$(CC) $(CFLAGS) /Fogservbyn /D_SAPI_GSERVBYNAME socket.c
gprotonu.obj:	socket.c
	$(CC) $(CFLAGS) /Fogprotonu /D_SAPI_GPROTONUMBER socket.c
gprotona.obj:	socket.c
	$(CC) $(CFLAGS) /Fogprotona /D_SAPI_GPROTONAME socket.c
isset.obj:	socket.c
	$(CC) $(CFLAGS) /Foisset /D_SAPI_ISSET socket.c
fdclr.obj:	socket.c
	$(CC) $(CFLAGS) /Fofdclr /D_SAPI_FDCLR socket.c
fdset.obj:	socket.c
	$(CC) $(CFLAGS) /Fofdset /D_SAPI_FDSET socket.c
maperror.obj:	socket.c
	$(CC) $(CFLAGS) /Fomaperror /D_SAPI_MAPERROR socket.c
getreadc.obj:	socket.c
	$(CC) $(CFLAGS) /Fogetreadc /D_SAPI_GETREADCOUNT socket.c
getnextp.obj:	socket.c
	$(CC) $(CFLAGS) /Fogetnextp /D_SAPI_GETNEXTPORTNUM socket.c
checkudp.obj:	socket.c
	$(CC) $(CFLAGS) /Focheckudp /D_SAPI_CHECKUDPOPEN socket.c
database.obj:	socket.c
	$(CC) $(CFLAGS) /Fodatabase /D_SAPI_DATABASE socket.c
base.obj:	socket.c
	$(CC) $(CFLAGS) /Fobase /D_SAPI_BASE socket.c


# HOUSEKEEPING
# -----------------
clean :
	@if exist *.obj del *.obj
	@if exist *.map del *.map
	@if exist *.lnk del *.lnk
	@if exist *.xrf del *.xrf
	@if exist *.lst del *.lst
	@if exist *.exe del *.exe
	@if exist *.pt del *.pt
	@if exist *.td del *.td
	@if exist *.tr del *.tr
	@if exist *.bak del *.bak
	@if exist *.rsp del *.rsp
	@if exist *.lib del *.lib
	@if exist x.y del x.y
	@if exist err.txt del err.txt
	@if exist status.me del status.me

cleanall : clean
	@if exist status.me del status.me
	@if exist build.log del build.log
        @if exist ..\lib\ms_sock?.lib del ..\lib\ms_sock?.lib >nul
