//
//   $Id: APIC.C 1.3 2003/02/15 00:50:16Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
// API C interface

#include <stdio.h>
#include <dos.h>
#include "inetdefs.h"
#include "compiler.h"
#include "api.h"
#include "apic.h"

unsigned api_int;
char id[] = "Inet";
WORD tcbs;

union REGS r;

int init_api(void)
{
	void interrupt (*int_apiv)();
	char far *pid;
	int i;

	for (api_int = 0x20;api_int < 0x100;++api_int) {
		int_apiv = getvect(api_int);
		if (int_apiv == 0)
			continue;
		pid = (char far *)int_apiv - 4;
		for (i = 0;i < 4;++i) {
			if (pid[i] != id[i])
				break;
		}
		if (i == 4)
			return api_int;
	}
	return -1;
}

DWORD Resolve(char *name)
{
	WORD adr[2];
	r.x.cx = FP_OFF(name);
	r.x.bx = FP_SEG(name);
	r.h.ah = API_GETIPADR;
	int86(api_int,&r,&r);
	adr[1] = r.x.cx;
	adr[0] = r.x.dx;
	return *(DWORD *)adr;
}

WORD OpenTcp(
struct isocket *lsocket,	/* Local socket */
struct isocket *fsocket,	/* Remote socket */
int mode,				/* Active/passive/server */
WORD window,			/* Receive window (and send buffer) sizes */
void (far *r_upcall)(WORD handle,WORD cnt),	/* Function to call when data arrives */
void (far *t_upcall)(),	/* Function to call when ok to send more data */
void (far *s_upcall)(WORD control,char old,char new),	/* Function to call when connection state changes */
char tos,
char *user)				/* User linkage area */
{
	TCP_OP_P op;

	if (fsocket) {
		op.wRemPort = fsocket->wPort;
		op.dwRemIPAd = fsocket->dwAddress;
	}
	else {
		op.wRemPort = 0;
		op.dwRemIPAd = 0;
	}
	op.wLocPort = lsocket->wPort;
	op.wMode = mode;		/* active/passive/server */
	op.wWindow = window;	/* window size (0 for default) */
	op.pRcvUpcall = r_upcall;
	op.pSndUpcall = t_upcall;
	op.pStcUpcall = s_upcall;
	op.pUser = (WORD)user;	/* user id field in TCB */
	op.cTos = tos;		/* type of service to use (normally 0) */
	r.x.cx = FP_OFF(&op);
	r.x.bx = FP_SEG(&op);
	r.h.ah = API_TCPOPEN;
	int86(api_int,&r,&r);
	lsocket->wPort = op.wLocPort;
	tcbs = r.x.bx;
	if (r.x.cx == 0) {
		printf("TCP open error: %s\n",get_errstr(r.x.cx));
		return -r.x.ax;
	}
	return r.x.cx;
}

int SendTcp(WORD handle,char *buf,int len,BYTE flags)
{
	r.x.si = FP_OFF(buf);
	r.x.dx = FP_SEG(buf);
	r.x.cx = len;
	r.x.bx = handle;
	r.h.ah = API_TCPWRITE;
	r.h.al = flags;
	int86(api_int,&r,&r);
	if (r.x.ax != 0)
		return -r.x.ax;
	return r.x.cx;
}

#pragma argsused
int RecvTcp(WORD handle,char *buf,WORD cnt,char *urgentp)
{
	r.x.si = FP_OFF(buf);
	r.x.dx = FP_SEG(buf);
	r.x.cx = cnt;
	r.x.bx = handle;
	r.h.ah = API_TCPREAD;
	int86(api_int,&r,&r);
	if (r.x.ax != 0)
		return -r.x.ax;
	return r.x.cx;
}

int CloseTcp(WORD handle)
{
	r.x.bx = handle;
	r.h.ah = API_TCPCLOSE;
	int86(api_int,&r,&r);
	return -r.x.ax;
}

int ResetTcp(WORD handle)
{
	r.x.bx = handle;
	r.h.ah = API_TCPRESET;
	int86(api_int,&r,&r);
	return -r.x.ax;
}

int DelTcp(WORD handle)
{
	r.x.bx = handle;
	r.h.ah = API_TCPDELET;
	int86(api_int,&r,&r);
	return -r.x.ax;
}

TCB far *GetTcb(WORD handle)
{
	if (tcbs == 4)
		return (TCB far *)MK_FP(handle,4);
	else
		return (TCB far *)MK_FP(tcbs,handle);
}

char *get_errstr(WORD errcode)	/* return errorcode string */
{
	static char unk[30];
	static char *errs[] = {
		"No error",
		"Connection already exists",
		"Connection does not exist",
		"Connection closing",
		"No memory for TCB or buffer creation",
		"Would block",
		"Protocol or mode not supported",
		"Invalid arguments"
	};

	if (errcode > INVALID) {
		sprintf(unk,"Unknown error %u",errcode);
		return unk;
	}
	return errs[errcode];
}
