//
//   $Id: RS.C 1.6 2003/01/27 20:25:10Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
// RS.C
// Read Serialisation file
// Portions Copyright GP van Niekerk Ondernemings BK  1993

// 2002-03-01 gvn Test for ALL bits in PRODUCT flags

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <dir.h>
#include "bump-up.h"
#include "bumpdefs.h"

#ifndef NOLIC
/***************************************************************************/
void read_dontwipeme(void);
void display_dontwipeme(void);
//SECRET        wiperec, copyright;
FILE          *dontwipefile;
unsigned long wipesize;
unsigned long serial_numbers[20];
unsigned int  copies, num_ser_num;
char message[TEXTSIZE];
#define LANDESIGN 1		/* LAN Design notice */
/***************************************************************************/
/*----------------------------------------------------------------------------
|  byteCRC performs a CRC calculation using the existing CRC variable and    |
|  incorporating the passed character into this running CRC.                 |
|  In order for the properties of this CRC to be preserved, the bytes must   |
|  be transmitted in the order given to the routine, low bit first, followed |
|  by the CRC, low byte first.  Note that no extra zero bytes are included   |
|  in calculating the CRC.                                                   |
----------------------------------------------------------------------------*/
unsigned int CRC16bit(unsigned int length, unsigned char *Array)
{
unsigned char ca, cb, cl, ch, b;
unsigned int i, CRC = 0xFFFF;

  for( i= 0; i < length; i++)
  {
	b  = Array[i];
	ca = (unsigned char)(CRC ^ b);
	cb = (unsigned char)(CRC >> 8);
	cl = cb ^ (ca >> 4) ^ (ca & 0x0F) ^ (ca << 3) ^ (ca << 7);
	ch = ca ^ (ca >> 5) ^ (ca << 4) ^ ((ca >> 1) & 0x07);
	CRC = cl | ((unsigned int)ch << 8);
  }
  return( CRC );
}

/***************************************************************************\
|      																		|
\***************************************************************************/
unsigned far char const index_form[16] = { 0x0F, 0x00, 0x01, 0x04,
									   0x02, 0x08, 0x05, 0x0A,
									   0x03, 0x0E, 0x09, 0x07,
									   0x06, 0x0D, 0x0B, 0x0C };
unsigned far char const r_s_coeff[13] =  { 0x0C, 0x0E, 0x03, 0x03,
									   0x0A, 0x0B, 0x05, 0x0B,
									   0x0E, 0x0A, 0x00, 0x0C, 0x05};
unsigned far char const alpha_form[16] = { 0x01, 0x02, 0x04, 0x08,
									   0x03, 0x06, 0x0C, 0x0B,
									   0x05, 0x0A, 0x07, 0x0E,
									   0x0F, 0x0D, 0x09, 0x01 };
unsigned far char const hamming_bits[16] = { 0x00, 0x0B, 0x15, 0x1E,
										 0x26, 0x2D, 0x33, 0x38,
										 0x47, 0x4C, 0x52, 0x59,
										 0x61, 0x6A, 0x74, 0x7F };
unsigned far char const hamming_corr [128] = { 0x00, 0x00, 0x00, 0x01,
										   0x00, 0x02, 0x04, 0x08,
										   0x00, 0x01, 0x01, 0x01,
										   0x09, 0x05, 0x03, 0x01,
										   0x00, 0x02, 0x0A, 0x06,
										   0x02, 0x02, 0x03, 0x02,
										   0x07, 0x0B, 0x03, 0x01,
										   0x03, 0x02, 0x03, 0x03,
										   0x00, 0x0C, 0x04, 0x06,
										   0x04, 0x05, 0x04, 0x04,
										   0x07, 0x05, 0x0D, 0x01,
										   0x05, 0x05, 0x04, 0x05,
										   0x07, 0x06, 0x06, 0x06,
										   0x0E, 0x02, 0x04, 0x06,
										   0x07, 0x07, 0x07, 0x06,
										   0x07, 0x05, 0x03, 0x0F,
										   0x00, 0x0C, 0x0A, 0x08,
										   0x09, 0x08, 0x08, 0x08,
										   0x09, 0x0B, 0x0D, 0x01,
										   0x09, 0x09, 0x09, 0x08,
										   0x0A, 0x0B, 0x0A, 0x0A,
										   0x0E, 0x02, 0x0A, 0x08,
										   0x0B, 0x0B, 0x0A, 0x0B,
										   0x09, 0x0B, 0x03, 0x0F,
										   0x0C, 0x0C, 0x0D, 0x0C,
										   0x0E, 0x0C, 0x04, 0x08,
										   0x0D, 0x0C, 0x0D, 0x0D,
										   0x09, 0x05, 0x0D, 0x0F,
										   0x0E, 0x0C, 0x0A, 0x06,
										   0x0E, 0x0E, 0x0E, 0x0F,
										   0x07, 0x0B, 0x0D, 0x0F,
										   0x0E, 0x0F, 0x0F, 0x0F };

unsigned far char const syndrome_table[14] = { 0xD9, 0xED, 0xAF, 0xBE,
										   0x67, 0x8A, 0x25, 0x9B,
										   0xFC, 0x76, 0x53, 0xC8,
										   0x42, 0x11 };

/****************************************************************************
|                            GALOIS MULTIPLIER                              |
\***************************************************************************/
unsigned char galois_mult(unsigned char x, unsigned char y)
{
  if (x == 0) return (0);
  else
  {
	x = index_form[x] + r_s_coeff[y];
	if (x > 15) x -= 15;
	return ( alpha_form[x] );
  }
}

/****************************************************************************
|                                   MULTIPLY                                |
\***************************************************************************/
unsigned char multiply(unsigned char x, unsigned char y)
{
  if (x == 0 || y == 0) return (0);
  else
  {
	x = index_form [x] + index_form [y];
	if (x > 15) x += 1;
	return ( alpha_form [x & 0x0F] );
  }
}
/****************************************************************************
|                                    DIVIDE                                 |
\***************************************************************************/
unsigned char divide(unsigned char numerator, unsigned char denominator)
{
   return multiply(numerator, alpha_form[15 - index_form [denominator]]);
}

#ifdef ENCODE
/****************************************************************************/
// Reed Sol (14,12) * Hamming (7,4) + Interleave = (98,48)
// The message is expanded to 12 bytes the low nibble with the message data
// and the high nibble 0, Reed sol on these 12 bytes adds a 2 byte suffix.
// Hamming is then done on these 14 bytes.
/****************************************************************************/
void encode(unsigned char *symbol, unsigned char *msg)
{
unsigned char byteno;
unsigned int i, bo, blockno, crc;

   /* Isolate Reed-Solomon symbols, split into 12 nibbles */
	for(blockno = 0; blockno < BLOCKS; blockno++)
	{
	  bo = blockno * 14;	// Block offset in Reed-Solomon
	  for (byteno = 0; byteno < 11; byteno += 2)
	  {
		symbol[bo+byteno] = *msg & 0x0F;
		symbol[bo+byteno+1] = *msg >> 4;
		msg++;
	  }

	  /* Generate Reed-Solomon check symbols [12] & [13] */

	  symbol[bo+12] = 0;
	  symbol[bo+13] = 0;
	  for (byteno = 0; byteno <= 10; ++byteno)
	  {
		symbol[bo+12] ^= galois_mult( symbol[bo+byteno], byteno );
		symbol[bo+13] ^= galois_mult( symbol[bo+byteno+1], byteno );
	  }
	  symbol[bo+12] ^= galois_mult( symbol[bo+11], 11 );
	  symbol[bo+13] ^= galois_mult( symbol[bo+12], 12 );

		  /* Generate Hamming check symbols */

	  for( byteno = 0; byteno < 14; ++byteno )
	  symbol[bo+byteno] = hamming_bits[symbol[bo+byteno]];
	}

	/* Calculate CRC. Use CRC as random seed further on */
	crc = CRC16bit(CODESIZE-2, symbol);
	symbol[CODESIZE-2] = (unsigned char)crc;
	symbol[CODESIZE-1] = (unsigned char)(crc >> 8);

	/* Add random encryption */
	srand(crc);
	for (i = 0;i < CODESIZE-2; ++i)
	{
		symbol[i] ^= (unsigned char)(rand() % 256);
	}
}
#endif

/***************************************************************************\
|       Capture incoming message and save the decoded, corrected result     |
\***************************************************************************/
int decode(unsigned char *symbol, unsigned char *decoded)
{
unsigned int  byteno;
unsigned char syndrome0, syndrome1;
unsigned char error_location, error_corrector;
unsigned int i,crc,blockno, bo;

	/* Remove random encryption */
	crc = symbol[CODESIZE-2] + (symbol[CODESIZE-1] << 8);
	srand(crc);
	for (i = 0;i < CODESIZE-2; ++i)
	{
		symbol[i] ^= (unsigned char)(rand() % 256);
	}
	crc = CRC16bit(CODESIZE, symbol);
	if(crc) return 1;	/* Error. Somebody tampered with final data */

	/* hamming correct the blocks */
	for(blockno = 0; blockno < BLOCKS; blockno++)
	{
	  bo = blockno * 14;	// Block offset in Reed-Solomon
	  for( byteno = 0; byteno < 14; byteno++ )
	  {
		 symbol[bo+byteno] = hamming_corr[symbol[bo+byteno] & 0x07F];
	  }

	  /* Reed-Solomon correct the block */

	  syndrome0 = 0;
	  syndrome1 = 0;
	  for( byteno = 0; byteno < 14; ++byteno )
	  {
		syndrome0 ^= multiply( symbol[bo+byteno], syndrome_table[byteno] & 0x0F );
		syndrome1 ^= multiply( symbol[bo+byteno], syndrome_table[byteno] >> 4 );
	  }
	  if (syndrome0 != 0 && syndrome1 != 0)
	  {
		error_location  = divide( syndrome1, syndrome0 );
		error_corrector = divide( syndrome0, error_location );
		error_location  = index_form[error_location];
		symbol[bo+14-error_location] ^= error_corrector;
	  }

	  /*Dump back the corrected bytes*/

	  for( byteno = 0; byteno <= 10; byteno += 2 )
	  {
		*decoded = symbol[bo+byteno] | (symbol[bo+byteno+1] << 4);
		decoded++;
	  }
	}
  return 0;
}

/***************************************************************************\
| Check DONTWIPE.ME! for license
\***************************************************************************/
void check_dontwipe()
{
	int error;
	unsigned long	fileindex;
	unsigned long newest_date;
	char string[80] = "c:\\inet";
	char *pn;
	unsigned char secret_line[CODESIZE];
	SECRET        wiperec, copyright;
	int exit_code;

	/* Find DONWIPE.ME! */
	if ((pn = getenv("INET")) == 0) {
		string[0] = getdisk() + 'A';
	}
	else {
		strncpy(string,pn,39);
	}
	strcat(string,"\\dontwipe.me!");
	if ((dontwipefile = fopen(string, "rb")) == NULL)
	{
		exit_code = MISSING_WIPE;
		goto ex;
	}

	/* Check size of DONTWIPE.ME! */
	fseek(dontwipefile, 0, SEEK_END);
	wipesize = ftell(dontwipefile);
	if((wipesize % CODESIZE) || (wipesize < (2*CODESIZE)))
	{
		exit_code = WRONG_WIPE;
		goto ex;
	}

	/* Read Copyright message */
	fseek(dontwipefile, CODESIZE, SEEK_SET);
	if(CODESIZE != fread(&secret_line, 1, sizeof(secret_line), dontwipefile))
	{
		exit_code = READERR_WIPE;
		goto ex;
	}
	error = decode(secret_line, (unsigned char*)&copyright);
	if(error)
	{
		exit_code = TAMPERED_COPY;
		goto ex;
	}

	/* Scan through DONTWIPE.ME! to find records */
	newest_date = 0;
	copies = 0;
	num_ser_num = 0;
	for(fileindex = 2*CODESIZE; fileindex < wipesize; fileindex += CODESIZE)
	{
		fseek(dontwipefile, fileindex, SEEK_SET);
		if(CODESIZE != fread(&secret_line, 1, CODESIZE, dontwipefile))
		{
			exit_code = READERR_WIPE;
			goto ex;
		}

		/* Decode line in DONTWIPE.ME! and check for tampering */
		error = decode((unsigned char*)&secret_line, (unsigned char*)&wiperec);
		if(error || (wiperec.date < newest_date))
		{
			exit_code = TAMPERED_WIPE;
			goto ex;
		}

		newest_date = wiperec.date;
		if((wiperec.flags & PRODUCT) == PRODUCT)
		{
			serial_numbers[num_ser_num++] = wiperec.serial;
			copies += wiperec.copies;
			strcpy(message, wiperec.text);
		}
	}
	if (copies == 0)
	{
		exit_code = TAMPERED_COPY;
		ex:
		printf("Invalid licence %s %d\r\n",string,exit_code);
		exit(exit_code);
	}
	fclose(dontwipefile);
}
#endif
