//
//   $Id: API.C 1.3 2003/05/08 14:04:36Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
// API.C
// API C interface

#include <stdio.h>
#include <dos.h>
#include <compiler.h>
#include "api.h"

static int api_call(union REGS *r);

int api_inti;		// API interrupt found

DWORD GetIPAddress(char *pszName)
{
	union REGS r;

	r.x.bx = FP_SEG(pszName);
	r.x.cx = FP_OFF(pszName);
	r.h.ah = API_GETIPADR;
	if (api_call(&r) == NO_API) {
		printf("TCP/IP stack not loaded\n");
		return 0;
	}
	return (DWORD)MK_FP(r.x.cx,r.x.dx);
}

/*
DWORD get_loc_ip_adr(char far **pname)
{
	union REGS r;

	r.x.bx = r.x.cx = 0;
	r.h.ah = API_GETIPADR;
	api_call(&r);
	*pname = (char far *)MK_FP(r.x.bx,r.x.si);
	return (DWORD)MK_FP(r.x.cx,r.x.dx);
}

void send_ping(DWORD host, int seq_num)
{
	union REGS r;

	r.x.cx = FP_SEG(host);
	r.x.dx = FP_OFF(host);
	r.x.bx = seq_num;
	r.h.ah = API_SENDPING;
	api_call(&r);
}
*/

int TcpOpen(TCP_OP_P *pop,WORD *phandle)
{
	union REGS r;

	r.x.bx = FP_SEG(pop);
	r.x.cx = FP_OFF(pop);
	r.h.ah = API_TCPOPEN;
	api_call(&r);
	*phandle = r.x.cx;
	return -r.x.ax;
}

int TcpRead(WORD handle,char *buf,int len)
{
	union REGS r;

	r.x.bx = handle;
	r.x.dx = FP_SEG(buf);
	r.x.si = FP_OFF(buf);
	r.x.cx = len;
	r.h.ah = API_TCPREAD;
	api_call(&r);
	if (r.x.ax)
		return -r.x.ax;
	else
		return r.x.cx;
}

int TcpWrite(WORD handle,char *buf,int len,int urgent)
{
	union REGS r;

	r.x.bx = handle;
	r.x.dx = FP_SEG(buf);
	r.x.si = FP_OFF(buf);
	r.x.cx = len;
	r.h.ah = API_TCPWRITE;
	r.h.al = urgent;
	api_call(&r);
	if (r.x.ax)
		return -r.x.ax;
	else
		return r.x.cx;
}

int TcpClose(WORD handle)
{
	union REGS r;

	r.x.bx = handle;
	r.h.ah = API_TCPCLOSE;
	return -api_call(&r);
}

int TcpReset(WORD handle)
{
	union REGS r;

	r.x.bx = handle;
	r.h.ah = API_TCPRESET;
	return -api_call(&r);
}

int TcpDelete(WORD handle)
{
	union REGS r;

	r.x.bx = handle;
	r.h.ah = API_TCPDELET;
	return -api_call(&r);
}

VARBLOCK far *GetVarBlock(void)
{
	union REGS r;

	r.h.ah = API_GETVARPTR;
	if (api_call(&r) == NO_API)
		return 0;
	return (VARBLOCK far *)MK_FP(r.x.bx,r.x.cx);
}

char *NetErrStr(int errcode)	/* return errorcode string */
{
	static char unk[30];
	static char *errs[] = {
		"No error",
		"Connection already exists",
		"Connection does not exist",
		"Connection closing",
		"No memory for TCB or buffer creation",
		"Would block",
		"Protocol or mode not supported",
		"Invalid arguments"
	};

	if (errcode > INVALID) {
		sprintf(unk,"Unknown error %u",errcode);
		return unk;
	}
	return errs[errcode];
}

int find_vec(void);

static int api_call(union REGS *r)
{
	if (!api_inti && !(api_inti = find_vec())) {
		return NO_API;
	}
	int86(api_inti,r,r);
	return r->x.ax;
}

int find_vec()
{
	void interrupt (*int_apiv)();
	static char id[] = "Inet";
	int api_inti,i;
	char far *pid;

	for (api_inti = 0x20;api_inti < 0x100;++api_inti) {
		int_apiv = getvect(api_inti);
		if (int_apiv == 0)
			continue;
		pid = (char far *)int_apiv - 4;
		for (i = 0;i < 4;++i) {
			if (pid[i] != id[i])
				break;
		}
		if (i == 4)
			break;
	}
	if (api_inti == 0x100) {
		api_inti = 0;
	}
	return api_inti;
}
