//
// HTTPGET.C
// Copyright (c) 2001 Datalight, Inc.
// Portions copyright (c) GPvNO 2001
// All Rights Reserved
// Datalight Confidential and Proprietary
//
// Simple HTTP Client
//
// Revision History
// 04/30/2001 jmb used ROMDOS version number and copyright info.
// 04/26/2001 jmb created header
//
//

#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <io.h>
#include <string.h>
#include <conio.h>
#include <dir.h>

#ifdef DL
#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "dosver.h"
#include "fatworld.h"
#endif

#include "compiler.h"
#include "api.h"
#include "api.pt"

// prototypes
WORD HtOpen(char *pszRemoteFile, int iPort);
int HtRead(char *pcBuf,int iBuflen,WORD wHtp);
int HtWrite(char *pcBuf,int iBuflen,WORD wHtp);
int HtClose(WORD wHtp);
void FixName(char *pszName);

#define BUFSZ 1000
char arcBuf[BUFSZ];
DWORD dwIPAddress;
BYTE bServer = 0, bVerbose = 0;

int main(int iArgc,char *ppszArgv[])
{
	char *pszArg, *pszArgSwitch, *pszRemoteFile, *psz;
	char *pszURL = 0, *pszLocalFile = 0, *pszServer = 0;
	int i = 0, iPort = 80, iCnt;
	FILE *fpo;
	VARBLOCK far *pv;
	WORD wHtp;

#ifdef DL
	printf("Datalight Sockets HTTPGET ");
	if (dlIsFat32World())
		printf("%s ", SHORTVERSION);
	else
		printf("%s ", SHORTVERSION622);
	printf("%s\n%s\nPortions copyright (c) GPvNO 2003\n%s\n\n",
		BUILDVERSION, COPYRIGHT, _BUILD_NUMBER);
#else
	printf("HTTPGET version 3.03.\n");
#endif
	while (iArgc > 1)
	{
		pszArg = *++ppszArgv;
		--iArgc;
		if (*pszArg == '-')
		{
			pszArgSwitch = pszArg + (pszArg[2] == '=' ? 3 : 2);
			switch (pszArg[1] | ('a' - 'A'))
			{
			case 'p':
				iPort = atoi(pszArgSwitch);
				break;
			case 's':
				pszServer = pszArgSwitch;
				bServer = 1;
				break;
			case 'v':
				bVerbose = 1;
				break;
			default:
				goto BadArg;
			}
		}
		else if (i == 0)
		{
			pszURL = pszArg;
			++i;
		}
		else if (i == 1)
		{
			pszLocalFile = pszArg;
			++i;
		}
	}
	if (!i)
	{
		BadArg:
		printf("HTTPGET [-p=<port>] [-s=<server>] [-v] <URL> [<local file>]\n");
		exit(1);
	}
	if (!bServer)
	{
		// Get server address/local file from URL
		if ((psz = strchr(pszURL,'/')) != 0)
		{
			if (psz[1] == '/')
			{
				// "//" given
				if (psz != pszURL && !pszServer && psz[-1] == ':')
				{
					psz[-1] = 0;
					if (stricmp(pszURL,"http") != 0)
					{
						printf("Unknown protocol: %s\n",pszURL);
						exit(1);
					}
					pszURL = psz;
				}
				pszServer = psz + 2;
			}
			else if (psz != pszURL)
				pszServer = pszURL;
			else if ((pv = GetVarBlock()) == 0 || (dwIPAddress = pv->http_addr) == 0)
			{
				printf("Server address cannot be determined\n");
				exit(1);
			}
		}
		else
			pszServer = pszURL;
		if ((psz = strchr(pszServer,'/')) != 0)
			*psz++ = 0;
		pszRemoteFile = psz;
	}
	else
		psz = pszURL;
	if (!pszLocalFile)
	{
		if ((pszLocalFile = strrchr(psz,'/')) != 0)
			++pszLocalFile;
		else
			pszLocalFile = psz;
	}
	if (!dwIPAddress && (dwIPAddress = GetIPAddress(pszServer)) == 0)
	{
		printf("Unable to resolve '%s'\n",pszServer);
		exit(2);
	}
	if (bVerbose)
		printf("Local file: '%s'\n",pszLocalFile);
	if ((fpo = fopen(pszLocalFile,"wb")) == 0)
	{
		printf("Unable to open file '%s'\n",pszLocalFile);
		exit(4);
	}
	if (bVerbose)
		printf("HTTP server: %u.%u.%u.%u:%u\n",((BYTE *)&dwIPAddress)[3],
			((BYTE *)&dwIPAddress)[2],((BYTE *)&dwIPAddress)[1],
			((BYTE *)&dwIPAddress)[0],iPort);

	if ((wHtp = HtOpen(bServer ? pszURL : pszRemoteFile,iPort)) == 0)
		exit(3);
	while ((iCnt = HtRead(arcBuf,BUFSZ,wHtp)) > 0)
	{
		if (fwrite(arcBuf,1,iCnt,fpo) != iCnt)
		{
			fclose(fpo);
			HtClose(wHtp);
			exit(4);
		}
	}
	HtClose(wHtp);
	if (fclose(fpo) != 0)
		exit(4);
	return 0;
}

TCP_OP_P sOp;
int iReadCount;
char *pcRead;
#define LBLEN 200

WORD HtOpen(char *pszRemoteFile, int iPort)
{
	WORD wHandle;
	int retv,len,linecnt = 0;
	char linebuf[LBLEN + 1],ch;

	sOp.dwRemIPAd = dwIPAddress;
	sOp.wRemPort = iPort;
	sOp.wLocPort = 0;
	sOp.wMode = TCP_ACTIVE;
	if ((retv = TcpOpen(&sOp,&wHandle)) != 0) {
		printf("Net open failed: %s\n",NetErrStr(-retv));
		return 0;
	}
	len = sprintf(arcBuf,"GET /%s HTTP/1.0\r\n\r\n",
		pszRemoteFile + (*pszRemoteFile == '/' ? 1 : 0));
	if (HtWrite(arcBuf,len,wHandle) <= 0)
	{
		printf("Unable to send header\n");
		HtClose(wHandle);
		return 0;
	}
	while (1) {
		while ((retv = TcpRead(wHandle,pcRead = arcBuf,BUFSZ)) == -WOULDBLK) {
			if (kbhit() != 0 && getch() == 0x1b) {	// Escape
				printf("Net read failed: user abort\n");
				HtClose(wHandle);
				return 0;
			}
		}
		if (retv == 0) {
			printf("Net connection closed\n");
			HtClose(wHandle);
			return 0;
		}
		if (retv < 0) {
			printf("Net read failed: %s\n",NetErrStr(-retv));
			HtClose(wHandle);
			return 0;
		}
		while (retv--) {
			ch = *pcRead++;
			if (ch == '\r')
				continue;
			else if (ch == '\n') {
				linebuf[linecnt] = 0;
				if (bVerbose)
					printf("HTTP: %s\n",linebuf);
				if (linecnt == 0) {
					iReadCount = retv;
					return wHandle;
				}
				linecnt = 0;
			}
			else if (linecnt < LBLEN) {
				linebuf[linecnt++] = ch;
			}
		}
	}
}

int HtRead(char *buf,int buflen,WORD wHandle)
{
	int retv;

	if (iReadCount) {
		memmove(buf,pcRead,iReadCount);
		retv = iReadCount;
		iReadCount = 0;
		return retv;
	}
	while ((retv = TcpRead(wHandle,buf,buflen)) == -WOULDBLK) {
		if (kbhit() != 0 && getch() == 0x1b) {	// Escape
			printf("Net read failed: user abort\n");
			return 0;
		}
	}
	if (retv == 0) {
		return 0;
	}
	if (retv < 0) {
		printf("Net read failed: %s\n",NetErrStr(-retv));
		return 0;
	}
	return retv;
}

int HtWrite(char *buf,int buflen,WORD wHandle)
{
	int retv,iWritten = 0;

	while (iWritten < buflen) {
		retv = TcpWrite(wHandle,buf + iWritten,buflen - iWritten,0);
		if (retv >= 0)
			iWritten += retv;
		else if (retv != -WOULDBLK) {
			printf("Net write failed: %s\n",NetErrStr(-retv));
			return 0;
		}
		if (kbhit() != 0 && getch() == 0x1b) {	// Escape
			printf("Net write failed: user abort\n");
			return 0;
		}
	}
	return buflen;
}

int HtClose(WORD htp)
{
	TcpClose(htp);
	TcpDelete(htp);
	return 0;
}

void fixname(char *pname)
{
	char *oname = pname,ch;
	int previous_is_slash = 0;

	while ((ch = *pname++) != 0) {
		if (ch == '\\' || ch == '/') {
			if (!previous_is_slash)
				*oname++ = ch;
			previous_is_slash = 1;
		}
		else {
			previous_is_slash = 0;
			*oname++ = ch;
		}
	}
	*oname = 0;
}

