#
#   $Id: mail.mak 1.6 2002/10/16 16:32:16Z peterb Exp $
#
#   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
#
#   Copyright (c) 1993 - 2002 Datalight, Inc.
#   All Rights Reserved
#
#   Datalight, Inc. is a Washington corporation with an address at
#   21520 30TH DR SE MS110 Bothell, WA, 98021
#   Tel: 800.221.6630  Fax: 425.951.8091
#   Http://www.datalight.com
#
#   This software, including without limitation all source code and
#   documentation, is the confidential, trade secret property of
#   Datalight, Inc., and is protected under the copyright laws of
#   the United States and other jurisdictions. Portions of the
#   software may also be subject to one or more the following US
#   patents: US#5860082, US#6260156.
#
#   In addition to civil penalties for infringement of copyright
#   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
#   penalties for violation of (a) the restrictions on circumvention
#   of copyright protection systems found in 17 U.S.C. 1201 and
#   (b) the protections for the integrity of copyright management
#   information found in 17 U.S.C. 1202.
#
#   U.S. Government Restricted Rights. Use, duplication,
#   reproduction, or transfer of this commercial product and
#   accompanying documentation is restricted in accordance with
#   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
#
#   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
#   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
#   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
#   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
#   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
#   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
#   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
#   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
#   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
#   THIS SOFTWARE IN ERROR.
#
#####################################################################
#
# MAIL.MAK      Created 12/14/00 by RWK
# Copyright (c) 1996-2001 Datalight, Inc.
# Confidential and Proprietary
# All Rights Reserved
#
# $DOCHISTORY
#  07/26/2001 jmb added ssetargv.obj for lfn command line arguments
#  06/21/2001 jmb added cleanall target
#  04/30/2001 jmb added ROMDOS libraries to link list for GETMAIL.EXE.
#  03/29/2001 jmb changed SAPI to CAPI
#                 made .PT files created dynamically using PROTO.
#                 modified rules to add include path to SAPI directory
#                 and to path directly to the CAPI.C and _CAPI.C files.
#  01/24/2001 rwk created makefile for example applications.
#
#####################################################################

#
# Borland C++ tools
#
CC  = Bcc
TLINK   = TLink


CFLAGS = $(RD_SW) -c -w3 -I..\..\INCLUDE;..\..\..\INCLUDE -DDL
LFLAGS = $(RD_SW_L) -x -c -Tde
STARTUP = c0s.obj+..\..\..\lib\ssetargv.obj
LIBS = noehs.lib+cs.lib+..\..\..\lib\dls.lib

release : makemail.exe sendmail.exe getmail.exe
	copy *.exe .. >nul


clean :
	@echo Cleaning MAIL
	@if exist *.obj DEL *.obj
	@if exist *.pt del *.pt

cleanall: clean
	@if exist *.exe del *.exe


makemail.exe: makemail.obj capi.obj _capi.obj
	$(TLINK)  @&&|
		$(LFLAGS)+
		$(STARTUP)+
		makemail.obj+
		capi.obj+
		_capi.obj
		$<, $*
		$(LIBS)
|

sendmail.exe: sendmail.obj capi.obj _capi.obj
	$(TLINK)  @&&|
		$(LFLAGS)+
		$(STARTUP)+
		sendmail.obj+
		capi.obj+
		_capi.obj
		$<, $*
		$(LIBS)
|

getmail.exe: getmail.obj capi.obj _capi.obj
	$(TLINK)  @&&|
		$(LFLAGS)+
		$(STARTUP)+
		getmail.obj+
		capi.obj+
		_capi.obj
		$<, $*
		$(LIBS)
|


makemail.obj : makemail.c makemail.pt
sendmail.obj : sendmail.c sendmail.pt
getmail.obj  : getmail.c getmail.pt
capi.obj     : ..\..\capi\capi.c
_capi.obj    : ..\..\capi\_capi.c


.c.obj:
	$(CC) $(CFLAGS) $<

.c.pt:
	proto $*.c >$*.pt


