//
//   $Id: GetKey.C 1.1 2003/04/07 20:06:54Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2003 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//
// getkey.c
//
// Copyright (c) 1996-2003 Datalight, Inc.
// Confidential and Proprietary
// All Rights Reserved
// Portions copyright (c) GPvNO 2003
//
// Remote console get scancode/key
//
// $DOCHISTORY
//  04/07/2001 gvn first version derived from old RCCLI.C
//

#include <stdio.h>
#include <dos.h>
#include <ctype.h>

#define KEYBOARD	0x16	/* Keyboard interrupt */

#define K_READ		0		/* read key */
#define K_SENSE	1		/* sense key */
#define K_SHIFT	2		/* read shift status */
#define K_XREAD	0x10	/* extended read key */
#define K_XSENSE	0x11	/* extended sense key */
#define K_XSHIFT	0x12	/* extended read shift status */
#define KSTAT_S	3		/* shift status */
#define KSTAT_C	4		/* control status */
#define KSTAT_A	8		/* alt status */
#define ZF			0x40	/*8086/8 zero flag in flags word */

int GetKey(char *pcControl)
{
	int ch = -1,shift;
	char cPrint = (char)(*pcControl > 1);

	_AH = K_XSENSE;
	geninterrupt(KEYBOARD);
	if (!(_FLAGS & ZF)) {
		_AH = K_XREAD;
		geninterrupt(KEYBOARD);
		ch = _AX;
		_AH = K_XSHIFT;
		geninterrupt(KEYBOARD);
		shift = _AX;
		*pcControl = (char)(shift & KSTAT_C ? 1 : 0);
		if (cPrint) {
			unsigned char asc = ch & 0xff;
			printf("%04x       %02x %c ",ch,asc,isgraph(asc) ? asc : '.');
			printf("%04x\n",shift);
		}
	}
	return ch;
}

