//
//   $Id: ENET.H 1.2 2002/10/16 16:40:06Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/* ENET.H
Generic Ethernet constants and templates
Updated @ Date 29 June 1993, 20:39 by Gerrit van Niekerk
*/

#define	EADDR_LEN	6
/* Format of an Ethernet header */
struct ether {
	BYTE dest[EADDR_LEN];
	BYTE source[EADDR_LEN];
	WORD type;
};
#define	ETHERLEN	14

/* Ethernet broadcast address */
extern BYTE ether_bdcst[];

/* Ethernet type fields */
#define	IP_TYPE		0x800	/* Type field for IP */
#define	ARP_TYPE	0x806	/* Type field for ARP */

/* ISO type fields */
#define	IPSAP		96	/* global SAP for IP */
#define	UI		3	/* unnumbered info frame */
#define ISOLEN		17

/* IEEE 802.x fields (RFC 1042) */
#define IEEESAP		170	/* SAP for IEEE IP */
#define ID_LEN		3	/* Protocol ID length in SNAP header */
#define IEEE_LEN	22

#define	RUNT		60	/* smallest legal size packet, no fcs */
#define	GIANT		1514	/* largest legal size packet, no fcs */

#define	MAXTRIES	16	/* Maximum number of transmission attempts */

struct mbuf *htonether(struct ether *ether);
struct mbuf *htoniso(struct ether *ether,WORD len);
struct mbuf *htontoken(struct ether *ether,BYTE *rif);
ntohether(struct ether *ether,struct mbuf **bpp);
ntohtoken(struct ether *ether,struct mbuf **bpp,BYTE *rif);
void pether(char *out,BYTE *addr);
void gether(BYTE *out,char *cp);
void gaether(BYTE *out,char *in[],int cnt);
