//
//   $Id: FTPS.H 1.3 2003/05/21 23:31:40Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
FTPS.H
Updated @ Date 27 May 1996, 10:44 by Gerrit van Niekerk
*/

#define CTLZ	26		/* EOF for CP/M systems */

extern char userfile[];	/* List of user names and permissions */

/* Per-session control block */
struct ftp {
	struct ftp *prev;	/* Linked list pointers */
	struct ftp *next;
	int id;
	unsigned control;	/* TCP control connection */
	char state;
#define	COMMAND_STATE		0	/* Awaiting user command */
#define	SENDING_STATE		1	/* Sending data to user */
#define	SENDING_STATE_WPOK	2	/* Wait for PORT OK before Sending */
#define	SEND_RDY_STATE		3	/* Sending, server ready */
#define	SENT_STATE			4	/* Finished sending, waiting for 226 */
#define	LIST_STATE_WTOK		5	/* Wait for TYPE OK before Listing */
#define	LIST_STATE_WPOK		6	/* Wait for PORT OK before Listing */
#define	LIST_STATE			7	/* Listing remote files to get */
#define	LIST_RDY_STATE		8	/* Listing, server ready */
#define	LISTED_STATE_WTOK	9	/* Listing done, waiting for TYPE OK */
#define	LISTED_STATE		10	/* Listing done, waiting for 226 */
#define	RECEIVING_STATE_WPOK 11	/* Wait for PORT OK before Storing */
#define	RECEIVING_STATE		12	/* Storing data from other side */
#define	RECV_RDY_STATE		13	/* Receiving, server ready */
#define	RECEIVED_STATE		14	/* Finished receiving data from user */
#define	REPLY_STATE			15	/* Waiting for reply from raw line */
#define	COMMAND_STATE_WTOK	16	/* waiting for TYPE OK */
#define	RCVLIST_STATE_WPOK	17	// wait for PORT OK before LIST
#define	RCVNLST_STATE_WPOK	18	// wait for PORT OK before NLST
	char type;		/* Transfer type */
#define	IMAGE_TYPE	0
#define	ASCII_TYPE	1
	char mode;

	FILE *fp;				/* File descriptor being transferred */
	struct socket port;		/* Remote port for data connection */
	int data;				/* Data connection */
	unsigned time;			/* time of transfer start */

	/* The following are used only by the server */
	char *username;			/* Arg to USER command */
	char *path;				/* Allowable path prefix */
	char perms;				/* Permission flag bits */
#define	FTP_READ	1		/* Read files */
#define	FTP_CREATE	2		/* Create new files */
#define	FTP_WRITE	4		/* Overwrite or delete existing files */
#define	FTP_DIRECTORY	8	/* access any directory or disk */

	char *buf;				/* Input command buffer */
	int cnt;				/* Length of input buffer */
	char *dbuf;				// data buffer
	char *dbufc;			// data buffer current pointer
	int dcnt;				// data buffer count
	char *cd;				/* Current directory name */

	FILE *fplist;			/* listing file for multi-file xfers */
	char *linebuf;			/* buffer for assembling a line from TCP */
	int lbindex;			/* line buffer index */
	int flags;				/* various control flags */
#define FF_NOPATH		1		/* no path in filename */
#define FF_APPEND		2		/* append rather than store */
#define	FF_WPOK		4		// wait for port OK
#define FF_PASV		8		// using passive mode
#define FF_CLIENT		0x10	// this is a client
#define	FF_SNDEOF	0x20	// eof while sending
	int error;				/* data error on read or write */
	char *oldname;			/* old name to rename from */
	char *remotename;		/* filename of remote file */
	char *filename;			// filename of file being received
	int status;				// status
	char status_line[100];	// status line
};

#define	NULLFTP	(struct ftp *)0

#define	LNBFLEN		100		/* line buffer length */
#define CBUFSZ		100		// control buffer size
#define DBUFSZ		500		// data buffer size
// prototypes and shared variables

int Tprintf(struct ftp *ftp,char *fmt,...);
void FtpDataReceiveHandler(struct ftp *ftp);
void FtpDataTransmitHandler(struct ftp *ftp);
void _loadds far FtpControlStateChange(WORD tcbo,char oldstate,char newstate);
int SendTcp(unsigned tcbo,char *buf,int cnt);
int RecvTcp(unsigned tcbo,char *buf,int cnt);
int CloseTcp(unsigned tcbo);
int DelTcp(unsigned tcbo);
int ResetTcp(unsigned tcbo);
char *err(unsigned errcode);	// return errorcode string
void schedule(void);
struct ftp *ftp_create(void);
void ftp_delete(struct ftp *ftp);
void FtpControlStateChangeHandler(void);
unsigned OpenTcpData(struct ftp *ftp,char receive);
WORD OpenTcp(
struct socket *lsocket,	/* Local socket */
struct socket *fsocket,	/* Remote socket */
int mode,				/* Active/passive/server */
WORD window,			/* Receive window (and send buffer) sizes */
void (far *r_upcall)(WORD handle,WORD cnt),	/* Function to call when data arrives */
void (far *t_upcall)(),	/* Function to call when ok to send more data */
void (far *s_upcall)(WORD control,char old,char new),	/* Function to call when connection state changes */
char tos,
char *user);			/* User linkage area */
extern unsigned serv_tcb;
extern unsigned numcon;		// number of connections
extern unsigned tcbs;
extern struct ftp *ftps;	// start of ftp chain
extern struct ftp *ftpe;	// end of ftp chain
extern char must_schedule;
extern long ip_addr;
extern int	g_status;			// global status

int OpenFTP(FTPPar far *pf);
int CloseFTP(FTPPar far *pf);
int SendFTPCom(FTPPar far *pf);
int GetFile(FTPPar far *pf);
int GetDir(FTPPar far *pf);
int SendFile(FTPPar far *pf);
int CheckStatus(FTPPar far *pf);
int SetType(FTPPar far *pf);
struct ftp *get_ftp(FTPPar far *pf);

WORD resident(void);
void resinit(void);
void FtpControlReceiveHandler(struct ftp *ftp);
void terminate(int iNoConfirm);
void ftp_client(struct ftp *ftp);
void status(WORD seg, WORD off);
void close_all(void);
int startget(struct ftp *ftp,char *locname,char *rname);
void xstatus(int flags);
void resterm(void);



