//
//   $Id: IFACE.H 1.4 2002/10/16 16:40:06Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
	IFACE.H

	Copyright (C) 2001 Datalight, Inc.
	All Rights Reserved
	Datalight Proprietary and Confidential
	Some portions Copyright (c) GPvNO, 2001

	Interface control structure

	Revision History:

	09/16/2002 gvn DHCP ARP followed by gratuitous ARP
	05/25/2001 gvn added PPP trace constant.
	??/??/???? ??? original revision
*/

#ifndef __IFACE_H
#define __IFACE_H
#ifndef __TIMER_H
#include "timer.h"
#endif
#ifndef __NETUSER_H
#include "netfunc.h"
#endif
typedef struct interface {
	struct interface *next;	/* Linked list pointer */
	char *name;			/* Ascii string with interface name */
	WORD mtu;			/* Maximum transmission unit size */
	int (*ioctl)(struct interface *ifp,int argc,char *argv[]);
						/* Function to handle device control */
	void (*send)(		/* Routine to send an IP datagram */
		struct mbuf *bp,struct interface *ifp,DWORD gateway,char precedence,
		char delay,char throughput,char reliability);
	int (*output)(		/* Routine to send link packet */
		struct interface *interface,BYTE *dest,BYTE *source,WORD type,
		struct mbuf *bp,BYTE *rif);
	int (*raw)(			/* Routine to call to send raw packet */
		struct interface *ifp,struct mbuf *bp);
	void (*recv)(		/* Routine to kick to process input */
		struct interface *ifp);
	void (*stop)(		/* Routine to call before detaching */
		struct interface *ifp);
	int (*xmit)(		/* Routine to xmit on serial link */
		struct interface *ifp,BYTE *buf,WORD cnt);
	int (*stxrdy)(		/* Routine to test for xmit ready */
		struct interface *ifp);
	int (*srecv)(		/* Routine for receiving from serial link */
		struct interface *ifp,char *buf,WORD cnt);
	WORD dev;				/* Subdevice number to pass to send */
	void *dcb;				/* device control block */
	void *indcb;			/* input device control block */
	void *prot_ext;		// protocol extension (used for PPP)
	void *mbuf;				/* general purpose buffer pointer */
	WORD flags;			/* Configuration flags */
#define	DIGI_FLAG		0x0001	/* Digiboard is the interface */
#define 	MDD_FLAG			0x0002	// Multi Destination Driver
#define	IEEE_FLAG		0x0004	/* Use IEEE encapsulation */
#define	X25_FLAG			0x0008	/* Using X.25 driver */
#define	LCS_FLAG			0x0010	/* LCS is the device */
#define	ETH_FLAG			0x0020	/* Ethernet interface */
#define	IPX_FLAG			0x0040	/* IPX interface */
#define	SECUR_FLAG		0x0080	/* Security bit set */
#define	TOKEN_FLAG		0x0100	/* Token ring */
#define 	PPP_FLAG			0x0200	// PPP
#define	DHCPI_FLAG		0x0400	// Use DHCPINFORM
#define	NAT_FLAG			0x0800	// perform Network Address Translation
#define	GARP_FLAG		0x1000	// gratuitous ARP
#define	TIMER_FLAG		0x2000	// restart timer
	WORD sflags;			// serial flags
#define	SF_RAW			0x0001
#define	SF_INUSE			0x0002
#define	SF_LAPB			0x0004	/* Use LAPB over SLIP */
#define	SF_FTP			0x0008	/* used for raw FTP */
#define	SF_TELNET		0x0010	/* used for raw TELNET */
#define	SF_PASSFC		0x0020	/* pass flow control characters on */
#define	SF_DELIVER		0x0040	/* deliver raw data */
#define	SF_CLOSEBREAK 	0x0080	/* Close on break */
#define 	SF_UNC			0x0100	// uncommitted
#define 	SF_COMPRESS		0x0200	// use compression
#define	SF_ASSIGNED_AD	0x0400	// using an assigned address
#define	SF_PPP_TRACE	0x0800	// tracing PPP file - ignore data
	WORD gpvar;				/* General purpose variable */
	WORD trace;				/* Trace flags */
#define	IF_TRACE_OUT	0x01	/* Output packets */
#define	IF_TRACE_IN 	0x10	/* Packets to me except broadcast */
#define	IF_TRACE_COMP	0x80	/* dump compressed packets */
#define	IF_TRACE_CHAR	0x100	/* Dump data in char */
#define	IF_TRACE_DATA 	0x200	/* Dump data in char/hex */
#define	IF_TRACE_HEX	0x400	/* Dump packets in hex/char */
#define	IF_TRACE_RAW	0x800	/* Dump packets with no header */
#define	IF_TRACE_TIME	0x1000	/* Dump packets with time info */
#define	IF_TRACE_EBCD	0x2000	/* Dump data in ebcdic */
#define	IF_TRACE_NOBC	0x4000	/* Dont dump broadcast traffic */
#define	IF_TRACE_STAT	0x8000	/* dump statistics in binary */

	BYTE *hwaddr;				/* Device hardware address, if any */
	DWORD ip_addr;				/* Our IP address */
	TIMER timer;				// interface timer
	WORD up_time;				// timeout for UP status
	WORD down_time;			// timeout for DOWN (!UP) status
	DWORD ip_query; 			// IP address to query
	char stat;					// Status of the interface
#define IF_UP			1		// interface is up
#define IF_QUERY		2		// query UP status
#define IF_NORIPADV 	4		// no RIP advertise
#define IF_NORIPUSE	8		// no RIP use
#define IF_THIS_RIP	0x10	// this is a RIP
#define IF_LAST_RIP	0x20	// last was a rip
#define IF_DISC      0x40  // disconnect X.25 on next timeout
#define IF_DISABLED	0x80	// disabled from sending
	char netbits;					// number of bits in netmask
	char hwtype;					// hardware type
	char hwalen;					// hardware address length
	char dhcp_state;
#define D_NONE				0		// don't use DHCP or BOOTP
#define D_BOOTP			1		// use BOOTP
#define D_INIT				2		// DHCP INIT state
#define D_SELECTING		3
#define D_REQUESTING    4
#define D_BOUND         5
#define D_RENEWING      6
#define D_REBINDING     7
#define D_DECLINING		8
#define D_INFORMING		9
	TIMER t1;						// DHCP timer, used for re-xmit, T1 and T2
	DWORD dhcp_server;
	char send_retry;				// DHCP send_retry
	struct socket lsock;
	unsigned long start_time;	// time starting BOOTP/DHCP
	unsigned long xid;			// time of last BOOTP/DHCP, also xid
	unsigned long renew;			// renew_time
	unsigned long rebind;      // rebind_time
	unsigned long lease;			// lease_time
	unsigned long TempIP;
#ifdef NAT
	DWORD	dwIpExternal;			// External NAT address
	DWORD dwIpInternal;			// Internal NAT address
	DWORD	dwNatMask;				// Network mask of NAT address
#endif
} IFACE;
#define	NULLIF	(struct interface *)0
extern struct interface *ifaces;	/* Head of interface list */
#define NETMASK(n) (0xfffffffful << (32 - n))
#define HOSTMASK(n) (0xfffffffful >> n)


/* generic IOCTL calls */

#define IOCTL_CONNECT		0	// start dial on ASY
#define IOCTL_DISCONNECT	1	// drop modem on ASY
#define IOCTL_ENABLEPORT	2 	// enable port on ASY
#define IOCTL_DISABLEPORT  3	// disable port on ASY
#define IOCTL_ENABLEDOD    4	// enable-dial-on-demand
#define IOCTL_DISABLEDOD   5	// disable dial-on-demand
#define IOCTL_GETSTATUS    6	// get dial status
#define IOCTL_PPP_OPEN		7	// Open PPP
#define IOCTL_PPP_START		8	// Start PPP
#define IOCTL_PPP_CLOSE		9	// Close PPP
#define IOCTL_HOTSWAP		10	// re-read MAC address after hot swap
#define IOCTL_REL_RSC		20	/* release resources */
#define IOCTL_STP_TMR		21	/* stop timer */
#define IOCTL_GET_CNT		22	/* get receive byte count */
#define IOCTL_PROD_OUTPUT 	23  /* try and start xmit */
#define IOCTL_CLEAR_BREAK 	24	/* clear line break condition */
#define IOCTL_SETMULTICAST	25	// Set multicast table

#define  NAMESIZE	20
#define  TYPESIZE	20
#define  CLASSSIZE	20
#define  HOSTNAMESZ	40
#define	 FLOWSIZE	4

typedef struct {
	char name[NAMESIZE];
	char type[TYPESIZE];
	char Class[CLASSSIZE];
	char ip_addr[HOSTNAMESZ];
	char query_addr[HOSTNAMESZ];
	char ldte[HOSTNAMESZ];
	char rdte[HOSTNAMESZ];
	int mtu;
	int timeout;
	int buflim;
	int numbuf;
	int bufsize;
	int intvec;
	int ioad;
	WORD speed;
	char modem_file[HOSTNAMESZ];
	char oflow[FLOWSIZE];
	char iflow[FLOWSIZE];
	char parity[FLOWSIZE];
	int	stopbits;
	int databits;
	char rip_advertise;
	char rip_use;
	int call_only;
	WORD up_time;
	WORD down_time;
	int netlen;
} InterfaceDesc;

IFACE *if_lookup(char *name);
void if_add(IFACE *ifp);
void if_mark_up(IFACE *ifp,int flag);
void if_mark_down(IFACE *ifp);

#endif
