//
//   $Id: IGMP.H 1.2 2002/10/16 16:40:06Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
// IGMP.H
// Internet Group Management Protocol
// Copyright (c) GP van Niekerk Ondernemings 1999


// Message types

#define IGMP_QUERY	0x11		// Membership Query
#define IGMP_REPORT2	0x16		// Version 2 Membership Report
#define IGMP_LEAVE	0x17		// Leave Group
#define IGMP_REPORT1	0x12		// Version 1 Membership Report

#define ALL_SYSTEMS	0xe0000001l// all-systems group address
#define ALL_ROUTERS	0xe0000002l// all-routers group address
#define	IGMPLEN		8	// Length of IGMP part

// multicast group structure

typedef struct s_group_ad {
	struct s_group_ad *psNext;	// pointer to next group address structure
	DWORD dwGroupAddr;			// the group address
	IFACE *psIface;				// the interface used for this group address
	WORD wUseCount;				// the number of users of the group address
	TIMER sTimer;					// the report timer
	BYTE bState;					// state of the group address
#define IGMP_IDLE			0
#define IGMP_DELAYING	1
	BYTE bLastReport;          // we sent the last report
} GROUP_AD;

extern GROUP_AD *psGroupAdFirst;	// pointer to chain of group addresses
extern WORD wNoMulticastEcho;

// prototypes

void igmp_input(IFACE *ifp,
MBUF *pmb,		// Pointer to IGMP message
BYTE protocol,	// Should always be IGMP_PTCL
DWORD source,	// Sender of IGMP message
DWORD dest,		// Us
char tos,		// Type of Service
WORD length,	// Length of IGMP message
char rxbroadcast);
void igmp_output(DWORD dwDest,BYTE bType,BYTE bMaxResp,DWORD dwGroupAddr);
int JoinGroup(DWORD dwGroupAddr,DWORD dwIFAddr);
int LeaveGroup(DWORD dwGroupAddr,DWORD dwIFAddr);
