//
//   $Id: MBUF.H 1.3 2002/10/16 16:40:06Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
 * MBUF.H
 *
 * Copyright (c) 2001 Datalight, Inc
 * All Rights Reserved
 * Datalight Confidential and Proprietary
 * Portions Copyright(c) 2001 GPvNO
 *
 * Basic message buffer structure
 *
 * Revision History
 * 07/23/2001 gvn added memory allocation tracing capability
 * Updated @ Date 13 October 1993, 14:2 by Gerrit van Niekerk
*/
#ifndef	__MBUF_H
#define	__MBUF_H

typedef struct mbuf {
	struct mbuf *next;	/* Links mbufs belonging to single packets */
	struct mbuf *anext;	/* Links packets on queues */
	BYTE *data;				/* Active working pointers */
	WORD cnt;
} MBUF;
#define	NULLBUF	(struct mbuf *)0
#define	NULLBUFP (struct mbuf **)0

#define	AUDIT(bp)	audit(bp,__FILE__,__LINE__)

void hex_dump(),ascii_dump();
#ifndef ALLOC_TRACE
#define alloc_mbuf(size,id) Alloc_mbuf(size)
#define dup_p(hp,bp,offset,cnt,id) Dup_p(hp,bp,offset,cnt)
#define copy_p(bp,cnt,id) Copy_p(bp,cnt)
#define qdata(data,cnt,id) Qdata(data,cnt)
struct mbuf *Alloc_mbuf(WORD size);
WORD Dup_p(struct mbuf **hp,struct mbuf *bp,WORD offset,WORD cnt);
struct mbuf *Copy_p(struct mbuf *bp,WORD cnt);
struct mbuf *Qdata(BYTE *data,WORD cnt);
#else
#define alloc_mbuf(size, id) Alloc_mbuf(size,id)
#define dup_p(hp,bp,offset,cnt,id) Dup_p(hp,bp,offset,cnt,id)
#define copy_p(bp,cnt,id) Copy_p(bp,cnt,id)
#define qdata(data,cnt,id) Qdata(data,cnt,id)
struct mbuf *Alloc_mbuf(WORD size,unsigned id);
WORD Dup_p(struct mbuf **hp,struct mbuf *bp,WORD offset,WORD cnt,unsigned id);
struct mbuf *Copy_p(struct mbuf *bp,WORD cnt,unsigned id);
struct mbuf *Qdata(BYTE *data,WORD cnt,unsigned id);
#endif
struct mbuf *free_mbuf(struct mbuf *bp);
struct mbuf *free_p(struct mbuf *bp);
void free_q(struct mbuf **q);
WORD len_mbuf(struct mbuf *bp);
WORD len_q(struct mbuf *bp);
void trim_mbuf(struct mbuf **bpp,WORD length);
WORD pullup(struct mbuf **bph,BYTE *buf,WORD cnt);
int append(struct mbuf **bph,struct mbuf *bp);
void enqueue(struct mbuf **q,struct mbuf *bp);
struct mbuf *dequeue(struct mbuf **q);
WORD dqdata(struct mbuf *bp,BYTE *buf,unsigned cnt);
DWORD pull32(struct mbuf **bpp);
WORD pull16(struct mbuf **bpp);
int pullchar(struct mbuf **bpp);
BYTE *put32(BYTE *cp,DWORD x);
BYTE *put16(BYTE *cp,WORD x);

#endif
