//
//   $Id: NETFUNC.H 1.3 2003/07/30 20:34:50Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/* NETUSER.H
Global structures and constants needed by an Internet user process
Updated @ Date 5 March 1996, 14:53 by Gerrit van Niekerk
*/

#ifndef __NETUSER_H
#define __NETUSER_H

extern char hosts[]; 	/* Host table */

#define	NCONN	20		/* Maximum number of open network connections */

extern int net_error;	/* Error return code */
#define	NONE	0		/* No error */
#define	CON_EXISTS	1	/* Connection already exists */
#define	NO_CONN	2		/* Connection does not exist */
#define	CON_CLOS	3	/* Connection closing */
#define	NO_SPACE	4	/* No memory for TCB creation */
#define	WOULDBLK	5	/* Would block */
#define	NOPROTO		6	/* Protocol or mode not supported */
#define	INVALID		7	/* Invalid arguments */

/* Codes for the tcp_open call */
#define	TCP_PASSIVE	0
#define	TCP_ACTIVE	1
#define	TCP_SERVER	2	/* Passive, clone on opening */

/* Socket structure */
#define SOCKET_DEF
typedef struct socket {
	DWORD address;		/* IP address */
	WORD port;			/* port number */
} SOCKET;

/* Connection structure (two sockets) */
typedef struct connection {
	struct socket local;
	struct socket remote;
} CONNECTION;
#define	NULLSOCK	(struct socket *)0

/* TCP port numbers */
#define	ECHO_PORT	7	/* Echo data port */
#define	DISCARD_PORT	9	/* Discard data port */
#define	FTPD_PORT	20	/* FTP Data port */
#define	FTP_PORT	21	/* FTP Control port */
#define TELNET_PORT	23	/* Telnet port */
#define SMTP_PORT	25	/* Mail port */
#define RLOGIN_PORT	513

DWORD aton(register char *s);
DWORD resolve_dns(char *name);
DWORD resolve(char *host);
char *host_select(int x,int y);
char *inet_ntoa(DWORD addr);
char *psocket(struct socket *s);
long htol(char *s);
int is_dotted_decimal(char *host);

#endif
