//
//   $Id: PKTDRV.H 1.2 2002/10/16 16:40:06Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/* PKTDRV.H
	Packet driver header file
	Updated @ Date 18 October 1995, 14:31 by Gerrit van Niekerk
*/

#define DRIVER_INFO			1
#define ACCESS_TYPE			2
#define RELEASE_TYPE			3
#define SEND_PKT				4
#define TERMINATE				5
#define GET_ADDRESS			6
#define RESET_INTERFACE 	7
#define GET_PARAMETERS  	10	/* high-performance */
#define AS_SEND_PKT			11	/* high-performance */
#define SET_RCV_MODE			20	/* extended */
#define GET_RCV_MODE			21	/* extended */
#define SET_MULTICAST_LIST	22	/* extended */
#define GET_MULTICAST_LIST	23	/* extended */
#define GET_STATISTICS     24	/* extended */
#define SET_ADDRESS			25	/* extended */

#define CLASS_DIX		1
#define CLASS_PRONET		2
#define CLASS_8025		3
#define CLASS_SLIP		6
#define CLASS_ARC		8
#define CLASS_8023		11
#define CLASS_X25		13

/* Error codes */

#define BAD_HANDLE      1	/* Invalid handle number */
#define NO_CLASS			2	/* No interfaces of specified class found */
#define NO_TYPE			3	/* No interfaces of specified type found */
#define NO_NUMBER			4	/* No interfaces of specified number found */
#define BAD_TYPE			5	/* Bad packet type specified */
#define NO_MULTICAST		6	/* This interface does not support multicast */
#define CANT_TERMINATE	7	/* This packet driver cannot terminate */
#define BAD_MODE			8	/* An invalid receiver mode was specified */
#define NO_MSPACE			9	/* Failed because of insufficient space */
#define TYPE_INUSE      10	/* The type had previously been accessed */
#define BAD_COMMAND		11	/* The command was out of range */
#define CANT_SEND			12	/* The packet couldn't be sent */
#define CANT_SET			13	/* Hardware address couldn't be changed */
#define BAD_ADDRESS		14	/* Hardware address has bad length or format */
#define CANT_RESET      15	/* Couldn't reset interface */

// NB NB NB Don't change anything without checking PDCBLEN in ptkrcv.asm !!!
typedef struct pdcb {		// Packet Driver Control Block
									// S	L
	IFACE *ifp;					// 2	4	interface pointer
	int arphandle;				// 2	2	ARP handle
	int iphandle;				// 2	2	IP handle
	struct mbuf *rcvq;		// 2	4	receive queue
	char rcvcnt;				// 1	1	receive count
	char rcvmax;				// 1	1	maximum receive count
	long rcvdcount;			// 4	4	number of frames received
	long sentcount;			// 4	4	number of frames sent
	unsigned vec;				// 2	2	H/W Interrupt vector
	void interrupt (*oldvec)(void);	// 4	4	Original interrupt h/w vector [cs:ip]
	long packets_dropped;	// 4	4	packets dropped (buffer err)
	struct mbuf *buffer;		// 2	4	current buffer
									//30   36
} PDCB;
// NB NB NB Don't change anything without checking PDCBLEN in ptkrcv.asm !!!

typedef struct pdpar {			/* Packet Driver parameters */
	unsigned char	major_rev;	/* Revision of Packet Driver spec */
	unsigned char	minor_rev;	/*  this driver conforms to. */
	unsigned char	length;		/* Length of structure in bytes */
	unsigned char	addr_len;	/* Length of a MAC-layer address */
	unsigned short	mtu;			/* MTU, including MAC headers */
	unsigned short	multicast_aval; /* Buffer size for multicast addr */
	unsigned short	rcv_bufs;	/* (# of back-to-back MTU rcvs) - 1 */
	unsigned short	xmt_bufs;	/* (# of successive xmits) - 1 */
	unsigned short	int_num;		/* Interrupt # to hook for post-EOI
											processing, 0 == none */
} PDPAR;

typedef struct pdstat {
	unsigned long	packets_in;	/* Totals across all handles */
	unsigned long	packets_out;
	unsigned long	bytes_in;	/* Including MAC headers */
	unsigned long	bytes_out;
	unsigned long	errors_in;	/* Totals across all error types */
	unsigned long	errors_out;
	unsigned long	packets_lost;/* No buffer from receiver(), card */
										/*  out of resources, etc. */
} PDSTAT;

#define CF	1						// 8086 carry flag
