;
;   $Id: API_INT.ASM 1.3 2003/01/07 22:57:24Z johnb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
page 50,132
TITLE 'API_INT.ASM'
;
;	This assembler routine provides an interface between the API
;	handler written in 'C' and the user program
;
;	2002-09-27 gvn Update DS on return
;

extrn	_api_inti_c : far
extrn	_api_int_c : far
extrn	_stack_pointer : word
extrn	_stack_segment : word
extrn	_in_tcp : word

public	_api_inti_a
public	_api_int_a

DGROUP	GROUP	_DATA

ASSUME	DS : DGROUP,	CS : _TEXT

_DATA	SEGMENT	WORD	PUBLIC	'DATA'
_DATA	ENDS

;
;	Start of Code
;

_TEXT	SEGMENT	WORD	PUBLIC	'CODE'

;
;	This routine is the API entry point.  It is called by the user
;
; User stack:
;	. Fl . CS . IP . BP . DS . DI
;	  10   8    6    4    2    ^
;                             BP
; INET stack:
;       . SS . SP . Fl . DS . SI . DI . AX . BX . CX . DX . ES .
;         ^    -2   -4   -6   -8  -10  -12  -14
;         DI
; Note:
;	DI is passed to INET but NOT udated before return to user
;	If required, it must be updated via SS:SP on INET stack

db	'Inet'

_api_inti_a	proc	far	;INET API entry
	push	bp
	push	ds
	push	di
	mov	di,20h			;mark INET interrupt
	jmp	short common
_api_inti_a	endp

db		'RinetI'
_api_int_a	proc	far	;FTP compatible entry
	jmp	skipmes
db		'TCPTSR'
skipmes:
	push	bp
	push	ds
	push	di
	mov	di,10h			;mark FTP compatible interrupt
common:
	MOV	bp, DGROUP		; Get Data Segment
	MOV	DS,bp				; Set up DS
	cli						;in case not done by real int
	mov	bp,sp
	test	_in_tcp,0fff0h
	jz		ok_to_enter
	mov	ax,27				;re_entry error
	or		byte ptr [bp+10],1	;set carry
	jmp	api_int_exit
ok_to_enter:
	push	ax
	mov	ax,[bp+10]		;get flags
	and	ax,0200h			;isolate interrupt bit
	or		di,ax
	pop	ax
	inc	_in_tcp
	or		_in_tcp,di
	mov	di, _stack_pointer
	mov	bp,ss
	mov 	ds, _stack_segment
	mov	[di],bp
	mov	[di-2],sp
	mov	bp,sp
	mov	[di-12],ax
	mov	ax,[bp+10]	;flags
	mov	[di-4],ax
	mov	ax,[bp+2]	;ds
	mov	[di-6],ax
	mov	[di-8],si
	mov	ax,[bp]		;di
	mov	[di-10],ax
	MOV	ax, DGROUP	; Get Data Segment
	MOV	DS,ax			; Set up DS
;now switch the stack
	sub	di,12
	mov	ss,_stack_segment
	mov	sp,di
	test	_in_tcp,0200h
	jz		int_not_set
	and	_in_tcp,0ffh
	sti
int_not_set:
	push	bx
	push	cx
	push	dx
	push	es
	mov	ax,sp
	push	ax	;DON'T push sp directly, it differs on 80x86's
	test	byte ptr _in_tcp,10h
	jnz	compat
	CALL	_api_inti_c
	jmp	short after
compat:	CALL	_api_int_c
after:	add	sp,2
	pop	es
	pop	dx
	pop	cx
	pop	bx
;switch stack back
	mov	ds,_stack_segment
	cli
	mov	ax,[di+12]	;ss
	mov	ss,ax
	mov	sp,[di+10]
	mov	ax,[di+8]	;flags
	mov	[bp+10],ax
	mov	ax,[di+6]	;ds
	mov	[bp+2],ax
	mov	ax,[di]
	mov	si,[di+4]
	MOV	di, DGROUP	; Get Data Segment
	MOV	DS,di		; Set up DS
	and	_in_tcp,0fh
	dec	_in_tcp
api_int_exit:
	pop	di
	pop	ds
	pop	bp
	iret

_api_int_a	endp

_TEXT	ENDS

	END

