//
//   $Id: COMMANDS.C 1.8 2002/10/24 21:03:10Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
// COMMANDS.C
// Command tables and various commands
// Copyright (c) GP van Niekerk Ondernemings 1990-1998
// Portions Copyright (c) 1986-1989 Phil Karn, KA9Q

#if APL==0
#pragma option -zAINETINIT
#pragma option -zFINETINIT
#endif

#define BUFSIZE	160	/* command buffer size */
extern char startupn[];	/* File to read startup commands from */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <io.h>
#include <stdarg.h>
#include <ctype.h>
#include <fcntl.h>
#include <sys\stat.h>
#include <dos.h>
#include <string.h>
#include <time.h>
#include <alloc.h>
#include <ctype.h>
#include "inetdefs.h"
#include "mbuf.h"
#include "netfunc.h"
#include "timer.h"
#include "iface.h"
#include "icmp.h"
#include "ip.h"
#include "tcp.h"
#include "commands.h"
#include "bootp.h"

#if APL
#define	TRACE	1
#include "log.h"
#include "twindow.h"
#include "session.h"
#include "demo.h"
#include "keys.h"
#include "ini.h"
#endif
#ifndef	INET_UTIL
#define	SERVERS	1
#endif
#include "cmdparse.h"
#ifdef TRACE
#include "trace.h"
#endif

#include "pc.h"
#include "task.h"

#ifdef TRACE
#include "trace.h"
/* Dummy structure for loopback tracing */
struct interface loopback = { NULLIF, "loopback" };
#endif
#if APL
char *altfunc[11];		// Alt key command pointers
extern int doscurx,doscury;		/* dos cursor on entry */
extern char conlogflag;		/* set to log all console output to log */
extern FILE *logfp;
#endif

extern int helping;
extern struct mbuf *loopq;

extern struct interface *ifaces;
extern char version[];
extern FILE *fpinput;		/* command input file */
extern int argcount;
extern char **argval;
extern char nospace[];
extern char *inbuff;

void showtrace(char *name,int trace);
void rc_close(void);
int dolapb(int argc,char *argv[]);
/* Command lookup and branch table */
int dotelnet(),dorlogin(),doexit(),doclose(),doclear(),dobootp(),
	doreset(),dotcp(),dotrace(),dohelp(),dodomain(),
	doroute(),dolog(),doip(),domenu(),domessage(),docheck(),dotelopt(),
	memstat(),doarp(),dosession(),doftp(),dostart(),dostop(),doiface(),
	domail(),doudp(),doparam(),doifstat(),doruser(int argc,char *argv[]),
	dodump(),dodb(),dokick(),doshell(),
	dodelete(),dorename(),dorip(),
	dodir(),docd(),doping(),dotest(),dohttp(),dousr(),
	doinput(),doterm(),dolapb(),doerror(),doemul(),dolist(),doexec(),
	dodate(),dotelterm(),dolpt(),dortm(),doalt(),x25_main(),dowait();

struct cmds far cmds[] = {
#if APL
	{"altkey",	doalt},
#endif
	{"arp",		doarp},
	{"bootp",	dobootp},
#if APL
	{"cd",		docd},
	{"check",	docheck},
	{"clear",	doclear},
	{"close",	doclose},
#if APL
	{"d",		dodb},
#endif
	{"date",		dodate},
	{"dir",		dodir},
	{"delete",	dodelete},
#endif
	{"domain",	dodomain},
#if APL
	{"dump",		dodump},
#endif
#ifdef X25
	{"eicon",	x25_main},
#endif
#if APL
	{"emulator",	doemul},
	{"error",	doerror},
	{"execute",	doexec},
	{"exit",		doexit},
#ifndef NOFTPC
	{"ftp",		doftp},
#endif
#endif
#ifdef HELP
	{"help",		dohelp},
#endif
#if APL
#ifdef HTTP_C
	{"http",		dohttp},
#endif
#endif
	{"iface",	doiface},
	{"interface",	doiface},
#if APL
	{"ifstatus",	doifstat},
	{"input",	doinput},
#endif
	{"ip",		doip},
#ifdef LAPB
	{"lapb",		dolapb},
#endif
#if APL
	{"list",		dolist},
	{"log",		dolog},
#ifdef SMTP
	{"mail",		domail},
#endif
	{"menu",		domenu},
	{"memstatus",	memstat},
	{"message",	domessage},
#endif
	{"parameter",	doparam},
#if APL
	{"ping",		doping},
#else
	{"printer",	dolpt},
#endif
#if APL
	{"prod",		dokick},
	{"pwd",		docd},
	{"rename",	dorename},
	{"reset",	doreset},
#endif
	{"rip",		dorip},
#if APL
	{"rlogin",	dorlogin},
#endif
	{"route",	doroute},
#if APL
	{"rtm",		dortm},
	{"session",	dosession},
	{"shell",	doshell},
#endif
#ifdef SERVERS
	{"start",	dostart},
	{"stop",		dostop},
#endif
	{"tcp",		dotcp},
#if APL
#ifndef NOTEL
	{"telnet",	dotelnet},
	{"telopt",	dotelopt},
#endif
#ifdef SERIAL
	{"telterm",	dotelterm},
#endif
	{"terminal",	doterm},
#ifdef TEST_C
	{"test",		dotest},
#endif
#endif
#ifdef TRACE
	{"trace",	dotrace},
#endif
#if APL
	{"udp",		doudp},
#endif
#if (APL || defined(USR))
	{"user",		dousr},
#endif
#if APL
	{"wait",		dowait},
#endif
	{"",		NULLFP},
};

#ifdef SERVERS
/* "start" and "stop" subcommands */
int dis1(),echo1(),ftp1(),smtp1(),tn1(),dh1(),ih1(),rc1(),rem1(),udpecho1();
int prntserv1(),lpdserv1(),lpddserv1(),http1();
static struct scmds far startcmds[] = {
#if APL
	{"discards",	dis1},
	{"echoserv",	echo1},
	{"ftpserv",	ftp1},
#ifdef IBM_S
	{"ibmserv",	ih1},
#endif IBM_S
#ifdef HTTP_S
	{"httpserv",	http1},
#endif HTTP_S
#ifndef NOPRN
	{"lpdserv", lpdserv1},
#endif NOPRN
#endif APL
#ifndef NOPRN
#ifdef LPDD
	{"lpdd", lpddserv1},
#endif LPDD
	{"prntserv",	prntserv1},
#endif NOPRN
#if APL
	{"remcons",	rc1},
	{"controls",	rem1},
#ifdef SERIAL
	{"serserv",	tn1},
#endif
#ifdef SMTP
	{"smtpserv",	smtp1},
#endif
#ifdef TEST_S
	{"testserv",	dh1},
#endif
	{"udpechos",	udpecho1},
#endif
	{"",		NULLFP},
};
int ftp_stop(),smtp_stop(),echo_stop(),tn_stop();
int dis0(),echo0(),ftp0(),smtp0(),tn0(),dh0(),ih0(),rc0(),rem0(),udpecho0();
int prntserv0(),http0();
int lpdserv0(),lpddserv0();
static struct scmds far stopcmds[] = {
#if APL
	{"discards",	dis0},
	{"echoserv",	echo0},
	{"ftpserv",	ftp0},
#ifdef IBM_S
	{"ibmserv",	ih0},
#endif
#ifdef HTTP_S
	{"httpserv",	http0},
#endif
#ifndef NOPRN
	{"lpdserv", lpdserv0},
#endif
#endif
#ifndef NOPRN
#ifdef LPDD
	{"lpdd",lpddserv0},
#endif
	{"prntserv",	prntserv0},
#endif
#if APL
	{"remcons",	rc0},
	{"controls",	rem0},
#ifdef SERIAL
	{"serserv",	tn0},
#endif
#ifdef SMTP
	{"smtpserv",	smtp0},
#endif
#ifdef TEST_S
	{"testserv",	dh0},
#endif
	{"udpechos",	udpecho0},
#endif
	{"",		NULLFP},
};
#endif

#if APL
WORD dumpseg = FP_SEG(&dumpseg);
WORD dumpoff;
// dump memory to screen
dodb(int argc,char *argv[])
{
	void abort();
	extern TIMER *timers;
	int cnt = 64,i;
	BYTE c;
	BYTE line[16];
	char *p;

	if (argc > 1) {
		if (argv[1][0] == 't') {	// dump timer
			TIMER *t;

			for (t = timers;t;t = t->next) {
				printf("%p func %04X:%04X arg %p %lu/%lu ms %s\n",
						t,!t->func ? 0 : FP_SEG(t->func) - FP_SEG(abort),
						!t->func ? 0 : FP_OFF(t->func),t->arg,
						(t->start - t->count) * (long)MSPTICK,
						t->start * (long)MSPTICK,
						t->state == TIMER_STOP ? "Stopped" :
						t->state == TIMER_RUN ? "Running" : "Expired");
			}
			return 0;
		}
		else if ((p = strchr(argv[1],':')) != 0) {
			++p;
			if (strnicmp(argv[1],"ds",2) == 0) {
				dumpseg = FP_SEG(&dumpseg) + htoi(argv[1] + 2);
				goto get_offset;
			}
			else if (strnicmp(argv[1],"cs",2) == 0) {
				dumpseg = FP_SEG(abort) + htoi(argv[1] + 2);
				goto get_offset;
			}
			else
				sscanf(argv[1],"%x:%x",&dumpseg,&dumpoff);
		}
		else {
			p = argv[1];
			get_offset:
			sscanf(p,"%x",&dumpoff);
		}
	}
	if (argc > 2)
		cnt = atoi(argv[2]);
	for (i = 0;cnt > 0;--cnt,++dumpoff) {
		if (i == 0) {
			printf("%04x:%04x ",dumpseg,dumpoff);
		}
		printf("%02x ",line[i] = *(char far *)MK_FP(dumpseg,dumpoff)) ;
		if (++i == 16) {
			for (i = 0;i < 16;++i) {
				c = line[i];
				printf("%c",isprint(c) ? c : '.');
			}
			i = 0;
			printf("\n");
		}
	}
	return 0;
}

/* dump memory */
dodump(int argc,char *argv[])
{
	if (argc == 2 && strcmp(argv[1],"dump") == 0)
		fatal("User requested dump");
	return -1;
}

/* Standard commands called from main */

setalt(int i,char *str)
{
	if (altfunc[i]) {
		free(altfunc[i]);
		altfunc[i] = 0;
	}
	if ((altfunc[i] = malloc(strlen(str) + 1,AllocComAltf)) == 0)
		return -1;
	strcpy(altfunc[i],str);
	return 0;
}

static doalt(int argc,char *argv[])
{
	int i,arg,len,tlen;
	char ch;
	char str[200];

	if (argc <= 1) {
		for (i = 0;i < 11;++i) {
			if (altfunc[i])
				printf("altkey %c %s\n",
						i == 10 ? 'x' : i + '0',
						altfunc[i]);
		}
		return 0;
	}
	ch = *argv[1];
	if (isdigit(ch))
		i = ch - '0';
	else if ((ch | 0x20) == 'x')
		i = 10;
	else
		return -1;
	str[0] = 0;
	for (arg = 2,tlen = 0;arg < argc;++arg) {
		len = strlen(argv[arg]);
		if ((tlen += (len + 1)) < 199) {
			strcat(str,argv[arg]);
			strcat(str," ");
		}
		else return -1;
	}
	if (tlen > 1) {
		str[tlen - 1] = 0;
		return setalt(i,str);
	}
	return 0;
}

#pragma argsused
doexit(int argc,char *argv[])
{
	extern char altconf;
	extern void restore_keyboard(void);
	int i;

#ifndef NORC
	if (altconf) {		/* remote logged on */
		rc_close();
		return 0;
	}
#endif
	for (i = 100;i;i--)
		schedule();
	if (tcp_active()) {
		if (argc < 2 && !enter_confirm(
				"Abort active connections ?",43,6)) {
			return 0;
		}
		tcp_resetall();
		for (i = 100;i;i--)
			schedule();
	}
	if(logfp != NULLFILE)
		fclose(logfp);
	iostop();
	close_all();		/* remove all windows */
	cursor(doscurx,doscury);
	restore_palette();
	restore_keyboard();
	exit(0);
	return 0;		// for compiler warning
}

static doerror(int argc,char *argv[])
{
	extern char error_fail;
	char opt;

	if(argc < 2)
		printf(error_fail ? "Fail on error\n" : "Operator intervention on error\n");
	else if ((opt = toupper(*argv[1])) == 'F')
		error_fail = 1;
	else if (opt == 'O')
		error_fail = 0;
	else
		return -1;
	return 0;
}
static doinput(int argc,char **argv)
{
	extern char custom_menu_flag;
	extern char input_flag;
	static char allocated;
	int cnt,i;
	char *ptr;
	char **argvn;

	if (allocated) {
		free(argval);
		argcount = 0;
		allocated = 0;
	}
	if (fpinput) {
		fclose(fpinput);
		fpinput = 0;
	}
	if(argc > 1) {
		if ((fpinput = fopen(argv[1],"rt")) == NULL) {
			printf("Open error: %s\n",argv[1]);
			return -1;
		}
		cnt = sizeof(char **);
		for (i = 1;i < argc;++i)
			cnt += (strlen(argv[i]) + sizeof(char **) + 1);
		if ((argval = argvn = (char **)malloc(cnt,AllocComArgs)) == 0) {
			printf(nospace);
			return -1;
		}
		allocated = 1;
		argcount = argc - 1;
		ptr = (char *)(argval + argc);
		for (i = 1;i < argc;++i) {
			*argvn++ = ptr;
			strcpy(ptr,argv[i]);
			ptr += (strlen(ptr) + 1);
		}
		*argvn = 0;
		input_flag = 1;
		custom_menu_flag = 0;
	}
	return 0;
}

#define TPSEC (1000 / MSPTICK)

typedef struct {
	TIMER *pt;	/* pointer to timer */
	char name[1];	/* start of name */
} TARG;

void checktimeout(TARG *parg);

static docheck(int argc,char *argv[])
{
	TIMER *pt;
	TARG *parg;
	WORD time;

	if (argc < 3 || (time = atoi(argv[2])) == 0)
		return -1;
	if ((pt = (TIMER *)calloc(1,sizeof(TIMER),AllocComTimer)) == 0 ||
		(pt->arg = (char *)malloc(sizeof(TARG) + strlen(argv[1]),AllocComTimerArg)) == 0) {
		return -1;
	}
	parg = (TARG *)pt->arg;
	parg->pt = pt;
	strcpy(parg->name,argv[1]);
	pt->func = (void(*)(char *))checktimeout;
	pt->start = time * TPSEC;
	start_timer(pt);
	return 0;
}

void checktimeout(TARG *parg)
{
	if (access(parg->name,0) == 0) {
		start_timer(parg->pt);
		return;
	}
	log(0,"Check failed on '%s'",parg->name);
	tcp_resetall();
	if(logfp != NULLFILE)
		fclose(logfp);
	iostop();
	sysreset();
}

#pragma argsused
static doclear(int argc,char *argv[])
{
	winclear();
	return 0;
}
#endif
int getfline(char **buf)		/* get a line from input file */
{
	int len;

	if (fpinput) {
		if ((*buf = fgets(inbuff,BUFSIZE,fpinput)) != NULL
#if APL
											&& test_key() != ALT_X
#endif
																	) {
			len = strlen(inbuff);
			if (inbuff[len - 1] == '\n')
				len--;
			inbuff[len++] = '\r';
			inbuff[len++] = '\n';
			inbuff[len] = 0;
			repargs(inbuff,BUFSIZE);
			return strlen(inbuff);
		}
		fclose(fpinput);
		fpinput = 0;
	}
	return -1;
}
#if APL
static int dolist(int argc,char *argv[])
{
	FILE *fp;
	char str[100];

	if (argc > 1) {
		if ((fp = fopen(argv[1],"rt")) == NULLFILE && argc == 2) {
			printf("File not found: '%s'\n",argv[1]);
		}
		else {
			while (fgets(str,90,fp) != NULL)
				printf("%s",str);
			fclose(fp);
		}
	}
	return 0;
}

static char logname[30];

static int dolog(int argc,char *argv[])
{
//	char *strncpy();

	if(argc < 2){
		if(logfp)
			printf("Logging to %s\n",logname);
		else
			printf("Logging off\n");
		return 0;
	}
	if(logfp){
		fclose(logfp);
		logfp = NULLFILE;
	}
	if(strcmp(argv[1],"stop") != 0){
		strncpy(logname,argv[1],29);
		logfp = fopen(logname,"a+b");
		log(0,"log started");
	}
	conlogflag = (argc > 2);
	return 0;
}

int check_log_del(char *name)	// delete logfile gracefully
{
	if (logfp && strcmp(name,logname) == 0) {
		fclose(logfp);
		unlink(name);
		logfp = fopen(logname,"a+b");
		log(0,"log deleted");
		return 1;
	}
	return 0;
}
#endif
#ifdef HELP
static int dohelp(int argc,char *argv[])
{
	struct cmds far *cmdp;
	int i,j;

	printf("Commands:\n");
	for(i=0,cmdp = cmds;cmdp->name[0] != 0;cmdp++,i++){
		printf("%.9Fs",cmdp->name);
		if((i % 4) == 3)
			printf("\n");
		else {
			for (j = 0;cmdp->name[j] && j < 9;++j);
			for (;j < 16; j++)
				printf(" ");
		}
	}
	if((i % 4) != 0)
		printf("\n");
	return 0;
}
#endif

/* Define an interface
 * Syntax: iface <hw type> <label> <mode> <mtu> <bufsize>
					[<I/O address> <vector> <speed>]
 */
extern struct scmds far attab[];

doiface(int argc,char *argv[])
{
	return subcmd(attab,argc,argv,0);
}

#ifdef INI_FILE

int no_ini(),ser_ini(),pdr_ini(),x25_ini();

// NB NB NB This table MUST syncronize with the attab[] table

int (*tab_ini[])() = {
#ifdef ETHER
	/* 3-Com Ethernet interface */
	/*"en3c",*/ no_ini,

	/* PunchLAN ethernet interface */
	/*"pl100",*/ no_ini,

	/* ELAN ethernet interface */
	/*"el100",*/ no_ini,

	/* Novell ethernet interfaces */
	/*"ne1000",*/ no_ini,

	/*"ne2000",*/ no_ini,

	/* Western Digital ethernet interface */
	/*"wd8003",*/ no_ini,
#endif
#ifdef NETB
	/* Netbios interface */
	/*"nb",*/ no_ini,
#endif
#ifdef IPX
	/* IPX interface */
	/*"ipx",*/ no_ini,
#endif
#ifdef ISOL
	/* ISOLINK interface */
	/*"isolink",*/ no_ini,
#endif
	/* PACKET DRIVER interface */
	/*"pdr",*/ pdr_ini,
#ifdef ASYNC
	/* Ordinary PC asynchronous adaptor */
	/*"asy",*/ ser_ini,
	/*"aslink",*/ser_ini,
	/*"mdd",*/ser_ini,
#endif
#ifdef SCC
	/* SCC async */
	/*"scc",*/ ser_ini,
#endif
#ifdef LCS
	/* LCS async */
	/*"lcs",*/ no_ini,
#endif
#ifdef DIGI
	/* Digiboard async */
	/*"digi",*/ no_ini,
#endif
#ifdef X25_S
	/* X25 resident driver */
	/*"x25",*/ x25_ini,
#endif
};

no_ini(InterfaceDesc *pif)
{
	printf("Interface type '%s' cannot be defined in INET.INI, use INET.STU\n",
		pif->type);
	return 0;
}

#define KEYBUFSZ	200

char *NextArg(char *psz);

void GetInterfaceDesc(InterfaceDesc *pInterface,char *ifname,char *ini_file)
{
	char i_ifname[60];
	char comport[8];

	if (strlen(ifname) >= NAMESIZE)
		ifname[NAMESIZE - 1] = 0;
	memset(pInterface,0,sizeof(InterfaceDesc));
	strcpy(pInterface->name,ifname);
	sprintf(i_ifname,"Interface:%s",ifname);
	GetPrivateProfileString("Interface",ifname,"pdr",pInterface->type,TYPESIZE,ini_file);
	// Interface0=pdr
	GetPrivateProfileString(i_ifname,"Type",pInterface->type,pInterface->type,TYPESIZE,ini_file);
	GetPrivateProfileString(i_ifname,"Class","dix",pInterface->Class,CLASSSIZE,ini_file);
	GetPrivateProfileString(i_ifname,"IPAddress","",pInterface->ip_addr,HOSTNAMESZ,ini_file);
	GetPrivateProfileString(i_ifname,"QueryAddress","",pInterface->query_addr,HOSTNAMESZ,ini_file);
	pInterface->mtu = GetPrivateProfileInt(i_ifname,"MTU",576,ini_file);
	pInterface->timeout = GetPrivateProfileInt(i_ifname,"TimeOut",0,ini_file);
	pInterface->buflim = GetPrivateProfileInt(i_ifname,"BufLim",10,ini_file);
	pInterface->numbuf = GetPrivateProfileInt(i_ifname,"NumBuf",10,ini_file);
	pInterface->bufsize = GetPrivateProfileInt(i_ifname,"BufSize",1000,ini_file);
	pInterface->intvec = GetPrivateProfileInt(i_ifname,"IntVec",0x60,ini_file);
	pInterface->ioad = GetPrivateProfileInt(i_ifname,"IOaddr",0x3f8,ini_file);
	pInterface->speed = GetPrivateProfileInt(i_ifname,"BaudRate",9600,ini_file);
	GetPrivateProfileString(i_ifname,"OutputFlow","CTS",pInterface->oflow,FLOWSIZE,ini_file);
	GetPrivateProfileString(i_ifname,"InputFlow","RTS",pInterface->iflow,FLOWSIZE,ini_file);
	GetPrivateProfileString(i_ifname,"Parity","",pInterface->parity,FLOWSIZE,ini_file);
	pInterface->databits = GetPrivateProfileInt(i_ifname,"DataBits",8,ini_file);
	pInterface->stopbits = GetPrivateProfileInt(i_ifname,"StopBits",1,ini_file);
	GetPrivateProfileString(i_ifname,"ModemFile","",pInterface->modem_file,HOSTNAMESZ,ini_file);
	GetPrivateProfileString(i_ifname,"LocalDTE","",pInterface->ldte,HOSTNAMESZ,ini_file);
	GetPrivateProfileString(i_ifname,"RemoteDTE","",pInterface->rdte,HOSTNAMESZ,ini_file);
	pInterface->rip_advertise = GetPrivateProfileInt(i_ifname,"RipAdv",1,ini_file);
	pInterface->rip_use = GetPrivateProfileInt(i_ifname,"RipUse",1,ini_file);
	pInterface->up_time = GetPrivateProfileInt(i_ifname,"UpTime",0,ini_file);
	pInterface->down_time = GetPrivateProfileInt(i_ifname,"DownTime",0,ini_file);
	pInterface->netlen = GetPrivateProfileInt(i_ifname,"NetBits",-1,ini_file);
	pInterface->call_only = GetPrivateProfileInt(i_ifname,"CallOnly",0,ini_file);
	GetPrivateProfileString(i_ifname,"ComPort","",comport,sizeof(comport),ini_file);
	if (*comport) switch (comport[3]) {
	case '1':
		pInterface->intvec = 4;
		pInterface->ioad = 0x3f8;
		break;
	case '2':
		pInterface->intvec = 3;
		pInterface->ioad = 0x2f8;
		break;
	default:
		printf("Invalid PORT: %s\n",comport);
		break;
	}
}

void ini_iface(char *sufname)
{
	char   	szKey[KEYBUFSZ];
	char   	*pszKey;
	int    	len;
	InterfaceDesc Interface;
	struct scmds far *scmdp;
	int (**func)(InterfaceDesc *pif);

	len = GetPrivateProfileString("Interface",NULL,"",szKey,KEYBUFSZ,sufname);
	if (len && *szKey) {
		for (pszKey = szKey; pszKey < szKey + len;
										pszKey += (strlen(pszKey) + 1)) {
			GetInterfaceDesc(&Interface,pszKey,sufname);
			if (*Interface.ip_addr)
				set_ip_addr(Interface.ip_addr,Interface.netlen);
			for (scmdp = attab,func = tab_ini;scmdp->name[0] != 0;scmdp++,func++) {
				if (_fstricmp(Interface.type,scmdp->name) == 0) {
					if ((**func)(&Interface) < 0)
						printf("Interface '%s' failed!\n",pszKey);
					goto next;
				}
			}
			printf("Interface type '%s' not supported\n",Interface.type);
			next:;
		}
	}
	return;
}
#endif

IFACE *find_if(int argc,char *argv[]);

/* Get interface status */
doifstat(int argc,char *argv[])
{
	IFACE *ifp;

	if ((ifp = find_if(argc,argv)) != NULLIF) {
		if(ifp->ioctl == NULLFP){
			printf("Not used\n");
			return 1;
		}
		/* Pass rest of args to device-specific code */
		(*ifp->ioctl)(ifp,argc-2,argv+2);
#ifdef LAPB
		if (ifp->sflags & SF_LAPB) {
			char *newargv[3];
			newargv[1] = "status";
			newargv[2] = argv[1];
			return dolapb(3,newargv);
		}
#endif
	}
	return 0;
}

/* Manipulate I/O device parameters */
doparam(int argc,char *argv[])
{
	IFACE *ifp;

	if ((ifp = find_if(argc,argv)) != NULLIF) {
		if(ifp->ioctl == NULLFP){
			printf("Not used\n");
			return 1;
		}
		/* Pass rest of args to device-specific code */
		return (*ifp->ioctl)(ifp,argc-2,argv+2);
	}
	return 0;
}

/* Find interface, print list if none */
IFACE *find_if(int argc,char *argv[])
{
	struct interface *ifp;
	extern char badhost[];
#if APL
	static char far heading[] =
		"Interface     Status UTime DTime Query_IPAddress Flags\n";
	static char far flagtext[] =
		"Digi"		/* Digiboard */
		"MDD\0"
		"IEEE"		/* Use IEEE (snap) encapsulation */
		"X.25"		/* X.25 iface */
		"LCS\0"		/* LCS is the device */
		"Ethn"		/* Ethernet */
		"IPX\0"		/* IPX */
		"Secr"		/* Security bit */
		"TokR"		/* token ring */
	;
	static char far sflagtext[] =
		"Raw\0"
		"Used"
		"Lapb"	/* Use LAPB over SLIP */
		"FTP\0"	/* used for raw FTP */
		"Teln"	/* used for raw TELNET */
		"Pflc"	/* pass flow control characters on */
		"Dlvr"	/* deliver raw data */
		"CBrk"	/* Close on break */
		"Unc\0"	// uncommitted
	;
	int indx;
	WORD mask;
	extern char *psocket();
	extern void raw_recv();

	if (argc <= 1)
		printf("%Fs",heading);
#endif
	for (ifp=ifaces;ifp != NULLIF;ifp = ifp->next) {
		if (argc <= 1) {
#if APL
			printf("%-13s %s   %5u %5u %15s ",ifp->name,
						(ifp->stat & IF_UP) ? ((ifp->stat & IF_QUERY) ?
						"Up? " : "Up  ") : "Down",
						ifp->up_time,ifp->down_time,inet_ntoa(ifp->ip_query));
			for (mask = 1,indx = 0;mask;mask <<= 1,indx += 4) {
				if (ifp->flags & mask)
					printf("%.4Fs ",flagtext + indx);
			}
			for (mask = 1,indx = 0;mask;mask <<= 1,indx += 4) {
				if (ifp->sflags & mask)
					printf("%.4Fs ",sflagtext + indx);
			}
			if (ifp->stat & IF_NORIPADV)
				printf("NoRA ");
			if (ifp->stat & IF_NORIPUSE)
				printf("NoRU");
#ifdef SERIAL
			if ((ifp->sflags & (SF_RAW | SF_INUSE)) ==
									(SF_RAW | SF_INUSE) &&
									ifp->recv == raw_recv) {
				TELN *tn;
				TCB *tcb;
				if ((tn = (TELN *)ifp->indcb) != 0 &&
											(tcb = tn->tcb) != 0) {
					printf("\n%14s%-22s","",psocket(&tcb->conn.local));
					printf("%-22s",psocket(&tcb->conn.remote));
				}
			}
#endif
			printf("\n");
#ifdef NAT
			if (ifp->flags & NAT_FLAG) {
				printf("%22s%s","NAT int ",inet_ntoa(ifp->dwIpInternal));
				printf(" ext %s",inet_ntoa(ifp->dwIpExternal));
				printf(" netmask %s\n",inet_ntoa(ifp->dwNatMask));
			}
#endif
#endif
		}
		else if(strcmp(argv[1],ifp->name) == 0)
			break;
	}
	if (argc <= 1)
		return 0;
	if (ifp == NULLIF) {
		printf("Interface '%s' unknown\n",argv[1]);
		return 0;
	}
#ifndef METRO
	if (argc == 3) {
		if (strcmp(argv[2],"up") == 0) {
			if_mark_up(ifp,1);
			return 0;
		}
		if (strcmp(argv[2],"down") == 0) {
			if_mark_down(ifp);
			return 0;
		}
		if (strcmp(argv[2],"noripadv") == 0) {
			ifp->stat |= IF_NORIPADV;
			return 0;
		}
		if (strcmp(argv[2],"ripadv") == 0) {
			ifp->stat &= ~IF_NORIPADV;
			return 0;
		}
		if (strcmp(argv[2],"noripuse") == 0) {
			ifp->stat |= IF_NORIPUSE;
			return 0;
		}
		if (strcmp(argv[2],"ripuse") == 0) {
			ifp->stat &= ~IF_NORIPUSE;
			return 0;
		}
		if (strcmp(argv[2],"dhcpinform") == 0) {
			dhcp_inform(ifp);
			return 0;
		}
	}
	if (argc == 4) {
		WORD timeout = atoi(argv[3]);
		if (strcmp(argv[2],"uptime") == 0) {
			ifp->up_time = timeout;
			if (ifp->stat & IF_UP) {
				stop_timer(&ifp->timer);
				if (timeout)
					set_timer(&ifp->timer,1000L * ifp->up_time);
			}
			return 0;
		}
		if (strcmp(argv[2],"downtime") == 0) {
			ifp->down_time = timeout;
			if (!(ifp->stat & IF_UP)) {
				stop_timer(&ifp->timer);
				if (timeout) {
					set_timer(&ifp->timer,1000L * ifp->down_time);
					start_timer(&ifp->timer);
				}
			}
			return 0;
		}
		if (strcmp(argv[2],"query") == 0) {
			if ((ifp->ip_query = resolve(argv[3])) == 0)
				printf(badhost,argv[3]);
			return 0;
		}
		if (strcmp(argv[2],"address") == 0) {
			set_ip_addr(argv[3],-1);
			if (def_ip_addr) {
				ifp->ip_addr = def_ip_addr;
				ifp->netbits = def_netbits;
			}
			else
				printf(badhost,argv[3]);
			return 0;
		}
	}
#ifdef NAT
	if (argc == 5) {
		WORD wNetLen;
		char *psz;
		if (strcmp(argv[2],"nat") == 0) {
			if ((ifp->dwIpInternal = resolve_nl(argv[3],&wNetLen,&psz)) == 0)
				printf(badhost,argv[3]);
			else if ((ifp->dwIpExternal = resolve(argv[4])) == 0)
				printf(badhost,argv[4]);
			else
				ifp->flags |= NAT_FLAG;
			ifp->dwNatMask = (long)0x80000000L >> (wNetLen - 1);
			return 0;
		}
	}
#endif
#endif
	return ifp;
}

#if APL
/* Log messages of the form
 * Tue Jan 31 00:00:00 1987 44.64.0.7:1003 open FTP
 */
void log(TCB *tcb,const char *fmt,...)
{
	char *cp;
	long t;
	int fd;
	va_list ap;
	char str[200];

	if(logfp == NULLFILE)
		return;
	time(&t);
	cp = ctime(&t);
	rip(cp);
	va_start(ap, fmt);
	vsprintf(str,fmt,ap);
	va_end(ap);
	fprintf(logfp,"%s %s - %s\r\n",cp,tcb ? psocket(&tcb->conn.remote) : "",str);
	fflush(logfp);
	/* MS-DOS doesn't really flush files until they're closed */
	fd = fileno(logfp);
	if((fd = dup(fd)) != -1)
		close(fd);
}
#endif
/* Configuration-dependent code */

/* List of supported hardware devices */
int ec_iface(),ser_iface(),nb_iface(),ipx_iface(),isol_iface(),
	pdr_iface(),lcs_iface(),x25_iface(),digi_iface(),dummy_iface();

// NB NB NB This table MUST be syncronized with tab_ini table
struct scmds far attab[] = {
#ifdef ETHER
	/* 3-Com Ethernet interface */
	"en3c", ec_iface,

	/* PunchLAN ethernet interface */
	"pl100", ec_iface,

	/* ELAN ethernet interface */
	"el100", ec_iface,

	/* Novell ethernet interfaces */
	"ne1000", ec_iface,

	"ne2000", ec_iface,

	/* Western Digital ethernet interface */
	"wd8003", ec_iface,
#endif
#ifdef NETB
	/* Netbios interface */
	{"nb", nb_iface},
#endif
#ifdef IPX
	/* IPX interface */
	{"ipx", ipx_iface},
#endif
#ifdef ISOL
	/* ISOLINK interface */
	{"isolink", isol_iface},
#endif
	/* PACKET DRIVER interface */
	{"pdr", pdr_iface},
#ifdef ASYNC
	/* Ordinary PC asynchronous adaptor */
	{"asy", ser_iface},
	{"aslink",ser_iface},
	{"mdd",ser_iface},
#endif
#ifdef SCC
	/* SCC async */
	{"scc", ser_iface},
#endif
#ifdef LCS
	/* LCS async */
	{"lcs", lcs_iface},
#endif
#ifdef DIGI
	/* Digiboard async */
	{"digi", digi_iface},
#endif
#ifdef DUMMY
	{"dummy", dummy_iface},
#endif
#ifdef X25_S
	/* X25 resident driver */
	{"x25", x25_iface},
#endif
	{"", NULLFP},
};

/* Protocol tracing function pointers */

#ifdef	TRACE
int ax25_dump(),ether_dump(),ip_dump(),ppp_dump(),x25_dump(),ipx_dump(),token_dump();

int (*tracef[])() = {
	NULLFP,
	ether_dump,
	ip_dump,
#ifdef PPP_S
	ppp_dump,
#endif
#ifdef LAPB
	x25_dump,
#else
	NULLFP,
#endif
#ifdef IPX
	ipx_dump,
#else
	NULLFP,
#endif
	token_dump,
};
#endif

#ifdef SERVERS
dostart(int argc,char *argv[])
{
	return subcmd(startcmds,argc,argv,0);
}

dostop(int argc,char *argv[])
{
	return subcmd(stopcmds,argc,argv,0);
}
#endif SERVERS

FILE *fptrace = Stdout;

#ifdef	TRACE

char fptracef;			/* set if file trace enabled */
char tfname[40];		/* file writing trace info into */
int trace_all;			// global trace flag

static int dotrace(int argc,char *argv[])
{
	struct interface *ifp;
	int trace = 0;

	if (argc < 2) {
		if (trace_all)
			showtrace("all",trace_all);
		showtrace("loopback",loopback.trace);
		for(ifp = ifaces; ifp != NULLIF; ifp = ifp->next)
			showtrace(ifp->name,ifp->trace);
		return 0;
	}
	if (strcmp("all",argv[1]) == 0)
		ifp = 0;
	else if (strcmp("loopback",argv[1]) == 0)
		ifp = &loopback;
	else {
		for (ifp = ifaces; ifp != NULLIF; ifp = ifp->next) {
			if(strcmp(ifp->name,argv[1]) == 0)
				break;
		}
		if(ifp == NULLIF){
			printf("Interface %s unknown\n",argv[1]);
			return 1;
		}
	}
	if(argc >= 3) {
		char *p;

		for (p = argv[2];*p;++p) {
			switch (toupper(*p)) {
			case 'I':
				trace |= IF_TRACE_IN;
				break;
			case 'O':
				trace |= IF_TRACE_OUT;
				break;
			case 'H':
				trace |= IF_TRACE_HEX;
				break;
			case 'E':
				trace |= IF_TRACE_EBCD;
			case 'C':
			case 'A':
				trace |= IF_TRACE_CHAR;
				break;
			case 'D':
				trace |= IF_TRACE_DATA;
				break;
			case 'N':
				trace = 0;
				if (fptracef) {
					fclose(fptrace);
					fptrace = Stdout;
					fptracef = 0;
				}
				goto endopt;
			case 'R':
				trace |= IF_TRACE_RAW;
				break;
			case 'S':
				trace |= IF_TRACE_STAT;
				break;
			case 'T':
				trace |= IF_TRACE_TIME;
				break;
			case 'X':
				trace |= IF_TRACE_NOBC;
				break;
			case 'V':
				trace |= IF_TRACE_COMP;
				break;
			default:
				printf("Unknown trace mode: %c\n",*p);
				break;
			}
		}
		endopt:
			;
	}
	if (argc >= 4) {		/* trace file specified */
		if (fptracef)
			fclose(fptrace);
		strncpy(tfname,argv[3],39);
		if ((fptrace = fopen(tfname,(trace & IF_TRACE_STAT) ?
				(argc >= 5 ? "ab" : "wb") :
				(argc >= 5 ? "at" : "wt"))) == 0) {
			fptracef = 0;
			printf("Unable to open file: %s\n",tfname);
			fptrace = Stdout;
		}
		else
			fptracef = 1;
	}
	if (!ifp) {
		showtrace("all",trace);
		for (ifp = ifaces;ifp;ifp = ifp->next) {
			ifp->trace = trace;
		}
		trace_all = trace;
	}
	else {
		ifp->trace = trace;
		showtrace(ifp->name,trace);
	}
	return 0;
}

/* Display the trace flags for a particular interface */
static void showtrace(char *name,int trace)
{
	printf("%s:",name);
	if(trace & (IF_TRACE_IN | IF_TRACE_OUT)){
		printf("%s%s%s%s%s%s%s%s%s to %s\n",
			(trace & IF_TRACE_IN) ? " input" : "",
			(trace & IF_TRACE_OUT) ? " output" : "",
			(trace & IF_TRACE_TIME) ? " time" : "",
			(trace & IF_TRACE_RAW) ? " no headers" : "",
			(trace & IF_TRACE_DATA) ? " (hex/char data)" :
			(trace & IF_TRACE_CHAR) ? " (char data)" : "",
			(trace & IF_TRACE_HEX) ? " (frame)" : "",
			(trace & IF_TRACE_EBCD) ? " EBCDIC": " ASCII",
			(trace & IF_TRACE_STAT) ? " stats" : "",
			(trace & IF_TRACE_COMP) ? " vjc" : "",
			fptracef ? tfname : "screen");
	} else
		printf(" tracing off\n");
}
#endif

#if APL

dowait(int argc, char *argv[])
{
	extern unsigned long master_tick;
	unsigned long target_tick = master_tick +
		(argc > 1 ? atol(argv[1]) : 1000l) / MSPTICK;

	while ((long)(target_tick - master_tick) > 0) {
		schedule();
	}
	return 0;
}

int get_passw(char *user,char *passw)
{
	extern char userfile[];
	char buf[80],*cp,*cp1;
	FILE *fp;

	cp1 = passw;
	if ((fp = fopen(getfilename(buf,userfile,0),"r")) == NULLFILE) {
		/* Userfile doesn't exist */
		*cp1 = 0;
		return;
	}
	while (fgets(buf,sizeof(buf),fp),!feof(fp)) {
		if ((cp = strchr(buf,' ')) == NULLCHAR)
			continue;
		*cp++ = '\0';		/* Now points to password */
		if (strcmp(user,buf) == 0) {
			int i;
			for (i = 0;i < 9 && *cp > ' ';i++) {
				*cp1++ = *cp++;
			}
			break;		/* Found password */
		}
	}
	fclose(fp);
	*cp1 = 0;
	return;
}
#endif
#if (APL || defined(USR))
#include "userpass.h"
USERPASS *psUserPass, *psUserPassLast;

int dousr(int argc, char *argv[])
{
	USERPASS *psU;

#if APL
	if (argc == 1) {
		for (psU = psUserPass;psU;psU = psU->next) {
			printf("%s %s %s %s\n",psU->szUserPass,
				psU->szUserPass + strlen(psU->szUserPass) + 1,
				inet_ntoa(psU->dwIpAddress),
				psU->wFlags & UP_CALLBACK ? "cbv" : "");
		}
		return 0;
	}
	if (argc == 2)
		return doruser(argc,argv);
#endif
	if (argc > 2) {
		int len = strlen(argv[1]);
		if ((psU = calloc(sizeof(USERPASS) + len + strlen(argv[2]),1,AllocComUser)) == 0)
			return -1;
		strcpy((char *)psU->szUserPass,argv[1]);
		strcpy((char *)psU->szUserPass + len + 1,argv[2]);
	}
	if (argc > 3)
		psU->dwIpAddress = resolve(argv[3]);
	if (argc > 4)
		psU->wFlags |= UP_CALLBACK;
	if (psUserPass) {
		psUserPassLast->next = psU;
		psUserPassLast = psU;
	}
	else
		psUserPass = psUserPassLast = psU;
	return 0;
}
#endif
