//
//   $Id: MAIN.C 1.12 2003/07/17 16:43:02Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
// File: MAIN.C
//
// Copyright (c) 2001-2002 Datalight, Inc.
// All Rights Reserved
// Datalight Confidential and Proprietary
// Portions Copyright (c) GPvNO 1989-2002
// Portions Copyright (c) 1986-1989 Phil Karn, KA9Q
//
// Main function - general initialisation
//
// History
// 04/26/2002 gvn Removed /p; now specified in config file
// 07/23/2001 gvn Allocation tracing
// 05/02/2001 jmb set internal version number to ROMDOS build number
//                when compiled with DL defined.
// 05/04/2001 pb  Added Usage screen.
//

#ifdef DL
#define CONFIG_EXT ".cfg"
#define PRNAME "DL Sockets"
#define INIFILE "socket.ini"
#else
#define CONFIG_EXT ".stu"
#if APL
#define PRNAME "Inet"
#else
#define PRNAME "Rinet"
#endif
#define INIFILE "inet.ini"
#endif

#if APL==0
#pragma option -zAINETINIT
#endif

#define BUFSIZE	160	/* command buffer size */
extern char startupn[];	/* File to read startup commands from */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <io.h>
#include <stdarg.h>
#include <ctype.h>
#include <fcntl.h>
#include <sys\stat.h>
#include <dos.h>
#include <string.h>
#include <time.h>
#include <alloc.h>
#include "inetdefs.h"
#include "mbuf.h"
#include "netfunc.h"
#include "timer.h"
#include "iface.h"
#include "icmp.h"
#include "ip.h"
#include "tcp.h"
#if APL
#define	TRACE	1
#define	SERVERS	1
#include "session.h"
#include "demo.h"
#include "keys.h"

#include "ini.h"
#include "twindow.h"
#endif
#include "cmdparse.h"
#include "commands.h"
#include "pc.h"
#ifdef TRACE
#include "trace.h"
#endif
#include "task.h"
#include "_api.h"
#ifdef DL
#include "bldver.h"
#endif

void errorinit(void);		/* initialize error handling */
void set_disk(void);
void setdmode(void);
int menu_init(void);
void kbinit(void);
void ute_init(void);
void sumes(void);
void cooked(void);
void snmp_init(void);
int api_init(void);
void termstart(void);
void imenu(void);
void checkresident(void);
void goresident(void);
void Usage(void);
void InitMemory(void);

extern int helping;

extern struct interface *ifaces;
extern char version[];
extern FILE *fpinput;		/* command input file */
extern struct cmds far cmds[];
extern unsigned uVersion;

int mode;
WORD tcp_lport = 2001;
WORD tcp_lport_i = 2001;
#if	APL
unsigned nsessions = NSESSIONS;
int doscurx,doscury;		/* dos cursor on entry */
char conlogflag;			/* set to log all console output to log */
FILE *logfp;
#endif
FILE *fpinput;
char quiet_flag;			// used to suppress RINET output
char cReverseVideo = 1;	// 0 if reverse video is not supported
char nospace[] = "No memory to execute command\n";/* Generic malloc fail message */

#ifdef INI_FILE
char *inet_ini;			// global for LPD.C
static char ini_flag = 0;
#endif

char no_action;			/* set when no Telnet delivery is to be done */
#if APL
char *transient_command;	// Transient command invoked by alt keys
#endif

int directvideo = 0;
BYTE bMultiCast;		// set if /A (multicAst) has been specified

time_t start_time;		/* time started */

c_break();			/* control break routine */

char bMinPacketSize = 0;


#if DEMO
void demoexit();
struct timer demo_timer = {
	0,0,
	20 * (60000 / MSPTICK),
	0,
	demoexit
};
#endif

int argcount;
char **argval;
char *inbuff;

main(int argc,char *argv[])
{
	extern char noxkey,upper_case;
	extern int line_flag;
	extern char unix_flag;
	extern char flush_printer;	// flush printer on print-thru
	extern char disp_snow,f386;
	extern unsigned stksize;
	extern unsigned heapsize;
	extern VARBLOCK stats;
	extern int api_intp;
	extern int api_int;
	extern int WBufLen;
	extern unsigned stack_segment;

	char *fgets();
	char *sufname;
	char name[50];
	int ttydriv();
	void check_time();
	int error = 0;
	char stu_given;

#ifdef DL
	uVersion = atoi(BUILD_NUMBER);
#endif
#if APL
	start_time = time(NULL);
#endif
	stack_segment = _SS;
#if APL
	errorinit();		/* initialize error handling */
#endif
	ctrlbrk(c_break);	/* catch ^C */
	while (argc > 1 && argv[1][0] == '/') {
		char *parg = argv[1] + 2;
		int val;
		if (parg[0] == '=')
			++parg;
		val = atoi(parg);
		switch (argv[1][1] & 0xdf) {
		case ('0' & 0xdf):
			f386 = 0;	// do not save extended registers on upcall
			break;
		case 'A':
			bMultiCast = 1;
			break;
#ifdef INI_FILE
		case 'C':		// Config file
			inet_ini = parg;
			break;
#endif
#ifdef DL
		case 'H':
		case '?' & 0xdf:
			Usage();
			break;
#endif
		case 'I':		// Interrupt
			api_intp = htoi(parg);
			break;
		case 'M':
			heapsize = val;
			break;
#if APL
		case 'F':
			flush_printer = 1;	// flush printer on print-thru
			break;
		case 'K':
			noxkey = 1;
			break;
		case 'O':
			disp_snow = 1;
			break;
#endif
		case 'U':
			if (!val || (val & 1))
				upper_case = 1;			// for Rinet it means UNLOAD
#if APL
			if (val & 2)
				line_flag = val;
			if (val)
				unix_flag = val & 4;
#endif
			break;
		case 'N':
		case 'G':		// global descriptors
			stats.ngdesc = val;
			break;
		case 'D':
		case 'L':		// local descriptors
			stats.nndesc = val;
			break;
      case 'P':      // minimum size 64 bytes allocated from packet driver
         bMinPacketSize = 1;
         break;
		case 'Q':
			quiet_flag = 1;
			break;
		case 'R':
			cReverseVideo = 0;
			break;
		case 'S':
			stksize = val;
			break;
		case 'V':		// Inet API int vector
			api_int = htoi(parg);
			break;
		}
		--argc;
		++argv;
	}
	InitMemory();
	set_disk();
	if ((inbuff = malloc(BUFSIZE,AllocMainInbf)) == 0)
		exit(1);
	argcount = argc - 1;
	argval = argv + 1;
#ifdef INI_FILE
	// process .ini file
	sufname = inet_ini ? inet_ini : getfilename(name,INIFILE,1);
	if (access(sufname,0) == 0 ||
		(inet_ini && access(sufname = getfilename(name,inet_ini,1),0) == 0)) {
		if ((inet_ini = malloc(strlen(sufname) + 1,AllocMainIni)) != 0)
			strcpy(inet_ini,sufname);
		OpenProfile(sufname);
		ini_flag = 1;
		WBufLen = GetPrivateProfileInt("Screen","BufLen",WBufLen,sufname);
	}
#endif
#if APL
	set_palette(1);
	setdmode();		/* set display mode */
	curr_cursor(&doscurx, &doscury);
	if (menu_init() != 0) {
		fprintf(stderr,"Not enough memory\n");
		exit(1);
	}
#endif
	ioinit();
#if APL
	kbinit();
	ute_init();
#endif
	sumes();
#if APL
	printf("\n\n\n");
	cooked();
	cursor(0,26);		/* hide cursor */
	sessions = (struct session *)calloc(nsessions,sizeof(struct session),AllocMainSessions);
#else
	checkresident();
	if (upper_case) {
		printf(PRNAME" not resident\n");
		exit(1);
	}
#endif
#ifdef INI_FILE
	if (ini_flag) {
		printf("Processing %s\n",sufname);
		ini_bootp(sufname);
		ini_ip(sufname);
		ini_iface(sufname);
		ini_tcp(sufname);
		ini_iproute(sufname);
		ini_domain(sufname);
		CloseProfile();
	}
#endif
	if (argc > 1 && argv[1][0] != ',') {
		/* Read startup file named on command line */
		char *pdot;
		strcpy(name,argv[1]);
		sufname = name;
		if (strchr(name,'.') == 0) {
			pdot = name + strlen(name);
			strcpy(pdot,CONFIG_EXT);
			if (access(name,0) != 0)
				*pdot = 0;
		}
		stu_given = 1;
	} else {
		sufname = getfilename(name,startupn,1);
		stu_given = 0;
	}
#if DEMO
	demohelp("demo_ms1");
	start_timer(&demo_timer);
#endif
#if APL
#ifndef NOSNMP
	snmp_init();
#endif
	if (api_init() < 0) {
		printf("Too many Network Descriptors\n");
		exit(1);
	}
#endif
	if ((fpinput = fopen(sufname,"r")) != NULLFILE) {
		printf("Processing %s\n",sufname);
#if !APL
		while (fgets(inbuff,BUFSIZE,fpinput) != NULLCHAR){
			repargs(inbuff,BUFSIZE);
			error |= cmdparse(cmds,inbuff,1);
		}
		fclose(fpinput);
		fpinput = 0;
#endif
	}
	else if (stu_given) {
		error |= -1;
		printf("Can't open '%s'",sufname);
	}
#if !APL
	if (api_init() < 0) {
		printf("Too many Network Descriptors\n");
		error = -1;
	}
#endif
#if APL
//	termstart();
	imenu();
#else
	_ES = *(int far *)MK_FP(_psp,0x2c);
	_AH = 0x49;
	geninterrupt(0x21);	/* release environment memory */
	free(inbuff);
	if (error != -1)
		goresident();
	printf("Errors encountered - " PRNAME " not resident\n");
	iostop();
	exit(1);
#endif
	return 0;
}

/* replace arguments in string with actual arguments */
void repargs(char *buf,int bufsiz)
{
	char *bufp = buf;
	char *prep,*pend;
	char ch;
	int i,len,room,left,gap;
	int argc = argcount;
	char **argv = argval;

	buf[bufsiz - 1] = 0;
	while ((ch = *bufp++) != 0) {
		if (ch == '%') {
			if (isdigit(ch = *bufp)) {
				++bufp;
				gap = 2;
				prep = ((i = ch - '0') <= argc) ? argv[i] : "";
				goto replace;
			}
			else if ((pend = strchr(bufp,'%')) != 0) {
				*pend = 0;
				strupr(bufp);
				if ((prep = getenv(bufp)) == 0)
					prep = "";
				gap = pend - bufp + 1;
				bufp += gap++;
				replace:
				len = strlen(prep);
				if (len <= gap) {
					strncpy(bufp - gap,prep,len);
					if (len < gap)
						strcpy(bufp - gap + len,bufp);
					bufp += (len - gap);
					continue;
				}
				room = buf - bufp + bufsiz + 1;
				if (len < room) {
					char *ps,*pd;

					room -= len;
					left = strlen(bufp);
					if (left > room)
						left = room;
					ps = bufp + left -1;
					pd = ps + len - gap;
					pd[1] = 0;
					while (left--) {
						*pd-- = *ps--;
					}
				}
				else
					len = room;
				strncpy(bufp - gap,prep,len);
				bufp += (len - gap);
			}
			else if (ch) {
				strcpy(bufp - 1,bufp);
				++bufp;
			}
		}
	}
}

#if DEMO
demohelp(char *help)
{
	set_help((char far *)help,10,10,0);
	helping = 1;
	dhelp();
	helping = 0;
}

void demoexit()
{
	tcp_resetall();
	if(logfp != NULLFILE)
		fclose(logfp);
	iostop();
	demohelp("demo_ms4");
	close_all();		/* remove all windows */
	cursor(doscurx,doscury);
	restore_palette();
	exit(0);
}
#endif
