//
//   $Id: PRNTSERV.C 1.5 2003/08/17 08:43:28Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
// PRNTSERV.C
// Print server/LPT redirector
// Copyright (c) GP van Niekerk Ondernemings 1990-2002
// Revision history
// 2003-08-17 gvn bi-directional transfer
// 2002-04-26 gvn /d=<delay count> to replace global /p=

#if APL==0
#pragma option -zAPRINTERS
#pragma option -zFPRINTERS
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <ctype.h>
#include "inetdefs.h"
#include "mbuf.h"
#include "timer.h"
#include "iface.h"
#include "icmp.h"
#include "netfunc.h"
#include "tcp.h"
#include "task.h"
#include "printing.h"
#include "log.h"

#define NUMPRINT 4
#define LPT	 0x17
#define INT17_FLAG 0x0100

#ifdef __LARGE__
#define UNS unsigned long
#else
#define UNS unsigned
#endif

char cPrintingUsed;	// set if printing is used
char print_flag;		/* set if any printer active */
void sched_printer();		/* entry from scheduler */
int interrupt (*lptvec)(void);	/* Original interrupt vector [cs:ip] */

PRINTQUE pque[NUMPRINT] = {
	{0,0,0,0,0,0xa8,0x80,40},
	{0,0,0,0,0,0xa8,0x80,40},
	{0,0,0,0,0,0xa8,0x80,40},
	{0,0,0,0,0,0xa8,0x80,40},
};

prntserv1(int argc,char *argv[])	/* start print server */
{
	PRINTQUE *pq;
	struct socket lsocket;
	void far prntsrv_state();
	int printnumber;
	char mask = 0xa8,stat = 0x80,report = 0;
	int val,iargc = 0;
	WORD wFlags = 0;
	WORD	wDelay = 40;
#if APL
	static char sched_set = 0;

	if (!sched_set) {
		if (task_create(sched_printer,0) == 0)
			return -1;
		sched_set = 1;
	}
#endif
	lsocket.port = 10;
	lsocket.address = 0;
	for (;argc > 1;argc--,argv++) {
		if (argv[1][0] == '/') {
			char *psz = argv[1] + (argv[1][2] == '=' ? 3 : 2);
			val = htoi(psz);
			switch (argv[1][1]) {
			case 'c':
				wFlags |= LPD_CR;
				break;
			case 'd':
				wDelay = atoi(psz);
				break;
			case 'f':
				wFlags |= LPD_FF;
				break;
			case 'm':
				mask = val;
				break;
			case 's':
				stat = val;
				break;
			case 'r':
				report = val;
				break;
			}
		}
		else if (iargc++ == 0)
			lsocket.port = atoi(argv[1]);
		else if (iargc++ == 1 || (printnumber = atoi(argv[1])) >= NUMPRINT)
			printnumber = 0;
	}
	lptvec = (int interrupt (*)())getvect(LPT);
	pq = pque + printnumber;
	pq->ltcb = open_tcp(&lsocket,NULLSOCK,TCP_SERVER,0,0,0,
				prntsrv_state,0,(char *)printnumber);
	pq->mask = mask;
	pq->stat = stat;
	pq->report = report;
	pq->status = 0xff;
	pq->flags |= wFlags;
	if ((pq->wDelay = wDelay) == 0)
		++pq->wDelay;
	_AX = 0x301;
	if (!report && (*lptvec)() == 'SP')
		pq->flags |= CAN_INPUT;
	cPrintingUsed = 1;
	return 0;
}

void send_prnstat(PRINTCON *pPrintCon,char status)
{
	MBUF *bp;
	TCB *tcb;

	if ((tcb = pPrintCon->pTCB) == 0)
		return;
	if ((bp = alloc_mbuf(1,AllocPrnStat)) != NULLBUF) {
		bp->cnt = 1;
		bp->data[0] = status;
		send_tcp(tcb,bp,0);
	}
}

#if APL
int pump_thruprint(char *str,int len)
{
	MBUF *bp;
	PRINTQUE *pq = pque;

	if (pq->mbuf)
		return 1;
	if ((bp = pq->mbuf = alloc_mbuf(len,AllocPrntsData)) == 0)
		return 1;
	bp->cnt = len;
	memcpy(bp->data,str,len);
	pq->pPrintCon = (PRINTCON *)1;
	return 0;
}
#endif

void sched_printer()			/* entry from scheduler */
{
	MBUF *bp;
	TCB *tcb;
	PRINTQUE *pq;
	PRINTCON *pPrintCon;
	int pn,ret,iAvailable,iCanSend;
	char printstat,c;
	unsigned loopcnt;

	print_flag = 0;
	for (pq = pque,pn = 0;pn < NUMPRINT;++pq,++pn) {
		if ((pPrintCon = pq->pPrintCon) == 0 && !pq->mbuf)
			continue;
		print_flag = 1;
		loopcnt = pq->wDelay;
		while (1) {
			_DX = pn;
			_AH = 2;	/* printer status */
			(*lptvec)();
			printstat = _AH;
			if (pPrintCon > (PRINTCON *)1 && pPrintCon->wState == ST_SPD) {
				if (((printstat & 0xfd) & pq->report) != pq->status && pq->report) {
					pq->status = printstat & pq->report & 0xfd;
					send_prnstat(pPrintCon,printstat);
				}
				if ((pq->flags & CAN_INPUT) && (tcb = pPrintCon->pTCB) != 0 &&
								(iCanSend = tcb->window - tcb->sndcnt) > 0) {
					_DX = pn;
					_AX = 0x301;		// Get count
					(*lptvec)();
					iAvailable = _CX;
					if ((iCanSend = min(iCanSend,iAvailable)) > 0) {
						if ((bp = alloc_mbuf(iCanSend,AllocPrnStat)) != 0) {
							bp->cnt = iCanSend;
							_SI = FP_OFF(bp->data);
							_DX = pn;
							_CX = iCanSend;
							_AX = 0x300;
							(*lptvec)();
							send_tcp(tcb,bp,0);
						}
					}
				}
			}
			if ((bp = pq->mbuf) == 0) {
				if (pPrintCon == (PRINTCON *)1 || (tcb = pPrintCon->pTCB) == 0) {
					if ((pq->flags & LPD_CR) && (pq->flags & (LAST_CR | LAST_LF))) {
						c = 0;
						goto last_char;
					}
					break;
				}
				if ((ret = recv_tcp(tcb,&bp,0,0)) > 0) {
					pq->mbuf = bp;
				}
				else if (ret == 0) {
					if ((pq->flags & LPD_CR) && (pq->flags & (LAST_CR | LAST_LF))) {
						c = 0;
						goto last_char;
					}
					if (pq->flags & LPD_FF) {
						c = '\f';
						goto last_char;
					}
					if (pq->report && pPrintCon->wState == ST_SPD)
						send_prnstat(pPrintCon,printstat | 2);
					close_tcp(tcb);
					break;
				}
				else
					break;
			}
			if (bp->cnt) {
				c = *bp->data;
				last_char:
				if ((printstat & pq->mask) != pq->stat) {
					if (--loopcnt == 0)
						break;
					continue;
				}
				// the printer will accept a character
				if (pq->flags & LPD_CR) {
					if (pq->flags & LAST_LF) {
						pq->flags &= ~LAST_LF;
						if (c == '\r') {
							bp->data++;
							--bp->cnt;
						}
						else
							c = '\r';
					}
					else if (pq->flags & LAST_CR) {
						pq->flags &= ~LAST_CR;
						if (c == '\n') {
							bp->data++;
							--bp->cnt;
						}
						else
							c = '\n';
					}
					else {
						if (c == '\r')
							pq->flags |= LAST_CR;
						else if (c == '\n')
							pq->flags |= LAST_LF;
						bp->data++;
						--bp->cnt;
					}
				}
				else {
					bp->data++;
					--bp->cnt;
				}
				loopcnt = pq->wDelay;
				switch (pPrintCon->wState) {
#ifdef LPDD
				case ST_RECEIVE_JOB:
					pPrintCon->dwLen = 0;
					if (c == RECEIVE_CONTROL_FILE)
						pPrintCon->wState = ST_RCV_CONTROL_COUNT;
					else if (c == RECEIVE_DATA_FILE)
						pPrintCon->wState = ST_RCV_DATA_COUNT;
					else if (c != ABORT_JOB)
						SendAck(pPrintCon,BAD_SUBCOM);
					break;
				case ST_RCV_CONTROL_COUNT:
				case ST_RCV_DATA_COUNT:
					if (isdigit(c))
						pPrintCon->dwLen = pPrintCon->dwLen * 10 + (c - '0');
					else if (isspace(c)) {
						pPrintCon->wState++;
						pPrintCon->wJobNumber = 0;
					}
					break;
				case ST_RCV_CONTROL_JOBNUM:
				case ST_RCV_DATA_JOBNUM:
					if (pPrintCon->iIndex >= 3 && pPrintCon->iIndex <= 5)
						pPrintCon->wJobNumber = 10 * pPrintCon->wJobNumber + (c - '0');
					pPrintCon->iIndex++;
					if (c == '\n') {
						pPrintCon->iIndex = 0;
						pPrintCon->wState++;
						SendAck(pPrintCon,GOOD);
					}
					break;
				case ST_RCV_CONTROL_DATA:
					if (--pPrintCon->dwLen == 0)
						pPrintCon->wState = ST_RCV_CONTROL_END;
					break;
				case ST_RCV_CONTROL_END:
				case ST_RCV_DATA_END:
					pPrintCon->wState = ST_RECEIVE_JOB;
					SendAck(pPrintCon, c ? BAD_END : GOOD);
					break;
				case ST_RCV_DATA_DATA:
					if (--pPrintCon->dwLen == 0)
						pPrintCon->wState = ST_RCV_DATA_END;
					// fall thru
#endif
				case ST_SPD:
					_DX = pn;
					_AL = c;
					_AH = 0;
					(*lptvec)();
					break;
				}
			}
			else {
				pq->mbuf = free_mbuf(bp);
			}
		}
	}
}

#pragma argsused
static void far prntsrv_state(struct tcb *tcb,char old,char newstate)
{
	int printnum;
	PRINTQUE *pq;
	PRINTCON *pPrintCon,*pPrConQ,*pPrConPrev;

	switch (newstate) {
	case ESTABLISHED:
		if ((printnum = (UNS)tcb->user) >= NUMPRINT ||
				(pPrintCon = (PRINTCON *)calloc(SPDCON_LEN,1,AllocPrnCon)) == 0) {
			close_tcp(tcb);
			return;
		}
#if APL
		log(tcb,"open PrintServ");
#endif
		pPrintCon->pTCB = tcb;
		tcb->user = (char *)pPrintCon;
		pq = pque + printnum;
		if ((pPrConQ = pq->pPrintCon) != 0) {
			while (pPrConQ->psNext)
				pPrConQ = pPrConQ->psNext;
			pPrConQ->psNext = pPrintCon;
		}
		else {
			pq->pPrintCon = pPrintCon;
			pPrintCon->pPrintQue = pq;
			pq->status = 0xff;
		}
		pPrintCon->pPrintQue = pq;
		pPrintCon->wState = ST_SPD;	// Mark as a Socket Print Daemon connection
		print_flag = 1;
		return;
	/*
	case CLOSE_WAIT:
		if (!tcb->rcvcnt) {
			if (pq->report)
				send_prnstat(pq,pq->status | 2);
			close_tcp(tcb);
		}
		break;
	*/
	case TIME_WAIT:
	case CLOSED:
		if ((pPrintCon = (PRINTCON *)tcb->user) != 0) {
			if ((pq = pPrintCon->pPrintQue) != 0) {
				// remove connection from printer queue
				pPrConPrev = 0;
				for (pPrConQ = pq->pPrintCon;pPrConQ;pPrConQ = pPrConQ->psNext) {
					if (pPrConQ == pPrintCon) {
						goto found;
					}
					pPrConPrev = pPrConQ;
				}
				goto not_found;
				found:
				if (pPrConPrev)
					pPrConPrev->psNext = pPrintCon->psNext;
				else {
					pq->pPrintCon = pPrintCon->psNext;
					pPrintCon->pPrintQue = pq;
					pq->status = 0xff;
				}
				not_found:
			}
			free(tcb->user);
			tcb->user = 0;
		}
		if (newstate == CLOSED)
			del_tcp(tcb);
		break;
	}
}

/* Shut down print server */
prntserv0(int argc,char *argv[])
{
	int printnumber;
	PRINTQUE *pq;

	if (argc < 2 || (printnumber = atoi(argv[1])) >= NUMPRINT)
		printnumber = 0;
	pq = pque + printnumber;
#if APL
	if (argc > 2) {
		TCB *tcb;
		PRINTCON *pPrintCon;
		if ((pPrintCon = pq->pPrintCon) != 0 && (tcb = pPrintCon->pTCB) != 0)
			reset_tcp(tcb);
		return 0;
	}
#endif
	close_tcp(pq->ltcb);
	return 0;
}

/***********************************************************************
Printer redirector client implementation.
This is too dangerous to implement for INET without checks for DOS
re-enterability.
*/

#if !APL

#define BUFSZ 100
void far lpt_rcv(struct tcb *tcb,WORD cnt);
void far lpt_state(TCB *tcb,char old,char new);

typedef struct {			// line printer control block
	SOCKET fsocket;
	TIMER timer;
	TCB *tcb;
	MBUF *bp;
	WORD wTimeOut;
	char cPrinterStatus;	// printer status
	char cData;				// stored data byte
	char cStatus;
#define LPTS_DATA	1		// have data to send
} LPCB;

LPCB lpcb[NUMPRINT];
void lpt_timeout(LPCB *plcb);
void interrupt (*old17)(void);	/* Original interrupt vector [cs:ip] */
void interrupt int17();
char lpt_installed;

dolpt(int argc,char *argv[])
{
	extern char badhost[];
	WORD n;
	LPCB *plcb;

	if (argc < 4)
		return -1;
	if ((n = atoi(argv[1])) >= NUMPRINT)
		return -1;
	plcb = lpcb + n;
	plcb->wTimeOut = atoi(argv[2]) * ((WORD)1000 / MSPTICK);
	plcb->timer.func = (void (*)(char *))lpt_timeout;
	plcb->timer.arg = (char *)plcb;
	if ((plcb->fsocket.address = resolve(argv[3])) == 0) {
		printf(badhost,argv[3]);
		return -1;
	}
	plcb->cPrinterStatus = PS_SELECTED;
	plcb->fsocket.port = (argc < 5) ? 10 : atoi(argv[4]);
	if (!lpt_installed) {
		old17 = getvect(LPT);
		setvect(LPT,int17);
		lpt_installed = 1;
	}
	cPrintingUsed = 1;
	return 0;
}

void lpt_exit()
{
	if (lpt_installed) {
		setvect(LPT,old17);
	}
}

void lpt_timeout(LPCB *plcb)
{
	TCB *tcb = plcb->tcb;
	MBUF *bp = plcb->bp;

	if (tcb == 0) {
		if (bp) {
			free_p(bp);
			plcb->bp = 0;
		}
		return;
	}
	if (tcb->sndcnt) {
		plcb->timer.start = plcb->wTimeOut;
		start_timer(&plcb->timer);
		return;
	}
	if (bp && bp->cnt) {
		bp->data -= bp->cnt;
		send_tcp(tcb,bp,0);
		plcb->bp = 0;
		plcb->timer.start = plcb->wTimeOut;
		start_timer(&plcb->timer);
		return;
	}
	if (plcb->timer.start == 2 ||
				(plcb->cPrinterStatus & (PS_PAPEROUT | PS_ERROR)) ||
				!(plcb->cPrinterStatus & PS_SELECTED)) {
		plcb->timer.start = plcb->wTimeOut;
		start_timer(&plcb->timer);
		return;
	}
	close_tcp(tcb);
	plcb->tcb = 0;
}

int SendLptChar(LPCB *plcb,char cData)
{
	SOCKET lsocket;
	MBUF *bp;
	TCB *tcb = plcb->tcb;

	if (tcb == 0) {
		lsocket.address = 0;
		lsocket.port = getlport();
		plcb->tcb = tcb = open_tcp(
			&lsocket,&plcb->fsocket,TCP_ACTIVE,0,
			lpt_rcv,0,lpt_state,0,(char *)plcb);
		if (!tcb)
			return -1;
	}
	while (1) {
		if (!plcb->bp && (plcb->bp = alloc_mbuf(BUFSZ,AllocPrnSnd)) == 0) {
			return -1;
		}
		bp = plcb->bp;
		if (bp->cnt < BUFSZ)
			break;
		if (tcb->window <= tcb->sndcnt + BUFSZ)
			return -1;
		bp->data -= bp->cnt;
		send_tcp(tcb,bp,0);
		plcb->bp = 0;
	}
	*bp->data++ = cData;
	++bp->cnt;
	plcb->timer.start = 2;
	start_timer(&plcb->timer);
	return 0;
}

/* emulate interrupt 17 */
#pragma argsused
void interrupt int17(unsigned br,unsigned di,unsigned si,
			  unsigned ds,unsigned es,unsigned dx,
			  unsigned cx,unsigned bx,unsigned ax)
{
	TCB *tcb;
	LPCB *plcb;
	unsigned savess,savebp,Ax,printnum,uTargetTime;
	static unsigned uSavess,uSavebp,uAx,uPrintnum;
	extern unsigned stack_pointer,sec_timer;
	extern int in_tcp;

#define Al (((BYTE *)&Ax)[0])
#define Ah (((BYTE *)&Ax)[1])
	if (dx >= NUMPRINT || !(lpcb + dx)->timer.arg) {
		_DX = dx;
		_AX = ax;
		(*old17)();
		ax = _AX;
		return;
	}
	disable();		// just incase it was a simulated INT 17
	// copy values from old stack/registers to static
	uAx = ax;
	uPrintnum = dx;
	uSavess = _SS;
	uSavebp = _BP;
	in_tcp |= INT17_FLAG;
	if (uSavess != _DS) {
		_SS = _DS;
		_SP = stack_pointer - 14;
		_BP = stack_pointer;
		stack_pointer -= 0x200;
	}
	else
		uSavess = 0;
	// copy values onto (new) local stack
	Ax = uAx;
	printnum = uPrintnum;
	savess = uSavess;
	savebp = uSavebp;
	// now OK to enable interrupts
	enable();
	uTargetTime = sec_timer + 30;
	if (Ah > 2) {
		Ah -= 2;
	}
	else while (1) {
		plcb = lpcb + printnum;
		tcb = plcb->tcb;
		if ((plcb->cPrinterStatus & (PS_PAPEROUT | PS_ERROR)) ||
				!(plcb->cPrinterStatus & PS_SELECTED)) {
			goto status_exit;
		}
		if (plcb->cStatus & LPTS_DATA) {
			if (SendLptChar(plcb,plcb->cData) < 0) {
				goto status_exit;
			}
			plcb->cStatus &= ~LPTS_DATA;
		}
		switch (Ah) {
		case 0:			/* send one char */
			if (SendLptChar(plcb,Al) < 0) {
				plcb->cStatus |= LPTS_DATA;
				plcb->cData = Al;
				status_exit:
				if (Ah == 0)
					break;
			}
			// fall thru
		case 1:			/* init printer port */
		case 2:			/* return status */
			if (tcb && tcb->sndcnt + BUFSZ >= tcb->window) {
				Ah = plcb->cPrinterStatus;
				plcb->timer.start = plcb->wTimeOut;
				start_timer(&plcb->timer);
			}
			else
				Ah = plcb->cPrinterStatus | PS_READY;	// give ready status
			goto done;
		}
		schedule();
		if ((int)(uTargetTime - sec_timer) < 0) {
			Ah = plcb->cPrinterStatus | PS_TIMEOUT;
			break;
		}
	}
	done:
	disable();
	// copy values from stack to static
	uAx = Ax;
	uSavebp = savebp;
	if (savess != 0) {
		_SS = savess;
		_BP = uSavebp;
		stack_pointer += 0x200;
	}
	// copy ax from static to (old) stack
	in_tcp &= 0xf;
	ax = uAx;
}

void far lpt_rcv(struct tcb *tcb,WORD cnt)
{
	MBUF *bp;
	char ch;
	LPCB *plcb = (LPCB *)tcb->user;

	recv_tcp(tcb,&bp,cnt,0);	/* flush input */
	while (bp) {
		ch = pullchar(&bp);
		plcb->cPrinterStatus &= ~(PS_PAPEROUT | PS_SELECTED | PS_ERROR | PS_LASTCHAR | PS_TIMEOUT);
		plcb->cPrinterStatus |= (ch & (PS_PAPEROUT | PS_SELECTED | PS_ERROR | PS_LASTCHAR | PS_TIMEOUT));
	}
}

/* State change upcall routine */
#pragma argsused
void far lpt_state(TCB *tcb,char old,char new)
{
	LPCB *plcb = (LPCB *)tcb->user;
	char reason;

	switch (new) {
	case CLOSE_WAIT:
		close_tcp(tcb);
		if (plcb->tcb == tcb) {
			goto error;	/* error on remote close */
		}
		break;
	case CLOSED:
		reason = tcb->reason;
		del_tcp(tcb);
		if (plcb->tcb == tcb) {
			if (reason != NORMAL_R) {
				error:
				//plcb->cPrinterStatus |= PS_ERROR;
			}
			if (plcb->bp) {
				free_p(plcb->bp);
				plcb->bp = 0;
			}
			plcb->tcb = 0;
			plcb->cPrinterStatus = PS_SELECTED;
		}
		break;
	}
}

#endif
// AH = 2 read the printer Status into (ah)
//   7   6   5   4   3   2   1   0
//   |   |   |   |   |   |   |   +-- time out
//   |   |   |   |   |   |   +------ last character sent to printer (Non-standard)
//   |   |   |   |   |   +---------- unused
//   |   |   |   |   +-------------- 1 = i/o error
//   |   |   |   +------------------ 1 = selected
//   |   |   +---------------------- 1 = out of paper
//   |   +-------------------------- 1 = acknowledge
//   +------------------------------ 1 = not busy
//
// DX =  printer to be used (0,1,2)
