//
//   $Id: TERM.C 1.3 2002/10/16 16:42:12Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
// TERM.C
// Security check routines. Called 'term' to confuse
// Copyright (c) GP van Niekerk Ondernemings 1990-1998

#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <dos.h>
#include "inetdefs.h"
#include "mbuf.h"
#include "netfunc.h"
#include "timer.h"
#include "iface.h"
#include "ip.h"
#include "udp.h"
#include "pc.h"

#ifdef SCREW
#define screw {poke(0,4,screwmes);poke(0,6,_CS);poke(0,12,screwmes);poke(0,14,_CS);}
#else
#define screw
#endif

#ifndef NOLIC
void termto();

static struct timer term_timer = {
	0,0,
	5 * ((unsigned)60000l / MSPTICK),
	0,
	termto
};

//#define DEB 1		// comment out for no debugging

//extern char copyr[];
extern unsigned int copies, num_ser_num;
extern unsigned long serial_numbers[],product_flags;
;

#define	TERM_PORT 12345
#define	BROADCAST 0xffffffffl

#define ENCODE 0
#define DECODE 1

typedef struct termstruc {
	int code;			/* request code */
#define	CLAIM	 0		/* claim a serial/sequence number */
#define	RESPONSE 1		/* respond to a claim */
#define	QUERY	 2		// query the license - rev 1
#define Q_RESPONSE 4	// query response - rev 1
	int seqnum;			/* sequence number claimed */
	WORD rnumclaims;	/* remote number of claims */
	union {
		char sernum[30];	/* the serial number */
		struct {
			char revision;
			unsigned long serie;
// rev 1
			WORD number;		// number of licenses
			DWORD flags;		// the product flags
// rev 2
			WORD id;			// random ID of request
		} numeric_serie;
   } serie_type;
} TERM;

int compare_serial(TERM *tp);
static termsend(int32 address,int port,int code,MBUF *bp);
static void termclaim(void);
static void termunclaim(void);

#define TERML sizeof(TERM)	/* length of TERM block */

static struct socket termsock;
static WORD myseq;		/* my sequence number */
static int seqtrycnt;		/* sequence try count */
static int numseqnum;		/* number of sequence numbers allowed */
static WORD numclaims;		/* number of unchallenged claims made,
				   every time a conflicting response is
				   received, this value is halved. When I
				   yield, this value is set to 0. */

/* Start the security server */
void termstart()
{
	void far termreq();
//	char *pline[8];
	static char executed;

	if (executed++)
		return;
/*
	endec(DECODE,pline);
	if (
//	   (pline[1][0] == 'S' &&
//		pline[1][1] == 'A' &&
//		pline[1][2] == 'S' &&
//		pline[1][3] == 'O' &&
//		pline[1][4] == 'L' &&
//		pline[1][5] == ' ' &&
//		pline[1][6] == 'I' &&
//		pline[1][7] == 'I') ||
		(	pline[1][0] == 'D' &&
		pline[1][1] == 'e' &&
		pline[1][2] == 'm' &&
		pline[1][3] == 'o' &&
		pline[1][4] == 'n' &&
		pline[1][5] == 's' &&
		pline[1][6] == 't' &&
		pline[1][7] == 'r' &&
		pline[1][8] == 'a' &&
		pline[1][9] == 't' &&
		pline[1][10] == 'i' &&
		pline[1][11] == 'o' &&
		pline[1][12] == 'n')
	)
	{
		endec(ENCODE,pline);
		return;
	}
*/
//	if (pline[1][0] == 'S' && pline[1][1] == 'L') {
		numseqnum = copies; // atoi(pline[1] + 2);
//	}
//	endec(ENCODE,pline);
	myseq = (WORD)(def_ip_addr % numseqnum);
	termsock.address = 0;
	termsock.port = TERM_PORT;
	open_udp(&termsock,termreq,0);
	termclaim();
	start_timer(&term_timer);
}

static void termclaim()
{
	IFACE *ifp;

	for (ifp = ifaces;ifp;ifp = ifp->next) {
		if (!(ifp->sflags & (SF_RAW | SF_UNC)))
			ifp->flags |= SECUR_FLAG;
	}
}

static void termunclaim()
{
	IFACE *ifp;

	for (ifp = ifaces;ifp;ifp = ifp->next) {
		if (!(ifp->sflags & (SF_RAW | SF_UNC)))
			ifp->flags &= ~SECUR_FLAG;
	}
}

/* called from ip_route */
void termprod()
{
	++numclaims;
	termsend(BROADCAST,TERM_PORT,CLAIM,0);
}

/* security timeout */
static void termto()
{
	seqtrycnt = 0;
	termclaim();
	start_timer(&term_timer);
}

/* Security request from remote */
#pragma argsused
static void far termreq(struct socket *sock,WORD cnt)
{
	IFACE *ifp;
	struct mbuf *bp;
	struct socket fsock;
	TERM *tp;
	char *ap,*e;

	recv_udp(sock,&fsock,&bp);
	tp = (TERM *)bp->data;
	if (tp->code == QUERY) {
		termsend(fsock.address,fsock.port,Q_RESPONSE,bp);
		return;
	}
#ifdef DEB
	ap = (char *)&fsock.address;
	printf("Rcv Secr from %u.%u.%u.%u ",ap[3],ap[2],ap[1],ap[0]);
#endif
	for (ifp = ifaces;ifp;ifp = ifp->next) {
		if (fsock.address == ifp->ip_addr) {
			free_p(bp);
			return;
		}
	}
	if (compare_serial(tp) == 1 && tp->seqnum == myseq) {
#ifdef DEB
		printf("%s %d %d\n",tp->code == RESPONSE ? "RESPONSE" : "CLAIM",
					tp->seqnum,tp->rnumclaims);
#endif
		if (tp->code == RESPONSE) {
			if (!numseqnum) {
				e = "Duplicate copy of INET detected";
				goto error;
			}
			else if (numclaims < tp->rnumclaims ||
						(numclaims >>= 1) == 0) {
				goto yield;
			}
			goto respond;
		}
		else if (tp->code == CLAIM) {
			if (!numseqnum || numclaims > tp->rnumclaims ||
				(numclaims == tp->rnumclaims &&
						def_ip_addr < fsock.address)) {
				respond:
				termunclaim();
				termsend(fsock.address,TERM_PORT,RESPONSE,bp);
				return;
			}
			else {
				yield:
				numclaims = 1;
				if (seqtrycnt++ < numseqnum) {
					if (++myseq >= numseqnum)
						myseq = 0;
					termunclaim();
					termsend(BROADCAST,TERM_PORT,CLAIM,bp);
					return;
				}
				else {
					e = "Too many copies of INET running";
					error:
					ap = (char *)&fsock.address;
					printf("\n%s!\nIP address: %u.%u.%u.%u\n",
						e,ap[3],ap[2],ap[1],ap[0]);
#ifndef DEB
					iostop();
					exit(1);
#endif
				}
			}
		}
	}
#ifdef DEB
	else
		printf("\n");
#endif
	free_p(bp);
}

static termsend(int32 address,int port,int code,MBUF *bp)
{
	struct socket fsock,lsock;
	TERM *tp;

	lsock.address = 0;
	fsock.address = address;
	lsock.port = fsock.port = port;
	if (bp) {
		tp = (TERM *)bp->data;
		if (tp->serie_type.numeric_serie.revision != 2) {
			free_p(bp);
			bp = 0;
		}
	}
#ifdef DEB
{
	char *ap = (char *)&address;
	printf("Snd Secr to %u.%u.%u.%u ",ap[3],ap[2],ap[1],ap[0]);
}
#endif
	if (!bp) {
		if ((bp = alloc_mbuf(TERML,AllocTermSnd)) == 0) {
#ifdef DEB
			printf("failed!\n");
#endif
			return;
		}
		tp = (TERM *)bp->data;
	}
	tp->serie_type.numeric_serie.revision = 0x02;	  /* revision */
	tp->serie_type.numeric_serie.serie = serial_numbers[num_ser_num - 1];
	bp->cnt = TERML-16;
	tp->code = code;					/* request code */
	tp->seqnum = myseq;					/* sequence number claimed */
	tp->rnumclaims = numclaims;			/* my number of claims */
	tp->serie_type.numeric_serie.number = numseqnum;// number of licenses
	tp->serie_type.numeric_serie.flags = product_flags;
	tp->serie_type.numeric_serie.id = 0;// we don't use this
#ifdef DEB
	printf("%s %d %d\n",tp->code == RESPONSE ? "RESPONSE" : "CLAIM",
											tp->seqnum,tp->rnumclaims);
#endif
	send_udp(&lsock,&fsock,0,0,bp,0,0,0,0);
	return;
}

int compare_serial(TERM *tp)
{
	unsigned long serie;
	int start;
	unsigned char i;
	char *cp, *cp1;
	char sernum[30];

	if(*(tp->serie_type.sernum) == 0x46 )
	{
		memcpy(sernum,tp->serie_type.sernum,30);
		for (i = 0, start = 21; i < 15; i++)
		{
			*(sernum + i) ^= start++;
		}
		sernum[i] = 0;
		if((cp = strchr(sernum, ' ')) != NULL)
			cp++;	// First space
		if((cp1 = strchr(cp, ' ')) != NULL )
		{
			*cp1 = 0;
			serie = (unsigned long)atoi(cp);
		}
	}
	else
	{
		memmove((char*)&serie, tp->serie_type.sernum + 1, 4);
	}

	for(i = 0; i < num_ser_num; i++)
	{
		if (serie == serial_numbers[i])
			return 1;	// matching any of my serial numbers
	}
	return 0;	/* Not found in list. OK */
}
#else
#ifdef ESEC

void re_boot(char *mes)
{
	void (*freset)(void);

	printf(mes);
	getch();
	freset = MK_FP(0xffff,0);
	(*freset)();
}

void screwmes(void)
{
	re_boot("Program corrupted\n");
}

char copyr[]= "\xd6\x5f\xf5"
"\n"
"                   \n\
x\0\0\0";

endec(char mode,char **pline)
{
	char *p;
	int i;
	char bline = 1;
	int cs;
	int ccs = 0;

	screw;
	if (mode) {
		for (p = copyr + 3,i = 5;1;p++,i++) {
			screw;
			ccs += *p;
			*p ^= i;
			if (!*p)
				break;
		}
		screw;
		cs = *((int *)(p + 1));
		for (i = 0,p = copyr + 3;*p;p++) {
			screw;
			if (bline) {
				pline[i++] = p;
				bline = 0;
			}
			if (*p == '\n') {
				*p = 0;
				bline = 1;
			}
		}
		pline[i] = 0;
		if (ccs != cs) {
			endec(0,pline);
			re_boot("\nInvalid copy of Rinet\n");
		}
	}
	else {
		screw;
		for (i = 1;pline[i];i++) {
			*(pline[i] - 1) = '\n';
		}
		for (p = copyr + 3,i = 5;*p;p++,i++) {
			screw;
			*p ^= i;
		}
		*p ^= i;
	}
}

#define EADDR_LEN 6

#endif

void termstart()
{
#ifdef ESEC
	char *pline[8],hwa[20],str[80];
	BYTE *hwadd = ifaces->hwaddr;
	int i;

	screw;
	for (i = 0;i < EADDR_LEN;i++)
		sprintf(hwa + 2 * i,"%02x",hwadd[i]);
	endec(1,pline);
	if (strncmp(pline[1],hwa,2 * EADDR_LEN) != 0) {
		sprintf(str,"Not serialised correctly: %s %s\n",pline[1],hwa);
		re_boot(str);
	}
	endec(0,pline);
#endif
}

void termprod()
{
}
#endif
