#
#   $Id: socketmd.mak 1.9 2002/10/24 18:37:46Z johnb Exp $
#
#   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
#
#   Copyright (c) 1993 - 2002 Datalight, Inc.
#   All Rights Reserved
#
#   Datalight, Inc. is a Washington corporation with an address at
#   21520 30TH DR SE MS110 Bothell, WA, 98021
#   Tel: 800.221.6630  Fax: 425.951.8091
#   Http://www.datalight.com
#
#   This software, including without limitation all source code and
#   documentation, is the confidential, trade secret property of
#   Datalight, Inc., and is protected under the copyright laws of
#   the United States and other jurisdictions. Portions of the
#   software may also be subject to one or more the following US
#   patents: US#5860082, US#6260156.
#
#   In addition to civil penalties for infringement of copyright
#   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
#   penalties for violation of (a) the restrictions on circumvention
#   of copyright protection systems found in 17 U.S.C. 1201 and
#   (b) the protections for the integrity of copyright management
#   information found in 17 U.S.C. 1202.
#
#   U.S. Government Restricted Rights. Use, duplication,
#   reproduction, or transfer of this commercial product and
#   accompanying documentation is restricted in accordance with
#   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
#
#   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
#   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
#   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
#   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
#   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
#   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
#   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
#   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
#   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
#   THIS SOFTWARE IN ERROR.
#
#
# SOCKETMD.EXE Makefile
# Copyright (c) 2001 Datalight, Inc.
# All Rights Reserved
# Datalight Confidential and Proprietary
#
# Revision History
# 10/24/2002 jmb added bootpcmd.c/.obj
# 10/24/2002 jmb added RD_SW and RD_SW_L support
# 07/25/2001 gvn added KERNEL flag
# 07/10/2001 gvn improved usage
# 07/09/2001 jmb removed -k- option
# 05/04/2001 pb  Added Usage screen file.
# 04/02/2001 jmb Ported from a Borland C++ Generated makefile
#
#
.AUTODEPEND


#
# Borland C++ tools
#
CC = BCC
BCCDOS  = $(CC)
TLINK   = TLink
TASM    = Tasm

#
# Dependency List
#
socketmd : BccDos.cfg socketmd\socketmd.exe
#	@if exist ,,\socketmd.exe del ..\socketmd.exe >nul
#	@copy socketmd\socketmd.exe ..\socketmd.exe

#
# Options
#
LFLAGS = $(RD_SW_L) -c -Tde -m
CFLAGS = $(RD_SW) -I..\INCLUDE;..\..\include -DMSDOS;APL=0;DL;noNOLIC;ASYNC;PPP_S;USR;noDEB;LPDD;KERNEL;


STARTUP = c0m.obj
LIB = noehm.lib cm.lib ..\..\lib\dlm.lib

LAST_OBJ = last.obj

SOCKETS_OBJ = 	!a000.obj	\
		!alloc.obj	\
		!api_intc.obj	\
		!arp.obj	\
		!arpcmd.obj	\
		!bootp.obj	\
		!bootpcmd.obj	\
		!bprintf.obj	\
		!cmdparse.obj 	\
		!commands.obj	\
		!debug.obj	\
		!dns.obj	\
		!eccom.obj	\
		!enet.obj	\
		!exit.obj	\
		!fileio45.obj	\
		!files.obj	\
		!files2.obj	\
		!icmp.obj	\
		!icmpcmd.obj	\
		!iface.obj	\
		!ifunc.obj	\
		!igmp.obj	\
		!ip.obj		\
		!ipcmd.obj	\
		!lpdd.obj	\
		!main.obj	\
		!mbuf.obj	\
		!misc.obj	\
		!netfunc.obj	\
		!pcs.obj	\
		!pktdrv.obj	\
		!pktdrvi.obj	\
		!prntserv.obj	\
		!rip.obj	\
		!rs.obj 	\
		!schedule.obj	\
		!tcp.obj	\
		!tcpcmd.obj	\
		!term.obj	\
		!timer.obj	\
		!udp.obj	\
		!version.obj	\
		!api_int.obj	\
		!newtimer.obj	\
		!pcg.obj	\
		!pktrcv.obj	\
		!usage.obj \
		!z000.obj

SOCKMD_OBJ  =  	!asy.obj	\
		!md5_dgst.obj	\
		!modem.obj	\
		!ppp.obj	\
		!pppcmd.obj	\
		!s_iface.obj	\
		!slhc.obj	\
		!slip.obj	\
		!slipb.obj	\
		!userpass.obj




socketmd.TLK : $(SOCKETS_OBJ:!=socketmd\) $(SOCKMD_OBJ:!=socketmd\)
	@echo Building linker response file...
	@echo $(STARTUP)  +>socketmd.TLK
	@&echo $? +              >>socketmd.tlk
        @echo socketmd\last.obj   >>socketmd.TLK
        @ECHO socketmd\socketmd, socketmd\socketmd >>socketmd.TLK
	@echo $(LIB) $(LFLAGS);  >>socketmd.TLK


socketmd\socketmd.exe : $(SOCKETS_OBJ:!=socketmd\) $(SOCKMD_OBJ:!=socketmd\) $(LAST_OBJ) socketmd.tlk
  @$(TLINK)  @socketmd.tlk
  @cd socketmd
  @echo Compressing socketmd.EXE
  @..\..\BIN\lzexe socketmd.exe > nul
  @cd ..
  @del socketmd.tlk > nul


socketmd\a000.obj :  a000.c
socketmd\alloc.obj :  alloc.c
socketmd\api_intc.obj :  api_intc.c
socketmd\arp.obj :  arp.c
socketmd\arpcmd.obj :  arpcmd.c
socketmd\asy.obj :  asy.c
socketmd\bootp.obj :  bootp.c
socketmd\bootpcmd.obj :  bootpcmd.c
socketmd\bprintf.obj :  bprintf.c
socketmd\cmdparse.obj :  cmdparse.c
socketmd\commands.obj :  commands.c
socketmd\debug.obj :  debug.c
socketmd\dns.obj :  dns.c
socketmd\eccom.obj :  eccom.c
socketmd\enet.obj :  enet.c
socketmd\exit.obj :  exit.c
socketmd\fileio45.obj :  fileio45.c
socketmd\files.obj :  files.c
socketmd\files2.obj :  files2.c
socketmd\icmp.obj :  icmp.c
socketmd\icmpcmd.obj :  icmpcmd.c
socketmd\iface.obj :  iface.c
socketmd\ifunc.obj :  ifunc.c
socketmd\igmp.obj :  igmp.c
socketmd\ip.obj :  ip.c
socketmd\ipcmd.obj :  ipcmd.c
socketmd\lpdd.obj :  lpdd.c
socketmd\main.obj :  main.c
socketmd\mbuf.obj :  mbuf.c
socketmd\md5_dgst.obj :  md5_dgst.c
socketmd\misc.obj :  misc.c
socketmd\modem.obj :  modem.c
socketmd\netfunc.obj :  netfunc.c
socketmd\pcs.obj :  pcs.c
socketmd\pktdrv.obj :  pktdrv.c
socketmd\pktdrvi.obj :  pktdrvi.c
socketmd\ppp.obj :  ppp.c
socketmd\pppcmd.obj :  pppcmd.c
socketmd\prntserv.obj :  prntserv.c
socketmd\rip.obj :  rip.c
socketmd\rs.obj :  rs.c
socketmd\s_iface.obj :  s_iface.c
socketmd\schedule.obj :  schedule.c
socketmd\slhc.obj :  slhc.c
socketmd\slip.obj :  slip.c
socketmd\slipb.obj :  slipb.c
socketmd\tcp.obj :  tcp.c
socketmd\tcpcmd.obj :  tcpcmd.c
socketmd\term.obj :  term.c
socketmd\timer.obj :  timer.c
socketmd\udp.obj :  udp.c
socketmd\userpass.obj :  userpass.c
socketmd\version.obj :  version.c
socketmd\api_int.obj :  api_int.asm
socketmd\newtimer.obj :  newtimer.asm
socketmd\pcg.obj :  pcg.asm
socketmd\pktrcv.obj :  pktrcv.asm
socketmd\z000.obj :  z000.c
socketmd\usage.obj :  usage.c
socketmd\last.obj :  last.c

# Compiler configuration file
BccDos.cfg :
   Copy &&|
-W-
-w
#-R
#-v
-vi
-H
-H=socketp.csm
-1
-C
-O-d
-Z
-O
-O-e
-Ol
-d
-mm
-f-
-x-
-xp-
-xd-
-xc-
-xf-
-RT-
-O-b
-O-W
-O-a
-O-m
-O-p
-v-
-R-
-K-
-H-
| $@


.c.obj:
  $(CC) @BccDos.cfg -P- -c @&&|
  $(CFLAGS) -osocketmd\$*.obj $*.c
|

.asm.obj:
  $(TASM) /ml $*.asm ,socketmd\$*.obj


