#
#   $Id: socketp.mak 1.10 2002/10/24 18:37:46Z johnb Exp $
#
#   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
#
#   Copyright (c) 1993 - 2002 Datalight, Inc.
#   All Rights Reserved
#
#   Datalight, Inc. is a Washington corporation with an address at
#   21520 30TH DR SE MS110 Bothell, WA, 98021
#   Tel: 800.221.6630  Fax: 425.951.8091
#   Http://www.datalight.com
#
#   This software, including without limitation all source code and
#   documentation, is the confidential, trade secret property of
#   Datalight, Inc., and is protected under the copyright laws of
#   the United States and other jurisdictions. Portions of the
#   software may also be subject to one or more the following US
#   patents: US#5860082, US#6260156.
#
#   In addition to civil penalties for infringement of copyright
#   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
#   penalties for violation of (a) the restrictions on circumvention
#   of copyright protection systems found in 17 U.S.C. 1201 and
#   (b) the protections for the integrity of copyright management
#   information found in 17 U.S.C. 1202.
#
#   U.S. Government Restricted Rights. Use, duplication,
#   reproduction, or transfer of this commercial product and
#   accompanying documentation is restricted in accordance with
#   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
#
#   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
#   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
#   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
#   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
#   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
#   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
#   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
#   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
#   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
#   THIS SOFTWARE IN ERROR.
#
#
# SOCKETP.EXE Makefile
# Copyright (c) 2001 Datalight, Inc.
# All Rights Reserved
# Datalight Confidential and Proprietary
#
# Revision History
# 10/24/2002 jmb added bootpcmd.c/.obj
# 09/27/2001 jmb added RD_SW and RD_SW_L support
# 07/25/2001 gvn added KERNEL flag
# 07/10/2001 gvn improved usage
# 07/09/2001 jmb removed -k- option
# 05/04/2001 pb  Added Usage screen file.
# 03/30/2001 jmb Ported from a Borland C++ Generated makefile
#
#
.AUTODEPEND


#
# Borland C++ tools
#
CC = BCC
BCCDOS  = $(CC)
TLINK   = TLink
TASM    = Tasm

#
# Dependency List
#
socketp : BccDos.cfg SOCKETP\socketp.exe
#	@if exist ..\socketp.exe del ..\socketp.exe >nul
#	@copy socketp\socketp.exe ..\socketp.exe

#
# Options
#
LFLAGS = $(RD_SW_L) -c -Tde -m
CFLAGS = $(RD_SW) -I..\INCLUDE;..\..\INCLUDE -DMSDOS;APL=0;DL;NOLIC;noDEB;LPDD;KERNEL;


STARTUP = c0m.obj
LIB = noehm.lib cm.lib ..\..\LIB\dlm.lib

LAST_OBJ = last.obj

SOCKETS_OBJ = 	!a000.obj	\
		!alloc.obj	\
		!api_intc.obj	\
		!arp.obj	\
		!arpcmd.obj	\
		!bootp.obj	\
		!bootpcmd.obj	\
		!bprintf.obj	\
		!cmdparse.obj 	\
		!commands.obj	\
		!debug.obj	\
		!dns.obj	\
		!eccom.obj	\
		!enet.obj	\
		!exit.obj	\
		!fileio45.obj	\
		!files.obj	\
		!files2.obj	\
		!icmp.obj	\
		!icmpcmd.obj	\
		!iface.obj	\
		!ifunc.obj	\
		!igmp.obj	\
		!ip.obj		\
		!ipcmd.obj	\
		!lpdd.obj	\
		!main.obj	\
		!mbuf.obj	\
		!misc.obj	\
		!netfunc.obj	\
		!pcs.obj	\
		!pktdrv.obj	\
		!pktdrvi.obj	\
		!prntserv.obj	\
		!rip.obj	\
		!rs.obj 	\
		!schedule.obj	\
		!tcp.obj	\
		!tcpcmd.obj	\
		!term.obj	\
		!timer.obj	\
		!udp.obj	\
		!version.obj	\
		!api_int.obj	\
		!newtimer.obj	\
		!pcg.obj	\
		!pktrcv.obj	\
		!usage.obj \
		!z000.obj



SOCKETP.TLK : $(SOCKETS_OBJ:!=SOCKETP\)
	@echo Building linker response file...
	@echo $(STARTUP)  +>SOCKETP.TLK
	@&echo $? +              >>socketp.tlk
        @echo socketp\last.obj   >>SOCKETP.TLK
        @ECHO socketp\socketp, socketp\socketp >>SOCKETP.TLK
	@echo $(LIB) $(LFAGS);  >>SOCKETP.TLK


SOCKETP\socketp.exe : $(SOCKETS_OBJ:!=SOCKETP\) $(LAST_OBJ) socketp.tlk
  @$(TLINK)  $(LFLAGS) @socketp.tlk
  @cd socketp
  @echo Compressing SOCKETP.EXE
  @..\..\BIN\lzexe socketp.exe > nul
  @cd ..
  @del socketp.tlk > nul


SOCKETP\a000.obj :  a000.c
SOCKETP\alloc.obj :  alloc.c
SOCKETP\api_intc.obj :  api_intc.c
SOCKETP\arp.obj :  arp.c
SOCKETP\arpcmd.obj :  arpcmd.c
SOCKETP\bootp.obj :  bootp.c
SOCKETP\bootpcmd.obj :  bootpcmd.c
SOCKETP\bprintf.obj :  bprintf.c
SOCKETP\cmdparse.obj :  cmdparse.c
SOCKETP\commands.obj :  commands.c
SOCKETP\debug.obj :  debug.c
SOCKETP\dns.obj :  dns.c
SOCKETP\eccom.obj :  eccom.c
SOCKETP\enet.obj :  enet.c
SOCKETP\exit.obj :  exit.c
SOCKETP\fileio45.obj :  fileio45.c
SOCKETP\files.obj :  files.c
SOCKETP\files2.obj :  files2.c
SOCKETP\icmp.obj :  icmp.c
SOCKETP\icmpcmd.obj :  icmpcmd.c
SOCKETP\iface.obj :  iface.c
SOCKETP\ifunc.obj :  ifunc.c
SOCKETP\igmp.obj :  igmp.c
SOCKETP\ip.obj :  ip.c
SOCKETP\ipcmd.obj :  ipcmd.c
SOCKETP\lpdd.obj :  lpdd.c
SOCKETP\main.obj :  main.c
SOCKETP\mbuf.obj :  mbuf.c
SOCKETP\misc.obj :  misc.c
SOCKETP\netfunc.obj :  netfunc.c
SOCKETP\pcs.obj :  pcs.c
SOCKETP\pktdrv.obj :  pktdrv.c
SOCKETP\pktdrvi.obj :  pktdrvi.c
SOCKETP\prntserv.obj :  prntserv.c
SOCKETP\rip.obj :  rip.c
SOCKETP\rs.obj :  rs.c
SOCKETP\schedule.obj :  schedule.c
SOCKETP\tcp.obj :  tcp.c
SOCKETP\tcpcmd.obj :  tcpcmd.c
SOCKETP\term.obj :  term.c
SOCKETP\timer.obj :  timer.c
SOCKETP\udp.obj :  udp.c
SOCKETP\version.obj :  version.c
SOCKETP\api_int.obj :  api_int.asm
SOCKETP\newtimer.obj :  newtimer.asm
SOCKETP\pcg.obj :  pcg.asm
SOCKETP\pktrcv.obj :  pktrcv.asm
SOCKETP\z000.obj :  z000.c
SOCKETP\usage.obj :  usage.c
SOCKETP\last.obj :  last.c

# Compiler configuration file
BccDos.cfg :
   Copy &&|
-W-
-w
#-R
#-v
-vi
-H
-H=socketp.csm
-1
-C
-O-d
-Z
-O
-O-e
-Ol
-d
-mm
-f-
-x-
-xp-
-xd-
-xc-
-xf-
-RT-
-O-b
-O-W
-O-a
-O-m
-O-p
-v-
-R-
-K-
-H-
| $@


.c.obj:
  $(CC) @BccDos.cfg -P- -c @&&|
  $(CFLAGS) -oSOCKETP\$*.obj $*.c
|

.asm.obj:
  $(TASM) /ml $*.asm ,SOCKETP\$*.obj


