#
#   $Id: socketpd.mak 1.9 2002/10/24 18:37:46Z johnb Exp $
#
#   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
#
#   Copyright (c) 1993 - 2002 Datalight, Inc.
#   All Rights Reserved
#
#   Datalight, Inc. is a Washington corporation with an address at
#   21520 30TH DR SE MS110 Bothell, WA, 98021
#   Tel: 800.221.6630  Fax: 425.951.8091
#   Http://www.datalight.com
#
#   This software, including without limitation all source code and
#   documentation, is the confidential, trade secret property of
#   Datalight, Inc., and is protected under the copyright laws of
#   the United States and other jurisdictions. Portions of the
#   software may also be subject to one or more the following US
#   patents: US#5860082, US#6260156.
#
#   In addition to civil penalties for infringement of copyright
#   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
#   penalties for violation of (a) the restrictions on circumvention
#   of copyright protection systems found in 17 U.S.C. 1201 and
#   (b) the protections for the integrity of copyright management
#   information found in 17 U.S.C. 1202.
#
#   U.S. Government Restricted Rights. Use, duplication,
#   reproduction, or transfer of this commercial product and
#   accompanying documentation is restricted in accordance with
#   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
#
#   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
#   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
#   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
#   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
#   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
#   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
#   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
#   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
#   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
#   THIS SOFTWARE IN ERROR.
#
#
# SOCKETPD.EXE Makefile
# Copyright (c) 2001 Datalight, Inc.
# All Rights Reserved
# Datalight Confidential and Proprietary
#
# Revision History
# 10/24/2002 jmb added bootpcmd.c/.obj
# 10/24/2002 jmb added RD_SW and RD_SW_L support
# 07/25/2001 gvn added KERNEL flag
# 07/10/2001 gvn improved usage
# 07/09/2001 jmb removed -k- option
# 05/04/2001 pb  Added Usage screen file.
# 04/02/2001 jmb Ported from a Borland C++ Generated makefile
#
#
.AUTODEPEND


#
# Borland C++ tools
#
CC = BCC
BCCDOS  = $(CC)
TLINK   = TLink
TASM    = Tasm

#
# Dependency List
#
socketpd : BccDos.cfg SOCKETPD\socketpd.exe
#	@if exist ..\socketpd.exe del ..\socketpd.exe >nul
#	@copy socketpd\socketpd.exe ..\socketpd.exe

#
# Options
#
LFLAGS = $(RD_SW_L) -c -Tde -m
CFLAGS = $(RD_SW) -I..\INCLUDE;..\..\INCLUDE -DMSDOS;APL=0;DL;noNOLIC;noDEB;LPDD;KERNEL;

STARTUP = c0m.obj
LIB = noehm.lib cm.lib ..\..\LIB\dlm.lib

LAST_OBJ = last.obj

SOCKETS_OBJ = 	!a000.obj	\
		!alloc.obj	\
		!api_intc.obj	\
		!arp.obj	\
		!arpcmd.obj	\
		!bootp.obj	\
		!bootpcmd.obj	\
		!bprintf.obj	\
		!cmdparse.obj 	\
		!commands.obj	\
		!debug.obj	\
		!dns.obj	\
		!eccom.obj	\
		!enet.obj	\
		!exit.obj	\
		!fileio45.obj	\
		!files.obj	\
		!files2.obj	\
		!icmp.obj	\
		!icmpcmd.obj	\
		!iface.obj	\
		!ifunc.obj	\
		!igmp.obj	\
		!ip.obj		\
		!ipcmd.obj	\
		!lpdd.obj	\
		!main.obj	\
		!mbuf.obj	\
		!misc.obj	\
		!netfunc.obj	\
		!pcs.obj	\
		!pktdrv.obj	\
		!pktdrvi.obj	\
		!prntserv.obj	\
		!rip.obj	\
		!rs.obj 	\
		!schedule.obj	\
		!tcp.obj	\
		!tcpcmd.obj	\
		!term.obj	\
		!timer.obj	\
		!udp.obj	\
		!version.obj	\
		!api_int.obj	\
		!newtimer.obj	\
		!pcg.obj	\
		!pktrcv.obj	\
		!usage.obj \
		!z000.obj



SOCKETPD.TLK : $(SOCKETS_OBJ:!=SOCKETPD\)
	@echo Building linker response file...
	@echo $(STARTUP)  +>SOCKETPD.TLK
	@&echo $? +              >>socketpd.tlk
        @echo socketpd\last.obj   >>SOCKETPD.TLK
        @ECHO socketpd\socketpd, socketpd\socketpd >>SOCKETPD.TLK
	@echo $(LIB) $(LFAGS);  >>SOCKETPD.TLK


SOCKETPD\socketpd.exe : $(SOCKETS_OBJ:!=SOCKETPD\) $(LAST_OBJ) socketpd.tlk
  @$(TLINK)  @socketpd.tlk
  @cd socketpd
  @echo Compressing SOCKETPD.EXE
  @..\..\BIN\lzexe socketpd.exe > nul
  @cd ..
  @del socketpd.tlk > nul


SOCKETPD\a000.obj :  a000.c
SOCKETPD\alloc.obj :  alloc.c
SOCKETPD\api_intc.obj :  api_intc.c
SOCKETPD\arp.obj :  arp.c
SOCKETPD\arpcmd.obj :  arpcmd.c
SOCKETPD\bootp.obj :  bootp.c
SOCKETPD\bootpcmd.obj :  bootpcmd.c
SOCKETPD\bprintf.obj :  bprintf.c
SOCKETPD\cmdparse.obj :  cmdparse.c
SOCKETPD\commands.obj :  commands.c
SOCKETPD\debug.obj :  debug.c
SOCKETPD\dns.obj :  dns.c
SOCKETPD\eccom.obj :  eccom.c
SOCKETPD\enet.obj :  enet.c
SOCKETPD\exit.obj :  exit.c
SOCKETPD\fileio45.obj :  fileio45.c
SOCKETPD\files.obj :  files.c
SOCKETPD\files2.obj :  files2.c
SOCKETPD\icmp.obj :  icmp.c
SOCKETPD\icmpcmd.obj :  icmpcmd.c
SOCKETPD\iface.obj :  iface.c
SOCKETPD\ifunc.obj :  ifunc.c
SOCKETPD\igmp.obj :  igmp.c
SOCKETPD\ip.obj :  ip.c
SOCKETPD\ipcmd.obj :  ipcmd.c
SOCKETPD\lpdd.obj :  lpdd.c
SOCKETPD\main.obj :  main.c
SOCKETPD\mbuf.obj :  mbuf.c
SOCKETPD\misc.obj :  misc.c
SOCKETPD\netfunc.obj :  netfunc.c
SOCKETPD\pcs.obj :  pcs.c
SOCKETPD\pktdrv.obj :  pktdrv.c
SOCKETPD\pktdrvi.obj :  pktdrvi.c
SOCKETPD\prntserv.obj :  prntserv.c
SOCKETPD\rip.obj :  rip.c
SOCKETPD\rs.obj :  rs.c
SOCKETPD\schedule.obj :  schedule.c
SOCKETPD\tcp.obj :  tcp.c
SOCKETPD\tcpcmd.obj :  tcpcmd.c
SOCKETPD\term.obj :  term.c
SOCKETPD\timer.obj :  timer.c
SOCKETPD\udp.obj :  udp.c
SOCKETPD\version.obj :  version.c
SOCKETPD\api_int.obj :  api_int.asm
SOCKETPD\newtimer.obj :  newtimer.asm
SOCKETPD\pcg.obj :  pcg.asm
SOCKETPD\pktrcv.obj :  pktrcv.asm
SOCKETPD\z000.obj :  z000.c
SOCKETPD\usage.obj :  usage.c
SOCKETPD\last.obj :  last.c

# Compiler configuration file
BccDos.cfg :
   Copy &&|
-W-
-w
#-R
#-v
-vi
-H
-H=socketpd.csm
-1
-C
-O-d
-Z
-O
-O-e
-Ol
-d
-mm
-f-
-x-
-xp-
-xd-
-xc-
-xf-
-RT-
-O-b
-O-W
-O-a
-O-m
-O-p
-v-
-R-
-K-
-H-
| $@


.c.obj:
  $(CC) @BccDos.cfg -P- -c @&&|
  $(CFLAGS) -oSOCKETPD\$*.obj $*.c
|

.asm.obj:
  $(TASM) /ml $*.asm ,SOCKETPD\$*.obj


