#  $Id: CGI.MAK 1.5 2003/03/20 18:19:24Z thomd Exp $
#
#  *** DO NOT REMOVE THE FOLLOWING NOTICE ***
#
#  Copyright (c) 2001-2003 Datalight, Inc.
#  All Rights Reserved
#
#  Datalight, Inc. is a Washington corporation located at:
#
#  21520 30th Dr SE, Suite 110,          Tel: +1.425.951.8086
#  Bothell, WA  98021                    Fax: +1.425.951.8094
#  USA                                   Http://www.datalight.com
#
#  This software, including without limitation all source code and
#  documentation, is the confidential, trade secret property of
#  Datalight, Inc., and is protected under the copyright laws of
#  the United States and other jurisdictions.  Portions of the
#  software may also be subject to one or more the following US
#  patents: US#5860082, US#6260156.
#
#  In addition to civil penalties for infringement of copyright
#  under applicable U.S. law, 17 U.S.C. 1204 provides criminal
#  penalties for violation of (a) the restrictions on circumvention
#  of copyright protection systems found in 17 U.S.C. 1201 and
#  (b) the protections for the integrity of copyright management
#  information found in 17 U.S.C. 1202.
#
#  U.S. Government Restricted Rights.  Use, duplication,
#  reproduction, or transfer of this commercial product and
#  accompanying documentation is restricted in accordance with
#  FAR 12.212 and DFARS 227.7202 and by a License Agreement.
#
#  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
#  PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
#  AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
#  INC. AND THE LICENSEE ("BINDING AGREEMENT").  YOUR RIGHT, IF ANY,
#  TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
#  TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
#  USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
#  TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT.  CONTACT
#  DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
#  THIS SOFTWARE IN ERROR.
#
# CGI Programs Makefile
# Copyright (c) 2001 Datalight, Inc.
# All Rights Reserved
# Datalight Confidential and Proprietary
#
# Revision History
# 07/19/2001 jmb added cgidemo
# 05/10/2001 jmb added ffur and removed form
# 04/11/2001 jmb original revision
#

#
# compiler/linker definitions
#
CC = bcc
TLINK = TLINK


#
# flags and support definitions
LFLAGS = -x -c -P-
CFLAGS = -c -K -I..\include -C -O -Z -k-
STARTUP = c0s.obj
LIBS    = emu.lib+maths.lib+cs.lib+graphics.lib

all : cgiecho.exe num.exe cgiform.exe ssi.exe ffur.exe

clean :
	@if exist *.obj del *.obj
	@if exist *.map del *.map
	@if exist cgiecho.exe del cgiecho.exe
	@if exist cgicount.exe del cgicount.exe
	@if exist num.exe del num.exe
	@if exist cgiform.exe del cgiform.exe
	@if exist ssi.exe del ssi.exe
	@if exist ffur.exe del ffur.exe
	@if exist cgidemo.exe del cgidemo.exe



cgiecho.exe : echo.obj cgiadap.obj
	@$(TLINK) $(LFLAGS) @&&|
		$(STARTUP)+
		echo.obj+
		cgiadap.obj
		cgiecho
		cgiecho
		$(LIBS)
|

num.exe : num.obj cgiadap.obj
	@$(TLINK) $(LFLAGS) @&&|
		$(STARTUP)+
		num.obj+
		cgiadap.obj
		num
		num
		$(LIBS)
|
	@copy num.exe cgicount.exe /y >nul

cgiform.exe : cgiform.obj cgiadap.obj
	@$(TLINK) $(LFLAGS) @&&|
		$(STARTUP)+
		cgiform.obj+
		cgiadap.obj
		cgiform
		cgiform
		$(LIBS)
|


ffur.exe : ffur.obj getch.obj cgiadap.obj
	@$(TLINK) $(LFLAGS) @&&|
		$(STARTUP)+
		ffur.obj+
		getch.obj+
		cgiadap.obj
		ffur
		ffur
		$(LIBS)
|


ssi.exe: ssi.obj ssicgi.obj cgiadap.obj
  $(TLINK) $(LFLAGS) @&&|
	$(STARTUP)+
	cgiadap.obj+
	ssicgi.obj+
	ssi.obj
	ssi
	ssi
	$(LIBS)
|

cgidemo.exe : cgidemo.obj cgiadap.obj
	@$(TLINK) $(LFLAGS) @&&|
		$(STARTUP)+
		echo.obj+
		cgiadap.obj
		cgidemo
		cgidemo
		$(LIBS)
|


#
# individual file dependencies
#
echo.obj     : echo.c

num.obj      : num.c

cgiform.obj  : cgiform.c

ffur.obj     : ffur.c
getch.obj    : getch.c

ssi.obj      : ssi.c

ssicgi.obj   : ssicgi.c

cgiadap.obj  : cgiadap.c

cgidemo.obj  : cgidemo.c

#
# implicit rules
#
.c.obj:
  $(CC) $(CFLAGS) {$< }

