//
//   $Id: CGIADAP.C 1.4 2002/10/16 16:57:00Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
	$DOCFILE:CGIADAP.C

	Copyright (C) 1999-2001 Datalight, Inc.
	All Rights Reserved

	HTTP CGI Adapter functions

	$DOCHISTORY:

	2001-07-14  gvn fixed resident sizes
	2001-05-11	GPvN fix NO_API return
	2000-05-18	GVvN first version
 */

#ifndef __BORLANDC__
#define	flags cflag
#undef	FP_SEG
#define	FP_SEG( fp ) ( (unsigned )(__segment)( fp ))
#endif


#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <dos.h>
#include "cgiadap.h"

// Stack pointer for asynchronous callbacks
static int iStackPointer, iStackSegment;

int GetStackPointer(void)
{
	return iStackPointer;
}

int GetStackSegment(void)
{
	return iStackSegment;
}

void SetStackPointer(int iPointer)
{
	iStackPointer = iPointer;
}

void SetStackSegment(int iSegment)
{
	iStackSegment = iSegment;
}


#define DOSINT 0x21

static unsigned MyPSP;	//this program's psp
static unsigned ServPSP;//httpd's psp

/* -------- return current PSP ---------- */
static unsigned GetPSP(void)
{
	_AH = 0x51;
	geninterrupt(DOSINT);
	return _BX;
}

/* Set PSP
 */
static void SetPSP(unsigned iPSP)
{
	_AH = 0x50;
	_BX = iPSP;
	geninterrupt(DOSINT);
}

static int ApiCall(union REGS *r, struct SREGS *s);

static int iApiInt;		// API interrupt found

static struct cbHolder {
	unsigned long dwUserID;
	//PFCALLBACK pfCallback;
	char *szName;
	struct cbHolder *next;
	int (far *pfCallback)(HTTP_PARAMS far *psHttpParams);
};

struct cbHolder *psList;//first in list

static int FindVec(void)
{
	void (far __interrupt *lpIntApiv)();
	static char rgcID[] = "SockHTTPD";
	int iApiInt,i;
	char far *lpcID;

	for (iApiInt = 0x20;iApiInt < 0x100;++iApiInt) {
		lpIntApiv = _dos_getvect(iApiInt);
		if (lpIntApiv == 0)
			continue;
		lpcID = (char far *)lpIntApiv - 10;
		for (i = 0;i < 9;++i) {
			if (lpcID[i] != rgcID[i])
				break;
		}
		if (i == 9)
			break;
	}
	if (iApiInt == 0x100) {
		iApiInt = 0;
	}
	return iApiInt;
}

static int ApiCall(union REGS *r, struct SREGS *s)
{
	if (!iApiInt && !(iApiInt = FindVec())) {
		return -NO_API;
	}

	int86x(iApiInt, r, r, s);
	return r->x.ax;
}

#define STACK_SIZE 1024
/*
handle callback - perform stack switch and call registered caller
*/
static int _loadds far Callback(HTTP_PARAMS far *psHttpParams)
{
	static int (far *Handler)(HTTP_PARAMS far*);
	static struct cbHolder *pcbHolder;
	//static far HTTP_PARAMS sParams;
	static far HTTP_PARAMS *psParams;// = &sParams;
	static int iRet;
	static int iSaveSS, iSaveSP;

	//restore the user's own variable and get the correct callback function pointer
	//_fmemcpy(&sParams, psHttpParams, sizeof(HTTP_PARAMS));
	psParams = psHttpParams;//save as stack switch will confuse
	pcbHolder = (struct cbHolder*)psParams->dwUserID;
	psParams->dwUserID = pcbHolder->dwUserID;
	//psHttpParams->dwUserID = pcbHolder->dwUserID;
	Handler = pcbHolder->pfCallback;

	iSaveSP = _SP;
	iSaveSS = _SS;
	_SS = iStackSegment;
	_SP = iStackPointer;

	if (!ServPSP)
		ServPSP = GetPSP();

	SetPSP(MyPSP);
	iRet = (*Handler)(psParams);
	SetPSP(ServPSP);


	_SS = iSaveSS;
	_SP = iSaveSP;

	psParams->dwUserID = (long)pcbHolder;//restore for internal use

	return iRet;
}



/*
adapter for cgi interfacing with HTTPD server
*/
/*
iFlags:


Bit 0 - 	overlapped requests (1), non-overlapped requests (0).
All other bits are reserved.

return:	0 - ok
			1 - already registered
			3 - not enough memory

dwUserID - value passed to Register();  this value is for use by the
	extension, HTTPD does not modify it.
iHandle - HTTPD handle, used in subsequent API calls for this request.
iReason - reason for callback:
	0 - 	New HTTP request. pszCommandLine points to the command line passed
		in the URL. The number contained in iValue specifies the HTTP
		operation; 0 for GET and 1 for POST.
	1 - 	Input data available, iValue contains count.
	2 - 	Can send output data, iValue contains count.
	3 - 	Peer closed connection ie "end of input data"
	4 - 	Connection closed.

return values:
	0 - not done
	1 - done, ok
	-1 - done, error

Remarks:
The callback is guaranteed to only be called when DOS can be called.
The DOS critical handler will be disabled and all critical errors will
result in an access error without any user intervention.
Since the callback happens at interrupt time, it should execute for
as short a time as possible. After a done or error return, no further
callbacks will be generated for the current request.

Only one callback will be active at any time.
Calling an API function while executing the callback function,
will not result in another callback before the current callback has returned.

Note that the stack and the data segment on entry will be that of HTTPD.
Depending on the memory model used for the extension and the amount of
stack space required, it may be required to switch stacks during the
callback.


	Assembler level:
	AH = 0
	szName: 	DS:SI
	pfCallback: 	ES:DI
	iFlags:		BX
	dwUserID:	CX:DX

	Return in AX register.

*/

int HttpRegister(char far *szPath,
 int (far *pfCallback)(HTTP_PARAMS far *psHttpParams), int iFlags,
 unsigned long dwUserID)
{
	union REGS r;
	struct SREGS s;
	int iRet;

	struct cbHolder *psHolder;
/*
#ifdef _M_I86LM
	#define __LARGE__
#endif
#ifdef __LARGE__
	static char rgcStack[STACK_SIZE];
	iStackPointer = (int)rgcStack + STACK_SIZE - 10;
#endif
*/
	if (!MyPSP)
		MyPSP = GetPSP();
	if (!iStackSegment)
		iStackSegment = _SS;
	if (!iStackPointer)
		iStackPointer = _SP - 1000;

	if (!pfCallback)//im not going to execute at null
		return -INVALID;//nb may later change

	if((psHolder = calloc(1, sizeof(struct cbHolder))) != 0) {
		if((psHolder->szName = malloc(_fstrlen(szPath) + 1)) == 0)
			free (psHolder);
	}
	if (!psHolder)
		return -NO_SPACE;//not enough memory
	_fstrcpy(psHolder->szName, szPath);
	psHolder->dwUserID = dwUserID;
	psHolder->pfCallback = pfCallback;
	//put userid in dwUserID
	r.h.ah = APIF_REGISTER;
	r.x.bx = iFlags;
	s.ds = FP_SEG(szPath);
	r.x.si = FP_OFF(szPath);
	s.es = FP_SEG(Callback);
	r.x.di = FP_OFF(Callback);
	r.x.cx = FP_SEG(psHolder);
	r.x.dx = FP_OFF(psHolder);
	iRet = ApiCall(&r, &s);
	if (iRet == 0) {//all OK
		//put in linked list
		psHolder->next = psList;
		psList = psHolder;
		return 0;
	}
	free(psHolder->szName);
	free(psHolder);
	return iRet;
}



/*
int HttpDeRegister(char *pszPath);
return:	0 - ok
			2 - not registered


Remarks:
After this call no more callbacks will be generated for this URL.
Any requests in progress will be terminated with an error to the peer.
This API must be called for all registrations made by a program before
terminating that program, otherwise the system will inevitably crash on
any subsequent request.

Assembler level:
AH = 1
pszPath: 	DS:SI

Return in AX register.
*/
int HttpDeRegister(char far *pszPath)
{
	union REGS r;
	struct SREGS s;
	struct cbHolder *psHolder;
	struct cbHolder *psPrev = 0;

	r.h.ah = APIF_DEREGISTER;
	s.ds = FP_SEG(pszPath);
	r.x.si = FP_OFF(pszPath);

	for (psHolder = psList; psHolder; psHolder = psHolder->next) {
		if (_fstricmp(psHolder->szName, pszPath) == 0)
			break;
		psPrev = psHolder;
	}
	if (psHolder) {
		if (psPrev)
			psPrev->next = psHolder->next;
		else
			psList = psHolder->next;
		free(psHolder->szName);
		free(psHolder);
	}
	//else it may perhaps still be registered in server (previous error)
	//leave errors to server	return -NO_USER;//return not found
	return ApiCall(&r, &s);
}


/*
Remarks:
This API can be called when a POST operation has been indicated by the
callback. If more data is expected and the extension is busy executing
the callback function, a 0 return should be made from the callback
indicating it is still busy and getting more data should be
attempted at the next callback.


return: 	>=0 bytes received
			-1 error; peer closed connection
	-2 error; connection does not exist

*/
int HttpGetData(int iHandle, char far *pcBuf, int iCount)
{
	union REGS r;
	struct SREGS s;
/*
Assembler level:
AH = 2
iHandle:		BX
pcBuf: 		DS:SI
iCount:		CX

Return in AX register.
*/
	r.h.ah = APIF_GETDATA;
	r.x.bx = iHandle;
	s.ds = FP_SEG(pcBuf);
	r.x.si = FP_OFF(pcBuf);
	r.x.cx = iCount;
	return ApiCall(&r, &s);
}


/*
Remarks:
This API can be called to send data to the peer.
If the return indicates that less than the requested number of bytes has
been sent and the extension is busy executing the callback function,
a 0 return should be made from the callback indicating it is still busy and
an attempt to send more data should be made at the next callback.

All the required data should be sent to the peer before the HttpSubmitFile()
function is used. After HttpSubmitFile(), HttpSendData() should not be
called again.

return: 	>= 0 number of bytes actually sent
	< 0 error

*/
int HttpSendData(int iHandle, char far *pcBuf, int iCount)
{
	union REGS r;
	struct SREGS s;
/*
AH = 3
iHandle:		BX
pcBuf: 		DS:SI
iCount:		CX
*/
	r.h.ah = APIF_SENDDATA;
	r.x.bx = iHandle;
	s.ds = FP_SEG(pcBuf);
	r.x.si = FP_OFF(pcBuf);
	r.x.cx = iCount;
	return ApiCall(&r, &s);
}


/*
Remarks:
The extension can submit a file to be sent to the peer in response
to a request. The file will be logically appended to any data already
sent using HttpSendData(). The file should not be exclusively opened
when it is submitted.
return:  	0 	ok
	< 0 	error

*/
int HttpSubmitFile(int iHandle, char far *pszFileName)
{
	union REGS r;
	struct SREGS s;
	int iRet;
/*
Assembler level:
AH = 4
iHandle:		BX
pszFileName: 	DS:SI

Return in AX register.
*/
	r.h.ah = APIF_SENDFILE;
	r.x.bx = iHandle;
	s.ds = FP_SEG(pszFileName);
	r.x.si = FP_OFF(pszFileName);
	if (!ServPSP)
		return INVALID;
	SetPSP(ServPSP);//let sockets open the file in his own context (he should actually do this?)
	iRet = ApiCall(&r, &s);
	SetPSP(MyPSP);//set psp for http server
	return iRet;

}

/*
 * Get the version number of the server
 */
int HttpGetVersion(void)
{
	union REGS r;
	struct SREGS s;

	r.h.ah = APIF_GETVERSION;
	return ApiCall(&r, &s);
}

/*
 * Get the status of the HTTP server.
 * Also, if the server is running in passive mode, give the server time to
 * process any qued events
 *
 * Return: number of active connections on server
 */
int HttpGetStatus(void)
{
	union REGS r;
	struct SREGS s;

	r.h.ah = APIF_GETSTATUS;
	return ApiCall(&r, &s);
}
