//
//   $Id: form.c 1.3 2002/10/16 16:57:00Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
	$DOCFILE:FORM.C

	Copyright (C) 1999-2001 Datalight, Inc.
	All Rights Reserved

	Simple spawn CGI forms demo program
	for Sockets HTTP server

	$DOCHISTORY:

	2001-05-11	GPvN cleanup
	2000-05-18	GVvN first version
 */

// Simple "CGI" program for Rinet HTTP server
#include <stdio.h>
#include <io.h>
#include <stdlib.h>
#include <string.h>
int check_password(char *pname,char *ppass);

// Format of input:
// loginname=gerrit&password=van+niekerk&submit=Submit
// clear=Clear+all

// Forms demo
void main(int argc,char *argv[])
{
	char buf[200],*p,*pname,*ppass,*rm;
	int rc;
	char **env;

	*buf = 0;
	if ((rm = getenv("REQUEST_METHOD")) == 0)
		rm = "Not set";
	if (strcmp(rm,"GET") == 0) {
		// concatenate all arguments just incase
		while (argc-- > 1) {
			strcat(buf,argv[1]);
			strcat(buf," ");
			++argv;
		}
	}
	else
		gets(buf);
	// build the dynamic page
	printf("Content-type: text/html\n\n<html>\n<h1>\n");
	if (strncmp(buf,"loginname=",10) == 0) {
		pname = buf + 10;
		if ((p = strchr(pname,'&')) == 0)
			goto bad_input;
		*p++ = 0;
		if ((ppass = strchr(p,'=')) == 0)
			goto bad_input;
		if ((p = strchr(++ppass,'&')) == 0)
			goto bad_input;
		*p = 0;
		if ((rc = check_password(pname,ppass)) < -1)
			printf("Sorry %s, we have a system problem",pname);
		else if (rc < 0)
			printf("Sorry %s, you entered the wrong password",pname);
		else if (rc == 0)
			printf("User %s logged in",pname);
		else
			printf("Welcome %s, you are now registered",pname);
	}
	else if (strncmp(buf,"clear=",6) == 0) {
		printf("You asked for it!<p>All users cleared out.");
		unlink("users.dat");
	}
	else {
		bad_input:
		printf("Bad input<p>Method: %s<p>%s<p>",rm,buf);
		for (env = environ;*env;env++) {
			printf("%s<p>\n",*env);
		}
	}
	printf("<P><P><A HREF=\"/form.htm\">Back</A>.</html>\n");
	exit(0);
}

int check_password(char *pname,char *ppass)
{
	FILE *fp;
	char name[40],pass[40], *mode = "r+t";
	int rc = 1;

	if (access("users.dat",0) != 0)
		mode = "w+t";
	if ((fp = fopen("users.dat",mode)) == 0)
		return -2;
	while (fgets(name,40,fp) != 0) {
		name[strlen(name) - 1] = 0;
		fgets(pass,40,fp);
		pass[strlen(pass) - 1] = 0;
		if (strcmp(pname,name) == 0) {
			rc = strcmp(ppass,pass) ? -1 : 0;
			break;
		}
	}
	if (rc == 1)
		fprintf(fp,"%s\n%s\n",pname,ppass);
	fclose(fp);
	return rc;
}

