#
#   $Id: httpftpd.mak 1.5 2003/08/05 13:25:24Z johnb Exp $
#
#   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
#
#   Copyright (c) 1993 - 2002 Datalight, Inc.
#   All Rights Reserved
#
#   Datalight, Inc. is a Washington corporation with an address at
#   21520 30TH DR SE MS110 Bothell, WA, 98021
#   Tel: 800.221.6630  Fax: 425.951.8091
#   Http://www.datalight.com
#
#   This software, including without limitation all source code and
#   documentation, is the confidential, trade secret property of
#   Datalight, Inc., and is protected under the copyright laws of
#   the United States and other jurisdictions. Portions of the
#   software may also be subject to one or more the following US
#   patents: US#5860082, US#6260156.
#
#   In addition to civil penalties for infringement of copyright
#   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
#   penalties for violation of (a) the restrictions on circumvention
#   of copyright protection systems found in 17 U.S.C. 1201 and
#   (b) the protections for the integrity of copyright management
#   information found in 17 U.S.C. 1202.
#
#   U.S. Government Restricted Rights. Use, duplication,
#   reproduction, or transfer of this commercial product and
#   accompanying documentation is restricted in accordance with
#   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
#
#   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
#   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
#   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
#   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
#   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
#   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
#   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
#   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
#   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
#   THIS SOFTWARE IN ERROR.
#
#
# HTTPFTPD.EXE Makefile
# Copyright (c) 2001 Datalight, Inc.
# All Rights Reserved
# Datalight Confidential and Proprietary
#
# Revision History
# 07/09/2001 jmb chaned library link order
# 06/21/2001 jmb added cleanall target
# 04/10/2001 jmb Ported from a Borland C++ Generated makefile
#
#
.AUTODEPEND


all:	httpftpd
	@echo Making HTTPFTPD
	@if exist ..\httpftpd.exe del ..\httpftpd.exe >nul
	@copy httpftpd.exe ..\httpftpd.exe >nul

clean:
	@echo Cleaning HTTPFTPD
	@if exist *.obj del *.obj >nul
	@if exist *.map del *.map >nul
	@if exist *.cfg del *.cfg >nul

cleanall: clean
	@if exist *.exe del *.exe >nul

#
# Borland C++ tools
#
CC  = Bcc
TLINK   = TLink
TASM = TASM


#
# Options
#
AFLAGS = $(RD_SW_A) /ml
LFLAGS = $(RD_SW_L) -c -Tde -s
CFLAGS = $(RD_SW)

STARTUP = c0s.obj
LIBS = noehs.lib+cs.lib+..\..\..\lib\dls.lib

#
# Dependency List
#
httpftpd : httpftpd.exe


HTTPFTPD_OBJS =\
   htftmain.obj\
   httpss.obj\
   login.obj\
   httpres.obj\
   resint.obj\
   htapia.obj\
   htapic.obj\
   rcs.obj\
   ftpss.obj\
   ftpcom.obj\
   pathname.obj\
   dirutil.obj\
   mkname.obj\
   getch.obj\
   lfnopen.obj\
   int86n.obj

httpftpd.exe : httpftpd.cfg $(HTTPFTPD_OBJS)
  $(TLINK) $(LFLAGS)  @&&|
	$(STARTUP)+
	htftmain.obj+
	httpss.obj+
	login.obj+
	httpres.obj+
	resint.obj+
	htapia.obj+
	htapic.obj+
	rcs.obj+
	ftpss.obj+
	ftpcom.obj+
	pathname.obj+
	dirutil.obj+
	mkname.obj+
	getch.obj+
	lfnopen.obj+
	int86n.obj
	$<,$*
	$(LIBS)

|

htftmain.obj :  ..\source\htftmain.c

httpss.obj :  ..\source\httpss.c

login.obj :  ..\source\login.c

httpres.obj :  ..\source\httpres.c

resint.obj :  ..\source\resint.asm

htapia.obj :  ..\source\htapia.asm

htapic.obj :  ..\source\htapic.c

rcs.obj :  ..\source\rcs.c

ftpss.obj : ..\source\ftpss.c

ftpcom.obj : ..\source\ftpcom.c

pathname.obj :  ..\source\pathname.c

dirutil.obj :  ..\source\dirutil.c

mkname.obj :  ..\source\mkname.c

getch.obj :  ..\source\getch.c

lfnopen.obj :  ..\source\lfnopen.c

int86n.obj :  ..\source\int86n.cas

.asm.obj:
  $(TASM) $(AFLAGS) $<

.c.obj:
  $(CC) @httpftpd.cfg @&&|
	$(CFLAGS) $<
|

.cas.obj:
  $(CC) @httpftpd.cfg @&&|
	$(CFLAGS) $<
|



#
# Compiler configuration file
#
httpftpd.cfg :
   Copy &&|
-P- 
-c 
-I..\..\include;..\..\..\include 
-DPRODUCT=P_FtpServer;NOLIC;CHECK_ALLOCn;DEBUG_Qn;DL;HTTPD;FTPD
-W-
-w
#-R
#-v
-vi
-H
-H=httpftpd.csm
-R-
-K
-C
-i32
-O
-Oe
-Ob
-Z
-k-
-vi-
-ms
-f-
-x-
-xp-
-xd-
-xc-
-xf-
-RT-
-1-
-H-
| $@

