//
//   $Id: Constants.java 1.2 2002/10/16 17:01:48Z peterb Exp johnb $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/**
Note on settings for emulator:
A user may have his own settings, but these may be overriden by another set
(usally read-only, located on a server).
The locations of these settings are supplied by either the command line arguments in the applet
application or command line args in the Standalone application.
The format is 'key=value' and is case sensitive.
All the basic java escapes and types apply.
The key Strings for keybord mappings is as in the JVM's awt.properties file.
Control, shift, alt, and meta keys may be used in combination with any other key, and any key
may be used on its own.

Examples:
rows=24
Cannot connect to server=Kannie die dienser kry nie
OK=REG
Alt+Shift+e=ea ea

  A list of all the keys that may be read (excluding keybord shortcuts) follows:


  //INCOMPLETE!!

Fuction keys have specific values.

  The emulator first looks in the superset, if not defined in the user's set, else it uses a
  hardcoded default value.


*/

package inet;

import java.util.*;
import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.event.*;

class Constants extends Properties
{

	//each catagory serves as indication of contents of object
	//classes are guaranteed that all these properties will have values
	//CD_ == Connection Dialog
	/*
	Dxxx  = dialog
	DCON = Connection Dialog
	DKM = Key Map Dialog
	DS = Setup Dialog
	B = Button
	H = heading
	M = Message
	T = Title
	L = Label
	I = Integer
	P = Popup
	*/
	static Properties defs = new Properties();
        /**
         * Extends the properties class which accociates one
         * string with another, thus mapping them. This mapping is loaded from a file.
         *
         */

	public static final String
		Connect_title = addToProps("Enter connection parameters"),
		Connect_remport = addToProps("remport", "23"),
		Connect_remhost = addToProps("remhost", ""),
		KeyMap_title    = addToProps("Setup for keybord mappings"),
		CurSpeed_title  = addToProps("Set cursor speed"),
		Setup_title     = addToProps("General setup options"),

		Label_ENVal  = addToProps("Enter new values"),
		Label_presKey = addToProps("Press any key"),
		Label_curAss = addToProps("Current assignment"),
		Label_mapTo  = addToProps("map to"),
		Label_mapToH = addToProps("in hex"),
		Label_func   = addToProps("function"),
		Label_host      = addToProps("Host to log on to"),
		Label_port      = addToProps("Remote port number"),
		Mes_HostNotFound = addToProps("Inet cannot establish a connection to the specified host and port."),
		Mes_ConFailed = addToProps("Connection failed"),

		ConNotS_title = addToProps("ConNotS.title", "Settings not saved - "),
		ConNotS_Mes = addToProps("ConNotS.Mes", "Do you want to save your settings?"),
		Screen_rows     = addToProps("Screen.rows", "24"),
		Screen_cols     = addToProps("Screen.cols", "80"),
		Screen_pages    = addToProps("Screen.pages", "6"),
		F_FACE = addToProps("Screen.fontface", "Courier"),
		F_SIZE = addToProps("Screen.fontsize", "13"),

		SET_LOAD = addToProps("Load settings"),
		SET_SAVE = addToProps("Save settings"),
		SET_TITLE = addToProps("Settings for Inet java terminal emulators"),

		//all button labels
		ok = addToProps("Ok"),
		cancel = addToProps("Cancel"),
		yes = addToProps("Yes"),
		no = addToProps("No"),
		retry = addToProps("Retry"),
		done = addToProps("Done"),
		clear = addToProps("Clear"),
		assign = addToProps("Assign")
	;

	static String addToProps (String name, String value)
	{
		defs.put(name, value);
		return name;
	}

	static String addToProps (String name)
	{
		defs.put(name,name);
		return name;
	}

	private boolean modified = false;
	private String pathname;//pathname coud be anything like c:\xyz, deva:/etc/xyz, http://at/... or ftp://196.10....

	//default constructor
	Constants()
	{
		super(defs);
	}

	Constants(String name)
	{
		super(defs);
		try {
			InputStream is;
                        is = getClass().getResourceAsStream(name);
                        //System.err.println("is= " +is);
                        try {
                          this.load(is);
                        }
                        catch (IOException ioe) {System.err.println("IOEXception: "+ioe);}

                        //File is in format:
                        //key:element
                        //key:element
                        //And the inherited load() method loads them into the class.
			is.close();
		}
		catch(Exception e) {
                  System.err.println("Error in loading constants from file: " +e);
			if (Debug.dv)
				Debug.out("init constants"+e);
		}
	}

	Constants(URL codebase, String name)
	{
		//pathname = codebase;
		super(defs);
		try {
			URL u = new URL(codebase, name);
			pathname = u.getHost() + u.getFile();
			if (Debug.dv)
				Debug.out("loading from:"+pathname);
			load(u.openStream());
		}
		catch(Exception e) {
			if (Debug.dv)
				Debug.out(e);
		}
	}

	/**
	creates a new Constants object and initialize with 3 sets of objects:
	1: the defaults defined within the code
	2: The user's settings
	3: Default values from host
	Jinet will always first search in (3), if not found in (2), else the value from (1) is taken
	*/
	/*
	Constants(Environment e)
	{
		//MAAK REG!!! (3 moet bo wees)
		super((Properties)defs.clone());
		try {
			load(new URL(pathname = e.settingsURL).openStream());
			defaults.load(new URL(e.defSettingsURL).openStream());
		}
		catch(Exception b) {
			if (Debug.dv) {
				Debug.out("constants constructor"+e.settingsURL+e.defSettingsURL+b);
			}
			//OD...
		}
	}
	*/
	boolean isModified()
	{
		return modified;
	}

	void load(Frame cFrame)
	{
		try {
			FileDialog l = new FileDialog(cFrame,getS(SET_LOAD),FileDialog.LOAD);
			l.show();
			InputStream is = new FileInputStream(l.getDirectory() + l.getFile());
			load(is);
			is.close();
		}
		catch(Exception e) {
			//pop nog dialog op wat probleem uitsorteer
			if (Debug.dv)
				Debug.out("Constants"+e);
		}
	}

	private void save() throws Exception
	{
		OutputStream os = new FileOutputStream(pathname);
		save(os, getS(SET_TITLE));
		os.close();
		modified = false;
	}

	int saveAs(Frame cFrame) {
		try {
			FileDialog d = new FileDialog(cFrame,getS(SET_SAVE),FileDialog.SAVE);
			d.show();
			pathname = d.getDirectory() + d.getFile();
			save();
			return 0;
		}
		catch(Exception e) {
			if (Debug.dv)
				Debug.out("Constants saving"+e);
			return -1;
		}
	}

	int save(Frame cFrame)
	{
		try {
			save();
			return 0;
		}
		catch(Exception e) {
			if (Debug.dv)
				Debug.out("Constants saving "+pathname+e);
			return saveAs(cFrame);
		}
	}

	/**
	Gets the value of the specified key. Return null if key doesnt exist
	*/
	String getS(String key)
	{
		return getProperty(key);
	}

	/**
	Gets the value of the specified key. Return the defualt supplied if key doesnt exist
	*/
	String getS(String key, String def)
	{
		String s = getS(key);
		if (null == s) return def;
		return s;
	}

	int getI(String key)
	{
		try {
			return Integer.decode(getProperty(key)).intValue();
		}
		catch(Exception e) {
			return -1;
		}
	}

	int getI(String key, int def) {
		int i = getI(key);
		if (-1 == i) return def;
		return i;
	}

	boolean getB(String key)
	{
		String s = getProperty(key);
		return !(s == null || "0".equals(s));
	}

	/**
	Gets the value of the specified key. Return null if key doesn't exist
	for key-mappings, and key is in format"aa 1211 afff 1a"etc.
	*/
	int[] getIntArray(String key)
	{
		return getIntsFromHexString(getProperty(key));
	}

	/**
	Gets the value of the specified key. Return the defualt supplied if key doesnt exist
	*/
	int[] getIntArray(String key, int[] def)
	{
		int[] ret = getIntArray(key);
		if (ret == null) return def;
		return ret;
	}

	// gets all elements starting with certian prefex
	// eg if "x.a" and "x.b" exits, getgroup("x") will return {"a","b"}.
	Constants getGroup (String prefix) {
		int length = prefix.length() + 1;//must include the '.'
		Constants ret = new Constants();
		for (Enumeration e = propertyNames(); e.hasMoreElements();  ) {
			String s = (String)e.nextElement();
			if (s.startsWith(prefix))
				ret.put(s.substring(length), getProperty(s));
		}
		return ret;
	}

	void setS(String k, String v)
	{
		put(k,v);
	}

	void setI(String k, int v)
	{
		put(k, ""+v);
	}

	void setH(String k, int v)
	{
		put(k, "0x" + Integer.toHexString(v));
	}

	void setB(String k, boolean v)
	{
		put(k, v ? "1" : "0");
	}

	//Used internally to put values in the default class - wont be saved
	void defPut(String k, String v)
	{
		defaults.put(k, v);
	}

	void put(String k, String v)
	{
		modified = true;
		super.put(k,v);
	}

	void remove(String s) {
		if (containsKey(s)) {
			modified = true;
			super.remove(s);
		}
	}

	public static String getKeyStateString(int mods, int key)
	{
		String m = KeyEvent.getKeyModifiersText(mods);
		String k = KeyEvent.getKeyText(key);
		if (mods == 0) return k;
		if (key == 0) return m;
		return m + "+" + k;
	}

	static int[] getIntsFromHexString(String s)
	{
//		od("+"+s+"+");
		try {
			StringTokenizer st = new StringTokenizer(s," ,;.\t");
			int[] ret = new int[st.countTokens()];
			for (char i = 0; i < ret.length; i++) {
				try {
					ret[i] = Integer.parseInt(st.nextToken(), 16);
				}catch (NumberFormatException n) {
					ret[i] = 0;
				}
			}
			return ret;
		}
		catch(Exception e) {
			return null;
		}
	}

	public static String getHexStringFromInts(int[] ints)
	{
		StringBuffer hex = new StringBuffer();
		for (char i = 0; i < ints.length; i++)
			hex.append(Integer.toHexString(ints[i])).append(' ');
		return new String(hex);
	}

}
