//
//   $Id: Debug.java 1.2 2002/10/16 17:01:48Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
package inet;

import java.io.*;
import java.awt.*;
import java.awt.event.*;

//contains constants that tells the compiler whether or not to compile debug code into the class files
//also handles debug output and error warnings

//Is not intended to ship with product

class Debug {
	static final boolean dv = false;//Debug Version - perform extra tests, notify if something rong, etc.
	static final boolean verboseInfo = false;//just verbose info that eg. tell connection status. For development only
	static final boolean ptests = false;
	static final boolean log = false;

	static Frame dw;
	static TextArea dt;

	static {
/*//	Mag nie in applet nie!
	System.setErr(new PrintStream(new OutputStream() {
			public void write(int i){dt.append(""+(char)i);}
			public void write(byte[]b){dt.append(new String(b));}
			},true)
		);
*/
		dw = new Frame("debug");
		dw.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e){dw.dispose();}
		});
		dw.setLayout(new FlowLayout());
		dw.add(dt = new TextArea(15,100));
		dw.pack();
		dw.show();
		dw.setLocation(200,200);
	}

	public static void out(Object o)//DEBUG
	{
		dt.append((o == null ? "null-obj" : o.toString())+"\r\n");
		if (o instanceof Exception)
			((Exception)o).printStackTrace();
		//pst();
	}

	static OutputStream o = null;
	public static void log(char c) {
		try {
			if (o == null) {
				o = new FileOutputStream("log.log");
			}
			o.write(c);
		}
		catch (Exception e) {
			if (dv)
				out("cant open log file"+e);
		}
	}
	public static void log(String s) {
		try {
			if (o == null) {
				o = new FileOutputStream("log.log");
			}
			o.write(s.getBytes());
		}
		catch (Exception e) {
			if (dv)
				out("cant open log file"+e);
		}
	}

	public static void pst()
	{
		try {
			throw new Exception();
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}

	static void bug(Object o)
	{
		dt.append("BUG DETECTED!!!");
		out(o);
	}
}
/**
Algemene notas oor prog.

  1. Hou method name en parameters beskrywend en mooi
  2. Gebruik eerder private methods as ingewikkelde algoritmes
  3. Gebruik mooi modelle (interfaces, etc)
  4. Maak access so nou as moontlik
  5. obj (instance) vars moet toetstand aandui, nie parameters nie


  Soek manier dat alles nie altyd oorgedoen hoef te word nie
  Skoon programmering? 
  KWALITEIT - funksies is gedokumenteer en doen als en slegs wat daarin staan
  Los 'tricks' - maak sake net ingewikkelder
  Dit vat 'n goeie begrip van die totale probleem / taak, holistiese siening, 
  Ervaring...
*/