//
//   $Id: OpenConnectionDialog.java 1.2 2002/10/16 17:01:48Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
package inet;

import java.awt.event.*;
import java.awt.*;

public class OpenConnectionDialog
extends QuickDialog
implements TextListener
{
	public String name = null;
	public int port = 0;
	List l;
	TextField ta, tb;
	Label err;
	Button b, b2;
	String lastURL = DataBase.addToProps("lastURL", "");
	String lastPort = DataBase.addToProps("lastPort", "23");
	DataBase db;

	public OpenConnectionDialog(Frame conFrame, DataBase s)
	{
		super(conFrame, "Open connection");
		db = s;
		//Constants s = e.settings;
		gridcons.fill = GridBagConstraints.BOTH;
		add (new Label(s.getS(s.Label_host)), gridcons);
		add (ta = new TextField(s.getS(lastURL), 30), gridcons);
		ta.selectAll();
		gridcons.gridy = 1;
		add (new Label(s.getS(s.Label_port)), gridcons);
		add (tb = new TextField(s.getS(lastPort), 10), gridcons);
		tb.selectAll();
		gridcons.gridy = 2;
		add (b2 = new Button(s.getS(s.cancel)));
		setgcXY(2, 1);
		add(b = new Button(s.getS(s.ok)),gridcons);
		b.setVisible(false);
		b.addActionListener(this);
		setModal(true);
		b2.addActionListener(this);
		ta.addTextListener(this);
		ta.addActionListener(this);
		display();
	}
	public void paint(Graphics g) {
		super.paint(g);
		ta.requestFocus();//may only get focus once visible on screen
	}

	public void actionPerformed(ActionEvent a) {
		Object o = a.getSource();
		if (o == b2) {
			name = null;
			dispose();
		}
		else if (o == b || o == ta) {
			try {
				port = Integer.valueOf(tb.getText(), 10).intValue();
				name = ta.getText();
				if (name == null || name.length() == 0)
					throw new Exception("No host spesified!");
				dispose();
				db.addSetting(lastURL, name);
				db.addSetting(lastPort, ""+port);
			}
			catch (Exception e) {
				Toolkit.getDefaultToolkit().beep();
				if(err != null) remove(err);
				err = new Label(e.toString());
				setgcXY(0, 2);
				gridcons.gridwidth = GridBagConstraints.REMAINDER; //end row				gridcons.gridwidth=GridBagConstraints.REMAINDER;
				add (err,gridcons);
				display();
			}
		}
	}
	
	//TextListener
    public void textValueChanged(TextEvent e) 
	{
		Object source = e.getSource();

		if (source == ta) {
			if (!b.isVisible())
				b.setVisible(true);
			else if(ta.getText().length() == 0)
				b.setVisible(false);
			display();
		}
	}

	public String getHost() 
	{
		return name;
	}

	public int getPort()
	{
		return port;
	}
}

