;
;   $Id: APIINT.ASM 1.2 2002/10/16 17:03:34Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
page 50,132
TITLE 'API_INT.ASM'
;
;	This assembler routine provides an interface between the API
;	handler written in 'C' and the user program
;	Updated @ Date 8 May 1996, 23:32 by Gerrit van Niekerk
;

extrn	_api_inti_c : near
extrn	_stack : word

public	_api_inti_a, _popf

DGROUP	GROUP	_DATA

ASSUME	DS : DGROUP,	CS : _TEXT

_DATA	SEGMENT	WORD	PUBLIC	'DATA'
_DATA	ENDS

;
;	Start of Code
;

_TEXT	SEGMENT	WORD	PUBLIC	'CODE'

;
;	This routine is the API entry point.  It is called by the user
;
; User stack:
;	. Fl . CS . IP . BP . DS . DI
;	  10   8    6    4    2    ^
;				   BP
; INET stack:
;       . SS . SP . Fl . DS . SI . DI . AX . BX . CX . DX . ES .
;         ^    -2   -4   -6   -8  -10  -12  -14
;         DI
; Note:
;	DS and DI are passed to INET but NOT udated before return to user
;	If required, they must be updated via SS:SP on INET stack

db	'RFTP'

_api_inti_a	proc	far	;INET API entry
	push	bp
	push	ds
	push	di
	MOV		bp,DGROUP		; Get Data Segment
	MOV		DS,bp		; Set up DS
	cli			;in case not done by real int
	mov		di, _stack
	mov		bp,ss
	mov		[di],bp
	mov		[di-2],sp
	mov		bp,sp
	mov		[di-12],ax
	mov		ax,[bp+2]	;ds
	mov		[di-6],ax
	mov		[di-8],si
	mov		ax,[bp]		;di
	mov		[di-10],ax
	mov		ax,[bp+10]	;flags
	mov		[di-4],ax
;now switch the stack
	sub		di,12
	and		ax,0200h		;test for interrupt state
	mov		ax,DGROUP
	mov		ss,ax
	mov		sp,di
	jz			ints_off
	sti
ints_off:
	push	bx
	push	cx
	push	dx
	push	es
	mov		ax,sp
	push	ax	;DON'T push sp directly, it differs on 80x86's
	CALL	_api_inti_c
	add		sp,2
	pop		es
	pop		dx
	pop		cx
	pop		bx
;switch stack back
	cli
	mov		ax,[di+12]	;ss
	mov		ss,ax
	mov		sp,[di+10]
	mov		ax,[di+8]	;flags
	mov		[bp+10],ax
	mov		ax,[di]
	mov		si,[di+4]
;	and		_in_tcp,0fh
;	dec		_in_tcp
api_int_exit:
	pop		di
	pop		ds
	pop		bp
	iret

_api_inti_a	endp

; simulate a popf instruction
_popf proc far
	iret
_popf endp

_TEXT	ENDS

	END

