//
//   $Id: FTPRES.C 1.5 2003/05/23 16:29:53Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
 * ftpres.c
 *
 * Copyright (C) 2001 Datalight, Inc.
 * All Rights Reserved
 * Datalight Confidential and Proprietary
 * Portions Copyright (c) 2001 GPvNO
 *
 * Revision History
 * Updated @ Date 18 November 1995, 12:34 by Gerrit van Niekerk
 * 07/27/2001 gvn replaced set_schedule with SetSchedule
 */

#pragma inline

#include <dos.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include "inetdefs.h"
#include "compiler.h"
#include "api.h"
#include "ftpapi.h"
#include "htapic.h"
#include "httftps.h"
#include "getch.h"
#define DOS_BUSY	1
#define DISKFLAG	2
#define SCHEDULE_FLAG	4
#define RUNNING		8
#define CRIT_ERR	16

static unsigned mcbseg;
static unsigned dosseg;
static unsigned enddos;
char far *intdta;
unsigned myss;
unsigned stack;
static unsigned mypsp;
static unsigned pids[2];
static int pidctr = 0;
void interrupt api_inti_a();
static char resoff = 0;
char opstat = 0x40;

#define DOSINT 0x21

void dores(void), pidaddr(void);
void setcsvecs(void interrupt (*vec1)(),void interrupt (*vec2)());

/* -------- establish & declare residency --------- */
void resinit()
{
	extern unsigned maxmem;

	myss = _SS;
	setvect(FTP_INT,api_inti_a);
	/* -------- get addresses of PID in DOS ------- */
	pidaddr();
	/* ------ compute stack pointer ------- */
	stack = maxmem + 0x800;
	/* ---- restore zero divide interrupt vector --- */
/*	setvect(0, ZeroDivVector);	*/
	/* ----- terminate and stay resident ------- */
	keep(0,(_SS + (stack / 16) - _psp + 1));
}

void SetSchedule()		// we need to re-enter soonest
{
	opstat |= SCHEDULE_FLAG;
}

void upcall_c()			// called by upcall
{
	opstat |= SCHEDULE_FLAG;
}

/*page*/

/* ------- test to see if the program is already resident
	  if found, return data segment ---------- */

WORD resident(void)
{
	return FP_SEG(getvect(FTP_INT));
}
/*page*/
/* -------- find address of PID ---------- */
static void pidaddr()
{
	unsigned adr = 0;

	/* ------- get the current pid --------- */
	_AH = 0x51;
	geninterrupt(DOSINT);
	mypsp = _BX;
	/* ----- find the end of the DOS segment ------- */
	_AH = 0x52;
	geninterrupt(DOSINT);
	enddos = _ES;
	enddos = peek(enddos, _BX - 2);
	/* ---- search for matches on the pid in dos ---- */
	while (pidctr < 2 &&
			(unsigned)((dosseg<<4) + adr) < (enddos<<4))	{
		if (peek(dosseg, adr) == mypsp)	{
			_BX = mypsp + 1;
			_AH = 0x50;
			geninterrupt(DOSINT);
			if (peek(dosseg, adr) == mypsp+1)
				pids[pidctr++] = adr;
			/* ---- reset the original pid ------ */
			_BX = mypsp;
			_AH = 0x50;
			geninterrupt(DOSINT);
		}
		adr++;
	}
}
/*page*/
#undef peekb	/* to overcome TC 1.0 bug */
/* ------- terminate function ----------- */
static void resterm()
{
	/* ---- get the seg addr of 1st DOS MCB ---- */
	_AH = 0x52;
	geninterrupt(DOSINT);
	mcbseg = _ES;
	mcbseg = peek(mcbseg, _BX - 2);
	/* ---- walk thru mcb chain & release memory ----- */
	while (peekb(mcbseg, 0) == 0x4d) {
		if (peek(mcbseg, 1) == mypsp) {
			_ES = mcbseg+1;
			_AH = 0x49;
			geninterrupt(DOSINT);
		}
		mcbseg += peek(mcbseg, 3) + 1;
	}
}
/* --------- terminate the resident program --------- */
void terminate(int iNoConfirmP)
{
   
	enable();
   if (ftps && !iNoConfirmP) {
		printf("Active sessions\n"
			"Press Ctrl A to abort them, any other key to continue...");
		if (Getch() != 1)
			return;
	}
	close_all();
	resterm();
	setvect(FTP_INT,0);
	printf("Unloaded\n");
}

/* ------------- restart the resident program --------- */
void restart()
{
	resoff = 0;
}

/* ------- put the program on hold -------- */
void wait()
{
	resoff = 1;
}
