//
//   $Id: HTFTMAIN.C 1.17 2003/05/19 20:37:32Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
// HTFTMAIN.C
// Copyright (c) 2001 Datalight, Inc.
// Portions copyright (c) GPvNO 2001
// All Rights Reserved
// Datalight Confidential and Proprietary
//
// Sockets TSR http/ftp/RemoteConsole server
//
// Revision History
// 05/19/2003 gvn status display corrected, keybord confirm optional
// 11/13/2002 jmb added flag to not use timer tick to schedule
// 01/05/2002 gvn Fix definitions for non Datalight version
// 08/06/2001 jmb corrected to allow FTPD to find and open SOCKET.UPW
// 07/27/2001 gvn prevent CGI extension to be called when Sockets is busy
// 07/26/2001 gvn fixed connections getting into CLOSED state without being deleted
// 04/30/2001 jmb used ROMDOS version number and copyright info.
// 04/30/2001 jmb created header
//
//

#include <stdlib.h>
#include <stdio.h>
#include "getch.h"
#include <dos.h>
#include <dir.h>
#include <process.h>
#include <string.h>
#include <stdarg.h>
#include <ctype.h>
#include <alloc.h>
#include "compiler.h"
#include "api.h"
#include "capi.h"
#include "dirutil.h"
#include <time.h>
#include "htapic.h"
#include "httftps.h"
#include "login.h"

#ifdef DL
#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "dosver.h"
#include "fatworld.h"
#endif

// HTTP history
// 0.05 98-12-17 POST operation
// 0.06 99-02-06 New Remote Console
// 1.00 99-05-13 Fix HTTP hangup
// 2.01 00-05-11 Included security features
// 2.02 00-06-01 Authentication
// 2.03 00-06-07 Included cgi api
// 2.04 00-06-20 Fixed callback bug
// 2.05 00-07-04 Included: passive mode, max number connections,
//						arguments passed to cgi-users, extended cgi api, documentation updated
// 2.06 00-07-12 Remove conio.h,
// 2.07 00-09-26 spawn problem removed
// 2.08 00-11-05 send out screensize at start

// FTPD history
// 2.05 98-09-04 Compatible with Rinet 3.26
// 2.07 98-09-14 Relative paths
// 2.08 99-02-11 /m=<mem> option, Datalight version
// 2.09 99-04-09 New Datalight path
// 2.10 99-07-08 fix for env variable ending in "\"
// 2.11 99-08-18 take out API chaining
// 2.12 99-09-11 cosmetic changes
// 2.13 99-11-10 updated help info (/x)
// 2.14 99-12-20 Exclusive open, FTPDIR env variable, remove sorting
// 2.15 99-12-27 LFN support
// 2.16 00-03-05 Preserve name case
// 2.17 00-04-12 eliminate upcall scheduling when not TSR, 80 byte mem leak
//               path buffer + stack buffers too small, garbage character
//               when reporting directory with drive spec, possibility of
//               sessions getting mixed up on session close
// 2.18 00-07-14 Enforce prototype checking

// 2.20 01-01-04 combine httpd and ftpd
// 3.02.20 01-02-14 New RESINT for LBA calls
// 04/11/2001 jmb cleaned up banner and usage screens to print valid
//                values for FTPD, HTTPD and HTTPFTPD.

#ifndef DL
char version[] = "2.23";
int hVersion = 0x100 * 2 + 23;
#else
#define VERSION SHORTVERSION " " BUILDVERSION
char version[] = VERSION;
int hVersion = VERSIONVAL;
#endif

#ifdef SHOW_DEB
char Hex(BYTE bVal)
{
	return (bVal > 9) ? bVal - 10 + 'A' : bVal + '0';
}

void ShowValue(WORD wVal,BYTE bFlag, int iOffset)
{
	static char cLevel;
	char cCol;
	char far *pc = MK_FP(0xb800,iOffset);

	if (bFlag) {
		pc[0] = Hex(wVal >> 12);
		pc[2] = Hex((wVal >> 8) & 0xf);
		pc[4] = Hex((wVal >> 4) & 0xf);
		pc[6] = Hex(wVal & 0xf);
		pc[10] = Hex(cLevel++);
		cCol = 0x40;		// black on red
	}
	else {
		cCol = 0x20;		// black on green
		cLevel--;
	}
	pc[1] = pc[3] = pc[5] = pc[7] = pc[11] = cCol;
}

#define CallApi ShowValue(r.h.ah,1,140);int86(api_int,&r,&r);ShowValue(0,0,140)
#else
#define CallApi int86(api_int,&r,&r)
#endif

//char state;
char cDontRemcon;		// don't start remcon
unsigned iNumcon;		// number of connections
unsigned iMaxNumcon;	//maximum number of connections
char cPassive = 0;	//Is this passive server
unsigned tcbs;
unsigned sTcboHttp;
unsigned sTcboFtp;
char *httpdir;
char httpBuf[100];
char *comspec;		// comspec env variable
char *path;			// path env variable
void SetRunning(void);
void far _loadds terminate(int iNoConfirm);
void far _loadds (*pterminate)(int iNoConfirm);
void far _loadds xstatus(int flags);
void SetRCtimer(void);
#define XSF_STOP_LISTEN	1
#define XSF_STATUS		2
void far _loadds (*pstatus)(int flags);
void handle_tcpq(void);
void close_all(void);

#ifdef HTTPD
TCP_OP_P sHttpOp = {0, 0, HTTP_PORT, TCP_SERVER, 0,
			http_rcv_up, http_snd_up, http_stc_up, 0, 0};
unsigned uRcPort = RMS_PORT;		// Remote Console port
#endif
#ifdef FTPD
TCP_OP_P sFtpOp = {0,0,FTP_PORT,TCP_SERVER,0,FtpControlReceive,0,FtpControlStateChange,0,0};
#endif

#ifdef DEBUGCON
static TCP_OP_P debug =  {0xc40ae502l,256,0,TCP_ACTIVE,0,0,0,0,0,0};//vp xserv port
static unsigned debugcon = 0;
#endif
void CloseListen(void);
void common_tcp(unsigned tcbo,char function);

#ifndef DL
#ifdef FTPD
#ifdef HTTPD
#define PROGRAM "IHFTPD"
#else
#define PROGRAM "IFTPD"
#endif
#else
#define PROGRAM "IHTTPD"
#endif
#define INET "Inet"
#define UPWFILE "inet.upw"
#define INETVAR "INET"
#define INETDIR	"\\inet"
#else
#ifdef FTPD
#ifdef HTTPD
#define PROGRAM "HTTPFTPD"
#else
#define PROGRAM "FTPD"
#endif
#else
#define PROGRAM "HTTPD"
#endif
#define INET "Sockets"
#define UPWFILE "socket.upw"
#define INETVAR "SOCKETS"
#define INETDIR	"\\dl\\sockets"
#endif

unsigned hapi_int = 0x63;
unsigned api_int;
unsigned api_intc;
void interrupt (*old_api)();
void interrupt (*old_apic)();
WORD far *pfwSocketsBusy;

char id[] = "Inet";
char id1[] = "RinetI";

char bUseTimerFlag = 1;
unsigned maxmem = 0x8000;
char monflag;					// monitor flag
char monfunc = 0x40;
char int28_ok = 1;			// set if OK to use int28
unsigned vidseg = 0xb800;
char signature[] = "Inet"
#ifdef HTTPD
"HTTP"
#endif
#ifdef FTPD
"FTP"
#endif
"Server";

unsigned dseg;

HTTP *HTTPfirst;				//first in ll pointers
HTTP *HTTPlast;				//last in ll pointers

int err_code, err_count;

typedef struct tcps {		// TCP request queue
	unsigned tcbo;
	char function;
	char *buf;					// buffer to free
	char *pbuf;					// current pointer
	int	cnt;					// current buffer count
} TCPQ;

#define TCPQSIZE 90
union {
	char message[sizeof(TCPQ) * TCPQSIZE];
	TCPQ tcpq[TCPQSIZE];
} u = {
"\n"
PROGRAM " [options] "
#ifdef HTTPD
"[<http_port>"
#endif
#ifdef FTPD
" [<ftp_port>"
#endif
#ifdef HTTPD
" [<rc_port>]"
#endif
#ifdef FTPD
"]"
#endif
#ifdef HTTPD
"]"
#endif
"\n\n"
"options:\n"
"/r - load as TSR\n"
"/s - list session status of resident servers\n"
"/c - close the listen socket (no new connections)\n"
"/u - unload if resident\n"
#ifdef HTTPD
"/t - htaccess - enable directory level authentication\n"
"/d - don't start Remote Console\n"
"/p - Passive mode\n"
"/x - don't schedule on timer tick\n"
"/i=<int_num> Interrupt number for cgi api\n"
"/a=<columns>,<rows>     - set screen aspect\n"
"/v=<segment>[:<offset>] - set video buffer address(hex)\n"
#endif
"/k - no Keyboard confirm when unloading\n"
"/m=<s> set the working memory to <s> bytes (default 32768)\n"
"/n=<maximum number of connections>\n"
#ifdef HTTPD
"<http_port> HTTP port to listen on (default 80)\n"
#endif
#ifdef FTPD
"<ftp_port>  FTP port to listen on (default 21)\n"
#endif
#ifdef HTTPD
"<rc_port>   Remote Console port to listen on (default 81)\n"
#endif
};

TCPQ *ptcpqi = u.tcpq;
TCPQ *ptcpqo = u.tcpq;
int ntcpq,iNoKeyboardConfirm;
WORD ErrTcpQueFull;

char *pszHostname;

char *pszUserfile;

main(int argc,char *argv[])
{
	int arg,api,iArgCount = 0;
	void interrupt (*int_apiv)();
	unsigned errcode,i;//ch,acnt;
	char far *pid;
	char is_id;
	char res_flag = 0,unload = 0;
#ifdef HTTPD
	char ht_flag = 0;
#endif
	int iStatusFag = 0;
	union REGS r;
	struct SREGS sr;
	char query_abort = 0;
	char *argvl[2];
	long memsize;
	char *cp,*cp2;

	printf(INET" "
#ifdef FTPD
						 "FTP"
#ifdef HTTPD
						 "/"
#endif
#endif
#ifdef HTTPD
						 "HTTP/RC"
#endif
	);
#ifdef DL
	if (dlIsFat32World())
	{
		printf(" Server %s",
				SHORTVERSION);
	}
	else
	{
		printf(" Server %s",
				SHORTVERSION622);
	}
	printf(" %s\n%s\n"
	       "Portions copyright (c) GPvNO 2003\n"
			 "(compiled: %s)\n\n",
			BUILDVERSION, COPYRIGHT, BUILDDATE);
#else
	printf(" Server ver %s\n", version);
#endif

#ifndef NOLIC
	check_dontwipe();
#endif
	for (api = 0x20;api < 0x100;++api) {
		int_apiv = getvect(api);
		if (int_apiv == 0)
			continue;
		pid = (char far *)int_apiv - 4;
		for (i = 0,is_id = 1;i < 4;++i) {
			if (pid[i] != id[i])
				is_id = 0;
		}
		if (is_id) {
			api_int = api;
			old_api = int_apiv;
		}
		pid = (char far *)int_apiv - 6;
		for (i = 0,is_id = 1;i < 6;++i) {
			if (pid[i] != id1[i])
				is_id = 0;
		}
		if (is_id) {
			api_intc = api;
			old_apic = int_apiv;
		}
		if (api_int && api_intc)
			break;
	}
	cp = malloc(10);			// get heap bottom
	free(cp);
	maxmem = (WORD)cp + 0x8000;
	for (arg = 1;arg < argc;++arg) {
		if (argv[arg][0] == '/') {
			char *parg = argv[arg] + (argv[arg][2] == '=' ? 3 : 2);
			switch (tolower(argv[arg][1])) {
				default:
					printf(u.message);
					return 1;
				case 'c':
					iStatusFag |= XSF_STOP_LISTEN;
					break;
				//case 'g':
				//	use_cgi = 1;
				//	break;
				case 'k':
					iNoKeyboardConfirm = 1;
					break;
				case 'm':
					memsize = atol(parg);
					if ((WORD)cp + memsize + 0xc00 > 0xfff0L)
						maxmem = 0xf3f0;
					else if (memsize < 12000)
						maxmem = (WORD)cp + 12000;
					else
						maxmem = (WORD)memsize + (WORD)cp;
					break;
				case 'n':
					iMaxNumcon = atoi(parg);
					break;
				case 'o':
					monflag = 1;
					break;
				case 'r':
					res_flag = 1;
					break;
				case 's':
					iStatusFag |= XSF_STATUS;
					break;
				case 'u':
					unload = 1;
					break;
#ifdef HTTPD
				case 'x':      // don't use timer to schedule
					bUseTimerFlag = 0;
					break;
				case 'd':		// don't start RemCon
					cDontRemcon = 1;
					break;
				case 'i':
					sscanf(parg,"%x",&hapi_int);
					break;
				case 'v':	//specify bios video
					setBiosVideo(parg);
					break;
				case 'a': 	//specify aspect ratio
					setAspectRatio(parg);
					break;
				case 't':	//use HT (file level) access
					ht_flag = 1;
					break;
				case 'p':
					SetPassive();
					break;
#endif
#ifdef FTPD
				case 'l':	// write out signature location
					{
						FILE *fp;
						static char szName[] = "ftpsig.h";

						if ((fp = fopen(szName,"wt")) != 0) {
							fprintf(fp,	"#define SIGSEG 0x%x\n"
											"#define SIGOFF 0x%x\n"
											"#define VERSION \"%s\"\n",
											FP_SEG(signature) - _psp,FP_OFF(signature),
											version);
							if (fclose(fp) != 0) {
								printf("Can't write '%s'\n",szName);
								exit(2);
							}
						}
						else {
							printf("Can't open '%s'\n",szName);
							exit(1);
						}
					}
					exit(0);
#endif
			}
		}
		else if (++iArgCount == 1)
#ifdef HTTPD
			sHttpOp.wLocPort = atoi(argv[arg]);
#else
			sFtpOp.wLocPort = atoi(argv[arg]);
#endif
		else if (iArgCount == 2)
#ifdef FTPD
			sFtpOp.wLocPort = atoi(argv[arg]);
#else
			uRcPort = atoi(argv[arg]);
#endif
#ifdef HTTPD
		else if (iArgCount == 3)
			uRcPort = atoi(argv[arg]);
#endif
	}
	if (api == 0x100) {
		printf(INET" API not loaded\n");
		exit(1);
	}
	memset(u.message,0,sizeof(u));
	comspec = getenv("COMSPEC");	// comspec env variable
	path = getenv("PATH");			// path env variable
	dseg = resident(signature);
	if (unload || iStatusFag) {
		if (!dseg) {
			printf("Not resident\n");
			exit(1);
		}
		if (iStatusFag) {
			pstatus = MK_FP(FP_SEG(xstatus) - _DS + dseg,FP_OFF(xstatus));
			(*pstatus)(iStatusFag);
		}
		if (unload) {
			pterminate = MK_FP(FP_SEG(terminate) - _DS + dseg,FP_OFF(terminate));
			iStatusFag = iNoKeyboardConfirm;	// need stack parameter
			(*pterminate)(iStatusFag);
		}
		return 0;
	}
	if (dseg) {
		printf("Already resident at %04X\n",dseg);
		return 0;
	}
#ifdef HTTPD
	if ((httpdir = getenv("HTTP_DIR")) == 0) {
		getcwd(httpBuf, 100);//freed in close_all
		httpdir = httpBuf;
		//cFreeHDir = 1;
	}
	//replace \ with / for httpdir
	cp = httpdir;
	while ((cp = strchr(cp, '\\')) != 0)
		*cp = '/';
#endif
	if ((cp = getenv(INETVAR)) == 0)
		cp = INETDIR;
	while (*(cp2 = cp + strlen(cp) - 1) == '\\')
		*cp2 = 0;
	r.h.ah = GET_BUSY_FLAG;
	int86x(api_intc,&r,&r,&sr);
	if (r.x.cflag) {
		printf("Error obtaining Sockets Busy Flag - x%x\n",r.x.ax);
		exit(1);
	}
	pfwSocketsBusy = MK_FP(sr.es,r.x.si);
	if ((pszUserfile = malloc(strlen(cp) + sizeof(UPWFILE) + 3)) == 0)
		exit(3);
	sprintf(pszUserfile, "%s\\"UPWFILE, cp);
#ifdef HTTPD
	if (InitLogin(pszUserfile, ht_flag) != L_OK)
		printf("Couldn't open passwordfile:%s - authorization not available\n", pszUserfile);
#ifdef DEBUGCON
	if(deblogf("Tracer for httpserver \n"))
		printf("cannot open debugging connection\n");
#endif;
	//printf("Starting LISTEN on port %u\n",sHttpOp.wLocPort);
	r.x.cx = FP_OFF(&sHttpOp);
	r.x.bx = FP_SEG(&sHttpOp);
	r.h.ah = API_TCPOPEN;
	CallApi;
	errcode = r.x.ax;
	sTcboHttp = r.x.cx;
	tcbs = r.x.bx;
	if (sTcboHttp == 0) {
		printf("Error on TCP_OPEN: %s\n",err(errcode));
		exit(1);
	}
	if (!cDontRemcon) {
		init_RTS(api_int, uRcPort);
		_AH = 15;
		geninterrupt(0x10);
		if (_AL == 7)
			vidseg = 0xb000;
	}
#endif
	if ((pszHostname = getenv("HOSTNAME")) == 0)
		pszHostname = INET;
	//printf("Starting LISTEN on port %u\n",sFtpOp.wLocPort);
#ifdef FTPD
	r.x.cx = FP_OFF(&sFtpOp);
	r.x.bx = FP_SEG(&sFtpOp);
	r.h.ah = API_TCPOPEN;
	CallApi;
	errcode = r.x.ax;
	sTcboFtp = r.x.cx;
	tcbs = r.x.bx;
	if (sTcboFtp == 0) {
		printf("Error on TCP_OPEN: %s\n",err(errcode));
		exit(1);
	}
#endif
	if (res_flag) {
		//if (use_cgi)
		//	int28_ok = 0;
		printf("Going resident\n");
		resinit();
	}
#ifdef HTTPD
	if (!cDontRemcon)
		SetRCtimer();
#endif
	SetRunning();
	while (1) {
		if (Kbhit()) {
			char ch = Getch();
			if (ch == 0) {			// function key
				ch = Getch();
				if (ch == 45)
					ch = 'x';
				else if (ch == 46)
					ch = 'c';
				else if (ch == 31)
					ch = 's';
				else if (ch == 32)
					ch = 'd';
				else
					ch = ' ';
			}
			if (query_abort) {
				query_abort = 0;
				if (ch == 1)
					break;
				else
					printf("\n");
			}
			switch(ch | ('a' - 'A')) {
			case 'c':
				CloseListen();
				break;
			case 'x':
				if (!iNoKeyboardConfirm && ActiveSessions()) {
					query_abort = 1;
					break;
				}
				goto exit;
			case 's':
#ifdef HTTPD
				HttpStatus(tcbs,sTcboHttp);
#endif
#ifdef FTPD
				FtpStatus(tcbs,sTcboFtp);
#endif
				break;

			case 'd':
				if ((argvl[0] = getenv("COMSPEC")) == 0)
					argvl[0] = "\\COMMAND.COM";
				argvl[1] = 0;
				spawnvp(P_WAIT,argvl[0],argvl);
				break;

			default:
				printf( "C  close LISTEN\n"
					"D  Dos shell\n"
					"S  status\n"
					"X  exit\n");
				break;
			}
		}
		schedule();
	}
	exit:
#ifdef HTTPD
	if (!cDontRemcon)
		close_RTS();
#endif
	close_all();
	printf("\n");
	return 0;
}

//
void close_all()
{
	CloseListen();
	schedule();
#ifdef DEBUGCON
	deblogf("Closing all");
	if (debugcon) {
		union REGS r;
		r.x.bx = debugcon;
		r.h.ah = API_TCPRESET;
		int86(api_int, &r, &r);
		if (r.x.ax)
			deblogf("error reset: %d\n", r.x.ax);
		r.h.ah = API_TCPDELET;
		int86(api_int, &r, &r);
		if (r.x.ax)
			deblogf("error delete: %d\n", r.x.ax);
	}
#endif

#ifdef HTTPD
	while (HTTPfirst) {
		if (HTTPfirst)
			http_delete(HTTPfirst);
		schedule();
	}
#endif
#ifdef FTPD
	while (ftps || ntcpq) {
		if (ftps)
			ftp_delete(ftps,ftps->id);
		schedule();
	}
#endif
	*signature = 0;
	//if(cFreeHDir)
	//	free(httpdir);
}

//nb perform any scheduled tasks
//called from all over
void schedule()
{
#ifdef HTTPD
	HTTP *ph, *pnext;
#endif
#ifdef FTPD
	struct ftp *ftp;
#endif
	union REGS r;

	if (*pfwSocketsBusy & 0xfff0)
		return;	// don't bother, can't enter Sockets
#ifdef HTTPD
	s_http();   // look if anything in state change que

	for (ph = HTTPfirst; ph;) {
		pnext = ph->next;//do it like this because ph may be freed during loop
		if (ph->flags & GOT_RECEIVE_UPCALL) {
			ph->flags &= ~GOT_RECEIVE_UPCALL;
			r_http(ph);
		}
		if ((ph->flags & HTTP_SENDFILE || ph->pCgiUser) && ph->flags & GOT_TRANSMIT_UPCALL) {
			ph->flags &= ~GOT_TRANSMIT_UPCALL;
			t_http(ph);
		}
		ph = pnext;
	}
#endif
#ifdef FTPD
	again:
	disable();
	for (ftp = ftps;ftp;ftp = ftp->next) {
		if (ftp->flags & FF_DAT_ST) {
			enable();
			FtpDataStateChangeHandler(ftp);
			goto again;
		}
		if (ftp->flags & FF_DAT_SN) {
			ftp->flags &= ~FF_DAT_SN;
			enable();
			FtpDataTransmitHandler(ftp);
			goto again;
		}
	}
	enable();
	for (ftp = ftps;ftp;ftp = ftp->next) {
		FtpControlReceiveHandler(ftp);
		if ((ftp->state == RECEIVING_STATE || ftp->state == SENDING_STATE) &&
														!ftp->data) {
			ftp->data = OpenTcp(ftp,ftp->state == RECEIVING_STATE ? 1 : 2);
		}
		if ((ftp->flags & FF_PASV) && !ftp->data)
			ftp->data = OpenTcp(ftp,3);
		if (ftp->state == RECEIVING_STATE && ftp->data)
			FtpDataReceiveHandler(ftp);
	}
	FtpControlStateChangeHandler();
#endif
	handle_tcpq();
	r.h.ah = API_NOOP;	/* keep INET alive */
	CallApi;
}

void enque_tcp(unsigned tcbo,char function,char *pbuf,int cnt)
{
	char *buf = 0;

	SetSchedule();
	if (ntcpq < TCPQSIZE) {
		if (cnt) {
			if ((buf = malloc(cnt)) != 0) {
				memcpy(buf,pbuf,cnt);
			}
			else {
				return;
			}
		}
		else
			pbuf = 0;
		disable();
		ptcpqi->tcbo = tcbo;
		ptcpqi->function = function;
		ptcpqi->buf =
		ptcpqi->pbuf = buf;
		ptcpqi->cnt = cnt;
		if (++ptcpqi >= u.tcpq + TCPQSIZE)
			ptcpqi = u.tcpq;
		++ntcpq;
		enable();
	}
	else
		++ErrTcpQueFull;
}

#pragma argsused
int tcpq_empty(HTTP *ph)
{
	return ntcpq == 0;
}

void handle_tcpq(void)
{
	int ret;
	union REGS r;

	while (ntcpq) {
		switch (ptcpqo->function) {
		case API_TCPWRITE:
			if ((ret = SendTcph(ptcpqo->tcbo,ptcpqo->pbuf,ptcpqo->cnt)) !=
																ptcpqo->cnt) {
				if (ret >= 0) {
					ptcpqo->cnt -= ret;
					ptcpqo->pbuf += ret;
					return;
				}
				else if (ret == -RE_ENTER)
					return;
			}
			if_RemoveAlloc("ptcpqo->buf",ptcpqo->buf)
				free_c(ptcpqo->buf);
			break;
		default:
			r.x.bx = ptcpqo->tcbo;
			r.h.ah = ptcpqo->function;
			CallApi;
			if (r.x.ax == RE_ENTER)
				return;
		}
		disable();
		if (++ptcpqo >= u.tcpq + TCPQSIZE)
			ptcpqo = u.tcpq;
		--ntcpq;
		enable();
	}
}

//the actual sending (return error if cannot)
//only place where data is send
	static union REGS r;

int SendTcph(unsigned tcbo,char far *buf,int cnt)
{
	r.x.si = FP_OFF(buf);
	r.x.dx = FP_SEG(buf);
	r.x.cx = cnt;
	r.x.bx = tcbo;
	r.h.ah = API_TCPWRITE;
	r.h.al = 0;
	CallApi;
	if (r.x.ax)
		return -r.x.ax;
	return r.x.cx;
}

int SendTcp(unsigned tcbo,char *buf,int cnt)
{
	int ret;
	char *pbuf = buf;

	if (ntcpq)
		handle_tcpq();
	if (!ntcpq) {
		if ((ret = SendTcph(tcbo,buf,cnt)) != cnt) {
			if (ret >= 0) {
				cnt -= ret;
				pbuf += ret;
			}
		}
		else {
			return 0;
		}
	}
	enque_tcp(tcbo,API_TCPWRITE,pbuf,cnt);
	return -1;
}

/*
 * Return: > 0: Actual read count
 *	      	 0: if peof contains value: eof
 *					 else Would Block received
 * 		  < 0: Error
 */
int RecvTcp(unsigned tcbo,char far *buf,int cnt,int *peof)
{
	union REGS r;
	int eof = 0;

	r.x.si = FP_OFF(buf);
	r.x.dx = FP_SEG(buf);
	r.x.cx = cnt;
	r.x.bx = tcbo;
	r.h.ah = API_TCPREAD;
	CallApi;
	if (r.x.ax != 0) {
		r.x.cx = 0;
		if (r.x.ax == RE_ENTER)
			SetSchedule();			// read again ASAP
		else if (r.x.ax != WOULDBLK)
			r.x.cx = -r.x.ax;
	}
	else if (r.x.cx == 0)
		eof = 1;
	if (peof)
		*peof = eof;
	return r.x.cx;
}


int TcpFunction(unsigned tcbo,char function)
{
	union REGS r;

	r.x.bx = tcbo;
	r.h.ah = function;
	r.h.al = 0;
	CallApi;
	return r.x.ax;
}


void common_tcp(unsigned tcbo,char function)
{
	union REGS r;

	if (ntcpq)
		handle_tcpq();
	if (!ntcpq) {
		r.x.bx = tcbo;
		r.h.ah = function;
		CallApi;
		if (r.x.ax == 0)
			return;
		/*
		if (function != 8)
			printf("tcp func error:%d function:%d tcbo:%x\n", r.x.ax, function, tcbo);
		*/

	}
	enque_tcp(tcbo,function,0,0);
}

void CloseListen()
{
	CloseTcp(sTcboHttp);
	DelTcp(sTcboHttp);
	sTcboHttp = 0;
	CloseTcp(sTcboFtp);
	DelTcp(sTcboFtp);
	sTcboFtp = 0;
}

void CloseTcp(unsigned tcbo)//tcb offset
{
	common_tcp(tcbo,API_TCPCLOSE);
}

void ResetTcp(unsigned tcbo)
{
	common_tcp(tcbo,API_TCPRESET);
	common_tcp(tcbo,API_TCPDELET);
}

void DelTcp(unsigned tcbo)
{
	common_tcp(tcbo,API_TCPDELET);
}

#ifdef FTPD
unsigned OpenTcp(struct ftp *ftp,char mode)
{
	static TCP_OP_P op = {0,0,FTPD_PORT,TCP_ACTIVE};
	TCB far *tcb;
	char str[80];
	union REGS r;

	op.dwRemIPAd = ftp->port.dwAddress;
	op.wRemPort = ftp->port.wPort;
	op.wLocPort = FTPD_PORT;
	op.wMode = TCP_ACTIVE;
	op.pRcvUpcall = mode & 1 ? FtpDataReceive : 0;
	op.pSndUpcall = mode & 2 ? FtpDataTransmit : 0;
	op.pStcUpcall = (void far *)FtpDataStateChange;
	op.pUser = (WORD)ftp;
	if (mode == 3) {
		op.dwRemIPAd = 0;
		op.wRemPort = 0;
		op.wLocPort = 0;
		op.wMode = TCP_PASSIVE;
	}
	r.x.cx = FP_OFF(&op);
	r.x.bx = FP_SEG(&op);
	r.h.ah = API_TCPOPEN;
	CallApi;
	if (mode == 3) {
		tcb = (TCB far *)MK_FP(tcbs,ftp->control);
		ftp->port.dwAddress = tcb->conn.sLocal.dwAddress;
		ftp->port.wPort = op.wLocPort;
		sprintf(str,"227 Entering Passive Mode (%u,%u,%u,%u,%u,%u)\r\n",
			((char *)&ftp->port.dwAddress)[3],
			((char *)&ftp->port.dwAddress)[2],
			((char *)&ftp->port.dwAddress)[1],
			((char *)&ftp->port.dwAddress)[0],
			((char *)&ftp->port.wPort)[1],
			((char *)&ftp->port.wPort)[0]);
		Tprintf(ftp->control,str);
		ftp->flags &= ~FF_DAT_CLSD;
		ftp->flags |= FF_PASV;
	}
	return r.x.cx;
}
#endif

int Tprintf(unsigned tcbo,char *message, ...)
{
	va_list argptr;
	char buf[300];
	int len;

	va_start(argptr, message);
	len = vsprintf(buf,message,argptr);
	va_end(argptr);
	SendTcp(tcbo,buf,len);
	return len;
}

void Psocket(char *str,ISOCKET far *s)
{
	char ad[4];

	*((long *)ad) = s->dwAddress;
	sprintf(str,"%u.%u.%u.%u:%u",ad[3],ad[2],ad[1],ad[0],s->wPort);
}

void far _loadds xstatus(int flags)
{
	extern unsigned myss,stack1;
	static unsigned svss,svsp,uFlags;

	disable();
	uFlags = flags;
	svsp = _SP;
	svss = _SS;
	_SS = myss;
	_SP = stack1;
	enable();
	if (uFlags & XSF_STOP_LISTEN) {
		CloseListen();
	}
	if (uFlags & XSF_STATUS) {
#ifdef HTTPD
		HttpStatus(tcbs,sTcboHttp);
#endif
#ifdef FTPD
		FtpStatus(tcbs,sTcboFtp);
#endif
	}
	disable();			/* reset interrupted stack     */
	_SS = svss;
	_SP = svsp;
	enable();
}

void PrintEvents(void);

//status of tcb block at specified segment and offset
HttpStatus(unsigned tcbs,unsigned tcbo)
{
	HTTP *ph;
//	int errcode;
	TCB far *tcb;
	char rsock[30];
//	TCPQ *pq;
//	char *func_str[] = {"READ","WRITE","CLOSE","RESET","DELET"};

	printf("Remote socket        HTTP state\n");
	if (tcbo) {
		tcb = MK_FP(tcbs,tcbo);
		Psocket(rsock,&tcb->conn.sRemote);
		printf("%-22s\n",rsock);
	}
	for (ph = HTTPfirst; ph; ph = ph->next) {
		char *st;//,*log;

		tcb = MK_FP(tcbs,ph->tcbo);
		switch(ph->state) {
		case REQUEST:
			st = "Request,";
			break;
		case HEADER:
			st = "Header,";
			break;
		case POST:
			st = "Post,";
			break;
		case NEWCGI:
			st = "NewCGI,";
			break;
		default:
			st = "Unknown,";
			break;
		}
		Psocket(rsock,&tcb->conn.sRemote);
		printf("%-22s%7.7s\n",rsock, st);
	}
	printf("Send errors: %d, Last send error: %d\n",
											err_count, err_code);
/*
	for (pq = ptcpqo,i = ntcpq;i;i--) {
		if (++pq >= u.tcpq + TCPQSIZE)
			pq = u.tcpq;
		printf("TCB %04x %s, Buf %p %p %d\n",
				pq->tcbo,func_str[pq->function - 6],
				pq->buf,pq->pbuf,pq->cnt);
	}
*/
	printf("TCP queue: %u, times full: %u\n",ntcpq,ErrTcpQueFull);
#ifdef HTTPD
	PrintEvents();
#endif
	return 0;
}

#ifdef FTPD
FtpStatus(unsigned tcbs,unsigned tcbo)
{
	struct ftp *ftp;
	TCB far *tcb;
	char rsock[30];
	struct heapinfo hi;
	unsigned blocks_free = 0,blocks_used = 0,bmem_free = 0,bmem_used = 0;
	int i,iRet;


	static char states[] = "ClLiSySREsF1F2CWCgLATW";

	printf("Remote socket        TCP FTP state          Current directory\n");
	if (tcbo) {
		tcb = MK_FP(tcbs,tcbo);
		Psocket(rsock,&tcb->conn.sRemote);
		printf("%-22s%2.2s\n",rsock,states + 2 * tcb->state);
	}
	for (ftp = ftps;ftp;ftp = ftp->next) {
		char *st,*log;

		tcb = MK_FP(tcbs,ftp->control);
		switch(ftp->state) {
		case COMMAND_STATE:
			st = "Command,";
			break;
		case SENDING_STATE:
			st = "Sending,";
			break;
		case RECEIVING_STATE:
			st = "Receiving,";
			break;
		default:
			st = "Unknown,";
			break;
		}
		log = (ftp->cd == NULL || ftp->path == NULL) ?
				"Not logged in" : "Logged in";
		Psocket(rsock,&tcb->conn.sRemote);
		printf("%-22s%2.2s %-9s%-9s %-s\n",
				rsock,states + 2 * tcb->state,st,log,
				ftp->cd ? ftp->cd : "");
	}
#ifdef CHECK_ALLOC
	printf("Allocated: %u Errors %u\n",wAllocated,wAllocErrs);
#endif

	hi.ptr = NULL;
	i = 1000;
	if (heapcheck() < 0)
		printf("Memory chain corrupted!\n");
	else while(((iRet = heapwalk(&hi)) != _HEAPEND) && --i) {
		if (iRet == _HEAPEMPTY || iRet < 0)
			break;
		if (hi.in_use) {
			bmem_used += hi.size;
			blocks_used++;
		}
		else {
			bmem_free += hi.size;
			blocks_free++;
		}
	}
	printf("Memory - Free: %u blocks %u; Used: %u blocks %u\n",
		bmem_free + coreleft(),blocks_free,bmem_used,blocks_used);
	return 0;
}
#endif

int ActiveSessions()
{
	if (
#ifdef HTTPD
		HTTPfirst
#ifdef FTPD
					||
#endif
#endif
#ifdef FTPD
						ftps
#endif
								) {
		printf("Active sessions\n"
				 "Press Ctrl A to abort them, any other key to continue...");
		return 1;
	}
	return 0;
}

char *err(unsigned errcode)	/* return errorcode string */
{
	static char unk[30];
	static char *errs[] = {
		"No error",
		"Connection already exists",
		"Connection does not exist",
		"Connection closing",
		"No memory for TCB or buffer creation",
		"Would block",
		"Protocol or mode not supported",
		"Invalid arguments"
	};

	if (errcode > INVALID) {
		sprintf(unk,"Unknown error %u",errcode);
		return unk;
	}
	return errs[errcode];
}

#ifdef DEBUGCON

int deblogf(char *format, ...)
{
	va_list argptr;
	char buf[100];//this will cause stack overflow if re-entering rinet

	va_start(argptr, format);
	vsprintf(buf, format, argptr);
	va_end(argptr);
	return deblog(buf);
}

int deblog(char* buf)
{
	union REGS r;

	if (!debugcon) {
		r.x.bx = FP_SEG(&debug);
		r.x.cx = FP_OFF(&debug);
		r.h.ah = API_TCPOPEN;
		CallApi;
		if (r.x.ax)
			return r.x.ax;
		debugcon = r.x.cx; //working in small model, only offset
	}
	r.h.ah = API_TCPWRITE;
	r.x.bx = debugcon;
	r.x.cx = strchr(buf, 0) - buf;
	r.x.dx = FP_SEG(buf);
	r.x.si = FP_OFF(buf);//DX:SI	Buffer address (SEG:OFF)
	CallApi;
	return r.x.ax;
}

#endif

#ifdef CHECK_ALLOC
// Allocation checking

#define NUM_ALLOC 1000
void *pAlloc[NUM_ALLOC];
WORD wAllocated,wAllocErrs;

void ErrOverflow(void)
{
	printf("Overflow\n");
}

void ErrNotFound(char *pWhat,void *pM)
{
	printf("Not found: %s %p\n",pWhat,pM);
}

void AddAlloc(void *pM)
{
	void **ppA;

	if (!pM)
		return;
	if (wAllocated == NUM_ALLOC) {
		ErrOverflow();
		return;
	}
	for (ppA = pAlloc;ppA < pAlloc + NUM_ALLOC;++ppA) {
		if (*ppA == 0) {
			*ppA = pM;
			++wAllocated;
			return;
		}
	}
	ErrOverflow();
}

int RemoveAlloc(char *pWhat,void *pM)
{
	void **ppA;

	if (!pM)
		return 0;
	if (wAllocated == 0) {
		ErrNotFound(pWhat,pM);
		return 0;
	}
	for (ppA = pAlloc;ppA < pAlloc + NUM_ALLOC;++ppA) {
		if (*ppA == pM) {
			*ppA = 0;
			--wAllocated;
//			printf("Free(%s, %p, %d)\n",pWhat,pM,wAllocated);
			return 1;
		}
	}
	ErrNotFound(pWhat,pM);
	return 0;
}

void        _Cdecl free(void _FAR *__block)
{
	if_RemoveAlloc("Lib",__block)
		free_c(__block);
}

void  _FAR *_Cdecl malloc(size_t __size)
{
	void _FAR *pv = malloc_c(__size);

	if (pv)
		AddAlloc(pv);
	else
		++wAllocErrs;
	return pv;
}

#endif


