//
//   $Id: HTTPRES.C 1.9 2003/05/19 22:50:24Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
 /*
  * HTTPRES.C
  *
  * Copyright (C) 2001 Datalight, Inc
  * All Rights Reserved
  * Datalight Confidential and Proprietary
  * Portions Copyright (c) GP van Niekerk Ondernemings 1990-2001
  *
  * Code to establish residency and interrupt handlers
  *
  * Revision History
  * 11/13/2002 jmb added flag to not use timer tick to schedule  
  * 07/20/2001 gvn patch Int2A handler depending on version of ROMDOS.
  * 07/18/2001 jmb removed Local2AIntercept
  * ??/??/???? gvn original revision
 */

#pragma inline

#include <dos.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "getch.h"
#include "compiler.h"
#include "api.h"
#include <time.h>
#include "htapic.h"
#include "httftps.h"

#define DOS_BUSY			1
#define DISKFLAG			2
#define SCHEDULE_FLAG	4
#define RUNNING			8
#define CRIT_ERR			16
#define PASSIVE			32	//passive server, dont schedule
#define CRIT_SEC			64

static unsigned mcbseg;
static unsigned dosseg;
static unsigned dosbusy;
static unsigned criterrseg;
static unsigned criterroff;
static unsigned uDOSDataSize;
static char *pcSaveArea;
unsigned uInCriticalSectionCount = 0;
void interrupt (*lpPrev2aHandler)(void);
static unsigned enddos;
char far *intdta;
static unsigned intsp;
static unsigned intss;
static char far *mydta;
unsigned myss;
unsigned stack;
unsigned apistk;	//the stack for when http server api is called
unsigned stack1;
static unsigned ctrl_break;
static unsigned mypsp;
static unsigned intpsp;
static unsigned pids[2];
static int pidctr = 0;
static int pp;
static void interrupt (*oldtimer)(void);
static void interrupt (*old28)(void);
void interrupt (*olddisk)(void);
void interrupt (*olddos)(void);
static void interrupt (*oldcrit)(void);
extern void interrupt (*ZeroDivVector)(void);
void interrupt newtimer(int BP,int DI,int SI,int DS,int ES,int DX,int CX,int BX,int AX,int IP,int CS,int FLAGS);
void interrupt new28(void);
void interrupt newdisk(void);
void interrupt newcrit(void);
void interrupt far Local2aIntercept(int BP,int DI,int SI,int DS,int ES,int DX,int CX,int BX,int AX,int IP,int CS,int FLAGS);
#ifdef SHOW_DEB
void interrupt (*old21)(void);
void interrupt new21(void);
#endif
static char resoff = 0;
char opstat;	//
char diskflag = 0;
extern unsigned hapi_int;
extern unsigned api_intc;
extern char int28_ok;
extern void interrupt (*old_api)();
extern void interrupt (*old_apic)();
void interrupt (api_inti_a)();
void RCtimer(void);
extern char cDontRemcon;
extern char bUseTimerFlag;

#define GET_EXTERR     0x59
#define SET_EXTERR     0x5d0a

struct   ExtErr
{
	unsigned int errax;
	unsigned int errbx;
	unsigned int errcx;
};
void  GetExtErr(struct ExtErr * ErrInfo);
void  SetExtErr(struct ExtErr * ErrInfo);
struct ExtErr ErrInfo;

#define DOSINT 0x21

#ifndef SHOW_DEB
#define dores(x) Dores()
void Dores(void);
#else
#define dores(x) Dores(x)
void Dores(int iArg);
#endif
void pidaddr(void);
void setcsvecs(void interrupt (*vec1)(),void interrupt (*vec2)());

/* -------- establish & declare residency --------- */
void resinit()
{
	extern unsigned maxmem;
	WORD wVersion,wBuild = 0;
	char sz[80],*psz;
	void Patch2aIntercept(void);

	myss = _SS;
	/* ------ get address of DOS busy flag ---- */
	_AH = 0x34;
	geninterrupt(DOSINT);
	dosseg = _ES;
	dosbusy = _BX;
	_AX = 0x5d06;		// get critcal error address
	asm push ds;
	geninterrupt(DOSINT);
	_AX = _DS;
	asm pop ds;
	criterrseg = _AX;
	criterroff = _SI;
	uDOSDataSize = _CX > _DX ? _CX : _DX;
	//printf("Dosdata at %04x:%04x size %x\n",criterrseg,criterroff,uDOSDataSize);
	if ((pcSaveArea = malloc(uDOSDataSize)) == 0) {
		printf("Not enough memory\n");
		exit(1);
	}
	/* ----- get address of resident program's dta ----- */
	mydta = getdta();
	/* -------- get addresses of PID in DOS ------- */
	pidaddr();
	/* ----- get original interrupt vectors ----- */
#ifdef SHOW_DEB
	old21 = getvect(DOSINT);
	setvect(DOSINT, new21);
#endif
   if (bUseTimerFlag)
	oldtimer = getvect(TIMERINT);
	old28 = getvect(0x28);
	olddisk = getvect(0x13);
	old_api = getvect(hapi_int);
	lpPrev2aHandler = getvect(0x2a);
	_SI = 0xb2d2;
	_DI = 3;
	_CX = 0;
	_AX = 0x30db;
	geninterrupt(DOSINT);
	wVersion = _AX;
	if (!(_FLAGS & 1) && _CX == 0xb2d2) {
		_fstrncpy(sz,MK_FP(_ES,_BX),70);
		if ((psz = strrchr(sz,'.')) != 0)
			wBuild = atoi(psz + 1);
		if (wVersion <= 0x410 && wBuild < 1160) {
			printf("ROM-DOS version %x Build %u detected\n",wVersion,wBuild);
			printf("Warning: please upgrade to latest version of ROM-DOS for best reliability\n");
			((char far *)Patch2aIntercept)[0] = 0x90;
			((char far *)Patch2aIntercept)[1] = 0x90;
		}
	}
	/* ----- attach vectors to resident program ----- */
   if (bUseTimerFlag)
	setvect(TIMERINT, newtimer);
	if (int28_ok)
		setvect(0x28, new28);
	setvect(0x13, newdisk);
#ifdef HTTPD
	setvect(hapi_int,api_inti_a);
#endif
	setcsvecs(old_api,old_apic);
	setvect(0x2a,Local2aIntercept);
	/* ------ compute stack pointer ------- */
	stack = maxmem + 0xc00;
	apistk = maxmem + 0x800;
	stack1 = maxmem + 0x400;
	/* ---- restore zero divide interrupt vector --- */
/*	setvect(0, ZeroDivVector);	*/
	/* ----- terminate and stay resident ------- */
	keep(0,(_SS + (stack / 16) - _psp + 1));
}

/* ----- timer ISR ------- */
#pragma argsused
void interrupt newtimer(int BP,int DI,int SI,int DS,int ES,int DX,int CX,int BX,int AX,int IP,int CS,int FLAGS)
{
//   static int nInTimer = 0;
//	extern unsigned long ticks;		// clock ticks

	(*oldtimer)();

//   if (nInTimer > 0)
//      return;

//   nInTimer++;

	if (resoff)
		return;
#ifdef HTTPD
	if (!cDontRemcon)
		RCtimer();
#endif
	disable();	// incase enabled by RCtimer()
	dores(CS);
//   nInTimer--;
}

//  The Local2aIntercept() function is used to monitor the DOS in
//  critical section flag.  It will then pass on the call to the
//  previous interrupt 2ah handler.
//
/* replaced by optimised assembler routine in RESINT.ASM
static void interrupt far Local2aIntercept( BP, DI, SI, DS, ES, DX, CX, BX, AX, IP, CS, FLAGS)
{
	if (((BYTE*)&AX)[1] == 0x80)
	{
		//  Begin critical section
		//
		uInCriticalSectionCount++;
		opstat |= CRIT_SEC;
	}
	else if (((BYTE*)&AX)[1] == 0x81)
	{
		//  Clear critical section
		//
		if (--uInCriticalSectionCount == 0)
			opstat &= ~CRIT_SEC;
	}
	_FLAGS = FLAGS;	// restore entry values of ax and flags registers
	_AX = AX;
	asm{
		pushf
		call dword ptr lpPrev2aHandler;
	}
	FLAGS = _FLAGS;	// pass back flags
}
*/

/* ----- DOS keyboard loop ISR -------- */
void interrupt new28()
{
	(*old28)();
	dores(0xffff);
}

void SetSchedule()		// we need to re-enter soonest
{
	opstat |= SCHEDULE_FLAG;
}

void UpcallC()			// called by upcall
{
	opstat |= SCHEDULE_FLAG;
	//dores();        // this crashes everything - just forget about it for now
}


void SetRunning(void)
{
	opstat |= RUNNING;
}

void SetPassive(void)
{
	opstat |= PASSIVE;
}

int IsPassive(void)			//check if server to passive mode
{
	return opstat & PASSIVE;
}

/* ------ switch psp context from interrupted to TSR ----- */
void resident_psp(void)
{
	/* ------ save interrupted program's psp ----- */
	intpsp = peek(dosseg, *pids);
	/* ----- set resident program's psp ----- */
	for (pp = 0; pp < pidctr; pp++)
		poke(dosseg, pids [pp], mypsp);
}

/* ---- switch psp context from TSR to interrupted ---- */
void interrupted_psp(void)
{
	/* ----- reset interrupted program's psp ----- */
	for (pp = 0; pp < pidctr; pp++)
		poke(dosseg, pids [pp], intpsp);
}

/* ------ execute the resident program ------- */
static void Dores(
#ifdef SHOW_DEB
	int iArg
#endif
)
{
	extern WORD far *pfwSocketsBusy;

	if (*pfwSocketsBusy & 0xfff0)
   {
		return;	// don't bother, can't enter Sockets
   }

	if (peekb(criterrseg,criterroff))
		opstat |= CRIT_ERR;
	else
		opstat &= ~CRIT_ERR;
	if ((opstat & (RUNNING|CRIT_SEC|DISKFLAG|SCHEDULE_FLAG|CRIT_ERR|PASSIVE)) !=
							SCHEDULE_FLAG) {
		return;
	}
	ShowDeb(iArg,1,40);
	disable();
	opstat &= ~SCHEDULE_FLAG;
	opstat |= RUNNING;
	intsp = _SP;
	intss = _SS;
	_SS = myss;
	_SP = stack;
	if (!IsPassive()) {
		_fmemcpy(pcSaveArea, MK_FP(criterrseg,criterroff), uDOSDataSize );
		//  Clear the INDOS flag
		pokeb(dosseg,dosbusy,0);
		oldcrit = getvect(0x24);/* redirect critical error     */
		setvect(0x24, newcrit);
		_AX = 0x3300;		/* get ctrl break setting      */
		geninterrupt(DOSINT);
		ctrl_break = _DL;
		_DL = 0;
		_AX = 0x3301;		/* turn off ctrl break logic   */
		geninterrupt(DOSINT);

		intdta = getdta();		/* get interrupted dta         */
		setdta(mydta);			/* set resident dta            */
	}
	resident_psp();			/* swap psps                   */
	if (!IsPassive())
		GetExtErr(&ErrInfo);

	//all set. perform task
	enable();
	schedule();
	disable();
	//reset all

	if (!IsPassive())
		SetExtErr(&ErrInfo);
	interrupted_psp();		/* reset interrupted psp       */
	if (!IsPassive()) {
		setdta(intdta);			/* reset interrupted dta       */
		setvect(0x24, oldcrit);		/* reset critical error        */
		_DL = ctrl_break;
		_AX = 0x3301;			/* reset ctrl break            */
		geninterrupt(DOSINT);
		//  Restore DOS state
		_fmemcpy(MK_FP(criterrseg,criterroff), pcSaveArea, uDOSDataSize );
	}
	_SS = intss;
	_SP = intsp;
	enable();
	ShowDeb(iArg,0,40);
	opstat &= ~RUNNING;
}
/*page*/

/* ------- test to see if the program is already resident
	  if found, return data segment ---------- */

typedef struct mcb_s {
	char id;
	unsigned psp;
	unsigned len;
	char junk[3];
	char name[8];
} MCB;

WORD resident(char *signature)
{
	MCB far * pmcb;
	unsigned mcbseg,segoff = FP_SEG(signature) - _psp;

	_AH = 0x52;
	geninterrupt(DOSINT);
	mcbseg = _ES;
	mcbseg = peek(mcbseg, _BX - 2);
	pmcb = MK_FP(mcbseg,0);
	while (1) {
		if (pmcb->id == 'Z')
			return 0;
		else if (pmcb->id == 'M') {
			if (pmcb->psp && pmcb->psp != _psp &&
						_fstrcmp(signature,MK_FP(pmcb->psp + segoff,
												FP_OFF(signature))) == 0) {
				return pmcb->psp + segoff;
			}
		}
		else {
			printf("DOS memory corruption\n");
			exit(2);
		}
		FP_SEG(pmcb) += pmcb->len + 1;
	}
}
/*page*/
/* -------- find address of PID ---------- */
static void pidaddr()
{
	unsigned adr = 0;

	/* ------- get the current pid --------- */
	_AH = 0x51;
	geninterrupt(DOSINT);
	mypsp = _BX;
	/* ----- find the end of the DOS segment ------- */
	_AH = 0x52;
	geninterrupt(DOSINT);
	enddos = _ES;
	enddos = peek(enddos, _BX - 2);
	/* ---- search for matches on the pid in dos ---- */
	while (pidctr < 2 &&
			(unsigned)((dosseg<<4) + adr) < (enddos<<4))	{
		if (peek(dosseg, adr) == mypsp)	{
			_BX = mypsp + 1;
			_AH = 0x50;
			geninterrupt(DOSINT);
			if (peek(dosseg, adr) == mypsp+1)
				pids[pidctr++] = adr;
			/* ---- reset the original pid ------ */
			_BX = mypsp;
			_AH = 0x50;
			geninterrupt(DOSINT);
		}
		adr++;
	}
}
/*page*/
#undef peekb	/* to overcome TC 1.0 bug */
/* ------- terminate function ----------- */
static void resterm(void)
{
	int iFileHandleTableSegment;
	#define PSP_HANDLE_TABLE 0x18
	#define PSP_NUM_HANDLES  0x32
	#define PSP_HANDLE_PTR   0x34
	/* ----- restore the interrupt vectors ----- */
#ifdef SHOW_DEB
	setvect(DOSINT, old21);
#endif
   if (bUseTimerFlag)
	setvect(TIMERINT, oldtimer);
	if (int28_ok)
		setvect(0x28, old28);
	setvect(0x13, olddisk);
	setvect(hapi_int,old_api);
	setvect(0x2a, lpPrev2aHandler);
	//setvect(api_intc,old_apic);
	/* ---- get the seg addr of 1st DOS MCB ---- */
	_AH = 0x52;
	geninterrupt(DOSINT);
	mcbseg = _ES;
	mcbseg = peek(mcbseg, _BX - 2);
	/* ---- walk thru mcb chain & release memory ----- */
	while (peekb(mcbseg, 0) == 0x4d) {
		if (peek(mcbseg, 1) == mypsp) {
			_ES = mcbseg+1;
			_AH = 0x49;
			geninterrupt(DOSINT);
		}
		mcbseg += peek(mcbseg, 3) + 1;
	}
	/*
		Release all of program memory.  The DOS PSP includes
		space for only 20 file handles.  If the environment
		was setup for more via FILES= command in CONFIG.SYS
		and the C library is actually using them, the startup
		code will allocate the necessary space to hold them
		from the DOS memory space.  It is not generally
		located in the same segment of SOCKETS.

		The PSP's handle table is located at PSP:18h, the
		number of table entries is at PSP:32h, and if the
		total number is more than 20, the segment:offset at
		PSP:34h is the far pointer to the additional table
		entries.
		12/20/2000 - pkg/pb
	*/
	if(*(int far *) MK_FP(_psp, PSP_NUM_HANDLES) > 20)
	{
		iFileHandleTableSegment =
				(* ((int far *)MK_FP(_psp, PSP_HANDLE_PTR) + 1));
		_ES = iFileHandleTableSegment;
		_AH = 0x49;
		geninterrupt(DOSINT);
	}
}
/* --------- terminate the resident program --------- */
void far _loadds terminate(int iNoConfirmP)
{
	static unsigned svss,svsp;
	static int iNoConfirm;

	disable();
	iNoConfirm = iNoConfirmP;
	svsp = _SP;
	svss = _SS;
	_SS = myss;
	_SP = stack1;
	enable();
	if (!iNoConfirm && !iNoKeyboardConfirm) {
		if (ActiveSessions()) {
			if (Getch() != 1)
				goto exit;
		}
	}
#ifdef HTTPD
	if (!cDontRemcon)
		close_RTS();
#endif
	close_all();
	if (getvect(0x13) == (void interrupt (*)()) newdisk &&
				(!int28_ok || (getvect(0x28) == new28)) &&
				(getvect(TIMERINT) == newtimer) &&
#ifdef HTTPD
				(getvect(hapi_int) == api_inti_a) &&
#endif
				(getvect(0x2a) == Local2aIntercept))
	{
		resterm();
		printf("Unloaded\n");
	}
	else {
		printf("Cannot be unloaded\n");
	}
	resoff = 1;	/* another TSR is above us, merely suspend */
	exit:
	disable();			/* reset interrupted stack     */
	_SS = svss;
	_SP = svsp;
	enable();
}

/* ------------- restart the resident program --------- */
void restart()
{
	resoff = 0;
}

/* ------- put the program on hold -------- */
void wait()
{
	resoff = 1;
}

/* EXTERR.C - extended error saving and restoring */

/*****
Function: GetExtErr
get extended error information
*****/
void GetExtErr(struct ExtErr * ErrInfo)
{ 
   if (_osmajor >= 3)   /* only for DOS 3 and above */
   {
      _BX = 0;  /* must be zero */
      _AH = GET_EXTERR;
      geninterrupt(DOSINT);
      ErrInfo->errax = _AX;
      ErrInfo->errbx = _BX;
      ErrInfo->errcx = _CX;
   }
}

/*****
Function: SetExtErr
set extended error information
*****/
void SetExtErr(struct ExtErr near * ErrInfo)
{ 
   if (_osmajor >= 3)   /* only for DOS  3 and above */
   {
      _AX = SET_EXTERR;
      _BX = 0;       /* must be zero */
      _DX = (unsigned) ErrInfo;
      geninterrupt(DOSINT);
   }
}
