//
//   $Id: HTTPSS.C 1.8 2003/05/21 03:00:26Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
	HTTPSS.C

	Copyright (C) 2001 Datalight, Inc.
	All Rights Reserved
	Datalight Confidential and Proprietary
	Portions Copyright (c) GP van Niekerk Ondernemings 1990-2001

	HTTP Server state machine - see RFC 1945

	Revision History
	01/27/2003 gvn Correct spelling of Last-Modified
	10/31/2002 jmb added error 405 for posting back to original URI
	07/27/2001 gvn used SetSchedule routine instead of must_schedule variable
	07/26/2001 gvn fixed connections getting into CLOSED state without being deleted
	07/23/2001 gvn got rid of CLOSED connections
	07/20/2001 gvn added state checking and cleaned up comments
	??/??/???? gvn original revision


*/

//defined in header #define   LINELEN      128   /* Length of command buffer */

#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <io.h>
#include <ctype.h>
#include <alloc.h>
#include <time.h>
#include <string.h>
#include <process.h>
#include <errno.h>
#include <dir.h>
#include <sys\stat.h>
#include "lfnopen.h"
#include "compiler.h"
#include "api.h"
#include "htapic.h"
#include "httftps.h"
#include "login.h"

#define UNIXBUG   0      /* simulate UNIX early 226 */

#define DEL_DAT   100
#define STDIN 0
#define STDOUT 1

extern char *pszHostname,version[];
extern unsigned s_tcbo;
extern char use_cgi;

void UpcallC(void);
char *AddCGIEnvVar(HTTP *ph,char *pVar, char *pVal);
void FreeEnv(HTTP *ph);
int DoCgi(HTTP *ph);
int DoResponse(HTTP *ph);

int base64Decode(char *szEncoded, char *szDecoded);

/*
Event que (EQ): Significant Interrupt
*/

//event queue
typedef struct event 
{
   unsigned tcbo;
   unsigned id;
   unsigned type:4;
                  //one of
#define QR   1    //receive
#define QT   2    //transmit
#define QS   3    //state change
   unsigned val:12;//may be count or new state
} EVENT;

#define QSIZE 50
EVENT sEventQue[QSIZE];
EVENT *psEventQueIn = sEventQue;
EVENT *psEventQueOut = sEventQue;
unsigned uNumTotalEvents;
int iNumEventQueEntries;// number queued items
int iNumEventQueMax;      // max number queued items
WORD wErrEventQueFull;   // number of queue fulls
WORD iNumEventsQueued;   // number of events queued
WORD iNumEventsDeQueued;   // number of events dequeued
WORD iNumState,iNumRecv,iNumXmit;
WORD iNumRequests;
int iNameNum;

#ifdef DEBUGCON
unsigned s_u = 0, t_u = 0, r_u = 0;//state change, transmit and recieve upcall counts
char *errstring = 0;
#endif

void PutInQue(char type, unsigned tcbo, unsigned val)
{
   HTTP *ph;

   ++iNumEventsQueued;   // number of events queued
#ifdef DEBQ
   if (uNumTotalEvents < QSIZE)
      ++uNumTotalEvents;
#endif
   if (iNumEventQueEntries >= QSIZE) 
   {
      ++wErrEventQueFull;
      return;//we're full - may perhaps be more graceful later
   }
   if (iNumEventQueEntries > iNumEventQueMax)
      iNumEventQueMax = iNumEventQueEntries;
   //put in que
   disable();
   ph = (HTTP *)(((TCB far *)MK_FP(tcbs,tcbo))->user);
   if (ph == (HTTP *)1)
      ph = 0;
   if (ph != 0)
      psEventQueIn->id = ph->id;
   else
      psEventQueIn->id = 0;
   psEventQueIn->tcbo = tcbo;
   psEventQueIn->type = type;
   psEventQueIn->val = val;
   if (++psEventQueIn >= sEventQue + QSIZE)
      psEventQueIn = sEventQue;//wrap around circular que buffer
   ++iNumEventQueEntries;
   enable();
}

/*EVENT popQue(void)
{
}


void boot(void)
{
   void (far *freset)(void);

   freset = MK_FP(0xffff,0);
   (*freset)();
}
*/
// make a name from a number
char *MakeName(int iNum)
{
   char *ps;
   static char s[80];

   if ((ps = getenv("HTTPTMP")) != 0) 
   {
       ps = stpcpy(s,ps);
       if (ps[-1] != '\\')
          *ps++ = '\\';
   }
   else
       ps = s;
   sprintf(ps,"HTM$%04X.TMP",iNum);
   return s;
}

/* Create control block, put in LL, initialize */
//called only from state change upcall handler
static HTTP *http_create(unsigned tcbo)
{
	HTTP *ph;
	TCB far *tcb = (TCB far *)MK_FP(tcbs, tcbo);
	static unsigned id;


	//check number of connections
	if (iMaxNumcon && iNumcon >= iMaxNumcon)
		return 0;
	if((ph = (HTTP *)calloc(1,sizeof (HTTP))) == 0)
		return 0;
	iNumcon++;
	++iNumRequests;
	if (++id == 0)
      ++id;
   ph->id = id;
   ph->tcbo = tcbo; /* Downward pointer */
	tcb->user = (WORD)ph;   /* Upward pointer */
   //ph->flags = GOT_RECEIVE_UPCALL | GOT_TRANSMIT_UPCALL;//lie a bit to get things going

   //linked list exists, put at end of list
   if (HTTPfirst) 
   {
      ph->prev = HTTPlast;
      HTTPlast->next = ph;
   }
	else
		HTTPfirst = ph;
	return HTTPlast = ph;
}

/* Free resources, delete control block */
void http_delete(HTTP *ph)
{
	TCB far *tcb;
	int iscq;
	EVENT *psq;
	HTTP *ph1;

	if (ph == 0)
		return;
	for (ph1 = HTTPfirst;ph1;ph1 = ph1->next)
	{
		if (ph == ph1)
			goto found;
	}
	return;
	found:
	iNumcon--;

	if (ph->tcbo)
   {
      tcb = (TCB far *)MK_FP(tcbs,ph->tcbo);
      tcb->user = 0;//remove from tcb structure
      //if connection exists, close it
      CloseTcp(ph->tcbo);
      DelTcp(ph->tcbo);
      disable();
      while (iNumEventQueEntries > 0) 
      {
         if (psEventQueOut->tcbo == ph->tcbo) 
         {
            if (++psEventQueOut >= sEventQue + QSIZE)
               psEventQueOut = sEventQue;//wrap around
            --iNumEventQueEntries;
            ++iNumEventsDeQueued;
         }
         else 
         {
            break;
         }
      }
      for (iscq = iNumEventQueEntries,psq = psEventQueOut;iscq;--iscq) 
      {
         if (psq->tcbo == ph->tcbo)
            psq->tcbo = 0;
         if (++psq >= sEventQue + QSIZE)
            psq = sEventQue;//wrap around
      }
      enable();
   }

   //remove from linklist
   disable();
   if (ph->prev)
      ph->prev->next = ph->next;
   else//first in list
      HTTPfirst = ph->next;
   if (ph->next)
      ph->next->prev = ph->prev;
   else//last in list
      HTTPlast = ph->prev;
   enable();
   //free resources
   if (ph->szUser)
      free(ph->szUser);
   if (ph->szPass)
      free(ph->szPass);
   if (ph->szFilename)
      free (ph->szFilename);
   if (ph->fp)
      fclose(ph->fp);
   while (ph->iEnvSize > 0)
      free((void *)FP_OFF(ph->ppEnv[--ph->iEnvSize]));
   if (ph->ppEnv)
      free((void *)FP_OFF(ph->ppEnv));
   if (ph->rqline) {
      if_RemoveAlloc("ph->rqline",ph->rqline)
         free_c(ph->rqline);
   }
   if (ph->iNameOut)
      unlink(MakeName(ph->iNameOut));
   FreeEnv(ph);
   if_RemoveAlloc("ph",ph)
      free_c(ph);
}

/* HTTP Server Receiver upcall handler */
void _loadds far http_rcv_up(WORD tcbo,WORD cnt)
{
   //see if ESTABLISHED has been qued. If not, dont que this event
   if (!((TCB far *)MK_FP(tcbs,tcbo))->user)
      return;
   PutInQue(QR, tcbo, cnt);
   ++iNumRecv;
   UpcallC();
}


/* Http transmit upcall handler */
void _loadds far http_snd_up(WORD tcbo, WORD cnt)
{
   //see if ESTABLISHED has been qued. If not, dont que this event
   if (!((TCB far *)MK_FP(tcbs,tcbo))->user)
      return;
   PutInQue(QT, tcbo, cnt);
   ++iNumXmit;
   SetSchedule();
   UpcallC();
}


/* HTTP Server State change upcall handler */
#pragma argsused
void _loadds far http_stc_up(WORD tcbo,char old,char new)
{
   static char arStack[100];
   static char cInStack = 0;
   static int iSS;
   static int iSP;

   TCB far *pfTCB;

   pfTCB = (TCB far *)MK_FP(tcbs,tcbo);
   switch (new) 
   {
      case ESTABLISHED:
         pfTCB->user = (WORD)1;//mark that ESTABLISHED is qued
         //fall thru
      case CLOSE_WAIT:
      case TIME_WAIT:
      case CLOSED:
         //not estab, just delete
         if (!pfTCB->user) 
         {
            if (cInStack == 0) 
            {
               cInStack++;
               iSS = _SS;
               iSP = _SP;
               _SS = _DS;
               _SP = (unsigned)arStack + 98;
   
            }
            TcpFunction(tcbo,API_TCPCLOSE);
            TcpFunction(tcbo,API_TCPDELET);
            if (--cInStack == 0) 
            {
               //restore stack
               _SS = iSS;
               _SP = iSP;
            }
            return;
         }
         PutInQue (QS, (unsigned)tcbo, new);
         ++iNumState;
   }//end switch
   SetSchedule();
   UpcallC();//see if we can get stable state, perform scheduled task
}

#ifdef DEBUG_Q
void Qerr(HTTP *ph,unsigned id,int type,unsigned tcb)
{
   printf("Que error: type=%d, id = %3u, ph->id = %u, ph = %p tcb = %04x\n",
      type,id,ph->id,ph,tcb);
}
#endif

/* HTTP connection state change upcall handler (stable-time) */
void s_http(void)
{
   HTTP *ph;
   TCB far *tcb;
   char type;
   unsigned tcbo;
   unsigned val;//new state
   unsigned id;

   while (disable(),iNumEventQueEntries > 0) 
   {
      type = psEventQueOut->type;
      tcbo = psEventQueOut->tcbo;
      val = psEventQueOut->val;
      id = psEventQueOut->id;
      if (++psEventQueOut >= sEventQue + QSIZE)
         psEventQueOut = sEventQue;//wrap around
      --iNumEventQueEntries;
      ++iNumEventsDeQueued;
      enable();
      if (!tcbo)
         continue;
      tcb = (TCB far *)MK_FP(tcbs, tcbo);
      ph = (HTTP *)tcb->user;
      if (ph == (void *)1)//not created yet
         ph = 0;
      if (ph && !id)
         id = ph->id;   // has been put into queue before creating ph
      switch (type) 
      {
         case QS:
            switch (val) 
            {
               case ESTABLISHED:
                  disable();
                  ph = http_create(tcbo);
                  enable();
                  if(!ph)//probably out of memory
                     CloseTcp(tcbo);
                  break;
               case CLOSE_WAIT:
                  if (ph && ph->id == id) 
                  {
                     r_http(ph);      // perhaps something more to read
                     CloseTcp(tcbo);
                  }
#ifdef DEBUG_Q
                  else
                     Qerr(ph,id,type,tcbo);
#endif
               case TIME_WAIT:
               case CLOSED:
                  ApiCgi(ph, R_CLOSED, 0, 0);
                  if (ph && ph->id == id)
                     http_delete(ph);
                  else 
                  {
                     // get rid of the connection
                     CloseTcp(tcbo);
                     DelTcp(tcbo);
#ifdef DEBUG_Q
                     Qerr(ph,id,type,tcbo);
#endif
                  }
                  /* Check if server is being shut down */
                  break;
            }//end switch(val)
            break;
         case QR://receive data and handle
            if (ph && ph->id == id)
            {
               ph->rcount = val;
               r_http(ph);
            }
   #ifdef DEBUG_Q
            else
                  Qerr(ph,id,type,tcbo);
   #endif
            break;
         case QT://cant transmit straight away (dont know what to), only set flag
            if (ph && ph->id == id) 
            {
               ph->tcount = val;
               ph->flags |= GOT_TRANSMIT_UPCALL;
            }
   #ifdef DEBUG_Q
            else
               Qerr(ph,id,type,tcbo);
   #endif
            break;
      }//end switch (type)
   }//end while
   enable();
}

typedef struct typess {
   char *ext;
   char *type;
} TYPES;

TYPES types[] = {
   {"htm","text/html"},
   {"txt","text/plain"},
   {"gif","image/gif"},
   {"jpe","image/jpeg"},
   {"jpg","image/jpeg"},
   {"pjp","image/pjpeg"},
   {"",""},
};

/* Date formats
Sun, 06 Nov 1994 08:49:37 GMT    ; RFC 822, updated by RFC 1123
Sunday, 06-Nov-94 08:49:37 GMT   ; RFC 850, obsoleted by RFC 1036
Sun Nov  6 08:49:37 1994         ; ANSI C's asctime() format
*/

char months[] =
   "Jan""Feb""Mar""Apr""May""Jun"
   "Jul""Aug""Sep""Oct""Nov""Dec";

static int getnum(char **pts)
{
   char *ps = *pts;
   char c;

   int num = 0;
   while ((c = *ps) != 0 && isdigit(c)) 
   {
      num = 10 * num + (c - '0');
      ++ps;
   }
   while (*ps && (isspace(*ps) || *ps == '-' || *ps == ':'))
      ++ps;
   *pts = ps;
   return num;
}

//create a filled time structure from a http time formatted string
static time_t parse_time(char *ts)
{
   struct tm time;
   char is_ctime = 0;

   while (*ts && !isspace(*ts))
      ++ts;
   while (*ts && isspace(*ts))
      ++ts;
   if (isdigit(*ts)) 
   {
      time.tm_mday = getnum(&ts);
   }
   else
      is_ctime = 1;
   for (time.tm_mon = 0;time.tm_mon < 12;++time.tm_mon) 
   {
      if (strnicmp(months + 3 * time.tm_mon,ts,3) == 0) 
      {
         ts += 3;
         break;
      }
   }
   while (*ts && (isspace(*ts) || *ts == '-'))
      ++ts;
   if (is_ctime)
      time.tm_mday = getnum(&ts);
   else
      time.tm_year = getnum(&ts);
   time.tm_hour = getnum(&ts);
   time.tm_min = getnum(&ts);
   time.tm_sec = getnum(&ts);
   if (is_ctime)
      time.tm_year = getnum(&ts);
   if (time.tm_year > 1900)
      time.tm_year -= 1900;
   time.tm_isdst = -1;
   return mktime(&time);
}

char hextobin(char c)
{
   if (c >= '0' && c <= '9')
      return c - '0';
   if (c >= 'A' && c <= 'F')
      return c - 'A' + 10;
   if (c >= 'a' && c <= 'f')
      return c - 'a' + 10;
   return 0;
}

// remove escape characters (%xx) from string
void unescape(char *pin)
{
   char *pout = pin,c,c1;

   while ((c = *pin++) != 0) 
   {
      if (c == '%') 
      {
         if (!(c = *pin++) || !(c1 = *pin++))
            break;      // unexpected end!
         c = (hextobin(c) << 4) + hextobin(c1);
      }
      *pout++ = c;
   }
   *pout = 0;
}

/* Process a line read on an HTTP connection (any state)
called from r_http
return 0 if normal, -1 if ph deleted
*/
int doline(register HTTP *ph)
{
   char *p,*pbuf;
   static char szFullname[LINELEN + 80];
   static char szReferPath[LINELEN + 80];
   extern char version[];
   extern long _timezone;
   //int iErr;
   TYPES *pt;

   if ((pbuf = strchr(ph->buf,' ')) != 0) 
   {
      *pbuf++ = 0;
      while (isspace(*pbuf))
         ++pbuf;
   }
   else
      pbuf = ph->buf;

   switch(ph->state) 
   {
      case REQUEST:
         if (strnicmp(ph->buf, "GET", 3) == 0)
            ph->request = RQ_GET;
         else if (strnicmp(ph->buf, "POST", 4) == 0)
         {
            ph->request = RQ_POST;
         }
         else 
         {
            Tprintf(ph->tcbo, "HTTP/1.0 501 Not implemented\r\n\r\n");
            http_delete(ph);
            return -1;
         }
   
         ph->flags |= USE_LOCAL_COPY;
         ph->state = HEADER;
         if ((p = strchr(pbuf,' ')) != 0)
            *p = 0;
   
         if ((ph->szFilename = malloc(strlen(pbuf) + 1)) == 0) 
         {
            //NB error message
            http_delete(ph);
            return -1;
         }
   
         strcpy(ph->szFilename, pbuf);
         pbuf = ph->szFilename;
   
   
         //check for cgi api handler
         while (*pbuf == '/')
            pbuf++;      //pbuf points to rel url
         if ((ph->pQuery = strchr(pbuf, '?')) != 0)
            *ph->pQuery++ = 0;   //p points to query
         else
            ph->pQuery = strchr(pbuf, 0);
         unescape(ph->pQuery);//remove any escape modifiers from query
   
         if ((ph->pCgiUser = FindCGIUser(pbuf)) != 0 || strstr(pbuf, "cgi-bin"))
            ph->flags |= IS_CGI;
         break;
      case HEADER:
         if (*ph->buf == 0) 
         {      // end of header
   
            CalcFullPath(szFullname, ph->szFilename, LINELEN + 65);
   
            //if it ends on '/' we append 'index.htm'
            if (ph->szFilename[strlen(ph->szFilename) - 1] == '/')
               strcat(szFullname, "/index.htm");
   
            if (Verify(ph->request, szFullname, ph->szUser, ph->szPass) != L_ALLOWED
             || ((ph->flags & IS_CGI)   //is cgi
				  && Verify(RQ_CGI, szFullname, ph->szUser, ph->szPass) != L_ALLOWED))
            {//but cgi not allowed
               /*
               switch (iErr) {
               case LERR_PASS: //if password incorrect
                  //NB proper response (like chalenge)
               case LERR_USER: //if user not found
               case LERR_PERM: //if user and password exists but no permission
               case LERR_ACC:  //if no access to path
               case LERR_TYPE: //if invalid cType
                  //operation not allowed
                  break;
               }
               */
               Tprintf(ph->tcbo,"HTTP/1.0 401 Not authorized\r\n"
                  "WWW-Authenticate: Basic realm=\"%s\"\r\n\r\n", szFullname);
               http_delete(ph);
               return -1;
            }
            if (ph->flags & IS_CGI) 
            {
               if (ph->pCgiUser) 
               {
                  //user will be notified by return-to function
                  ph->state = NEWCGI;
                  break;//leave all the rest to the extension
               }
               //is old type cgi request
               //if (!use_cgi) {
               //   Tprintf(ph, "HTTP/1.0 501 CGI not allowed\r\n\r\n");
               //   http_delete(ph);
               //   return -1;
               //}
               if (ph->request == RQ_POST) 
               {
                  if ((ph->iNameIn = ++iNameNum) == 0)
                     ph->iNameIn = ++iNameNum;
                  ph->fp = fopen(MakeName(ph->iNameIn),"wb");
               }
               if ((ph->rqline = malloc(strlen(szFullname) + 1)) != 0)
                  strcpy(ph->rqline, szFullname);
            }
            else if (ph->request == RQ_GET) 
            {
               if ((ph->fp = LFNfopen(szFullname,"rb")) == NULL) 
               {
                  strcat(szFullname, "/index.htm");
                  ph->fp = LFNfopen(szFullname,"rb");
               }
            }
				else if (ph->request == RQ_POST)
            {
               ph->fp = LFNfopen(szFullname,"wb");
            }
            ph->type = "application/octet-stream";
            //logf = 1;
            if ((p = strrchr(szFullname, '.')) != 0) 
            {
               if (p[1]) 
               {
                  for (pt = types;*pt->ext;++pt) 
                  {
                     if (strnicmp(p + 1,pt->ext,3) == 0) 
                     {
                        //logf = 0;
                        ph->type = pt->type;
                        break;
                     }
                  }
               }
               else 
               {
                  //logf = 0;
                  ph->type = "text/html";
					}
				}
				else
				{
					//logf = 0;
					ph->type = "text/html";
				}

				if (ph->request == RQ_POST)
				{
					if (ph->fp)
					{
						ph->state = POST;
					}
					else
					{
						if (ph->content_len > 0)
						{
							Tprintf(ph->tcbo,"HTTP/1.0 500 Internal server error\r\n");
							Tprintf(ph->tcbo,"Content-type: text/html\r\n\r\n");
							Tprintf(ph->tcbo,"<body><h1>POST file open error</h1></body>");
							http_delete(ph);
							return -1;
						}
						else
						{
							ph->state = POST;
						}
					}
				}
				else if (DoResponse(ph) < 0)
					return -1;
				break;
			}
			else if (ph->pCgiUser && ph->pCgiUser->iFlags & F_ENV)
			{
            char cErr = 0;
            //just save this header
            if (ph->iEnvSize % 10 == 0) 
            {//make it bigger
               int iOldsize = ph->iEnvSize * sizeof(char far*);
               int iNewsize = iOldsize + (10 * sizeof(char far*));
               char far* far* ppNewEnv   = malloc(iNewsize);
               if (ppNewEnv) 
               {
                  if (ph->ppEnv) 
                  {
                     _fmemcpy(ppNewEnv, ph->ppEnv, iOldsize);
                     free((void *)FP_OFF(ph->ppEnv));
                     ph->ppEnv = 0;
                  }
                  ph->ppEnv = ppNewEnv;
               }
               else
                  cErr = 1;
            }
            if (!cErr) 
            {
               char *pString = malloc (strlen(ph->buf) + 1 + strlen(pbuf) + 1);
               if (pString) 
               {
                  ph->ppEnv[ph->iEnvSize++] = pString;
                  sprintf (pString, "%s %s", ph->buf, pbuf);
               }
            }
         }
   
         if (stricmp(ph->buf,"If-Modified-Since:") == 0) 
         {
            ph->if_modified_time = parse_time(pbuf) - _timezone;
            if ((pbuf = strchr(pbuf,';')) != 0) 
            {
               ph->if_modified_length = atol(pbuf + 7);
            }
         }
         else if (stricmp(ph->buf,"Content-Length:") == 0) 
         {
            if (ph->flags & IS_CGI)
					AddCGIEnvVar(ph,"CONTENT_LENGTH",pbuf);
				ph->content_len = atol(pbuf);
         }
         //see if there is a challenge response
         //format: Authorization: <type> (base64<username>:<password>)
         else if (stricmp(ph->buf,"Authorization:") == 0) 
         {
            //pbuf should point to type
            if ((p = strchr(pbuf, ' ')) == 0) //p points to cookie
               break;//bad format
            *p++ = 0;
            if (stricmp(pbuf, "Basic") != 0)
               break;//doesnt support this type
            base64Decode(p, p);   //p points to username
            if ((pbuf = strchr(p, ':')) == 0) //pbuf points to password
               break;//bad format
            *pbuf++ = 0;
            if ((ph->szUser = malloc(strlen(p) + 1)) != 0 &&
                (ph->szPass = malloc(strlen(pbuf) + 1)) != 0) 
            {
               strcpy(ph->szUser, p);
               strcpy(ph->szPass, pbuf);
            }
            else 
            {
               //just treat as if no password?? NB
            }
         }
         //
         // see if there is a referer 
         //
         else if (stricmp(ph->buf, "Referer:") == 0)
         {
            // pbuf points to file
            // get past server information
            p = strchr(pbuf, '/');  // server seperators
            p += 2;
   
            // point to the beginning of the url path
            p = strchr(p, '/');
   
            CalcFullPath(szReferPath, p, LINELEN + 65);
   
            if (stricmp(szReferPath, szFullname) == 0)
            {
               Tprintf(ph->tcbo,"HTTP/1.1 405 Method Not Allowed\r\n");
               Tprintf(ph->tcbo,"Content-type: text/html\r\n\r\n");
               Tprintf(ph->tcbo,"<html><head><title>405 Method Not Allowed</title>\r\n</head><body>\r\n");
               Tprintf(ph->tcbo,"<h1>405 Method Not Allowed</h1>\r\n");
               Tprintf(ph->tcbo,"The Requested method POST is not allowed for the URL %s.<p>\r\n", p);
               Tprintf(ph->tcbo,"<br>\r\n<address>Server: Sockets %s</address>\r\n",version);
               Tprintf(ph->tcbo,"</body></html>");
               http_delete(ph);
               return -1;
            }
   
         }
   
            
         if (ph->flags & IS_CGI) 
         {
            if (stricmp(ph->buf,"Content-Type:") == 0)
               AddCGIEnvVar(ph,"CONTENT_TYPE",pbuf);
         }
         break;
   }
   ph->cnt = 0;
   return 0;
}

int DoCgi(HTTP *ph)
{
   char header_seen;
   static char str[100];
   int i = 1;
   int oldstdin;
   int oldstdout;

   // add a few standard variables
   AddCGIEnvVar(ph,"PATH",path);
   AddCGIEnvVar(ph,"COMSPEC",comspec);
   // add request method
   AddCGIEnvVar(ph,"REQUEST_METHOD",ph->request == RQ_POST ? "POST" : "GET");
   // redirect stdout and stdin
   oldstdout = dup(STDOUT);
   if ((ph->iNameOut = ++iNameNum) == 0)
      ph->iNameOut = ++iNameNum;
   freopen(MakeName(ph->iNameOut), "wt", stdout);
   if (ph->request == RQ_POST) 
   {
      oldstdin = dup(STDIN);
      freopen(MakeName(ph->iNameIn),"rt",stdin);
   }
   if (ph->pQuery)
      i = spawnlpe(P_WAIT, ph->rqline, ph->rqline, ph->pQuery, 0, ph->pCGIEnv);
   else
      i = spawnlpe(P_WAIT, ph->rqline, ph->rqline, 0, ph->pCGIEnv);
   // return stdin and stdout
   //freopen("yyy", "wt", stdout);//just to set it back to text mode
   dup2(oldstdout, STDOUT);
   if (close(oldstdout) < 0)
		;//printf("Error on close(oldstdout)\n");   // debug
   if (isatty(fileno(stdout)))
      setbuf(stdout,0);
   if (ph->request == RQ_POST) 
   {
      //freopen("xxx","rt",stdin);//just to set it back to text mode
      dup2(oldstdin, STDIN);
      if (close(oldstdin) < 0)
         ;//printf("Error on close(oldstdin)\n");
      unlink(MakeName(ph->iNameIn));
   }
   if (i) 
   {
      Tprintf(ph->tcbo,"HTTP/1.0 404 URL not found\r\n"
                     "Content-type: text/html\r\n\r\n");
      Tprintf(ph->tcbo,"<body><h1>Error executing %s - %s</h1></body>",
                     ph->rqline,sys_errlist[errno]);
      http_delete(ph);
      return -1;
   }
   ph->flags &= ~USE_LOCAL_COPY;
   if ((ph->fp = fopen(MakeName(ph->iNameOut),"rb")) == 0)
      return 0;
   ph->type = "text/plain";
   header_seen = 0;
   while (fgets(str,100,ph->fp) != 0) 
   {
      if (*str == '\r' || *str == '\n')
         break;         // past header
      if (str[strlen(str) - 1] != '\n') 
      {
         break;
      }
      if (strncmp(str,"Content-type: ",14) == 0) 
      {
         str[99] = 0;
         strcpy(ph->buf,str + 14);
         ph->type = ph->buf;
         header_seen = 1;
      }
   }
   if (!header_seen)
      rewind(ph->fp);
   return 0;
}

int DoResponse(HTTP *ph)
{
   struct stat statbuf;
   struct tm *time_gm;
   time_t secs_now;
   static char str[60];

   if (ph->flags & IS_CGI) 
   {
      if (DoCgi(ph) < 0)
         return -1;
   }
   if (ph->fp == 0) 
   {      //couldnt open file
      //NB cluge for IE4
      Tprintf(ph->tcbo,"%sContent-type: text/html\r\n\r\n", URLNF);
      Tprintf(ph->tcbo,"<body><h1>%s</h1></body>", URLNF);
      http_delete(ph);
      return -1;
   }
   fstat(fileno(ph->fp), &statbuf);
   if ((ph->flags & USE_LOCAL_COPY) && ph->if_modified_time &&
      statbuf.st_ctime <= (ph->if_modified_time) &&
      (!ph->if_modified_length ||
      ph->if_modified_length == (DWORD)statbuf.st_size)) 
   {
      Tprintf(ph->tcbo,"HTTP/1.0 304 Use local copy\r\n");
   }
   else 
   {
      Tprintf(ph->tcbo,"HTTP/1.0 200 OK\r\n");
      ph->flags &= ~USE_LOCAL_COPY;
   }
   Tprintf(ph->tcbo,"Server: Sockets/%s\r\n",version);
   time(&secs_now);
   time_gm = gmtime(&secs_now);
   strftime(str,58,"Date: %a, %d %b %Y %H:%M:%S GMT",time_gm);
   Tprintf(ph->tcbo,"%s\r\n",str);
   if ((ph->flags & USE_LOCAL_COPY) ||
         (ph->request == RQ_POST && !(ph->flags & IS_CGI))) 
   {
      Tprintf(ph->tcbo,"\r\n");
      fclose(ph->fp);
      ph->fp = 0;
      http_delete(ph);
      return -1;
   }
   if (ph->flags & IS_CGI) 
   {
      Tprintf(ph->tcbo,"Expires: Monday, 30-Mar-1970 02:57:45 GMT\r\n"
               "Pragma: no-cache\r\n");
   }
   else 
   {
      time_gm = gmtime(&statbuf.st_ctime);
      strftime(str,58,"Last-Modified: %a, %d %b %Y %H:%M:%S GMT",time_gm);
      Tprintf(ph->tcbo,"%s\r\n",str);
      //Tprintf(ph,"Expires: Monday, 30-Mar-1970 02:57:45 GMT\r\n"
      //         "Pragma: no-cache\r\n");
   }
   Tprintf(ph->tcbo,"Content-length: %lu\r\n"
               "Content-type: %s\r\n\r\n",//END of header
            statbuf.st_size - (ph->flags & IS_CGI ?
            ftell(ph->fp) : 0),ph->type);
   ph->flags |= HTTP_SENDFILE;//we are ready to send a file
   return 0;
}

//transmit (a) file on connection
//only send at stable state
//dont overcrowd rinet - only send when transmit upcall received
void t_http(register HTTP *ph)
{
   char *bp;
   int rc;//read count
   int cnt;

   if (ph->pCgiUser && ph->state > HEADER) 
   {
      if (!ph->fp) 
      {
         ApiCgi(ph, R_OUTDATA, 0, ph->tcount);
         return;
      }
      //get data from user and send ??
      //what if file send - normal fashion
      //if we cant send, buffer data and dont call user to send until all done
   }

   if (ph->fp == 0 || !tcpq_empty(ph))
      return;

   cnt = ph->tcount;//set at upcall
   while(1) 
   {
      if ((bp = malloc(cnt)) == 0) 
      {
         if ((cnt = cnt / 2) < 10) 
         {
            fclose(ph->fp);
            ph->fp = 0;
            http_delete(ph);
            return;
         }
      }
      else 
      {
         break;
      }
   }
   rc = fread(bp, 1, cnt, ph->fp);
   if (rc != cnt) 
   {
      ph->flags &= ~HTTP_SENDFILE;
      fclose(ph->fp);
      ph->fp = 0;
   }
   if(rc != 0)
      cnt = SendTcph(ph->tcbo, bp, rc);
   if_RemoveAlloc("bp",bp)
      free_c(bp);
   if (ph->fp && cnt != rc) 
   {
      long move;

      if (cnt < 0) 
      {//error occurred
         //pretend not a serious error, just move back
         move = -rc;
      }
      else 
      {//couldnt send all
         move = cnt - rc;
      }
      fseek(ph->fp, move, SEEK_CUR);//move file pointer back
   }
   if (ph->fp == 0) 
   {      //file closed during operation, indicating done
      if (!ph->pCgiUser)      //user dont want to receive any more data
         http_delete(ph);   //finished job, end off
      //else wait for next upcall
   }
}

/*
 * HTTP receiver upcall handler (stable time)
 */
void r_http(register HTTP *ph)//may later use count
{
   char readbuf[LINELEN],ch;
   int cnt, index, eof = 0;

   if (ph->state == POST)
   /* Assemble an input line in the session buffer.
    * Return if incomplete
    */
   if (!ph || !ph->tcbo) 
   {
      return;
   }
   if (ph->pCgiUser && ph->state > HEADER) 
   {
      //tell user we've got data for him
      ApiCgi(ph, R_INDATA, 0, ph->rcount);
      return;
   }
   while (1) 
   {
		if (ph->state == POST && ph->content_len <= 0)
      {
         fclose(ph->fp);
         if (DoResponse(ph) < 0)
            return;
         break;
      }
      cnt = RecvTcp(ph->tcbo, readbuf, LINELEN, &eof);
      if (cnt <= 0) 
      {
         ph->flags |= GOT_RECEIVE_UPCALL;   // try receive again soon
         break;
      }
      ph->rcount -= cnt;
      if (ph->state == POST) 
      {
         if (eof) 
         {
            ph->content_len = 0;
            continue;
         }
         fwrite(readbuf,1,cnt,ph->fp);
         ph->content_len -= cnt;
         continue;
      }
      if (eof)
      {
         break;
      }
      for (index = 0; index < cnt; index++) 
      {
         switch(ch = readbuf[index]) 
         {
            case '\r':   /* Strip cr's */
               continue;
            case '\n':   /* Complete line; process it */
               ph->buf[ph->cnt] = '\0';
               if (doline(ph) == -1)
                  return;
               if (ph->state == NEWCGI) 
               {
                  ++index;
                  memcpy(ph->buf, readbuf + index, cnt - index);
                  ph->cnt = cnt - index;
                  if(ApiCgi(ph, R_NEWREQ, ph->pQuery, 0) != 0) //deleted
                     return;
                  if (ph->rcount < 0)
                     ph->rcount = 0;
                  if (ph->cnt != 0)
                     ApiCgi(ph, R_INDATA, 0, ph->rcount);//ignore ph-cnt bytes as it will be added in ApiCgi
                  return;
               }
               if (ph->state == POST) 
               {
                  ++index;
						fwrite(readbuf + index,1,cnt - index,ph->fp);
                  ph->content_len -= (cnt - index);
                  index = cnt;
               }
					break;
            default:
               if (ph->cnt < LINELEN - 1)
                  ph->buf[ph->cnt++] = ch;
               break;
         }//end switch
      }//end for
   }//end while
}

//char NoEnv = 1;

char *AddCGIEnvVar(HTTP *ph,char *pVar, char *pVal)
{
   char *pInsert;
   char **pEnv;

//   if (NoEnv)
//      return 0;
   // adding a new var
   if (!ph->pCGIEnv)
      pEnv = (char **) malloc( (ph->countEnv + 2) * sizeof(char **));
   else
      pEnv = (char **) realloc( ph->pCGIEnv, (ph->countEnv + 2) * sizeof(char **));
   if (!pEnv)
      return 0;
   ph->pCGIEnv = pEnv;
   pInsert = malloc(strlen(pVar) + strlen(pVal) + 3);
   ph->pCGIEnv[ph->countEnv] = pInsert;
   ph->pCGIEnv[ph->countEnv + 1] = NULL;
   if (!pInsert)
      return 0;
   ph->countEnv++;
   strcpy(pInsert, pVar);
   strcat(pInsert, "=");
   strcat(pInsert, pVal);
   return pInsert;
}

void FreeEnv(HTTP *ph)
{
   char *pInsert;

   if (ph->pCGIEnv) 
   {
      while (ph->countEnv >= 0) 
      {
         if ((pInsert = ph->pCGIEnv[ph->countEnv]) != 0) 
         {
            free(pInsert);
         }
         --ph->countEnv;
      }
      ph->countEnv = 0;
      free(ph->pCGIEnv);
      ph->pCGIEnv = 0;
   }
}

// part of status routine
void PrintEvents(void)
{
   extern unsigned uInCriticalSectionCount;
   extern char opstat;

   printf("Event queue: Count: %d, Max: %d, Full: %u\n",
      iNumEventQueEntries,iNumEventQueMax, wErrEventQueFull);
   printf("Events: State %u Recv %u Xmit %u Total in %u out %u\n",
      iNumState,iNumRecv,iNumXmit,
      iNumEventsQueued,iNumEventsDeQueued);   // number of events dequeued
   printf("Requests %u\n",iNumRequests);
   //printf("uInCriticalSectionCount = %d opstat %02x\n",
   //      uInCriticalSectionCount,opstat);
#ifdef DEBQ
   {
      EVENT *pQ;

      for (pQ = sEventQue;pQ < sEventQue + uNumTotalEvents;++pQ) 
      {
         printf("%s %4u %04x %04x %s %s\n",
            pQ->type == QR ? "R" :
            pQ->type == QT ? "T" :
            pQ->type == QS ? "S" : "?",
            pQ->val,pQ->tcbo,pQ->id,
            pQ == psEventQueIn ? "<" : "",
            pQ == psEventQueOut ? ">" : "");
		}
	}
#endif
	/*
	if (errd1 || errd1c || errd2 || errd2c || errd2cg ||  errd1cg)
		printf("Delete errors  S:%d C:%d D:%d est can:%d D2:%d C2%d\n",// %x g:%d b:%d\n",
					errd1,errd1c,errd1cg, errd2,errd2cg,errd2c);
	for (i = 0; i < 11; i++) {
		printf("%d-%d  ", i, dreg[i]);
	}
	printf("\n");
   */
}

/*
 * Decodes a base64 encoded string. The decoded string is stored at szDecoded.
 * szDecoded will be at least 75% and at most 100% the length of szEncoded.
 * szDecoded may be the same or less than szEncoded
 *
 * Return the length of the decoded string, excluding the 0-terminator.
 *
 * Implemented according to RFC 1521 par 5.2
 */
int base64Decode(char *szEncoded, char *szDecoded)
{
   unsigned char byte;
   int count = 0;
   char* pOrig = szDecoded;

   while(1) 
   {
      char cEnc = *szEncoded++;
      if (cEnc <= 'Z' && cEnc >= 'A')
         byte = cEnc - 'A';
      else if (cEnc <= 'z' && cEnc >= 'a')
         byte = cEnc - 'a' + 26;
      else if (cEnc >= '0' && cEnc <= '9')
         byte = cEnc - '0' + 52;
      else if (cEnc == '+')
         byte = 62;
      else if (cEnc == '/')
         byte = 63;
      else if (cEnc == '=' || cEnc == 0)
      {//end of processing
         *szDecoded = 0;//terminate string
         return szDecoded - pOrig;
      }
      else
         continue;//ignore: might be transmission formatting like CR
      switch(count++ & 3) 
      {
         case 0:
            *szDecoded = (byte << 2) & 0xfc;
            break;
         case 1:
            *szDecoded++ |= (byte >> 4);
            *szDecoded = (byte << 4) & 0xf0;
            break;
         case 2:
            *szDecoded++ |= (byte >> 2);
            *szDecoded = (byte << 6) & 0xc0;
            break;
         case 3:
            *szDecoded++ |= byte;
            break;
      }
   }
}

