;
;   $Id: RESINT.ASM 1.6 2002/10/16 17:03:34Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
; RESINT.ASM
;
; Copyright (C) 2001 Datalight, Inc.
; All Rights Reserved
; Datalight Confidential and Proprietary
; Portions Copyright (c) GP van Niekerk Ondernemings 1990-2001
;
; Assembler functions for resident programs
;
; $DocHistory
; 08/01/2001 jmb  Cleaned up Local2aIntercept to make more readable and
;                 not use local stack space.
; 07/20/2001 gvn  Changed Local2aIntercept to GPvNO's version and modified it
;                 to allow it to be patched.
; 07/18/2001 gvn  added Local2aIntercept
; 02/14/2001 DE   changed int 13h chain procedure in newdisk to
;                 restore original DS and BP register values in support
;                 of EDD (LBA) disk calls.
;

;SHOW_DEB equ 1		; To display INT21 function

_TEXT	segment byte public 'CODE'
_TEXT	ends
DGROUP	group	_DATA,_BSS
	assume	cs:_TEXT,ds:DGROUP
_DATA	segment word public 'DATA'
_DATA	ends
_BSS	segment word public 'BSS'
_BSS	ends
_TEXT	segment byte public 'CODE'

	extrn	_new_api:far

	assume	cs:_TEXT
_newdisk	proc	far
	push	bp
	push	ds
	mov	bp,DGROUP
	mov	ds,bp
	mov	bp,sp
	inc	byte ptr DGROUP:_diskflag
	or	byte ptr DGROUP:_opstat,2		; DISKFLAG
	cmp	byte ptr DGROUP:_monflag,0
	je	skipmon1
	push	es
	push	ax
	mov	es,_vidseg
	mov	al,byte ptr DGROUP:_opstat
	mov	ah,70h
	mov	es:word ptr 3998,ax
	or	byte ptr DGROUP:_monfunc,2
	mov	al,byte ptr DGROUP:_monfunc
	mov	es:word ptr 3996,ax
	pop	ax
	pop	es

skipmon1:
	; LBA calls use ds:si, therefore we must restore the original 
	; information before forwarding the call to the old handler.
	;
	push	bp
	push	ds		; save local ds, bp

	pushf			; simulate int 13h stack data
	push	cs		
	push	offset return_here  	; next in line irets here

	push	word ptr DGROUP:_olddisk+2	; set up for far "call"
	push	word ptr DGROUP:_olddisk

	mov	ds, [bp]	; restore caller's ds, bp
	mov	bp, [bp+2]
	retf			; call old int 13h handler

return_here:
	pop	ds		; restore local ds
	pop	bp
	pushf
	pop	[bp+8]		; return flags to caller

	dec	byte ptr DGROUP:_diskflag
	cmp	byte ptr DGROUP:_diskflag,0
	jne	mult_entry
	and	byte ptr DGROUP:_opstat,0fdh	; ~DISKFLAG
mult_entry:
	cmp	byte ptr DGROUP:_monflag,0
	je	skipmon2
	push	es
	push	ax
	mov	es,_vidseg
	mov	al,byte ptr DGROUP:_opstat
	mov	ah,70h
	mov	es:word ptr 3998,ax
	pop	ax
	pop	es
skipmon2:
	pop	ds
	pop	bp
	iret
_newdisk	endp

old_api		dd	0
old_apic	dd	0

_setcsvecs	proc	near
	push	bp
	mov	bp,sp
	mov	ax,word ptr [bp+6]
	mov	dx,word ptr [bp+4]
	mov	word ptr old_api+2,ax
	mov	word ptr old_api,dx
	mov	ax,word ptr [bp+10]
	mov	dx,word ptr [bp+8]
	mov	word ptr old_apic+2,ax
	mov	word ptr old_apic,dx
	pop	bp
	ret
_setcsvecs	endp


	assume	cs:_TEXT
_newcrit	proc	far
	mov	ax,3
	iret
_newcrit	endp

ENTER_CRIT_SECTION equ 40h
LEAVE_CRIT_SECTION equ 0BFh

        assume DS:NOTHING

_Local2aIntercept       proc    far

        ; Preserve callers flags
        pushf                                   

        ; Enter critical section notification?
        cmp     ah, 080h                        
        je      @@DoInc

        ; End critical section notification?
        cmp     ah, 081h                        
        je      @@DoDec

        ; Clear all critical sections
        cmp     ah, 082h                        
	je      @@ClearAll

@@Done:
        ; Restore callers flags (saved above)
        popf                                    

        ; on to previous handler
        jmp	dword ptr cs:_lpPrev2aHandler   

@@DoInc:
        ;
        ; Note: if segment assumtions are declared correctly
        ; the uInCriticalSectionCount variables address will
        ; be computed relative to CS
        ;
		
        ; begin critical section
        inc     word ptr cs:_uInCriticalSectionCount
        or      byte ptr cs:_opstat, ENTER_CRIT_SECTION
        jmp     @@Done

@@DoDec:
        ;
        ;  Note: if segment assumtions are declared correctly
        ; the uInCriticalSectionCount variables address will
        ; be computed relative to CS
        ;

        ; end critical section
        dec     word ptr cs:_uInCriticalSectionCount
        cmp     word ptr cs:_uInCriticalSectionCount, 0

_Patch2aIntercept:
        ; this will be patched to NOP,NOP for old ROM-DOS.
        jne     @@Done

		  and     byte ptr cs:_opstat, LEAVE_CRIT_SECTION
		  jmp     @@Done

@@ClearAll:
		  ;
		  ;  Note: if segment assumtions are declared correctly
		  ; the uInCriticalSectionCount variables address will
		  ; be computed relative to CS
		  ;

		  mov     word ptr cs:_uInCriticalSectionCount, 0
		  and     byte ptr cs:_opstat, LEAVE_CRIT_SECTION
		  jmp     @@Done

_Local2aIntercept	endp

ifdef SHOW_DEB
level	dw 0
_new21	proc	far
		pushf
		push	ax
		push	si
		push	ds
		mov	si,0b800h
		mov	ds,si
		xor	si,si
		mov	al,byte ptr level
		add	al,'0'
		mov	[si],al
		mov	al,ah
		shr	al,4
		add	al,'0'
		cmp	al,'9'
		jle	digit1
		add	al,'A' - '0' - 10
digit1:
		mov	si,level
		shl	si,2
		mov	[si+4],al
		mov	al,ah
		and 	al,0fh
		add	al,'0'
		cmp	al,'9'
		jle	digit2
		add	al,'A' - '0' - 10
digit2:
		mov	[si+6],al
		inc	level
		mov	al,040h
		mov	ds:byte ptr [1],al
		mov	[si+5],al
		mov	[si+7],al
		pop	ds
		pop	si
		pop	ax
		call dword ptr cs:_old21
		dec	level
		push	ax
		push	bp
		mov	bp,sp
		pushf
		pop	ax
		mov	[bp+8],ax
		pop	bp
		push	si
		push	ds
		mov	si,0b800h
		mov	ds,si
		xor	si,si
		mov	al,020h
		mov	[si+1],al
		mov	si,level
		shl	si,2
		mov	[si+5],al
		mov	[si+7],al
		pop	ds
		pop	si
		pop	ax
		iret
_new21	endp
	extrn _old21
	public _new21
endif

_TEXT	ends
	public   _newcrit
	public   _newdisk
	public   _setcsvecs
	public   _Local2aIntercept
	public	_Patch2aIntercept
	extrn	_diskflag:byte
	extrn	_opstat:byte
	extrn	_monflag:byte
	extrn	_monfunc:byte
	extrn	_vidseg:word
	extrn _uInCriticalSectionCount:word
	extrn	_olddisk:dword
	extrn	_olddos:dword
	extrn	_old_apic:dword
	extrn	_old_api:dword
	extrn _lpPrev2aHandler
	extrn	_upcall_c:near
	extrn	_dos_c:near
	extrn	_badstin:far
	end
