#
#   $Id: iptest.mak 1.2 2003/08/19 20:48:56Z johnb Exp $
#
#   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
#
#   Copyright (c) 1993 - 2002 Datalight, Inc.
#   All Rights Reserved
#
#   Datalight, Inc. is a Washington corporation with an address at
#   21520 30TH DR SE MS110 Bothell, WA, 98021
#   Tel: 800.221.6630  Fax: 425.951.8091
#   Http://www.datalight.com
#
#   This software, including without limitation all source code and
#   documentation, is the confidential, trade secret property of
#   Datalight, Inc., and is protected under the copyright laws of
#   the United States and other jurisdictions. Portions of the
#   software may also be subject to one or more the following US
#   patents: US#5860082, US#6260156.
#
#   In addition to civil penalties for infringement of copyright
#   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
#   penalties for violation of (a) the restrictions on circumvention
#   of copyright protection systems found in 17 U.S.C. 1201 and
#   (b) the protections for the integrity of copyright management
#   information found in 17 U.S.C. 1202.
#
#   U.S. Government Restricted Rights. Use, duplication,
#   reproduction, or transfer of this commercial product and
#   accompanying documentation is restricted in accordance with
#   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
#
#   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
#   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
#   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
#   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
#   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
#   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
#   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
#   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
#   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
#   THIS SOFTWARE IN ERROR.
#
#
# CAPIDIAG.EXE Makefile
# Copyright (c) 2001 Datalight, Inc.
# All Rights Reserved
# Datalight Confidential and Proprietary
#
# Revision History
# 06/21/2001 jmb added cleanall target
# 05/01/2001 jmb added math libraries to accomodate changes from GPvNO
# 04/02/2001 jmb original revision
#
.AUTODEPEND

all:	iptest 
	@if exist ..\iptest.exe del ..\iptest.exe >nul
	@if exist ..\iptest.c   del ..\iptest.c >nul
	@if exist ..\iptest.pt   del ..\iptest.pt >nul
	@copy iptest.exe ..\iptest.exe >nul
	@copy iptest.c ..\iptest.c >nul
	@copy iptest.pt ..\iptest.pt >nul
        

clean:
	@echo Cleaning CAPIDIAG
	@if exist *.cfg del *.cfg >nul
	@if exist *.obj del *.obj >nul
	@if exist *.map del *.map >nul
	@if exist *.pt  del *.pt  >nul

cleanall: clean
	@if exist *.exe del *.exe >nul

#
# Borland C++ tools
#
CC  = Bcc
TLINK   = TLink


#
# Options
#
LFLAGS = $(RD_SW_L) -c -Tde -x
CFLAGS = $(RD_SW) -I..\..\include; -P- -c -mm
STARTUP= c0m.obj
LIBS   = emu.lib+mathm.lib+noehm.lib+cm.lib+..\..\lib\capim.lib

#
# Dependency List
#
iptest : iptest.cfg iptest.exe

iptest.exe : iptest.obj 
  @$(TLINK)  /v $(LFLAGS) @&&|
	$(STARTUP)+iptest.obj
	$<,$*
	$(LIBS)
|

iptest.obj :  iptest.c

.c.obj:
  @proto $*.c >$&.pt
  @$(CC) @iptest.cfg @&&|
	$(CFLAGS) $*.c
|

# Compiler configuration file
iptest.cfg :
   Copy &&|
-W-				# ?
-w				# warning control
#-R				# produce browser info
#-v				# source level debugging
-vi				# control expansion of inline funcs
-H				# use pre-compiled headers
-H=iptest.csm			# use pre-compiled header filname
-mm				# medium memory model
#-f-				# disable floating point
-x-				# disable exception handling
-xp-				# disable exception location info
-xd-				# disable destructor cleanup
-xc-				# disable compatible exception
-xf-				# disable fast exception prologs
-RT-				# disable runtime type info
#-d				# merge duplicate strings
-C				# enable nested comments
-H=				# use pre-compiled header filname
-1-				# compile 8086 instructions
| $@


