//
//   $Id: dhcpstat.C 1.2 2003/07/23 17:09:20Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
// DHCPSTAT.C
// Copyright (c) 2001 Datalight, Inc.
// Portions copyright (c) GPvNO 2001
// All Rights Reserved
// Datalight Confidential and Proprietary
//
// NOTE!!: USE THE MEDIUM MODEL!
//
// Revision History
// 11/01/2002 jmb original revision
//
//

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <dos.h>
#include "inetdefs.h"
#include "mbuf.h"
#include "iface.h"
#include "ip.h"
#include "modem.h"
#include "ser.h"
#include "ppp.h"
#include "_api.h"
#include "_capi.h"

#ifdef DL
#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "dosver.h"
#include "fatworld.h"
#define STACK	"Sockets"
#define OLD_BUILD "Sockets must be at least build 0530\n"
#else
#define STACK	"Rinet"
#define OLD_BUILD "Rinet must be at least version 2.18\n"
#endif


unsigned api_int;
unsigned api_intc;
char id[] = "Inet";
char id1[] = "RinetI";
unsigned tcbs;
unsigned iseg;

union REGS r;
struct SREGS sr;

char *ppszDhcpStates[] = {
	"Invalid",
	"BOOTP",
	"INIT",
	"SELECTING",
	"REQUESTING",
	"BOUND",
	"RENEWING",
	"REBINDING",
	"DECLINING",
	"INFORMING"
};

#define	O_VERSION   1
#define	O_RENEWING  2

int iOptions = O_VERSION;

#pragma argsused
main(int argc,char *argv[])
{
	void interrupt (*int_apiv)();
	IFACE far *pIface;
	VARBLOCK far *pstat;
	char far *pid;
	int i,api;
	char is_id;

	if (argc > 1)
   {
		iOptions = 0;
		for (i = 0;(is_id = argv[1][i]) != 0;++i) {
			switch (is_id  | ('a' - 'A')) {
			case 'r':
				iOptions |= O_RENEWING;
				break;
			case 'v':
				iOptions |= O_VERSION;
				break;
			default:
				printf("Usage:\ndhcpstat [r]\n"
						 "r force DHCP lease renewal.\n"
						 "v Version info\n");
				exit(1);
			}
		}
	}
	if (iOptions & O_VERSION) {
#ifndef DL
		printf("DHCPSTAT version 1.00, ");
#else
		printf("Datalight Sockets DHCPSTAT ");
		if (dlIsFat32World())
			printf("%s ", SHORTVERSION);
		else
			printf("%s ", SHORTVERSION622);
		printf("%s\n%s\nPortions copyright (c) GPvNO 2003\n%s\n\n",
			BUILDVERSION, COPYRIGHT, _BUILD_NUMBER);
#endif
	}
	for (api = 0x20;api < 0x100;++api) {
		int_apiv = getvect(api);
		if (int_apiv == 0)
			continue;
		pid = (char far *)int_apiv - 4;
		for (i = 0,is_id = 1;i < 4;++i) {
			if (pid[i] != id[i])
				is_id = 0;
		}
		if (is_id) {
			api_int = api;
		}
		pid = (char far *)int_apiv - 6;
		for (i = 0,is_id = 1;i < 6;++i) {
			if (pid[i] != id1[i])
				is_id = 0;
		}
		if (is_id) {
			api_intc = api;
		}
		if (api_int && api_intc)
			break;
	}
	if (api == 0x100) {
		printf(STACK" API not loaded\n");
		exit(1);
	}
	r.h.ah = GET_SOCKETS_VERSION;
	int86(api_intc,&r,&r);
	if (r.x.flags & 1) {
		printf(STACK" version too old\n");
		exit(1);
	}
	if (r.x.ax < (2 * 256 + 18)) {
		printf(OLD_BUILD);
		exit(1);
	}

	if (iOptions & O_VERSION) {
#ifdef DL
		printf("Sockets build %04u\n",r.x.ax);
#else
		printf("Rinet version %u.%02u\n",r.h.ah,r.h.al);
#endif
	}
	r.h.ah = API_GETVARPTR;
	int86(api_int,&r,&r);
	iseg = r.x.bx;
	pstat = MK_FP(iseg,r.x.cx);
	pIface = MK_FP(iseg,*(WORD far *)MK_FP(iseg,pstat->ppIface));
	while (FP_OFF(pIface)) 
   {
		printf("\nInterface name: %Fs\n",MK_FP(iseg,pIface->name));

		printf("IP address %s\n",inet_ntoa(pIface->ip_addr));
		printf("Net bits %d\n",pIface->netbits);
		printf("Net mask   %s\n",inet_ntoa(~((0x80000000L >> (pIface->netbits - 1)) - 1)));

		if (pIface->stat & IF_DISABLED)
      {
			printf("Disabled\n");
      }

		if (!pIface->dhcp_state) 
      {
         printf("This interface is not using DHCP or BOOTP\n");
      }
      else
      {
			BYTE bDhcpState = pIface->dhcp_state;
			if (bDhcpState == D_BOOTP)
				printf("Using BOOTP\n");
			else 
         {
				if (bDhcpState > D_INFORMING)
					bDhcpState = D_NONE;
				printf("DHCP state %s Retry %d ",ppszDhcpStates[bDhcpState],
															pIface->send_retry);
				switch(pIface->t1.state) 
            {
				   case TIMER_STOP:
					   printf("Timer stopped ");
					   break;
				   case TIMER_RUN:
					   printf("Timer running (%lu/%lu ms) ",
					   (long)MSPTICK * (pIface->t1.start - pIface->t1.count),
					   (long)MSPTICK * pIface->t1.start);
					   break;
				   case TIMER_EXPIRE:
					   printf("Timer expired ");
				}
				if (bDhcpState <= D_BOUND)
					printf("Lease %lu s\n",pIface->renew +
										(pIface->rebind + pIface->lease) / 1000);
				else
					printf("Renew %lu s\n",pIface->renew);

            if (iOptions & O_RENEWING)
            {
               printf("** forcing lease renewal!\n");
               pIface->t1.count = 1;
            }
			}
		}
		pIface = MK_FP(iseg,pIface->next);
	}
	return 0;
}
/* Convert an internet address (in host byte order) to a dotted decimal ascii
 * string, e.g., 255.255.255.255\0
 */
char *inet_ntoa(DWORD a)
{
	static char buf[16];

	sprintf(buf,"%u.%u.%u.%u",
		(BYTE)hibyte(hiword(a)),
		(BYTE)lobyte(hiword(a)),
		(BYTE)hibyte(loword(a)),
		(BYTE)lobyte(loword(a)));
	return buf;
}
