//
//   $Id: FINDFTPS.C 1.2 2002/10/16 17:46:04Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
// Program to find resident FTPD

#include <dos.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
// To create ftpsig.h, run: ftpd /l
#include "ftpsig.h"

#define DOSINT 0x21

/* ------- test to see if the program is already resident
		if found, return data segment ---------- */

typedef struct mcb_s {
	char id;
	unsigned psp;
	unsigned len;
	char junk[3];
	char name[8];
} MCB;

char signature[] = "InetFTPServer";



unsigned wSignatureSegment = SIGSEG;	// _DS - _psp
unsigned wSignatureOffset = SIGOFF;  // FP_OFF(signature)

int main(void)
{
	MCB far * pmcb;
	unsigned mcbseg;

	_AH = 0x52;
	geninterrupt(DOSINT);
	mcbseg = _ES;
	mcbseg = peek(mcbseg, _BX - 2);
	pmcb = MK_FP(mcbseg,0);
	while (1) {
		if (pmcb->id == 'Z') {
			printf("FTPD version "VERSION" not resident\n");
			exit(1);
			return 1;
		}
		else if (pmcb->id == 'M') {
			if (pmcb->psp && pmcb->psp != _psp &&
						_fstrcmp(signature,MK_FP(pmcb->psp + wSignatureSegment,
												wSignatureOffset)) == 0) {
				printf("FTPD version "VERSION" is resident\n");
				exit(0);
			}
		}
		else {
			printf("DOS memory corruption\n");
			exit(2);
		}
		FP_SEG(pmcb) += pmcb->len + 1;
	}
}
