//
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
// FTPAPI.C
// Copyright (c) 2001 Datalight, Inc.
// Portions copyright (c) GPvNO 2001
// All Rights Reserved
// Datalight Confidential and Proprietary
//
// Sockets FTP API
//
// Revision History
// 01/05/2002 gvn Startup message for non Datalight version
// 09/19/2001 pb  added code to handle the /p (port number) switch.
// 05/30/2001 jmb added code to check the FTPAPI interrupt vector
//                for use by another application or a previous
//                instance of FTPAPI when the vector returns non-zero.
//                Also added a /o commandline parameter to override
//                the save and overwrite the current interrupt vector
//                if it is set and it is not a previous instance of
//                FTPAPI.
// 04/30/2001 jmb used ROMDOS version number and copyright info.
// 04/30/2001 jmb created header
//
//

#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <process.h>
#include <time.h>
#include <alloc.h>
#include <ctype.h>
#include <string.h>
#include "inetdefs.h"

#ifdef DL
#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "dosver.h"
#include "fatworld.h"
#endif

#include "compiler.h"
#include "api.h"
#include "ftpapi.h"
#include "htapic.h"
#include "httftps.h"

#ifndef DL
#define ENVAR "INET"
#define USERPASS "inet.upw"
#define HOSTNAME "Inet"
#define DIRECTORY "\\inet"
#else
#define ENVAR "SOCKETS"
#define USERPASS "socket.upw"
#define HOSTNAME "Sockets"
#define DIRECTORY "\\dl\\sockets"
#endif

// 2.12 00-03-03 do not enable interrupts if called with ints disabled

char version[] = "2.13";
unsigned numcon;		// number of connections
unsigned tcbs;
unsigned s_tcbo;
char *pszHostname;
char *pszUserfile;
void close_all(void);
char must_schedule;
int bPassive = 1;

TCP_OP_P op = {0,0,FTP_PORT,TCP_SERVER,0,0,0,FtpControlStateChange,0,0};

unsigned api_int;
unsigned api_intc;
void interrupt (*old_api)();
void interrupt (*old_apic)();
void Psocket(char *str,ISOCKET far *s);
void interrupt (*old_ftpapiv)();

unsigned iNumcon;		// number of connections
unsigned iMaxNumcon;	//maximum number of connections

char id[] = "Inet";
char id1[] = "RinetI";

int maxmem = 0x8000;
char monflag;		// monitor flag
char monfunc = 0x40;
unsigned vidseg = 0xb800;
unsigned dseg;

main(int argc,char *argv[])
{
	int arg,api;
	void interrupt (*int_apiv)();
	unsigned errcode,i;
	char far *pid;
	char *pinet,*cp;
	char is_id;
	char status_flag = 0;
	union REGS r;
	char override_flag = 0;

#ifndef DL
	printf("Resident FTP Services ver %s\n",version);
#else
	printf("Datalight Sockets Resident FTP Services ");
	if (dlIsFat32World())
		printf("%s ", SHORTVERSION);
	else
		printf("%s ", SHORTVERSION622);
	printf("%s\n%s\nPortions copyright (c) GPvNO 2003\n%s\n\n",
		BUILDVERSION, COPYRIGHT, _BUILD_NUMBER);
#endif

	// searching for sockets kernel
	for (api = 0x20;api < 0x100;++api) {
		int_apiv = getvect(api);
		if (int_apiv == 0)
			continue;
		pid = (char far *)int_apiv - 4;
		for (i = 0,is_id = 1;i < 4;++i) {
			if (pid[i] != id[i])
				is_id = 0;
		}
		if (is_id) {
			api_int = api;
			old_api = int_apiv;
		}
		pid = (char far *)int_apiv - 6;
		for (i = 0,is_id = 1;i < 6;++i) {
			if (pid[i] != id1[i])
				is_id = 0;
		}
		if (is_id) {
			api_intc = api;
			old_apic = int_apiv;
		}
		if (api_int && api_intc)
			break;
	}
	if (api == 0x100) {
		printf(HOSTNAME" API not loaded\n");
		exit(1);
	}
	for (arg = 1;arg < argc;++arg) {
		if (argv[arg][0] == '/') {
			char *parg = argv[arg] + (argv[arg][2] == '=' ? 3 : 2);
			switch (tolower(argv[arg][1])) {
				case 'c':
					status_flag |= XSF_STOP_LISTEN;
					break;
				case 'm':
					maxmem = atoi(parg);
					break;
				case 'n':
					iMaxNumcon = atoi(parg);
					break;
				case 'o':
				   // override the current interrupt vector
					override_flag = 1;
					break;
				case 's':
					status_flag |= XSF_STATUS;
					break;
				case 'u':
					status_flag |= XSF_UNLOAD;
					break;
				case 'p':
					op.wLocPort = atoi(parg);
					break;
            case 'v':
					bPassive = 0;
			}
		}
		else
			op.wLocPort = atoi(argv[arg]);
	}
	dseg = resident();
	if (status_flag) {
		if (!dseg) {
			printf("Not resident\n");
			exit(1);
		}
		r.h.ah = CallResident;
		r.h.al = status_flag;
		int86(FTP_INT,&r,&r);
		return 0;
	}
	if (dseg) {
		r.h.ah = 0xff;
		r.h.al = 0;
		int86(FTP_INT, &r, &r);
		if (r.x.ax == FERR_UNKNOWN_CALL)
		{
			printf("Already resident at %04X\n",dseg);
			return 0;
		}
		// specified vector is in use - don't override if not forced.
		else if (!override_flag)
		{
			printf("Interrupt vector is in use - cannot load.\n");
			return 0;
		}
		
		// specified vector is in use - tell user we are overriding current value
		else
			printf("Overriding current interrupt vector value!\n");
	}

	// save old FTPAPI interrupt vector
	old_ftpapiv = getvect(FTP_INT);

	if ((pinet = getenv(ENVAR)) == 0)
		pinet = DIRECTORY;
	while (*(cp = pinet + strlen(pinet) - 1) == '\\')
		*cp = 0;
	if ((pszUserfile = malloc(strlen(pinet) + sizeof(USERPASS) + 3)) == 0)
		exit(3);
	sprintf(pszUserfile, "%s\\"USERPASS, pinet);
	if ((pszHostname = getenv("HOSTNAME")) == 0)
		pszHostname = HOSTNAME;
	printf("Starting LISTEN on port %u\n",op.wLocPort);
	r.x.cx = FP_OFF(&op);
	r.x.bx = FP_SEG(&op);
	r.h.ah = API_TCPOPEN;
	int86(api_int,&r,&r);
	errcode = r.x.ax;
	s_tcbo = r.x.cx;
	tcbs = r.x.bx;
	if (s_tcbo == 0) {
		printf("Error on TCP_OPEN: %s\n",err(errcode));
		exit(1);
	}
	_AH = 15;
	geninterrupt(0x10);
	if (_AL == 7)
		vidseg = 0xb000;
	printf("Going resident\n");
	resinit();
	return 0;
}

void close_all()
{
	CloseTcp(s_tcbo);
	DelTcp(s_tcbo);
	s_tcbo = 0;
	schedule();
	while (ftps) {
		ftp_delete(ftps,ftps->id);
		schedule();
	}
}

void schedule()
{
	struct ftp *ftp;
	union REGS r;

	r.h.ah = API_NOOP;	/* keep INET/Sockets alive */
	int86(api_int,&r,&r);
	FtpControlStateChangeHandler();
	for (ftp = ftps;ftp && !ftp->status;ftp = ftp->next) {
		FtpDataReceiveHandler(ftp);
		if (ftp->status)
			break;
		FtpDataTransmitHandler(ftp);
		if (ftp->status)
			break;
		if (ftp->flags & FF_CLIENT) {
			ftp_client(ftp);
		}
		else {
			FtpControlReceiveHandler(ftp);
		}
	}
}

int SendTcp(unsigned tcbo,char *buf,int cnt)
{
	union REGS r;

	r.x.si = FP_OFF(buf);
	r.x.dx = FP_SEG(buf);
	r.x.cx = cnt;
	r.x.bx = tcbo;
	r.h.ah = API_TCPWRITE;
	r.h.al = 0;
	int86(api_int,&r,&r);
	if (r.x.ax)
		return -r.x.ax;
	return r.x.cx;
}

int common_tcp(unsigned tcbo,char function)
{
	union REGS r;

	r.x.bx = tcbo;
	r.h.ah = function;
	int86(api_int,&r,&r);
	return -r.x.ax;
}

void CloseTcp(unsigned tcbo)
{
	common_tcp(tcbo,API_TCPCLOSE);
}

void ResetTcp(unsigned tcbo)
{
	common_tcp(tcbo,API_TCPRESET);
	common_tcp(tcbo,API_TCPDELET);
}

void DelTcp(unsigned tcbo)
{
	common_tcp(tcbo,API_TCPDELET);
}

TCB far *GetTcb(WORD handle)
{
	if (tcbs == 4)
		return (TCB far *)MK_FP(handle,4);
	else
		return (TCB far *)MK_FP(tcbs,handle);
}


WORD OpenTcpC(
struct isocket *lsocket,	/* Local socket */
struct isocket *fsocket,	/* Remote socket */
int mode,					/* Active/passive/server */
WORD window,				/* Receive window (and send buffer) sizes */
void (far *r_upcall)(	/*WORD handle,WORD cnt*/),	/* Function to call when data arrives */
void (far *t_upcall)(),	/* Function to call when ok to send more data */
void (far *s_upcall)(	/*WORD control,char old,char new*/),	/* Function to call when connection state changes */
char tos,
char *user)					/* User linkage area */
{
	TCP_OP_P op;
	union REGS r;

	if (fsocket) {
		op.wRemPort = fsocket->wPort;
		op.dwRemIPAd = fsocket->dwAddress;
	}
	else {
		op.wRemPort = 0;
		op.dwRemIPAd = 0;
	}
	op.wLocPort = lsocket->wPort;
	op.wMode = mode;		/* active/passive/server */
	op.wWindow = window;	/* window size (0 for default) */
	op.pRcvUpcall = r_upcall;
	op.pSndUpcall = t_upcall;
	op.pStcUpcall = s_upcall;
	op.pUser = (WORD)user;	/* user id field in TCB */
	op.cTos = tos;		/* type of service to use (normally 0) */
	r.x.cx = FP_OFF(&op);
	r.x.bx = FP_SEG(&op);
	r.h.ah = API_TCPOPEN;
	int86(api_int,&r,&r);
	lsocket->wPort = op.wLocPort;
	tcbs = r.x.bx;
	if (r.x.cx == 0) {
		return -r.x.ax;
	}
	return r.x.cx;
}

unsigned OpenTcp(struct ftp *ftp,char mode)
{
	static TCP_OP_P op = {0,0,FTPD_PORT,TCP_ACTIVE};
	TCB far *tcb;
	char str[80];
	union REGS r;

	op.dwRemIPAd = ftp->port.dwAddress;
	op.wRemPort = ftp->port.wPort;
	op.wLocPort = FTPD_PORT;
	op.wMode = TCP_ACTIVE;
	op.pUser = (WORD)ftp;
	if (mode == 3) {
		op.dwRemIPAd = 0;
		op.wRemPort = 0;
		op.wLocPort = 0;
		op.wMode = TCP_PASSIVE;
	}
	r.x.cx = FP_OFF(&op);
	r.x.bx = FP_SEG(&op);
	r.h.ah = API_TCPOPEN;
	int86(api_int,&r,&r);
	if (mode == 3) {
		tcb = (TCB far *)MK_FP(tcbs,ftp->control);
		ftp->port.dwAddress = tcb->conn.sLocal.dwAddress;
		ftp->port.wPort = op.wLocPort;
		sprintf(str,"227 Entering Passive Mode (%u,%u,%u,%u,%u,%u)\r\n",
			((char *)&ftp->port.dwAddress)[3],
			((char *)&ftp->port.dwAddress)[2],
			((char *)&ftp->port.dwAddress)[1],
			((char *)&ftp->port.dwAddress)[0],
			((char *)&ftp->port.wPort)[1],
			((char *)&ftp->port.wPort)[0]);
		Tprintf(ftp->control,str);
		ftp->flags |= FF_PASV;
	}
	return r.x.cx;
}

/*
 * Return: > 0: Actual read count
 *	      	 0: if peof contains value: eof
 *					 else Would Block received
 * 		  < 0: Error
 */
int RecvTcp(unsigned tcbo,char far *buf,int cnt,int *peof)
{
	union REGS r;
	int eof = 0;

	r.x.si = FP_OFF(buf);
	r.x.dx = FP_SEG(buf);
	r.x.cx = cnt;
	r.x.bx = tcbo;
	r.h.ah = API_TCPREAD;
	int86(api_int,&r,&r);
	if (r.x.ax != 0) {
		r.x.cx = 0;
		/*if (r.x.ax == RE_ENTER)
			set_schedule();			// read again ASAP
		else */if (r.x.ax != WOULDBLK)
			r.x.cx = -r.x.ax;
	}
	else if (r.x.cx == 0)
		eof = 1;
	if (peof)
		*peof = eof;
	return r.x.cx;
}

void Psocket(char *str,ISOCKET far *s)
{
	char ad[4];

	*((long *)ad) = s->dwAddress;
	sprintf(str,"%u.%u.%u.%u:%u",ad[3],ad[2],ad[1],ad[0],s->wPort);
}

void xstatus(int flags)
{
	if (flags & XSF_UNLOAD) {
		terminate(0);
		
		// restore interrupt vector
		setvect(FTP_INT, old_ftpapiv);

		return;
	}
	if (flags & XSF_STOP_LISTEN) {
		CloseTcp(s_tcbo);
		DelTcp(s_tcbo);
		s_tcbo = 0;
	}
	if (flags & XSF_STATUS)
		status(tcbs,s_tcbo);
}

char *ftp_state[] = {
	"COMMAND",
	"SENDING",
	"SENDING_WPOK",
	"SEND_RDY",
	"SENT",
	"LIST_WTOK",
	"LIST_WPOK",
	"LIST",
	"LIST_RDY",
	"LISTED_WTOK",
	"LISTED",
	"RECEIVING_WPOK",
	"RECEIVING",
	"RECV_RDY",
	"RECEIVED",
	"REPLY",
	"COMMAND_WTOK",
	"RCVLIST_WPOK",
	"RCVNLST_WPOK",
};


void status(WORD tcbs,WORD tcbo)
{
	struct heapinfo hi;
	unsigned blocks_free = 0,blocks_used = 0,bmem_free = 0,bmem_used = 0;
	struct ftp *ftp;
	TCB far *tcb;
	char rsock[30];

	static char states[] = "ClLiSySREsF1F2CWCgLATW";

	printf("Remote socket        TCP FTP state          Current directory\n");
	if (tcbo) {
		tcb = MK_FP(tcbs,tcbo);
		Psocket(rsock,&tcb->conn.sRemote);
		printf("%-22s%2.2s\n",rsock,states + 2 * tcb->state);
	}
	for (ftp = ftps;ftp;ftp = ftp->next) {
		char *log;

		tcb = MK_FP(tcbs,ftp->control);
		log = (ftp->flags & FF_CLIENT) ?
				"Client" : (ftp->cd == NULL || ftp->path == NULL) ?
				"Not logged in" : "Logged in";
		Psocket(rsock,&tcb->conn.sRemote);
		printf("%-22s%2.2s %-9s%-9s %-s\n",
				rsock,states + 2 * tcb->state,ftp_state[ftp->state],log,
				ftp->cd ? ftp->cd : "");
	}
	hi.ptr = NULL;

	while(heapwalk(&hi) == _HEAPOK) {
		if (hi.in_use) {
			bmem_used += hi.size;
			blocks_used++;
		}
		else {
			bmem_free += hi.size;
			blocks_free++;
		}
	}
	printf("Memory - Free: %u in %u blocks; Used: %u in %u blocks\n",
		bmem_free + coreleft(),blocks_free,bmem_used,blocks_used);
}

char *err(unsigned errcode)	/* return errorcode string */
{
	static char unk[30];
	static char *errs[] = {
		"No error",
		"Connection already exists",
		"Connection does not exist",
		"Connection closing",
		"No memory for TCB or buffer creation",
		"Would block",
		"Protocol or mode not supported",
		"Invalid arguments"
	};

	if (errcode > INVALID) {
		sprintf(unk,"Unknown error %u",errcode);
		return unk;
	}
	return errs[errcode];
}
