//
//   $Id: IFSTAT.C 1.12 2003/07/23 17:11:55Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
// IFSTAT.C
// Copyright (c) 2001 Datalight, Inc.
// Portions copyright (c) GPvNO 2001
// All Rights Reserved
// Datalight Confidential and Proprietary
//
// NOTE!!: USE THE MEDIUM MODEL!
//
// Revision History
// 01/04/2002 gvn fixed negative timer values being displayed
// 09/18/2001 gvn added options and DL/GPvNO messages
// 07/09/2001 jmb corrected spelling error in displayed message
// 05/02/2001 jmb displayed SOCKETS build number
// 04/30/2001 jmb used ROMDOS version number and copyright info.
// 04/30/2001 jmb created header
//
//

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <dos.h>
#include "inetdefs.h"
#include "mbuf.h"
#include "iface.h"
#include "ip.h"
#include "modem.h"
#include "ser.h"
#include "ppp.h"
#include "_api.h"
#include "_capi.h"

#ifdef DL
#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "dosver.h"
#include "fatworld.h"
#define STACK	"Sockets"
#define OLD_BUILD "Sockets must be at least build 0530\n"
#else
#define STACK	"Rinet"
#define OLD_BUILD "Rinet must be at least version 2.18\n"
#endif


unsigned api_int;
unsigned api_intc;
char id[] = "Inet";
char id1[] = "RinetI";
unsigned tcbs;
unsigned iseg;

union REGS r;
struct SREGS sr;
static int spot(WORD work,WORD want,WORD will,WORD mask);
static void genstat(PPP far *ppp_p);
static void lcpstat(FSM far *fsm_p);
static void papstat(FSM far *fsm_p);
static void ipcpstat(FSM far *fsm_p);
void PppShow(IFACE far *ifp);
void DialStatus(MODEMPAR far *pm);
void SerialStatus(SER far *serp);
void SlhcStatus(struct slcompress far *comp,int flag);
int Getch(void);

char *ppszDhcpStates[] = {
	"Invalid",
	"BOOTP",
	"INIT",
	"SELECTING",
	"REQUESTING",
	"BOUND",
	"RENEWING",
	"REBINDING",
	"DECLINING",
	"INFORMING"
};

#define	O_VERSION	1
#define	O_INTERFACE	2
#define	O_PPP			4
#define	O_SER			8
#define	O_MODEM		16

int iOptions = -1;

#pragma argsused
main(int argc,char *argv[])
{
	void interrupt (*int_apiv)();
	IFACE far *pIface;
	SER far *pSer;
	MODEMPAR far *pModem;
	VARBLOCK far *pstat;
	char far *pid;
	int i,api;
	char is_id;

	if (argc > 1) {
		iOptions = 0;
		for (i = 0;(is_id = argv[1][i]) != 0;++i) {
			switch (is_id  | ('a' - 'A')) {
			case 'i':
				iOptions |= O_INTERFACE;
				break;
			case 'm':
				iOptions |= O_MODEM;
				break;
			case 'p':
				iOptions |= O_PPP;
				break;
			case 's':
				iOptions |= O_SER;
				break;
			case 'v':
				iOptions |= O_VERSION;
				break;
			default:
				printf("Usage:\nifstat [i][m][p][s][v]\n"
						 "i Interface stats\n"
						 "m Modem stats\n"
						 "p PPP stats\n"
						 "v Version info\n");
				exit(1);
			}
		}
	}
	if (iOptions & O_VERSION) {
#ifndef DL
		printf("IFSTAT version 1.04, ");
#else
		printf("Datalight Sockets IFSTAT ");
		if (dlIsFat32World())
			printf("%s ", SHORTVERSION);
		else
			printf("%s ", SHORTVERSION622);
		printf("%s\n%s\nPortions copyright (c) GPvNO 2003\n%s\n\n",
			BUILDVERSION, COPYRIGHT, _BUILD_NUMBER);
#endif
	}
	for (api = 0x20;api < 0x100;++api) {
		int_apiv = getvect(api);
		if (int_apiv == 0)
			continue;
		pid = (char far *)int_apiv - 4;
		for (i = 0,is_id = 1;i < 4;++i) {
			if (pid[i] != id[i])
				is_id = 0;
		}
		if (is_id) {
			api_int = api;
		}
		pid = (char far *)int_apiv - 6;
		for (i = 0,is_id = 1;i < 6;++i) {
			if (pid[i] != id1[i])
				is_id = 0;
		}
		if (is_id) {
			api_intc = api;
		}
		if (api_int && api_intc)
			break;
	}
	if (api == 0x100) {
		printf(STACK" API not loaded\n");
		exit(1);
	}
	r.h.ah = GET_SOCKETS_VERSION;
	int86(api_intc,&r,&r);
	if (r.x.flags & 1) {
		printf(STACK" version too old\n");
		exit(1);
	}
	if (r.x.ax < (2 * 256 + 18)) {
		printf(OLD_BUILD);
		exit(1);
	}

	if (iOptions & O_VERSION) {
#ifdef DL
		printf("Sockets build %04u\n",r.x.ax);
#else
		printf("Rinet version %u.%02u\n",r.h.ah,r.h.al);
#endif
	}
	r.h.ah = API_GETVARPTR;
	int86(api_int,&r,&r);
	iseg = r.x.bx;
	pstat = MK_FP(iseg,r.x.cx);
	pIface = MK_FP(iseg,*(WORD far *)MK_FP(iseg,pstat->ppIface));
	while (FP_OFF(pIface)) {
		if (iOptions & O_INTERFACE) {
			printf("\nInterface name: %Fs\n",MK_FP(iseg,pIface->name));
			if (pIface->flags & (ETH_FLAG | TOKEN_FLAG)) {
				BYTE far *pcHwAddress = MK_FP(iseg,pIface->hwaddr);
				printf("%s address %02x:%02x:%02x:%02x:%02x:%02x\n",
							pIface->flags & ETH_FLAG ? "Ethernet" : "Token ring",
							pcHwAddress[0],pcHwAddress[1],pcHwAddress[2],
							pcHwAddress[3],pcHwAddress[4],pcHwAddress[5]);
			}
			printf("IP address %s\n",inet_ntoa(pIface->ip_addr));
			printf("Net bits %d\n",pIface->netbits);
			printf("Net mask   %s\n",inet_ntoa(~((0x80000000L >> (pIface->netbits - 1)) - 1)));
		}
		if (!(pIface->flags & (ETH_FLAG | TOKEN_FLAG))) {
			pSer = MK_FP(iseg,pIface->dcb);
			if (iOptions & O_SER)
				SerialStatus(pSer);
			if (pSer->pmpar) {
				pModem = MK_FP(iseg,pSer->pmpar);
				if (iOptions & O_MODEM)
					DialStatus(pModem);
			}
		}
		if ((pIface->flags & PPP_FLAG) && (iOptions & O_PPP)) {
			printf("PPP\n");
			PppShow(pIface);
		}
		if (pIface->stat & IF_DISABLED)
			printf("Disabled\n");
		if (pIface->dhcp_state) {
			BYTE bDhcpState = pIface->dhcp_state;
			if (bDhcpState == D_BOOTP)
				printf("Using BOOTP\n");
			else {
				if (bDhcpState > D_INFORMING)
					bDhcpState = D_NONE;
				printf("DHCP state %s Retry %d ",ppszDhcpStates[bDhcpState],
															pIface->send_retry);
				switch(pIface->t1.state) {
				case TIMER_STOP:
					printf("Timer stopped ");
					break;
				case TIMER_RUN:
					printf("Timer running (%lu/%lu ms) ",
					 (long)MSPTICK * (pIface->t1.start - pIface->t1.count),
					 (long)MSPTICK * pIface->t1.start);
					break;
				case TIMER_EXPIRE:
					printf("Timer expired ");
				}
				if (bDhcpState <= D_BOUND)
					printf("Lease %lu s\n",pIface->renew +
										(pIface->rebind + pIface->lease) / 1000);
				else
					printf("Renew %lu s\n",pIface->renew);
			}
		}
		pIface = MK_FP(iseg,pIface->next);
	}
	return 0;
}
/* Convert an internet address (in host byte order) to a dotted decimal ascii
 * string, e.g., 255.255.255.255\0
 */
char *inet_ntoa(DWORD a)
{
	static char buf[16];

	sprintf(buf,"%u.%u.%u.%u",
		(BYTE)hibyte(hiword(a)),
		(BYTE)lobyte(hiword(a)),
		(BYTE)hibyte(loword(a)),
		(BYTE)lobyte(loword(a)));
	return buf;
}
char *ostates[] = {		// Output states
	"IDLE","RAW","FSTART","DATA","FRESC","FREND","CRC1","CRC1ESC",
	"CRC1END","CRC2","CRC2ESC","CRC2END","END","FHDLC","HDLCDATA",
	"HDLCEND","HDLCCRC","HDLCEA","FCS1","FCS1ESC","FCS2","FCS2ESC",
	"MODEM"
};

char *istates[] = {		// Input states
	"RAW","DATA","ESC","IGN","DATAB","ESCB","IGNB","HDLC",
	"PPP","PPPESC","PPPIGN","MODEM"
};

void SerialStatus(SER far *serp)
{
	unsigned errtot;

	printf("Characters received: %lu  sent: %lu\n"
					"ostate '%s' istate '%s' flg: %02x %s%s%s%s%s\n",
				serp->rcvcount,serp->xmtcount,
				ostates[serp->ostate],
				istates[serp->istate],serp->flags,
				serp->flags & FL_IS16550A	? "FIFO " : "",
				serp->flags & FL_OFSTOPPED ? "OFC " : "",
				serp->flags & FL_IFSTOPPED ? "IFC " : "",
				serp->flags & FL_MODEM	   ? "MODEM " : "",
				serp->flags & FL_CONNECTED ? "CONNECTED" : "");
	if ((errtot = serp->overrun + serp->parerr + serp->frmerr +
				serp->brkerr + serp->buferr) != 0) {
		printf("Line errors: %u - Overrun: %u Parity: %u\n",
			errtot,serp->overrun,serp->parerr);
		printf("Framing: %u Break: %u Buffer: %u\n",
			serp->frmerr,serp->brkerr,serp->buferr);
	}
	if (serp->errors)
		printf("Serial errors: %u\n",serp->errors);
}

char far modem_states[] = {"IDLEINITDIALCONNANSWRCV XID"};
//							^	^	^	^	^	^	^
char far timer_states[] = {"IDLEWDCDWTO WRCVWXIDWADDPACE"};
//							^	^	^	^	^	^	^   ^

void DialStatus(MODEMPAR far *pm)
{
	if (!pm) {
		printf("No dial parameters\n");
		return;
	}
	printf("Dial state:%u %4.4Fs\n",pm->state,modem_states + 4 * pm->state);
	if (pm->timer.state == TIMER_RUN) {
		printf("Timer running (%ld/%ld ms)\n",
		 (long)MSPTICK * (pm->timer.start - pm->timer.count),
		 (long)MSPTICK * pm->timer.start);
		printf("Timer state:%u %4.4Fs\n",pm->tmstate,timer_states + 4 * pm->tmstate);
//		printf("Hangup time: %ld\n",(long)MSPTICK * pm->time);
	}
	printf("Flags %x %s%s%s\n",pm->flags,
				pm->flags & MF_INIT ? "Initialised " : "",
				pm->flags & MF_ACKSEEN ? "XID acked " : "",
				pm->flags & MF_DISCON ? "Disconnected" : "");
	printf("retry %u/%u\n",pm->retry,pm->retry_val);
	if (pm->dial && *pm->dial)
		printf("Current dial number %Fs\n",MK_FP(iseg,*pm->dial));
	if (pm->nextptr)
		printf("Next output: %-60.60Fs\n",MK_FP(iseg,pm->nextptr));
	if (pm->xchange)
		printf("XID: %Fs\n",MK_FP(iseg,pm->xchange));
}

static char *PPPStatus[] = {
	"Physical Line Dead",
	"Establishment Phase",
	"Authentication Phase",
	"Network Protocol Phase",
	"Termination Phase"
};

static char *NCPStatus[] = {
	"Closed",
	"Listening - waiting for request",
	"Starting configuration exchange",
	"Ack received; waiting for request",
	"Request ack'ed; waiting for ack",
	"Opened",
	"Terminate request sent"
};

void PppShow(IFACE far *ifp)
{
	register PPP far *ppp_p = MK_FP(iseg,ifp->prot_ext);

	genstat(ppp_p);
	if ( ppp_p->fsm[Lcp].pdv != NULL )
		lcpstat(MK_FP(iseg,&(ppp_p->fsm[Lcp])));
	if ( ppp_p->fsm[Ap].pdv != NULL )
		papstat(MK_FP(iseg,&(ppp_p->fsm[Ap])));
	if ( ppp_p->fsm[IPcp].pdv != NULL )
		ipcpstat(MK_FP(iseg,&(ppp_p->fsm[IPcp])));
}

static void genstat(register PPP far *ppp_p)
{
	FSM far *psFSM = MK_FP(iseg,&(ppp_p->fsm[Lcp]));

	printf("%s - %s\n", PPPStatus[ppp_p->phase],
			psFSM->pdv == psFSM->pdv_out ? "outgoing" : "incoming");
	if (ppp_p->flags & PPP_CBV)
		printf("Callback pending\n");
	if (ppp_p->flags & PPP_CBVCALL)
		printf("Callback in progress\n");

	printf("%10lu In,%11lu Flags,%6u ME, %6u FE, %7u CSE,%6u other\n",
		ppp_p->InRxOctetCount,
		ppp_p->InOpenFlag,
		ppp_p->InMemory,
		ppp_p->InFrame,
		ppp_p->InChecksum,
		ppp_p->InError);
	printf("\t\t%9u Lcp,%8u Ap, %6u IPcp,%6u Unknown\n",
		ppp_p->InNCP[Lcp],
		ppp_p->InNCP[Ap],
		ppp_p->InNCP[IPcp],
		ppp_p->InUnknown);
	printf("%10lu Out,%10lu Flags,%6u ME, %6u Fail\n",
		ppp_p->OutTxOctetCount,
		ppp_p->OutOpenFlag,
		ppp_p->OutMemory,
		ppp_p->OutError);
	printf("\t\t%9u Lcp,%8u Ap, %6u IPcp\n",
		ppp_p->OutNCP[Lcp],
		ppp_p->OutNCP[Ap],
		ppp_p->OutNCP[IPcp]);
}

static int spot(WORD work,WORD want,WORD will,WORD mask)
{
	char blot = ' ';
	int result = (work & mask);

	if ( !(will & mask) ) {
		blot = '*';
	} else if ( (want ^ work) & mask ) {
		blot = (result ? '+' : '-');
	}
	printf( "%c", blot );
	return result;
}

static void lcpstat(FSM far *fsm_p)
{
	LCP far *lcp_p = MK_FP(iseg,fsm_p->pdv);
	LCP_VALUE far *localp = MK_FP(iseg,&(lcp_p->local.work));
	WORD  localwork = lcp_p->local.work.negotiate;
	WORD  localwant = lcp_p->local.want.negotiate;
	WORD  localwill = lcp_p->local.will_negotiate;
	LCP_VALUE far *remotep = MK_FP(iseg,&(lcp_p->remote.work));
	WORD  remotework = lcp_p->remote.work.negotiate;
	WORD  remotewant = lcp_p->remote.want.negotiate;
	WORD  remotewill = lcp_p->remote.will_negotiate;

	printf("LCP %s, id %u\n",NCPStatus[fsm_p->state],fsm_p->lastid);

	printf("\t\t MRU\t  ACCM\t\t AP\t PFC  ACFC Magic\n");
	printf("\tLocal:\t");
	spot( localwork, localwant, localwill, LCP_N_MRU );
	printf( "%4d\t", localp->mru );
	spot( localwork, localwant, localwill, LCP_N_ACCM );
	printf( "0x%08lx\t", localp->accm );
	if ( spot( localwork, localwant, localwill, LCP_N_AUTHENT ) ) {
		switch ( localp->authentication ) {
		case PPP_PAP_PROTOCOL:
			printf( "Pap\t" );
			break;
		case PPP_CHAP_PROTOCOL:
			printf( "Chap\t" );
			break;
		default:
			printf( "0x%04x\t", localp->authentication);
			break;
		};
	} else {
		printf( "None\t" );
	}

	printf( spot( localwork, localwant, localwill, LCP_N_PFC )
		 ? "Yes " : "No  " );
	printf( spot( localwork, localwant, localwill, LCP_N_ACFC )
		 ? "Yes " : "No  " );

	spot( localwork, localwant, localwill, LCP_N_MAGIC );
	if ( localp->magic_number != 0L ) {
		printf( "0x%08lx\n", localp->magic_number );
	} else {
		printf( "unused\n" );
	}

	printf("\tRemote:\t");

	spot( remotework, remotewant, remotewill, LCP_N_MRU );
	printf( "%4d\t", remotep->mru );

	spot( remotework, remotewant, remotewill, LCP_N_ACCM );
	printf( "0x%08lx\t", remotep->accm );

	if ( spot( remotework, remotewant, remotewill, LCP_N_AUTHENT ) ) {
		switch ( remotep->authentication ) {
		case PPP_PAP_PROTOCOL:
			printf( "Pap\t" );
			break;
		case PPP_CHAP_PROTOCOL:
			printf( "Chap\t" );
			break;
		default:
			printf( "0x%04x\t", remotep->authentication);
			break;
		};
	} else {
		printf( "None\t" );
	}

	printf( spot( remotework, remotewant, remotewill, LCP_N_PFC )
		 ? "Yes " : "No  " );
	printf( spot( remotework, remotewant, remotewill, LCP_N_ACFC )
		 ? "Yes " : "No  " );

	spot( remotework, remotewant, remotewill, LCP_N_MAGIC );
	if ( remotep->magic_number != 0L ) {
		printf( "0x%08lx\n", remotep->magic_number );
	} else {
		printf( "unused\n" );
	}
}


static void papstat(FSM far *psFSM)
{
	AP far *pap_p = MK_FP(iseg,psFSM->pdv);

	printf("AP %s%s%s%s%s\n",
				psFSM->state & AP_OPENED ? "Opened " : "",
				psFSM->state & AP_REQUEST_SENT ? "REQUEST " : "",
				psFSM->state & AP_CHALLENGE_SENT ? "CHALLENGE " : "",
				psFSM->state & AP_RESPONSE_SENT ? "RESPONSE " : "",
				psFSM->state & (AP_REQUEST_SENT|AP_CHALLENGE_SENT|AP_RESPONSE_SENT) ? "sent" : "");

	printf( "\tMessage: '%Fs'\n", (pap_p->psApMessage == NULL) ?
		(char far *)"none" : MK_FP(iseg, pap_p->psApMessage ));
}

static void ipcpstat(FSM far *fsm_p)
{
	IPCP far *ipcp_p = MK_FP(iseg,fsm_p->pdv);
	IPCP_VALUE far *localp = MK_FP(iseg,&(ipcp_p->local.work));
	WORD  localwork = ipcp_p->local.work.negotiate;
	IPCP_VALUE far *remotep = MK_FP(iseg,&(ipcp_p->remote.work));
	WORD  remotework = ipcp_p->remote.work.negotiate;

	printf("IPCP %s, id %u\n",NCPStatus[fsm_p->state],fsm_p->lastid);
	printf("\tlocal IP address: %s",
		inet_ntoa(localp->dwLocalAddress));
	printf("  remote IP address: %s\n",
		inet_ntoa(remotep->dwLocalAddress));

	if (localwork & IPCP_N_COMPRESS) {
		printf("    In\tTCP header compression enabled:"
			" slots = %d, flag = 0x%02x\n",
			localp->slots,
			localp->slot_compress);
		SlhcStatus(MK_FP(iseg,ipcp_p->slhcp),1);
	}

	if (remotework & IPCP_N_COMPRESS) {
		printf("    Out\tTCP header compression enabled:"
			" slots = %d, flag = 0x%02x\n",
			remotep->slots,
			remotep->slot_compress);
		SlhcStatus(MK_FP(iseg,ipcp_p->slhcp),2);
	}
}

void SlhcStatus(struct slcompress far *comp,int flag)
{
	if (FP_OFF(comp) != 0) {
		if (flag & 1) {
			printf( "In - Comp: %lu "
				"Uncomp: %lu "
				"Bad: %lu "
				"Tossed: %lu\n",
				comp->sls_i_compressed,
				comp->sls_i_uncompressed,
				comp->sls_i_error,
				comp->sls_i_tossed);
		}
		if (flag & 2) {
			printf("Out - Comp: %lu "
				"Uncomp: %lu "
				"AsIs: %lu "
				"NotTCP: %lu\n",
				comp->sls_o_compressed,
				comp->sls_o_uncompressed,
				comp->sls_o_tcp,
				comp->sls_o_nontcp);
			printf("Searches: %lu "
				"Misses: %lu\n",
				comp->sls_o_searches,
				comp->sls_o_misses);
		}
	}
}

int Getch(void)
{
	_AX = 0x0700;        /* Console input (no echo)      */
	geninterrupt(0x21);
	_AH = 0;					/* Force it to be unsigned      */
	return _AX;
}

