//
//   $Id: IPSTAT.C 1.9 2003/09/06 02:45:36Z johnb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
// IPSTAT.C
// Copyright (c) 2001 Datalight, Inc.
// Portions copyright (c) GPvNO 2001
// All Rights Reserved
// Datalight Confidential and Proprietary
//
// NOTE!!  Use the MEDIUM MODEL.
//
// Revision History
// 09/18/2001 gvn added DL/GPvNO messages
// 07/23/2001 gvn dump allocation trace
// 04/30/2001 jmb used ROMDOS version number and copyright info.
// 04/30/2001 jmb created header
//
//

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <dos.h>
#include "inetdefs.h"
#include "ip.h"
#include "_api.h"
#include "_capi.h"

#ifdef DL
#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "dosver.h"
#include "fatworld.h"
#define STACK	"Sockets"
#else
#define STACK	"Rinet"
#endif

#define SMINBUILD 1419       		// Sockets minimum build
#define RMINBUILD (3 * 256 + 71)	// Rinet minimum build

void dumproute(void);
//ROUTE *routes[33][NROUTE];	/* Routing table */
ROUTE *(far *proutes)[33][NROUTE];	/* Routing table */

unsigned api_int;
unsigned api_intc;
char id[] = "Inet";
char id1[] = "RinetI";
unsigned tcbs;
unsigned iseg;

union REGS r;
struct SREGS sr;

typedef union header {
	struct {
		union header *ptr;
		unsigned size;
	} s;
	long len;
} HEADER;

#define HEADERSZ (sizeof(HEADER))

#define _DIST_ALLOC
#include "allocdef.h"

#pragma argsused
main(int argc,char *argv[])
{
	void interrupt (*int_apiv)();
	struct ip_stats far *pip;
	struct mem_stat far *pmem;
	VARBLOCK far *pstat;
	char far *pid;
	int i,api,size = 4;
	BYTE ip_addr[4],is_id;

#ifndef DL
	printf("IPSTAT version 2.01\n");
#else
	printf("Datalight Sockets IPSTAT ");
	if (dlIsFat32World())
		printf("%s ", SHORTVERSION);
	else
		printf("%s ", SHORTVERSION622);
	printf("%s\n%s\nPortions copyright (c) GPvNO 2003\n%s\n\n",
		BUILDVERSION, COPYRIGHT, _BUILD_NUMBER);
#endif
	for (api = 0x20;api < 0x100;++api) {
		int_apiv = getvect(api);
		if (int_apiv == 0)
			continue;
		pid = (char far *)int_apiv - 4;
		for (i = 0,is_id = 1;i < 4;++i) {
			if (pid[i] != id[i])
				is_id = 0;
		}
		if (is_id) {
			api_int = api;
		}
		pid = (char far *)int_apiv - 6;
		for (i = 0,is_id = 1;i < 6;++i) {
			if (pid[i] != id1[i])
				is_id = 0;
		}
		if (is_id) {
			api_intc = api;
		}
		if (api_int && api_intc)
			break;
	}
	if (api == 0x100) {
		printf(STACK" API not loaded\n");
		exit(1);
	}
	r.h.ah = GET_SOCKETS_VERSION;
	int86(api_intc,&r,&r);
	if (r.x.flags & 1) {
		printf(STACK" version too old\n");
		exit(1);
	}

	if (r.x.ax > 1200) {
		printf("Sockets build %04u\n",r.x.ax);
		if (r.x.ax < SMINBUILD) {
			printf("Sockets must be at least build %d\n",SMINBUILD);
			exit(1);
		}
	}
	else {
		printf("Rinet version %u.%02u\n",r.h.ah,r.h.al);
		if (r.x.ax < RMINBUILD) {
			printf("Rinet must be at least version %u.%u\n",
							RMINBUILD >> 8,RMINBUILD & 0xff);
			exit(1);
		}
	}
	if (argc > 2)
		printf("%s\n",argv[2]);
	sr.ds = FP_SEG(ip_addr);
	r.x.si = FP_OFF(ip_addr);
	sr.es = FP_SEG(&size);
	r.x.di = FP_OFF(&size);
	r.h.ah = GetKernelInfo;
	r.x.bx = 0;
	r.h.dh = K_INF_IP_ADDR;
	r.h.dl = 0;
	int86x(api_intc,&r,&r,&sr);
	printf("IP address %u.%u.%u.%u  ",ip_addr[0],ip_addr[1],
												ip_addr[2],ip_addr[3]);
	sr.ds = FP_SEG(ip_addr);
	r.x.si = FP_OFF(ip_addr);
	sr.es = FP_SEG(&size);
	r.x.di = FP_OFF(&size);
	r.h.ah = GetKernelInfo;
	r.x.bx = 0;
	r.h.dl = 0;
	r.h.dh = K_INF_SUBNET_MASK;
	int86x(api_intc,&r,&r,&sr);
	printf("Subnet mask: %u.%u.%u.%u\n",ip_addr[0],ip_addr[1],
												ip_addr[2],ip_addr[3]);
	r.h.ah = API_GETVARPTR;
	int86(api_int,&r,&r);
	iseg = r.x.bx;
	pstat = MK_FP(iseg,r.x.cx);
	pmem = MK_FP(iseg,pstat->memstat);
	pip = MK_FP(iseg,pstat->ipstat);
	proutes = MK_FP(iseg,pip->proutes);
	printf("Routing table:\n");
	dumproute();
	printf("IP stats at %Fp:\n",pip);
	printf(
		"Total packets          %10lu\n"
		"Smaller than minimum size   %5u\n"
		"IP header length too small  %5u\n"
		"Wrong IP version            %5u\n"
		"IP header checksum errors   %5u\n"
		"Unsupported protocol        %5u\n\n",
		pip->total,pip->runt,pip->length,
		pip->version,pip->checksum,pip->badproto);
	printf(
		"Memory available       %10lu\n"
		"Largest available block     %5d\n"
		"Memory allocation failures  %5u\n"
		"Memory free errors          %5u\n"
		"Minimum stack observed      %5d\n\n",
		pmem->mem_avail,pmem->wLargest,pmem->mem_fail,
		pmem->mem_free_err,pmem->stack_avail);
	if (argc > 1) {
		WORD wAd[500],wSize[500],wBase,wTotal = 0;
		HEADER far *pHeader;
		int iNum = 0;
		disable();		// don't get interrupted here
		pHeader = MK_FP(iseg,wBase = (WORD)pmem->pFreeChain);
		do {
			wSize[iNum] = pHeader->s.size * HEADERSZ;
			FP_OFF(pHeader) = wAd[iNum] = (WORD)pHeader->s.ptr;
		} while (++iNum < 500 && FP_OFF(pHeader) != wBase);
		enable();
		printf("Free chain:\n");
		for (i = 0;i < iNum;++i) {
			printf("%04x %5u\n",wAd[i],wSize[i]);
			wTotal += wSize[i];
		}
		printf("Total %5u\n",wTotal);
	}
	if (pmem->pwTraceBuf && argc > 1) {
		printf("pmem = %Fp,pwTraceBuf = %Fp\n",pmem,pmem->pwTraceBuf);
		for (i = 0;i < pmem->trace_index;++i) {
			if (pmem->pwTraceBuf[i].adr) {
				WORD wAd,wCheck;
				int iIndex;
				unsigned char far *pfcBuf = MK_FP(iseg,pmem->pwTraceBuf[i].adr);
				printf("%p %p %4u ",(wAd = pmem->pwTraceBuf[i].adr) + 4,
					wCheck = ((WORD far *)pfcBuf)[0],
					((WORD far *)pfcBuf)[1] * 4);
				iIndex = pmem->pwTraceBuf[i].id * 10;
				printf("%c %-10.10s",wAd == wCheck ? ' ' : '!',
						iIndex < sizeof(szAlloc) ? szAlloc + iIndex : "          ");
				for (iIndex = 4;iIndex < 20;++iIndex)
					printf(" %02x",pfcBuf[iIndex]);
				printf("\n");
			}
		}
		if ((argv[1][0] | ('c' - 'C')) == 'c')
			pmem->trace_index = 0;
	}
	printf("DOS compatible sockets %d Normal sockets %d\n",pstat->nndesc,pstat->ngdesc);
	return 0;
}
/* Convert an internet address (in host byte order) to a dotted decimal ascii
 * string, e.g., 255.255.255.255\0
 */
char *inet_ntoa(DWORD a)
{
	static char buf[16];

	sprintf(buf,"%u.%u.%u.%u",
		(BYTE)hibyte(hiword(a)),
		(BYTE)lobyte(hiword(a)),
		(BYTE)hibyte(loword(a)),
		(BYTE)lobyte(loword(a)));
	return buf;
}

void dumproute(void)
{
	register unsigned int i,bits;
	struct route far *rp;
	static char *class[] = {"Net A","Net B","Net C","Host"};

	printf("Destination     Class Interface    Gateway        Metric RIP time/flags\n");
	for (bits = 0;bits <= 32;bits++){
		for (i=0;i<NROUTE;i++) {
			for(rp = MK_FP(iseg,(WORD)(*proutes)[bits][i]);FP_OFF(rp);
								FP_OFF(rp) = (WORD)rp->next){
				if (bits) {
					printf("%-16s",inet_ntoa(rp->target));
					if (bits % 8)
						printf("Net%02d ",bits);
					else
						printf("%-6s",class[bits / 8 - 1]);
				}
				else
					printf("%-22s","Default");
				printf("%-13Fs",MK_FP(iseg,(WORD)
				(((IFACE far *)MK_FP(iseg,(WORD)rp->interface))->name)));
				printf("%-16s%5u ",rp->gateway ?
					inet_ntoa(rp->gateway) : "",rp->metric);
				if (rp->timer.start) {
					printf("%u ",
						(WORD)((rp->timer.count *
									(long)MSPTICK + 500) / 1000));
				}
				printf("%s%s%s%s\n",rp->stat & RT_PROXY ? "Proxy " : "",
								  rp->stat & RT_PRIVATE ? "Private " : "",
								  rp->stat & RT_TRIG ? "Trig " : "",
								  rp->stat & RT_STATIC ? "Static " : "");
			}
		}
	}
}

