#
#   $Id: sockdiag.mak 1.2 2003/02/21 00:59:14Z johnb Exp $
#
#   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
#
#   Copyright (c) 1993 - 2002 Datalight, Inc.
#   All Rights Reserved
#
#   Datalight, Inc. is a Washington corporation with an address at
#   21520 30TH DR SE MS110 Bothell, WA, 98021
#   Tel: 800.221.6630  Fax: 425.951.8091
#   Http://www.datalight.com
#
#   This software, including without limitation all source code and
#   documentation, is the confidential, trade secret property of
#   Datalight, Inc., and is protected under the copyright laws of
#   the United States and other jurisdictions. Portions of the
#   software may also be subject to one or more the following US
#   patents: US#5860082, US#6260156.
#
#   In addition to civil penalties for infringement of copyright
#   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
#   penalties for violation of (a) the restrictions on circumvention
#   of copyright protection systems found in 17 U.S.C. 1201 and
#   (b) the protections for the integrity of copyright management
#   information found in 17 U.S.C. 1202.
#
#   U.S. Government Restricted Rights. Use, duplication,
#   reproduction, or transfer of this commercial product and
#   accompanying documentation is restricted in accordance with
#   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
#
#   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
#   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
#   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
#   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
#   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
#   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
#   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
#   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
#   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
#   THIS SOFTWARE IN ERROR.
#
#
#   Revision History
#   01/07/2003 jmb original revision
#
.AUTODEPEND

all:	sockdiag
	@if exist ..\sockdiag.exe del ..\sockdiag.exe >nul
	@if exist ..\sockdiag.c   del ..\sockdiag.c >nul
	@if exist ..\sockdiag.pt   del ..\sockdiag.pt >nul
	@copy sockdiag.exe ..\sockdiag.exe >nul
	@copy sockdiag.c ..\sockdiag.c >nul
	@copy sockdiag.pt ..\sockdiag.pt >nul

clean:
	@echo Cleaning SOCKDIAG
	@if exist *.cfg del *.cfg >nul
	@if exist *.obj del *.obj >nul
	@if exist *.map del *.map >nul
	@if exist *.pt  del *.pt  >nul

cleanall: clean
	@if exist *.exe del *.exe >nul

#
# Borland C++ tools
#
CC  = Bcc
TLINK   = TLink


#
# Options
#

LFLAGS = $(RD_SW_L) -c -Tde -x

CFLAGS = $(RD_SW) -I..\..\include; -P- -c -ml
STARTUP= c0m.obj
LIBS   = emu.lib+mathl.lib+noehl.lib+cl.lib+..\..\LIB\socketl.lib+..\..\LIB\capil.lib

#
# Dependency List
#
sockdiag : sockdiag.cfg sockdiag.exe

sockdiag.exe : sockdiag.obj
  @$(TLINK)  /v $(LFLAGS) @&&|
	$(STARTUP)+sockdiag.obj
	$<,$*
	$(LIBS)
|

sockdiag.obj :  sockdiag.c

.c.obj:
  @proto $*.c >$&.pt
  @$(CC) @sockdiag.cfg @&&|
	$(CFLAGS) $*.c
|

# Compiler configuration file
sockdiag.cfg :
   copy &&|
-vi				# control expansion of inline funcs
-ml				# medium memory model
-f				   # enable floating point
-x-				# disable exception handling
-xp-				# disable exception location info
-xd-				# disable destructor cleanup
-xc-				# disable compatible exception
-xf-				# disable fast exception prologs
-RT-				# disable runtime type info
-C				   # enable nested comments
-1-				# compile 8086 instructions
| .\$@


