//
//   $Id: CACHE.H 1.13 2002/10/16 21:38:52Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*

	CACHE.H
	Created 06-30-2001  by Keith Garvin

	Provides public APIs and types to the disk cache.

	Copyright (c) 2001-2002 Datalight, Inc.
	All rights reserved.
	Confidential and Proprietary

*/

//  DEBUG ONLY - Count the number of read and write requests
//
#define COUNT_READS_AND_WRITES			FALSE


//  DEBUG ONLY - Determine if we are validating the "sort" inside cache
//
#define CHECK_COMMIT_OF_LOCALBUFFER		FALSE


//  DEBUG ONLY - Determine whether we are sending the device
//  request information to the comm port for logging purposes
//
#define COMM_PORT_LOGGING					FALSE


//  DEBUG ONLY - Determine if we are validating the "sort" inside cache
//
#define ENABLE_CHECK_SORT					FALSE


//  EXPERIMENTAL - Determine if we should make a runtime decision to
//  perform read ahead
//
#define CONDITIONAL_READAHEAD				FALSE


//  EXPERIMENTAL - Determine if we are aligning elements and clusters
//
#define CLUSTER_ALIGNMENT					FALSE


#if ENABLE_CHECK_SORT
#define CHECK_SORT()	CheckSort( __FILENUM__, __LINE__ )
#else
#define CHECK_SORT()
#endif


//  This macro is used to determine if a buffer address is in
//  the local buffer but may not be the starting point of the
//
#define IS_LOCALBUFFER(buffer) ( (((ulong)(buffer)) >= (ulong)(lprucLocalBuffer)) && (((ulong)(buffer)) < ((ulong)(lprucLocalBuffer) + uXmsCacheElementSize)))


/*
	Used in the register call to record information
	regarding cached disks.
*/
typedef struct _tageDiskInfo
{
	bool fValid;
	unsigned uSectorShiftValue;
	unsigned uDataOffset;
} DISK_INFO;

bool PASCAL InitializeDiskCache(unsigned uNumberOfElements,
				unsigned uElementSize, unsigned uBufferSize);
void PASCAL DeinitializeDiskCache(void);
bool PASCAL RegisterDiskInformation(unsigned uDisk, unsigned uSectorSize,
				unsigned uDataAlignmentOffset );
void PASCAL InvalidateDiskCache(unsigned uDisk);
bool PASCAL FlushDiskCache(unsigned uDisk);
bool PASCAL FlushOneCacheElement(void);

unsigned PASCAL CacheReadWrite(bool fRead, unsigned uDisk, ulong ulStartSector,
			unsigned uNumberOfSectors, void far * pvData, bool fCacheWrite,
			unsigned * puSectorsReadWritten );

//  --- External APIs ---

/*
	External prototype provided by the caller and which
	handles all disk input and output.
*/

/*
	Used for the disk access function
	FIXME: Need to reflect some type of real failure code to DOS
*/
#define IO_SUCCESS 0X00
#define IO_FAILURE 0X0C

unsigned PASCAL DiskReadWrite(bool fRead, unsigned uDisk, ulong ulStartSector,
			unsigned uNumberOfSectors, void far * pvData,
			unsigned * puSectorsRead );


#if TESTING
bool PASCAL TestCache(void);
#endif
