//
//   $Id: COMPARSE.C 1.4 2002/10/16 21:38:52Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//  COMPARSE.C
//
//  Copyright (c) 2001-2002 Datalight, Inc.
//  All Rights Reserved.
//  Datalight Confidential and Proprietary
//
//  HISTORY:
//
//  09-28-2001  bt  Created
//


//  Borland libraries
//
#include "stdio.h"
#include "string.h"
#include "mem.h"


//  Datalight libraries
//
#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "dldosio.h"
#include "dllfn.h"
#include "dlapp.h"
#include "windows.h"
#include "fatworld.h"
#include "dosver.h"
#include "bldver.h"


//  Local includes
//
#include "comparse.h"


//  Prototypes
//
#include "comparse.pt"


//  Variables
//
bool fIsFat32World;
bool fSwitches[MAX_BOOLEAN_SWITCHES];
int iInputHandle;
int iOutputHandle;
uchar ucMaxDrive;
ulong ulMaxSector[26];
unsigned uMaxSectorCount[26];


//  Program starts here
//
uchar main( int argc, char * argv[] )
{
	uchar ucExitCode = ERR_NONE;
	char szOutput[240];
	bool fIsRead = TRUE;
	uchar ucDrive = 0;
	ulong ulSector = 0;
	unsigned uSectorCount = 0;
	bool fSuccessful = TRUE;
	char * szInput;
	unsigned uDriveIndex;


	//  Determine if we are operating in a DOS 7.1 enviornment
	//
	fIsFat32World = dlIsFat32World();


	//  Parse the command line
	//
	DoParseCommandLine( argc-1, &argv[1] );


	//  Determine if we should display the signon message and if
	//  so display it
	//
	DisplaySignonMessage();


	//  Create the starting brace in the output file
	//
	sprintf( szOutput, "{\r" );
	WriteOutput( szOutput );


	//  Add the variable declarations to the output file
	//
	sprintf( szOutput, "\tbool fIsRead = TRUE;\r" );
	strcat( szOutput, "\tuchar ucDrive = 0;\r" );
	strcat( szOutput, "\tulong ulSector = 0;\r" );
	strcat( szOutput, "\tunsigned uSectorCount = 0;\r\r" );
	WriteOutput( szOutput );


	while( TRUE )
	{
		//  Get the next line from the input file
		//
		szInput = GetSourceLine();
//		printf( "%s\n", szInput );
		if( *szInput == 0 )
		{
			break;
		}


		//  Parse the line
		//
		fSuccessful = ProcessLine( szInput, &fIsRead, &ucDrive, &ulSector,
				&uSectorCount );
		if( !fSuccessful )
		{
			break;
		}



		//  Format the read/write condition variable
		//
		sprintf( szOutput, "\r\tfIsRead = ");
		if( fIsRead )
		{
			strcat( szOutput, "TRUE;\r" );
		}
		else
		{
			strcat( szOutput, "FALSE;\r" );
		}
		WriteOutput( szOutput );


		//  Format the drive number variable
		//
		sprintf( szOutput, "\tucDrive = 0x%x;\r", (unsigned)ucDrive );
		WriteOutput( szOutput );


		//  Format the sector number variable
		//
		sprintf( szOutput, "\tulSector = 0x%lx;\r", ulSector );
		WriteOutput( szOutput );


		//  Format the sector count variable
		//
		sprintf( szOutput, "\tuSectorCount = 0x%x;\r", uSectorCount );
		WriteOutput( szOutput );


		//  Format the test case function call
		//
		sprintf( szOutput, "\tTestSectors( fIsRead, ucDrive, ulSector, uSectorCount, FALSE );\r" );
		WriteOutput( szOutput );
	}


	//  Create the closing brace in the output file
	//
	sprintf( szOutput, "}\r" );
	WriteOutput( szOutput );


	printf( "Max drive: %xh\n", (unsigned)ucMaxDrive );
	for( uDriveIndex = 0; uDriveIndex < 26; uDriveIndex++ )
	{
		if( uMaxSectorCount[uDriveIndex] )
		{
			printf( "Max sector number on drive %xh: %lxh\n", uDriveIndex,
					ulMaxSector[uDriveIndex] );
			printf( "Max sector count on drive %xh:  %xh\n", uDriveIndex,
					uMaxSectorCount[uDriveIndex] );
		}
	}


	//  Terminate
	//
	return ucExitCode;
}


bool ProcessLine( char * szLine, bool * pfIsRead, uchar * pucDrive,
		ulong * pulSector, unsigned * puSectorCount )
{
	int iResult;
	ulong ulValue;


	//  Set the read write flag
	//
	if( (szLine[0] != 'C') && (szLine[0] != 'H') )
	{
		printf("Error processing line\n");
		exit(1);
	}
	szLine++;
	if( szLine[0] == 'R' )
	{
		*pfIsRead = TRUE;
	}
	else if( szLine[0] == 'W' )
	{
		*pfIsRead = FALSE;
	}
	else
	{
		printf("Error processing line\n");
		exit(1);
	}
	szLine++;
	szLine = LFNSkipWhite( szLine );


	//  Skip the drive label
	//
	iResult = memcmp( szLine, "Drv: ", 5 );
	if( iResult != 0 )
	{
		printf("Error processing line\n");
		exit(1);
	}
	szLine += 5;
	szLine = GetHexValue( szLine, &ulValue );
	if( *szLine != 'h' )
	{
		printf("Error processing line\n");
		exit(1);
	}
	szLine++;
	szLine = LFNSkipWhite( szLine );
	if( ulValue > 255 )
	{
		printf("Error processing line\n");
		exit(1);
	}
	*pucDrive = (uchar)ulValue;
	if( *pucDrive > ucMaxDrive )
	{
		ucMaxDrive = *pucDrive;
	}


	//  Skip the sector label
	//
	iResult = memcmp( szLine, "Sec: ", 5 );
	if( iResult != 0 )
	{
		printf("Error processing line\n");
		exit(1);
	}
	szLine += 5;
	szLine = GetHexValue( szLine, &ulValue );
	if( *szLine != 'h' )
	{
		printf("Error processing line\n");
		exit(1);
	}
	szLine++;
	szLine = LFNSkipWhite( szLine );
	*pulSector = ulValue;
	if( *pulSector > ulMaxSector[*pucDrive] )
	{
		ulMaxSector[*pucDrive] = *pulSector;
	}


	//  Skip the count label
	//
	iResult = memcmp( szLine, "Cnt: ", 5 );
	if( iResult != 0 )
	{
		printf("Error processing line\n");
		exit(1);
	}
	szLine += 5;
	szLine = GetHexValue( szLine, &ulValue );
	if( *szLine != 'h' )
	{
		printf("Error processing line\n");
		exit(1);
	}
	szLine++;
	szLine = LFNSkipWhite( szLine );
	if( ulValue & 0xffff0000 )
	{
		printf("Error processing line\n");
		exit(1);
	}
	*puSectorCount = (unsigned)ulValue;
	if( *puSectorCount > uMaxSectorCount[*pucDrive] )
	{
		uMaxSectorCount[*pucDrive] = *puSectorCount;
	}


	if( *szLine != 0 )
	{
		printf("Error processing line\n");
		exit(1);
	}

	return TRUE;
}


char * GetHexValue( char * szLine, ulong * pulValue )
{
	unsigned uIndex;
	char cByte;
	ulong ulValue = 0;


	for( uIndex = 0; uIndex < 8; uIndex++ )
	{
		cByte = toupper( *szLine );

		if( (cByte >= '0') && (cByte <= '9') )
		{
			ulValue <<= 4;
			ulValue += cByte - '0';
		}
		else if( (cByte >= 'A') && (cByte <= 'F') )
		{
			ulValue <<= 4;
			ulValue += cByte - 'A' + 10;
		}
		else
		{
			break;
		}


		szLine++;
	}


	*pulValue = ulValue;
	return szLine;
}


char * PASCAL GetSourceLine( void )
{
	bool fSuccessful;
	unsigned uBytesRead;
	static char szInputLine[240];
	static unsigned uCharactersInBuffer = 0;
	static unsigned uCharactersInLastLine = 0;
	char * szCR;


	//  Move all the data remaining in the buffer forward
	//  past the "last" line found
	//
	uCharactersInBuffer -= uCharactersInLastLine;
	memmove( &szInputLine[0], &szInputLine[uCharactersInLastLine],
			uCharactersInBuffer );


	//  Fill up the buffer
	//
	uBytesRead = sizeof(szInputLine) - uCharactersInBuffer;
	fSuccessful = dlReadFile( iInputHandle, &uBytesRead,
			&szInputLine[uCharactersInBuffer] );
	if( !fSuccessful )
	{
		printf("Error reading input file\n" );
		exit(1);
	}
	uCharactersInBuffer += uBytesRead;


	//  Determine if there are any characters left in the buffer
	//
	uCharactersInLastLine = 0;
	if( uCharactersInBuffer == 0 )
	{
		*szInputLine = 0;
	}
	else
	{
		//  Terminate the string at the first CR
		//
		szCR = memchr( szInputLine, 0x0d, uCharactersInBuffer );
		if( szCR == NULL )
		{
			printf("Error finding the end of the string\n");
			exit(1);
		}
		*szCR = 0;
		if( szCR[1] == 0x0a )
		{
			szCR++;
		}
		*szCR = 0;
		uCharactersInLastLine = szCR - szInputLine;
		uCharactersInLastLine++;
	}


	//  Return the address of the line
	//
	return szInputLine;
}


//  Write a string to the output file
//
void PASCAL WriteOutput( char * szOutput )
{
	unsigned uOutputSize;
	unsigned uBytesWritten;
	bool fSuccessful;


	//  Determine the number of bytes in the output string
	//
	uOutputSize = strlen( szOutput );


	//  Write the output string to the output file
	//
	uBytesWritten = uOutputSize;
	fSuccessful = dlWriteFile( iOutputHandle, &uBytesWritten,
			szOutput );
	if( (!fSuccessful) || (uBytesWritten != uOutputSize) )
	{
		printf("Error writing to output file\n");
		exit(1);
	}
}


//  Parse the command line
//
void PASCAL DoParseCommandLine( int argc, char *argv[] )
{
	int iActionTaken;
	bool fSuccessful;
	static ARGDEF ProgramOpts[] =
	{
		{ BOOL_SWITCH, &fSwitches[HIDE_SIGNON],            '[', 0 }, //  0
		{ 0 }
	};


	//  Parse the switches
	//
	SetParseFlags(PARSEF_NOARGSOK);
	argc = ParseCmdline(argc, &argv[0], ProgramOpts);


	//  There must be one and only one argument remaining
	//
	if( argc < 1 )
	{
		printf("Insufficient command line options\n");
		exit(1);
	}
	else if( argc > 2 )
	{
		OptError( argv[2] );
		exit(1);
	}


	//  Open the file to be parsed
	//
	fSuccessful = SmartCreateOpenFile( OPEN_ACCESS_READONLY, A_NORMAL,
			FILE_OPEN, argv[0], &iInputHandle, &iActionTaken);
	if( !fSuccessful )
	{
		printf( "Unable to open file: %s\n", argv[0] );
		exit(1);
	}


	//  Create the outputfile
	//
	fSuccessful = SmartCreateOpenFile( OPEN_ACCESS_READWRITE, A_NORMAL,
			FILE_CREATE | FILE_TRUNCATE, argv[1], &iOutputHandle,
			&iActionTaken);
	if( !fSuccessful )
	{
		printf( "Unable to create file: %s\n", argv[1] );
		exit(1);
	}
}


//  Show the usage for a bad command line parameter
//
void OptError(char * szMsg)
{
	unsigned uIndex = 0;
	extern char szInvalidSwitch[];


	while( (szMsg[uIndex] != ' ') && (szMsg[uIndex] != 0) )
	{
		if( szMsg[uIndex] == '/' )
		{
			uIndex++;
			if( szMsg[uIndex] != 0 )
			{
				uIndex++;
			}
			break;
		}
		uIndex++;
	}
	szMsg[uIndex] = 0;

	printf( "Invalid option : %s\n", szMsg );
	exit(1);
}


//  Display the usage screen
//
void Usage( void )
{
	char szUsage[] =
	"COMPARSE inputefile outputfile\n"
	"\n"
	"inputfile   The name of the file to parse\n"
	"outputfile  The name of the file to ouput\n"
	"";


	fSwitches[HIDE_SIGNON] = 0;
	DisplaySignonMessage();
	printf( szUsage );
	exit(1);
}


//  Determine if we should display the signon message and if
//  so display it
//
void DisplaySignonMessage( void )
{
	char * szSignOnMessage = "COMPARSE %s %s\n%s\n\n";

	if( !DoHideSignon() )
	{
		if( fIsFat32World )
		{
			printf(szSignOnMessage,SHORTVERSION,BUILDVERSION,COPYRIGHT);
		}
		else
		{
			printf(szSignOnMessage,SHORTVERSION622,BUILDVERSION,COPYRIGHT);
		}
	}
}
