;
;   $Id: DEVICE.INC 1.2 2002/10/16 21:39:42Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;



;  DEVICE HEADER
;  Description: The beginning of a valid device driver
;
;  Reference: Adv MS-DOS, p 264  -or-  DOS Ref, p 340
;
;  Device Attribute Char:
;  1xxx xxxx xxxx xxxx    Character Device (1=char)
;  x1xx xxxx xxxx xxxx    IOCTL (4402H-4405H)
;  xx1x xxxx xxxx xxxx    Output Until Busy
;  xxxx 1xxx xxxx xxxx    Open/Close
;  xxxx xxxx 1xxx xxxx    Query IOCTL (4410H)
;  xxxx xxxx x1xx xxxx    Generic IOCTL (440CH)
;  xxxx xxxx xxx1 xxxx    FAST I/O (INT 29H)
;  xxxx xxxx xxxx 1xxx    Clock Device
;  xxxx xxxx xxxx x1xx    NUL Device
;  xxxx xxxx xxxx xx1x    Stdout Device
;  xxxx xxxx xxxx xxx1    Stdin Device
;
;  Device Attribute Disk:
;  0xxx xxxx xxxx xxxx    Disk Device (0=disk)
;  x1xx xxxx xxxx xxxx    IOCTL (4402H-4405H)
;  xx1x xxxx xxxx xxxx    IBM block format (0=FAT, 1=scratch?)
;  xxx1 xxxx xxxx xxxx    Network device??
;  xxxx 1xxx xxxx xxxx    Removable Media (4408H)
;  xxxx xxxx 1xxx xxxx    Query IOCTL (4411H)
;  xxxx xxxx x1xx xxxx    Generic IOCTL (440DH)
;  xxxx xxxx xxxx xx1x    Driver Supports 32 bit sectors
;
DeviceHeader struc
    DEV_next		dd	?	; 00 ptr to next device
    DEV_attr		dw	?	; 04 attribute of device
    DEV_strategy	dw	?	; 06 ptr to strat routine
    DEV_service		dw	?	; 08 ptr to serv routine
    DEV_name		db    8 dup (?)	; 0A name of char device
DeviceHeader ends


;  DEVICE REQUEST HEADER
;  Description: Passed to a device (a device call)
;
;  Device Commands
;     0   Init
;     1   Media Check
;     2   Build BPB
;     3   IOCTL Read        (bit 14 required)
;     4   Read
;     5   Nondestructive Read
;     6   Input Status
;     7   Input Flush
;     8   Write
;     9   Write w/ Verify
;    0A   Output Status
;    0B   Output Flush
;    0C   IOCTL Write       (bit 14 required)
;    0D   Device Open       (bit 11 required)
;    0E   Device Close      (bit 11 required)
;    0F   Disk Removable?   (bit 11 required)
;    10   Output Until Busy (bit 13 required)
;    13   Generic IOCTL     (bit  6 required)
;
;  Device Status
;  15           9 8 7             0
;  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
;  |E|         |B|D|               |
;  |r|         |u|o|               |
;  |r|         |s|n|               |
;  | |         |y|e|               |
;  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
;
;  Reference: Adv MS-DOS, p 265  -or-  DOS Ref, p 345
;
DeviceRequestHeader     struc
    RQHDR_length	db	?	; 00 length of the command
    RQHDR_unit		db	?	; 01 unit # for disk access
    RQHDR_command	db	?	; 02 the command itself
    RQHDR_status   	dw	?	; 03 returned status
    RQHDR_reserved 	db   8 dup (?)	; 05
    RQHDR_media		db	?	; 0D media ID for disks
    RQHDR_trans		dd	?	; 0E data transfer buffer
    RQHDR_count		dw	?	; 12 length of data
    RQHDR_start		dw	?	; 14 starting sector for data
    RQHDR_drive		db	?	; 16 starting drive #
    RQHDR_res2		db   3 dup (?)	; 17
    RQHDR_start32	dd	?	; 1A long starting sector
DeviceRequestHeader	ends


