;
;   $Id: cad.asm 1.8 2003/01/31 18:50:58Z thomd Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
; DEFINTR.ASM
; Interrupt handlers for the Datalight disk DEFRAGmentation utility.
;
; Copyright (c) 1989-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary
;
;
;
include datalght.inc

InitModel small, pascal, use16

.data?
	; see comments for yield() in DEFERR.C
	;
		public _abortingBecause
	_abortingBecause	dw	?


	extrn	_fInCache:word

.data

	extrn	_lpLocalStack:dword


; The exit code we'll generate when a trapped <Ctrl><Alt><Del>
; exits the program
;
EL_CTRL_ALT_DEL =	10


; Segment used to address BIOS data area
;
ABS_DATA	segment at 0h

; BIT values for <Ctrl><Alt><Del> keystroke
;
CTRL_SHIFT	=	4
ALT_SHIFT	=	8
DEL_SCAN_CODE	=	83

	; the BIOS keyboard shift state flag
	;
	org	417h
kbd_shift_flag	db	?

ABS_DATA	ends



.Code
	assume cs:@curseg, ds:DGROUP,  es:nothing, ss:nothing

	extrn	FlushAllBuffers:proc

	public old_int15_handler
old_int15_handler	label	dword
    old_int15_off	dw      0
    old_int15_seg	dw	0

	public	trappingCtrlAltDel
trappingCtrlAltDel	db	0


COMMENT ~ ;prototype;
void PASCAL InstallCtrlAltDelHandler(void)
~
ProcBegin	InstallCtrlAltDelHandler, public
ProcUses	es,di
ProcSetup

	xor	ax, ax
	mov	es, ax
	mov	di, 15h*4
	mov	ax, offset int15_handler
	mov	dx, cs

	cli
	xchg	ax, es:[di]
	xchg	dx, es:[di][2]
	mov	cs:old_int15_off, ax
	mov	cs:old_int15_seg, dx
	sti

	mov	cs:trappingCtrlAltDel, 1

ProcEnd


COMMENT ~ ;prototype;
void RemoveCtrlAltDelHandler(void)
~
ProcBegin	RemoveCtrlAltDelHandler,c, public
ProcUses	es,di
ProcSetup

	mov	cs:trappingCtrlAltDel, 0

	xor	ax, ax
	mov	es, ax
	mov	di, 15h*4
	mov	ax, cs:old_int15_off
	mov	dx, cs:old_int15_seg

	cli
	mov	es:[di], ax
	mov	es:[di][2], dx
	sti
ProcEnd


ASSUME	ds:NOTHING

COMMENT ~ ;prototype;
void PASCAL PassOnCtrlAltDel(void)
~
ProcBegin	PassOnCtrlAltDel, public
ProcSetup
	mov	cs:trappingCtrlAltDel, 0
ProcEnd


ASSUME	ds:NOTHING

COMMENT ~ ;prototype;
void PASCAL TrapCtrlAltDel(void)
~
ProcBegin	TrapCtrlAltDel, public
ProcSetup
	mov	cs:trappingCtrlAltDel, 1
ProcEnd


ASSUME	ds:NOTHING

comment ~
void PASCAL RebootTheMachine(void)
end_comment ~
ProcBegin	RebootTheMachine, public
ProcSetup

	;
	; jump to FFFF:0
	;


	;  Clear the flag indicating that we filtering int 15h
	;
	call	PassOnCtrlAltDel


	;  Call the previous int 15h handler with the
	;  control alt delete notification
	;
	xor	ax, ax
	mov	ds, ax

	assume  ds:ABS_DATA

	or	[kbd_shift_flag], (CTRL_SHIFT or ALT_SHIFT)
	mov	ax, 4F53h
	stc
	int	15h


	; !!!
	;
	; Don't let anybody back out. We got our orders...
	;
	xor	ax, ax
	dec	ax
	push	ax
	inc	ax
	push	ax
	retf
ProcEnd


ASSUME	ds:NOTHING


COMMENT ~ ;prototype;
void _interrupt int15_handler(void)
~
	public int15_handler
int15_handler	proc

	pushf

	cmp	cs:trappingCtrlAltDel, 0
	je	int15_continue

	cmp	ah, 4Fh
	jne	int15_continue

	cmp	cs:_abortingBecause, 0
	jne	IgnoreAllKeypresses

	cmp	al, DEL_SCAN_CODE
	jne	int15_continue

	push	ax
	push	ds

	xor	ax, ax
	mov	ds, ax

	ASSUME	ds:ABS_DATA

	mov	al, kbd_shift_flag
	and	al, (CTRL_SHIFT OR ALT_SHIFT)
	cmp	al, (CTRL_SHIFT OR ALT_SHIFT)
    	jnz	int15_not_ctrl_alt_del

	mov	ax, DGROUP
	mov	ds, ax

	ASSUME	ds:DGROUP


	; Set our exit reason flag
	;
	mov	_abortingBecause, EL_CTRL_ALT_DEL


	;  Determine if we are inside the cache now
	;
	cmp	_fInCache, 0
	jne	ReturnToInt9



	public	__FlushAndReboot
    __FlushAndReboot:

	;  Issue the EOI
	;
	mov	al, 20h
	out	20h, al



	;  Flush the cache
	;
	mov	ax, DGROUP
	mov	ds, ax
	mov	ss, word ptr ds:_lpLocalStack+2
	mov	sp, word ptr ds:_lpLocalStack

	mov   cs:_fInCache, 1                   ; fInCache
	call    FlushAllBuffers


	;  Reboot the machine
	;
	jmp	RebootTheMachine


	;
	;  Clear the call and return to the int 9 handler
	;

    ReturnToInt9:

	xor	ax, ax
	mov	ds, ax

	ASSUME	ds:ABS_DATA

	; <Ctrl><Alt><Del> found, unshift the keyboard
	; turn off <Ctrl><Alt> shift state
	;
	and	kbd_shift_flag, NOT(CTRL_SHIFT OR ALT_SHIFT)

	pop	ds
	pop	ax

	ASSUME 	ds:nothing

    IgnoreAllKeypresses:
	popf
	clc
	retf	2


	;
	;  Pass on the call to the previous int 15h handler
	;

    int15_not_ctrl_alt_del:
	pop	ds
	pop	ax

	ASSUME 	ds:nothing

    int15_continue:
	popf
	jmp	dword ptr cs:old_int15_handler

int15_handler	endp

@curseg	ends
	end
