;
;   $Id: device.asm 1.9 2002/10/16 21:39:42Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
;  DEVICE.ASM
;
;  Copyright (c) 2001-2002 Datalight, Inc.
;  All Rights Reserved.
;  Datalight Confidential and Proprietary
;
;  History:
;
;  06-29-2001  bt  Created
;


include device.inc
include devhdr.inc


.model small


.data?


    ;  This is the stack that the handler switches to
    ;  to perform an int 2fh processing
    ;
    DeviceStack		dw	2048 dup(?)
	public	_DeviceStackTop
    _DeviceStackTop	label   word


    ;
    ;
	public	_fInCache
    _fInCache		dw	?



    extrn _abortingBecause:word


.data

    ;  For easy reference, save a local pointer to our device stack
    ;
	public	_lpDeviceStack
    _lpDeviceStack	label	dword
    DeviceStackSP	dw	_DeviceStackTop - 2
    DeviceStackSS	dw	@Data


    ;  DeviceCallersStack
    ;
    _lpDeviceCallersStack	label	dword
    DeviceCallersSP		dw	?
    DeviceCallersSS		dw	?


    ;  pointer to the previous FDHD handler
    ;
	public _lpOldStrategyFDHD
    _lpOldStrategyFDHD	dd	?
	public _lpOldServiceFDHD
    _lpOldServiceFDHD	dd	?


    ;  pointer to the previous CDEX handler
    ;
	public _lpOldStrategyCDEX
    _lpOldStrategyCDEX	dd	?
	public _lpOldServiceCDEX
    _lpOldServiceCDEX	dd	?


	public _lpPrevDeviceHandler
    _lpPrevDeviceHandler dd	?


    ;  pointer to the previous ATAPI Device handler
    ;
	public _lpATAPIDeviceHandler
    _lpATAPIDeviceHandler	label	dword
    ATAPIDeviceOffset	dw	?
    ATAPIDeviceSegment	dw	?


    	public	_lpFDHDHDR
    _lpFDHDHDR	label	dword
    uFDHDHDROffset	dw	LABEL_FDHDHDR
    uFDHDHDRSegment	dw	@Code


    	public	_lpCDEXHDR
    _lpCDEXHDR	label	dword
    uCDEXHDROffset	dw	LABEL_CDEXHDR
    uCDEXHDRSegment	dw	@Code


    ;
    ;
	public	_lpRequest
    _lpRequest		dd	?


    ;
    ;
	public	_fInDevice
    _fInDevice		dw	?


    ;
    ;
	public	_fInFDHD
    _fInFDHD		dw	?


    ;
    ;
	public	_fDeviceCallHandled
    _fDeviceCallHandled	dw	?

.code

	ASSUME	CS:@Code,DS:NOTHING

	extrn	_DeviceDispatch:proc
	extrn	__FlushAndReboot:proc


.186


; CDEX/ATAPI device header set at run time
;
LABEL_CDEXHDR:
CDEXHDR DeviceHeader <>


;  FDHD device header set at run time
;
LABEL_FDHDHDR:
_FDHDHDR DeviceHeader <>


;  Device Service routine
;
	public _DeviceService
_DeviceService:


EnterDispatcher:


	;  Set a flag indicating that we are in the cache
	;
	mov	cs:_fInCache, 1


	;  Save callers stack
	;
	mov	cs:DeviceCallersSS, ss
	mov	cs:DeviceCallersSP, sp


	;  Set our stack
	;
	mov	ss, word ptr cs:_lpDeviceStack+2
	mov	sp, word ptr cs:_lpDeviceStack


	;  Preserve all caller registers
	;
	pushf
	push	ax
	push	bx
	push	cx
	push	dx
	push	si
	push	di
	push	ds
	push	es


	;  Set our DS
	;
	push	ss
	pop	ds
	ASSUME	DS:@Data


	;  Set a flag indicating that the call has not
	;  been handled
	;
	mov	_fDeviceCallHandled, 0


	;  Call the dispatcher
	;
	call	_DeviceDispatch


	;  Restore all caller registers
	;
	pop	es
	pop	ds
	ASSUME	DS:NOTHING
	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	popf


	;  Restore callers stack
	;
	mov	ss, word ptr cs:_lpDeviceCallersStack+2
	mov	sp, word ptr cs:_lpDeviceCallersStack


	;  Clear the flag indicating that we are in FDHD
	;
	mov	cs:_fInFDHD, 0


	;  Clear the flag indicating that we are in the cache
	;
	mov	cs:_fInCache, 0


	;
	;
	cmp	cs:_abortingBecause, 0
	jnz	DoReboot


	;  Return to caller
	;
	retf


DoReboot:

	;  Flush and reboot
	;
	jmp	__FlushAndReboot


;  FDHD Strategy routine
;
	public _StrategyFDHD
_StrategyFDHD:

	mov	word ptr cs:_lpRequest, bx
	mov	word ptr cs:_lpRequest+2, es
	jmp	dword ptr cs:_lpOldStrategyFDHD


;  FDHD Service routine
;
	public _ServiceFDHD
_ServiceFDHD:

	push	ax
IF 0
	mov	al, es:[bx.RQHDR_command]
IF 0
	cmp	al, 03h
	jz	EnterDispatcher2
ENDIF
	cmp	al, 04h
	jz	EnterDispatcher2
	cmp	al, 08h
	jz	EnterDispatcher2
	cmp	al, 09h
	jz	EnterDispatcher2
IF 0
	cmp	al, 0ch
	jz	EnterDispatcher2
ENDIF
	cmp	al, 13h
	jz	EnterDispatcher2
	pop	ax
	jmp	dword ptr cs:_lpOldServiceFDHD

ENDIF ; IF 0

EnterDispatcher2:

	mov	ax, word ptr cs:_lpOldServiceFDHD
	mov	word ptr cs:_lpPrevDeviceHandler, ax
	mov	ax, word ptr cs:_lpOldServiceFDHD+2
	mov	word ptr cs:_lpPrevDeviceHandler+2, ax
	mov	cs:_fInFDHD, 1
	pop	ax

	jmp	_DeviceService


;  CDEX Strategy routine
;
	public _StrategyCDEX
_StrategyCDEX:

	mov	word ptr cs:_lpRequest, bx
	mov	word ptr cs:_lpRequest+2, es
	jmp	dword ptr cs:_lpOldStrategyCDEX


;  CDEX Service routine
;
	public _ServiceCDEX
_ServiceCDEX:

	push	ax
IF 0
	mov	al, es:[bx.RQHDR_command]

IF 0  ;  need this one for media change
	cmp	al, 03h
	jz	EnterDispatcher3
ENDIF
	cmp	al, 80h
	jz	EnterDispatcher3
	cmp	al, 86h
	jz	EnterDispatcher3
	cmp	al, 87h
	jz	EnterDispatcher3
	cmp	al, 7h
	jz	EnterDispatcher3
	cmp	al, 11h
	jz	EnterDispatcher3
	cmp	al, 12h
	jz	EnterDispatcher3
	pop	ax
	jmp	dword ptr cs:_lpOldServiceCDEX

ENDIF ; IF 0

EnterDispatcher3:

	mov	ax, word ptr cs:_lpOldServiceCDEX
	mov	word ptr cs:_lpPrevDeviceHandler, ax
	mov	ax, word ptr cs:_lpOldServiceCDEX+2
	mov	word ptr cs:_lpPrevDeviceHandler+2, ax
	mov	cs:_fInFDHD, 0
	pop	ax

	jmp	_DeviceService


	;  Do the previous handler
	;
	public _DoPreviousService
_DoPreviousService:
	push	bx
	les	bx, _lpRequest
	call	dword ptr _lpPrevDeviceHandler
	pop	bx
	ret


	END
