;
;   $Id: int13.asm 1.9 2002/10/16 21:39:42Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
;  INT13.ASM
;
;  Copyright (c) 2001-2002 Datalight, Inc.
;  All Rights Reserved.
;  Datalight Confidential and Proprietary
;
;  History:
;
;  06-29-2001  bt  Created
;



.model small


.data?


    extrn _fInCache:word

.data

    extrn _Dispatcher:word
    extrn _fInFDHD:word


    ;  For easy reference, save a local pointer to our INT 13h handler
    ;
	public _lpInt13Handler
    _lpInt13Handler	label	dword
    LocalInt13Offset	dw	_Int13Handler
    LocalInt13Segment	dw	@Code


    ;  pointer to the previous INT 13h handler
    ;
	public _lpOldInt13Handler
    _lpOldInt13Handler	label	dword
    OldInt13Offset	dw	_Int13Handler
    OldInt13Segment	dw	@Code


    ;  pointer to the previous int ?? handler (changes for different ints)
    ;
    extrn _lpOldHandler:dword


    fInt13Patched	dw	?

    extrn	_fInFDHD:word

.code

	ASSUME	CS:@Code,DS:NOTHING

	extrn	_Int13Dispatch:proc
	extrn	DoServiceCall:proc


.186


;  _INT13Handler
;
;  This handler gets called everytime that there is an INT 13h
;
comment ~
void INT13Handler( void )
{}
~
    public _INT13Handler
_INT13Handler:


	;  Make sure that we are not in the FDHD device which
	;  will need to make int 13 calls
	;
	cmp	cs:_fInCache, 0
	jz      DoInt13
	jmp	dword ptr cs:_lpOldInt13Handler


	;  Tell the dispatcher to use the int 13h dispatcher
	;
DoInt13:
	push	ax
	mov	ax, offset _Int13Dispatch
	mov	cs:_Dispatcher, ax
	mov	ax, word ptr cs:_lpOldInt13Handler
	mov	word ptr cs:_lpOldHandler, ax
	mov	ax, word ptr cs:_lpOldInt13Handler+2
	mov	word ptr cs:_lpOldHandler+2, ax
	pop	ax


	;  Jump to the dispatcher
	;
	jmp	DoServiceCall



;  InstallInt13Vector
;
;  Save the current int 13h vector and set the int 13h vector to
;  our handler
;
comment ~
void InstallInt13Vector( void )
{}
~
	ASSUME	DS:@Data
    public	_InstallInt13Vector
_InstallInt13Vector:


	;  Set ES:BX to the int 13h vector
	;
	xor	bx, bx
	mov	es, bx
	mov	bx, 13h * 4


	;  Save the current int 13h vector
	;
	pushf
	cli
	mov	ax, es:[bx]
	mov	OldInt13Offset, ax
	mov	ax, es:[bx+2]
	mov	OldInt13Segment, ax


	;  Set our int 13h vector
	;
	mov	ax, LocalInt13Offset
	mov	es:[bx], ax
	mov	ax, LocalInt13Segment
	mov	es:[bx+2], ax
	popf


	;  Set the flag indicating that the INT 13h interface
	;  has been patched
	;
	mov	fInt13Patched, 1


	;  All done, return
	;
	ret


	END
