;
;   $Id: int19.asm 1.3 2003/01/31 18:51:08Z thomd Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
;  Int19.ASM
;
;  Copyright (c) 2002 Datalight, Inc.
;  All Rights Reserved.
;  Datalight Confidential and Proprietary
;
;  History:
;
;  01-25-2001  bt  Created
;



.model small


.data?


    extrn _fInCache:word

    fInt19Patched	dw	?

.data

	extrn	_lpLocalStack:dword


    ;  For easy reference, save a local pointer to our INT 25h handler
    ;
	public _lpInt19Handler
    _lpInt19Handler	label	dword
    LocalInt19Offset	dw	_Int19Handler
    LocalInt19Segment	dw	@Code


    ;  pointer to the previous INT 21h handler
    ;
	public _lpOldInt19Handler
    _lpOldInt19Handler	label	dword
    OldInt19Offset	dw	_Int19Handler
    OldInt19Segment	dw	@Code


    ;  pointer to the previous int ?? handler (changes for different ints)
    ;
    extrn _lpOldHandler:dword


.code

	ASSUME	CS:@Code,DS:NOTHING

	extrn	FlushAllBuffers:proc
.186


;  _Int19Handler
;
;  This handler gets called everytime that there is an INT 21h
;
comment ~
void Int19Handler( void )
{}
~
    public _Int19Handler
_Int19Handler:

	;  Flush the cache
	;
	mov	ax, DGROUP
	mov	ds, ax

	ASSUME	DS:@Data

	mov	ss, word ptr ds:_lpLocalStack+2
	mov	sp, word ptr ds:_lpLocalStack

	mov   cs:_fInCache, 1                   ; fInCache
	call    FlushAllBuffers


	;  Call the previous handler
	;
	jmp	dword ptr cs:[_lpOldInt19Handler]



;  InstallInt19Vector
;
;  Save the current int 21h vector and set the int 21h vector to
;  our handler
;
comment ~
void InstallInt19Vector( void )
{}
~
	ASSUME	DS:@Data
    public	_InstallInt19Vector
_InstallInt19Vector:


	push	bx
	mov	ah, 35h
	mov	al, 19h
	int	21h
	mov	OldInt19Offset, bx
	mov	ds:OldInt19Segment, es
	pop	bx
	push	ds
	pushf
	cli
	mov	ah, 25h
	mov	al, 19h
	lds	dx, _lpInt19Handler
	int	21h
	popf
	pop	ds


	;  Set the flag indicating that the INT 21h interface
	;  has been patched
	;
	mov	fInt19Patched, 1


	;  All done, return
	;
	ret


	END
