;
;   $Id: sdreq.asm 1.4 2002/10/16 21:39:42Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;--------------------------------------------------------------------
; $DOCMODULE:SDREQ.ASM
;
; Copyright (c) 2001-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary.
;
; $DOCHISTORY
; 06-29-2001 bt  Created.
;--------------------------------------------------------------------

include datalght.inc

InitModel %MEMMODEL, pascal, use16


.code

IF 0

;--------------------------------------------------------------------
;
; GetHDRequestCounts
;
; INT 2fh ax=4a10h bx=FFFFh (RD ONLY)
;
;--------------------------------------------------------------------
COMMENT ~
bool PASCAL GetHDRequestCounts( ulong * pulHDReadRequests,
	ulong * pulHDWriteRequests )
{}
~
ProcBegin	GetHDRequestCounts,public
if @DataSize
ProcUses	ds,bx,si,di
else
ProcUses	bx,si,di
endif
ProcArgs	@@pulHDReadRequests:PTR,@@pulHDWriteRequests:PTR
ProcSetup

	mov	ax, 4a10h
	mov	bx, 0ffffh
	push	bp
	int	2fh
	pop	bp

	cmp	ax, 0babeh
	jnz	@@NotInstalled

	mov	ax, bx
	LPTR_DS	bx, @@pulHDReadRequests
	mov	[bx], ax
	mov	[bx+2], dx

	LPTR_DS	bx, @@pulHDWriteRequests
	mov	[bx], si
	mov	[bx+2], di

	mov	ax, 1
	jmp	short @@Done

    @@NotInstalled:

	xor	ax, ax

    @@done:

ProcEnd


;--------------------------------------------------------------------
;
; GetCDRequestCounts
;
; INT 2fh ax=4a10h bx=FFFEh (RD ONLY)
;
;--------------------------------------------------------------------
COMMENT ~
bool PASCAL GetCDRequestCounts( ulong * pulCDReadRequests,
	ulong * pulCDWriteRequests )
{}
~
ProcBegin	GetCDRequestCounts,public
if @DataSize
ProcUses	ds,bx,si,di
else
ProcUses	bx,si,di
endif
ProcArgs	@@pulCDReadRequests:PTR,@@pulCDWriteRequests:PTR
ProcSetup

	mov	ax, 4a10h
	mov	bx, 0fffeh
	push	bp
	int	2fh
	pop	bp

	cmp	ax, 0babeh
	jnz	@@NotInstalled

	mov	ax, bx
	LPTR_DS	bx, @@pulCDReadRequests
	mov	[bx], ax
	mov	[bx+2], dx

	LPTR_DS	bx, @@pulCDWriteRequests
	mov	[bx], si
	mov	[bx+2], di

	mov	ax, 1
	jmp	short @@Done

    @@NotInstalled:

	xor	ax, ax

    @@done:

ProcEnd

ENDIF

;--------------------------------------------------------------------
;
; CacheInstallCheckAndStats
;
; INT 2fh ax=4a10h bx=0000h
;
;--------------------------------------------------------------------
COMMENT ~
bool PASCAL CacheInstallCheckAndStats( ulong * pulCacheHits,
	ulong * pulCacheMisses )
{}
~
ProcBegin	CacheInstallCheckAndStats,public
if @DataSize
ProcUses	ds,bx,si,di
else
ProcUses	bx,si,di
endif
ProcArgs	@@pulCacheHits:PTR,@@pulCacheMisses:PTR
ProcSetup

	mov	ax, 4a10h
	mov	bx, 0000h
	push	bp
	int	2fh
	pop	bp

	cmp	ax, 0babeh
	jnz	@@NotInstalled

	mov	ax, bx
	LPTR_DS	bx, @@pulCacheHits
	mov	[bx], ax
	mov	[bx+2], dx

	LPTR_DS	bx, @@pulCacheMisses
	mov	[bx], si
	mov	[bx+2], di

	mov	ax, 1
	jmp	short @@Done

    @@NotInstalled:

	xor	ax, ax

    @@done:

ProcEnd


;--------------------------------------------------------------------
;
; CacheCommit
;
; INT 2fh ax=4a10h bx=0001h
;
;--------------------------------------------------------------------
COMMENT ~
void PASCAL CacheCommit( void )
{}
~
ProcBegin	CacheCommit,public
ProcSetup

	mov	ax, 4a10h
	mov	bx, 0001h
	int	2fh

ProcEnd


;--------------------------------------------------------------------
;
; CacheRestart
;
; INT 2fh ax=4a10h bx=0002h
;
;--------------------------------------------------------------------
COMMENT ~
void PASCAL CacheRestart( void )
{}
~
ProcBegin	CacheRestart,public
ProcSetup

	mov	ax, 4a10h
	mov	bx, 0002h
	int	2fh

ProcEnd


;--------------------------------------------------------------------
;
; CacheGetSetStatus
;
; INT 2fh ax=4a10h bx=0003h
;
;--------------------------------------------------------------------
COMMENT ~
void PASCAL CacheGetSetStatus( uchar ucDOSDriveNumber, uchar ucAction,
	uchar * pucStatusByte )
{}
~
ProcBegin	CacheGetSetStatus,public
if @DataSize
ProcUses	ds,bx,si,di
else
ProcUses	bx,si,di
endif
ProcArgs	@@ucDOSDriveNumber:byte,@@ucAction:byte,@@pucStatusByte:PTR
ProcSetup

	mov	ax, 4a10h
	mov	bx, 0003h
	mov	dl, @@ucAction
	xor	cx, cx
	mov	cl, @@ucDOSDriveNumber
	push	bp
	mov	bp, cx
	int	2fh
	pop	bp

	LPTR_DS	bx, @@pucStatusByte
	mov	[bx], dl

ProcEnd


;--------------------------------------------------------------------
;
; CacheGetSize
;
; INT 2fh ax=4a10h bx=0004h
;
;--------------------------------------------------------------------
COMMENT ~
void PASCAL CacheGetSize( unsigned * puElementsInCache,
	unsigned * puElementSize )
{}
~
ProcBegin	CacheGetSize,public
if @DataSize
ProcUses	ds,bx
else
ProcUses	bx
endif
ProcArgs	@@puElementsInCache:PTR,@@puElementSize:PTR
ProcSetup

	mov	ax, 4a10h
	mov	bx, 0004h
	int	2fh

	mov	dx, bx
	LPTR_DS	bx, @@puElementsInCache
	mov	[bx], ax

	LPTR_DS	bx, @@puElementSize
	mov	[bx], cx

ProcEnd


;--------------------------------------------------------------------
;
; CacheGetDoubleBufferStatus
;
; INT 2fh ax=4a10h bx=0005h
;
;--------------------------------------------------------------------
COMMENT ~
void PASCAL CacheGetDoubleBufferStatus( uchar ucDOSDriveNumber,
	uchar far * * plpucDoubleBufferList )
{}
~
ProcBegin	CacheGetDoubleBufferStatus,public
if @DataSize
ProcUses	ds,es,bx
else
ProcUses	es,bx
endif
ProcArgs	@@ucDOSDriveNumber:byte,@@plpucDoubleBufferList:PTR
ProcSetup

	mov	ax, 4a10h
	mov	bx, 0005h
	xor	cx, cx
	mov	cl, @@ucDOSDriveNumber
	push	bp
	mov	bp, cx
	int	2fh
	pop	bp

	LPTR_DS	bx, @@plpucDoubleBufferList

	cmp	ax, 0babeh
	jnz	@@ResultsValid

	xor	ax, ax
	mov	[bx], ax
	mov	[bx+2], ax
	jmp	short @@Done

    @@ResultsValid:
	mov	[bx], di
	mov	[bx+2], es

    @@Done:

ProcEnd


;--------------------------------------------------------------------
;
; CacheDriveCacheable
;
; INT 2fh ax=4a10h bx=0006h
;
;--------------------------------------------------------------------
COMMENT ~
bool PASCAL CacheDriveCacheable( uchar ucDOSDriveNumber )
{}
~
ProcBegin	CacheDriveCacheable,public
ProcArgs	@@ucDOSDriveNumber:byte
ProcSetup

	mov	ax, 4a10h
	mov	bx, 0006h
	xor	cx, cx
	mov	cl, @@ucDOSDriveNumber
	inc	cx
	int	2fh

	mov	bx, ax
	xor	ax, ax

	cmp	bx, 6
	jz	@@Done

	inc	ax

    @@Done:

ProcEnd


;--------------------------------------------------------------------
;
; CacheGetCommandFlushFlag
;
; INT 2fh ax=4a10h bx=0008h dl=01
;
;--------------------------------------------------------------------
COMMENT ~
void PASCAL CacheGetCommandFlushFlag( unsigned * puStatusWord )
{}
~
ProcBegin	CacheGetCommandFlushFlag,public
if @DataSize
ProcUses	ds,bx
else
ProcUses	bx
endif
ProcArgs	@@puStatusWord:PTR
ProcSetup

	mov	ax, 4a10h
	mov	bx, 0008h
	mov	dx, 1
	push	bp
	int	2fh
	pop	bp

	LPTR_DS	bx, @@puStatusWord
	mov	[bx], dx

ProcEnd


;--------------------------------------------------------------------
;
; CacheSetCommandFlushFlag
;
; INT 2fh ax=4a10h bx=0008h dl=02
;
;--------------------------------------------------------------------
COMMENT ~
void PASCAL CacheSetCommandFlushFlag( uchar ucStatusByte )
{}
~
ProcBegin	CacheSetCommandFlushFlag,public
if @DataSize
ProcUses	ds
endif
ProcArgs	@@ucStatusByte:byte
ProcSetup

	mov	ax, 4a10h
	mov	bx, 0008h
	mov	dl, 2
	mov	dh, @@ucStatusByte
	int	2fh

ProcEnd


	end
