//
//   $Id: CHKINT.C 1.6 2002/10/16 21:40:24Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//  CHKINT.C
//
//  Copyright (c) 2000-2002 Datalight, Inc.
//  All Rights Reserved.
//  Datalight Confidential and Proprietary
//
//  This module contains the interrrupt handlers for chkdsk
//
//  HISTORY:
//
//  03-15-2000  bt  Created (Started over from scratch)
//  03-23-1989  Drew Gislason (created old chkdsk)
//


#define __FILENUMBER__		3


//  Borland libraries
//
#include "dir.h"
#include "stdio.h"
#include "stdlib.h"
#include "ctype.h"
#include "mem.h"
#include "string.h"


//  Datalight libraries
//
#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "dldosio.h"


//  Chkdsk header files
//
#include "chkdsk.h"
#include "chkasert.h"


//  Prototypes
//
#include "chkdsk.pt"


//  Variables
//
bool fInt23Occured = FALSE;
extern char szUserAbort[];


//  Set our interrupt handlers
//
void SetInterruptHandlers( void )
{
	//  Install a control break handler so that we can abort cleanly
	//  if the user presses CTRL-C
	//
	InstallCTRLCHandler();


	//  Install a critical error handler so that we can abort cleanly
	//
	InstallInt24Handler();
}


//  Restore interrupt vectors
//
void RestoreInterruptVectors( void )
{
	//  Uninstall the critical error handler
	//
	UninstallInt24Handler();


	//  Uninstall the control break handler
	//
	UninstallCTRLCHandler();
}


//  Int 23 handler
//
#pragma argsused
 void interrupt far Int23Handler(BP, DI, SI, DS, ES, DX, CX, BX, AX,
		IP, CS, FLAGS)
{
	fInt23Occured = TRUE;
}


//  Install a control break handler so that we can abort cleanly if
//  the user presses CTRL-C
//
void InstallCTRLCHandler( void )
{
	void far * far * lplpOldCtrlCHandler;

	lplpOldCtrlCHandler = MK_FP( 0, 0x23*4 );
	SaveOldCtrlCHandler( *lplpOldCtrlCHandler );
	*lplpOldCtrlCHandler = (void far *)Int23Handler;
}


//  Uninstall the control break handler
//
void UninstallCTRLCHandler( void )
{
	void far * far * lplpOldCtrlCHandler;

	lplpOldCtrlCHandler = MK_FP( 0, 0x23*4 );
	*lplpOldCtrlCHandler = GetOldCtrlCHandler();
}


//  Return the address of the old control break handler
//
void far * GetOldCtrlCHandler( void )
{
	void far * * plpOldCtrlCHandler;

	plpOldCtrlCHandler = GetOldCtrlCHandlerAddress();
	return *plpOldCtrlCHandler;
}


//  Save the address of the old control break handler
//
void SaveOldCtrlCHandler( void far * lpOldCtrlCHandler )
{
	void far * * plpOldCtrlCHandler;

	plpOldCtrlCHandler = GetOldCtrlCHandlerAddress();
	*plpOldCtrlCHandler = lpOldCtrlCHandler;
}


//  Return the address of the variable which contain the old control
//  break handler
//
void far * * GetOldCtrlCHandlerAddress( void )
{
	static void far * lpOldCtrlCHandler;

	return &lpOldCtrlCHandler;
}


//  Int 24 handler
//
#pragma argsused
 void interrupt far Int24Handler(BP, DI, SI, DS, ES, DX, CX, BX, AX,
		IP, CS, FLAGS)
{
	(uchar)AX = 3;
}


//  Install a critical error handler so that we can abort cleanly
//
void InstallInt24Handler( void )
{
	void far * far * lplpOldCritHandler;


	lplpOldCritHandler = MK_FP( 0, 0x24*4 );
	SaveOldCritHandler( *lplpOldCritHandler );
	*lplpOldCritHandler = (void far *)Int24Handler;
}


//  Uninstall the critical error handler
//
void UninstallInt24Handler( void )
{
	void far * far * lplpOldCritHandler;

	lplpOldCritHandler = MK_FP( 0, 0x24*4 );
	*lplpOldCritHandler = GetOldCritHandler();
}


//  Return the address of the old critical error handler
//
void far * GetOldCritHandler( void )
{
	void far * * plpOldCritHandler;

	plpOldCritHandler = GetOldCritHandlerAddress();
	return *plpOldCritHandler;
}


//  Save the address of the old critical error handler
//
void SaveOldCritHandler( void far * lpOldCritHandler )
{
	void far * * plpOldCritHandler;

	plpOldCritHandler = GetOldCritHandlerAddress();
	*plpOldCritHandler = lpOldCritHandler;
}


//  Return the address of the variable which contain the old critical
//  error handler
//
void far * * GetOldCritHandlerAddress( void )
{
	static void far * lpOldCritHandler;

	return &lpOldCritHandler;
}


//  Check if the user wants to abort CTRL-BRK
//
void CheckUserAbort( void )
{
	//  Determine if the user hit CTRL-BRK.  If so ...
	//
	if( fInt23Occured )
	{
		//  Display a message stating that the user aborted
		//
		printf(szUserAbort);


		//  Flush buffers, free memory, unlock the drive, restore current
		//  drive and directory, set exit code and exit
		//
		ErrorExit(255);
	}
}
