//
//   $Id: IFSDISP.H 1.5 2002/10/16 21:42:08Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//  IFSDISP.H
//
//  Copyright (c) 2001-2002 Datalight, Inc.
//  All Rights Reserved.
//  Datalight Confidential and Proprietary
//
//  History:
//
//  04-01-2001  bt  Created
//



//  This is the structure used to store the offset of a CDS used
//  to map a remote drive letter
//
typedef struct CDSMapping CDSMAP;
struct CDSMapping
{
	unsigned uCDSOffset;
	uchar ucLocalDriveLetter;
	uchar ucRemoteDriveLetter;
};






//  The bit for the carry flag when the flags are in a word register
//
#define FLAG_CARRY		0x0001



//  Structure of registers saved on int 2fh call
//
typedef struct CallersRegisters CALLREG;
typedef CALLREG * PCALLREG;
typedef CALLREG far * LPCALLREG;
struct CallersRegisters
{
    unsigned	ax;
    unsigned	bx;
    unsigned	cx;
    unsigned	dx;
    unsigned	si;
    unsigned	di;
    unsigned	bp;
    unsigned 	ds;
    unsigned 	es;
    unsigned 	sp;
    unsigned 	ss;
    unsigned 	ip;
    unsigned 	cs;
    unsigned 	flags;
};


//  This variable countains the number of used entries in
//  the CDS map structure
//
extern unsigned uNumberOfMappedDrives;


//  This variable contains the segment address for all the CDSs
//
extern unsigned uCDSSegment;


//  This array contains the CDS offset, local drive letter, and
//  remote drive letter, for all the mapped drives
//
extern CDSMAP xCDSMAP[];


//  UnmapDrives
//
//
//  Invalidate all the drives that were mapped to the IFS both in
//  the CDS settings and in the internal table
//
//
//  On entry:
//
//    nothing
//
//
//  On exit:
//
//    nothing
//
//
void UnmapDrives( void );
