;
;   $Id: IFSINT.ASM 1.5 2002/10/16 21:42:08Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
;  IFSINT.ASM
;
;  Copyright (c) 2001-2002 Datalight, Inc.
;  All Rights Reserved.
;  Datalight Confidential and Proprietary
;
;  This file contains the interrupt handlers, stack, and data used
;  by the IFS for traping and returning from an IFS call
;
;  History:
;
;  04-01-2001  bt  Created
;



.model small



.data

    ;  This is the stack that the IFS handler switches to
    ;  to perform an IFS operation
    ;
    I2fStack		dw	1024 dup(?)
	public _I2fStackTop
    _I2fStackTop	label   word


    ;  For easy reference, save a local pointer to our stack
    ;
	public _lpLocalStack
    _lpLocalStack	label	dword
    LocalStackSP	dw	_I2fStackTop - 2
    LocalStackSS	dw	@Data


    ;  For easy reference, save a local pointer to our INT 2fh handler
    ;
	public _lpInt2fHandler
    _lpInt2fHandler	label	dword
    LocalInt2fOffset	dw	_INT2fHandler
    LocalInt2fSegment	dw	@Code


    ;  pointer to the previous INT 2fh handler
    ;
	public _lpOldInt2fHandler
    _lpOldInt2fHandler	label	dword
    OldInt2fOffset	dw	_INT2fHandler
    OldInt2fSegment	dw	@Code

	public _lpOnExitPtr
	public _uOnExitPtrOffset
	public _uOnExitPtrSegment
    _lpOnExitPtr	label	dword
    _uOnExitPtrOffset	dw	?
    _uOnExitPtrSegment	dw	@code


    ;  Callers registers
    ;
	public	_CallersRegisters
    _CallersRegisters	label	byte

    CallersAX		dw	?
    CallersBX		dw	?
    CallersCX		dw	?
    CallersDX		dw	?
    CallersSI		dw	?
    CallersDI		dw	?
    CallersBP		dw	?
    CallersDS		dw	?
    CallersES		dw	?

    _lpCallersStack	label	dword
    CallersSP		dw	?
    CallersSS		dw	?

    _lpCallersCSIP	label	dword
    CallersIP		dw	?
    CallersCS		dw	?

    CallersFlags	dw	?


    	public _bIFSHandledCall
    _bIFSHandledCall	dw	?


    fInt2fPatched	dw	?

.code

	ASSUME	CS:@Code,DS:@Data

	extrn	_IFSDispatch:proc


.186


;  _INT2fHandler
;
;  This handler gets called everytime that there is an INT 3
;
comment ~
void INT2fHandler( void )
~
    public _INT2fHandler
_INT2fHandler:

	;  Determine if this is an IFS call
	;
	cmp	ah, 11h
	je	DoServiceCall
	jmp	QuickOut


	;  Save the stack
	;
DoServiceCall:
	mov	cs:CallersSS, ss
	mov	cs:CallersSP, sp


	;  Set our stack
	;
	mov	ss, word ptr cs:_lpLocalStack+2
	mov	sp, word ptr cs:_lpLocalStack


	;  Save DS
	;
	mov	cs:CallersDS, ds


	;  Set our DS
	;
	push	ss
	pop	ds


	;  Save the rest of the registers
	;
	mov	CallersAX, ax
	mov	CallersBX, bx
	mov	CallersCX, cx
	mov	CallersDX, dx
	mov	CallersSI, si
	mov	CallersDI, di
	mov	CallersBP, bp
	mov	ds:CallersES, es


	;  Save the CS:IP
	;
	les	bx, _lpCallersStack
	mov	ax, es:[bx]
	mov	CallersIP, ax
	mov	ax, es:[bx+2]
	mov	CallersCS, ax


	;  Save the flags
	;
	mov	ax, es:[bx+4]
	mov	cs:CallersFlags, ax


	;  Clear the flag indicating that the call was handled
	;
	mov	ax, 0
	mov	_bIFSHandledCall, ax


	;  Re-enter our program
	;
	call	_IFSDispatch


	;  We should never end up here but just in case
	;
	hlt


;  _INT2fReturn
;
;  This is where control is passed on to the previous int 2fh handler
;  or returned to the caller depending on whether the call was handled
;
comment ~
void INT2fReturn( void )
~
    public	_INT2fReturn
_INT2fReturn:


	;  Set the flags
	;
	les	bx, _lpCallersStack
	mov	ax, CallersFlags
	mov	es:[bx+4], ax


	;  Set all the registers
	;
	mov	ax, CallersAX
	mov	bx, CallersBX
	mov	cx, CallersCX
	mov	dx, CallersDX
	mov	si, CallersSI
	mov	di, CallersDI
	mov	bp, CallersBP
	mov	es,  ds:CallersES


	;  Set DS
	;
	mov	ds, CallersDS


	;  Set the stack
	;
	mov	ss, word ptr cs:_lpCallersStack+2
	mov	sp, word ptr cs:_lpCallersStack


	pushf
	cmp	cs:_bIFSHandledCall, 0
	jz	QuickOut2


	;  Return
	;
	popf
	iret


	;  Pass on the call to the previous INT 2fh
	;

QuickOut2:
	popf
QuickOut:
	jmp     dword ptr cs:_lpOldInt2fHandler


;  InstallIFSVector
;
;  Save the current int 2fh vector and set the int 2fh vector to
;  our handler
;
comment ~
void InstallIFSVector( void )
~
    public	_InstallIFSVector
_InstallIFSVector:


	;  Set ES:BX to the int 2fh vector
	;
	xor	bx, bx
	mov	es, bx
	mov	bx, 2fh * 4


	;  Save the current int 2fh vector
	;
	pushf
	cli
	mov	ax, es:[bx]
	mov	OldInt2fOffset, ax
	mov	ax, es:[bx+2]
	mov	OldInt2fSegment, ax


	;  Set our int 2fh vector
	;
	mov	ax, LocalInt2fOffset
	mov	es:[bx], ax
	mov	ax, LocalInt2fSegment
	mov	es:[bx+2], ax
	popf


	;  Set the flag indicating that the INT 2fh interface
	;  has been patched
	;
	mov	fInt2fPatched, 1


	;  All done, return
	;
	ret



;  RestoreIFSVector
;
;  Restore the previous int 2fh handler
;
comment ~
bool RestoreIFSVector( void )
~
    public	_RestoreIFSVector
_RestoreIFSVector:


	xor	ax, ax
	push	ax

	;  Determine if the INT 2f vector has been patched
	;
	cmp	fInt2fPatched, 0
	jz	RestVectDone


	;  Set ES:BX to the int 2fh vector
	;
	xor	bx, bx
	mov	es, bx
	mov	bx, 2fh * 4


	;  Determine if the int 2fh vector points to our handler.  if
	;  not, then someone has chained the 2fh vector after us and
	;  we cannot overwrite their handler address
	;
	mov	ax, LocalInt2fOffset
	cmp	word ptr es:[bx], ax
	jne	RestVectDone
	mov	ax, LocalInt2fSegment
	cmp	word ptr es:[bx+2], ax
	jne	RestVectDone


	;  Restore the previous int 2fh vector
	;
	pushf
	cli
	mov	ax, OldInt2fOffset
	mov	es:[bx], ax
	mov	ax, OldInt2fSegment
	mov	es:[bx+2], ax
	popf
	pop	ax
	inc	ax
	push	ax


	;  Clear the flag indicating that the INT 2fh interface
	;  has been patched
	;
	mov	fInt2fPatched, 0


	;  All done, return
	;
  RestVectDone:
	pop	ax
	ret

	END
