;
;   $Id: ABSRDWR.ASM 1.4 2002/10/16 21:45:08Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
; ABSRDWR.ASM
;
; Copyright (c) 1989-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary
;
; int 25h/26h interface to HLLs: absread() and abswrite()
; also contains IsBigDrive() to determine if a drive has
; more than 65535 sectors.
;
include ..\include\datalght.inc

InitModel compact, pascal, use16



ABS_DISK_IO	struc
	startingSector	dd	?
	sectorCount	dw    	?
	buffer		dd	?
ABS_DISK_IO	ends



.Code

	assume 	cs:@code, ds:DGROUP, es:nothing, ss:nothing


; Returns 0 if <drive> has 65536 total sectors or less, drive: {0,1,..n}
;
comment ~
bool PASCAL IsBigDrive(int drive)
end_comment ~

ProcBegin	IsBigDrive,public
ProcUses	ds,di,si
ProcArgs	@@drive:word
ProcSetup

	; determine # of sectors on disk
	;
	mov	ah, 1CH
	mov	dl, byte ptr @@drive	; drive passed (A=0, B=1)
	inc	dl			; DOS wants 1=A, 2=B, etc
	int	21h

	; DX = clusters, AL = sectors per cluster
	; if more than 64K sectors, it's big
	;
	xor	ah, ah
	mul	dx
	mov	ax, dx
ProcEnd

; Int 25h interface to read logical sectors (64Kbytes max).
; Returns 0 if worked, 1 if failed
;
comment ~
int PASCAL _absread(bool isBig, int drive, int sects, long start, void far * buff)
end_comment ~
ProcBegin 	_absread, public
ProcUses  	ds,di,si
ProcArgs	@@isBig:word, @@drive:word, @@sects:word, @@start:dword, @@buff:dword
ProcLocals	@@absReadData:ABS_DISK_IO
ProcSetup

	mov	ax, @@isBig
	or	ax, ax
	jz	ABSR_is_small

	; this is a BIG (32M+) partition, pass data in a struc
	; pointed to by DS:BX, CX=-1 signals this, AL = drive
	;
	mov	al, byte ptr @@drive
	mov	cx, -1
	mov	bx, ss
	mov	ds, bx
	lea	bx, @@absReadData

	mov	dx, word ptr @@start
	mov	word ptr [bx].startingSector, dx
	mov	dx, word ptr @@start[2]
	mov	word ptr [bx].startingSector[2], dx

	mov	dx, @@sects
	mov	[bx].sectorCount, dx

	mov	dx, word ptr @@buff
	mov	word ptr [bx].buffer, dx
	mov	dx, word ptr @@buff[2]
	mov	word ptr [bx].buffer[2], dx

	jmp	short ABSR_do_int25

	; this is a SMALL (<=32M) partition, all args fit in registers
	;
    ABSR_is_small:
	mov	al, byte ptr @@drive
	mov	cx, @@sects
	mov	dx, word ptr @@start
	mov	bx, word ptr @@buff
	mov	ds, word ptr @@buff[2]

    ABSR_do_int25:
	int	25h
	jnc	ABSR_read_ok
	mov	ax, 1
	jmp	short ABSR_read_done

	; 0 = OK (ERR_NONE)
	;
    ABSR_read_ok:
	xor	ax, ax

	; int 25h/26h leave the flags on the top of the stack
	; get rid of them
	;
    ABSR_read_done:
	pop	bx
ProcEnd


; Int 26h interface to write logical sectors (64Kbytes max).
; Returns 0 if worked, 1 if failed
;
comment ~
int PASCAL _abswrite(bool isBig, int drive, int sects, long start, void far * buff)
end_comment ~
ProcBegin 	_abswrite, public
ProcUses  	ds,di,si
ProcArgs	@@isBig:word, @@drive:word, @@sects:word, @@start:dword, @@buff:dword
ProcLocals	@@absWriteData:ABS_DISK_IO
ProcSetup

	mov	ax, @@isBig
	or	ax, ax
	jz	ABSW_is_small

	; this is a BIG (32M+) partition, pass data in a struc
	; pointed to by DS:BX, CX=-1 signals this, AL = drive
	;
	mov	al, byte ptr @@drive
	mov	cx, -1
	mov	bx, ss
	mov	ds, bx
	lea	bx, @@absWriteData

	mov	dx, word ptr @@start
	mov	word ptr [bx].startingSector, dx
	mov	dx, word ptr @@start[2]
	mov	word ptr [bx].startingSector[2], dx

	mov	dx, @@sects
	mov	[bx].sectorCount, dx

	mov	dx, word ptr @@buff
	mov	word ptr [bx].buffer, dx
	mov	dx, word ptr @@buff[2]
	mov	word ptr [bx].buffer[2], dx

	jmp	short ABSW_do_int26

	; this is a SMALL (<=32M) partition, all args fit in registers
	;
    ABSW_is_small:
	mov	al, byte ptr @@drive
	mov	cx, @@sects
	mov	dx, word ptr @@start
	mov	bx, word ptr @@buff
	mov	ds, word ptr @@buff[2]

    ABSW_do_int26:
	int	26h
	jnc	ABSW_write_ok
	mov	ax, 1
	jmp	short ABSW_write_done

	; 0 = OK (ERR_NONE)
	;
    ABSW_write_ok:
	xor	ax, ax

	; int 25h/26h leave the flags on the top of the stack
	; get rid of them
	;
    ABSW_write_done:
	pop	bx
ProcEnd

@curseg	ends
	end
