;
;   $Id: CPUINFO.ASM 1.4 2002/10/16 21:45:08Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
; CPUINFO.ASM
;
; Copyright (c) 1989-2002 Datalight, Inc.
; All Rights Reserved.
; Datalight Confidential and Proprietary
;
; Determines  	1) if running on a 32-bit CPU
;		2) if in protected mode (safely).
;		3) if Windows is running
;
; This code originally from Chappel's DOS Internals and Intel Docs.
; It has not been tested on a lot of processors.
;
; Converted to Datalight standards 04-23-97 Dennis Edwards
;
include ..\include\datalght.inc

InitModel compact, pascal, use16


.Code

.286p 	; required by TASM to use SMSW op


; Determines if the CPU is at least an 80386
;
; ->	void
; <-	AX	<> 0 if 80386 or later CPU
;	AX      == 0 if not
; regs	ax
;
comment ~
bool PASCAL Is32BitCPU(void)
end_comment ~

ProcBegin	Is32BitCPU,public
ProcSetup

	pushf 			; save flags - particularly the interrupt
				; flag, which is cleared during the test
	pushf
	pop	ax
	and	ax, 0FFFh
	or      ax, 7000h	; try setting the NT and IOPL bits
	push    ax		; but clearing the reserved bit B15
	popf

	pushf
	pop     ax
	test    ax,8000h
	jnz     IsNot		; if B15 comes on, then 8086 or 80186

	and     ax,7000h
	or	ax,ax
	jz	IsNot		; if other bits stay clear, then 80286

	mov     ax,0001h	; return TRUE for an 80386 or better
	jmp     IsDone

    IsNot:
        xor     ax,ax		; else return FALSE

    IsDone:
        popf			; restore original flags
ProcEnd


; Safely determines if the CPU is in protected Mode.
;
; ->	void
; <-	AX	<> 0 if CPU is in protected mode
;	AX      == 0 if not
; regs	ax
;
comment ~
bool PASCAL InProtectedMode(void)
end_comment ~

ProcBegin	InProtectedMode,public
ProcSetup

	smsw	ax
	and	ax, 0001h
ProcEnd


; Determins if Windows is running.
;
; ->	void
; <-	AX	== 0 if not
;       AX      <> 0 if so
;
comment ~
bool PASCAL InWindows(void)
end_comment ~

ProcBegin	InWindows,public
ProcSetup

	mov	ax, 4680h
	int	2Fh
	or	ax, ax		; not win /s or win /r if 0
	jz	InWin

	mov	ax, 1600h
	int	2Fh
	or	ax, ax		; not win /e if 0
	jz	InWinDone

	sub	ax, 1600h	; not any win at all if 1600
	jz	InWinDone

    InWin:
	mov	ax, 1

    InWinDone:
ProcEnd


@curseg	ends
end
