//
//   $Id: DISKCOMN.C 1.4 2002/10/16 21:47:06Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//  DISKCOMN.C
//
//  Copyright (c) 2001-2002 Datalight, Inc.
//  All Rights Reserved.
//  Datalight Confidential and Proprietary
//
//  HISTORY:
//
//	 05-01-2001  aj  Created
//


//  BORLAND INCLUDES
//
#include <dos.h>


//  DATALIGHT LIBRARIES
//
#include "datalght.h"

#include "dostruct.h"

#include "dosdef.h"
#include "dldosio.h"
#include "dosver.h"
#include "fatworld.h"
#include "dlapp.h"
#include "dlpath.h"


//  PROTOTYPES
//
#include "DISKCOMN.pt"
#include "diskcomn.h"


//
//  VARIABLES
//


//  Flag indicating that we are using DOS 7.1
//
extern bool fIsFat32World;

//  Externs
//
extern char * szReadError;
extern char * szInsertTarget;
extern char * szInsertSource;
extern char * szAnyKey;
extern char * szBadOpt;
extern char * szErrorMessages;
extern char * szUnkErrorCode;
extern char * szNotReady;


//  Read a number of tracks
//
bool ReadWriteANumberOfTracks( bool fIsWrite, unsigned uCountSides,
		unsigned uSectorsPerTrack,	unsigned uMaxTracks, unsigned uStartTrack,
		uchar ucDriveNumber, ulong ulTrackBufferAddress, bool fOneSide )
{
	static IOCTL_READWRITE ParmBlock;
	lpBOOTSECTOR lpBootSector;
	unsigned uTrack;
	unsigned uHead;
	unsigned uSegment;
	unsigned uOffset;
	unsigned uMaxSides = uCountSides;
	unsigned uDrive = ucDriveNumber;
	unsigned uEndTrack = uStartTrack + uMaxTracks;
	bool fSuccessful;
	bool fSingleDrive;
	uchar ucDriveLetter;
	uchar ucCategoryCode = DEFAULT_CATEGORY_CODE;


	//  Find out the real drive number
	//
	if( ucDriveNumber != 1 )
	{
		fSingleDrive = IsSingleDrive( ucDriveNumber, 1 );
		if( fSingleDrive )
		{
			uDrive = 1;
		}
	}

	//  If onesided copy or compare, only do one side
	//
	if( fOneSide )
	{
		uMaxSides = 1;
	}


	//  And the drive letter
	//
	ucDriveLetter = GetDriveLetter( ucDriveNumber );


	//  Setup the IOCTL read parameter block
	//
	ParmBlock.ucSpecialFunction = 0;
	ParmBlock.uSector = 0;
	ParmBlock.uNumberOfSectors = uSectorsPerTrack;


	//  Continue reading tracks until the requested amount has
	//  been read
	//
	for( uTrack = uStartTrack; uTrack < uEndTrack; uTrack++ )
	{
		ParmBlock.uTrack = uTrack;
		for( uHead = 0; uHead < uMaxSides; uHead++ )
		{
			ParmBlock.uHead = uHead;


			//  Normalize pointer for next iteration
			//
			uOffset = (unsigned)(ulTrackBufferAddress & 0xF);
			uSegment = (unsigned)(ulTrackBufferAddress >> 4);
			ParmBlock.lpBuffer = MK_FP( uSegment, uOffset );


			if( fIsWrite )
			{
				if( (uTrack == 0) && (uHead == 0) )
				{
					lpBootSector = ParmBlock.lpBuffer;
					lpBootSector->BootSectorInfo.BootInfo16.ulVolumeSerialNumber =
							CreateNewSerialNumber();
					SaveSerialnumber( lpBootSector->BootSectorInfo.BootInfo16.ulVolumeSerialNumber );
				}
				fSuccessful = dlGenericIOCTLForBlockDevices( uDrive,
						ucCategoryCode, IOCTL_WRITE, &ParmBlock );
			}
			else
			{
				fSuccessful = dlGenericIOCTLForBlockDevices( uDrive,
						ucCategoryCode, IOCTL_READ, &ParmBlock );
			}

			if( !fSuccessful )
			{
				printf(szReadError, ucDriveLetter, uHead, uTrack);
			}


			//  Update pointer
			//
			ulTrackBufferAddress += (uSectorsPerTrack * BYTES_PER_SECTOR);
		}
	}

	return TRUE;
}


//  Swap disk
//
bool SwapDisk( unsigned uMode, uchar ucDriveNumber )
{
	uchar ucDriveLetter;
	uchar ucGetChar;

	ucDriveLetter = GetDriveLetter( ucDriveNumber );

	if( uMode == 1 )
	{
		printf(szInsertTarget, ucDriveLetter);
	}
	if( uMode == 2 )
	{
		printf(szInsertSource, ucDriveLetter);
	}

	printf(szAnyKey);
	GetKey(&ucGetChar);

	return TRUE;
}


//  Check if this is a single drive system
//  1 based drive numbers
//
bool IsSingleDrive( uchar ucSrcDriveNumber, uchar ucDestDriveNumber )
{
	bool fSuccessful;
	uchar ucSrcMapDriveNumber;
	uchar ucDestMapDriveNumber;

	if( ucSrcDriveNumber == ucDestDriveNumber )
	{
		return TRUE;
	}

	fSuccessful = dlGetLogicalDriveMap( ucSrcDriveNumber, &ucSrcMapDriveNumber );
	if ( !fSuccessful )
	{
		DisplayErrorAndExit( ERR_DISKREAD );
	}

	fSuccessful = dlGetLogicalDriveMap( ucDestDriveNumber, &ucDestMapDriveNumber );
	if ( !fSuccessful )
	{
		DisplayErrorAndExit( ERR_DISKREAD );
	}

	if( (ucSrcDriveNumber == ucDestMapDriveNumber) ||
			(ucDestDriveNumber == ucSrcMapDriveNumber) )
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}


//  Build a track layout table
//
void SetTrackLayout( void * pTrackParms, PBPB pBPB )
{
	unsigned uSectorsPerTrack;
	unsigned uSectorSize;
	unsigned uSectorIndex;
	struct Parms{
		unsigned uSectorsInTrack;
		struct TRACK_TABLE TrackInfo[MAX_SPT];
	};
 	struct Parms * pParms;


	//  Create some local variables
	//
	pParms = pTrackParms;
	uSectorsPerTrack = pBPB->sec_per_trak;
	uSectorSize = pBPB->sec_size;


	//  Set the number of sectors in a track
	//
	pParms->uSectorsInTrack = uSectorsPerTrack;


	//  Create the track layout table
	//
	for( uSectorIndex=0; uSectorIndex < MAX_SPT; uSectorIndex++)
	{
		pParms->TrackInfo[uSectorIndex].uNumber = uSectorIndex+1;
		pParms->TrackInfo[uSectorIndex].uSize = uSectorSize;
	}
}


//  Show the usage for a bad command line parameter
//
void OptError(char * szMsg)
{
	unsigned uIndex = 0;
	bool fSwitchFound = FALSE;


	while( szMsg[uIndex] != 0 )
	{
		if( szMsg[uIndex] == '/' )
		{
			if( fSwitchFound )
			{
				szMsg[uIndex] = 0;
				break;
			}
			else
			{
				fSwitchFound = TRUE;
			}
		}
		uIndex++;
	}

	printf(szBadOpt, szMsg );

	Usage();
}


//  Get the drive letter from 1 based drive number
//
uchar GetDriveLetter( uchar ucDriveNumber )
{
	if( ucDriveNumber == 1 )
	{
		return 'A';
	}
	if( ucDriveNumber == 2 )
	{
		return 'B';
	}
	return 'Z';
}


//  Diskread error messages
//
void ErrDiskread( uchar ucDriveNumber )
{
	uchar ucDriveLetter;
	uchar ucGetChar;


	//Get drive letter
	ucDriveLetter = GetDriveLetter(ucDriveNumber);

	//print error
	printf(szNotReady, ucDriveLetter);
	GetKey(&ucGetChar);
}


//  GetKey get character function
//
void GetKey( uchar * pucGetChar )
{
	uchar ucGetKey;


	dlFlushAndGetKeyNoEcho( &ucGetKey );
	*pucGetChar = ucGetKey;
	if( ucGetKey == 0 )
	{
		dlGetKey( &ucGetKey );
	}
}

//  Record the serial number for easy referencing
//
void SaveSerialNumber( ulong ulSerialNumber )
{
	ulong * pulSerialNumber;

	pulSerialNumber = GetSerialNumberPointer();
	*pulSerialNumber = ulSerialNumber;
}


//  Return the serial number for the disk we just formatted
//
ulong GetSerialNumber( void )
{
	ulong * pulSerialNumber;

	pulSerialNumber = GetSerialNumberPointer();
	return *pulSerialNumber;
}


//  Return the address of the variable which contains the serial number
//
ulong * GetSerialNumberPointer( void )
{
	static ulong ulSerialNumber;
	return &ulSerialNumber;
}


//  Return a new serial number
//
ulong CreateNewSerialNumber( void )
{
	union REGS r;
	unsigned cx1,cx2;
	unsigned dx1,dx2;
	DOSDate DOSDate;
	DOSTime DOSTime;


#if 0
	r.h.ah = 0x2A;		/* get date */
	intdos(&r,&r);
	cx1 = r.x.cx;
	dx1 = r.x.dx;
	r.h.ah = 0x2C;		/* get time */
	intdos(&r,&r);
	cx2 = r.x.cx;
	dx2 = r.x.dx;
#else
	dlGetDOSDate( &DOSDate );
	cx1 = DOSDate.year;
	dx1 = *((unsigned *)(&DOSDate));
	dlGetDOSTime( &DOSTime );
	cx2 = *((unsigned *)(&DOSTime));
	dx2 = *((unsigned *)((char *)(&DOSTime))+2);
#endif

	/* add date & time together to get serial # */
	return (ulong)(MK_FP(dx1+dx2,cx1+cx2));
}
