//
//   $Id: DUMPDOS.C 1.4 2002/10/16 21:47:42Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/**********************************************************

	DUMPDOS  created 6/6/90  by Drew Gislason

   Copyright (c) 1990-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

	This program displays the internal DOS structures in a
	readable form.

***********************************************************/

#include <stdio.h>
#include <dos.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

//#include "dostruct.h"
#include "dosver.h"

#define FAT32	1

typedef unsigned char uchar;
typedef unsigned long ulong;
typedef int bool;

#if 0
; The BPB for FAT32 drives is an extended version of the FAT16/FAT12
; BPB. It contains identical information to a standard BPB, but also
; includes several extra fields for FAT32 specific information. This
; structure is implemented in Windows95 OEM Service Release 2 (OSR2)
; and later.
;
; A typical Win 95 OSR2 boot sector is shown below:
;
; 00 - EB 58 90 4D 53 57 49 4E-34 2E 31 00 02 08 20 00   .X.MSWIN4.1... .
; 10 - 02 00 00 00 00 F8 00 00-3F 00 80 00 3F 00 00 00   ........?...?...
; 20 - 41 97 60 00 20 18 00 00-00 00 00 00 02 00 00 00   A.`. ...........
; 30 - 01 00 06 00 00 00 00 00-00 00 00 00 00 00 00 00   ................
; 40 - 80 00 29 E7 12 49 25 46-41 54 33 32 2D 33 47 20   ..)..I%FAT32-3G
; 50 - 20 20 46 41 54 33 32 20-20 20 FA 33 C9 8E D1 BC     FAT32   .3....
; 60 - F8 7B 8E C1 BD 78 00 C5-76 00 1E 56 16 55 BF 22   .{...x..v..V.U."
; 70 - 05 89 7E 00 89 4E 02 B1-0B FC F3 A4 8E D9 BD 00   ..~..N..........
;
;
; The BPB fields that are of specific interest in FAT32 are:
;
; A_BF_BPB_RootEntries
;	This field is ignored on FAT32 drives. It is always 0.
; A_BF_BPB_SectorsPerFAT
;	This number of sectors per FAT field will always be zero in
; 	a FAT32 BPB. Use the values from A_BF_BPB_BigSectorsPerFat
;	and A_BF_BPB_BigSectorsPerFatHi for FAT32 media.
; A_BF_BPB_BigSectorsPerFat
;	The number of sectors per FAT on the FAT32 drive. This is the
;	first additional field in a BPB32.
; A_BF_BPB_BigSectorsPerFatHi
;	The high word of the FAT32 sectors per FAT value.
; A_BF_BPBExtFlags
;	Flags describing the drive. Bit 7 of this field indicates
;	whether or not information written to the active FAT will
;	be written to all copies of the FAT. The low 4 bits of this
;	field contain the 0-based FAT number of the Active FAT, but
;	are only meaningful if bit 8 is set. This field can contain
;	a combination of the following values:
;
;	BGBPB_F_ActiveFATMsk (000Fh) 	Mask for low four bits.
;	BGBPB_F_NoFATMirror (0080h)  	Mask indicating FAT mirroring
;					state. If set, FAT mirroring
;					is disabled. If clear, FAT
;					mirroring is enabled.
;	Bits 4-6 and 8-15 are reserved.
;
; A_BF_BPB_FS_Version
;	The file system version number of the FAT32 drive.
;	The high byte represents the major version, and the
;	low byte represents the minor version.
; A_BF_BPB_RootDirStrtClus
;	The cluster number of the first cluster in the FAT32
;	drive's root directory.
; A_BF_BPB_RootDirStrtClusHi
;	The high word of the FAT32 starting cluster number.
; A_BF_BPB_FSInfoSec
;	The sector number of the file system information sector.
;	The file system info sector contains a BIGFATBOOTFSINFO
;	structure. This field is set to 0FFFFh if there is no FSINFO
;	sector. Otherwise, this value must be non-zero and less than
;	the reserved sector count.
; A_BF_BPB_BkUpBootSec
;	The sector number of the backup boot sector. This field is set
;	to 0FFFFh if there is no backup boot sector. Otherwise, this
;	value must be non-zero and less than the reserved sector count.
; A_BF_BPB_Reserved
;	Reserved field. Do not use.
;
BPB    struc
    BPB_BytesPerSector       	DW    ?		; 00
    BPB_SectorsPerCluster    	DB    ?         ; 02
    BPB_ReservedSectors      	DW    ?         ; 03
    BPB_NumberOfFATs         	DB    ?         ; 05
    BPB_RootEntries          	DW    ?         ; 06
    BPB_TotalSectors         	DW    ?         ; 08
    BPB_MediaDescriptor      	DB    ?         ; 0A
    BPB_SectorsPerFAT        	DW    ?         ; 0B
    BPB_SectorsPerTrack      	DW    ?         ; 0D
    BPB_Heads                	DW    ?         ; 0F
    BPB_HiddenSectors        	DW    ?         ; 11
    BPB_HiddenSectorsHigh    	DW    ?         ; 13
    BPB_BigTotalSectors      	DW    ?         ; 15
    BPB_BigTotalSectorsHigh  	DW    ?         ; 17
  IF FAT32
    BPB_BigSectorsPerFat     	DW    ?         ; 19
    BPB_BigSectorsPerFatHi   	DW    ?         ; 1B
    BPB_ExtFlags             	DW    ?         ; 1D
    BPB_FS_Version           	DW    ?         ; 1F
    BPB_RootDirStrtClus      	DW    ?         ; 21
    BPB_RootDirStrtClusHi    	DW    ?         ; 23
    BPB_FSInfoSec            	DW    ?         ; 25
    BPB_BkUpBootSec          	DW    ?         ; 27
    BPB_Reserved             	DW    6 DUP (?)	; 29
  ENDIF
BPB    ends


; The boot sector on a FAT32 drive is layed out the same as for FAT16.
; The main difference is that, since the BPB32 is larger than the one
; for FAT16, the offsets of the subsequent fields are larger. Offsets
; for FAT32 boot sectors are shown in parenthesis.
;
BOOT_SECTOR struc
    JumpInstruction		db	3 dup 	?	; 00
    FileSystemOEMName		db	8 dup	?       ; 03
    BootSectorBPB		BPB	<>              ; 0B
    PhysicalDriveNumber		dw	80h             ; 40
    ExtendedBootRecordSig	db	29h             ; 26 (42)
    VolumeSerialNumber		dd	12345678	; 27 (43)
    VolumeLabel			db	"No Label   "   ; 2B (47)
    FileSystemID		db	"FAT32   "      ; 36 (52)
    BootCodeStarts		db	?		; 3E (5A)
BOOT_SECTOR ends


; File System Information Structure (aka BIGFATBOOTFSINFO (FAT32) by MS).
;
; Contains information about the file system on a FAT32 volume. This
; structure is implemented in Windows OEM Service Release 2 and later.
;
; bfFSInf_Sig
;	The signature of the file system information sector. The value
;	in this field is FSINFOSIG (0x61417272L).
; bfFSInf_free_clus_cnt
;	The count of free clusters on the drive. Set to -1 when the
;	count is unknown.
; bfFSInf_next_free_clus
;	The cluster number of the cluster that was most recently
;	allocated.
; bfFSInf_resvd
;	Reserved field. Do not use.
;

FSINFO_SECTOR_SIGNATURE	=	041615252h	; "RRaA"
FSINFO_STRUC_OFFSET	=	001E4h
FSINFO_SIGNATURE	=       061417272h	; "rrAa"
BOOT_SECTOR_SIGNATURE	=	0AA55h

FSINFO struc
    FSINFO_Signature            dd    	FSINFO_SIGNATURE	; 00
    FSINFO_FreeClusterCount     dd    	?			; 04
    FSINFO_NextFreeCluster    	dd    	?			; 08
    FSINFO_Reserved             dd    	3 DUP (?)		; 0C
    FSINFO_Reserved2		dw	?                       ; 18
    FSINFO_Signature2		dw	BOOT_SECTOR_SIGNATURE	; 1A
FSINFO ends
#endif




typedef struct BiosParameterBlock5 BPB5;
struct BiosParameterBlock5
{
   	unsigned    BytesPerSector;       		// 00
   	uchar    	SectorsPerCluster;    	   // 02
   	unsigned    ReservedSectors;      	   // 03
   	uchar    	FATs;		         	   	// 05
   	unsigned    RootEntries;          	   // 06
   	unsigned    TotalSectors;         	   // 08
   	uchar    	MediaDescriptor;      	   // 0A
   	unsigned    SectorsPerFAT;        	   // 0B
   	unsigned    SectorsPerTrack;      	   // 0D
   	unsigned    Heads;                	   // 0F
   	unsigned    HiddenSectors;        	   // 11
   	unsigned    HiddenSectorsHigh;    	   // 13
};

typedef struct BiosParameterBlock7 BPB7;
struct BiosParameterBlock7
{
   	unsigned    BytesPerSector;       	   // 00
   	uchar    	SectorsPerCluster;    	   // 02
   	unsigned    ReservedSectors;      	   // 03
   	uchar    	FATs;			         	   // 05
   	unsigned    RootEntries;          	   // 06
   	unsigned    TotalSectors;         	   // 08
   	uchar    	MediaDescriptor;      	   // 0A
   	unsigned    SectorsPerFAT;        	   // 0B
   	unsigned    SectorsPerTrack;      	   // 0D
   	unsigned    Heads;                	   // 0F
   	unsigned    HiddenSectors;        	   // 11
   	unsigned    HiddenSectorsHigh;    	   // 13
   	unsigned    BigTotalSectors;      	   // 15
   	unsigned    BigTotalSectorsHigh;  	   // 17
   	unsigned    BigSectorsPerFat;     	   // 19
   	unsigned    BigSectorsPerFatHigh;  	   // 1B
   	unsigned    ExtendedFlags;         	   // 1D
   	unsigned    FileSystemVersion;     	   // 1F
   	unsigned    RootDirStartCluster;   	   // 21
   	unsigned    RootDirStartClusterHigh;   // 23
   	unsigned    FSInfoSector;          	   // 25
   	unsigned    BackUpBootSector;      	   // 27
   	unsigned    Reserved[6];           	   // 29
};




typedef struct DriveDataTable5 DDT5;
struct DriveDataTable5
{
	DDT5 far *nextptr;	                     // 00H ptr to next structure
	uchar		stdrive;	                     // 04H BIOS drive #
	uchar		dos_drive;                    // 05H unit #
	BPB5		curbpb;	                     // 06H current BPB
	uchar		is16bitfat;	                  // 1FH 0=12 bit, 40H=16 bit, 20h=32 bit
	unsigned	opencnt;	                     // 20H open count
	uchar		dtype;		                  // 22H 0=360,1=1.2,2=720,5=hard,7=1.44
	unsigned	dattr;		                  // 23H 1=not-removable, 2=chgline status
	unsigned	tracks;	                     // 25H # tracks (cylinders)
	BPB5		defbpb;	                     // 27H default BPB
	uchar		unknown[6];                   // 40H ???
	uchar 	curtrack;                     // 46H current track position
	ulong		ticks;	                     // 47H last tick count, also ST_TRAK
	uchar 	volume[12];                   // 4BH Volume Label from boot sector
	ulong		serial;	                     // 57H Serial # from boot sector
	uchar 	fatstr[9];	                  // 5BH "FAT12" from boot sector
};

typedef struct DriveDataTable7 DDT7;
struct DriveDataTable7
{
	DDT7 far *nextptr;                     // 00H ptr to next structure
	uchar		stdrive;	                     // 04H BIOS drive #
	uchar		dos_drive;                    // 05H unit #
	BPB7		curbpb;	                     // 06H current BPB
	uchar		is16bitfat;	                  // 1FH (3Bh) 0=12 bit, 40H=16 bit, 20h=32 bit
	unsigned	opencnt;	                     // 20H open count
	uchar		dtype;		                  // 22H 0=360,1=1.2,2=720,5=hard,7=1.44
	unsigned	dattr;		                  // 23H 1=not-removable, 2=chgline status
	unsigned	tracks;	                     // 25H # tracks (cylinders)
	BPB7		defbpb;	                     // 27H default BPB
	uchar 	curtrack;                     // 46H current track position
	ulong		ticks;	                     // 47H last tick count, also ST_TRAK
	uchar 	volume[12];                   // 4BH Volume Label from boot sector
	ulong		serial;	                     // 57H Serial # from boot sector
	uchar 	fatstr[9];	                  // 5BH "FAT12" from boot sector
};

typedef struct DeviceHeader         DEV_HDR;
typedef struct DeviceHeader far * LPDEV_HDR;
struct DeviceHeader /*()*/
{
   LPDEV_HDR next;            /* 00 ptr to next device   */
   unsigned  attr;            /* 04 attribute of device  */
   unsigned  strategy;        /* 06 ptr to strat routine */
   unsigned  service;         /* 08 ptr to serv routine  */
   char      name[8];         /* 0A name of char device  */
};


typedef struct DriveParameterBlock3 DPB3;
struct DriveParameterBlock3 /*()*/
{
   uchar       drive;           /* 00 0=A, 1=B, 2=C, etc           */
   uchar       unit;            /* 01 unit # to pass to device     */
   unsigned    bytes_per_sec;   /* 02 bytes per sector             */
   uchar       ms_spc;          /* 04 sectors per cluster-1        */
   uchar       shift;           /* 05 shift factor to get spc      */
   unsigned    fat_start;       /* 06 # of "reserved" sectors      */
   uchar       num_fats;        /* 08 copies of fat                */
   unsigned    dir_ent;         /* 09 # of root dir entries        */
   unsigned    data_start;      /* 0B sector # for start of data   */
   unsigned    hiclus;          /* 0D highest cluster #            */
   uchar       fat_len;         /* 0F sectors per fat              */
   unsigned    dir_start;       /* 10 sector where root dir starts */
   LPDEV_HDR   device;  		  /* 12 pointer to the device driver */
   uchar       media;           /* 16 disk ID byte (360K = 0xFD)   */
   uchar       rebuild;         /* 17 FF says rebuild, 00 no need  */
   DPB3 far    *next;           /* 18 pointer to next DPB          */
   unsigned    newclus;         /* 1C start here when allocating   */
   unsigned    freeclus;        /* 1E free clusters, -1 = unknown  */
};

typedef struct DriveParameterBlock5 DPB5;
struct DriveParameterBlock5
{
	uchar    	Drive;           	// 00 0=A, 1=B, 2=C, etc
	uchar       Unit;            	// 01 unit # to pass to device
	unsigned    BytesPerSector;  	// 02 bytes per sector (128,256,512,1024)
	uchar       ms_spc;          	// 04 sectors per cluster-1
	uchar       shift;           	// 05 shift factor to get spc
	unsigned    FatStart;       	// 06 # of "reserved" sectors
	uchar       FatCount;        	// 08 copies of fat
	unsigned    RootDirEntries;  	// 09 # of root dir entries
	unsigned    data_start;      	// 0B sector # for start of data
	unsigned    hiclus;          	// 0D highest cluster #
	unsigned    fat_len;         	// 0F sectors per fat
	unsigned    dir_start;       	// 11 sector where root dir starts
	LPDEV_HDR   device;  	      // 13 pointer to the device driver
	uchar       media;           	// 17 disk ID byte (360K = 0xFD)
   uchar			rebuild;				// 18 0xFF means rebuild drive, 0 means no need
   DPB5 far    *next;            // 19 pointer to next DPB
   unsigned		newclus;				// 1D start here when allocating
   unsigned		freeclus;         // 1F free clusters, -1 = unknown
};

typedef struct DriveParameterBlock7 DPB7;
struct DriveParameterBlock7
{
	uchar    	Drive;           	// 00 0=A, 1=B, 2=C, etc
	uchar       Unit;            	// 01 unit # to pass to device
	unsigned    BytesPerSector;  	// 02 bytes per sector (128,256,512,1024)
	uchar       ms_spc;          	// 04 sectors per cluster-1
	uchar       shift;           	// 05 shift factor to get spc
	unsigned    FatStart;       	// 06 # of "reserved" sectors
	uchar       FatCount;        	// 08 copies of fat
	unsigned    RootDirEntries;  	// 09 # of root dir entries
	unsigned    data_start;      	// 0B sector # for start of data
	unsigned    hiclus;          	// 0D highest cluster #
	unsigned    fat_len;         	// 0F sectors per fat
	unsigned    dir_start;       	// 11 sector where root dir starts
	LPDEV_HDR   device;        	// 13 pointer to the device driver
	uchar       media;           	// 17 disk ID byte (360K = 0xFD)
   uchar			rebuild;				// 18 0xFF means rebuild drive, 0 means no need
   DPB7 far    *next;            // 19 pointer to next DPB
   unsigned		newclus;				// 1D start here when allocating
   unsigned		freeclus;         // 1F free clusters, -1 = unknown
unsigned		freeclus_hi;
unsigned		flags;
unsigned		FSInfoSec;
unsigned		BkUpBootSec;
ulong			first_sector;
ulong			max_cluster;
ulong			fat_size;
ulong			root_clus;
ulong			next_free;
};

struct DIR5
{
   char     name[8];         /* 00 file name                */
   char     ext[3];          /* 08 */
   uchar    attr;            /* 0B file attribute           */
   uchar    reserved[10];    /* 0C */
   unsigned time;            /* 16 file date                */
   unsigned date;            /* 18 file time                */
   unsigned start;           /* 1A starting cluster of file */
   ulong    size;            /* 1C file size in bytes       */
};

struct DIR7
{
   char     name[8];					// 00h file name and extension
   char     ext[3];					// 08h
   uchar    attr;						// 0Bh file attribute
   uchar    reserved;				// 0Ch ???
	uchar		CentiSeconds;			// 0Dh centiseconds of creation time
   unsigned CreationTime;			// 0Eh file creation date/time
   unsigned CreationDate;			// 10h
   unsigned LastAccessDate;		// 12h date file was last accessed (opened)
   unsigned StartingClusterHi;	// 14h high word of the starting cluster
   unsigned time;						// 16h last date/time file was modified
   unsigned date;						// 18h
   unsigned start;					// 1Ah starting cluster of file/dir (low word)
   ulong    size;						// 1Ch file size in bytes (0 for a dir)
};

struct SDB5
{
   uchar      drive;       /* 00  0=default, 1=A, 2=B...     */
   char       emask[11];   /* 01  name mask in expanded form */
   uchar      srchattr;    /* 0C  attribute search mask      */
   unsigned   dirnum;      /* 0D  directory entry number     */
   unsigned   subdir;      /* 0F  cluster # of subdirectory  */
   uchar      res1[4];     /* 11  unused                     */
};

struct SDB7
{
   uchar      drive;       /* 00  0=default, 1=A, 2=B...     */
   char       emask[11];   /* 01  name mask in expanded form */
   uchar      srchattr;    /* 0C  attribute search mask      */
   unsigned   dirnum;      /* 0D  directory entry number     */
   ulong      subdir;      /* 0F  cluster # of subdirectory  */
   uchar      res1[2];     /* 13  ???                        */
};

typedef struct CurrentDirectoryStructure3 CDS3;
struct CurrentDirectoryStructure3
{
   char       cwd[67];    /* 00 as in "C:\" or "Network.node\" */
   unsigned   status;     /* 43 bit mapped status, see above   */
   DPB3 far   *dpb;       /* 45 network drives have no DPB     */
   unsigned   subdir;     /* 49 subdir cluster # (0000=root)   */
   unsigned   unknown1;   /* 4B */
   unsigned   unknown2;   /* 4D */
   unsigned   skip;       /* 4F chars to skip to get past root */
};

typedef struct CurrentDirectoryStructure5 CDS5;
struct CurrentDirectoryStructure5
{
   char       cwd[67];    /* 00 as in "C:\" or "Network.node\" */
   unsigned   status;     /* 43 bit mapped status, see above   */
   DPB5 far   *dpb;       /* 45 network drives have no DPB     */
   unsigned   subdir;     /* 49 subdir cluster # (0000=root)   */
   unsigned   unknown1;   /* 4B */
   unsigned   unknown2;   /* 4D */
   unsigned   skip;       /* 4F chars to skip to get past root */
   uchar      unknown3;   /* 51 */
   void far * ifsptr;     /* 52 ??? */
   unsigned   unknown4;   /* 56 */
};

typedef struct CurrentDirectoryStructure7 CDS7;
struct CurrentDirectoryStructure7
{
   char       cwd[67];    /* 00 as in "C:\" or "Network.node\" */
   unsigned   status;     /* 43 bit mapped status, see above   */
   DPB7 far   *dpb;       /* 45 network drives have no DPB     */
   ulong      subdir;     /* 49 subdir cluster # (0000=root)   */
   unsigned   unknown2;   /* 4D */
   unsigned   skip;       /* 4F chars to skip to get past root */
   uchar      unknown3;   /* 51 */
   void far   *ifsptr;    /* 52 ??? */
   unsigned   unknown4;   /* 56 */
};

struct SFT3 /*()*/
{
   unsigned   handles;         /* 00 # of handles using this SFT */
   unsigned   rwmode;          /* 02 0=rd_only, 1=wr_only, 2=rw  */
   uchar      attr;            /* 04 file attribute              */
   unsigned   ioctl;           /* 05 bit map for ioctl (device)  */
   LPDEV_HDR  device;          /* 07 ptr to device or DPB        */
   unsigned   start;           /* 0B starting cluster of file    */
   unsigned   time;            /* 0D date and time of file entry */
   unsigned   date;            /* 0F */
   ulong      size;            /* 11 the file size               */
   ulong      offset;          /* 15 offset for next read/write  */
   unsigned   relclus;         /* 19 logical clus last accessed  */
   unsigned   absclus;         /* 1B as above, 0000 = invalid    */
   unsigned   dirsec;          /* 1D sector containing dir entry */
   uchar      dirent;          /* 1F entry # within above sector */
   char       name[8];         /* 20 filename */
   char       ext[3];
   void far   *shareptr;       /* 2B ??? share pointer           */
   unsigned   shareid;         /* 2F ??? network id of process   */
   unsigned   owner;           /* 31 psp of owner of this SFT    */
   unsigned   shareoff;        /* 33 ??? sharing record offset   */
};
struct DCB3 /*()*/
{
   struct DCB3 far *next;      /* 00 ptr next block of SFTs         */
   unsigned   numsft;          /* 04 number of SFTs in this block   */
   struct SFT3 sft[1];         /* 06 the array of SFTs for this DCB */
};

struct SFT5 /*()*/
{
   unsigned   handles;         /* 00 # of handles using this SFT */
   unsigned   rwmode;          /* 02 0=rd_only, 1=wr_only, 2=rw  */
   uchar      attr;            /* 04 file attribute              */
   unsigned   ioctl;           /* 05 bit map for ioctl (device)  */
   LPDEV_HDR  device;          /* 07 ptr to device or DPB        */
   unsigned   start;           /* 0B starting cluster of file    */
   unsigned   time;            /* 0D date and time of file entry */
   unsigned   date;            /* 0F */
   ulong      size;            /* 11 the file size               */
   ulong      offset;          /* 15 offset for next read/write  */
   unsigned   relclus;         /* 19 logical clus last accessed  */
   ulong      dirsec;          /* 1B sector containing dir entry */
   uchar      dirent;          /* 1F entry # within above sector */
   char       name[8];         /* 20 filename */
   char       ext[3];
   void far   *shareptr;       /* 2B ??? share pointer           */
   unsigned   shareid;         /* 2F ??? network id of process   */
   unsigned   owner;           /* 31 psp of owner of this SFT    */
   unsigned   shareoff;        /* 33 ??? sharing record offset   */
   unsigned   absclus;         /* 35 as above, 0000 = invalid    */
   void far   *ifsptr;         /* 37 ??? */
};
struct DCB5 /*()*/
{
   struct DCB5 far *next;      /* 00 ptr next block of SFTs         */
   unsigned   numsft;          /* 04 number of SFTs in this block   */
   struct SFT5 sft[1];         /* 06 the array of SFTs for this DCB */
};

struct SFT7 /*()*/
{
   unsigned   handles;         /* 00 # of handles using this SFT */
   unsigned   rwmode;          /* 02 0=rd_only, 1=wr_only, 2=rw  */
   uchar      attr;            /* 04 file attribute              */
   unsigned   ioctl;           /* 05 bit map for ioctl (device)  */
   LPDEV_HDR  device;          /* 07 ptr to device or DPB        */
   unsigned   relclushi;       /* 0B high word of relclus        */
   unsigned   time;            /* 0D date and time of file entry */
   unsigned   date;            /* 0F */
   ulong      size;            /* 11 file size in bytes <= 7FFFFFFFh */
   ulong      offset;          /* 15 byte offset for next read/write  */
   unsigned   relclus;       	 /* 19 low word of file cluster last accessed relative to start of file  */
   ulong      dirsec;          /* 1B sector containing dir entry */
   uchar      dirent;          /* 1F entry # within above sector */
   char       name[8];         /* 20 filename */
   char       ext[3];
   ulong	  	  start;           /* 2B starting cluster of file */
   unsigned   shareid;         /* 2F ??? network id of process   */
   unsigned   owner;           /* 31 psp of owner of this SFT    */
   unsigned   shareoff;        /* 33 ??? sharing record offset   */
   ulong      absclus;         /* 35 actual cluster number corresponding to relclus */
   unsigned   unknown;         /* 39 ??? */
};
struct DCB7 /*()*/
{
   struct DCB7 far *next;      /* 00 ptr next block of SFTs         */
   unsigned   numsft;          /* 04 number of SFTs in this block   */
   struct SFT7 sft[1];         /* 06 the array of SFTs for this DCB */
};

struct BUFLIST /*()*/
{
   struct BUFLIST *prev;     /* 00 least recently used   */
   struct BUFLIST *next;     /* 02 most recently used    */
   uchar      drive;         /* 04 drive, 0xFF = invalid */
   uchar      flags;         /* 05 bit mapped flags      */
   ulong      sector;        /* 06 what sector           */
   uchar      copies;        /* 0A copies of this sector */
   unsigned   distance;      /* 0B distance to next copy */
   void far   *dpb;          /* 0D pointer to DPB        */
	uchar      store_drive;   /* 11 "remember" during crit errors */
   uchar      store_flags;   /* 12 "remember" during crit errors */
   uchar      unknown;       /* 13 */
   uchar      buffer[1];     /* 14 the actual buffer     */
};

struct MCB /*()*/
{
   uchar      id;        /* 00 'M' for normal, 'Z' for last MCB */
   unsigned   owner;     /* 01 psp segment of owner        */
   unsigned   para_cnt;  /* 03 # of paragraphs in this MCB */
   char       unused[2]; /* 05                             */
   char       init_id;   /* 07 ROM-DOS specific            */
   char       name[8];   /* 08 name of program or device   */
};

struct LOL /*()*/
{
   char       unknown1[4];        /* 00 ??? */
   char       dos5;               /* 04 DOS 3 or 5 structures?    */
   char       unknown2[9];        /* 05 ??? */
   int        netbios_id;         /* 0E returned via func 5EH     */
   char       unknown3[10];       /* 10 ??? */
   int        share_retry;        /* 1A sharing retry             */
   int        share_delay;        /* 1C sharing delay             */
   void far * cur_buf;            /* 1E pointer to current buffer */
   unsigned   bufoff;             /* 22 offset within cur buf     */
   unsigned   first_mcb;          /* 24 segment of 1st MCB        */

   /* ----- address returned by INT 21H func 52H (DGROUP:26) ---- */

   void far   *first_dpb;         /* 26 linked list of DPBs       */
   void far   *first_dcb;         /* 2A linked list of SFTs       */
   LPDEV_HDR  clkdev;             /* 2E ptr to CLOCK device       */
   LPDEV_HDR  condev;             /* 32 ptr to CON device         */
   unsigned   bufsize;            /* 36 max sect size on any disk */
   void far * far *bufinfo;       /* 38 linked list of disk buffs */
   void far   *first_cds;         /* 3C ptr to array of CDSs      */
   void far   *first_fcb;         /* 40 list of SFTs for FCBs     */
   unsigned   numfcbs;            /* 44 # SFTs for use w/ FCBs    */
   uchar      numdrives;          /* 46 Number of Logical Drives  */
   uchar      lastdrive;          /* 47 Value of lastdrive        */
   LPDEV_HDR  first_dev;          /* 48 actual hdr of NULL device */
   uchar      nulbyte;            /* 5A just a 0                  */
   unsigned   specprogs;          /* 5B ??? */
   void far   *utilfuncs;         /* 5D ??? */
   void far   *ifschain;          /* 61 ??? */
   unsigned   numbufs;            /* 65 Total BUFFERS */
   unsigned   lookahead;          /* 67 ??? */
   uchar      bootdrive;          /* 69 A=1, B=2, C=3, etc */
   uchar      unknown;            /* 6A ??? */
   unsigned   extmemsize;         /* 6B Extended memory size in K */
};




#define DUMP 1		/* info types */
#define ASCII 2	/* info types */

struct info
{
	char *name;
	int	size;
	int	type;		/* 0=smart */
};


void far * SDA;		/* ptr into the Swappable Data Area */
void far * LOL;		/* ptr into the List Of Lists       */
uchar maxdrv;
int dosver;				/* determine the DOS major version */


/* PROTO  Version 1.00 */

/* File DUMPDOS.C */
int main(int argc,char *argv[]);
void dump_buff(void);
void dump_cds(void);
void dump_dpb(void);
void dump_sft(void);
void dump_mcb(void);
void dump_dev(void);
void dump_ioctl(void);
void dump_drive_tables(void);
void dump_sda(void);
void dump_lol(void);
void dump_struct(struct info *inf,void far *val);
void dumpascii(char far *p,unsigned len);
void dumpfar(char far *p,unsigned len);
void dump(char *buff, int length);

/* big enough to hold maximum ROM-DOS version string */
char szRevisionString[40];

/*
	Get a string from a far address.
*/
void GetFarString(char *szNear, char far *szFar)
{
	while(*szFar)
		*szNear++ = *szFar++;
	*szNear = 0;
}

int main(int argc,char *argv[])
{
	union REGS r;
	struct SREGS sr;
	int c,arg;
	unsigned char minor;
	int rd;

	/* get pointers into the DOS areas */
	r.h.ah = 0x52;
	intdosx(&r,&r,&sr);
	LOL = MK_FP(sr.es, r.x.bx - 8);
	r.x.ax = 0x5D06;
	intdosx(&r,&r,&sr);
	SDA = MK_FP(sr.ds, r.x.si);
	maxdrv = *((uchar far *)LOL + 0x29);

	// get dos version
	r.h.ah = 0x30;
	intdos(&r,&r);
	dosver = r.h.al;		// major version
	minor  = r.h.ah;		// minor version
	if((minor % 10) == 0)
		minor /= 10;

	// is it ROM-DOS?
	r.x.ax = 0x30DB;
	r.x.si = 0xB2D2;
	r.x.di = 3;
	r.x.cx = 0;
	intdosx(&r,&r,&sr);
	rd = (r.x.cx == 0xB2D2);
	if(rd)
		GetFarString(szRevisionString, MK_FP(sr.es, r.x.bx));

	/* sign-on */
	printf("DUMPDOS %s\n%s\n\n",FULLVERSION, COPYRIGHT);
	printf("DOS reports v%d.%d ",dosver,minor);
	if(rd)
		printf("(ROM-DOS Revision %s)\n",szRevisionString);
	else
		printf("(MS-DOS)\n");

	/* no arguments means quit with help */
	if(argc < 2)
	{
		printf("LOL = %04X:%04X,  SDA = %04X:%04X\n\n",
			FP_SEG(LOL),FP_OFF(LOL),
			FP_SEG(SDA),FP_OFF(SDA));

		printf("USAGE = DUMPDOS [BCDFLMSV*]\n");
		printf("\tB = Buffers\n");
		printf("\tC = Current Directory Structures\n");
		printf("\tD = Drive Parameter Blocks\n");
		printf("\tF = System File Tables\n");
		printf("\tI = IOCTL 440DH, 0860H\n");
		printf("\tL = List of Lists\n");
		printf("\tM = Memory Control Blocks\n");
		printf("\tS = Swappable Data Area\n");
		printf("\tT = IO.SYS Drive Tables\n");
		printf("\tV = Device List\n");
		printf("\t* = All of the above\n");

		return 0;
	}

	for(arg=1; arg<argc; ++arg)
	{
		for(c=0; c<strlen(argv[arg]); ++c)
		{
			switch(toupper(argv[arg][c]))
			{
				// dump an individual area
				case 'B': dump_buff();	break;
				case 'C': dump_cds();	break;
				case 'D': dump_dpb();	break;
				case 'F': dump_sft();	break;
				case 'I': dump_ioctl(); break;
				case 'L': dump_lol();	break;
				case 'M': dump_mcb();	break;
				case 'S': dump_sda();	break;
				case 'T': dump_drive_tables();	break;
				case 'V': dump_dev();   break;

				// dump all of 'em
				case '*':
					dump_buff();
					dump_cds();
					dump_dpb();
					dump_sft();
					dump_ioctl();
					dump_lol();
					dump_mcb();
					dump_sda();
					dump_drive_tables();
					dump_dev();
					break;

				default:
					printf("Bad Option '%c'\n",argv[arg][c]);
			}
		}
	}

	return 0;
}


/*
	---------------------------------------------------------------
	Display the buffer structures
	---------------------------------------------------------------
*/
struct info buf3info[] =
{
	{ "next", 4 },
	{ "drive", 1 },
	{ "flags", 1 },
	{ "sector", 2 },
	{ "copies", 1 },
	{ "distance", 1 },
	{ "dpb", 4 },
	{ "unknown", 2 },
	{ "buffer", 32, 1 },
	{ NULL }
};

struct info buf5info[] =
{
	{ "prev", 2 },
	{ "next", 2 },
	{ "drive", 1 },
	{ "flags", 1 },
	{ "sector", 4 },
	{ "copies", 1 },
	{ "distance", 2 },
	{ "dpb", 4 },
	{ "unknown1", 2 },
	{ "unknown2", 1 },
	{ "buffer", 32, 1 },
	{ NULL }
};

void dump_buff(void)
{
	uchar far * buf;
	int count = 0;
	unsigned startoff;

	buf = (void far *)(*(long far *)((uchar far *)LOL + 0x1A));

	if(dosver <= 3)
	{
		do
		{
			printf("\nBuffer Structure %d\n",count);
			dump_struct(buf3info, buf);

			++count;
			buf = (void far *)(((struct BUFLIST far *)buf)->next);
		} while(FP_OFF(buf) != 0xFFFF);
	}

	/* DOS 4 & 5 */
	else
	{
		printf("\nBuffer Info at %04X:%04X\n",FP_SEG(buf),FP_OFF(buf));
		buf = (void far *)(*(long far *)buf);
		startoff = FP_OFF(buf);
		do
		{
			printf("\nBuffer Structure %d\n",count);
			dump_struct(buf5info, buf);

			++count;
			buf = MK_FP(FP_SEG(buf), ((struct BUFLIST far *)buf)->next);

		} while(FP_OFF(buf) != startoff);
	}

}


struct info cds3info[] =
{
	{ "cwd", 67, 1 },
	{ "status", 2 },
	{ "dpb", 4 },
	{ "subdir", 2 },
	{ "unknown1", 2 },
	{ "unknown2", 2 },
	{ "skip", 2 },
	{ NULL }
};

struct info cds5info[] =
{
	{ "cwd", 67, 1 },
	{ "status", 2 },
	{ "dpb", 4 },
	{ "subdir", 2 },
	{ "unknown1", 2 },
	{ "unknown2", 2 },
	{ "skip", 2 },
	{ "unknown3", 1 },
	{ "ifsptr", 4 },
	{ "unknown4", 2 },
	{ NULL }
};

struct info cds7info[] =
{
	{ "cwd", 67, 1 },
	{ "status", 2 },
	{ "dpb", 4 },
	{ "subdir", 4 },
	{ "unknown2", 2 },
	{ "skip", 2 },
	{ "unknown3", 1 },
	{ "ifsptr", 4 },
	{ "unknown4", 2 },
	{ NULL }
};



/*
	The CDSs are an array that is pointed to by the LOL
	at offset 0x1E.  It is simply an array, no "linked
	list" is involved at all.

*/
void dump_cds(void)
{
	uchar far * cds;
	int i;
	uchar drvlet = 'A';

	cds = (void far *)(*(long far *)((uchar far *)LOL + 0x1E));
	for(i=0; i<maxdrv; ++i)
	{
		printf("\nCurrent Directory Structure for Drive %c\n",drvlet);

		if(dosver <= 3)
		{
			dump_struct(cds3info, cds);
			cds += sizeof(CDS3);
		}
		else if(dosver <= 7)
		{
			dump_struct(cds5info, cds);
			cds += sizeof(CDS5);
		}
		else
		{
			dump_struct(cds7info, cds);
			cds += sizeof(CDS7);
		}
		++drvlet;
	}
}


/*
	---------------------------------------------------------------
	Display the Drive Parameter Blocks for all drives
	---------------------------------------------------------------
*/
struct info dpb3info[] = {
	{ "drive", 1 },
	{ "unit", 1 },
	{ "bytes_per_sec", 2 },
	{ "ms_spc", 1 },
	{ "shift", 1 },
	{ "fat_start", 2 },
	{ "num_fats", 1 },
	{ "max_dir_ent", 2 },
	{ "data_start", 2 },
	{ "hi_clus", 2 },
	{ "fat_len", 1 },
	{ "dir_start", 2 },
	{ "device", 4 },
	{ "media", 1 },
	{ "rebuild", 1 },
	{ "next", 4 },
	{ "newclus", 2 },
	{ "freeclus", 2 },
	{ NULL }
	};

struct info dpb5info[] = {
	{ "drive", 1 },
	{ "unit", 1 },
	{ "bytes_per_sec", 2 },
	{ "ms_spc", 1 },
	{ "shift", 1 },
	{ "fat_start", 2 },
	{ "num_fats", 1 },
	{ "max_dir_ent", 2 },
	{ "data_start", 2 },
	{ "hi_clus", 2 },
	{ "fat_len", 2 },
	{ "dir_start", 2 },
	{ "device", 4 },
	{ "media", 1 },
	{ "rebuild", 1 },
	{ "next", 4 },
	{ "newclus", 2 },
	{ "freeclus", 2 },
	{ NULL }
	};

struct info dpb7info[] = {
	{ "drive", 1 },
	{ "unit", 1 },
	{ "bytes_per_sec", 2 },
	{ "ms_spc", 1 },
	{ "shift", 1 },
	{ "fat_start", 2 },
	{ "num_fats", 1 },
	{ "max_dir_ent", 2 },
	{ "data_start", 2 },
	{ "hi_clus", 2 },
	{ "fat_len", 2 },
	{ "dir_start", 2 },
	{ "device", 4 },
	{ "media", 1 },
	{ "rebuild", 1 },
	{ "next", 4 },
	{ "newclus", 2 },
	{ "freeclus", 2 },
   { "freeclus_hi", 2 },
   { "flags", 2 },
   { "FSInfoSec", 2 },
   { "BkUpBootSec", 2 },
   { "first_sector", 4 },
   { "max_cluster", 4 },
   { "fat_size", 4 },
   { "root_clus", 4 },
   { "next_free", 4 },
	{ NULL }
	};

void dump_dpb(void)
{
	void far * dpb;
	uchar drvlet = 'A';

	dpb = (void far *)(*(long far *)((uchar far *)LOL + 0x8));

	do
	{
		printf("\nDrive Parameter Block for Drive %c\n",drvlet);
		dump_struct(dosver <= 3 ? dpb3info : ((dosver <= 6) ? dpb5info : dpb7info), dpb);

		if(dosver <= 3)
			dpb = ((DPB3 far *)dpb)->next;
		else if(dosver <= 7)
			dpb = ((DPB5 far *)dpb)->next;
		else
			dpb = ((DPB7 far *)dpb)->next;

		++drvlet;
	} while(FP_OFF(dpb) != 0xFFFF);
}


/*
	---------------------------------------------------------------
	Display the System File Tables for all drives
	---------------------------------------------------------------
*/
struct info sft3info[] =
{
	{ "handles", 2 },
	{ "rwmode", 2 },
	{ "attr", 1},
	{ "ioctl", 2 },
	{ "device", 4 },
	{ "start", 2 },
	{ "time", 2 },
	{ "date", 2 },
	{ "size", 4 },
	{ "ptr", 4 },
	{ "relclus", 2 },
	{ "absclus", 2 },
	{ "dirsect", 2 },
	{ "dirent", 1},
	{ "name", 11, 2 },
	{ "shareptr", 4 },
	{ "shareid", 2 },
	{ "owner", 2 },
	{ "shareoff", 2 },
	{ NULL }
};

struct info sft5info[] =
{
	{ "handles",    2   },
	{ "rwmode",    2   },
	{ "attr",    1      },
	{ "ioctl",    2   },
	{ "device", 4 },
	{ "start",    2   },
	{ "time",    2   },
	{ "date",    2   },
	{ "size",    4      },
	{ "offset",    4      },
	{ "relclus",    2   },
	{ "dirsec",    4      },
	{ "dirent",    1      },
	{ "name", 11, 2 },
   { "shareptr", 4},
	{ "shareid",    2   },
	{ "owner",    2   },
	{ "shareoff",    2   },
	{ "absclus",    2   },
	{ "ifsptr",    4      },
	{ NULL }
};

struct info sft7info[] =
{
	{ "handles",    2   },
	{ "rwmode",    2   },
	{ "attr",    1      },
	{ "ioctl",    2   },
	{ "device", 4 },
	{ "relclushi",    2   },
	{ "time",    2   },
	{ "date",    2   },
	{ "size",    4      },
	{ "offset",    4      },
	{ "relcluslo",    2   },
	{ "dirsec",    4      },
	{ "dirent",    1      },
	{ "name", 11, 2 },
   { "start", 4},
	{ "shareid",    2   },
	{ "owner",    2   },
	{ "shareoff",    2   },
	{ "absclus",    4   },
	{ "unknown",    2  },
	{ NULL }
};


struct info dcbinfo[] =
{
	{ "next", 4 },
	{ "numsft", 2 },
	{ NULL }
};

/*
	The SFTs are pointed to by a far pointer in the LOL at
	offset 0CH.  The list is a hybrid of arrays and linked
	lists, called Device Control Blocks.
*/
void dump_sft(void)
{
	struct DCB3 far *dcb;
	uchar far * sft;
	int num,i;
	int count = 0;

	dcb = (void far *)(*(long far *)((uchar far *)LOL + 0xC));

	do
	{
		num = ((struct DCB3 far *)dcb)->numsft;
		sft = (void far *)((uchar far *)dcb + 6);

		printf("\nDCB at %04X:%04X contains %d SFTs\n",
			FP_SEG(dcb),FP_OFF(dcb),num);
		dump_struct(dcbinfo,dcb);
		for(i=0; i<num; ++i)
		{
			printf("\nSFT %d at %04X:%04X\n",count,FP_SEG(sft),FP_OFF(sft));
			if(dosver <= 3)
			{
				dump_struct(sft3info, sft);
			   sft += sizeof(struct SFT3);
			}
			else if(dosver <= 7)
			{
				dump_struct(sft5info, sft);
			   sft += sizeof(struct SFT5);
			}
			else
			{
				dump_struct(sft7info, sft);
			   sft += sizeof(struct SFT7);
			}
			++count;
		}

		dcb = ((struct DCB3 far *)dcb)->next;
	} while(FP_OFF(dcb) != 0xFFFF);
}


struct info info_440D_60[] =
{
	{ "SpecFunc", 1 },
	{ "DevType", 1 },
	{ "DevAttr", 2 },
	{ "Cylinders", 2 },
	{ "Media", 1 },
	{ "BytesPerSec", 2 },
	{ "SecPerClus", 1 },
	{ "ResSectors", 2 },
	{ "NumFATs", 1 },
	{ "DirEntries", 2 },
	{ "Sectors", 2 },
	{ "Media", 1 },
	{ "FATSecs", 2 },
	{ "SecPerTrak", 2 },
	{ "Heads", 2 },
	{ "Hidden", 4 },
	{ "HugeSectors", 4 },
	{ NULL }
};

char iobuff[80];

void dump_ioctl(void)
{
	union REGS r;
	int drv;

	drv = 1;
	while(1)
	{
		r.x.ax = 0x440D;
		r.x.bx = drv;
		r.x.cx = 0x860;
		r.x.dx = (unsigned)iobuff;
		intdos(&r,&r);
		if(r.x.cflag)
			break;

		printf("IOCTL Drive %c\n",drv+'A'-1);
		dump_struct(info_440D_60,iobuff);
		printf("\n");
		++drv;
	}
}

struct info info_io_drv_tbl[] =
{
	{ "Next ", 4 },
	{ "INT13 Drv", 1 },
	{ "DOS Drv", 1 },
	{ "BPB.BytesPerSec", 2 },
	{ "BPB.SecPerClus", 1 },
	{ "BPB.ResSectors", 2 },
	{ "BPB.NumFATs", 1 },
	{ "BPB.DirEntries", 2 },
	{ "BPB.Sectors", 2 },
	{ "BPB.Media", 1 },
	{ "BPB.FATSecs", 2 },
	{ "BPB.SecPerTrak", 2 },
	{ "BPB.Heads", 2 },
	{ "BPB.Hidden", 4 },
	{ "BPB.HugeSectors", 4 },
	{ "16 Bit Fat", 1 },
	{ "Opened", 2 },
	{ "DevType", 1 },
	{ "DevAttr", 2 },
	{ "Cylinders", 2 },
	{ "maxBPB.BytesPerSec", 2 },
	{ "maxBPB.SecPerClus", 1 },
	{ "maxBPB.ResSectors", 2 },
	{ "maxBPB.NumFATs", 1 },
	{ "maxBPB.DirEntries", 2 },
	{ "maxBPB.Sectors", 2 },
	{ "maxBPB.Media", 1 },
	{ "maxBPB.FATSecs", 2 },
	{ "maxBPB.SecPerTrak", 2 },
	{ "maxBPB.Heads", 2 },
	{ "maxBPB.Hidden", 4 },
	{ "maxBPB.HugeSectors", 4 },
	{ "unknown", 6, DUMP },
	{ "Cur Track", 1},
	{ "Ticks", 4 },
	{ "Volume", 12, ASCII },
	{ "Serial #", 4 },
	{ "Fatstr", 9, ASCII },
	{ NULL }
};

struct info info_io_drv_tbl7[] =
{
	{ "Next ", 4 },
	{ "INT13 Drv", 1 },
	{ "DOS Drv", 1 },
	{ "BPB.BytesPerSec", 2 },
	{ "BPB.SecPerClus", 1 },
	{ "BPB.ResSectors", 2 },
	{ "BPB.NumFATs", 1 },
	{ "BPB.DirEntries", 2 },
	{ "BPB.Sectors", 2 },
	{ "BPB.Media", 1 },
	{ "BPB.FATSecs", 2 },
	{ "BPB.SecPerTrak", 2 },
	{ "BPB.Heads", 2 },
	{ "BPB.Hidden", 4 },
	{ "BPB.HugeSectors", 4 },
   { "BPB.BigSectorsPerFat", 2 },
   { "BPB.BigSectorsPerFatHi", 2 },
   { "BPB.ExtFlags", 2 },
   { "BPB.FS_Version", 2 },
   { "BPB.RootDirStrtClus", 2 },
   { "BPB.RootDirStrtClusHi", 2 },
   { "BPB.FSInfoSec", 2 },
   { "BPB.BkUpBootSec", 2 },
   { "BPB.Reserved[6]", 12 },
	{ "16 Bit Fat", 1 },
	{ "Opened", 2 },
	{ "DevType", 1 },
	{ "DevAttr", 2 },
	{ "Cylinders", 2 },
	{ "maxBPB.BytesPerSec", 2 },
	{ "maxBPB.SecPerClus", 1 },
	{ "maxBPB.ResSectors", 2 },
	{ "maxBPB.NumFATs", 1 },
	{ "maxBPB.DirEntries", 2 },
	{ "maxBPB.Sectors", 2 },
	{ "maxBPB.Media", 1 },
	{ "maxBPB.FATSecs", 2 },
	{ "maxBPB.SecPerTrak", 2 },
	{ "maxBPB.Heads", 2 },
	{ "maxBPB.Hidden", 4 },
	{ "maxBPB.HugeSectors", 4 },
   { "maxBPB.BigSectorsPerFat", 2 },
   { "maxBPB.BigSectorsPerFatHi", 2 },
   { "maxBPB.ExtFlags", 2 },
   { "maxBPB.FS_Version", 2 },
   { "maxBPB.RootDirStrtClus", 2 },
   { "maxBPB.RootDirStrtClusHi", 2 },
   { "maxBPB.FSInfoSec", 2 },
   { "maxBPB.BkUpBootSec", 2 },
   { "maxBPB.Reserved[6]", 12 },
	{ "Cur Track", 1},
	{ "Ticks", 4 },
	{ "Volume", 12, ASCII },
	{ "Serial #", 4 },
	{ "Fatstr", 9, ASCII },
	{ NULL }
};

/*
	IO.SYS Drive Tables as defined in Undoc DOS 2e
*/
void dump_drive_tables(void)
{
	union REGS r;
	struct SREGS sr;
	uchar far * io_drv_tbl;
	int drv;

	printf("\nIO.SYS Drive Tables\n");

	// get the address using INT 2F, 0803H, returned in DS:SI
	r.x.ax = 0x0803;
	int86x(0x2F, &r, &r, &sr);
	if(r.x.cflag)
	{
		printf("Not supported!\n");
		return;
	}
	io_drv_tbl = MK_FP(sr.ds,r.x.di);

	while((unsigned)io_drv_tbl != 0xFFFF)
	{
		// determine the drive
		drv = *(io_drv_tbl + 5);

		// display the info
		printf("IO.SYS Drive Table for drive %c\n",drv+'A');
		dump_struct(((dosver <= 6) ? info_io_drv_tbl : info_io_drv_tbl7), io_drv_tbl);
		printf("\n");

		// on to next
		io_drv_tbl = (uchar far *)(*(ulong far *)io_drv_tbl);
	}
}


/*
	---------------------------------------------------------------
	Display the MCB chain
	---------------------------------------------------------------
*/

void gather_name(char far *p, char *name)
{
	int i;

	p += 8;
	for(i=0; i<8 && *p && isprint(*p); ++i)
		name[i] = *p++;
	if(i && (i==8 || *p == 0))
		name[i] = 0;
	else
		*name = 0;
}

char * mcb_ownerof(struct MCB far * mcb)
{
	static char name[9];
	#define SYSTEM 8

	// default to no name
	*name = 0;

	// this MCB might have a name
	if(FP_SEG(mcb) +1 == mcb->owner || mcb->owner == SYSTEM)
		gather_name((char far *)mcb, name);

	// MCB does NOT have name, but it's owner might
	else if(mcb->owner)
		gather_name(MK_FP(mcb->owner-1,0), name);

	else
		strcpy(name, "--free--");

	return name;
}

char * mcb_nameof(char id)
{
	char * idstr;
	switch(id)
	{
		case 'D': idstr = "DEVICE"; break;
		case 'E': idstr = "APPENDAGE"; break;	// ?
		case 'I': idstr = "IFS DRIVER"; break;
		case 'F': idstr = "SFTs"; break;
		case 'X': idstr = "FCBs"; break;
		case 'C': idstr = "WORKSPACE"; break;	// ?
		case 'B': idstr = "BUFFERS"; break;
		case 'L': idstr = "CDS"; break;
		case 'S': idstr = "STACKS"; break;
		case 'T': idstr = "TRANSIENT CODE"; break;
		default:  idstr = "unknown??"; break;
	}
	return idstr;
}

void set_umb_link(bool on)
{
	union REGS r;
	r.x.ax = 0x5803;
	r.x.bx = on;
	intdos(&r,&r);
}

void dump_mcb(void)
{
	unsigned mcbseg = *(((unsigned far *)LOL)+3);
	unsigned mcbseg2;
	struct MCB far *mcb;

	// display contents of master chain
	mcb = MK_FP(mcbseg,0);
	if(mcb->owner == SYSTEM)
	{
		printf("\nSystem IDs at %04X:0000\n", mcbseg);
		mcbseg2 = mcbseg + mcb->para_cnt + 1;
		mcb = MK_FP(mcbseg+1,0);
		do
		{
			printf("MCB %04X(%04X), id %c owner %04X paras %04X  ",mcbseg,
				FP_SEG(mcb),mcb->id,mcb->owner,mcb->para_cnt);
			printf("%s\n", (mcb->id == 'D') ? mcb_ownerof(mcb) :
				mcb_nameof(mcb->id));
			mcb = MK_FP(FP_SEG(mcb) + mcb->para_cnt + 1, 0);
		} while(FP_SEG(mcb) && FP_SEG(mcb) < mcbseg2);
	}

	set_umb_link(1);

	// display normal MCB (and UMB) chains and owners
	printf("\nMCB Chain begins at %04X:0000\n",mcbseg);
	do
	{
		mcb = MK_FP(mcbseg,0);
		printf("MCB %04X, id %c owner %04X paras %04X  %s\n",mcbseg,
			mcb->id,mcb->owner,mcb->para_cnt, mcb_ownerof(mcb));
		mcbseg += mcb->para_cnt + 1;
	} while(mcb->id != 'Z');

	set_umb_link(0);

	printf("Top %04X\n", mcbseg);
}

/*
	---------------------------------------------------------------
	Display the Device Header Chain
	---------------------------------------------------------------
*/
struct info devinfo[] =
{
	{ "next",	4 },
	{ "attribute", 2 },
	{ "strategy", 2 },
	{ "service", 2 },
	{ "name", 8, 1 },
	{ NULL }
};

void dump_dev(void)
{
	LPDEV_HDR dev;

	dev = (LPDEV_HDR)((void far *)((uchar far *)LOL + 0x2A));

	printf("\nDevice Header Chain\n");
	while(FP_OFF(dev) != 0xFFFF)
	{
		dump_struct(devinfo,dev);
		dev = dev->next;
	}
}


/*
	---------------------------------------------------------------
	Display the Swappable Data Area in readable form
	---------------------------------------------------------------
*/
struct info sda3info[] =
{
	{ "CritERR",	1 },
	{ "InDOS",	1 },
	{ "sda_drive",	1 },
	{ "err_locus",	1 },
	{ "error_no",	2 },
	{ "err_class_act",	2 },
	{ "unused1",	4, 1 },
	{ "DTA",	4 },
	{ "current_psp",	2 },
	{ "sp_x_int23",	2 },
	{ "last_rc",	2 },
	{ "current_drv", 1 },
	{ "BREAK_FLAG",	1 },
	{ "int21_ax",	2 },
	{ "shrnet_psp",	2 },
	{ "net_mc_no",	2 },
	{ "unknown2", 16,	1 },
	{ "day",	1 },
	{ "month",	1 },
	{ "year",	2 },
	{ "day_count",	2 },
	{ "day_of_week",	1 },
	{ "unknown3", 3,	1 },
	{ "devreqhdr1", 26,	1 },
	{ "dev_drvptr",	4 },
	{ "devreqhdr2", 22,	1 },
	{ "devreqhdr3", 22,	1 },
	{ "unknown4", 8,	1 },
	{ "clock_txd", 6,	1 },
	{ "unknown5", 2,	1 },
	{ "sda_fname1", 128,	1 },
	{ "sda_fname2", 128,	1 },
	{ "sda_sdb", sizeof(struct SDB5), 1 },
	{ "sda_ffb", sizeof(struct DIR5), 1 },
	{ "sda_cds", sizeof(CDS5), 1 },
	{ "sda_ename1", 11,	1 },
	{ "unknown6",	1 },
	{ "sda_ename2", 11,	1 },
	{ "unknown7", 11,	1 },
	{ "sda_srchattr",	1 },
	{ "sda_openmode",	1 },
	{ "unknown8", 16,	1 },
	{ "criterr_dpbptr",	4 },
	{ "int21_ss_sp",	4 },
	{ "unknown9", 16,	1 },
	{ "sda_sftptr",	4 },
	{ "sda_cdsptr",	4 },
	{ "unknown10", 72,	1 },
	{ "ren_sdb", sizeof(struct SDB5), 1 },
	{ "ren_ffb", sizeof(struct DIR5), 1 },
	{ NULL }
};

struct info sda5info[] =
{
	{ "CritERR",	1 },			// 2CEH
	{ "InDOS",	1 },
	{ "sda_drive",	1 },
	{ "err_locus",	1 },
	{ "error_no",	2 },
	{ "err_class_act",	2 },
	{ "unused1",	4, 1 },
	{ "DTA",	4 },
	{ "current_psp",	2 },		// 2DEH
	{ "sp_x_int23",	2 },
	{ "_return_code",	2 },
	{ "CUR_DRIVE", 1 },
	{ "BREAK_FLAG",	1 },
	{ "unknown1",  2 },
	{ "int21_ax",	2 },
	{ "shrnet_psp",	2 },
	{ "net_mc_no",	2 },
	{ "unknown2", 16,	1 },
	{ "day",	1 },
	{ "month",	1 },
	{ "year",	2 },				// 300H
	{ "day_count",	2 },
	{ "day_of_week",	1 },
	{ "unknown3", 3,	1 },
	{ "devreqhdr1", 30,	1 },
	{ "dev_drvptr",	4 },
	{ "devreqhdr2", 22,	1 },
	{ "devreqhdr3", 30,	1 },
	{ "unknown4", 6,	1 },
	{ "clock_txd", 6,	1 },		// 364H
	{ "unknown5", 2,	1 },
	{ "sda_fname1", 128,	1 },	// 36C
	{ "sda_fname2", 128,	1 },
	{ "sda_sdb", sizeof(struct SDB5), 1 },
	{ "sda_ffb", sizeof(struct DIR5), 1 },
	{ "sda_cds", 88, 1 },
	{ "sda_ename1", 12,	1 },	// 4F9H
	{ "sda_ename2", 12,	1 },
	{ "unknown7", 10,	1 },
	{ "sda_srchattr",	1 },		// 51BH
	{ "sda_openmode",	1 },
	{ "unknown8", 17,	1 },
	{ "criterr_dpbptr",	4 },
	{ "int21_ss_sp",	4 },
	{ "unknown9", 16,	1 },
	{ "media ID", 1 },
	{ "unknown10", 5 },
	{ "sda_sftptr",	4 },
	{ "sda_cdsptr",	4 },
	{ "unknown11", 8 },
	{ "JFT ptr", 4 },
	{ "fname1 ptr", 2 },			// 560H
	{ "fname2 ptr", 2 },
	{ "unknown11", 52,	1 },
	{ "bx_ds_tmp", 6 },
	{ "prev stack", 4 },
	{ "unknown12", 9 },
	{ "spo_act", 2 },
	{ "spo_attr", 2 },
	{ "spo_mode", 2 },
	{ "unknown 13", 29 },
	{ "ren_sdb", sizeof(struct SDB5), 1 },	// 5CE
	{ "ren_ffb", sizeof(struct DIR5), 1 },
	{ NULL }
};

void dump_sda(void)
{
	printf("\nSwappable Data Area  %04X:%04X\n",FP_SEG(SDA),FP_OFF(SDA));
	dump_struct(dosver<=3? sda3info : sda5info,SDA);
}



/*
	---------------------------------------------------------------
	Display the List Of Lists in a readable form
	---------------------------------------------------------------
*/
struct info lol3info[] =
{
	{ "cur_buf", 4 },
	{ "bufoff", 2 },
	{ "first_mcb", 2 },
	{ "first_dpb", 4 },
	{ "first_sft", 4 },
	{ "clkdev", 4 },
	{ "condev", 4 },
	{ "bufsize", 2 },
	{ "first_buf", 4 },
	{ "cds", 4 },
	{ "first_fcb", 4 },
	{ "numfcb", 2 },
	{ "numdrives", 1 },
	{ "lastdrive", 1 },
	{ "first_dev", 18, 1 },
	{ NULL }
};

struct info lol5info[] =
{
	{ "cur_buf", 4 },
	{ "bufoff", 2 },
	{ "first_mcb", 2 },
	{ "first_dpb", 4 },
	{ "first_sft", 4 },
	{ "clkdev", 4 },
	{ "condev", 4 },
	{ "bufsize", 2 },
	{ "first_buf", 4 },
	{ "cds", 4 },
	{ "first_fcb", 4 },
	{ "numfcb", 2 },
	{ "numdrives", 1 },
	{ "lastdrive", 1 },
	{ "first_dev", 18, 1 },
   { "unknown1", 1 },
   { "specprogs", 2 },
   { "utilfuncs", 4 },
   { "ifschain", 4 },
   { "numbuffers", 2 },
   { "lookahead", 2 },
   { "bootdrive", 1 },
   { "unknown2", 1 },
   { "extmemsize", 2 },
	{ NULL }
};

void dump_lol(void)
{
	printf("\nList Of Lists  %04X:%04X\n",FP_SEG(LOL),FP_OFF(LOL) + 8);
	dump_struct(dosver <=3 ? lol3info : lol5info,LOL);
}


/*
	----------------------------------------------------------------

			LOWER LEVEL UTILITIES

	----------------------------------------------------------------
*/


/*
	Given an info structure, dump its contents
*/
void dump_struct(struct info *inf,void far *val)
{
	unsigned off = 0;

	while(inf->name)
	{
		printf("%04X:%04X  %04X  %-29s ",FP_SEG(val),FP_OFF(val),off,inf->name);

		if(inf->type == DUMP)
			dumpfar(val,inf->size);
		else if(inf->type == ASCII)
			dumpascii(val,inf->size);
		else if(inf->size == 1)
			printf("%02X\n",*(uchar far *)val);
		else if(inf->size == 2)
			printf("%04X\n",*(unsigned far *)val);
		else if(inf->size == 4)
			printf("%04X:%04X\n",*((unsigned far *)val+1),*(unsigned far *)val);
		else
			dumpfar(val,inf->size);

		/* update pointers */
		(uchar far *)val += inf->size;
		off += inf->size;
		++inf;
	}
}

void dumpascii(char far *p,unsigned len)
{
	printf("\"");
	while(len--)
	{
		// don't print nul terminators
		if(!len && *p==0)
			/*do nothing*/;
		else
			printf("%c",*p++);
	}
	printf("\"\n");
}

void dumpfar(char far *p,unsigned len)
{
	unsigned i,n;
	char buff[16];

	printf("\n");
	while(len)
	{
		printf("%11s","");
		n= min(16,len);
		for(i=0;i<n;++i)
			buff[i]= *p++;
		dump(buff,n);
		len-= n;
	}
}

void dump(char *buff, int length)
{
	int start=0, len, i;
	uchar *buffer = (uchar *)buff;

	while(length>0)
	{
		len=min(length,16);
		for(i=0;i<16;++i)
		{
			printf(i<len ? "%02X " : "   ",buffer[start+i]);
			if(i==7)
				printf(i<len ? "| " : "  ");
		}
		printf(" ");
		for(i=0;i<16;++i)
		{
			if(i<len)
				printf(isprint(buffer[start+i]) ? "%c" : ".",buffer[start+i]);
			else
				printf(" ");
		}
		printf("\n");
		length -= len;
		start  += len;
	}
}
