//
//   $Id: EXEHDR.H 1.4 2002/10/16 21:48:58Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/**********************************************************

	exehdr.h -- structure of .EXE file header.

   Copyright (c) 1989-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

***********************************************************/
/*
struct rel_item {
	unsigned short offset;
	unsigned short segment;
};
*/
#define EXESIG  (('Z' << 8) | 'M')


struct exehdr {
  unsigned short sig;     /* MS-LINK's signature == 4D5A hex */
  unsigned short imgmod;  /* image length mod 512 (bytes) */
  unsigned short imglen;  /* image length in 512-byte pages (including hdr) */
  unsigned short nreloc;  /* Number of relocation table items */
  unsigned short hdrlen;  /* Size of header in paragraphs */
  unsigned short minpar;  /* Minimum paragraphs required above loaded program */
  unsigned short maxpar;  /* Maximum paragraphs required above loaded program */
  unsigned short ssdsp;   /* Displacement of SS within module (paragraphs) */
  unsigned short spofs;   /* Offset to be put in SP when executing */
  unsigned short cksum;   /* Neg. sum of all words in file, ignoring overflow */
  unsigned short ipofs;   /* Offset to be put in IP when executing */
  unsigned short csdsp;   /* Displacement of CS within module (paragraphs) */
  unsigned short reldsp;  /* Displacement of 1st reloc item in file (bytes) */
  unsigned short ovlnum;  /* Overlay no. (0 for resident part) */
};


struct rxehdr {
  unsigned short sig;     /* MS-LINK's signature == 4D5A hex */
  unsigned short imgmod;  /* image length mod 512 (bytes) */
  unsigned short imglen;  /* image length in 512-byte pages (including hdr) */
  unsigned short nreloc;  /* Numbermseg; */
  unsigned short hdrlen;  /* Size of header in paragraphs */
  unsigned short minpar;  /* Minimum paragraphs required above loaded program */
  unsigned short maxpar;  /* Maximum paragraphs required above loaded program */
  unsigned short ssdsp;   /* Displacement of SS within module (paragraphs) */
  unsigned short spofs;   /* Offset to be put in SP when executing */
  unsigned short cksum;   /* Neg. sum of all words in file, ignoring overflow */
  unsigned short ipofs;   /* Offset to be put in IP when executing */
  unsigned short csdsp;   /* Displacement of CS within module (paragraphs) */
  unsigned short reldsp;  /* Displacement of 1st reloc item in file (bytes) */
  unsigned short ovlnum;  /* Overlay no. (0 for resident part) */
			  /* Used for RXE support only NOT part of EXE hdr */
  unsigned short ds_dsp;  /* Displacement of 1st DS value for runtime fixup */
  unsigned short ld_seg;  /* Segment of start of RXE in memory */
  unsigned short rxe_int; /* Interrupt used for RXE support */
  unsigned short cd_seg;  /* Segment of start code of RXE in memory */
  unsigned short cd_len;  /* Length in paragraphs of RXE code block */
  unsigned short cd_sum;  /* Check sum of RXE code block */
};



