//
//   $Id: FINDFILE.C 1.5 2002/10/16 21:49:50Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/**********************************************************

	FINDFILE.C

   Copyright (c) 1989-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

	This file contains the findfirst/next routines used by
	ATTRIB and TREE.

**********************************************************/
#include <dos.h>
#include <mem.h>
#include <stdio.h>

#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "dllfn.h"

/* PATH.C */
void add_path(char *path, char *sub_dir);
void del_path(char *path);


#define CARRY 1

int entry_count = 0;

int find_file(char *fname, PFIND f, unsigned attr, void (*func)())
{
	int count = 0;
	char path[65];
	bool fSuccess;

	++entry_count;

	/* get the full path */
	*path = 0;
	SmartExpandPath(FULLPATH_LONGNAME, fname, path);

	fSuccess = SmartFindFirst(A_NORMAL, path, f);
	del_path(path);

	while(fSuccess)
	{
		/* Ignore "." and ".." */
		if(f->name[0] != '.' && ((!(attr&0x10) || (f->attr & 0x10))))
		{
			++count;
			add_path(path, f->name);
			(*func)(f->name, f->attr, path);	/* Call User fuction */
			del_path(path);
		}

	/*	Find Next */
		fSuccess = SmartFindNext(f);
	}

	--entry_count;

	return count;
}

char *find_vol_label(int drive)
{
	static FIND f;
	char *slabel = "A:\\*.*";
	static char label[12];
	bool fSuccess;

	slabel[0] = 'A' + drive;

	fSuccess = SmartFindFirst(A_VOLUME, slabel, &f);
	//  does this work ???
	memcpy(label, f.name, 8);
	memcpy(label+8, f.name+9, 3);
	if(!fSuccess)
		return NULL;
	else
		return label;
}
