//
//   $Id: FORMAT.H 1.7 2002/10/16 21:50:26Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//  FORMAT.H
//
//  Copyright (c) 1999-2002 Datalight, Inc.
//  All Rights Reserved.
//  Datalight Confidential and Proprietary
//
//  HISTORY:
//
//  09-08-1999  bt  Created
//

#define MAX_SPT				0x3f
#define MAX_SECTOR_SIZE		2048


//  Constants for drive locking (LIKE MSDOS 7.1 FORMAT)
//
#define FORMAT_LOCK_LEVEL				0
#define FORMAT_LOCK_PERMISSIONS		0


//  Error Code indexes
//
#define ERR_CANTFORMAT		0
#define ERR_WRITEPROTECT   1
#define ERR_NO_PARM  		2
#define ERR_ABORT				3
#define ERR_NOMEMORY			4
#define ERR_RESIZE			5
#define ERR_RELEASE			6
#define ERR_NO_DRIVE 		7
#define ERR_OPEN     		8
#define ERR_READ				9
#define ERR_WRITE				10
#define ERR_CLOSING  		11
#define ERR_DATETIME 		12
#define ERR_BADDRIVE    	13
#define ERR_CREATE			14
#define ERR_DRVNOTREADY		15
#define ERR_NOT13				16
#define ERR_LOCK				17
#define ERR_UNLOCK			18
#define ERR_BADSIZE			19
#define ERR_NOQUICK			20
#define ERR_BADCLUSTERS		21
#define ERR_QUICKSIZE		22
#define ERR_INVALIDSWITCH	23

#define MS_ERR_INVALID_DRIVE        1
#define MS_ERR_UNSUPORTED_DRIVE		2
#define MS_ERR_CTRL_BREAK				3
#define MS_ERR_FATAL_ERROR 			4
#define MS_ERR_NO_PROCEED				5

struct TRACK_TABLE{
	unsigned uNumber;
	unsigned uSize;
};

typedef struct DRIVE_PARMS DRIVE_PARMS;
typedef DRIVE_PARMS * pDRIVE_PARMS;
typedef DRIVE_PARMS far * lpDRIV_PARMS;
struct DRIVE_PARMS{
	struct DEVICE_PARMS Parms;
	uchar  ucReserved[32];
	unsigned uSectorsInTrack;
	struct TRACK_TABLE TrackInfo[MAX_SPT];
};


//  Specify the maximum switches in the boolean switch array
//
#define MAX_BOOLEAN_SWITCHES		13

//  Indexes into the boolean command line switches array
//
#define QUICK_FORMAT			0
#define USER_SIZE				1
#define COPY_SYSTEM			2
#define DONT_HIDE_SYSTEM	3
#define CONFIRM_DELETE		4
#define HIDE_SIGNON			5
#define HAVE_LABEL			6
#define DONT_CONFIRM			7
#define FORCE_360K			8
#define FORCE_720K			9
#define UNCONDITIONAL		10
#define QF_UNFORMATTED		11
#define AUTOTEST				12

//  Macros for boolean command line switches
//
#define IsQuickFormat()			(fSwitches[QUICK_FORMAT]     != 0)
#define DoUserSize()				(fSwitches[USER_SIZE]        != 0)
#define DoCopySystem()			(fSwitches[COPY_SYSTEM]      != 0)
#define DoHideSystemFiles()	(fSwitches[DONT_HIDE_SYSTEM] == 0)
#define DoConfirmDelete()		(fSwitches[CONFIRM_DELETE]   != 0)
#define DoHideSignon()			(fSwitches[HIDE_SIGNON]      != 0)
#define DoHaveLabel()			(fSwitches[HAVE_LABEL]       != 0)
#define DoConfirmFormat()		(fSwitches[DONT_CONFIRM]     == 0)
#define QuickFormatUnformattedDrive() (fSwitches[QF_UNFORMATTED] != 0)
#define Autotest()				(fSwitches[AUTOTEST] != 0)


//  Specify the different BPB types
//
#define BPB_TYPE_UNKNOWN	5



//  Constants for which boot sector to use
//
#define USE_FAT16_BOOT_SECTOR		0
#define USE_FAT32_BOOT_SECTOR		1


//  Structure used by formats fat buffering scheme
//
typedef struct FATBUF FATBUF;
typedef FATBUF * pFATBUF;
typedef FATBUF far * lpFATBUF;
struct FATBUF{
	ulong		ulFirstSectorNumber;
	unsigned	uNumberOfSectors;
	bool		fDoRead;
	bool		fDoWrite;
	unsigned uCopies;
};


//  This is the number of paragraphs you allocate when
//  you are trying to determine the available amount
//  of conventional memory.
//
#define MAX_PARAGRAPH_SIZE				0xffff


//  Constant used for formats sector buffering
//
#define BUFFER_READ			TRUE
#define BUFFER_NO_READ		FALSE
#define BUFFER_WRITE			TRUE
#define BUFFER_NO_WRITE		FALSE


//  Structure for recording bad clusters
//
typedef struct BadClusterInfo BAD_CLUSTER_INFO;
typedef BAD_CLUSTER_INFO * pBAD_CLUSTER_INFO;
typedef BAD_CLUSTER_INFO far * lpBAD_CLUSTER_INFO;
struct BadClusterInfo{
	unsigned uListSegment;
	unsigned uNumberOfEntries;
	unsigned uNextLookup;
};


//  This defines the maximum number of bad cluster format
//  will allow before it errors
//
#define MAX_BAD_CLUSTERS	8192


//  This structure is passed to DOS to record the new
//  serial number and other disk information
//
typedef struct DiskInfo DISK_INFO;
typedef DISK_INFO * pDISK_INFO;
typedef DISK_INFO far * lpDISK_INFO;
struct DiskInfo{
	unsigned uInfoLevel;
	ulong    ulSerialNumber;
	char		cVolumeLabel[11];
	char		cFatTypeString[8];
};


#define BAD_TRACK_ERROR				7


//  Define the number of statistical information strings
//
#define NUMSTAT	4
