//
//   $Id: LABEL.C 1.7 2002/11/20 21:20:00Z thomd Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*********************************************************

	LABEL.C

   Copyright (c) 1989-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

	Just like DOS label

**********************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <string.h>
#include <ctype.h>


#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "dldosio.h"
#include "dosver.h"
#include "datalght.h"
#include "fatworld.h"

#define LABEL 1
#include "dosmsg.c"

#include "getkey.h"

char fcb[50];
char dta[50];

/* Prototypes */
void err_exit(int num);
int islegal_drive(int drive);
int getstring(char *s,int len);
void display(char *s);
void SignOn(void);
char GetHexChar(int hexNybble);
void ULong2SerNum(unsigned long serNum, char *s);
int GetMediaID(int drive, struct mediaID *pMediaID);


#define ERR_BADDRIVE	1
#define ERR_BADCHAR	2
#define ERR_NOROOM	3

#define MSG_SHOWVOL	0
#define MSG_ISVOL		1
#define MSG_NOVOL		2
#define MSG_GETVOL	3
#define MSG_DELVOL	4
#define MSG_SERNUMIS 5

char *illegal = "\\/<>+?*";
char *crlf = "\r\n";
char *crlf2= "\r\n\n";

extern int errno;

#define	DIM(x) (sizeof(x) / sizeof(x[0]))
#define  CFLAG	1

// see MSDOS prog ref pg 54
//
struct mediaID
{
	unsigned midInfoLevel;
	unsigned long midSerialNumber;
	unsigned char midVolLabel[11];
	unsigned char midFileSysType[8];
} midRecord = {0,0,{0},{0}};
char serNumStr[10];

bool fIsFat32World;

// displays the signon message
//
void SignOn(void)
{
	char * szSignOn = "LABEL %s %s\n%s\n\n";
	static int signedOn = 0;

	// display signon, but only once
	//
	if(signedOn++ == 0)
	{
		if( fIsFat32World )
		{
			printf(szSignOn,SHORTVERSION,BUILDVERSION,COPYRIGHT);
		}
		else
		{
			printf(szSignOn,SHORTVERSION622,BUILDVERSION,COPYRIGHT);
		}
	}
}

// returns the ASCII representation of hexNybble
//
char GetHexChar(int hexNybble)
{
	if(hexNybble > 9)
		return (hexNybble - 10) + 'A';
	else
		return hexNybble + '0';
}

// Fills in s[] with the ASCII equivalent of serNum
//
void ULong2SerNum(unsigned long serNum, char *s)
{
	int i=28;

	*s++ = GetHexChar( (int)((serNum >> i) & 0x0F) ); i -= 4;
	*s++ = GetHexChar( (int)((serNum >> i) & 0x0F) ); i -= 4;
	*s++ = GetHexChar( (int)((serNum >> i) & 0x0F) ); i -= 4;
	*s++ = GetHexChar( (int)((serNum >> i) & 0x0F) ); i -= 4;
	*s++ = '-';
	*s++ = GetHexChar( (int)((serNum >> i) & 0x0F) ); i -= 4;
	*s++ = GetHexChar( (int)((serNum >> i) & 0x0F) ); i -= 4;
	*s++ = GetHexChar( (int)((serNum >> i) & 0x0F) ); i -= 4;
	*s++ = GetHexChar( (int)(serNum & 0x0F) );
}

// returns 0 on success with the media ID record filled in
//
int GetMediaID(int drive, struct mediaID *pMediaID)
{
	int result=0;

	asm {
		push	bx
		mov	ax, 440Dh
		mov	cx, 866h
		mov	bx, drive
		mov	dx, word ptr pMediaID
		int	21h
		pushf
		pop	bx
		and	bx, CFLAG
		jz		done
		mov	result, ax
	}
done:
	asm{
		pop	bx
	}
	return result;
}

void main(int argc,char *argv[])
{
	int drive;
	unsigned char err;
	bool fGotLabel;
	bool fSuccessful;
	static char s[14] = {0}, t[3] = {0};
	int len=0,i;
//	int fd;

	//  Determine if we are operating in a DOS 7.1 enviornment
	//
	fIsFat32World = dlIsFat32World();

	/* get the drive to check */
	if(argc>1)
	{char *p;

		if(*argv[1] == '/' &&
			(argv[1][1]=='?' || argv[1][1]=='H' || argv[1][1]=='h'))
		{
			SignOn();
			printf(USAGE);
			exit(1);
		}

		p = argv[1];
		if(p[1] == ':')
		{
			drive = toupper(p[0])-'A';
			p += 2;
		}
		else
		{
			dlGetCurrentDrive( &drive );
		}

		s[0] = DIM(s)-2;
		if(*p != '\0')
		{
			strncat(&s[2],p,DIM(s)-2);
			s[1] = strlen(&s[2]);
			strncat(&s[2]," ",DIM(s)-(strlen(&s[2]) + 3));
		}
		for(i=2; i < argc; i++)
		{
			strncat(&s[2],argv[i],DIM(s)-(strlen(&s[2]) + 3));
			s[1] = strlen(&s[2]);
			strncat(&s[2]," ",DIM(s)-(strlen(&s[2]) + 3));
		}
		if(s[1] > 0)
			strncat(&s[2],"           ",DIM(s)-(strlen(&s[2]) + 3));
		len = (s[1] = strlen(&s[2]));
		for(i=0, err=0; !err && i<len; ++i)		/* check for validity */
			if(strchr(illegal,s[i]))
			{
				SignOn();
				display(errmsg[ERR_BADCHAR-1]);
				display(crlf2);
				err = 1;
				err_exit(err);
			}
		if(len)
			strcpy(s,s+2);

	}
	else
	{
		dlGetCurrentDrive( &drive );
	}


	/* check the drive for validity */
	if(!islegal_drive(drive))
		err_exit(ERR_BADDRIVE);

	/* find old volume label and display it */
	fcb[0] = 0xFF;
	fcb[6] = 8;
	fcb[7] = drive + 1;
	strcpy(fcb+8,"???????????");
	dlSetDTA( dta );
	fGotLabel = dlFcbFindFirst( fcb );
	if(len == 0)
	{

		SignOn();
		display(msg[MSG_SHOWVOL]);
		t[0] = drive + 'A';
		t[1] = 0;
		display(t);
		if(!fGotLabel)
			display(msg[MSG_NOVOL]);
		else
		{
			display(msg[MSG_ISVOL]);
			dta[8+11] = 0;
			display(dta+8);
		}
		display(crlf);
	}

	// get serial number
	//
	if(GetMediaID(drive+1, &midRecord) == 0)
	{
		ULong2SerNum(midRecord.midSerialNumber, serNumStr);
		display(msg[MSG_SERNUMIS]);
		display(serNumStr);
		display(crlf);
	}

	/* get new one */
	if(len)
	{
		err = 0;
	}
	else
	{
		do
		{
			display(msg[MSG_GETVOL]);
			len = getstring(s,12);
			display(crlf);
			if(!len)
			{
				err = 0;
				break;
			}
         if( s[0] == ' ' )
         {
            err = 1;
         }
         else
         {
   			for(i=0, err=0; !err && i<len; ++i)		/* check for validity */
   			{
   				if(strchr(illegal,s[i]))
   				{
   					display(errmsg[ERR_BADCHAR-1]);
   					display(crlf);
   					err = 1;
   				}
   			}
         }
		} while(err);
	}


	if( len )
	{
		while(len < 11)
			s[len++] = ' ';
		s[len]=0;
	}


	/* write it out */
	if(len)
	{
		strcpy(dta+8,"???????????");
		if(fGotLabel)
		{
			dlFCBDelete( (PFCB)(dta) );
		}
		strcpy(fcb+8,s);
		fSuccessful = dlFCBCreate( (PFCB)(fcb) );
		if(!fSuccessful)
		{
			err_exit(ERR_NOROOM);
		}
	}
	else if(fGotLabel)
	{
		/* no new one, does user want to delete old? */
		do
		{
			err = 0;
			strcpy(dta+8,"???????????");
			display(msg[MSG_DELVOL]);
			len = getstring(s,11);
			display(crlf2);
			if(toupper(s[0]) == 'Y')
			{
				dlFCBDelete( (PFCB)(dta) );
			}
			else if(toupper(s[0]) != 'N')
				err = 1;
		} while(err);
	}

	err_exit(0);
}


/*
	display an error message and exit
*/
void err_exit(int num)
{
	if(num)
	{
		display(errmsg[num-1]);
		display(crlf2);
	}
	exit(num);
}

int islegal_drive(int drive)
{
	int old,new;
	int ok = 1;

	dlGetCurrentDrive( &old );
	dlSetCurrentDrive( drive );
	dlGetCurrentDrive( &new );
	if(new != drive)
		ok = 0;
	dlSetCurrentDrive( old );

	return ok;
}


/*
	Get a string via DOS call 0AH if the input is
   a character device.  Otherwise, check for end-
   of stream first.
*/
int getstring(char *s,int len)
{
	uchar ucTemp;


	// If inputting from a file
	if( !IsCharDevice( FD_STDIN ))
	{
		// If no characters are availablefor input, we've reached
		// EOF and should terminate.
		//
		asm	mov	ah, 0bh
		asm	int	21h
		asm	mov	ucTemp, al
		if( ucTemp != 0xFF )
		{
			printf( "\n\nUnexpected end of input file!\n" );
			exit( 5 );
		}
	}

	s[0] = len;
	s[1] = 0;
	dlFlushAndGetLine( s );
	len = s[1];
	s[len+2] = 0;
	strcpy(s,s+2);
	return len;
}

/*
	Display a string via DOS call 09H
*/
void display(char *s)
{
	char buff[60];
	unsigned uTemp;

	strcpy(buff,s);
	buff[strlen(s)] = '$';

	uTemp = (unsigned)buff;
	asm	mov	ah, 09h
	asm	mov	dx, uTemp
	asm	int	21h
}
