;
;   $Id: CASM.INC 1.2 2002/10/16 21:54:04Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;**************************************************************************
; STANDARD INCLUDE FILE FOR MASM 5.1 MODULES LINKED WITH 'C' PROGRAMS
;  defines common equates
;**************************************************************************

;  Mike Dumdei,  6 Holly Lane,  Texarkana TX  75503

IFNDEF ??version
 IF1START EQU <IF1>
 IF1END EQU <ENDIF>
ELSE
 IF1START EQU <>
 IF1END EQU <>
ENDIF

% IF1START

;------ Define external procedures/variables macros -----

IMPORT  macro   typ, list
ifdifi  <typ>,<PTRS>
        irp     x,<list>
        extrn   x:typ
        endm
endif
ifidni  <typ>,<PTRS>
  if @DataSize
        irp     x,<list>
        extrn   x:DWORD
        endm
  else
        irp     x,<list>
        extrn   x:WORD
        endm
  endif
endif
        endm

GLOBE   macro   typ, list
ifidni      <typ>,<BYTE>
        irp     x,<list>
  x     LABEL   typ
        public  x
        db      0
        endm
elseifidni  <typ>,<WORD>
        irp     x,<list>
  x     LABEL   typ
        public  x
        dw      0
        endm
else
        irp     x,<list>
  x     LABEL   typ
        public  x
        endm
endif
        endm

;------- Mixed memory model macros ----------------------
;  Compatible with MicroSoft's MIXED.INC macros except
; this ifFP works with multiple operand instructions.
; Also an ifNP (if Near Pointers) macro is added.
IF @DataSize                ;FAR DATA MODEL
    FP      EQU     <es:>
    ifFP    MACRO   a,b,c,d,e
            IFNB <c>
        a b,c d e
            ELSE
        a b
            ENDIF
            ENDM
    ifNP    MACRO   a,b,c,d,e
            ENDM
    pLes    MACRO   a,b
        les     a,b
            ENDM
    pLds    MACRO   a,b
        lds     a,b
            ENDM
ELSE                        ;NEAR DATA MODEL
    FP      EQU     <>
    ifFP    MACRO   a,b,c,d,e
            ENDM
    ifNP    MACRO   a,b,c,d,e
            IFNB <c>
        a b,c d e
            ELSE
        a b
            ENDIF
            ENDM
    pLes    MACRO   a,b
        mov     a,b
            ENDM
    pLds    MACRO   a,b
        mov     a,b
            ENDM
ENDIF

;--- Macro to fix problem with naming the code segment --
_CODE   MACRO   textname
IF @CodeSize
        ASSUME cs:textname
        .CODE   textname
ELSE
        .CODE
ENDIF
        ENDM

;------- Procedure macros -------------------------------
PUBLICPROC      MACRO   PNAME
        PUBLIC  PNAME
IF @CodeSize
PNAME           LABEL   FAR
ELSE
PNAME           LABEL   NEAR
ENDIF
        ENDM

LOCALPROC       MACRO   PNAME
PNAME           LABEL   NEAR
        ENDM

LOCPUBPROC      MACRO   PNAME
        PUBLIC  PNAME
PNAME           LABEL   NEAR
        ENDM

calln           MACRO   TNAME
        call    Near Ptr TNAME
        ENDM

callf           MACRO TNAME
        call    Far Ptr TNAME
        ENDM

IF @CodeSize
 BOFST  =       6
ELSE
 BOFST  =       4
ENDIF

;------- USEFUL EQUATES -------------------------------
s       EQU     <SHORT>
n       EQU     <NOT>
OFST    EQU     <OFFSET>
BPTR    EQU     <Byte Ptr>
WPTR    EQU     <Word Ptr>
bBP     EQU     <Byte Ptr [BP]>
wBP     EQU     <Word Ptr [BP]>
bBX     EQU     <Byte Ptr [BX]>
wBX     EQU     <Word Ptr [BX]>
bSI     EQU     <Byte Ptr [SI]>
wSI     EQU     <Word Ptr [SI]>
bDI     EQU     <Byte Ptr [DI]>
wDI     EQU     <Word Ptr [DI]>
bDG     EQU     <Byte Ptr DGROUP>
wDG     EQU     <Word Ptr DGROUP>
ofDG    EQU     <OFFSET DGROUP>
DG      EQU     <DGROUP>

% IF1END
