//
//   $Id: EXTRA.H 1.2 2002/10/16 21:54:04Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//

/****************************************************************************
 EXTRA.H -- miscellaneous functions
   Mike Dumdei,  6 Holly Lane,  Texarkana TX  75503    (c) 1989,1990
****************************************************************************/

#ifndef MCOMM
  #define _C_ cdecl
  #define _V_ volatile
  #define _F_ far
  #if (__TURBOC__ && __HUGE__)
    #define _N_
  #else
    #define _N_ near
  #endif
  #define MCOMM
#endif

#if __cplusplus
  extern "C" {
#endif
#if __ZTC__
  #define INTERRUPT
#else
  #define INTERRUPT interrupt
#endif

#define SET_TO_TENTHS(to, tenths)   set_timeout((&to), (tenths)*9/5)
#define SET_TO_SECS(to, secs)       set_timeout((&to), (secs)*18)
#define SET_TO_MINS(to, mins)       set_timeout((&to), (mins)*1080)
#define DELAY_TENTHS(tenths)        tdelay((tenths)*9/5)
#define DELAY_SECS(secs)            tdelay((secs)*18)
#define DELAY_MINS(mins)            tdelay((mins)*1080)

/* function declarations */
int _C_ calc_crc(char *blk, int blksz);
int _C_ update_crc(int oldcrc, char ch);
int _C_ strcntch(char *str, char ch_to_cnt);
char * _C_ strrstr(char *str1, char *str2);
char * _C_ strpbrkf(char *str1, char *str2);
char * _C_ strrtrim(char *str);
char * _C_ strltrim(char *str);
char * _C_ strtrim(char *str);
char * _C_ strsum(char *, ...);               /* dest, str1, str2, ..., NULL */
char * _C_ strrjust(char *str, int fldwidth, char pad);
char * _C_ strljust(char *str, int fldwidth, char pad);
char * _C_ strcentr(char *str, int fldwidth, char pad);
int _C_ watchdogset(int flag, int commchipadrs);
void INTERRUPT _F_ watchdoghook(void);
int _C_ ctshookset(int flag, int port, int chipadrs);
void INTERRUPT _F_ int14ctshook(void);

 /*------- NEW TIMER FUNCTIONS ---------*/
#ifndef TIMER_H
int _C_ tickhookset(int flag); /* MUST disable before exiting program !!!!! */
void _C_ set_timeout(long *timer, unsigned ticks);
void _C_ set_longtimeout(long *timer, long ticks);
int _C_ timed_out(long *timer);
void _C_ tdelay(unsigned ticks);
long _C_ get_ticker(void);
#define TIMER_H
#endif

#if __cplusplus
  }
#endif

