//
//   $Id: ZCMPLR.C 1.2 2002/10/16 21:54:04Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//  History:
//
//  01-30-1999 bt  Added dostruct.h include
//

/*/////////////////////////////////////////////////////////////////////
//                                                                   //
//                                                                   //
//  ZCMPLR.C -- compiler specific functions                          //
//                                                                   //
//   (c) 1991, Mike Dumdei, 6 Holly Lane, Texarkana TX, 75503        //
//                                                                   //
//////////////////////////////////////////////////////////////////// */
#ifndef __TURBOC__          /* defined by Turbo C compiler */
  #ifndef __ZTC__           /* defined by Zortech C compiler */
    #define __MSC__         /* assume Microsoft C if not TC or ZTC */
  #endif
#endif

extern long PrevHunds;
extern long PrevSecs;

/*/////////////////////////////////////////////////////////////////
//                                                               //
//                                                               //
//      Microsoft C  /  Quick C                                  //
//                                                               //
//                                                               //
//////////////////////////////////////////////////////////////// */
#ifdef __MSC__

#include <dos.h>
/*/////////////////////////////////////////////////////////
//  DosFindFirst -- find file (1st instance)             //
//////////////////////////////////////////////////:disk:/*/
int DosFindFirst(char *pathname, int atrib, struct find_t *fstruc)
{
    return (_dos_findfirst(pathname, atrib, fstruc));
}

/*/////////////////////////////////////////////////////////
//  DosFindNext -- find file (except 1st instance)       //
//////////////////////////////////////////////////:disk:/*/
int DosFindNext(struct find_t *fstruc)
{
    return (_dos_findnext(fstruc));
}

/*/////////////////////////////////////////////////////////
//  DosGetDiskFree -- gets free space left on disk       //
//////////////////////////////////////////////////:disk:/*/
long DosGetDiskFree(int drive)
{
    struct diskfree_t spc;
    _dos_getdiskfree(drive, &spc);
    return ((long)spc.avail_clusters * (long)spc.sectors_per_cluster *
     (long)spc.bytes_per_sector);
}

/*/////////////////////////////////////////////////////////
//  DosSetFileTime -- set file date/time                 //
//////////////////////////////////////////////////:disk:/*/
int DosSetFileTime(int handle, unsigned date, unsigned time)
{
    return (_dos_setftime(handle, date, time));
}

/*/////////////////////////////////////////////////////////
//  DosSetFileAttr -- set file attribute                 //
//////////////////////////////////////////////////:disk:/*/
int DosSetFileAttr(char *path, unsigned attrib)
{
	 return (_dos_setfileattr(path, attrib));
}

/*/////////////////////////////////////////////////////////
//  getHunds -- get time to 1/100 of a second            //
//////////////////////////////////////////////////:time:/*/
long getHunds(void)
{
    struct dostime_t hmsh;
    long hunds;

    _dos_gettime(&hmsh);
    hunds = (((((long)hmsh.hour * 60L + (long)hmsh.minute) * 60L)
     + (long)hmsh.second) * 100L) + (long)hmsh.hsecond;
    while (hunds < PrevHunds)
        hunds += (24L * 60L * 60L * 100L);
    PrevHunds = hunds;
    return (hunds);
}

/*/////////////////////////////////////////////////////////
//  getSeconds -- get time to nearest second             //
//////////////////////////////////////////////////:time:/*/
long getSeconds(void)
{
    struct dostime_t hmsh;
    long secs;

    _dos_gettime(&hmsh);
    secs = (((long)hmsh.hour * 60L + (long)hmsh.minute) * 60L) +
     (long)hmsh.second;
    while (secs < PrevSecs)
        secs += (24L * 60L * 60L);
    PrevSecs = secs;
    return (secs);
}
#endif


/*/////////////////////////////////////////////////////////////////
//                                                               //
//                                                               //
//      Turbo C  /  Turbo C++                                    //
//                                                               //
//                                                               //
//////////////////////////////////////////////////////////////// */
#ifdef __TURBOC__

#if 0
#include <dos.h>
#include <dir.h>
#include <io.h>
#if __TURBOC__ >= 0x0410
 #include <bios.h>
#endif
#else

#include <errno.h>

#include "datalght.h"
#include "dostruct.h"
#include "dldosio.h"
#include "dlbiosio.h"

#endif

/*/////////////////////////////////////////////////////////
//  _bios_keybrd --  link to Turbo C/C++ bios key        //
/////////////////////////////////////////////////////////*/
int _bios_keybrd(int flag)
{
#if 0
    return bioskey(flag);
#else

	return BIOSKeyboard(flag);

#endif
}

/*/////////////////////////////////////////////////////////
//  DosFindFirst -- find file (1st instance)             //
//////////////////////////////////////////////////:disk:/*/
#if 0
int DosFindFirst(char *pathname, int atrib, struct ffblk *fstruc)
{
    return (findfirst(pathname, fstruc, atrib));
#else
int DosFindFirst(char *pathname, int atrib, void *fstruc)
{

	// use our own function from the DLDOSIO lib. Errors handled
	// IAW the bc45 help file
	//
	if(dlSetDTA(fstruc))
	{
		if(dlFindFirstFile(atrib,pathname))
			return 0;
	}
	errno = ENOENT;
	_doserrno = dlResetDOSError();
	return -1;

#endif
}

/*/////////////////////////////////////////////////////////
//  DosFindNext -- find file (except 1st instance)       //
//////////////////////////////////////////////////:disk:/*/
#if 0
int DosFindNext(struct ffblk *fstruc)
{
    return (findnext(fstruc));
#else

#pragma argsused
int DosFindNext(void *fstruc)
{
	// use our own function from the DLDOSIO lib. Errors handled
	// IAW the bc45 help file
	//
	if(dlFindNextFile())
			return 0;

	errno = ENOENT;
	_doserrno = dlResetDOSError();
	return -1;

#endif
}

/*/////////////////////////////////////////////////////////
//  DosGetDiskFree -- gets free space left on disk       //
//////////////////////////////////////////////////:disk:/*/
long DosGetDiskFree(int drive)
{

#if 0
    struct dfree spc;
    getdfree(drive, &spc);
    return ((long)spc.df_avail * (long)spc.df_sclus * (long)spc.df_bsec);
#else

	unsigned long bytes;

	// use our own function from the DLDOSIO lib. Errors handled
	// IAW the bc45 help file
	//
	if(dlGetFreeSpaceOnDrive(drive, &bytes))
		return (long)bytes;

	errno = EINVAL;
	return 0;

#endif
}

/*/////////////////////////////////////////////////////////
//  getHunds -- get time to 1/100 of a second            //
//////////////////////////////////////////////////:time:/*/
long getHunds(void)
{
   long hunds;

#if 0
    struct time hmsh;

    gettime(&hmsh);
    hunds = (((((long)hmsh.ti_hour * 60L + (long)hmsh.ti_min) * 60L)
     + (long)hmsh.ti_sec) * 100L) + (long)hmsh.ti_hund;
#else

	DOSTime time;

	if(dlGetDOSTime(&time))
	{
		hunds = (((time.hour*60L)+(long)time.minute)*60L)+(long)time.second;
		hunds = hunds*100L+time.hundredths;
	}
	else hunds = PrevHunds;

#endif

    while (hunds < PrevHunds)
        hunds += (24L * 60L * 60L * 100L);
    PrevHunds = hunds;
    return (hunds);
}

/*/////////////////////////////////////////////////////////
//  getSeconds -- get time to nearest second             //
//////////////////////////////////////////////////:time:/*/
long getSeconds(void)
{
	long secs;

#if 0
    struct time hmsh;

    gettime(&hmsh);
    secs = (((long)hmsh.ti_hour * 60L + (long)hmsh.ti_min) * 60L)
     + (long)hmsh.ti_sec;
#else

	DOSTime time;

	if(dlGetDOSTime(&time))
	{
		secs = (((time.hour*60L)+(long)time.minute)*60L)+(long)time.second;

	}
	else secs = PrevSecs;

#endif

    while (secs < PrevSecs)
        secs += (24L * 60L * 60L);
    PrevSecs = secs;
    return (secs);
}

/*/////////////////////////////////////////////////////////
//  DosSetFileTime -- set file date/time                 //
//////////////////////////////////////////////////:disk:/*/
int DosSetFileTime(int handle, unsigned date, unsigned time)
{
	bool SetFileDate(unsigned handle, unsigned date, unsigned time);
#if 0
    unsigned long ftim = ((unsigned long)date << 16) | (unsigned long)time;
    return (setftime(handle, (struct ftime *)&ftim));
#else

	// use our own function from the DLDOSIO lib. Errors handled
	// IAW the bc45 help file
	//
	if(SetFileDate(handle, date, time))
		return 0;

	switch(dlResetDOSError())
	{
	case 6:	// invalid handle
		errno = EBADF;
		break;
	case 5:	// access denied
		errno	= EACCES;
		break;
	case 1:	// invalid function number
	default:
		errno = EINVFNC;
		break;
	}
	return -1;

#endif
}

/*/////////////////////////////////////////////////////////
//  DosSetFileAttr -- set file attribute                 //
//                                                       //
//   Older versions of TURBO C libraries (TC++ 1.00 for  //
//  sure) do not have the _dos_setfileattr function so   //
//  the call to it is #if'd out.  The defined version    //
//  (0x0400) corresponds to BC++ 3.0 which does have the //
//  _dos_setfileattr function.  Probably some versions   //
//  earlier than 4.0 do too but didn't have them to find //
//  out.  It is only used if an undocumented switch is   //
//  enabled so you probably will never miss it.          //
//////////////////////////////////////////////////:disk:/*/
int DosSetFileAttr(char *path, unsigned attrib)
{
#if 0
  #if __TURBOC__ >= 0x0400
    return (_dos_setfileattr(path, attrib));
  #else
    return 0;
  #endif
#else

	// use our own function from the DLDOSIO lib. Errors handled
	// IAW the bc45 help file
	//
	if(dlSetFileAttributes(attrib, path))
		return 0;

	errno = ENOENT;
	return dlResetDOSError();

#endif
}
#endif	// TURBO C


/*/////////////////////////////////////////////////////////////////
//                                                               //
//                                                               //
//      Zortech C  /  Zortech C++                                //
//                                                               //
//                                                               //
//////////////////////////////////////////////////////////////// */
#ifdef __ZTC__

#define MSDOS 1
#include <dos.h>
long timezone = 0L;

/*/////////////////////////////////////////////////////////
//  DosFindFirst -- find file (1st instance)             //
//////////////////////////////////////////////////:disk: */
int DosFindFirst(char *pathname, int atrib, struct find_t *fstruc)
{
    return (_dos_findfirst(pathname, atrib, fstruc));
}

/*/////////////////////////////////////////////////////////
//  DosFindNext -- find file (except 1st instance)       //
//////////////////////////////////////////////////:disk: */
int DosFindNext(struct find_t *fstruc)
{
    return (_dos_findnext(fstruc));
}

/*/////////////////////////////////////////////////////////
//  DosGetDiskFree -- gets free space left on disk       //
//////////////////////////////////////////////////:disk: */
long DosGetDiskFree(int drive)
{
    return (dos_getdiskfreespace(drive));
}

/*/////////////////////////////////////////////////////////
//  DosSetFileTime -- set file date/time                 //
//////////////////////////////////////////////////:disk: */
int DosSetFileTime(int handle, unsigned date, unsigned time)
{
    return (dos_setftime(handle, date, time));
}

/*/////////////////////////////////////////////////////////
//  DosSetFileAttr -- set file attribute                 //
//////////////////////////////////////////////////:disk: */
int DosSetFileAttr(char *path, unsigned attrib)
{
    return (dos_setfileattr(path, attrib));
}

/*/////////////////////////////////////////////////////////
//  getHunds -- get time to 1/100 of a second            //
//////////////////////////////////////////////////:time:/*/
long getHunds(void)
{
    struct dostime_t hmsh;
    long hunds;

    _dos_gettime(&hmsh);
    hunds = (((((long)hmsh.hour * 60L + (long)hmsh.minute) * 60L)
     + (long)hmsh.second) * 100L) + (long)hmsh.hsecond;
    while (hunds < PrevHunds)
        hunds += (24L * 60L * 60L * 100L);
    PrevHunds = hunds;
    return (hunds);
}

/*/////////////////////////////////////////////////////////
//  getSeconds -- get time to nearest second             //
//////////////////////////////////////////////////:time:/*/
long getSeconds(void)
{
    struct dostime_t hmsh;
    long secs;

    _dos_gettime(&hmsh);
    secs = (((long)hmsh.hour * 60L + (long)hmsh.minute) * 60L) +
     (long)hmsh.second;
    while (secs < PrevSecs)
        secs += (24L * 60L * 60L);
    PrevSecs = secs;
    return (secs);
}
#endif


/*/////////////////////////////////////////////////////////////////////
//                                                                   //
//  The following math functions were added in TXZM version 2.15 in  //
//  order to solve the following problems:                           //
//                                                                   //
//   1.  There was a bug in TXZM.C that sometimes caused a divide    //
//       by zero error during ZMODEM restarts. This code prevents    //
//       division by 0.                                              //
//                                                                   //
//   2.  The helper functions used by various compilers differ       //
//       making precompiled libraries that used long division and    //
//       multiplication difficult to support.  By moving all long    //
//       multiply/divide operations to a set of functions you        //
//       have source code for it doesn't matter what your            //
//       compiler does to perform these operations.                  //
//                                                                   //
//////////////////////////////////////////////////////////////////// */
#ifdef __TURBOC__
  #pragma warn -par
#endif
unsigned long divzero(unsigned long n1)
{
#if (DEBUG > 1)
    extern vDisplay(int, int, char *, ...);
    int *p1 = (int *)&n1;

    vDisplay(24, 40, "divide by 0 at %04X, notify Mike\r", *(p1 + 3) - 3);
#endif
    return (1L);
}
#ifdef __TURBOC__
  #pragma warn +par
#endif

unsigned long uldiv(unsigned long n1, unsigned long n2)
{
    return (n2) ? (n1 / n2) : divzero(n1);
}

unsigned long ulmod(unsigned long n1, unsigned long n2)
{
    return (n2) ? (n1 % n2) : divzero(n1);
}

unsigned long ulmul(unsigned long n1, unsigned long n2)
{
    return (n1 * n2);
}

unsigned long ulshl(unsigned long n1, int shiftval)
{
    return (n1 << shiftval);
}


