//
//   $Id: MEM.H 1.4 2002/10/16 21:54:04Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*********************************************************

   MEM.H  created 03/03/97  by Drew Gislason

	Copyright (c) 1997-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

	Various structures for the MEM utility.

**********************************************************/

// general debugging
#if DEBUG
#include <assert.h>
#define ASSERT(x) assert(x)
#else
#define ASSERT(x)
#endif


//  Declared in dostruct.h
//
#if 0
struct MCB
{
	unsigned char sig;
	unsigned owner;
	unsigned size;
	char dummy[3];
	char name[8];
};
#endif


/*
	Simple PSP, used to get environment segment.
*/
struct SIMPLE_PSP
{
	char reserved[0x2C];
   unsigned   envSeg;            /* 2C environment segment  */
};


#define SYSTEM_MCB 8				// DOS is the owner of an MCB!

// bios extension stuff
#define BIOSEXT_SIG  		0xAA55	// signature for BIOS extension
#define BIOSEXT_PAGESIZE	512		// each page
#define BIOSEXT_INCR			2048		// check at 2K incrementes
#define BIOSEXT_STARTSEG	0xC000	// start looking at C000:0
#define BIOSEXT_ENDSEG		0xF800	// stop looking at F800:0

// error codes
#define ERR_USAGE		1			// show help
#define ERR_BADOPT	2			// invalid option
#define ERR_MCBCHAIN	3			// invalid MCB chain
