;
;   $Id: DLFILE.ASM 1.4 2002/10/16 21:55:48Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
;   DLFILE.ASM Created 05-06-97 Dennis Edwards
;   DOS FILE I/O module for the Datalight C utilities library.
;
;   Copyright (c) 1989-2002 Datalight, Inc.
;   All Rights Reserved.
;   Datalight Confidential and Proprietary
;
;
; This module contains the following DOS file interface routines:
;
; 	bool PASCAL DOSExtendedOpen(char far *lpName,
;				unsigned openMode,unsigned attributes,
;				unsigned far * lpAction, int far *lpHandle);
; 	bool PASCAL DOSOpen(char far *lpName, unsigned attributes,
;				int far *lpHandle);
; 	bool PASCAL DOSCreate(char far *lpName, unsigned attributes,
;				int far *lpHandle);
; 	bool PASCAL DOSClose(unsigned handle);
; 	bool PASCAL DOSCommit(unsigned handle);
; 	bool PASCAL DOSRead(unsigned handle, uchar far *lpBuffer,
;				unsigned far *lpByteCount);
; 	bool PASCAL DOSWrite(unsigned handle, uchar far *lpBuffer,
;				unsigned far * lpByteCount);
; 	bool PASCAL DOSDelete(char far *lpName);
; 	bool PASCAL DOSSeek(unsigned handle, long far *lpDistance, uchar from);
;
;

include ..\include\datalght.inc
include ..\include\dlerrcod.inc


InitModel %MEMMODEL, pascal, use16

.Data
		public	_DLErrno
_DLErrno	dw	0

.Code
	assume	cs:@curseg, ds:@data, es:nothing, ss:nothing

comment ~
int PASCAL LastDOSError(void)
end_comment ~
ProcBegin	LastDOSError,public
ProcUses	ds
ProcSetup
	mov	ax, @data
	mov	ds, ax
	mov	ax, _DLErrno
ProcEnd


comment ~
int PASCAL ResetDOSError(void)
end_comment ~
ProcBegin	ResetDOSError,public
ProcUses	ds
ProcSetup
	mov	ax, @data
	mov	ds, ax
	xor	ax, ax
	xchg	ax, _DLErrno
ProcEnd


comment ~
bool PASCAL DOSExtendedOpen(char far *lpName, unsigned openMode,
			     unsigned attributes, unsigned far * lpAction,
			     int far *lpHandle)
end_comment ~
ProcBegin	DOSExtendedOpen,public
ProcUses	ds,si
ProcArgs	@@lpName:dword, @@openMode:word, @@attributes:word,	@@lpAction:dword,  @@lpHandle:dword
ProcSetup

	mov	ah, 6Ch
	mov	bx, @@openMode
	mov	cx, @@attributes
	lds	si, @@lpAction
	mov	dx, [si]
	lds	si, @@lpName
	int	21h
	jc	@@_err

	lds	bx, @@lpAction
	mov	[bx], cx
	lds	bx, @@lpHandle
	mov	[bx], ax
	mov	ax, 1
	jmp	short @@_exit

    @@_err:
	lds	bx, @@lpHandle
	mov	word ptr [bx], -1
	mov	bx, SEG _DLErrno
	mov	ds, bx
	mov	_DLErrno, ax
	mov	ax, 0

    @@_exit:
ProcEnd


comment ~
bool PASCAL DOSOpen(char far *lpName, unsigned attributes, int far *lpHandle)
end_comment ~
ProcBegin	DOSOpen,public
ProcUses	ds,si
ProcArgs	@@lpName:dword, @@attributes:word, @@lpHandle:dword
ProcSetup

	mov	ah, 3Dh
	mov	al, byte ptr @@attributes
	lds	dx, @@lpName
	int	21h
	jc	@@_err

	lds	bx, @@lpHandle
	mov	[bx], ax
	mov	ax, 1
	jmp	short @@_exit

    @@_err:
	lds	bx, @@lpHandle
	mov	word ptr [bx], -1
	mov	bx, SEG _DLErrno
	mov	ds, bx
	mov	_DLErrno, ax
	mov	ax, 0

    @@_exit:
ProcEnd


comment ~
bool PASCAL DOSCreate(char far *lpName, unsigned attributes, int far *lpHandle)
end_comment ~
ProcBegin	DOSCreate,public
ProcUses	ds,si
ProcArgs	@@lpName:dword, @@attributes:word, @@lpHandle:dword
ProcSetup

	mov	ah, 3Ch
	mov	cx, @@attributes
	lds	dx, @@lpName
	int	21h
	jc	@@_err

	lds	bx, @@lpHandle
	mov	[bx], ax
	mov	ax, 1
	jmp	short @@_exit

    @@_err:
	lds	bx, @@lpHandle
	mov	word ptr [bx], -1
	mov	bx, SEG _DLErrno
	mov	ds, bx
	mov	_DLErrno, ax
	mov	ax, 0

    @@_exit:
ProcEnd


comment ~
bool PASCAL DOSClose(unsigned handle)
end_comment ~
ProcBegin	DOSClose,public
ProcUses	ds
ProcArgs	@@handle:word
ProcSetup

	mov	ah, 3Eh
	mov	bx, @@handle
	int	21h
	jc	@@_err
	xor	ax, ax

    @@_err:
	mov	bx, SEG _DLErrno
	mov	ds, bx
	mov	_DLErrno, ax
	mov	ax, 0
	cmc
	adc	ax, ax
ProcEnd


comment ~
bool PASCAL DOSCommit(unsigned handle)
end_comment ~
ProcBegin	DOSCommit,public
ProcUses	ds
ProcArgs	@@handle:word
ProcSetup

	mov	ah, 68h
	mov	bx, @@handle
	int	21h
	jc	@@_err
	xor	ax, ax

    @@_err:
	mov	bx, SEG _DLErrno
	mov	ds, bx
	mov	_DLErrno, ax
	mov	ax, 0
	cmc
	adc	ax, ax
ProcEnd


comment ~
bool PASCAL DOSRead(unsigned handle, uchar far *lpBuffer, unsigned far *lpByteCount)
end_comment ~
ProcBegin	DOSRead,public
ProcUses	ds
ProcArgs	@@handle:word, @@lpBuffer:dword, @@lpByteCount:dword
ProcSetup

	mov	ah, 3Fh
	lds	bx, @@lpByteCount
	mov	cx, [bx]
	mov	bx, @@handle
	lds	dx, @@lpBuffer
	int	21h
	jc      @@_err

	lds	bx, @@lpByteCount
	mov	[bx], ax
	xor	ax, ax

    @@_err:
	mov	bx, SEG _DLErrno
	mov	ds, bx
	mov	_DLErrno, ax
	mov	ax, 0
	cmc
	adc	ax, ax
ProcEnd


comment ~
bool PASCAL DOSWrite(unsigned handle, uchar far *lpBuffer, unsigned far * lpByteCount)
end_comment ~
ProcBegin	DOSWrite,public
ProcUses	ds,si,di
ProcArgs	@@handle:word, @@lpBuffer:dword, @@lpByteCount:dword
ProcSetup

	mov	ah, 40h
	lds	bx, @@lpByteCount
	mov	cx, [bx]
	mov	si, cx
	mov	bx, @@handle
	lds	dx, @@lpBuffer
	int	21h
	jc	@@_err

	lds	bx, @@lpByteCount
	mov	[bx], ax
	mov	di, ax
	xor	ax, ax
	or	di, di
	jnz	@@_err
	or	si, si
	jz	@@_err

	mov	ax, ERR_HANDLE_DISK_FULL
	stc

    @@_err:
	mov	bx, SEG _DLErrno
	mov	ds, bx
	mov	_DLErrno, ax
	mov	ax, 0
	cmc
	adc	ax, ax
ProcEnd


comment ~
bool PASCAL DOSDelete(char far *lpName)
end_comment ~
ProcBegin	DOSDelete,public
ProcUses	ds
ProcArgs	@@lpName:dword
ProcSetup

	mov	ah, 41h
	lds	dx, @@lpName
	int	21h
	jc	@@_err
	xor	ax, ax

    @@_err:
	mov	bx, SEG _DLErrno
	mov	ds, bx
	mov	_DLErrno, ax
	mov	ax, 0
	cmc
	adc	ax, ax
ProcEnd


comment ~
bool PASCAL DOSSeek(unsigned handle, long far *lpDistance, uchar from)
end_comment ~
ProcBegin	DOSSeek,public
ProcUses	es
ProcArgs	@@handle:word, @@lpDistance:dword, @@from:byte
ProcSetup

	mov	ah, 42h
	mov	al, @@from
	les	bx, @@lpDistance
	mov	dx, word ptr es:[bx]
	mov	cx, word ptr es:[bx][2]
	mov	bx, @@handle
	int	21h
	jc	@@_err

	les	bx, @@lpDistance
	mov	es:[bx],    ax
	mov	es:[bx][2], dx
	mov	ax, 1
	jmp	short @@_exit

    @@_err:
	mov	bx, SEG _DLErrno
	mov	es, bx
	mov	es:_DLErrno, ax
	xor	ax, ax

    @@_exit:
ProcEnd


comment ~
bool PASCAL	DOSRename(char far *lpOldName, char far *lpNewName)
end_comment ~
ProcBegin	DOSRename, public
ProcUses	es,ds,di,si
ProcArgs	@@lpOldName:dword, @@lpNewName:dword
ProcSetup

	mov	ah, 56h
	lds	dx, @@lpOldName
	les	di, @@lpNewName
	int	21h
	jc	@@_err
	xor	ax, ax

    @@_err:
	mov	bx, SEG _DLErrno
	mov	ds, bx
	mov	_DLErrno, ax
	mov	ax, 0
	cmc
	adc	ax, ax
ProcEnd


;
; --- 	get/set file date/time
;
comment ~
bool PASCAL GetFileDateAndTime(int handle, unsigned far *lpDate, unsigned far* lpTime)
end_comment ~
ProcBegin	GetFileDateAndTime,public
ProcUses	es
ProcArgs	@@handle:word, @@lpDate:dword, @@lpTime:dword
ProcSetup

	mov	ax, 5700h
	mov	bx, @@handle
	int	21h
	jc	@@_err

	les	bx, @@lpDate
	mov	es:[bx], dx
	les	bx, @@lpTime
	mov	es:[bx], cx
	mov	ax, 1
	jmp	short @@_exit

    @@_err:
	mov	bx, SEG _DLErrno
	mov	es, bx
	mov	es:_DLErrno, ax
	xor	ax, ax

    @@_exit:
ProcEnd


comment ~
bool PASCAL SetFileDateAndTime(int handle, unsigned date, unsigned time)
end_comment ~
ProcBegin	SetFileDateAndTime,public
ProcUses	ds
ProcArgs	@@handle:word, @@date:word, @@time:word
ProcSetup

	mov	ax, 5701h
	mov	bx, @@handle
	mov	cx, @@time
	mov	dx, @@date
	int	21h
	jc	@@_err
	xor	ax, ax

    @@_err:
	mov	bx, SEG _DLErrno
	mov	ds, bx
	mov	_DLErrno, ax
	mov	ax, 0
	cmc
	adc	ax, ax
ProcEnd





	end
