;
;   $Id: DOSMATH.ASM 1.4 2002/10/16 21:57:04Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
COMMENT ~
-----------------------------------------------------------

   DOSMATH.ASM  created 11/30/89  by Drew Gislason

   Copyright (c) 1989-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

   The long math routines, and fast string manipulation
   routines are all contained in this assembly file.
   ROM-DOS uses no routines from the compiler's library.

----------------------------------------------------------- ~
include macros.inc

cBegCode


;---------------------------------------------------------
;
;		MATH OPERATIONS
;
;---------------------------------------------------------


COMMENT ; prototype
ulong PASCAL _lshru(ulong l, unsigned u)
{}
;
	public _LSHRU
_LSHRU:
	PUSH	BP
	MOV	BP,SP

	MOV	AX,P+2[BP]
	MOV	DX,P+4[BP]	; DX:AX = l
	MOV	CX,P[BP]	; CX    = u
	JCXZ	shrx

shr1:	SHR	DX,1
	RCR	AX,1
	LOOP	shr1

shrx:	POP	BP
	RET	6


COMMENT ; prototype
ulong PASCAL _lshlu(ulong l, unsigned u)
{}
;
	public	_LSHLU
_LSHLU:
	PUSH	BP
	MOV	BP,SP

	MOV	AX,P+2[BP]
	MOV	DX,P+4[BP]	; DX:AX = l
	MOV	CX,P[BP]	; CX    = u
	JCXZ	shldone

shl1:	SHL	AX,1
	RCL	DX,1
	LOOP	shl1
shldone:
	POP	BP
	RET	6


COMMENT ; prototype
ulong PASCAL _lmulu(ulong l, unsigned u)
{}
;
	public	_LMULU
_LMULU:
	PUSH	BP
	MOV	BP,SP

	; multiply lower 16 bits
	MOV	AX,P[BP]	; unsigned
	MOV	DX,P+2[BP]	; low  16 bits of ulong
	MUL	DX
	MOV	CX,DX		; save high part
	MOV	BX,AX		; save low order part

	; multiply upper 16 bits
	MOV	AX,P[BP]	; unsigned
	MOV	DX,P+4[BP]	; hi 16 bites of ulong
	MUL	DX		; high order part
	ADD	AX,CX		; add in overflow from prev multiply

	MOV	DX,AX		; high 16 bits
	MOV	AX,BX		; low  16 bits

	POP	BP
	RET	6


COMMENT ; prototype
unsigned PASCAL _ldivu(ulong ul, unsigned u)
{}
;
	public	_LDIVU
_LDIVU:
	PUSH	BP
	MOV	BP,SP

	MOV	AX,P+2[BP]
	MOV	DX,P+4[BP]	; DX:AX = ulong
	MOV	CX,P[BP]	; CX = unsigned
	DIV	CX

	POP	BP
	RET	6


IF 1

 COMMENT ; prototype
 unsigned _lmodu(ulong ul, unsigned u)
 {}
 ;
c_func	_lmodu
	PUSH	BP
	MOV	BP,SP

	MOV	AX,P[BP]
	MOV	DX,P+2[BP]	; DX:AX = ulong
	MOV	CX,P+4[BP]	; CX = unsigned
	DIV	CX
	MOV	AX,DX

	POP	BP
	RET
c_endp	_lmodu ;


 COMMENT ; prototype
ulong _ldiv(ulong l1, ulong l2)
 {}
 ;
c_func	_ldiv
	PUSH	BP
	MOV	BP,SP
	PUSH	SI
	PUSH	DI

	MOV	AX,P+2[BP]	; high 16 bits of l1
	MOV	BX,P+0[BP]	; low  16 bits of l1
	MOV	CX,P+6[BP]	; high 16 bits of l2
	MOV	DX,P+4[BP]	; low  16 bits of l2

	CALL	LXXX

	MOV	DX,AX		; high order bits of divide
	MOV	AX,BX		; low order bits of divide

	POP	DI
	POP	SI
	POP	BP
	RET
c_endp	_ldiv ;


 COMMENT ; prototype
 ulong _lmod(ulong l1, ulong l2)
 {}
 ;
c_func _lmod
	PUSH	BP
	MOV	BP,SP
	PUSH	SI
	PUSH	DI

	MOV	AX,P+2[BP]	; high 16 bits of l1
	MOV	BX,P+0[BP]	; low  16 bits of l1
	MOV	CX,P+6[BP]	; high 16 bits of l2
	MOV	DX,P+4[BP]	; low  16 bits of l2

	CALL	LXXX

	MOV	AX,DX		; low order bits of remainder
	MOV	DX,CX		; high order bits of remainder

	POP	DI
	POP	SI
	POP	BP
	RET
c_endp _lmod


;-------------------------------------------
; Unsigned Long Divide
;
; Input:
;	[AX,BX],[CX,DX]
; Output:
;	[AX,BX] = [AX,BX] / [CX,DX]
;	[CX,DX] = [AX,BX] % [CX,DX]
;	SI,DI	destroyed

LXXX	PROC	NEAR
	MOV	SI,CX
	MOV	DI,DX			;[SI,DI] = divisor
	OR	CX,DX			;test for divide by 0
	JZ	div0			;yes

	;left justify [SI,DI] and leave count of shifts + 1 in BP

	PUSH	BP			;need a temporary
	MOV	BP,1			;at least 1 shift
L6:	TEST	SI,SI			;left justified?
	JS	L1			;yes
	JNZ	L2			;if non-zero
	XCHG	SI,DI			;SI = DI, DI = 0
	MOV	BP,17			;at least 17 shifts
	JMP	L6

L2:	INC	BP			;another shift
	SHL	DI,1
	RCL	SI,1			;[SI,DI] <<= 1
	TEST	SI,SI			;affect sign flag
	JNS	L2			;not left justified yet

L1:	MOV	CX,AX
	MOV	DX,BX			;[CX,DX] = [AX,BX]
	XOR	AX,AX
	XOR	BX,BX			;[AX,BX] = 0
L4:	CMP	SI,CX			;is [CX,DX] > [SI,DI]?
	JA	L3
	JB	L5			;definitely less than
	CMP	DI,DX			;check low order word
	JA	L3
L5:	SUB	DX,DI
	SBB	CX,SI			;[CX,DX] -= [SI,DI]
	STC				;rotate in a 1
L3:	RCL	BX,1
	RCL	AX,1			;[AX,BX] = ([AX,BX] << 1) + C
	SHR	SI,1
	RCR	DI,1			;[SI,DI] >>= 1
	DEC	BP			;control count
	JNE	L4
	POP	BP
	RET

div0:	MOV	AX,-1
	MOV	BX,AX			;quotient is -1
	XOR	CX,CX
	XOR	DX,DX			;remainder is 0
	RET

LXXX	ENDP

ENDIF	; commented out


;---------------------------------------------------------
;
;		STRING OPERATIONS
;
;---------------------------------------------------------


COMMENT ~ ; prototype ;
/*
   This move is "smart" in that it can work with overlapping
   data, either forward or backward.  That is, it does both
   these moves correctly:
	memmove(p, p+1, 5);
	memmove(p+1, p, 5);
*/
void PASCAL memmove(void *to,void *from,unsigned len)
{}
~
	public	MEMMOVE
MEMMOVE:
	PUSH	BP
	MOV	BP,SP
	PUSH	SI
	PUSH	DI
	PUSH	DS
	XOR	AX, AX		; save flag indicating # of bytes to
	PUSH	AX		; pop off return stack (pascal func)

	; near move, ES must equal DS
	PUSH	DS
	POP	ES
	MOV	AX,P+2[BP]	; move forward if "from" is greater
	CMP	AX,P+4[BP]	; move backward if "to" is greater
	JNB	M1
	STD
	MOV	AX,1
	JMP	M2
M1:	CLD
	XOR	AX,AX
M2:	MOV	SI,P+2[BP]
	MOV	DI,P+4[BP]
	MOV	CX,P[BP]

	; ES:DI = dest
	; DS:SI = src
	; CX    = length
	; AX    = direction (0=forward, 1=backward)
do_move:
	OR	AX,AX
	JE	M3
	ADD	SI,CX
	DEC	SI
	ADD	DI,CX
	DEC	DI
M3:	TEST	DI,1
	JE	M4
	JCXZ	M5
	MOVSB
	DEC	CX
M4:	SUB	SI,AX
	SUB	DI,AX
	SHR	CX,1
	; do NOT CLD here, we MAY be going the OTHER way
	REP	MOVSW
	JNB	M5
	ADD	SI,AX
	ADD	DI,AX
	MOVSB
	; now CLD so it is FORWARD like NORMAL
M5:	CLD
	POP	AX		; flag indicating size of pascal return
	POP	DS
	POP	DI
	POP	SI
	POP	BP
	OR	AX, AX		; 0 means near ptrs, 1 means far
	JNZ	farmov
	RET	6	; 2 near ptrs + len
farmov:	RET	10	; 2 far ptrs + len

;
;   NOTE:   unlike memmove(), this routine does no
;   overlap checking at all.
;
COMMENT ; prototype
void PASCAL fmemmove(void far *dst,void far *src,unsigned len)
{}
;
	public	FMEMMOVE
FMEMMOVE:
	PUSH	BP
	MOV	BP,SP
	PUSH	SI
	PUSH	DI
	PUSH	DS
	MOV	AX, 1		; save flag indicating # of bytes to
	PUSH	AX		; pop off return stack (pascal func)

	CLD			; far move is always forward
	XOR	AX,AX
	MOV	DI,P+6[BP]	; dst
	MOV	ES,P+8[BP]
	MOV	SI,P+2[BP]	; src
	MOV	DS,P+4[BP]
	MOV	CX,P[BP]	; len

	JMP	do_move



COMMENT ; prototype
void PASCAL memset(void *dst,uchar val,unsigned len)
{}
;
	public	MEMSET
MEMSET:
	PUSH	BP
	MOV	BP,SP
	PUSH	SI
	PUSH	DI
	XOR	AX, AX		; flag indicating # of bytes to
	PUSH	AX		; pop off stack on pascal return

	; get the parameters
	PUSH	DS
	POP	ES
	MOV	DI,P+4[BP]
	MOV	AL,P+2[BP]
	MOV	CX,P[BP]

	; fill the bytes
memset1:CLD
	REP	STOSB

	POP	AX		; flag indicating size of pascal return
	POP	DI
	POP	SI
	POP	BP
	OR	AX, AX
	JNZ	farset
	RET	6		; near ptr + val + len
farset:	RET	8		; far ptr + val + len

COMMENT ; prototype
void PASCAL fmemset(void far *dst,uchar val,unsigned len)
{}
;
	public	FMEMSET
FMEMSET:
	PUSH	BP
	MOV	BP, SP
	PUSH	SI
	PUSH	DI
	MOV	AX, 1		; flag indicating # of bytes to
	PUSH	AX		; pop off stack on pascal return

	; get the parameters
	MOV	CX, P[BP]	; len
	MOV	AL, P+2[BP]	; val
	MOV	DI, P+4[BP]
	MOV	ES, P+6[BP]	; far * dst

	; go do the move
	JMP	memset1


COMMENT ; prototype
/*
   Unlike the standard C function, this memcmp returns TRUE
   if the strings are identical, FALSE if not.
*/
bool PASCAL memcmp(char *str1,char *str2,unsigned len)
{}
;
	public	MEMCMP
MEMCMP:
	PUSH	BP
	MOV	BP,SP
	PUSH	SI
	PUSH	DI
	PUSH	DS
	XOR	AX, AX		; flag indicating # of bytes to
	PUSH	AX		; pop off stack on pascal return

	; make sure ES = DS
	PUSH	DS
	POP	ES

	; get parameters from stack
	MOV	SI,P+4[BP]	; str1
	MOV	DI,P+2[BP]	; str2
	JMP	cmpnearfar


COMMENT ; prototype
/*
   Unlike the standard C function, this fmemcmp returns
   TRUE if the strings are identical, FALSE if not.
*/
bool PASCAL fmemcmp(char far *str1,char far *str2,unsigned len)
{}
;
	public	FMEMCMP
FMEMCMP:
	PUSH	BP
	MOV	BP,SP
	PUSH	SI
	PUSH	DI
	PUSH	DS
	MOV	AX, 1		; flag indicating # of bytes to
	PUSH	AX		; pop off stack on pascal return

	; get parameters from stack
	MOV	DS,P+8[BP]
	MOV	SI,P+6[BP]	; str1
	MOV	ES,P+4[BP]
	MOV	DI,P+2[BP]	; str2

cmpnearfar:
	MOV	CX, P[BP]	; len

cmpagain:
	CMPSB
	JNZ	cmpfail
	LOOP	cmpagain
cmpok:	MOV	AX,1
	JMP	SHORT cmpdone

cmpfail:
	MOV	AX,0

cmpdone:
	POP	BX		; flag for pascal return size
	POP	DS
	POP	DI
	POP	SI
	POP	BP
	OR	BX, BX		; 1 means far, 0 means near
	JNZ	cmpfar
	RET	6		; 2 near ptrs + len
cmpfar:	RET	10		; 2 far ptrs + len


COMMENT ; prototype
int PASCAL strlen(char *s)
{}
;
	public	STRLEN
STRLEN:
	push	BP
	mov	BP, SP
	push	DS
	pop	ES		; ES must point to segment
	call	strlenx		; requires far pointer
	pop	BP
	ret	2

COMMENT ; prototype
int PASCAL fstrlen(char far * s)
{}
;
	public	FSTRLEN
FSTRLEN:
	push	BP
	mov	BP, SP
	mov	ES, P+2[BP]	; ES must point to segment
	call	strlenx
	pop	BP
	ret	4

;-------------------------------------
;  internal use by strlen/fstrlen
;  Returns string length in AX
strlenx	proc	near
	push	DI
	mov	DI, P[BP]	; offset

	; get maximum possible length (no wrapping past FFFF)
	mov	CX, DI
	not	CX
	xor	AX, AX
	cld
	repnz	scasb

	; got endptr in DI, convert to length in AX
	xchg	DI, AX
	sub	AX, P[BP]
	dec	AX

	; restore regs and return
	pop	DI
	ret
strlenx	endp

cEndCode
	end
