;
;   $Id: POWASM.ASM 1.5 2002/10/16 21:57:04Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
; Datalight Power Management Software
; Assembly  Module
;
; Copyright(c) 1993-2002 Datalight Inc.
; All Rights Reserved
; Datalight Confidential and Proprietary
;
include macros.inc
include power.inc			; Get Defines


; This module contains handlers for:
;	INT 9 (keystroke)	Turn system back on when key is pressed
;	INT 13 (disk)		Remember latest use of disk
;	INT 14 (serial)		Remember latest use of serial port
;	INT 16 (keyboard)	Remember latest use of keyboard
;				Perform power management if scheduled
;				Shut down keyboard if in tight polling loop
;	INT 17 (parallel)	Remember latest use of parallel port
;	INT 1C (timer)		Increment ticks in our CS
;				Schedule power management at next INT 16


DISK_LU		equ 12
DISK_STAT	equ 16

PRINT_LU	equ 18
PRINT_STAT	equ 20

SERIAL_LU	equ 24
SERIAL_STAT	equ 26

KEYB_LU		equ 30
KEYB_STAT	equ 32


DGROUP	GROUP	_TEXT,_DATA,_BSS


cBegCode

Assume CS:DGROUP
Assume DS:DGROUP

	public _int_9, _old_int_9
	public _int_B, _old_int_B
	public _int_C, _old_int_C
	public _int_10, _old_int_10
	public _int_13, _old_int_13
	public _int_14, _old_int_14
	public _int_16, _old_int_16
	public _int_17, _old_int_17
	public _int_1C, _old_int_1C
	public _int_28, _old_int_28
	public _int_2F, _old_int_2F
	public _getCS, _getvect, _setvect
	public _enhanced_keyboard
	public do_power_mgt

	extrn _Check_If_Idle:near
	extrn _power_restore:near
	extrn _RealTime2Ticks:proc
	extrn _UnInstall:proc

	extrn _SetMAXOperation:near
	extrn _SetSTDOperation:near
	extrn _SetMINOperation:near
	extrn _SetOFFOperation:near



_int_9:
	push	CS:_Ticks
	pop	CS:_LastActivity	; Save time when last system activity occured

	push	CS:_Ticks
	pop	CS:_Devices+KEYB_LU	; Save time when Keyboard LastUsed in Device Struct

	cli
	mov	CS:_restorePower, 1	; Schedule restoration of power!
	sti

L9a:	db	0EAH			; Far Jump instruction
_old_int_9:	dd	0		; far pointer to old interrupt 9 routine


; Interrupt B is a Serial Interrupt.  Turn the power on with a Serial
; interrupt occurs.
_int_B:
	push	CS:_Ticks
	pop	CS:_LastActivity	; Save time when last system activity occured

	cli
	mov	CS:_restorePower, 1	; Schedule restoration of power!
	sti

LBa:	db	0EAH			; Far Jump instruction
_old_int_B:	dd	0		; far pointer to old interrupt B routine


; Interrupt C is a Serial Interrupt.  Turn the power on with a Serial
; interrupt occurs.
_int_C:
	push	CS:_Ticks
	pop	CS:_LastActivity	; Save time when last system activity occured

	cli
	mov	CS:_restorePower, 1	; Schedule restoration of power!
	sti

LCa:	db	0EAH			; Far Jump instruction
_old_int_C:	dd	0		; far pointer to old interrupt C routine


_int_10:
	cmp	Word Ptr cs:_Devices + 12, READY
	jnz	L10a
	push	ax
	push	bx
	push	cx
	mov	ax, 5307H
	mov	bx, 0100H
	mov	cx, 0
	int	15H
	pop	ax
	pop	bx
	pop	cx
L10a:	db	0EAH			; Far Jump instruction
_old_int_10:	dd	0		; far pointer to old interrupt 9 routine



_int_1C:
	cmp	cs:_PowerMgtStatusCode, 0 	; if turned off
	je	int1C_poll_APM			; just dispatch events

	add	CS:_Ticks, 1		; Increment Local Tick Counter
	adc	CS:_TotalTicks, 0

	cmp	cs:_LastActivity, 0
	jz	Int1cb

	mov	cs:_LastActivity, 0
	push	cs:_Pwr_Mgt_Ticks
	pop	cs:_SystemIdleCount
	jmp 	short Int1cA

Int1cb:
	dec	CS:_SystemIdleCount
	jnz	Int1cA

	push	cs:_Pwr_Mgt_Ticks
	pop	cs:_SystemIdleCount

	mov	cs:gotAppIdleSignal, 1
	jmp	short int1C_manage_pwr

Int1cA:
	; APM BIOS Callback counter. See ProcessingRequestNotifier below.
	;
	cli				; "volatile" variable
	cmp	cs:_APM_notify_count, 0	; is counter armed?
	sti
	js    	int1C_do_power_mgt      ; -1 means no, aren't processing

	cli
	dec	cs:_APM_notify_count	; dec the counter
	sti
	jnz    	int1C_do_power_mgt 	; 0 means deliver signal to APM BIOS

	call	ProcessingRequestNotifier
	jmp	short int1C_skip_APM	; we are already doing pwr mgt

    int1C_do_power_mgt:
	cmp	gotAppIdleSignal, 0	; qualify sleep request now
	jne	int1C_manage_pwr

    int1C_poll_APM:
	dec	CS:_Pwr_Mgt_Count	; time for PowerManagement Function?
	jnz	int1C_skip_APM

    int1C_manage_pwr:
	call	do_power_mgt		; Call Power_Management Function
	mov	CS:_Pwr_Mgt_Count, 9

    int1C_skip_APM:
	db	0EAH			; Far Jump instruction
_old_int_1C:	dd	0		; far pointer to old interrupt 1C routine


_int_13:
	push	CS:_Ticks
	pop	CS:_LastActivity	; Save time when last system activity occured

	push	CS:_Ticks
	pop	CS:_Devices+DISK_LU	; Save time when disk LastUsed in Device Struct

	cmp	CS:_Devices+DISK_STAT,READY ; If disk not in ReadyState
	jna	_int13_A
	mov	CS:_Devices+DISK_STAT,READY ; Set Flag to READY
	push	AX
	push	BX
	push	CX
	mov	AX, APM_SET_POWER_STATE	; 	Set DISK to Ready!
	mov	BX, APM_DEV_DISK
	mov	CX, READY
	int	15H
	pop	CX
	pop	BX
	pop	AX

_int13_A:	db	0EAH		; Far Jump instruction
_old_int_13:	dd	0		; far pointer to old interrupt 13 routine

_int_14:
	push	CS:_Ticks
	pop	CS:_LastActivity	; Save time when last system activity occured

	push	CS:_Ticks
	pop	CS:_Devices+SERIAL_LU	; Save time when Serial Port LastUsed

	cmp	CS:_Devices+SERIAL_STAT,READY; If not in ReadyState
	jna	_int14_A
	mov	CS:_Devices+SERIAL_STAT,READY; 	Set Flag to READY
	push	AX
	push	BX
	push	CX
	mov	AX, APM_SET_POWER_STATE	; 	Set Serial Port to Ready!
	mov	BX, APM_DEV_SERIAL
	mov	CX, READY
	int	15H
	pop	CX
	pop	BX
	pop	AX

_int14_A:	db	0EAH		; Far Jump instruction
_old_int_14:	dd	0		; far pointer to old interrupt 14 routine



_int_28:
	cmp	cs:_InWindows, 1	;if( InWindows )
	jz	_jmp_28			;	old_int_28();
 	inc	cs:_DOS_IdleCount
	cmp	cs:_DOS_IdleCount, 10
	jle	_jmp_28
	call 	DoIdle

_jmp_28:db	0EAH			; Far Jump instruction
_old_int_28:	dd	0		; far pointer to old interrupt 28 routine



;
; Function to cause the CPU to be IDLE till LastActivity != 0
;
DoIdle:	ret


if 1
_int_16:
if 1
	cmp	ah, 1		; if(KeyPoll)
	jz	do_int_16		; {
	cmp	ah, 11H
	jz	do_int_16
 	inc	cs:_KEY_IdleCount
	cmp	cs:_KEY_IdleCount, 10	;	if(10 Times)
	jle	do_int_16		;	{
	call 	DoIdle			;		Do Idle
endif					;	}
do_int_16:	db	0EAH		; Far Jump instruction
_old_int_16:	dd	0		; far pointer to old interrupt 16 routine
_int16_b:	ret


else
;
;
;
_int_16:
	cmp	CS:_Do_Pwr_Mgt,0	; Check if power_management Scheduled
	jna	NoPwrMgt		; If NOT, skip ahead
	mov	CS:_Do_Pwr_Mgt,0	; Reset Flag
	call	do_power_mgt		; Call Power_Management Function
	jmp	do_int_16		; Do normal int16
if 1
NoPwrMgt:
	cmp	CS:_restorePower,0	; Check if Power_Restore scheduled
	jz	SmartInt16
	mov	CS:_restorePower,0	; Reset Flag
	call	do_power_restore

SmartInt16:
	push	AX			; Save original command
	and	AH, 0Fh
	cmp	AH, 0			; if a poll_key Function
	jnz	PollForKey		; then we have more to think about

WaitForKey:
	mov	AH, cs:_checkForKey	; Check for keystroke
;	mov	AH, 1
	push	BX			; save BX
	call	Call_int_16
	pop	BX			; restore BX
	jnz	KeyWaiting		; While Key NOT available {

	cmp	CS:_Do_Pwr_Mgt,0	; Check if power_management Scheduled
	jz	CheckRestore		; If NOT, skip ahead
	mov	CS:_Do_Pwr_Mgt,0	; Reset Flag
	call	do_power_mgt		; Call Power_Management Function

CheckRestore:
	cmp	CS:_restorePower,0	; Check if Power_Restore scheduled
	jz	WaitForKey
	mov	CS:_restorePower,0	; Reset Flag
	call	do_power_restore

;	push	BX
;	push	CX
;	mov	AX, 5307H		; 	Power Down System
;	mov	BX, ALL_DEVICE
;	mov	BL, 0FFH		; 	All display devices
;	mov	CX, STANDBY
;	int	15H			;	Call APM
;	pop	CX
;	pop	BX

	jmp	WaitForKey		; }

KeyWaiting:

	pop	AX			;	get key return to app
	jmp	do_int_16

PollForKey:				; i16_A:
	cmp	CS:_Checking, 1
	jz	SmartIdleCheck
	pop	AX
	jmp 	do_int_16

SmartIdleCheck:				; i16e
	push	BX
	cmp	AH, 1			; if not pollkey function,
	jnz	IdleCheck		; skip right to idle check
	mov	AX, CS:_Ticks
	sub	AX, CS:_Check_Start
	cmp	AX, CS:_Check_MAX	; only if we have enough data
	ja	IdleCheck		; should we do the idle check
	mov	BX, AX
	add	BX, AX
	add	BX, offset DGROUP:_Check_Ticks
	inc	word ptr CS:[BX]	; Record int 16 Call at this Tick
	pop	BX
	pop	AX
	jmp	do_int_16

IdleCheck:				;i16_C:		; 	else
	pushf
	push	CS
	call	_Check_If_Idle		;		Review INT 16 Usage
	pop	BX
	pop	AX
	jmp	do_int_16


Call_int_16:	pushf			; Call (with return) BIOS int 16
		push	CS
		mov	BX, offset _TEXT:_int16_b
		push	BX
endif

do_int_16:	db	0EAH		; Far Jump instruction
_old_int_16:	dd	0		; far pointer to old interrupt 16 routine
_int16_b:	ret

endif

;
; Printer Power Manager
;
_int_17:
	push	CS:_Ticks
	pop	CS:_LastActivity	; Save time when last system activity occured

	push	CS:_Ticks
	pop	CS:_Devices+PRINT_LU	; Save time when disk LastUsed in Device Struct

	cmp	CS:_Devices+PRINT_STAT,READY; If not in ReadyState
	jna	_int17_A
	mov	CS:_Devices+PRINT_STAT,READY; 	Set Flag to READY
	push	AX
	push	BX
	push	CX
	mov	AX, APM_SET_POWER_STATE	; 	Set Printer to Ready!
	mov	BX, APM_DEV_PRINTER
	mov	CX, READY
	int	15H
	pop	CX
	pop	BX
	 pop	AX

_int17_A:	db	0EAH		; Far Jump instruction
_old_int_17:	dd	0		; far pointer to old interrupt 17 routine


; Local variables used to track various APM BIOS capabilities
; and system states.
;
APMVersion	dw	0
APMFlags	dw	0
gotAppIdleSignal db	0
ucCurrentPowerState db  READY

; This checks for the presence of an APM BIOS and, if found,
; establishes a connection with it. If successful the CPU and
; all power managed devices are restored to their default power
; on state. A device, or the CPU, is powered down as a result
; of inactivity when a timed callback is activated.
;
; ->	void
; <-	ax	APM BIOS version number (BCD, ah=major, al=minor)
;	on error ax = 0, and _APM_errno holds the last returned error code
; regs  cx, bx, ax
;
comment ~
int APM_Installed(void)
end_coment ~
	public	APM_Installed
c_func APM_Installed

	mov	APMVersion, 0
	mov	ax, APM_INSTALLATION_CHECK
	xor	bx, bx                    ; try to find APM BIOS
	int 	15h
	jnc	APMI_is_installed

    APMI_error:
	mov	_APM_errno, ax
	xor	ax, ax
	jmp	APMI_exit

    APMI_is_installed:
	cmp	bx, "PM"	; sanity check
	jne	APMI_error

	mov	APMVersion, ax
	mov	APMFlags, cx

	mov	ax, APM_REAL_MODE_CONNECT
	xor	bx, bx		; tell BIOS to confer with us
	int	15h
	jc	APMI_error

	cmp	APMVersion, 0101h
	jb	APMI_exit

	mov	ax, APM_GET_DRIVER_VERSION
	xor	bx, bx
	mov	cx, 0101h	; We are v1.1 compliant
	int	15h
	jc	APMI_error

	mov	ax, APM_RESTORE_DEFAULTS
	mov	bx, APM_DEV_ALL	; engage power mgt. & enable all devices
	int	15h
	jc	APMI_error

    APMI_exit:
	mov	ax, APMVersion

	ret
c_endp APM_Installed


;/*
; * Disconnect from the APM BIOS
; * Return
; *			TRUE on sucess
; *			FALSE on Failure
; */
comment ~
int APM_Disconnect(void)
end_comment ~
	public	APM_Disconnect
c_func APM_Disconnect

	mov	ax, APM_INTERFACE_DISCONNECT
	mov	bx, 0
	int	15h
	mov	ax, 1
	jnc 	APMD_exit

	dec	ax

    APMD_exit:
	ret
c_endp APM_Disconnect


;/*
; * Set Power State places the system or Device into the specified
; * Power state
; * Input
; *		Device
; *			System			= 00XX
; *			BIOS			= 0000
; *			All Devices	 	= 0001
; *			Display			= 01XX
; *			Secondary Storage 	= 02XX
; *			Parrallel Ports		= 03XX
; *			Serial Ports		= 04XX
; *		State
; *			Ready			= 0
; *			Stand-By		= 1
; *			Suspend			= 2
; *			Off			= 3
; * Return
; *		TRUE on sucess
; *		FALSE on Failure
; */
comment ~
int APM_SetPowerState(unsigned DeviceID, unsigned State)
end_comment ~
	public	APM_SetPowerState
c_func APM_SetPowerState
DeviceID	equ	P[BP]
State 		equ	P[BP+2]

	mov	ax, APM_SET_POWER_STATE
%	mov	bx, DeviceID
%	mov	cx, State
	int	15h
	mov	ax, 1
	jnc 	APMSPS_exit

	dec	ax

    APMSPS_exit:
	ret
c_endp APM_SetPowerState


comment ~
int APM_GetStatus(void)
end_comment ~
	public	APM_GetStatus
c_func APM_GetStatus

	mov	ax, APM_GET_PWR_STATUS
	mov	bx, 1
	int	15h
	mov	ax, bx
	ret
c_endp APM_GetStatus


comment ~
void SetTicks(void)
end_comment ~
	public	SetTicks
SetTicks proc	C

	call	_RealTime2Ticks
	mov	cx, dx		; msw
	mov	dx, ax		; lsw
	mov	ax, 0100H
	int	1Ah
	ret
SetTicks endp

; This is a timed call back that sends a "We're still processing
; your request" signal to the APM BIOS. These signals are
; required "at least once every 5 seconds" after a standby/suspend
; request is delivered in order to hold off the state transition.
;
	public ProcessingRequestNotifier
ProcessingRequestNotifier	proc near

	push	ax
	push	bx
	push	cx

	mov	ax, APM_SET_POWER_STATE
	mov	bx, APM_DEV_ALL
	mov	cx, APM_REQUEST_IN_PROGRESS
	int	15h

	; The int 1Ch handler will call this routine again in 3 secs.
	; RequestNotifier() will set the _APM_notify_count to -1
	; once all APM aware apps have responded and so cancel
	; further callbacks.
	;
	cli
	mov	cs:_APM_notify_count, 55
	sti
	pop	cx
	pop	bx
	pop	ax
	retn
ProcessingRequestNotifier	endp


lastSuspendOrStandbyTicks	dd	0

; Calls the APM BIOS to tell it that its power reduction request was
; rejected by an APM aware app.
;
; ->	void
; <-	void
;
	public RequestRejectedNotifier
RequestRejectedNotifier proc near

	call	_RealTime2Ticks
	mov	word ptr cs:lastSuspendOrStandbyTicks, ax
	mov	word ptr cs:lastSuspendOrStandbyTicks[2], dx

	mov	ax, APM_SET_POWER_STATE
	mov	bx, APM_DEV_ALL
	mov	cx, APM_REQUEST_REJECTED
	int	15h
	ret
RequestRejectedNotifier endp


	public RecordCurrentPowerState
RecordCurrentPowerState	proc	near
	push	ax
	push	bx
	push	cx

	mov	ax, APM_GET_PWR_MGMT_STATE
	mov	bx, APM_DEV_ALL
	int	15h
	mov	ucCurrentPowerState, cl

	pop	cx
	pop	bx
	pop	ax
	ret
RecordCurrentPowerState	endp


; Calls the APM BIOS to put the entire system in the STANDBY state
;
; ->	void
; <-	void
;
	public	SetSystemStandbyState
SetSystemStandbyState	proc near

	mov	_restorePower, 1
	call	_RealTime2Ticks
	mov	word ptr cs:lastSuspendOrStandbyTicks, ax
	mov	word ptr cs:lastSuspendOrStandbyTicks[2], dx

	mov	ax, APM_SET_POWER_STATE
	mov	bx, APM_DEV_ALL
	mov	cx, STANDBY
	int	15h

	call	RecordCurrentPowerState
	ret
SetSystemStandbyState 	endp


; This is the APM BIOS CRITICAL_SUSPEND_NOTICE event handler.
; This contains the handler to actually suspend the system.
;
; POWER must respond by suspending the system "without delay
; and without notifying APM-aware applications or device drivers
; first." However, APM v1.1 gives POWER 5 secs before it calls
; back the APM BIOS with the SUSPEND request. The intent is to
; allow us to make sure we can restore things that might otherwise
; get unrecoverably munged up...
;
; This event is only generated in emergencies.
;
; -> 	void
; <-	void
;
	public CriticalSuspendHandler
CriticalSuspendHandler	proc near

	mov	ax, APM_APP_EVENT_BROADCAST
	mov	bx, CRITICAL_SUSPEND_NOTICE
	int	2Fh

; Calls the APM BIOS to put the entire system in the SUSPENDed state
;
; ->	void
; <-	void
;
	public SetSystemSuspendState
SetSystemSuspendState	proc near

	mov	_restorePower, 1
	call	_RealTime2Ticks
	mov	word ptr cs:lastSuspendOrStandbyTicks, ax
	mov	word ptr cs:lastSuspendOrStandbyTicks[2], dx

	mov	ax, APM_SET_POWER_STATE
	mov	bx, APM_DEV_ALL
	mov	cx, SUSPEND
	int	15h

	call	RecordCurrentPowerState
	ret
SetSystemSuspendState 	endp
CriticalSuspendHandler	endp


; Informs APM aware apps of a return to the full power state.
; This directly handles the following APM BIOS events:
;
;  	END_NORMAL_SUSPEND_NOTICE
;	END_CRITICAL_SUSPEND_NOTICE
;	END_NORMAL_STANDBY_NOTICE
;
; This is also called when an APM aware app rejects any APM BIOS
; power reduction request.
;
; ->	BX	one of the above APM BIOS event IDs
; <-	void
;
	public PowerRestoredNotifier
PowerRestoredNotifier	proc near

	push	bx

	call	_RealTime2Ticks
	sub	ax, word ptr cs:lastSuspendOrStandbyTicks
	sbb	dx, word ptr cs:lastSuspendOrStandbyTicks[2]
	add	cs:_IdleTicks, ax
	adc	cs:_IdleTicks2, dx
	add	cs:_Ticks, ax
	adc	cs:_TotalTicks, dx

	call	SetTicks
	pop	bx

	mov	cs:_LastActivity, 0
	push	cs:_Pwr_Mgt_Ticks
	pop	cs:_SystemIdleCount
	mov	cs:_Pwr_Mgt_Count, 9

	mov	ax, APM_APP_EVENT_BROADCAST
	int	2Fh

	call	RecordCurrentPowerState
	ret
PowerRestoredNotifier	endp


; (Dis)Qualifies standby request events from APM with APM aware
; apps. The request events generated by the APM BIOS are:
;
; 	SYSTEM_STANDBY_REQUEST:	event ID = 0001b
; 	SYSTEM_SUSPEND_REQUEST: event ID = 0010b
; 	USER_STANDBY_REQUEST:	event ID = 1001b
; 	USER_SUSPEND_REQUEST:	event ID = 1010b
;
; Note that the both xxx_STANDBY_REQUEST event IDs have B0 set
; and B1 clear while both xxx_SUSPEND_REQUEST event IDs have B0
; clear and B1 set. The actions take for USER_xxx_EVENTS are the
; same as for SYSTEM_xxx_EVENTS.
;
; ->	BX	one of the above APM BIOS event IDs
; <-	void
;
	public RequestNotifier
RequestNotifier	proc near

	; We need to keep notifying the APM BIOS that we are working
	; on the request "a minimum of once every 5 seconds" or it
	; will go ahead and change the power state anyway.
	; Notify APM that we're processing the request
	;
	call	ProcessingRequestNotifier ; will queue itself

	; Notify APM aware apps of the APM BIOS' power reduction plans
	;
	push	bx			; save the APM BIOS event ID
	mov	ax, APM_APP_EVENT_BROADCAST
	int	2Fh

	; Notify the BIOS one last time that we are handling the request
	; then cancel the timed call back.
	;
	call	ProcessingRequestNotifier
	cli
	mov	cs:_APM_notify_count, -1 ; no more callbacks 'till next time
	sti

	; Bit 80h will be set if any of the APM aware apps rejected the
	; APM BIOS' request to reduce the system power drain
	;
	shl	bx, 1
	pop	bx			; get back BIOS event code again
	jnc	RN_request_accepted

    RN_request_rejected:

	; Some app rejected the request, Tell the BIOS "no way".
	;
	push	bx			; save the event code one more time
	call	RequestRejectedNotifier

	; There may exist apps that approved the BIOS' request and so
	; "powered themselves down". We gotta wake those guys up
	; and tell them that power has been restored.
	;
	pop	bx			; retrieve event code one last time
	shr	bx, 1
	mov	bx, END_NORMAL_SUSPEND_NOTICE	; assume "suspend" request
	jnc    	RN_restore_apps

	mov	bx, END_NORMAL_STANDBY_NOTICE	; oops, "standby" request

    RN_restore_apps:
	call	PowerRestoredNotifier
	jmp	short RN_exit

    RN_request_accepted:
	shr	bx, 1
	jc	RN_enter_standby_mode

    RN_enter_suspend_mode:
	call	SetSystemSuspendState
	jmp	short RN_exit

    RN_enter_standby_mode:
	call 	SetSystemStandbyState

    RN_exit:
	ret
RequestNotifier	endp


; The APM BIOS BATTERY_LOW_NOTICE event handler.
;
; ->	BX 	BATTERY_LOW_NOTICE event ID
; <-	void
;
	public BatteryLowHandler
BatteryLowHandler	proc near

	mov	_BatteryLow, 1
	call	NonspecificEventHandler

	; do we really want to shut down now?

	ret
BatteryLowHandler	endp


; This handles the APM BIOS POWER_STATUS_CHANGE_NOTICE event.
; It calls the BIOS back to get the system power status and see
; what has changed (with the AC line or the battery).
;
; ->	void
; <-	BH:	AC line status
;			00h = off line
;			01h = on line
;			02h = on backup power
;			FFh = unknown, all other values reserved
;	BL:	Battery status
;			00h = high
;			01h = low
;			02h = critical
;			FFh = unknown, all other values reserved
;	CH:	Battery flag
;			B0:	1 = high
;			B1:	1 = low
;			B2:	1 = critical
;			B3:	1 = charging
;			B7:	1 = no system battery
;			0FFh 	  = unknown battery condition,
;				    all other values reserved
;	CL:	Remaining battery life (per centage)
;			0-100	(% of full charge)
;			0FFh	unknown charge, all other values reserved
;	DX:	Remaining battery life (time)
;			B15	1 = time units are minutes
;				0 = time units are seconds
;			B0-B14	  = time units remaining, valid values are
;				    0-7FFFh seconds and 0-7FFEh minutes
;			FFFFh	unknown charge
;
	public PowerStatusChangedHandler
PowerStatusChangedHandler	proc near

	mov	ax, APM_GET_PWR_STATUS
	mov	bx, APM_DEV_ALL
	int	2Fh

	; record status stuff
	;
	ret
PowerStatusChangedHandler	endp


; This routine broadcasts all the special events that POWER doesn't
; do anything else with. These event numbers are:
;
;	0005h		Battery Low Notice
;
; 	000Ch...00FFh:	Reserved System Events
;	0100h...01FFh:	Reserved Device Events
;	0200h...02FFh:	OEM Defined APM Events
;	0300h...FFFFh:	Reserved
;
; ->	BX	one of the above APM BIOS event IDs
; <-	void
;
	public NonspecificEventHandler
NonspecificEventHandler	proc near

	mov	ax, APM_APP_EVENT_BROADCAST
	int	2Fh
	ret
NonspecificEventHandler	endp


; This is the table of APM BIOS event handlers. Many of these
; events are handled by common functions which are passed the
; APM BIOS ID number in BX.
;
APMEventHandlerTable	label	word
	dw offset NonspecificEventHandler	; any event not listed below
	dw offset RequestNotifier		; SYSTEM_STANDBY_REQUEST
	dw offset RequestNotifier		; SYSTEM_SUSPEND_REQUEST
	dw offset PowerRestoredNotifier		; END_NORMAL_SUSPEND_NOTICE
	dw offset PowerRestoredNotifier		; END_CRITICAL_SUSPEND_NOTICE
	dw offset BatteryLowHandler		; BATTERY_LOW_NOTICE
	dw offset PowerStatusChangedHandler	; POWER_STATE_CHANGE_NOTICE
	dw offset SetTicks			; UPDATE_TIME_NOTICE
	dw offset CriticalSuspendHandler	; CRITICAL_SUSPEND_NOTICE
	dw offset RequestNotifier		; USER_STANDBY_REQUEST
	dw offset RequestNotifier		; USER_SUSPEND_REQUEST
	dw offset PowerRestoredNotifier		; END_NORMAL_STANDBY_NOTICE


; This routine collects and routes pending APM BIOS events.
;
	public HandleAPMEvents
HandleAPMEvents	proc

;	cmp	word ptr _APM_version, 0101h
;	jb	HAPME_get_next_event

    HAPME_get_next_device_status:
	;
	; RoyS reports these crash the Phoenix BIOS on the ELAN386 board.
	;

    HAPME_get_next_event:
	mov	ax, APM_GET_PWR_MGMT_EVENT
	int	15h				; get next APM BIOS event
	jc	HAPME_exit			; CF set if none, else BX = ID

	push	bx				; save event ID
	cmp	bx, END_NORMAL_STANDBY_NOTICE
	jbe	HAPME_dispatch_next_event	; if event is not in our table

	xor	bx, bx				; just broadcast it

    HAPME_dispatch_next_event:
	shl	bx, 1
	mov	ax, cs:APMEventHandlerTable[bx]
	pop	bx				; get back event ID and
	call	ax				; call the event handler

	jmp	short HAPME_get_next_event	; repeat until no more events

    HAPME_exit:
	ret
HandleAPMEvents	endp



; Interrupt 2F is the Redirector Int.
; Functions 1605 and 1606 are the Entering Windows/Leaving Windows
; messages, respectively.
; The AH=54 are the POWER Specific calls to the 2f interrupt.
; Only a few are supported.
;
_int_2F	proc

	cmp	ax, APM_APP_IDLE_SIGNAL	; just set a flag in response
	jne	_2F_not_idle_app

	mov	cs:gotAppIdleSignal, 1
	mov	ax, APM_CPU_IDLE
	int	15h
	mov	ax, APM_CPU_BUSY
	int 	15h

	jmp	_2F_ret

    _2F_not_idle_app:
	cmp	ax, 1605h		; Is MS-Windows Starging UP?
	jnz	_2F_leaving
	mov	cs:_InWindows, 1
	xor	cx, cx
	jmp	_2F_out

    _2F_leaving:
	cmp	ax, 1606h		; Are we leaving MS-Windows?
	jnz	_2F_wait
	mov	cs:_InWindows, 0
	jmp	_2F_out

    _2F_wait:
    	cmp	ax, 5380h		; Set suspend wait ticks
	jnz	_2F_A
	mov	cs:_Pwr_Mgt_Ticks, bx
	mov	cs:_SystemIdleCount, bx
	jmp	_2F_out

    _2F_A:
    	cmp	ah,54h			; Power Specific Call?
	jz	_2F_AA
	jmp	_2F_out

    _2F_AA:
	cmp	al, 00			; Installation Check
	jnz	_2F_B
	mov	bx, 'PM'
	mov	ax, 100h
	jmp	_2F_OK

    _2F_B:
	cmp	al, 1			; Get Status
	jnz	_2F_C

	xor 	ax, ax
	mov	bx, 303
	jmp	_2F_OK

    _2F_C:
	cmp	al, 3			; Get Power Mgt Status
	jnz	_2F_D
	or	bx, bx
	jz	_2F_Cexit

	push	si
	push	di
	push	ds
	push	cs
	pop	ds

	cmp	bx, 6
	je	_2F_C_setReg
	jb	_2F_C_setMin

	or	bx, bx
	jns	_2F_C_setMax

	call	_SetOFFOperation;
	jmp	short _2F_Cdone

    _2F_C_setMax:
	call	_SetMAXOperation;
	jmp	short _2F_Cdone

    _2F_C_setMin:
	call	_SetMINOperation;
	jmp	short _2F_Cdone

    _2F_C_setReg:
	call	_SetSTDOperation;

    _2F_Cdone:
	pop	ds
	pop	di
	pop	si

    _2F_Cexit:
	xor 	ax, ax
	mov	bx, cs:_PowerMgtStatusCode
	jmp	_2F_OK

    _2F_D:
	cmp	al,81H			; Get Power Status Table
	jnz	_2F_E

	xor	ax, ax
	push	ds
	push	es
	push	ds
	pop	es
	push	cs
	pop	ds

	xchg	si, di
	push	si
	mov	si, Offset _TEXT:_Ticks
	cld
	rep movsb

	pop	si
	pop	es
	pop	ds
	iret

    _2F_E:
    	cmp	al,99H			; ROM-DOS Power UnLoad
	jnz	_2F_Z
	push	ds
	mov	ax, DGROUP
	mov	ds, ax
	call	_UnInstall
	pop	ds
	jmp	_2F_OK

    _2F_Z:
	jmp	_2F_Error

    _2F_OK:
    	push	bp			; Success Return
	mov	bp, sp
	and 	Word Ptr [bp+6], NOT CARRY_FLAG
	pop	bp
	iret

    _2F_Error:
       	push	bp		; Error 2f Return
	mov	bp, sp
	or 	Word Ptr [bp+6], CARRY_FLAG
	pop	bp

    _2F_ret:
        iret

    _2F_out:	db	0EAH	; Far Jump instruction
_old_int_2F	dd	0   	; far pointer to old interrupt C routine

_int_2F	endp


;* Power Management executive power management function.
;* This function is called once every ?? seconds at the
;* start of a get key call.  It does the following:
;*
;*	1) Powers down any devices not used for ?? period of time
;*	2) Checks APM_Event and take approaite action
;*	3) Re-schedules it self
;*/
	public	_power_management
_power_management	proc

	push	si

	cmp	_InWindows, 0
	je	PM_start
	jmp	PM_exit

    PM_start:
IF 0
	lea	si, _Devices
	cmp	APMVersion, 101h
	jb	PM_dispatch_BIOS_events

	xor	bx, bx
	push	si

    PM_get_one_device_state:
	push	bx

	mov	ax, APM_GET_PWR_MGMT_STATE
	int	15h
	mov	[si].Status, cx

	pop	bx
	inc	bx
	add	si, SIZE DEVICE
	cmp	bx, 5
	jb	PM_get_one_device_state

	pop	si
ENDIF
    PM_dispatch_BIOS_events:
	call	HandleAPMEvents

    PM_check_suspend:
	cmp	gotAppIdleSignal, 0	; always act on user request
	je	PM_exit
;	je	PM_handle_idle_devices

	cmp	ucCurrentPowerState, STANDBY
	je	PM_suspend   		; if in STANDBY goto SUSPEND
	jb	PM_standby		; if READY goto STANDBY
	jmp	short PM_exit		; otherwise just leave

    PM_handle_idle_devices:
IF 0
	mov	al, SIZE DEVICE
	mov	ah, DEV_KEYBOARD
	mul	ah
	add	si, ax			; point to our keyboard device

	mov	ax, [si].InactiveCount
	or	ax, ax
	jz	PM_exit

	mov	bx, _Ticks
	sub	bx, [si].LastUsed
	cmp	bx, ax
	jbe	PM_exit			; if it hasn't been used
ENDIF
    PM_standby:
	mov	ax, APM_APP_EVENT_BROADCAST
    	mov	bx, SYSTEM_STANDBY_REQUEST
	int	2Fh
	or	bx, bx
	js	PM_exit

	call	SetSystemStandbyState
	jmp	short PM_awake

    PM_suspend:
	mov	ax, APM_APP_EVENT_BROADCAST
    	mov	bx, SYSTEM_SUSPEND_REQUEST
	int	2Fh
	or	bx, bx
	js	PM_exit

	call	SetSystemSuspendState

    PM_awake:
    PM_exit:
    	call	HandleAPMEvents

	mov	gotAppIdleSignal, 0

	pop	si
	ret
_power_management	endp


	public	do_power_mgt
do_power_mgt	proc

	push	ax
	inc	cs:onXstack
	jnz	DPM_exit

	mov	word ptr cs:old_SS, ss
	mov	word ptr cs:old_SP, sp

	mov	ax, cs
	mov	ss, ax
	mov	sp, offset _TEXT:end_Xstack

	sti
	push	bx
	push	cx
	push	dx
	push	si
	push	di
	push	ds
	push	es

	mov	ds, ax
	call	_power_management

	pop	es
	pop	ds
	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	bx

	mov	ss, word ptr cs:old_SS
	mov	sp, word ptr cs:old_SP

    DPM_exit:
	dec	cs:onXstack
	pop	ax
	ret
do_power_mgt	endp


	public	do_power_restore
do_power_restore	proc

	push	ax
	inc	cs:onXstack
	jnz	DPR_exit

	mov	word ptr cs:old_SS, ss
	mov	word ptr cs:old_SP, sp

	mov	ax, cs
	mov	ss, ax
	mov	sp, offset _TEXT:end_Xstack

	sti
	push	bx
	push	cx
	push	dx
	push	si
	push	di
	push	ds
	push	es

	mov	ds, ax
	call	_power_restore

	pop	es
	pop	ds
	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	bx

	mov	ss, word ptr cs:old_SS
	mov	sp, word ptr cs:old_SP

    DPR_exit:
	dec	cs:onXstack
	pop	ax
	ret
do_power_restore	endp



_getCS:	mov	AX,CS
       	ret

;
;Standard Borland C setvect function
;
_setvect:	push	bp
		mov	BP,SP
		mov	AH, 25H
		mov	AL, byte Ptr [BP+4]
		push	DS
		lds	DX, [BP+6]
		int	21H
		pop	DS
		pop	BP
		ret

;
; Standard Borland C getvect function
;
_getvect:	push	BP
		mov	BP, SP
		mov	AH, 35H
		mov	AL, byte ptr [BP+4]
		int	21H
		mov	AX, BX
		mov	DX, ES
		pop	BP
		ret

;COMMENT ; prototype
;int enhanced_keyboard(void)
;{}
;
_enhanced_keyboard:
	; determine if we have an extended keyboard or not
	; clear the zero flag and check for key
	mov	AX, 1100H	; Extended check, AL = 0
	cmp	AL, 1		; Always false to clear ZF
	int	16H
	jz	yesext		; if BIOS says no char, believe it
	or	AL, AL
	jz	notext		; if char, but char==0, don't believe it

yesext:
	mov	AX, 1
	ret

notext:
	mov	AX, 0
	ret
cEndCode


cBegData
	extrn _Ticks:word
	extrn _IdleTicks:word
	extrn _IdleTicks2:word
	extrn _TotalTicks:word
	extrn _Pwr_Mgt_Count:word, _Pwr_Mgt_Ticks:word
	extrn _Do_Pwr_Mgt:word, _Devices:word, _restorePower:word
	extrn _checkForKey:byte

	extrn _Check_Start:word, _Check_MAX:word, _Check_Ticks:word
	extrn _Checking:word
	extrn _DOS_IdleCount:word
	extrn _KEY_IdleCount:word
	extrn _LastActivity:word
	extrn _IsIdle:word
	extrn _SystemIdleCount:word
	extrn _InWindows:word
	extrn _APM_errno:word
	extrn _APM_version:word
	extrn _BatteryLow:word
	extrn _PowerMgtStatusCode:word

old_SS		dw	0
old_SP		dw	0

; The "is it time to call APM BIOS and say we're still talking to apps"
; counter variable.
;
	public	_APM_notify_count
_APM_notify_count dw	-1

; The single pwr mgt stack counted semaphore.
;
	public	onXstack
onXstack	db	-1


cEndData


cBegUdata
Xstack	db 1024 dup(?)
end_Xstack equ $-2
cEndUdata

	End


