//
//   $Id: POWER.C 1.4 2002/10/16 21:57:04Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*
 * Datalight Power Management Software
 * Main Module
 *
 * Copyright(c) 1993-2002 Datalight Inc.
 * All Rights Reserved
 * Datalight Confidential and Proprietary
 */


#define FUDGE 10

#include "dosver.h"
#include "datalght.h"
#include "fatworld.h"

#include "power.h"

#include "proto.h"


#if SIMULATE
//#include "apm-sim.h"
#endif

extern char *USAGE;

// This becomes the start of a table for POWER.EXE with
// The TotalTicks and IdleTicks at the front
// Other entries in this table are unknown at this time!
//
unsigned Ticks=0;	         /* Tick Count for PM */
unsigned TotalTicks=0;		/* MS-Power uses a long for Tick Count */
unsigned IdleTicks=0;		/* # of Ticks that the system has been IDLE */unsigned IsIdle;				/* Flag for System Idle! 0 = Active 1 = Idle */
unsigned IdleTicks2=0;		/* MS-Power uses a long for Tick Count */
unsigned Pwr_Mgt_Count=9;	/* Ticks left till next schedule of Power_Managment */

unsigned Do_Pwr_Mgt;			/* True if Power_Management function scheduled */
unsigned restorePower;		/* True if Power_Restore function scheduled */

unsigned DOS_SetDate;		/* Flag for reseting DOS date after Suspend */

unsigned DOS_IdleCount;		/* Counter for number of DOS Idle calls per Tic */
unsigned KEY_IdleCount;		/* Counter for number of Poll call per Tic */
unsigned LastActivity;		/* Tic of last Activity */

unsigned BatteryLow;			/* Flag for signaling battery low */

unsigned char checkForKey = 1;	/* INT 16 Function to check for keypress */

unsigned InWindows=0;		/* Are we in Windows?  (never suspend) */

unsigned APM_Version = 0, APM_errno = 0;

unsigned SystemIdleCount=0;

bool fIsFat32World;

//  This is a boolean variable used to tell if there was
//  a K parameter on the command line.  It is used to determine
//  if the _Pwr_Mgt_Ticks variable needs to be updated in
//  the resident code.
//
int bParameterK = 0;

//  This is a boolean variable used to tell if there was
//  a set operation occured initiated byt the command
//  line.  It is used to determine if the _Pwr_Mgt_Ticks
//  variable needs to be updated in the resident code.
//
int bSetOperation = 0;

void SetSuspendWait( unsigned Pwr_Mgt_Ticks );
void SetSTDOperation(void);
void SetMAXOperation(void);
void SetMINOperation(void);
void SetOFFOperation(void);
int PowerMgtStatusCode = 6; // Magic numbers: 1..5="MIN"; 6="REG"; 7,8="MAX"

struct device Devices[6] = {

/* 		LastUsed,	Inactive, 	Status */
		{	0,				0, 			0		},	/* System */
		{	0,				0, 			0		},	/* Display */
		{	0,				0,				0		},	/* Disk */
		{	0,				0, 			0		},	/* Printer Port */
		{	0,				0, 			0		},	/* Serial Port */
		{	0,				0, 			0		},	/* Keyboard */
};

int defPwr_Mgt_Ticks = 0;

int PWR_SetAPMSettings(int val);

// return the uppercase equivalent of the character c
int toupper(char c)
{
	if(c>='a' && c<='z')
		c = c-'a'+'A';
	return c;
}

void DisplaySignOnMessage( void )
{
	if( fIsFat32World )
	{
		printf(SIGNON,SHORTVERSION,BUILDVERSION,COPYRIGHT);
	}
	else
	{
		printf(SIGNON,SHORTVERSION622,BUILDVERSION,COPYRIGHT);
	}
}

void main(char far *cmd_line)
{
	unsigned paras;
	extern int enhanced_keyboard(void);

	//  Determine if we are operating in a DOS 7.1 enviornment
	//
	fIsFat32World = dlIsFat32World();

	/* display sign-on */
	DisplaySignOnMessage();

	APM_Version = APM_Installed();
	if(APM_Version == 0)
	{
		fat_error(1);
	}


	Pwr_Mgt_Ticks = scale_time(Pwr_Mgt_Ticks);
	SystemIdleCount  = Pwr_Mgt_Ticks;
	defPwr_Mgt_Ticks = Pwr_Mgt_Ticks;

	Devices[DEV_DISPLAY].InactiveCount = scale_time(Power_Down_Display);
	Devices[DEV_DISK].InactiveCount = scale_time(Power_Down_Disk);
	Devices[DEV_PRINTER].InactiveCount = scale_time(Power_Down_Printer);
	Devices[DEV_SERIAL].InactiveCount = scale_time(Power_Down_Serial);

	do_args(cmd_line);

	if(PWR_Installed())
	{
		ShowPMStatus();

		if( bParameterK )
		{
			SetSuspendWait( Devices[5].InactiveCount );
		}

		if( bSetOperation )
		{
			SetSuspendWait( Pwr_Mgt_Ticks );
		}

		exit(0);
	}

#if SIMULATE
	install_APM_SIM();
#endif

#if DEBUG
	printf("APM Version = %x\n", APM_Version);
#endif


#if 0
	functionality moved to APM_Installed() in POWASM.ASM

	if(!APM_Connect())
	{
#if SIMULATE
		uninstall_APM_SIM();
#endif
		fat_error(5);
	}
#endif


	if (enhanced_keyboard())
		checkForKey = 0x11;

	Install();				/* Install capture BIOS interrupts */


#if 0

	/* Put Debug Code Here */
	while(1)
	{
		if (getch() == 27)
			break;
	}

	UnInstall();
#else

//	paras = get_total_bytes() >> 4;		/* Program Space */
	paras = 0x200;
	paras += 0x10;							/* PSP */
	paras += FUDGE;
//		printf("TSR at %x for %x paras GetTotalBytes = %x\n", getCS(), paras, get_total_bytes());
	keep(0, paras);							/* Become a TSR */

#endif

}


/*
 * Install Power Management interrupt vectors.
 * The vectors include BIOS interrupts 13, 16, and 1A
 *
 */
void Install(void)
{
	message(3);

//	old_int_10 = getvect(SCREEN_INTERRUPT);
//	setvect(SCREEN_INTERRUPT, int_10);

	if(Devices[DEV_DISK].InactiveCount != 0)
	{
		old_int_13 = getvect(DISK_INTERRUPT);
		setvect(DISK_INTERRUPT, int_13);
	}

	if(Devices[DEV_SERIAL].InactiveCount != 0)
	{
		old_int_14 = getvect(SERIAL_INTERRUPT);
		setvect(SERIAL_INTERRUPT, int_14);
	}

	if(Devices[DEV_PRINTER].InactiveCount != 0)
	{
		old_int_17 = getvect(PRINTER_INTERRUPT);
		setvect(PRINTER_INTERRUPT, int_17);
	}

	old_int_16 = getvect(KEYBOARD_INTERRUPT);
	setvect(KEYBOARD_INTERRUPT, int_16);

	old_int_1C = getvect(TIMER_INTERRUPT);
	setvect(TIMER_INTERRUPT, int_1C);

	old_int_9 = getvect(KEYSTROKE_INTERRUPT);
	setvect(KEYSTROKE_INTERRUPT, int_9);

	old_int_B = getvect(SERIAL_INTERRUPT_1);
	setvect(SERIAL_INTERRUPT_1, int_B);

	old_int_C = getvect(SERIAL_INTERRUPT_2);
	setvect(SERIAL_INTERRUPT_2, int_C);

	old_int_28 = getvect(DOS_IDLE_INTERRUPT);
	setvect(DOS_IDLE_INTERRUPT, int_28);

	old_int_2F = getvect(DOS_REDIR_INTERRUPT);
	setvect(DOS_REDIR_INTERRUPT, int_2F);
}

/*
 * UnInstall Power Management interrupt vectors.
 * The vectors include BIOS interrupts 13, 16, and 1A
 *
 */
void UnInstall(void)
{
	if(Devices[DEV_DISK].InactiveCount != 0){
		setvect(DISK_INTERRUPT, old_int_13);
	}

	if(Devices[DEV_SERIAL].InactiveCount != 0){
		setvect(SERIAL_INTERRUPT, old_int_14);
	}

	if(Devices[DEV_PRINTER].InactiveCount != 0){
		setvect(PRINTER_INTERRUPT, old_int_17);
	}

	setvect(KEYBOARD_INTERRUPT, old_int_16);

	setvect(TIMER_INTERRUPT, old_int_1C);

	setvect(KEYSTROKE_INTERRUPT, old_int_9);

	setvect(SERIAL_INTERRUPT_1, old_int_B);

	setvect(SERIAL_INTERRUPT_2, old_int_C);

	setvect(DOS_REDIR_INTERRUPT, old_int_2F);

	APM_Disconnect();

#if SIMULATE
	uninstall_APM_SIM();
#endif

	message(4);
}



/*
 * Parse the Command line arguments
 */
void do_args(char far *cmd_line)
{
	int i, j, len;
	char numb_string[25];

	len = *cmd_line++;

	for(i=0; i<len; ++i){

		if(cmd_line[i] == ' ' || cmd_line[i] == '\t')
			continue;

		if(cmd_line[i] == '?')
			goto do_usage;

		if(cmd_line[i]  == '/' || cmd_line[i] == '/'){
			++i;
			switch(cmd_line[i]){
				case 'c':				/* COM Ports */
				case 'C':
					++i;
					j=0;
					while(cmd_line[i] >= '0' && cmd_line[i] <= '9')
						numb_string[j++] = cmd_line[i++];
					numb_string[j] = '\0';
					Devices[4].InactiveCount = scale_time(atoi(numb_string)*10);
					break;

				case 'd':				/* Disk */
				case 'D':
					++i;
					j=0;
					while(cmd_line[i] >= '0' && cmd_line[i] <= '9')
						numb_string[j++] = cmd_line[i++];
					numb_string[j] = '\0';
					Devices[2].InactiveCount = scale_time(atoi(numb_string)*10);
					break;

				case 'k':				/* Keyboard */
				case 'K':
					++i;
					j=0;
					while(cmd_line[i] >= '0' && cmd_line[i] <= '9')
						numb_string[j++] = cmd_line[i++];
					numb_string[j] = '\0';
					Devices[5].InactiveCount = scale_time(atoi(numb_string)*10);
					bParameterK = 1;
					Pwr_Mgt_Ticks    = Devices[5].InactiveCount;
					SystemIdleCount  = Pwr_Mgt_Ticks;
					defPwr_Mgt_Ticks = Pwr_Mgt_Ticks;
					break;

				case '?':
				case 'h':
				case 'H':
do_usage:		printf(USAGE);
					exit(1);

				case 'p':				/* Printer */
				case 'P':
					++i;
					j=0;
					while(cmd_line[i] >= '0' && cmd_line[i] <= '9')
						numb_string[j++] = cmd_line[i++];
					numb_string[j] = '\0';
					Devices[3].InactiveCount = scale_time(atoi(numb_string)*10);
					break;

				case 's':				/* Screen */
				case 'S':
					if((toupper(cmd_line[i+1]) == 'T') && (toupper(cmd_line[i+2]) == 'D'))
					{
						SetSTDOperation();
						PWR_SetAPMSettings(PowerMgtStatusCode);
						i+=2;
						break;
					}
					++i;
					j=0;
					while(cmd_line[i] >= '0' && cmd_line[i] <= '9')
						numb_string[j++] = cmd_line[i++];
					numb_string[j] = '\0';
					Devices[1].InactiveCount = scale_time(atoi(numb_string)*10);
					break;

				case 'a':
				case 'A':
					if(toupper(cmd_line[++i]) != 'D') break;
					if(toupper(cmd_line[++i]) != 'V') break;
					if(cmd_line[++i] == ':')
					{
						++i;
						if(toupper(cmd_line[i]) == 'R')
						{
							SetSTDOperation();
						}
						else if(toupper(cmd_line[i+2]) == 'X')
						{
							SetMAXOperation();
						}
						else
						{
							SetMINOperation();
						}
						i+=2;
						PWR_SetAPMSettings(PowerMgtStatusCode);
					}
					break;

				case 'o':
				case 'O':
					if((toupper(cmd_line[i+1]) == 'F') && (toupper(cmd_line[i+2]) == 'F'))
					{
						SetOFFOperation();
						i+=2;

						// NOTE: 0 is the get status function code.
						// 	   Use -1 to indicate we want POWER off.
						//
						PWR_SetAPMSettings(PowerMgtStatusCode-1);
					}
					break;

				default:
					goto bad_arg;
			}
		}
		else{
bad_arg:		fat_error(2, cmd_line[i]);
			exit(1);
		}
	}
}

//  This function sets the _Pwr_Mgt_Ticks variable in the resident
//  part of power management code.  This variable controls the time
//  the system will wait with no activity before initiating a
//  standby and inevidably a suspend.
//
void SetSuspendWait( unsigned Pwr_Mgt_Ticks )
{
	asm {
		mov	ax, 5380h
		mov	bx, Pwr_Mgt_Ticks
		int 	2Fh
	}
}


/*
 * Power Restore function is triggered by a keystroke (INT 9)
*/
void power_restore(void)
{
#if SOUND
	int i;
	sound(10000);
	delay(20);
	nosound();
#endif

	APM_SetPowerState((APM_DEV_SYSTEM + 0xFF), READY);
	Devices[DEV_SYSTEM].Status = READY;
	Devices[DEV_SYSTEM].LastUsed = Ticks;
	APM_SetPowerState(APM_DEV_DISPLAY + 0xFF, READY);
	Devices[DEV_DISPLAY].Status = READY;
	Devices[DEV_DISPLAY].LastUsed = Ticks;

}


#if 0
void do_command(void)
{
	char *getenv(char *);
	char *name = getenv("COMSPEC");
	if(name == NULL)
		name = "C:\\COMMAND.COM";
	spawn(0, name, name, 0);
}
#endif


int atoi(const char * str)
{
	unsigned num=0;
	while(*str >= '0' && *str <= '9')
		num = (num * 10) + (*str++ - '0');

	return (num);
}


/*
 * Scale_Time changes the time from a fixed point decimal number
 * into ticks.  The fixed point decimal number is ten times the actual
 * number of seconds.  For example 10 represents 1 second, and
 * 35 represents 3 and 1/2 seconds.
 * There are 18.2 ticks per second or just 18 for our purposes.
 */
scale_time(unsigned time)
{
	return (time * 18) / 10;
}


long RealTime2Ticks()
{
	unsigned char Hour;
	unsigned char Min;
	unsigned char Sec;
	unsigned long Ticks;

asm	mov	ax, 0200H
asm	int	1AH
asm	mov	Hour, ch
asm	mov	Min, cl
asm	mov	Sec, dh

	Hour = (Hour & 0xF) + ((Hour >> 4) * 10);
	Min = (Min & 0xF) + ((Min >> 4) * 10);
	Sec = (Sec & 0xF) + ((Sec >> 4) * 10);

	Ticks =  Sec  * 182;
	Ticks += _lmulu((182L * 60), Min);
	Ticks += _lmulu((182L * 3600), Hour);
	Ticks  = _ldiv(Ticks, 10L);

	return (Ticks);
}

int PWR_Installed(void)
{
	_AX = 0x5400;
	_BX = 99;
	geninterrupt(0x2f);
	if(_BX == 'MP')
		return 1;
	else
		return 0;
}

void PWR_GetStatTable(struct PowerStat *S)
{
	_AX = 0x5481;
	_BX = 0;
	_CX = sizeof(struct PowerStat);
	_SI = (unsigned) S;
	geninterrupt(0x2f);
}

int PWR_GetAPMSetting(void)
{
	int APM_Setting;
	_AX = 0x5403;
	_BX = 0;
	_CX = 0;
	geninterrupt(0x2f);
	APM_Setting = _BX;
	return (APM_Setting);
}

int PWR_SetAPMSettings(int val)
{

	// establish ADVANCED POWER MGT SETTING
	//
	asm {
		mov	ax, 5403h
		mov	bx, val
		int 	2Fh
		mov	PowerMgtStatusCode, bx
	}

	// if val was (-1) then POWER was just turned off, disable APM BIOS;
	// otherwise POWER is turned (back) on, make sure APM BIOS enabled.
	//
	val = (val > 0) ? 1 : 0;
	asm {
		mov	ax, 5308h
		mov	bx, APM_DEV_ALL
		mov	cx, val
		int	15h
	}

	return PowerMgtStatusCode;
}

void SetSTDOperation(void)
{
	PowerMgtStatusCode = 6;
	Pwr_Mgt_Ticks = defPwr_Mgt_Ticks;
	SystemIdleCount = Pwr_Mgt_Ticks;
	bSetOperation = 1;
}

void SetMAXOperation(void)
{
	PowerMgtStatusCode = 8;
	Pwr_Mgt_Ticks = defPwr_Mgt_Ticks / 2;
	SystemIdleCount = Pwr_Mgt_Ticks;
	bSetOperation = 1;
}

void SetMINOperation(void)
{
	PowerMgtStatusCode = 4;
	Pwr_Mgt_Ticks = defPwr_Mgt_Ticks * 2;
	SystemIdleCount = Pwr_Mgt_Ticks;
	bSetOperation = 1;
}

void PWR_UnLoad(void)
{
	_AX = 0x5499;
	geninterrupt(0x2f);
}

void SetOFFOperation(void)
{
	PowerMgtStatusCode = 0;
	bSetOperation = 1;
}

char *PwrMgtStat =
"Power Status\n"
"------------------\n"
"Setting =  ADV: " ;

char *PwrCPUStat = "\nCPU: idle ";
char *PwrCPUStat2 = " of time.\n";

void ShowPMStatus(void)
{
	int APM_Setting;
	struct PowerStat PowerStat;
	APM_Setting = PWR_GetAPMSetting();

	PWR_GetStatTable(&PowerStat);

	printf(PwrMgtStat);
	if(APM_Setting == 0)
		printf("Off");
	else if(APM_Setting < 6)
		printf("Min");
	else if(APM_Setting > 6)
		printf("Max");
	else
		printf("Reg");
	printf(PwrCPUStat);

#if 1
	printf("%d%%", (unsigned)	_ldiv(_lmulu(PowerStat.IdleTicks, 100), PowerStat.TotalTicks) );
#endif
	printf(PwrCPUStat2);

	if((APM_GetStatus() & 0xFF00) == APM_STAT_ON_LINE)
		printf("AC Line Status : ONLINE\n");
}

