;
;   $Id: ABSREAD.ASM 1.4 2002/10/16 21:58:28Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
COMMENT ~
-----------------------------------------------------------

   ABSREAD.ASM  created by Drew Gislason

   Copyright (c) 1990-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary.

----------------------------------------------------------- ~

include macros.inc

cBegUdata
	; do NOT change the order of these items
	start_sec	dd	?
	num_sec		dw	?
	buffer		dd	?
cEndUdata

cBegData
	dirstr	db	"A:*.*",0
cEndData

cBegCode

;
comment ~
int diskinit(int drive)
~
;
;  drive, 0=A, 1=B, etc...
;
c_func	diskinit
	push	BP
	mov	BP, SP
	mov	AL, P[BP]
	add	AL, 'A'
	mov	[dirstr], AL
	mov	DX, GOFFSET dirstr
	xor	CX, CX
	mov	AH, 4EH
	int	21H
	pop	BP
	ret
c_endp	diskinit

;
comment ~
int _absread(int drive, int sects, long start, void * buff)
~
;
;  Returns 0 if worked, error if failed
;
c_func	_absread
	push	BP
	mov	BP,SP
	push	DS
	push	SI
	push	DI

	; this is a BIG (32M+) partition
	mov	AX, P+2[BP]		; # sects
	mov	num_sec, AX
	mov	AX, P+4[BP]		; lo word starting sector
	mov	word ptr start_sec, AX
	mov	AX, P+6[BP]		; hi word starting
	mov	word ptr start_sec+2, AX
	mov	AX, P+8[BP]		; lo word buffer
	mov	word ptr buffer, AX
	mov	word ptr buffer+2, DS	; hi word buffer
	mov	AL, P[BP]		; drive
	mov	CX, -1
	mov	BX, GOFFSET start_sec
	INT	25H
	pop	BX		; remove flags from stack
	jnc	read_ok
	mov	AX, 1
	jmp	short read_done
read_ok:
	xor	AX, AX
read_done:

	pop	DI
	pop	SI
	pop	DS
	pop	BP
	ret
c_endp	_absread

;
comment ~
int _abswrite(int drive, int sects, long start, void * buff)
~
;
;  Returns 0 if worked, error if failed
;
c_func	_abswrite
	push	BP
	mov	BP,SP
	push	DS
	push	SI
	push	DI

	; this is a BIG (32M+) partition
	mov	AX, P+2[BP]		; # of sectors
	mov	num_sec, AX
	mov	AX, P+4[BP]		; lo word starting sector
	mov	word ptr start_sec, AX
	mov	AX, P+6[BP]		; hi word starting sector
	mov	word ptr start_sec+2, AX
	mov	AX, P+8[BP]		; lo word buffer
	mov	word ptr buffer, AX
	mov	word ptr buffer+2, DS	; hi word buffer
	mov	AL, P[BP]
	mov	CX, -1
	mov	BX, GOFFSET start_sec
	INT	26H
	pop	BX		; remove flags from stack
	jnc	write_ok
	mov	AX, 1
	jmp	short write_done
write_ok:
	xor	AX, AX
write_done:

	pop	DI
	pop	SI
	pop	DS
	pop	BP
	ret
c_endp	_abswrite

cEndCode

	END
