;
;   $Id: REM8250A.ASM 1.4 2002/10/16 21:58:28Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
COMMENT ~
-----------------------------------------------------------
   REM8250A.ASM  created 3/01/94  by Drew Gislason

   Copyright (c) 1990-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary.
----------------------------------------------------------- ~
include macros.inc

BUFSIZE		equ	2080


; Port/bit definitions for 8259 Programmable Interrupt Controller (PIC)
;
PIC_EOIVal	=	20h

PIC_EOIPort1	=	20h
PIC_MaskPort1	=	21h	; each bit: 0=interrupt enabled, 1=masked off

PIC_EOIPort2	=	0A0h
PIC_MaskPort2	=	0A1h	; each bit: 0=interrupt enabled, 1=masked off


comport	STRUC
   cp_base		dw	?	; I/O port base address eg 3F8H, 2F8H
   cp_head		dw	?	; head and tail of ring buffer
   cp_tail		dw	?
   cp_bufsize		dw	?	; size of ring buffer
   cp_modemcontrol	db	?
   cp_port		db	?
   cp_uiIrqNumber   	dw	?       ; comport irq
   cp_buffer db	BUFSIZE dup (?)	; ring buffer itself
comport	ENDS

cBegData
	extrn	_cp:comport
cEndData

cBegCode

; /*
;	comm_char_isr
;
;	This ISR is an interrupt driven CHARACTER receive routine.
;	It stuffs the character received into a ring buffer.
; */
comment ~ ; prototype ;
void interrupt far comm_char_isr(void)
{}
~
c_func comm_char_isr
	push	DS
	push	AX
	push	BX
	push	DX
	push	SI
	mov	AX, DGROUP
	mov	DS, AX

;	/* get the data */
;	cp.buffer[cp.head++] = inportb(DATAREG);
getchar:
	mov	SI, GOFFSET _cp
	mov	DX, [SI.cp_base]
	in	AL, DX
	mov	BX, [SI.cp_head]
	mov	byte ptr [SI.cp_buffer+BX], AL
	inc	BX

;	/* check for wrap around */
;	if(cp.head >= cp.bufsize)
;		cp.head= 0;
	cmp	BX, [SI.cp_bufsize]
	jb	nowrap
	xor	BX, BX
nowrap:	mov	[SI.cp_head], BX

	; in case we are reading an 16550 vs an 8250/16450 UART,
	; we want to be sure and drain the Rx FIFO, keep reading
	; data until the UART says there isn't any any more.
	;
	add	dx, 5
	in	al, dx
	sub	dx, 5
	shr	al, 1
	jc	getchar

	cmp	[SI.cp_uiIrqNumber], 8
	jb	CRCI_1st_PIC


	mov	al, PIC_EOIVal			; sending non-specific EOI to the 2nd PIC
	out	PIC_EOIPort2, al		; enables this and lower priority IRQs

CRCI_1st_PIC:
	mov	al, PIC_EOIVal			; sending non-specific EOI to the 1st PIC
	out	PIC_EOIPort1, al		; enables this and lower priority IRQs


	pop	SI
	pop	DX
	pop	BX
	pop	AX
	pop	DS
	iret
c_endp	comm_char_isr

cEndCode
	END
