//
//   $Id: REMDISK.H 1.4 2002/10/16 21:58:28Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*********************************************************

	REMDISK.H  created 02/05/90  by Drew Gislason

	Copyright (c) 1990-2002 Datalight, Inc.
	All Rights Reserved.
	Datalight Confidential and Proprietary.

	History:

	01-30-1999 bt  Removed the BPB (bpb_def) structure

**********************************************************/


/*
        Things in the packet
*/
#define PAC_CMD         rdsk_buff[0]
#define PAC_CHGCODE     rdsk_buff[1]
#define PAC_BPB         (rdsk_buff+1)
#define PAC_SECTOR      *(unsigned long *)(rdsk_buff+1)
#define PAC_NUM         *(unsigned *)(rdsk_buff+5)

#define CHG_YES -1
#define CHG_NO           1
#define CHG_MAYBE        0

#define DEVERR_NOTRDY   2

// IBM - RAY added #defines for read and write error rc to CEH
#define DEVERR_WRITE     0x0a
#define DEVERR_READ      0x0b

// The ROM-DOS kernel used to handle retrying failed block device calls.
// The responsibility for retries was moved to the devices to be like
// MS-DOS and so decrease the granularity of the retry operation (from
// multiple-sector writes to a single sector, for instance). REMDISK.C
// contains the interface to the generic MEMDISK driver and handles
// the retries there.
//
#define MAX_RETRIES		 5

extern uchar		rdsk_mode;
extern int			rdsk_port;
extern unsigned	rdsk_uiIrqNumber;
extern unsigned	rdsk_baud;
