//
//   $Id: REMDISK3.C 1.4 2002/10/16 21:58:28Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/**********************************************************************

	REMDISK3.C  created 02/28/90  by Drew Gislason

	Copyright (c) 1990-2002 Datalight, Inc.
	All Rights Reserved.
	Datalight Confidential and Proprietary.

	This file is used on the TARGET, in the Remote Disk Driver

	There are only 2 routines in this file, one for use when the
	Remote Disk Driver takes control and one for use when control
	is relinquished.  The user may modifiy these routines to do
	whatever is necessary to get into and out of the remote disk.

	1) If the port is dedicated to the remote disk, these routines
	   can do nothing.

	2) If the port used with in conjuction with the miniBIOS as both
	   the Console and the Remote Disk, these routines must reroute
	   the ISR, and possibly modify the baud rate.

	3) If the port will be used for many purposes, you may want to
	   reinitialize the port every time Remote Disk is entered.

***********************************************************************/

#include "datalght.h"

#include "remote.h"
#include "remdisk.h"
#include "remdisk3.pt"
#include "rem8250.pt"

void far *old_vect;

/*
	enter_rdsk

	Called every time the Remote Disk Device is entered
	from DOS.  That is every Read/Write/Get BPB/etc...

*/
int enter_rdsk(void)
{
	/* swap from BIOS ISR to our own ISR */
	old_vect = getportvect(rdsk_port);
	return remote_open(rdsk_mode,rdsk_port,rdsk_uiIrqNumber,rdsk_baud,0);
}


/*
	leave_rdsk

	Called every time the Remote Disk Device leaves.  This
	happens after every Read/Write/Get BPB/etc...
*/
void leave_rdsk(void)
{
	if(old_vect)
		setportvect(old_vect);
}

void leave_rdskc(void)
{
	if(old_vect)
		setportvect(old_vect);
	remote_close();
}
