//
//   $Id: REMTEXT.C 1.4 2002/10/16 21:58:28Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/*********************************************************

   REMTEXT.C  created 11/18/93  by Drew Gislason

	Copyright (c) 1990-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary.

   This file contains all the language specific messages
   displayed in REMDISK and REMSERV.  Each section is
   surrounded by an #if/#endif pair.

**********************************************************/

// baud rate can be 9600, 19200, 38400, 57600, 115
#define DEFBAUD 115

/*
   []-----------------------------------------[]
    |                                         |
    |           REMOTE DISK MESSAGES          |
    |                                         |
   []-----------------------------------------[]
*/

#if REMDISK

#if IBM
unsigned        rdsk_baud = DEFBAUD;    // see DEFBAUD for valid baud rates
#endif


char msg_bad_ver[] = "\r\nDOS version must be at least 5.0!\r\n$";
char msg_no_drives[] =
"\r\nNot enough drives available! Increase LASTDRIVE in CONFIG.SYS.\r\n$";

char USAGE[] =
        "REMDISK  [/?] [/U] [/T] [/H] [/Bxxxx][+|-] [/COMn] [/IRQn]\r\n"
        "\n"
        "/Bxxxx  Set the baud rate. Choose from 300, 1200, 2400...19200,\r\n"
        "        38400, 57600, 115. A '+' after the BAUD specifies 'packet'\r\n"
        "        style transfers. By default, packet transfers will be used\r\n"
		  "        for all baud rates higher than 9600. Use '-' after the BAUD\r\n"
		  "        if REMSERV is running under Windows 95. Both sides must\r\n"
		  "        agree on using either '+' or '-'.\r\n"
        "/COMn   Set the communications port. Choose 1, 2, 3 or 4.\r\n"
        "/IRQn   Set the IRQ for the communications port. choose 3-15.\r\n"
        "/Tnnn   Set the timeout in seconds. Choose 3-3640, 15 seconds is not\r\n"
		  "        unusual for FLASH drives.\r\n"
		  "/H      Use Hardware Handshaking for flow control.\r\n"
        "/U      Unload REMDISK from memory\r\n"
		  "\n"
        "Examples:   (in CONFIG.SYS)    DEVICE=REMDISK.EXE /T15\r\n"
        "            (in AUTOEXEC.BAT)  REMDISK /B9600 /COM2 /T10\r\n"
        "\n"
        "The default is /B115+ /COM1 /T3\r\n";

char signon_str[] = "\r\nRemote Disk ";        // eg Remote Disk v1.0
char uninstall_str[] = "Uninstalling...";
char uninstall_fail_str[] =
        "\r\nError: can't unload; not previously installed.\r\n";
char irq_range_str[] = "IRQ out of range.";
char install_err_str[] = "Error: already installed!\r\n";
char complete_str[] = "complete\r\n";

char baud_str[] = "/B115K   ";  // modified at run-time
char com_str[] = "/COMn  ";             // modified at run-time
char irq_str[] = "/IRQ3  ";
char drive_str[] = "Installed as Drive A: ";    // modified at run-time
char time_str[] = "/Tn     ";		// modified at run-time

int BAUD_POS = 2;
int COM_POS  = 4;
int IRQ_POS  = 4;
int DRIVE_POS = 19;
int TIME_POS = 2;
#endif   /* REMDISK */


/*
   []-----------------------------------------[]
    |                                         |
    |         REMOTE SERVER MESSAGES          |
    |                                         |
   []-----------------------------------------[]
*/

#if REMSERVE

#if IBM
unsigned baud = DEFBAUD;        // see DEFBAUD for valid baud rates

/*
        This routine provides a hook during the idle loop to
        exit the REMSERV program.  Any and all C functions are
        available, however, Datalight does NOT recommend disk
        I/O, as the disk that REMSERV is accessing may be in
        a "between" state where part of a file or the FAT is
        written, but the rest has not been.

        To tell REMSERV to exit, return TRUE (1) from this
        function.  A return value of FALSE (0) tells REMSERV
        to continue as normal.

        Return TRUE (1) to exit, FALSE (0) to continue
*/
int unusual_exit(void)
{
        return 0;       // continue as normal.
}

#endif

char USAGE1[] = "REMSERV.EXE  d: [/Bxxxx][+|-] [/COMn]\n";
char USAGE[] =
        "REMSERV.EXE  d: [/T] [/H] [/Bxxxx][+|-] [/COMn] [/IRQn]\n"
        "\n"
        "/Bxxxx  Set the baud rate. Choose from 300, 1200, 2400...19200,\r\n"
        "        38400, 57600, 115. A '+' after the BAUD specifies 'packet'\r\n"
        "        style transfers. By default, packet transfers will be used\r\n"
		  "        for all baud rates higher than 9600. Use '-' after the BAUD\r\n"
		  "        to force polling operation under Windows 95. Both sides must\r\n"
		  "        agree on using either '+' or '-'.\r\n"
        "/COMn   Set the communications port. Choose 1, 2, 3 or 4.\r\n"
        "/IRQn   Set the IRQ for the communications port. choose 3-15.\r\n"
        "/S      Silent (no output)\r\n"
        "/Tnnn   Set the timeout in seconds. Choose 2-3640, 15 seconds is not\r\n"
		  "        unusual for FLASH drives.\r\n"
		  "/H      Use Hardware Handshaking for flow control.\r\n"
		  "\n"
        "Example:   REMSERV D: /B38400- /COM2 /T10\n"
        "\n"
        "The default is /B115+ /COM1 /T2\n";

char using_str[] = "Using COM%d IRQ%d at %u%s%s baud.  Accessing Drive %c:.\nTimeout is %d seconds\n";
char mouse_range_str[] = "Mouse Range X(%d,%d) Y(%d,%d)\n";
char exit_str[] =
        "Press <Esc> to Exit.  (There may be a delay before exit occurs)\n";
char terminate_str[] = "\nTerminating Remote Access\n";

char invalid_drv_str[] =
        "\nInvalid Drive '%c'!  Drive letter must be 1st argument.\n\n%s";
char bad_opt_str[]     = "\nBad option %s!\n\n";
char irq_range_str[]   = "IRQ out of range.";
char packet_err_str[]  = "packet error! %d\n";
char invalid_cmd_str[] = "Invalid cmd %d(%c)\n";
char not_FAT16_str[]   = "Drive '%c' is not a FAT16 drive. Aborting...\n";
#endif   /* REMSERVE */
