//
//   $Id: IFSDISP.C 1.7 2002/10/16 21:59:16Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
//
//  IFSDISP.C
//
//  Copyright (c) 2001-2002 Datalight, Inc.
//  All Rights Reserved.
//  Datalight Confidential and Proprietary
//
//  This file contains all the API functions that an int 2fh IFS
//  server interface is expected to dispatch for the IFS API.
//
//  History:
//
//  04-01-2001  bt  Created
//


//  Borland libraries
//
#include <string.h>
#include <mem.h>


//  Local libraries
//
#include "datalght.h"
#include "dostruct.h"
#include "dosdef.h"
#include "fatworld.h"
#include "dlbiosio.h"


#define	SERVER_APP	1


//  Local definitions
//
#include "commapi.h"
#include "netapi.h"
#include "cliapi.h"


//  Prototypes
//
#include "ifsdisp.pt"
unsigned UpdateDriveMapList( PREMOTELIST pRemoteList );


unsigned Service( void )
{
	unsigned uError;
	uchar * pPacketData;
	unsigned uPacketSize = 0;
	ulong ulWaitTicks;
	ulong ulCurrentTicks;
	ulong ulEndTicks;
	extern unsigned uSecondsToTimeout;


	//  Get the data space for the packet
	//
	pPacketData = GetGlobalRequestPacketAddress();


	//  Determine if there is a packet to process
	//
	uError = NetworkRX( pPacketData );
	if( uError == NET_SERVICED )
	{
		//  Process the client request
		//
		ProcessRequest( pPacketData, &uPacketSize );


		//  Send the results of the request
		//
	 	ulWaitTicks  = 182 * uSecondsToTimeout;
		ulWaitTicks /= 10;
		dlGetTimerTicks( &ulCurrentTicks );
		ulEndTicks = ulCurrentTicks + ulWaitTicks;
		while( ulCurrentTicks < ulEndTicks )
		{
			uError = NetworkTX( pPacketData, uPacketSize );
			if( uError == NET_SERVICED )
			{
				break;
			}
			dlGetTimerTicks( &ulCurrentTicks );
		}
	}


	//  Return any error code
	//
	return uError;
}


void ProcessRequest( void * pRequestPacket, unsigned * puPacketSize )
{
	PREQSHORT  pReqSHORT;
	PSERVSHORT pServSHORT;
	PREQ110C   pReq110c;
	PSERV110C  pServ110c;
	PREQ111B   pReq111b;
	PSERV111B  pServ111b;
	PREQ111C   pReq111c;
	PSERV111C  pServ111c;
	PREQ110F   pReq110f;
	PSERV110F  pServ110f;
	PREQ110E   pReq110e;
	PREQ1103   pReq1103;
	PREQ1105   pReq1105;
	PREQ1101   pReq1101;
	PREQ1113   pReq1113;
	PREQ1111   pReq1111;
	PREQ112E   pReq112e;
	PSERV112E  pServ112e;
	PREQ1116   pReq1116;
	PSERV1116  pServ1116;
	PREQ1117   pReq1117;
	PSERV1117  pServ1117;
	PREQ1121   pReq1121;
	PSERV1121  pServ1121;
	PREQ1108   pReq1108;
	PSERV1108  pServ1108;
	PREQ1109   pReq1109;
	PSERV1109  pServ1109;
	PREQ1106   pReq1106;
	PREQ111D   pReq111D;
	PREQ1107   pReq1107;
	PSERVMAP   pServMap;
	bool fCallServiced = TRUE;
	unsigned uErrorCode;
	unsigned uAction;
	unsigned uFileTime;
	unsigned uFileDate;
	unsigned uAttributes;
	ulong ulSize;


	pReqSHORT  = pRequestPacket;
	pServSHORT = pRequestPacket;


//	printf("Servicing function %04xh\n", pReqSHORT->uFunction );
	pReqSHORT->fService = TRUE;
	switch( pReqSHORT->uFunction )
	{
		//  INT 21h fn 110ch  Get Remote Drive List (internal)
		//
		//  NOTE:  This is not a service routine for a DOS
		//         IFS.  This is used to retrieve the list
		//         of available drives from the server.
		//
		case 0x1100:
			{
				//  Set the address of the request and service structures
				//
				pServMap = pRequestPacket;


				//  Service the call
				//
				uErrorCode = UpdateDriveMapList( pServMap->DriveList );


				//  Set the size of the packet
				//
				*puPacketSize = sizeof(SERVMAP);
			}
			break;


		//  INT 21h fn 110ch  Get Remote Drive Info
		//
		case 0x110c:
			{
				//  Set the address of the request and service structures
				//
				pReq110c = pRequestPacket;
				pServ110c = pRequestPacket;


				//  Service the call
				//
				uErrorCode = GetRemoteDriveInfo( pReq110c->ucDriveLetter,
						&pServ110c->ucSectorsPerCluster, &pServ110c->ucMediaIdByte,
						&pServ110c->uTotalClusters, &pServ110c->uBytesPerSector,
						&pServ110c->uAvailableClusters );


				//  Set the size of the packet
				//
				*puPacketSize = sizeof(SERV110C);
			}
			break;


		//  INT 21h fn 111bh  Find first
		//
		case 0x111b:
			{
				//  Set the address of the request and service structures
				//
				pReq111b = pRequestPacket;
				pServ111b = pRequestPacket;


				//  Service the call
				//
				uErrorCode = RemoteFindFirst( pReq111b->ucDriveLetter,
						pReq111b->szCWD, pReq111b->szMask, pReq111b->uSearchAttr,
						&pServ111b->Find, &pServ111b->Dir );
				pServ111b->uErrorCode = uErrorCode;


				//  Set the size of the packet
				//
				*puPacketSize = sizeof(SERV111B);
			}
			break;


		//  INT 21h fn 111ch  Find next
		//
		case 0x111c:
			{
				//  Set the address of the request and service structures
				//
				pReq111c = pRequestPacket;
				pServ111c = pRequestPacket;


				//  Service the call
				//
				uErrorCode = RemoteFindNext( pReq111c->ucDriveLetter,
						pReq111c->szCWD, &pServ111c->Find, &pServ111c->Dir );
				pServ111c->uErrorCode = uErrorCode;


				//  Set the size of the packet
				//
				*puPacketSize = sizeof(SERV111C);
			}
			break;


		//  INT 2fh fn 110fh  Get Remote File Attributes And Size
		//
		case 0x110f:
			{
				//  Set the address of the request and service structures
				//
				pReq110f = pRequestPacket;
				pServ110f = pRequestPacket;


				//  Service the call
				//
				uErrorCode = GetRemoteFileAttributesAndSize(
						pReq110f->ucDriveLetter, pReq110f->szCWD, pReq110f->szPath,
						&pServ110f->uAttributes, &pServ110f->ulSize );


				//  Set the size of the packet
				//
				*puPacketSize = sizeof(SERV110F);
			}
			break;


		//  INT 2fh fn 110eh  Set Remote File Attributes
		//
		case 0x110e:
			{
				//  Set the address of the request and service structures
				//
				pReq110e = pRequestPacket;


				//  Service the call
				//
				uErrorCode = SetRemoteFileAttributes( pReq110e->ucDriveLetter,
						pReq110e->szCWD, pReq110e->szPath, pReq110e->uAttributes );


				//  Set the size of the packet
				//
				*puPacketSize = sizeof(SERV110E);
			}
			break;


		//  INT 2fh fn 1103h  Create Remote Directory
		//
		case 0x1103:
			{
				//  Set the address of the request and service structures
				//
				pReq1103 = pRequestPacket;


				//  Service the call
				//
				uErrorCode = CreateRemoteDirectory( pReq1103->ucDriveLetter,
						pReq1103->szCWD, pReq1103->szPath );


				//  Set the size of the packet
				//
				*puPacketSize = sizeof(SERV1103);
			}
			break;


		//  INT 2fh fn 1101h  Remove Remote Directory
		//
		case 0x1101:
			{
				//  Set the address of the request and service structures
				//
				pReq1101 = pRequestPacket;


				//  Service the call
				//
				uErrorCode = RemoveRemoteDirectory( pReq1101->ucDriveLetter,
						pReq1101->szCWD, pReq1101->szPath );


				//  Set the size of the packet
				//
				*puPacketSize = sizeof(SERV1101);
			}
			break;


		//  INT 2fh fn 1105h  Change Remote Directory
		//
		case 0x1105:
			{
				//  Set the address of the request and service structures
				//
				pReq1105 = pRequestPacket;


				//  Service the call
				//
				uErrorCode = ChangeRemoteDirectory( pReq1105->ucDriveLetter,
						pReq1105->szCWD, pReq1105->szPath );


				//  Set the size of the packet
				//
				*puPacketSize = sizeof(SERV1105);
			}
			break;


		//  INT 2fh fn 1113h  Delete Remote File
		//
		case 0x1113:
			{
				//  Set the address of the request and service structures
				//
				pReq1113 = pRequestPacket;


				//  Service the call
				//
				uErrorCode = DeleteRemoteFile( pReq1113->ucDriveLetter,
						pReq1113->szCWD, pReq1113->szPath );


				//  Set the size of the packet
				//
				*puPacketSize = sizeof(SERV1113);
			}
			break;


		//  INT 2fh fn 1111h  Rename Remote File
		//
		case 0x1111:
			{
				//  Set the address of the request and service structures
				//
				pReq1111 = pRequestPacket;


				//  Service the call
				//
				uErrorCode = RenameRemoteFile( pReq1111->ucDriveLetter,
						pReq1111->szCWD, pReq1111->szCurrentName,
						pReq1111->szNewName );


				//  Set the size of the packet
				//
				*puPacketSize = sizeof(SERV1111);
			}
			break;


		//  INT 2fh fn 112Eh  Remote Extended Open Create File
		//
		case 0x112e:
			{
				//  Set the address of the request and service structures
				//
				pReq112e = pRequestPacket;
				pServ112e = pRequestPacket;


				//  Service the call
				//
				uAction = pReq112e->uAction;
				uErrorCode = RemoteExtendedOpenCreateFile(
						pReq112e->ucDriveLetter, pReq112e->szCWD, pReq112e->szPath,
						pReq112e->uOpenMode, pReq112e->uAttributes,
						pReq112e->uProcessID, &uAction, &pServ112e->uRemoteHandle,
						&uFileTime, &uFileDate, &ulSize, &uAttributes );
				if( !uErrorCode )
				{
					pServ112e->uRemoteAction = uAction;
					pServ112e->uFileTime = uFileTime;
					pServ112e->uFileDate = uFileDate;
					pServ112e->ulSize = ulSize;
					pServ112e->uAttributes = uAttributes;
				}


				//  Set the size of the packet
				//
				*puPacketSize = sizeof(SERV112E);
			}
			break;


		//  INT 2fh fn 1116h  Remote Extended Open Create File
		//
		case 0x1116:
			{
				//  Set the address of the request and service structures
				//
				pReq1116 = pRequestPacket;
				pServ1116 = pRequestPacket;


				//  Service the call
				//
				uErrorCode = RemoteOpenFile( pReq1116->ucDriveLetter,
						pReq1116->szCWD, pReq1116->szPath, pReq1116->uOpenMode,
						pReq1116->uProcessID, &pServ1116->uRemoteHandle,
						&uFileTime, &uFileDate, &ulSize, &uAttributes );
				if( !uErrorCode )
				{
					pServ1116->uFileTime = uFileTime;
					pServ1116->uFileDate = uFileDate;
					pServ1116->ulSize = ulSize;
					pServ1116->uAttributes = uAttributes;
				}


				//  Set the size of the packet
				//
				*puPacketSize = sizeof(SERV1116);
			}
			break;


		//  INT 2fh fn 1117h  Remote Create File
		//
		case 0x1117:
			{
				//  Set the address of the request and service structures
				//
				pReq1117 = pRequestPacket;
				pServ1117 = pRequestPacket;


				//  Service the call
				//
				uErrorCode = RemoteCreateFile( pReq1117->ucDriveLetter,
						pReq1117->szCWD, pReq1117->szPath, pReq1117->uAttributes,
						pReq1117->fCreateNew, pReq1117->uProcessID,
						&pServ1117->uRemoteHandle, &uFileTime, &uFileDate,
						&ulSize, &uAttributes );
				if( !uErrorCode )
				{
					pServ1117->uFileTime = uFileTime;
					pServ1117->uFileDate = uFileDate;
					pServ1117->ulSize = ulSize;
					pServ1117->uAttributes = uAttributes;
				}


				//  Set the size of the packet
				//
				*puPacketSize = sizeof(SERV1117);
			}
			break;


		//  INT 2fh fn 1121h  Set Remote File Position
		//
		case 0x1121:
			{
				//  Set the address of the request and service structures
				//
				pReq1121 = pRequestPacket;
				pServ1121 = pRequestPacket;


				//  Service the call
				//
				uErrorCode = SetRemoteFilePosition( pReq1121->uRemoteHandle,
						pReq1121->ulPositionFromEnd,
						&pServ1121->ulResultingPosition );


				//  Set the size of the packet
				//
				*puPacketSize = sizeof(SERV1121);
			}
			break;


		//  INT 2fh fn 1108h  Read Remote File
		//
		case 0x1108:
			{
				//  Set the address of the request and service structures
				//
				pReq1108 = pRequestPacket;
				pServ1108 = pRequestPacket;


				//  Service the call
				//
				uErrorCode = ReadRemoteFile( pReq1108->uRemoteHandle,
						pReq1108->ulFilePosition, pReq1108->uNumberOfBytes,
						&pServ1108->ucData, &pServ1108->uBytesRead );


				//  Set the size of the packet
				//
				*puPacketSize = sizeof(SERV1108) - MAX_RW_SIZE +
						pServ1108->uBytesRead;
			}
			break;


		//  INT 2fh fn 1109h  Write Remote File
		//
		case 0x1109:
			{
				//  Set the address of the request and service structures
				//
				pReq1109 = pRequestPacket;
				pServ1109 = pRequestPacket;


				//  Service the call
				//
				uErrorCode = WriteRemoteFile( pReq1109->uRemoteHandle,
						pReq1109->ulFilePosition, pReq1109->uNumberOfBytes,
						&pReq1109->ucData, &pServ1109->uBytesWritten );


				//  Set the size of the packet
				//
				*puPacketSize = sizeof(SERV1109);
			}
			break;


		//  INT 2fh fn 1106h  Close Remote File
		//
		case 0x1106:
			{
				//  Set the address of the request and service structures
				//
				pReq1106 = pRequestPacket;


				//  Service the call
				//
				uErrorCode = CloseRemoteFile( pReq1106->uRemoteHandle,
						pReq1106->fUpdateDateTime, pReq1106->uFileTime,
						pReq1106->uFileDate, pReq1106->fDuplicateHandleAndClose );


				//  Set the size of the packet
				//
				*puPacketSize = sizeof(SERV1106);
			}
			break;


		//  INT 2fh fn 111Dh  Close all remote files for process termination
		//
		case 0x111D:
			{
				//  Set the address of the request and service structures
				//
				pReq111D = pRequestPacket;


				//  Service the call
				//
				uErrorCode = CloseAllRemoteFiles( pReq111D->uProcessID );


				//  Set the size of the packet
				//
				*puPacketSize = sizeof(SERV111D);
			}
			break;


		//  INT 2fh fn 1107h  Commit Remote File
		//
		case 0x1107:
			{
				//  Set the address of the request and service structures
				//
				pReq1107 = pRequestPacket;


				//  Service the call
				//
				uErrorCode = CommitRemoteFile( pReq1107->uRemoteHandle,
						pReq1107->fUpdateDateTime, pReq1107->uFileTime,
						pReq1107->uFileDate );


				//  Set the size of the packet
				//
				*puPacketSize = sizeof(SERV1107);
			}
			break;


		//  Unknown function request
		//
		default:
			{
				fCallServiced = FALSE;
				*puPacketSize = sizeof(SERVSHORT);
				pServSHORT->uErrorCode = ERR_BADFUNC;

			}
			break;
	}


	//
	//
	if( fCallServiced )
	{
		pServSHORT->fService = TRUE;
		pServSHORT->uErrorCode = uErrorCode;

	}
}


bool IsFAT32World( void )
{
	static bool fChecked = FALSE;
	static bool fIsFAT32World = FALSE;


	if( !fChecked )
	{
		fIsFAT32World = dlIsFat32World();
		fChecked = TRUE;
	}

	return fIsFAT32World;
}


#if 0
void Dump( uchar * pucTemp, unsigned uSize )
{
	unsigned uIndex;


	for( uIndex = 0; uIndex < uSize; uIndex++ )
	{
		if( (uIndex % 0x10) == 0 )
		{
			printf("\n");
		}
		printf("%02X ", *pucTemp );
		pucTemp++;
	}
	printf("\n");
}
#endif


#if 0
//  DebugPrintf
//
//
//  Output a character to the display going directly through INT 10h
//
//
//  On Entry:
//
//    szString = the string to output
//
//
//  On Exit:
//
//    Nothing
//
//
void DebugPrintf( char * szString )
{
	while( *szString )
	{
		if( *szString == '\\' )
		{
			szString++;
			switch( toupper(*szString) )
			{
				case 0x00:
					break;

				case 'R':
					DebugPutc( 0x0a );
					break;

				case 'B':
					DebugPutc( 0x08 );
					break;

				case 'N':
					DebugPutc( 0x0d );
					DebugPutc( 0x0a );
					break;

				default:
					DebugPutc( *szString );
					break;

			}
			szString++;
		}
		else
		{
			if( *szString == 0x0d )
			{
				DebugPutc( *szString );
//				DebugPutc( 0x0a );
			}
			else
			{
				DebugPutc( *szString );
			}
			szString++;
		}
	}
}


//  DebugPutc
//
//
//  Output a character to the display going directly through INT 10h
//
//
//  On Entry:
//
//    cCharacter = the character to output
//
//
//  On Exit:
//
//    Nothing
//
//
void DebugPutc( char cCharacter )
{
	asm	mov	ah, 0eh
	asm	mov	al, cCharacter
	asm	mov	bx, 0101h
	asm	int   10h
}
#endif
