//
//   $Id: SYS.H 1.4 2002/10/16 22:02:52Z peterb Exp $
//
//   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
//
//   Copyright (c) 1993 - 2002 Datalight, Inc.
//   All Rights Reserved
//
//   Datalight, Inc. is a Washington corporation with an address at
//   21520 30TH DR SE MS110 Bothell, WA, 98021
//   Tel: 800.221.6630  Fax: 425.951.8091
//   Http://www.datalight.com
//
//   This software, including without limitation all source code and
//   documentation, is the confidential, trade secret property of
//   Datalight, Inc., and is protected under the copyright laws of
//   the United States and other jurisdictions. Portions of the
//   software may also be subject to one or more the following US
//   patents: US#5860082, US#6260156.
//
//   In addition to civil penalties for infringement of copyright
//   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
//   penalties for violation of (a) the restrictions on circumvention
//   of copyright protection systems found in 17 U.S.C. 1201 and
//   (b) the protections for the integrity of copyright management
//   information found in 17 U.S.C. 1202.
//
//   U.S. Government Restricted Rights. Use, duplication,
//   reproduction, or transfer of this commercial product and
//   accompanying documentation is restricted in accordance with
//   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
//
//   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
//   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
//   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
//   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
//   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
//   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
//   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
//   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
//   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
//   THIS SOFTWARE IN ERROR.
//
/************************************************************

	SYS.H  created 11/26/88  by Drew Gislason

   Copyright (c) 1988-2002 Datalight, Inc.
   All Rights Reserved.
   Datalight Confidential and Proprietary

	This file is included in both SYS and FORMAT.

	History:

	01-30-1999 bt  Removed the BPB structure that was in here
	01-27-1999 bt  Added the USING_FAT32 define as FALSE

*************************************************************/


//  08-06-1998 BT
//
#define CMDNAME	"COMMAND.COM"
#if SYS

#define ERR_WRITE		5		/* disk is write protected */
#define ERR_COMMAND	15		/* failure accessing command.com */

#endif /* SYS.COM */




#define SYSSTR "ROM-DOS %s %s\r\n%s\r\n"

/* locations within the MASTER boot record */
#define PARTOFF		0x1BE
#define IDOFF			0x1FE
#define PDOS12			1
#define PDOS16			4
#define PDOSEXT		5
#define PDOSBIG		6

/* max sectors for 12 bit (8 spc), otherwise 16 bit (4 spc) FATs */
#define GREAT_DIVIDE	0x7F80

/* BIOS disk commands */
#define BREAD	2
#define BWRITE 3

/* file attributes */
#define A_RDONLY 0x01
#define A_SYSHID 0x06		/* system and hidden files */
#define A_NORMAL 0x00		/* normal file */
#define A_ARCHIVE 0x20		/* archive bit set */
#define A_VOLUME 0x08		/* volume label */

#define DELETED	0xE5		/* directory entries marked deleted */
#define DELETED2	0x05

#define PATHSIZE	66

#define ERR	-1

/* Generic DOS locations within the BOOT sector */
#define BS_BPB			0x0B		/* the Bios Parameter Block */
#define BS_BIOSDRV	0x24		/* the drive # (80 = hd) */
#define BS_SERIAL		0x27		/* serial # (date/time stamp) */
#define BS_VOLUME		0x2B		/* volume label */
#define BS_FATID		0x36		/* "FAT16" or "FAT12" */
#define BS_CODESTART	0x3E		/* start of actual code */

/* ROM-DOS specific locations within the BOOT sector */
#define BS_LOADOFF	0x1E0		/* offset to load ROM-DOS (0) */
#define BS_LOADSEG	0x1E2		/* segment to load ROM-DOS (70H) */
#define BS_RELOCOFF	0x1E4		/* offset to relocate boot code (0) */
#define BS_RELOCSEG	0x1E6		/* segment to relocate boot code (C00H) */
#define BS_DIRENT		0x1E8		/* entry within that sector */
#define BS_DIRSTART	0x1EA		/* root dir sector w/ ROM-DOS dir entry */
#define BS_RDSTART	0x1EC		/* starting sector of ROM-DOS.SYS */
#define BS_RDSECS		0x1F0		/* # of sectors in boot program */
#define BS_RDNAME		0x1F1		/* the name of program to load (ROM-DOS SYS) */
#define BS_BIOSDRV2	0x1FD		/* same as BIOSDRV, for compatibility */
#define BS_BOOTID		0x1FE		/* should be AA55 */

#define BOOTID			0xAA55	/* make sure boot sector is valid */

/* BIOS drive types */
enum BTYPE { T360K=0, T1_2M, T720K, T1_44M, TUNKNOWN, TFIXED };

/* BIOS calls */
#define B_RESET		0
#define B_VERIFY		4
#define B_FORMAT		5
#define B_GETPARMS	8
#define B_SETTYPE		0x17
#define B_SETMEDIA	0x18


#if !defined(COMMON_TYPES)

/* structures and types */
typedef unsigned long ulong;

#define FALSE 0
#define TRUE  !FALSE
#endif

/*
   FILE CONTROL BLOCK (FCB)
   Description: DOS 1 file I/O uses this structure.  Note
   that the file time and date are in reverse order from
   all other DOS structures.  Also, a DOS1 findfirst/next
   does not use this structure (findfirst returns a DIR).

   DOS3.31 - see dirent structure for changes.

   Reference: Adv MS-DOS, p --  -or-  DOS Ref, p --
*/
//struct FCB /*()*/
//{
//   uchar      drive;       /* 00  drive of file            */
//   uchar      name[8];     /* 01  file name                */
//   uchar      ext[3];      /* 09  and extension            */
//   unsigned   cur_blk;     /* 0C  current block            */
//   unsigned   record_size; /* 0E  record size              */
//   ulong      file_size;   /* 10  file size                */
//   unsigned   date;        /* 14  date of file             */
//   unsigned   time;        /* 16  time of file             */
//   uchar      sft;         /* 18  sft # for file           */
//   uchar      reserved[2]; /* 19  unknown                  */
//   unsigned   start;       /* 1B  starting cluster of file */
//   unsigned   dirsec;      /* 1D  directory sector         */
//   uchar      dirent;      /* 1F  dir entry # in the sect  */
//   uchar      cur_record;  /* 20  current record           */
//   ulong      rand_record; /* 21  random record #          */
//};


// CDS status bits
//
#define  CDS_NETWORK    0x8000
#define  CDS_VALID      0x4000
#define  CDS_JOIN       0x2000
#define  CDS_SUBST      0x1000
#define  CDS_ISREMOTE   0x0100   // ???
#define  CDS_CDROM      0x0080

/* Prototypes */
_absread(int isbig, int drive, int num, long start, void far * buffer);
_abswrite(int isbig, int drive, int num, long start, void far * buffer);

#define assert(e)	if(!(e)) _assert(__FILENUM__*10000 + __LINE__)
