;
;   $Id: TRANS.ASM 1.4 2002/10/16 22:04:26Z peterb Exp $
;
;   *** DO NOT REMOVE THE FOLLOWING NOTICE ***
;
;   Copyright (c) 1993 - 2002 Datalight, Inc.
;   All Rights Reserved
;
;   Datalight, Inc. is a Washington corporation with an address at
;   21520 30TH DR SE MS110 Bothell, WA, 98021
;   Tel: 800.221.6630  Fax: 425.951.8091
;   Http://www.datalight.com
;
;   This software, including without limitation all source code and
;   documentation, is the confidential, trade secret property of
;   Datalight, Inc., and is protected under the copyright laws of
;   the United States and other jurisdictions. Portions of the
;   software may also be subject to one or more the following US
;   patents: US#5860082, US#6260156.
;
;   In addition to civil penalties for infringement of copyright
;   under applicable U.S. law, 17 U.S.C. 1204 provides criminal
;   penalties for violation of (a) the restrictions on circumvention
;   of copyright protection systems found in 17 U.S.C. 1201 and
;   (b) the protections for the integrity of copyright management
;   information found in 17 U.S.C. 1202.
;
;   U.S. Government Restricted Rights. Use, duplication,
;   reproduction, or transfer of this commercial product and
;   accompanying documentation is restricted in accordance with
;   FAR 12.212 and DFARS 227.7202 and by a License Agreement.
;
;   IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS
;   PROTECTED UNDER A SOURCE CODE AGREEMENT, NON-DISCLOSURE
;   AGREEMENT (NDA), OR SIMILAR BINDING CONTRACT BETWEEN DATALIGHT,
;   INC. AND THE LICENSEE ("BINDING AGREEMENT"). YOUR RIGHT, IF ANY,
;   TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,IS SUBJECT
;   TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT, AND BY
;   USING THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE
;   TO BE BOUND BY THE TERMS OF THE BINDING AGREEMENT. CONTACT
;   DATALIGHT, INC. AT THE ADDRESS SET FORTH ABOVE IF YOU OBTAINED
;   THIS SOFTWARE IN ERROR.
;
;
;   TRANS.ASM  created 02/15/89  by Drew Gislason
;
;   Copyright (c) 1990-2002 Datalight, Inc.
;   All Rights Reserved.
;   Datalight Confidential and Proprietary
;
include macros.inc

CBegCode

STDIN	=	0
STDOUT	=	1



COMMENT ~ ; prototype ;
/*
   Check if a character is available from the BIOS console.
   If not, return -1.  If so, return the character.
   Equivalent to comm_poll().
*/
int bios_poll(void)
~
c_func	bios_poll
	mov	ah, 1
	int	16h		; is character available?
	jz	nochar

	mov	ah, 0		; get character from CON
	int	16h
	mov	ah, 0
	ret
nochar:
	mov	ax,-1
	ret
c_endp	bios_poll

COMMENT ~ ; prototype ;
/*
   Send a character to the BIOS console. Equivalent to
   comm_putc().
*/
void bios_putc(char c)
~
c_func	bios_putc
	push	bp
	mov	bp, sp

	mov	al, P[bp]
	mov	bh, 0
	mov	ah, 0Eh
	int	10h		; Video Out (CON)

	pop	bp
	ret
c_endp	bios_putc


COMMENT ~ ;prototype;
/*
   Check if a character is available from the DOS CONsole device.
   If not, return -1.  If so, return the character.
   Equivalent to comm_poll().
*/
int CON_poll(void)
~
c_func	CON_poll
	mov	ah, 06h
	mov	dl, 0FFh	; read STDIN, no wait
	int	21h		; is character available on STDIN (CON)?
	jz	conochar

	and	ax, 0FFh
	ret
conochar:
	mov	AX,-1
	ret
c_endp	CON_poll

COMMENT ~ ; prototype ;
/*
   Send a character to the DOS CONsole device.  Equivalent to
   comm_putc().
*/
void CON_putc(char c)
~
c_func	CON_putc
	push	bp
	mov	bp, sp

	mov	ah, 40h
	mov	bx, STDOUT      ; put 1 char on STDOUT (CON)
	mov	cx, 1
	mov	dx, bp
	add 	dx, 4		; assumes ds=ss! (as in small model C)
	int 	21h

	pop	bp
	ret
c_endp	CON_putc

COMMENT ~ ; prototype ;
/*
   Get the clock ticks from the BIOS.  Returns the tick
   count as a long.
*/
long get_ticks(void)
~
c_func	get_ticks
	mov	AH, 0
	int	1AH		; get ticks since midnight
	mov	AX, DX		; low order word
	mov	DX, CX		; high order word
	ret
c_endp	get_ticks



CEndCode
	END
